#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 4159
#define LARGE_STATE_COUNT 855
#define SYMBOL_COUNT 348
#define ALIAS_COUNT 8
#define TOKEN_COUNT 156
#define EXTERNAL_TOKEN_COUNT 5
#define FIELD_COUNT 39
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 260

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_type = 6,
  anon_sym_EQ = 7,
  anon_sym_as = 8,
  anon_sym_namespace = 9,
  anon_sym_LBRACE = 10,
  anon_sym_COMMA = 11,
  anon_sym_RBRACE = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_BANG = 19,
  anon_sym_else = 20,
  anon_sym_if = 21,
  anon_sym_switch = 22,
  anon_sym_for = 23,
  anon_sym_LPAREN = 24,
  anon_sym_RPAREN = 25,
  anon_sym_await = 26,
  anon_sym_in = 27,
  anon_sym_of = 28,
  anon_sym_while = 29,
  anon_sym_do = 30,
  anon_sym_try = 31,
  anon_sym_with = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  anon_sym_LT = 46,
  anon_sym_GT = 47,
  anon_sym_SLASH = 48,
  anon_sym_DOT = 49,
  anon_sym_class = 50,
  anon_sym_async = 51,
  anon_sym_function = 52,
  anon_sym_EQ_GT = 53,
  anon_sym_QMARK_DOT = 54,
  anon_sym_new = 55,
  anon_sym_PLUS_EQ = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_CARET_EQ = 61,
  anon_sym_AMP_EQ = 62,
  anon_sym_PIPE_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_GT_GT_GT_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_STAR_STAR_EQ = 67,
  anon_sym_AMP_AMP_EQ = 68,
  anon_sym_PIPE_PIPE_EQ = 69,
  anon_sym_QMARK_QMARK_EQ = 70,
  anon_sym_DOT_DOT_DOT = 71,
  anon_sym_AMP_AMP = 72,
  anon_sym_PIPE_PIPE = 73,
  anon_sym_GT_GT = 74,
  anon_sym_GT_GT_GT = 75,
  anon_sym_LT_LT = 76,
  anon_sym_AMP = 77,
  anon_sym_CARET = 78,
  anon_sym_PIPE = 79,
  anon_sym_PLUS = 80,
  anon_sym_DASH = 81,
  anon_sym_PERCENT = 82,
  anon_sym_STAR_STAR = 83,
  anon_sym_LT_EQ = 84,
  anon_sym_EQ_EQ = 85,
  anon_sym_EQ_EQ_EQ = 86,
  anon_sym_BANG_EQ = 87,
  anon_sym_BANG_EQ_EQ = 88,
  anon_sym_GT_EQ = 89,
  anon_sym_QMARK_QMARK = 90,
  anon_sym_instanceof = 91,
  anon_sym_TILDE = 92,
  anon_sym_void = 93,
  anon_sym_delete = 94,
  anon_sym_PLUS_PLUS = 95,
  anon_sym_DASH_DASH = 96,
  anon_sym_DQUOTE = 97,
  anon_sym_SQUOTE = 98,
  sym_unescaped_double_string_fragment = 99,
  sym_unescaped_single_string_fragment = 100,
  sym_escape_sequence = 101,
  sym_comment = 102,
  anon_sym_BQUOTE = 103,
  anon_sym_DOLLAR_LBRACE = 104,
  anon_sym_SLASH2 = 105,
  sym_regex_pattern = 106,
  sym_regex_flags = 107,
  sym_number = 108,
  sym_private_property_identifier = 109,
  anon_sym_target = 110,
  sym_this = 111,
  sym_super = 112,
  sym_true = 113,
  sym_false = 114,
  sym_null = 115,
  sym_undefined = 116,
  anon_sym_AT = 117,
  anon_sym_static = 118,
  anon_sym_readonly = 119,
  anon_sym_get = 120,
  anon_sym_set = 121,
  anon_sym_QMARK = 122,
  anon_sym_declare = 123,
  anon_sym_public = 124,
  anon_sym_private = 125,
  anon_sym_protected = 126,
  anon_sym_override = 127,
  anon_sym_module = 128,
  anon_sym_any = 129,
  anon_sym_number = 130,
  anon_sym_boolean = 131,
  anon_sym_string = 132,
  anon_sym_symbol = 133,
  anon_sym_abstract = 134,
  anon_sym_require = 135,
  anon_sym_extends = 136,
  anon_sym_implements = 137,
  anon_sym_global = 138,
  anon_sym_interface = 139,
  anon_sym_enum = 140,
  anon_sym_DASH_QMARK_COLON = 141,
  anon_sym_QMARK_COLON = 142,
  anon_sym_asserts = 143,
  anon_sym_infer = 144,
  anon_sym_is = 145,
  anon_sym_keyof = 146,
  anon_sym_unknown = 147,
  anon_sym_never = 148,
  anon_sym_object = 149,
  anon_sym_LBRACE_PIPE = 150,
  anon_sym_PIPE_RBRACE = 151,
  sym__automatic_semicolon = 152,
  sym__template_chars = 153,
  sym__ternary_qmark = 154,
  sym__function_signature_automatic_semicolon = 155,
  sym_program = 156,
  sym_export_statement = 157,
  sym_export_clause = 158,
  sym__import_export_specifier = 159,
  sym_declaration = 160,
  sym_import = 161,
  sym_import_statement = 162,
  sym_import_clause = 163,
  sym__from_clause = 164,
  sym_namespace_import_export = 165,
  sym_named_imports = 166,
  sym_expression_statement = 167,
  sym_variable_declaration = 168,
  sym_lexical_declaration = 169,
  sym_variable_declarator = 170,
  sym_statement_block = 171,
  sym_else_clause = 172,
  sym_if_statement = 173,
  sym_switch_statement = 174,
  sym_for_statement = 175,
  sym_for_in_statement = 176,
  sym__for_header = 177,
  sym_while_statement = 178,
  sym_do_statement = 179,
  sym_try_statement = 180,
  sym_with_statement = 181,
  sym_break_statement = 182,
  sym_continue_statement = 183,
  sym_debugger_statement = 184,
  sym_return_statement = 185,
  sym_throw_statement = 186,
  sym_empty_statement = 187,
  sym_labeled_statement = 188,
  sym_switch_body = 189,
  sym_switch_case = 190,
  sym_switch_default = 191,
  sym_catch_clause = 192,
  sym_finally_clause = 193,
  sym_parenthesized_expression = 194,
  sym_expression = 195,
  sym_primary_expression = 196,
  sym_yield_expression = 197,
  sym_object = 198,
  sym_object_pattern = 199,
  sym_assignment_pattern = 200,
  sym_object_assignment_pattern = 201,
  sym_array = 202,
  sym_array_pattern = 203,
  sym_nested_identifier = 204,
  sym_class = 205,
  sym_class_declaration = 206,
  sym_class_heritage = 207,
  sym_function = 208,
  sym_function_declaration = 209,
  sym_generator_function = 210,
  sym_generator_function_declaration = 211,
  sym_arrow_function = 212,
  sym__call_signature = 213,
  sym__formal_parameter = 214,
  sym_call_expression = 215,
  sym_new_expression = 216,
  sym_await_expression = 217,
  sym_member_expression = 218,
  sym_subscript_expression = 219,
  sym_assignment_expression = 220,
  sym__augmented_assignment_lhs = 221,
  sym_augmented_assignment_expression = 222,
  sym__initializer = 223,
  sym__destructuring_pattern = 224,
  sym_spread_element = 225,
  sym_ternary_expression = 226,
  sym_binary_expression = 227,
  sym_unary_expression = 228,
  sym_update_expression = 229,
  sym_sequence_expression = 230,
  sym_string = 231,
  sym_template_string = 232,
  sym_template_substitution = 233,
  sym_regex = 234,
  sym_meta_property = 235,
  sym_arguments = 236,
  sym_decorator = 237,
  sym_decorator_member_expression = 238,
  sym_decorator_call_expression = 239,
  sym_class_body = 240,
  sym_formal_parameters = 241,
  sym_pattern = 242,
  sym_rest_pattern = 243,
  sym_method_definition = 244,
  sym_pair = 245,
  sym_pair_pattern = 246,
  sym__property_name = 247,
  sym_computed_property_name = 248,
  sym_public_field_definition = 249,
  sym_non_null_expression = 250,
  sym_method_signature = 251,
  sym_abstract_method_signature = 252,
  sym_function_signature = 253,
  sym_type_assertion = 254,
  sym_as_expression = 255,
  sym_import_require_clause = 256,
  sym_extends_clause = 257,
  sym_implements_clause = 258,
  sym_ambient_declaration = 259,
  sym_abstract_class_declaration = 260,
  sym_module = 261,
  sym_internal_module = 262,
  sym__module = 263,
  sym_import_alias = 264,
  sym_nested_type_identifier = 265,
  sym_interface_declaration = 266,
  sym_extends_type_clause = 267,
  sym_enum_declaration = 268,
  sym_enum_body = 269,
  sym_enum_assignment = 270,
  sym_type_alias_declaration = 271,
  sym_accessibility_modifier = 272,
  sym_override_modifier = 273,
  sym_required_parameter = 274,
  sym_optional_parameter = 275,
  sym__parameter_name = 276,
  sym_omitting_type_annotation = 277,
  sym_opting_type_annotation = 278,
  sym_type_annotation = 279,
  sym_asserts = 280,
  sym__type = 281,
  sym_tuple_parameter = 282,
  sym_optional_tuple_parameter = 283,
  sym_optional_type = 284,
  sym_rest_type = 285,
  sym__tuple_type_member = 286,
  sym_constructor_type = 287,
  sym__primary_type = 288,
  sym_template_type = 289,
  sym_template_literal_type = 290,
  sym_infer_type = 291,
  sym_conditional_type = 292,
  sym_generic_type = 293,
  sym_type_predicate = 294,
  sym_type_predicate_annotation = 295,
  sym__type_query_member_expression = 296,
  sym__type_query_subscript_expression = 297,
  sym__type_query_call_expression = 298,
  sym_type_query = 299,
  sym_index_type_query = 300,
  sym_lookup_type = 301,
  sym_mapped_type_clause = 302,
  sym_literal_type = 303,
  sym__number = 304,
  sym_existential_type = 305,
  sym_flow_maybe_type = 306,
  sym_parenthesized_type = 307,
  sym_predefined_type = 308,
  sym_type_arguments = 309,
  sym_object_type = 310,
  sym_call_signature = 311,
  sym_property_signature = 312,
  sym_type_parameters = 313,
  sym_type_parameter = 314,
  sym_default_type = 315,
  sym_constraint = 316,
  sym_construct_signature = 317,
  sym_index_signature = 318,
  sym_array_type = 319,
  sym_tuple_type = 320,
  sym_readonly_type = 321,
  sym_union_type = 322,
  sym_intersection_type = 323,
  sym_function_type = 324,
  aux_sym_program_repeat1 = 325,
  aux_sym_export_statement_repeat1 = 326,
  aux_sym_export_clause_repeat1 = 327,
  aux_sym_named_imports_repeat1 = 328,
  aux_sym_variable_declaration_repeat1 = 329,
  aux_sym_switch_body_repeat1 = 330,
  aux_sym_object_repeat1 = 331,
  aux_sym_object_pattern_repeat1 = 332,
  aux_sym_array_repeat1 = 333,
  aux_sym_array_pattern_repeat1 = 334,
  aux_sym_string_repeat1 = 335,
  aux_sym_string_repeat2 = 336,
  aux_sym_template_string_repeat1 = 337,
  aux_sym_class_body_repeat1 = 338,
  aux_sym_formal_parameters_repeat1 = 339,
  aux_sym_extends_clause_repeat1 = 340,
  aux_sym_implements_clause_repeat1 = 341,
  aux_sym_extends_type_clause_repeat1 = 342,
  aux_sym_enum_body_repeat1 = 343,
  aux_sym_template_literal_type_repeat1 = 344,
  aux_sym_object_type_repeat1 = 345,
  aux_sym_type_parameters_repeat1 = 346,
  aux_sym_tuple_type_repeat1 = 347,
  alias_sym_import_specifier = 348,
  alias_sym_namespace_export = 349,
  alias_sym_property_identifier = 350,
  alias_sym_shorthand_property_identifier = 351,
  alias_sym_shorthand_property_identifier_pattern = 352,
  alias_sym_statement_identifier = 353,
  alias_sym_this_type = 354,
  alias_sym_type_identifier = 355,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_private_property_identifier] = "private_property_identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_override] = "override",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_abstract] = "abstract",
  [anon_sym_require] = "require",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_object] = "object",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym__ternary_qmark] = "\?",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "export_specifier",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import_export] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_formal_parameters] = "formal_parameters",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_public_field_definition] = "public_field_definition",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_extends_clause] = "extends_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_type_clause] = "extends_type_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_override_modifier] = "override_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_asserts] = "asserts",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_template_type] = "template_type",
  [sym_template_literal_type] = "template_literal_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym__type_query_member_expression] = "member_expression",
  [sym__type_query_subscript_expression] = "subscript_expression",
  [sym__type_query_call_expression] = "call_expression",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_type_clause_repeat1] = "extends_type_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_template_literal_type_repeat1] = "template_literal_type_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_namespace_export] = "namespace_export",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_this_type] = "this_type",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_unescaped_double_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_unescaped_single_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [sym_private_property_identifier] = sym_private_property_identifier,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__ternary_qmark] = anon_sym_QMARK,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import_export] = sym_namespace_import_export,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_extends_clause] = sym_extends_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_type_clause] = sym_extends_type_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_override_modifier] = sym_override_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_asserts] = sym_asserts,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_template_type] = sym_template_type,
  [sym_template_literal_type] = sym_template_literal_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym__type_query_member_expression] = sym_member_expression,
  [sym__type_query_subscript_expression] = sym_subscript_expression,
  [sym__type_query_call_expression] = sym_call_expression,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_type_clause_repeat1] = aux_sym_extends_type_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_template_literal_type_repeat1] = aux_sym_template_literal_type_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_namespace_export] = alias_sym_namespace_export,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_this_type] = alias_sym_this_type,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_private_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym__ternary_qmark] = {
    .visible = true,
    .named = false,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import_export] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_override_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_type_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_export] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_constraint = 8,
  field_constructor = 9,
  field_declaration = 10,
  field_decorator = 11,
  field_finalizer = 12,
  field_flags = 13,
  field_function = 14,
  field_handler = 15,
  field_increment = 16,
  field_index = 17,
  field_index_type = 18,
  field_initializer = 19,
  field_key = 20,
  field_kind = 21,
  field_label = 22,
  field_left = 23,
  field_module = 24,
  field_name = 25,
  field_object = 26,
  field_operator = 27,
  field_parameter = 28,
  field_parameters = 29,
  field_pattern = 30,
  field_property = 31,
  field_return_type = 32,
  field_right = 33,
  field_sign = 34,
  field_source = 35,
  field_type = 36,
  field_type_arguments = 37,
  field_type_parameters = 38,
  field_value = 39,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_index_type] = "index_type",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 1},
  [13] = {.index = 3, .length = 1},
  [15] = {.index = 12, .length = 2},
  [16] = {.index = 14, .length = 1},
  [17] = {.index = 15, .length = 2},
  [18] = {.index = 17, .length = 2},
  [19] = {.index = 19, .length = 2},
  [20] = {.index = 21, .length = 2},
  [21] = {.index = 23, .length = 2},
  [22] = {.index = 25, .length = 1},
  [23] = {.index = 26, .length = 2},
  [24] = {.index = 28, .length = 2},
  [25] = {.index = 30, .length = 2},
  [26] = {.index = 32, .length = 2},
  [30] = {.index = 34, .length = 1},
  [31] = {.index = 35, .length = 2},
  [32] = {.index = 37, .length = 2},
  [33] = {.index = 39, .length = 1},
  [34] = {.index = 40, .length = 2},
  [35] = {.index = 42, .length = 2},
  [36] = {.index = 44, .length = 6},
  [37] = {.index = 50, .length = 1},
  [38] = {.index = 51, .length = 3},
  [39] = {.index = 54, .length = 3},
  [40] = {.index = 57, .length = 2},
  [41] = {.index = 59, .length = 2},
  [42] = {.index = 61, .length = 2},
  [43] = {.index = 63, .length = 2},
  [44] = {.index = 65, .length = 2},
  [45] = {.index = 67, .length = 1},
  [46] = {.index = 68, .length = 3},
  [47] = {.index = 71, .length = 2},
  [48] = {.index = 73, .length = 2},
  [49] = {.index = 75, .length = 2},
  [50] = {.index = 77, .length = 2},
  [51] = {.index = 79, .length = 2},
  [52] = {.index = 81, .length = 2},
  [54] = {.index = 77, .length = 2},
  [55] = {.index = 83, .length = 2},
  [56] = {.index = 85, .length = 1},
  [57] = {.index = 86, .length = 1},
  [58] = {.index = 87, .length = 2},
  [59] = {.index = 89, .length = 4},
  [60] = {.index = 93, .length = 2},
  [61] = {.index = 95, .length = 2},
  [62] = {.index = 26, .length = 2},
  [63] = {.index = 30, .length = 2},
  [64] = {.index = 83, .length = 2},
  [65] = {.index = 97, .length = 3},
  [66] = {.index = 100, .length = 2},
  [67] = {.index = 100, .length = 2},
  [68] = {.index = 102, .length = 3},
  [69] = {.index = 105, .length = 2},
  [70] = {.index = 107, .length = 4},
  [71] = {.index = 111, .length = 3},
  [72] = {.index = 114, .length = 2},
  [73] = {.index = 116, .length = 2},
  [74] = {.index = 118, .length = 1},
  [75] = {.index = 119, .length = 1},
  [76] = {.index = 120, .length = 1},
  [77] = {.index = 121, .length = 2},
  [78] = {.index = 118, .length = 1},
  [79] = {.index = 26, .length = 2},
  [80] = {.index = 123, .length = 2},
  [81] = {.index = 125, .length = 5},
  [82] = {.index = 130, .length = 1},
  [83] = {.index = 121, .length = 2},
  [84] = {.index = 131, .length = 2},
  [85] = {.index = 133, .length = 3},
  [86] = {.index = 136, .length = 2},
  [87] = {.index = 138, .length = 3},
  [88] = {.index = 141, .length = 6},
  [89] = {.index = 147, .length = 1},
  [90] = {.index = 148, .length = 1},
  [91] = {.index = 149, .length = 3},
  [92] = {.index = 152, .length = 3},
  [93] = {.index = 155, .length = 4},
  [94] = {.index = 159, .length = 2},
  [95] = {.index = 161, .length = 3},
  [96] = {.index = 164, .length = 1},
  [97] = {.index = 165, .length = 4},
  [98] = {.index = 169, .length = 4},
  [99] = {.index = 173, .length = 4},
  [100] = {.index = 177, .length = 2},
  [101] = {.index = 179, .length = 3},
  [102] = {.index = 182, .length = 2},
  [103] = {.index = 184, .length = 2},
  [104] = {.index = 186, .length = 2},
  [105] = {.index = 188, .length = 3},
  [106] = {.index = 191, .length = 2},
  [107] = {.index = 193, .length = 3},
  [108] = {.index = 196, .length = 2},
  [109] = {.index = 198, .length = 2},
  [110] = {.index = 200, .length = 4},
  [111] = {.index = 198, .length = 2},
  [112] = {.index = 204, .length = 4},
  [113] = {.index = 208, .length = 4},
  [114] = {.index = 212, .length = 5},
  [115] = {.index = 217, .length = 3},
  [116] = {.index = 136, .length = 2},
  [117] = {.index = 220, .length = 1},
  [118] = {.index = 220, .length = 1},
  [119] = {.index = 221, .length = 2},
  [120] = {.index = 223, .length = 3},
  [121] = {.index = 226, .length = 2},
  [122] = {.index = 228, .length = 3},
  [123] = {.index = 231, .length = 2},
  [124] = {.index = 233, .length = 3},
  [125] = {.index = 236, .length = 2},
  [126] = {.index = 238, .length = 2},
  [127] = {.index = 240, .length = 5},
  [128] = {.index = 245, .length = 1},
  [129] = {.index = 246, .length = 1},
  [130] = {.index = 247, .length = 4},
  [131] = {.index = 251, .length = 2},
  [132] = {.index = 253, .length = 2},
  [133] = {.index = 255, .length = 2},
  [134] = {.index = 257, .length = 2},
  [135] = {.index = 259, .length = 1},
  [136] = {.index = 260, .length = 2},
  [137] = {.index = 262, .length = 4},
  [138] = {.index = 266, .length = 4},
  [139] = {.index = 266, .length = 4},
  [140] = {.index = 270, .length = 4},
  [141] = {.index = 270, .length = 4},
  [142] = {.index = 274, .length = 4},
  [143] = {.index = 274, .length = 4},
  [144] = {.index = 278, .length = 2},
  [145] = {.index = 280, .length = 3},
  [146] = {.index = 283, .length = 2},
  [147] = {.index = 285, .length = 2},
  [148] = {.index = 287, .length = 3},
  [149] = {.index = 290, .length = 4},
  [150] = {.index = 294, .length = 4},
  [151] = {.index = 298, .length = 4},
  [152] = {.index = 302, .length = 4},
  [153] = {.index = 306, .length = 5},
  [154] = {.index = 311, .length = 2},
  [155] = {.index = 313, .length = 3},
  [156] = {.index = 316, .length = 2},
  [157] = {.index = 316, .length = 2},
  [158] = {.index = 318, .length = 3},
  [159] = {.index = 321, .length = 2},
  [160] = {.index = 323, .length = 2},
  [161] = {.index = 325, .length = 3},
  [162] = {.index = 328, .length = 4},
  [163] = {.index = 332, .length = 3},
  [164] = {.index = 335, .length = 3},
  [165] = {.index = 338, .length = 2},
  [166] = {.index = 340, .length = 3},
  [167] = {.index = 343, .length = 5},
  [168] = {.index = 348, .length = 3},
  [169] = {.index = 348, .length = 3},
  [170] = {.index = 351, .length = 3},
  [171] = {.index = 354, .length = 2},
  [172] = {.index = 356, .length = 4},
  [173] = {.index = 131, .length = 2},
  [174] = {.index = 360, .length = 1},
  [175] = {.index = 361, .length = 3},
  [176] = {.index = 364, .length = 2},
  [177] = {.index = 366, .length = 2},
  [178] = {.index = 368, .length = 1},
  [179] = {.index = 369, .length = 4},
  [180] = {.index = 373, .length = 4},
  [181] = {.index = 377, .length = 4},
  [182] = {.index = 381, .length = 3},
  [183] = {.index = 384, .length = 2},
  [184] = {.index = 386, .length = 2},
  [185] = {.index = 388, .length = 3},
  [186] = {.index = 391, .length = 3},
  [187] = {.index = 394, .length = 5},
  [188] = {.index = 399, .length = 3},
  [189] = {.index = 402, .length = 2},
  [190] = {.index = 404, .length = 2},
  [191] = {.index = 406, .length = 2},
  [192] = {.index = 408, .length = 1},
  [193] = {.index = 409, .length = 4},
  [194] = {.index = 413, .length = 3},
  [195] = {.index = 416, .length = 4},
  [196] = {.index = 420, .length = 5},
  [197] = {.index = 425, .length = 1},
  [198] = {.index = 426, .length = 2},
  [199] = {.index = 428, .length = 4},
  [200] = {.index = 432, .length = 4},
  [201] = {.index = 436, .length = 2},
  [202] = {.index = 438, .length = 4},
  [203] = {.index = 442, .length = 4},
  [204] = {.index = 446, .length = 2},
  [205] = {.index = 448, .length = 2},
  [206] = {.index = 450, .length = 1},
  [207] = {.index = 451, .length = 1},
  [208] = {.index = 452, .length = 4},
  [209] = {.index = 456, .length = 4},
  [210] = {.index = 460, .length = 4},
  [211] = {.index = 464, .length = 2},
  [212] = {.index = 466, .length = 3},
  [213] = {.index = 469, .length = 3},
  [214] = {.index = 472, .length = 2},
  [216] = {.index = 474, .length = 4},
  [217] = {.index = 478, .length = 5},
  [218] = {.index = 483, .length = 5},
  [219] = {.index = 488, .length = 5},
  [220] = {.index = 493, .length = 3},
  [221] = {.index = 496, .length = 3},
  [222] = {.index = 499, .length = 3},
  [223] = {.index = 496, .length = 3},
  [224] = {.index = 502, .length = 2},
  [225] = {.index = 504, .length = 4},
  [226] = {.index = 508, .length = 4},
  [227] = {.index = 512, .length = 2},
  [228] = {.index = 514, .length = 2},
  [229] = {.index = 516, .length = 4},
  [230] = {.index = 520, .length = 3},
  [231] = {.index = 523, .length = 2},
  [232] = {.index = 525, .length = 3},
  [233] = {.index = 528, .length = 2},
  [234] = {.index = 530, .length = 1},
  [235] = {.index = 531, .length = 5},
  [236] = {.index = 536, .length = 5},
  [237] = {.index = 541, .length = 4},
  [238] = {.index = 545, .length = 4},
  [239] = {.index = 549, .length = 3},
  [240] = {.index = 549, .length = 3},
  [241] = {.index = 552, .length = 2},
  [242] = {.index = 554, .length = 3},
  [243] = {.index = 557, .length = 2},
  [244] = {.index = 559, .length = 3},
  [245] = {.index = 562, .length = 2},
  [246] = {.index = 564, .length = 2},
  [247] = {.index = 566, .length = 5},
  [248] = {.index = 571, .length = 5},
  [249] = {.index = 576, .length = 4},
  [250] = {.index = 576, .length = 4},
  [251] = {.index = 580, .length = 4},
  [252] = {.index = 584, .length = 4},
  [253] = {.index = 588, .length = 3},
  [254] = {.index = 591, .length = 2},
  [255] = {.index = 593, .length = 2},
  [256] = {.index = 595, .length = 3},
  [257] = {.index = 598, .length = 5},
  [258] = {.index = 603, .length = 4},
  [259] = {.index = 607, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_pattern, 0},
  [9] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [11] =
    {field_body, 1},
  [12] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [14] =
    {field_constructor, 1},
  [15] =
    {field_argument, 0},
    {field_operator, 1},
  [17] =
    {field_arguments, 1},
    {field_function, 0},
  [19] =
    {field_parameters, 0},
    {field_return_type, 1},
  [21] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [23] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [25] =
    {field_declaration, 2},
  [26] =
    {field_left, 0},
    {field_right, 2},
  [28] =
    {field_body, 2},
    {field_label, 0},
  [30] =
    {field_body, 2},
    {field_parameter, 0},
  [32] =
    {field_body, 1},
    {field_name, 0},
  [34] =
    {field_source, 1},
  [35] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [37] =
    {field_name, 0},
    {field_type, 1},
  [39] =
    {field_kind, 0},
  [40] =
    {field_condition, 1},
    {field_consequence, 2},
  [42] =
    {field_body, 2},
    {field_value, 1},
  [44] =
    {field_body, 2},
    {field_kind, 1, .inherited = true},
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [50] =
    {field_pattern, 1},
  [51] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [54] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
  [57] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 1},
  [59] =
    {field_body, 2},
    {field_condition, 1},
  [61] =
    {field_body, 1},
    {field_handler, 2},
  [63] =
    {field_body, 1},
    {field_finalizer, 2},
  [65] =
    {field_body, 2},
    {field_object, 1},
  [67] =
    {field_label, 1},
  [68] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [71] =
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [73] =
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [75] =
    {field_arguments, 1, .inherited = true},
    {field_function, 1, .inherited = true},
  [77] =
    {field_name, 0},
    {field_type_arguments, 1},
  [79] =
    {field_name, 0},
    {field_value, 1},
  [81] =
    {field_constraint, 1},
    {field_name, 0},
  [83] =
    {field_body, 2},
    {field_name, 1},
  [85] =
    {field_value, 1},
  [86] =
    {field_body, 2},
  [87] =
    {field_body, 2},
    {field_type_parameters, 1},
  [89] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [93] =
    {field_arguments, 2},
    {field_constructor, 1},
  [95] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [97] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [100] =
    {field_object, 0},
    {field_property, 2},
  [102] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [105] =
    {field_arguments, 2},
    {field_function, 0},
  [107] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [111] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [114] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [116] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [118] =
    {field_source, 2, .inherited = true},
  [119] =
    {field_value, 2},
  [120] =
    {field_name, 1},
  [121] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [123] =
    {field_key, 0},
    {field_value, 2},
  [125] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [130] =
    {field_source, 2},
  [131] =
    {field_name, 0},
    {field_type, 2},
  [133] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [136] =
    {field_body, 3},
    {field_name, 2},
  [138] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [141] =
    {field_body, 3},
    {field_kind, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [147] =
    {field_type, 2},
  [148] =
    {field_pattern, 2},
  [149] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [152] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
  [155] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [159] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 2},
  [161] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [164] =
    {field_parameters, 1},
  [165] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [169] =
    {field_arguments, 1},
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [173] =
    {field_arguments, 1},
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [177] =
    {field_module, 0},
    {field_name, 2},
  [179] =
    {field_constraint, 1},
    {field_name, 0},
    {field_value, 2},
  [182] =
    {field_parameters, 0},
    {field_return_type, 2},
  [184] =
    {field_flags, 3},
    {field_pattern, 1},
  [186] =
    {field_body, 3},
    {field_name, 1},
  [188] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [191] =
    {field_type_arguments, 2},
    {field_value, 1},
  [193] =
    {field_type_arguments, 2, .inherited = true},
    {field_value, 1},
    {field_value, 2, .inherited = true},
  [196] =
    {field_body, 3},
    {field_type_parameters, 1},
  [198] =
    {field_body, 3},
    {field_parameter, 1},
  [200] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [204] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [208] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [212] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [217] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [220] =
    {field_type, 1},
  [221] =
    {field_index, 2},
    {field_object, 0},
  [223] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [226] =
    {field_declaration, 3},
    {field_decorator, 0, .inherited = true},
  [228] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [231] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [233] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [236] =
    {field_alias, 2},
    {field_name, 0},
  [238] =
    {field_name, 1},
    {field_value, 3},
  [240] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [245] =
    {field_source, 3, .inherited = true},
  [246] =
    {field_pattern, 3},
  [247] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [251] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 3},
  [253] =
    {field_body, 1},
    {field_condition, 3},
  [255] =
    {field_parameters, 1},
    {field_type, 2},
  [257] =
    {field_parameters, 2},
    {field_type_parameters, 1},
  [259] =
    {field_name, 2},
  [260] =
    {field_name, 1},
    {field_type, 2},
  [262] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [266] =
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 2},
  [270] =
    {field_index, 0, .inherited = true},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 2},
  [274] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_object, 0},
    {field_property, 2},
  [278] =
    {field_parameters, 1},
    {field_type, 3},
  [280] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_type_parameters, 0},
  [283] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [285] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [287] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [290] =
    {field_type_arguments, 2},
    {field_type_arguments, 3, .inherited = true},
    {field_value, 1},
    {field_value, 3, .inherited = true},
  [294] =
    {field_type_arguments, 0, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [298] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [302] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [306] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [311] =
    {field_body, 4},
    {field_name, 2},
  [313] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [316] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [318] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [321] =
    {field_index, 3},
    {field_object, 0},
  [323] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [325] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [328] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [332] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [335] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [338] =
    {field_alias, 3},
    {field_name, 1},
  [340] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [343] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [348] =
    {field_left, 1},
    {field_operator, 2},
    {field_right, 3},
  [351] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [354] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 4},
  [356] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [360] =
    {field_type, 3},
  [361] =
    {field_parameters, 2},
    {field_type, 3},
    {field_type_parameters, 1},
  [364] =
    {field_name, 2},
    {field_type, 3},
  [366] =
    {field_name, 1},
    {field_type, 3},
  [368] =
    {field_name, 3},
  [369] =
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [373] =
    {field_index, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [377] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
  [381] =
    {field_parameters, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [384] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [386] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [388] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [391] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [394] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [399] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [402] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [404] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [406] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [408] =
    {field_name, 2, .inherited = true},
  [409] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [413] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [416] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [420] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [425] =
    {field_source, 4},
  [426] =
    {field_body, 3},
    {field_value, 1},
  [428] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [432] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [436] =
    {field_body, 4},
    {field_parameter, 2},
  [438] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [442] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [446] =
    {field_name, 2},
    {field_type, 4},
  [448] =
    {field_name, 3},
    {field_type, 4},
  [450] =
    {field_type, 4},
  [451] =
    {field_name, 4},
  [452] =
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [456] =
    {field_index, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [460] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
  [464] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [466] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [469] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [472] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [474] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [478] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [483] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [488] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 4},
    {field_right, 5},
    {field_value, 3, .inherited = true},
  [493] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [496] =
    {field_index_type, 3},
    {field_name, 1},
    {field_type, 5},
  [499] =
    {field_alias, 4},
    {field_name, 0},
    {field_type, 2},
  [502] =
    {field_sign, 0},
    {field_type, 5},
  [504] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [508] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [512] =
    {field_name, 3},
    {field_type, 5},
  [514] =
    {field_name, 4},
    {field_type, 5},
  [516] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [520] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [523] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [525] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [528] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [530] =
    {field_name, 5},
  [531] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [536] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [541] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [545] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [549] =
    {field_index_type, 4},
    {field_name, 2},
    {field_type, 6},
  [552] =
    {field_name, 4},
    {field_type, 6},
  [554] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [557] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [559] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [562] =
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [564] =
    {field_name, 5},
    {field_type, 6},
  [566] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [571] =
    {field_body, 8},
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [576] =
    {field_index_type, 5},
    {field_name, 3},
    {field_sign, 0},
    {field_type, 7},
  [580] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [584] =
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [588] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [591] =
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [593] =
    {field_name, 5},
    {field_type, 7},
  [595] =
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [598] =
    {field_body, 9},
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [603] =
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [607] =
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [12] = {
    [0] = alias_sym_type_identifier,
  },
  [13] = {
    [0] = alias_sym_type_identifier,
  },
  [14] = {
    [0] = alias_sym_this_type,
  },
  [23] = {
    [0] = sym_identifier,
  },
  [24] = {
    [0] = alias_sym_statement_identifier,
  },
  [25] = {
    [0] = sym_identifier,
  },
  [27] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [28] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [29] = {
    [1] = sym_identifier,
  },
  [45] = {
    [1] = alias_sym_statement_identifier,
  },
  [50] = {
    [0] = alias_sym_type_identifier,
  },
  [51] = {
    [0] = alias_sym_type_identifier,
  },
  [52] = {
    [0] = alias_sym_type_identifier,
  },
  [53] = {
    [1] = alias_sym_type_identifier,
  },
  [55] = {
    [1] = alias_sym_type_identifier,
  },
  [66] = {
    [2] = alias_sym_property_identifier,
  },
  [78] = {
    [1] = alias_sym_namespace_export,
  },
  [79] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [83] = {
    [1] = alias_sym_import_specifier,
  },
  [100] = {
    [2] = alias_sym_type_identifier,
  },
  [101] = {
    [0] = alias_sym_type_identifier,
  },
  [104] = {
    [1] = alias_sym_type_identifier,
  },
  [105] = {
    [1] = alias_sym_type_identifier,
  },
  [109] = {
    [1] = sym_identifier,
  },
  [116] = {
    [2] = alias_sym_type_identifier,
  },
  [117] = {
    [1] = alias_sym_type_identifier,
  },
  [122] = {
    [2] = alias_sym_type_identifier,
  },
  [126] = {
    [1] = alias_sym_type_identifier,
  },
  [138] = {
    [2] = alias_sym_property_identifier,
  },
  [140] = {
    [2] = alias_sym_property_identifier,
  },
  [142] = {
    [2] = alias_sym_property_identifier,
  },
  [148] = {
    [1] = alias_sym_type_identifier,
  },
  [154] = {
    [2] = alias_sym_type_identifier,
  },
  [155] = {
    [2] = alias_sym_type_identifier,
  },
  [156] = {
    [1] = alias_sym_type_identifier,
  },
  [161] = {
    [2] = alias_sym_type_identifier,
  },
  [162] = {
    [2] = alias_sym_type_identifier,
  },
  [164] = {
    [3] = alias_sym_type_identifier,
  },
  [166] = {
    [1] = alias_sym_type_identifier,
  },
  [168] = {
    [1] = sym_identifier,
  },
  [173] = {
    [0] = alias_sym_type_identifier,
  },
  [188] = {
    [2] = alias_sym_type_identifier,
  },
  [193] = {
    [2] = alias_sym_type_identifier,
  },
  [194] = {
    [3] = alias_sym_type_identifier,
  },
  [195] = {
    [3] = alias_sym_type_identifier,
  },
  [215] = {
    [3] = alias_sym_property_identifier,
  },
  [216] = {
    [3] = alias_sym_type_identifier,
  },
  [221] = {
    [1] = sym_identifier,
  },
  [222] = {
    [0] = alias_sym_type_identifier,
  },
  [239] = {
    [2] = sym_identifier,
  },
  [249] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__import_export_specifier, 2,
    sym__import_export_specifier,
    alias_sym_import_specifier,
  sym_namespace_import_export, 2,
    sym_namespace_import_export,
    alias_sym_namespace_export,
  0,
};

static inline bool anon_sym_BANG_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? (c >= '\t' && c <= '\n')
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_regex_pattern_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '{' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '|' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_private_property_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < '['
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '@')))
      : (c <= '^' || (c < '{'
        ? c == '`'
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '$') ADVANCE(200);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(206);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(29);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(69)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(201);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(22)
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(68);
      if (sym_regex_pattern_character_set_1(lookahead)) ADVANCE(187);
      if (lookahead != 0) ADVANCE(188);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(206);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(2)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(201);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(147);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(206);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(137);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(3)
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(201);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(25);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(20);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '}') ADVANCE(83);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(5)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(201);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(25);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(20);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(139);
      if (lookahead == '}') ADVANCE(83);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(5)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(201);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(30);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(202);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '?') ADVANCE(204);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(136);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(7)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(201);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(205);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(8)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '*' < lookahead) &&
          lookahead != '^') ADVANCE(201);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(142);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(204);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(83);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(10)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(201);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(142);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(204);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(83);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(10)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(201);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(19);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(41);
      if (lookahead == '}') ADVANCE(83);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(11)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(201);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead == '\\') ADVANCE(32);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(170);
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 13:
      if (lookahead == '$') ADVANCE(33);
      if (lookahead == '-') ADVANCE(26);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == '?') ADVANCE(24);
      if (lookahead == '\\') ADVANCE(32);
      if (lookahead == '`') ADVANCE(184);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(14)
      END_STATE();
    case 14:
      if (lookahead == '$') ADVANCE(33);
      if (lookahead == '-') ADVANCE(26);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == '?') ADVANCE(24);
      if (lookahead == '`') ADVANCE(184);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(14)
      END_STATE();
    case 15:
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '\\') ADVANCE(32);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(176);
      if (lookahead != 0) ADVANCE(177);
      END_STATE();
    case 16:
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(183);
      END_STATE();
    case 17:
      if (lookahead == '*') ADVANCE(17);
      if (lookahead == '/') ADVANCE(182);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(17);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 19:
      if (lookahead == '.') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 20:
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '?') ADVANCE(159);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(120);
      END_STATE();
    case 22:
      if (lookahead == '/') ADVANCE(16);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(22)
      END_STATE();
    case 23:
      if (lookahead == ':') ADVANCE(208);
      END_STATE();
    case 24:
      if (lookahead == ':') ADVANCE(209);
      END_STATE();
    case 25:
      if (lookahead == '=') ADVANCE(154);
      END_STATE();
    case 26:
      if (lookahead == '?') ADVANCE(23);
      END_STATE();
    case 27:
      if (lookahead == '\\') ADVANCE(30);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(202);
      END_STATE();
    case 28:
      if (lookahead == '\\') ADVANCE(67);
      if (lookahead == ']') ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == 'u') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(181);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 30:
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 31:
      if (lookahead == 'u') ADVANCE(36);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(37);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(181);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 33:
      if (lookahead == '{') ADVANCE(185);
      END_STATE();
    case 34:
      if (lookahead == '{') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 36:
      if (lookahead == '{') ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 37:
      if (lookahead == '{') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 38:
      if (lookahead == '}') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 39:
      if (lookahead == '}') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '}') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == '}') ADVANCE(211);
      END_STATE();
    case 42:
      if (lookahead == '}') ADVANCE(179);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(197);
      END_STATE();
    case 44:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(193);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(194);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(196);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(197);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(201);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(202);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(178);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(195);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(179);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 67:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(28);
      END_STATE();
    case 68:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(188);
      END_STATE();
    case 69:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '$') ADVANCE(200);
      if (lookahead == '%') ADVANCE(150);
      if (lookahead == '&') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(144);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(206);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(135);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(138);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(69)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(201);
      END_STATE();
    case 70:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(102);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(207);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(134);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(140);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(70)
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(201);
      END_STATE();
    case 71:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(165);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(204);
      if (lookahead == '@') ADVANCE(203);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(184);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(141);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(71)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(201);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(151);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(154);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '>') ADVANCE(103);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(103);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(210);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(156);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(130);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(129);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(125);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(126);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(183);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(183);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(113);
      if (lookahead == '>') ADVANCE(128);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(122);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(121);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(112);
      if (lookahead == '|') ADVANCE(124);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(112);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(211);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(123);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(211);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(211);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(162);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(162);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      if (lookahead == '=') ADVANCE(106);
      if (lookahead == '?') ADVANCE(23);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(157);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '\n') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(169);
      if (lookahead == '/') ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(171);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '/') ADVANCE(167);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(171);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(171);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '\n') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(172);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(175);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(175);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(175);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '/') ADVANCE(173);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(31);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(201);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(180);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(183);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(22)
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(68);
      if (sym_regex_pattern_character_set_1(lookahead)) ADVANCE(187);
      if (lookahead != 0) ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(31);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(189);
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(201);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(199);
      if (lookahead == '0') ADVANCE(196);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(44);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(45);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(53);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(190);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(199);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == '_') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(190);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(53);
      if (lookahead == 'n') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(195);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(196);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(197);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (lookahead == '_') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == '{') ADVANCE(185);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(201);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(31);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(201);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_private_property_identifier);
      if (lookahead == '\\') ADVANCE(30);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(202);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(104);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '?') ADVANCE(160);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(104);
      if (lookahead == '?') ADVANCE(159);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8203) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 8288 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'b') ADVANCE(53);
      if (lookahead == 'f') ADVANCE(54);
      if (lookahead == 'v') ADVANCE(55);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(59);
      if (lookahead == 't') ADVANCE(60);
      if (lookahead == 'u') ADVANCE(61);
      if (lookahead == 'w') ADVANCE(62);
      if (lookahead == 'y') ADVANCE(63);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(64);
      if (lookahead == 'h') ADVANCE(65);
      if (lookahead == 'r') ADVANCE(66);
      if (lookahead == 'y') ADVANCE(67);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(68);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(69);
      if (lookahead == 'o') ADVANCE(70);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(71);
      if (lookahead == 'i') ADVANCE(72);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(73);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(75);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(76);
      if (lookahead == 'y') ADVANCE(77);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(81);
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(84);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(85);
      if (lookahead == 'c') ADVANCE(86);
      if (lookahead == 'f') ADVANCE(87);
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(89);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(90);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(91);
      if (lookahead == 't') ADVANCE(92);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(95);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(99);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(100);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(101);
      if (lookahead == 's') ADVANCE(102);
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(104);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(106);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(107);
      END_STATE();
    case 51:
      if (lookahead == 'v') ADVANCE(108);
      if (lookahead == 'w') ADVANCE(109);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(110);
      if (lookahead == 'm') ADVANCE(111);
      END_STATE();
    case 53:
      if (lookahead == 'j') ADVANCE(112);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(114);
      if (lookahead == 'o') ADVANCE(115);
      END_STATE();
    case 57:
      if (lookahead == 'b') ADVANCE(116);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(117);
      if (lookahead == 'q') ADVANCE(118);
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(121);
      if (lookahead == 'r') ADVANCE(122);
      END_STATE();
    case 61:
      if (lookahead == 'p') ADVANCE(123);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(124);
      END_STATE();
    case 63:
      if (lookahead == 'm') ADVANCE(125);
      END_STATE();
    case 64:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(127);
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 66:
      if (lookahead == 'u') ADVANCE(129);
      if (lookahead == 'y') ADVANCE(130);
      END_STATE();
    case 67:
      if (lookahead == 'p') ADVANCE(131);
      END_STATE();
    case 68:
      if (lookahead == 'd') ADVANCE(132);
      if (lookahead == 'k') ADVANCE(133);
      END_STATE();
    case 69:
      if (lookahead == 'r') ADVANCE(134);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(135);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(136);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 77:
      if (lookahead == 'n') ADVANCE(141);
      END_STATE();
    case 78:
      if (lookahead == 'i') ADVANCE(142);
      END_STATE();
    case 79:
      if (lookahead == 'l') ADVANCE(143);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(144);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 82:
      if (lookahead == 'c') ADVANCE(146);
      END_STATE();
    case 83:
      if (lookahead == 's') ADVANCE(147);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(148);
      if (lookahead == 't') ADVANCE(149);
      END_STATE();
    case 85:
      if (lookahead == 'u') ADVANCE(150);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(151);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 90:
      if (lookahead == 'm') ADVANCE(155);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(156);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 93:
      if (lookahead == 's') ADVANCE(158);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(159);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 96:
      if (lookahead == 'm') ADVANCE(160);
      END_STATE();
    case 97:
      if (lookahead == 'c') ADVANCE(161);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 99:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 100:
      if (lookahead == 'l') ADVANCE(163);
      if (lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 102:
      if (lookahead == 't') ADVANCE(166);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 104:
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 106:
      if (lookahead == 'u') ADVANCE(169);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 110:
      if (lookahead == 'l') ADVANCE(172);
      END_STATE();
    case 111:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 113:
      if (lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 114:
      if (lookahead == 'v') ADVANCE(176);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(177);
      END_STATE();
    case 116:
      if (lookahead == 'l') ADVANCE(178);
      END_STATE();
    case 117:
      if (lookahead == 'd') ADVANCE(179);
      END_STATE();
    case 118:
      if (lookahead == 'u') ADVANCE(180);
      END_STATE();
    case 119:
      if (lookahead == 'u') ADVANCE(181);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(182);
      END_STATE();
    case 122:
      if (lookahead == 'i') ADVANCE(183);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 124:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 125:
      if (lookahead == 'b') ADVANCE(186);
      END_STATE();
    case 126:
      if (lookahead == 'g') ADVANCE(187);
      END_STATE();
    case 127:
      if (lookahead == 's') ADVANCE(188);
      END_STATE();
    case 128:
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 129:
      if (lookahead == 'e') ADVANCE(190);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(191);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(192);
      END_STATE();
    case 133:
      if (lookahead == 'n') ADVANCE(193);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 135:
      if (lookahead == 'd') ADVANCE(194);
      END_STATE();
    case 136:
      if (lookahead == 'l') ADVANCE(195);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(196);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(197);
      END_STATE();
    case 139:
      if (lookahead == 'r') ADVANCE(198);
      END_STATE();
    case 140:
      if (lookahead == 'r') ADVANCE(199);
      END_STATE();
    case 141:
      if (lookahead == 'c') ADVANCE(200);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 143:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 144:
      if (lookahead == 'k') ADVANCE(203);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 146:
      if (lookahead == 'h') ADVANCE(204);
      END_STATE();
    case 147:
      if (lookahead == 's') ADVANCE(205);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 149:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 150:
      if (lookahead == 'g') ADVANCE(208);
      END_STATE();
    case 151:
      if (lookahead == 'a') ADVANCE(209);
      END_STATE();
    case 152:
      if (lookahead == 'u') ADVANCE(210);
      END_STATE();
    case 153:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 156:
      if (lookahead == 'r') ADVANCE(212);
      END_STATE();
    case 157:
      if (lookahead == 'n') ADVANCE(213);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(215);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 162:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 163:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 165:
      if (lookahead == 'r') ADVANCE(220);
      END_STATE();
    case 166:
      if (lookahead == 'a') ADVANCE(221);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(222);
      END_STATE();
    case 168:
      if (lookahead == 'f') ADVANCE(223);
      END_STATE();
    case 169:
      if (lookahead == 'l') ADVANCE(224);
      END_STATE();
    case 170:
      if (lookahead == 's') ADVANCE(225);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 174:
      if (lookahead == 'c') ADVANCE(228);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(229);
      END_STATE();
    case 176:
      if (lookahead == 'a') ADVANCE(230);
      END_STATE();
    case 177:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 178:
      if (lookahead == 'i') ADVANCE(232);
      END_STATE();
    case 179:
      if (lookahead == 'o') ADVANCE(233);
      END_STATE();
    case 180:
      if (lookahead == 'i') ADVANCE(234);
      END_STATE();
    case 181:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 182:
      if (lookahead == 'i') ADVANCE(236);
      END_STATE();
    case 183:
      if (lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 184:
      if (lookahead == 'r') ADVANCE(238);
      END_STATE();
    case 185:
      if (lookahead == 'c') ADVANCE(239);
      END_STATE();
    case 186:
      if (lookahead == 'o') ADVANCE(240);
      END_STATE();
    case 187:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 189:
      if (lookahead == 'w') ADVANCE(242);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(243);
      END_STATE();
    case 192:
      if (lookahead == 'f') ADVANCE(244);
      END_STATE();
    case 193:
      if (lookahead == 'o') ADVANCE(245);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 195:
      if (lookahead == 'e') ADVANCE(246);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 197:
      if (lookahead == 'd') ADVANCE(247);
      END_STATE();
    case 198:
      if (lookahead == 'a') ADVANCE(248);
      END_STATE();
    case 199:
      if (lookahead == 't') ADVANCE(249);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 202:
      if (lookahead == 'a') ADVANCE(250);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 207:
      if (lookahead == 'n') ADVANCE(251);
      END_STATE();
    case 208:
      if (lookahead == 'g') ADVANCE(252);
      END_STATE();
    case 209:
      if (lookahead == 'r') ADVANCE(253);
      END_STATE();
    case 210:
      if (lookahead == 'l') ADVANCE(254);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(255);
      END_STATE();
    case 212:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 213:
      if (lookahead == 'd') ADVANCE(257);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 215:
      if (lookahead == 'l') ADVANCE(258);
      END_STATE();
    case 216:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 217:
      if (lookahead == 'l') ADVANCE(260);
      END_STATE();
    case 218:
      if (lookahead == 'm') ADVANCE(261);
      END_STATE();
    case 219:
      if (lookahead == 't') ADVANCE(262);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 221:
      if (lookahead == 'n') ADVANCE(263);
      END_STATE();
    case 222:
      if (lookahead == 'f') ADVANCE(264);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 224:
      if (lookahead == 'e') ADVANCE(265);
      END_STATE();
    case 225:
      if (lookahead == 'p') ADVANCE(266);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 227:
      if (lookahead == 'r') ADVANCE(267);
      END_STATE();
    case 228:
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 229:
      if (lookahead == 'i') ADVANCE(269);
      END_STATE();
    case 230:
      if (lookahead == 't') ADVANCE(270);
      END_STATE();
    case 231:
      if (lookahead == 'c') ADVANCE(271);
      END_STATE();
    case 232:
      if (lookahead == 'c') ADVANCE(272);
      END_STATE();
    case 233:
      if (lookahead == 'n') ADVANCE(273);
      END_STATE();
    case 234:
      if (lookahead == 'r') ADVANCE(274);
      END_STATE();
    case 235:
      if (lookahead == 'n') ADVANCE(275);
      END_STATE();
    case 236:
      if (lookahead == 'c') ADVANCE(276);
      END_STATE();
    case 237:
      if (lookahead == 'g') ADVANCE(277);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 239:
      if (lookahead == 'h') ADVANCE(278);
      END_STATE();
    case 240:
      if (lookahead == 'l') ADVANCE(279);
      END_STATE();
    case 241:
      if (lookahead == 't') ADVANCE(280);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 243:
      if (lookahead == 'f') ADVANCE(281);
      END_STATE();
    case 244:
      if (lookahead == 'i') ADVANCE(282);
      END_STATE();
    case 245:
      if (lookahead == 'w') ADVANCE(283);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 248:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 249:
      if (lookahead == 's') ADVANCE(285);
      END_STATE();
    case 250:
      if (lookahead == 'n') ADVANCE(286);
      END_STATE();
    case 251:
      if (lookahead == 'u') ADVANCE(287);
      END_STATE();
    case 252:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 253:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 254:
      if (lookahead == 't') ADVANCE(290);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 257:
      if (lookahead == 's') ADVANCE(291);
      END_STATE();
    case 258:
      if (lookahead == 'y') ADVANCE(292);
      END_STATE();
    case 259:
      if (lookahead == 'o') ADVANCE(293);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 261:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 263:
      if (lookahead == 'c') ADVANCE(295);
      END_STATE();
    case 264:
      if (lookahead == 'a') ADVANCE(296);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 266:
      if (lookahead == 'a') ADVANCE(297);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 269:
      if (lookahead == 'd') ADVANCE(298);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(299);
      END_STATE();
    case 271:
      if (lookahead == 't') ADVANCE(300);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 273:
      if (lookahead == 'l') ADVANCE(301);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(302);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 282:
      if (lookahead == 'n') ADVANCE(303);
      END_STATE();
    case 283:
      if (lookahead == 'n') ADVANCE(304);
      END_STATE();
    case 284:
      if (lookahead == 't') ADVANCE(305);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 287:
      if (lookahead == 'e') ADVANCE(306);
      END_STATE();
    case 288:
      if (lookahead == 'r') ADVANCE(307);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 293:
      if (lookahead == 'n') ADVANCE(308);
      END_STATE();
    case 294:
      if (lookahead == 'n') ADVANCE(309);
      END_STATE();
    case 295:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 296:
      if (lookahead == 'c') ADVANCE(311);
      END_STATE();
    case 297:
      if (lookahead == 'c') ADVANCE(312);
      END_STATE();
    case 298:
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 300:
      if (lookahead == 'e') ADVANCE(314);
      END_STATE();
    case 301:
      if (lookahead == 'y') ADVANCE(315);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 303:
      if (lookahead == 'e') ADVANCE(316);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 309:
      if (lookahead == 't') ADVANCE(317);
      END_STATE();
    case 310:
      if (lookahead == 'o') ADVANCE(318);
      END_STATE();
    case 311:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 312:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 314:
      if (lookahead == 'd') ADVANCE(321);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 316:
      if (lookahead == 'd') ADVANCE(322);
      END_STATE();
    case 317:
      if (lookahead == 's') ADVANCE(323);
      END_STATE();
    case 318:
      if (lookahead == 'f') ADVANCE(324);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 71},
  [2] = {.lex_state = 2, .external_lex_state = 2},
  [3] = {.lex_state = 2, .external_lex_state = 2},
  [4] = {.lex_state = 71},
  [5] = {.lex_state = 71},
  [6] = {.lex_state = 71},
  [7] = {.lex_state = 71},
  [8] = {.lex_state = 71},
  [9] = {.lex_state = 71},
  [10] = {.lex_state = 71},
  [11] = {.lex_state = 71},
  [12] = {.lex_state = 71},
  [13] = {.lex_state = 71},
  [14] = {.lex_state = 71},
  [15] = {.lex_state = 71},
  [16] = {.lex_state = 71},
  [17] = {.lex_state = 71},
  [18] = {.lex_state = 71},
  [19] = {.lex_state = 71},
  [20] = {.lex_state = 71},
  [21] = {.lex_state = 71},
  [22] = {.lex_state = 71},
  [23] = {.lex_state = 71},
  [24] = {.lex_state = 71},
  [25] = {.lex_state = 71},
  [26] = {.lex_state = 71},
  [27] = {.lex_state = 71},
  [28] = {.lex_state = 71},
  [29] = {.lex_state = 71},
  [30] = {.lex_state = 71},
  [31] = {.lex_state = 71},
  [32] = {.lex_state = 71},
  [33] = {.lex_state = 71},
  [34] = {.lex_state = 71},
  [35] = {.lex_state = 71},
  [36] = {.lex_state = 71},
  [37] = {.lex_state = 71},
  [38] = {.lex_state = 71},
  [39] = {.lex_state = 71},
  [40] = {.lex_state = 71},
  [41] = {.lex_state = 71},
  [42] = {.lex_state = 71},
  [43] = {.lex_state = 71},
  [44] = {.lex_state = 71},
  [45] = {.lex_state = 71},
  [46] = {.lex_state = 71},
  [47] = {.lex_state = 71},
  [48] = {.lex_state = 3, .external_lex_state = 2},
  [49] = {.lex_state = 7},
  [50] = {.lex_state = 7},
  [51] = {.lex_state = 3, .external_lex_state = 2},
  [52] = {.lex_state = 7},
  [53] = {.lex_state = 7},
  [54] = {.lex_state = 3, .external_lex_state = 2},
  [55] = {.lex_state = 7},
  [56] = {.lex_state = 7},
  [57] = {.lex_state = 3, .external_lex_state = 2},
  [58] = {.lex_state = 7},
  [59] = {.lex_state = 3, .external_lex_state = 2},
  [60] = {.lex_state = 7},
  [61] = {.lex_state = 7},
  [62] = {.lex_state = 3, .external_lex_state = 2},
  [63] = {.lex_state = 3, .external_lex_state = 2},
  [64] = {.lex_state = 3, .external_lex_state = 2},
  [65] = {.lex_state = 7},
  [66] = {.lex_state = 7},
  [67] = {.lex_state = 7},
  [68] = {.lex_state = 7},
  [69] = {.lex_state = 7},
  [70] = {.lex_state = 7},
  [71] = {.lex_state = 7},
  [72] = {.lex_state = 7},
  [73] = {.lex_state = 7},
  [74] = {.lex_state = 7},
  [75] = {.lex_state = 7},
  [76] = {.lex_state = 7},
  [77] = {.lex_state = 7},
  [78] = {.lex_state = 7},
  [79] = {.lex_state = 7},
  [80] = {.lex_state = 7},
  [81] = {.lex_state = 7},
  [82] = {.lex_state = 7},
  [83] = {.lex_state = 7},
  [84] = {.lex_state = 7},
  [85] = {.lex_state = 7},
  [86] = {.lex_state = 70, .external_lex_state = 2},
  [87] = {.lex_state = 70, .external_lex_state = 3},
  [88] = {.lex_state = 70, .external_lex_state = 3},
  [89] = {.lex_state = 70, .external_lex_state = 3},
  [90] = {.lex_state = 70, .external_lex_state = 2},
  [91] = {.lex_state = 70, .external_lex_state = 2},
  [92] = {.lex_state = 70, .external_lex_state = 2},
  [93] = {.lex_state = 70, .external_lex_state = 2},
  [94] = {.lex_state = 71},
  [95] = {.lex_state = 2, .external_lex_state = 2},
  [96] = {.lex_state = 71},
  [97] = {.lex_state = 71},
  [98] = {.lex_state = 71},
  [99] = {.lex_state = 71},
  [100] = {.lex_state = 71},
  [101] = {.lex_state = 2, .external_lex_state = 3},
  [102] = {.lex_state = 2, .external_lex_state = 3},
  [103] = {.lex_state = 2, .external_lex_state = 2},
  [104] = {.lex_state = 2, .external_lex_state = 2},
  [105] = {.lex_state = 2, .external_lex_state = 2},
  [106] = {.lex_state = 2, .external_lex_state = 2},
  [107] = {.lex_state = 2, .external_lex_state = 2},
  [108] = {.lex_state = 2, .external_lex_state = 2},
  [109] = {.lex_state = 2, .external_lex_state = 3},
  [110] = {.lex_state = 2, .external_lex_state = 2},
  [111] = {.lex_state = 2, .external_lex_state = 2},
  [112] = {.lex_state = 2, .external_lex_state = 2},
  [113] = {.lex_state = 70, .external_lex_state = 3},
  [114] = {.lex_state = 70, .external_lex_state = 3},
  [115] = {.lex_state = 70, .external_lex_state = 3},
  [116] = {.lex_state = 70, .external_lex_state = 3},
  [117] = {.lex_state = 70, .external_lex_state = 3},
  [118] = {.lex_state = 70, .external_lex_state = 3},
  [119] = {.lex_state = 71},
  [120] = {.lex_state = 70, .external_lex_state = 3},
  [121] = {.lex_state = 70, .external_lex_state = 3},
  [122] = {.lex_state = 70, .external_lex_state = 3},
  [123] = {.lex_state = 71},
  [124] = {.lex_state = 70, .external_lex_state = 3},
  [125] = {.lex_state = 70, .external_lex_state = 3},
  [126] = {.lex_state = 70, .external_lex_state = 3},
  [127] = {.lex_state = 70, .external_lex_state = 3},
  [128] = {.lex_state = 70, .external_lex_state = 3},
  [129] = {.lex_state = 70, .external_lex_state = 3},
  [130] = {.lex_state = 70, .external_lex_state = 3},
  [131] = {.lex_state = 70, .external_lex_state = 3},
  [132] = {.lex_state = 70, .external_lex_state = 3},
  [133] = {.lex_state = 70, .external_lex_state = 3},
  [134] = {.lex_state = 70, .external_lex_state = 3},
  [135] = {.lex_state = 70, .external_lex_state = 3},
  [136] = {.lex_state = 70, .external_lex_state = 3},
  [137] = {.lex_state = 70, .external_lex_state = 3},
  [138] = {.lex_state = 70, .external_lex_state = 3},
  [139] = {.lex_state = 70, .external_lex_state = 3},
  [140] = {.lex_state = 70, .external_lex_state = 3},
  [141] = {.lex_state = 70, .external_lex_state = 3},
  [142] = {.lex_state = 71},
  [143] = {.lex_state = 71},
  [144] = {.lex_state = 71},
  [145] = {.lex_state = 71},
  [146] = {.lex_state = 71},
  [147] = {.lex_state = 71},
  [148] = {.lex_state = 71},
  [149] = {.lex_state = 71},
  [150] = {.lex_state = 71},
  [151] = {.lex_state = 71},
  [152] = {.lex_state = 71},
  [153] = {.lex_state = 71},
  [154] = {.lex_state = 71},
  [155] = {.lex_state = 71},
  [156] = {.lex_state = 71},
  [157] = {.lex_state = 71},
  [158] = {.lex_state = 71},
  [159] = {.lex_state = 71},
  [160] = {.lex_state = 71},
  [161] = {.lex_state = 71},
  [162] = {.lex_state = 71},
  [163] = {.lex_state = 71},
  [164] = {.lex_state = 71, .external_lex_state = 4},
  [165] = {.lex_state = 71},
  [166] = {.lex_state = 3, .external_lex_state = 2},
  [167] = {.lex_state = 71},
  [168] = {.lex_state = 71},
  [169] = {.lex_state = 71},
  [170] = {.lex_state = 71},
  [171] = {.lex_state = 71},
  [172] = {.lex_state = 3, .external_lex_state = 2},
  [173] = {.lex_state = 3, .external_lex_state = 2},
  [174] = {.lex_state = 71},
  [175] = {.lex_state = 3, .external_lex_state = 2},
  [176] = {.lex_state = 71},
  [177] = {.lex_state = 3, .external_lex_state = 3},
  [178] = {.lex_state = 71},
  [179] = {.lex_state = 71},
  [180] = {.lex_state = 71},
  [181] = {.lex_state = 71},
  [182] = {.lex_state = 71},
  [183] = {.lex_state = 71},
  [184] = {.lex_state = 3, .external_lex_state = 3},
  [185] = {.lex_state = 71},
  [186] = {.lex_state = 71},
  [187] = {.lex_state = 71},
  [188] = {.lex_state = 71},
  [189] = {.lex_state = 71},
  [190] = {.lex_state = 3, .external_lex_state = 3},
  [191] = {.lex_state = 71},
  [192] = {.lex_state = 71},
  [193] = {.lex_state = 71},
  [194] = {.lex_state = 71},
  [195] = {.lex_state = 71},
  [196] = {.lex_state = 71},
  [197] = {.lex_state = 71},
  [198] = {.lex_state = 71},
  [199] = {.lex_state = 71},
  [200] = {.lex_state = 71},
  [201] = {.lex_state = 71},
  [202] = {.lex_state = 71},
  [203] = {.lex_state = 71},
  [204] = {.lex_state = 71},
  [205] = {.lex_state = 71},
  [206] = {.lex_state = 71},
  [207] = {.lex_state = 71},
  [208] = {.lex_state = 71},
  [209] = {.lex_state = 71},
  [210] = {.lex_state = 71},
  [211] = {.lex_state = 71},
  [212] = {.lex_state = 71, .external_lex_state = 4},
  [213] = {.lex_state = 71},
  [214] = {.lex_state = 71},
  [215] = {.lex_state = 71},
  [216] = {.lex_state = 71},
  [217] = {.lex_state = 71},
  [218] = {.lex_state = 71},
  [219] = {.lex_state = 71},
  [220] = {.lex_state = 2, .external_lex_state = 3},
  [221] = {.lex_state = 71},
  [222] = {.lex_state = 71},
  [223] = {.lex_state = 2, .external_lex_state = 3},
  [224] = {.lex_state = 2, .external_lex_state = 3},
  [225] = {.lex_state = 71},
  [226] = {.lex_state = 71},
  [227] = {.lex_state = 71},
  [228] = {.lex_state = 71},
  [229] = {.lex_state = 71},
  [230] = {.lex_state = 71},
  [231] = {.lex_state = 71},
  [232] = {.lex_state = 71},
  [233] = {.lex_state = 71},
  [234] = {.lex_state = 71},
  [235] = {.lex_state = 71},
  [236] = {.lex_state = 71},
  [237] = {.lex_state = 71},
  [238] = {.lex_state = 71},
  [239] = {.lex_state = 71},
  [240] = {.lex_state = 71},
  [241] = {.lex_state = 71},
  [242] = {.lex_state = 71},
  [243] = {.lex_state = 71},
  [244] = {.lex_state = 71},
  [245] = {.lex_state = 71},
  [246] = {.lex_state = 71},
  [247] = {.lex_state = 3, .external_lex_state = 3},
  [248] = {.lex_state = 71},
  [249] = {.lex_state = 71},
  [250] = {.lex_state = 71},
  [251] = {.lex_state = 71},
  [252] = {.lex_state = 71},
  [253] = {.lex_state = 71},
  [254] = {.lex_state = 71},
  [255] = {.lex_state = 71},
  [256] = {.lex_state = 71},
  [257] = {.lex_state = 71},
  [258] = {.lex_state = 71},
  [259] = {.lex_state = 71},
  [260] = {.lex_state = 71},
  [261] = {.lex_state = 71},
  [262] = {.lex_state = 71},
  [263] = {.lex_state = 71},
  [264] = {.lex_state = 71},
  [265] = {.lex_state = 71},
  [266] = {.lex_state = 71},
  [267] = {.lex_state = 71},
  [268] = {.lex_state = 71},
  [269] = {.lex_state = 71},
  [270] = {.lex_state = 71},
  [271] = {.lex_state = 71},
  [272] = {.lex_state = 71},
  [273] = {.lex_state = 71},
  [274] = {.lex_state = 71},
  [275] = {.lex_state = 71},
  [276] = {.lex_state = 71},
  [277] = {.lex_state = 71},
  [278] = {.lex_state = 71},
  [279] = {.lex_state = 71},
  [280] = {.lex_state = 71},
  [281] = {.lex_state = 71},
  [282] = {.lex_state = 71},
  [283] = {.lex_state = 71},
  [284] = {.lex_state = 71},
  [285] = {.lex_state = 71},
  [286] = {.lex_state = 71},
  [287] = {.lex_state = 71},
  [288] = {.lex_state = 71},
  [289] = {.lex_state = 71},
  [290] = {.lex_state = 71},
  [291] = {.lex_state = 71},
  [292] = {.lex_state = 71},
  [293] = {.lex_state = 71},
  [294] = {.lex_state = 71},
  [295] = {.lex_state = 71},
  [296] = {.lex_state = 71},
  [297] = {.lex_state = 71},
  [298] = {.lex_state = 71},
  [299] = {.lex_state = 71},
  [300] = {.lex_state = 71},
  [301] = {.lex_state = 71},
  [302] = {.lex_state = 71},
  [303] = {.lex_state = 71},
  [304] = {.lex_state = 71},
  [305] = {.lex_state = 71},
  [306] = {.lex_state = 71},
  [307] = {.lex_state = 71},
  [308] = {.lex_state = 71},
  [309] = {.lex_state = 71},
  [310] = {.lex_state = 71},
  [311] = {.lex_state = 3, .external_lex_state = 3},
  [312] = {.lex_state = 71},
  [313] = {.lex_state = 71},
  [314] = {.lex_state = 71},
  [315] = {.lex_state = 71},
  [316] = {.lex_state = 71},
  [317] = {.lex_state = 71},
  [318] = {.lex_state = 71},
  [319] = {.lex_state = 71},
  [320] = {.lex_state = 71},
  [321] = {.lex_state = 71},
  [322] = {.lex_state = 71},
  [323] = {.lex_state = 71},
  [324] = {.lex_state = 71},
  [325] = {.lex_state = 71},
  [326] = {.lex_state = 71},
  [327] = {.lex_state = 71},
  [328] = {.lex_state = 71},
  [329] = {.lex_state = 71},
  [330] = {.lex_state = 71},
  [331] = {.lex_state = 71},
  [332] = {.lex_state = 71},
  [333] = {.lex_state = 71},
  [334] = {.lex_state = 71},
  [335] = {.lex_state = 71},
  [336] = {.lex_state = 71},
  [337] = {.lex_state = 71},
  [338] = {.lex_state = 71},
  [339] = {.lex_state = 71},
  [340] = {.lex_state = 71},
  [341] = {.lex_state = 71},
  [342] = {.lex_state = 71},
  [343] = {.lex_state = 71},
  [344] = {.lex_state = 71},
  [345] = {.lex_state = 71},
  [346] = {.lex_state = 71},
  [347] = {.lex_state = 71},
  [348] = {.lex_state = 71},
  [349] = {.lex_state = 71},
  [350] = {.lex_state = 71},
  [351] = {.lex_state = 71},
  [352] = {.lex_state = 71},
  [353] = {.lex_state = 71},
  [354] = {.lex_state = 71},
  [355] = {.lex_state = 71},
  [356] = {.lex_state = 71},
  [357] = {.lex_state = 71},
  [358] = {.lex_state = 71},
  [359] = {.lex_state = 71},
  [360] = {.lex_state = 71},
  [361] = {.lex_state = 71},
  [362] = {.lex_state = 71},
  [363] = {.lex_state = 71},
  [364] = {.lex_state = 71},
  [365] = {.lex_state = 71},
  [366] = {.lex_state = 71},
  [367] = {.lex_state = 71},
  [368] = {.lex_state = 71},
  [369] = {.lex_state = 71},
  [370] = {.lex_state = 71},
  [371] = {.lex_state = 71},
  [372] = {.lex_state = 71},
  [373] = {.lex_state = 71},
  [374] = {.lex_state = 71},
  [375] = {.lex_state = 71},
  [376] = {.lex_state = 71},
  [377] = {.lex_state = 71},
  [378] = {.lex_state = 71},
  [379] = {.lex_state = 71},
  [380] = {.lex_state = 71},
  [381] = {.lex_state = 71},
  [382] = {.lex_state = 71},
  [383] = {.lex_state = 71},
  [384] = {.lex_state = 71},
  [385] = {.lex_state = 71},
  [386] = {.lex_state = 71},
  [387] = {.lex_state = 71},
  [388] = {.lex_state = 71},
  [389] = {.lex_state = 71},
  [390] = {.lex_state = 71},
  [391] = {.lex_state = 71},
  [392] = {.lex_state = 71},
  [393] = {.lex_state = 2, .external_lex_state = 3},
  [394] = {.lex_state = 71},
  [395] = {.lex_state = 71},
  [396] = {.lex_state = 71},
  [397] = {.lex_state = 71},
  [398] = {.lex_state = 71},
  [399] = {.lex_state = 71},
  [400] = {.lex_state = 71},
  [401] = {.lex_state = 71},
  [402] = {.lex_state = 71},
  [403] = {.lex_state = 71},
  [404] = {.lex_state = 71},
  [405] = {.lex_state = 71},
  [406] = {.lex_state = 71},
  [407] = {.lex_state = 71},
  [408] = {.lex_state = 71},
  [409] = {.lex_state = 71},
  [410] = {.lex_state = 71},
  [411] = {.lex_state = 71},
  [412] = {.lex_state = 71},
  [413] = {.lex_state = 71},
  [414] = {.lex_state = 71},
  [415] = {.lex_state = 71},
  [416] = {.lex_state = 71},
  [417] = {.lex_state = 71},
  [418] = {.lex_state = 71},
  [419] = {.lex_state = 71},
  [420] = {.lex_state = 71},
  [421] = {.lex_state = 71},
  [422] = {.lex_state = 71},
  [423] = {.lex_state = 71},
  [424] = {.lex_state = 71},
  [425] = {.lex_state = 71},
  [426] = {.lex_state = 71},
  [427] = {.lex_state = 71},
  [428] = {.lex_state = 71},
  [429] = {.lex_state = 71},
  [430] = {.lex_state = 71},
  [431] = {.lex_state = 71},
  [432] = {.lex_state = 71},
  [433] = {.lex_state = 2, .external_lex_state = 3},
  [434] = {.lex_state = 71},
  [435] = {.lex_state = 71},
  [436] = {.lex_state = 71},
  [437] = {.lex_state = 71},
  [438] = {.lex_state = 71},
  [439] = {.lex_state = 71},
  [440] = {.lex_state = 71},
  [441] = {.lex_state = 71},
  [442] = {.lex_state = 71},
  [443] = {.lex_state = 71},
  [444] = {.lex_state = 71},
  [445] = {.lex_state = 71},
  [446] = {.lex_state = 71},
  [447] = {.lex_state = 71},
  [448] = {.lex_state = 71},
  [449] = {.lex_state = 71},
  [450] = {.lex_state = 71},
  [451] = {.lex_state = 71},
  [452] = {.lex_state = 71},
  [453] = {.lex_state = 71},
  [454] = {.lex_state = 71},
  [455] = {.lex_state = 71},
  [456] = {.lex_state = 71},
  [457] = {.lex_state = 71},
  [458] = {.lex_state = 71},
  [459] = {.lex_state = 71},
  [460] = {.lex_state = 71},
  [461] = {.lex_state = 71},
  [462] = {.lex_state = 71},
  [463] = {.lex_state = 71},
  [464] = {.lex_state = 71},
  [465] = {.lex_state = 71},
  [466] = {.lex_state = 71},
  [467] = {.lex_state = 71},
  [468] = {.lex_state = 71},
  [469] = {.lex_state = 71},
  [470] = {.lex_state = 71},
  [471] = {.lex_state = 71},
  [472] = {.lex_state = 71},
  [473] = {.lex_state = 71},
  [474] = {.lex_state = 71},
  [475] = {.lex_state = 71},
  [476] = {.lex_state = 71},
  [477] = {.lex_state = 71},
  [478] = {.lex_state = 71},
  [479] = {.lex_state = 71},
  [480] = {.lex_state = 71},
  [481] = {.lex_state = 71},
  [482] = {.lex_state = 71},
  [483] = {.lex_state = 71},
  [484] = {.lex_state = 71},
  [485] = {.lex_state = 71},
  [486] = {.lex_state = 71},
  [487] = {.lex_state = 71},
  [488] = {.lex_state = 71},
  [489] = {.lex_state = 71},
  [490] = {.lex_state = 71},
  [491] = {.lex_state = 71},
  [492] = {.lex_state = 71},
  [493] = {.lex_state = 71},
  [494] = {.lex_state = 71},
  [495] = {.lex_state = 71},
  [496] = {.lex_state = 71},
  [497] = {.lex_state = 71},
  [498] = {.lex_state = 71},
  [499] = {.lex_state = 71},
  [500] = {.lex_state = 71},
  [501] = {.lex_state = 71},
  [502] = {.lex_state = 71},
  [503] = {.lex_state = 71},
  [504] = {.lex_state = 71},
  [505] = {.lex_state = 71},
  [506] = {.lex_state = 71},
  [507] = {.lex_state = 71},
  [508] = {.lex_state = 71},
  [509] = {.lex_state = 71},
  [510] = {.lex_state = 71},
  [511] = {.lex_state = 71},
  [512] = {.lex_state = 71},
  [513] = {.lex_state = 71},
  [514] = {.lex_state = 71},
  [515] = {.lex_state = 71},
  [516] = {.lex_state = 2, .external_lex_state = 3},
  [517] = {.lex_state = 71},
  [518] = {.lex_state = 71},
  [519] = {.lex_state = 71},
  [520] = {.lex_state = 71},
  [521] = {.lex_state = 71},
  [522] = {.lex_state = 71},
  [523] = {.lex_state = 71},
  [524] = {.lex_state = 71},
  [525] = {.lex_state = 71},
  [526] = {.lex_state = 2, .external_lex_state = 3},
  [527] = {.lex_state = 2, .external_lex_state = 3},
  [528] = {.lex_state = 2, .external_lex_state = 3},
  [529] = {.lex_state = 2, .external_lex_state = 3},
  [530] = {.lex_state = 2, .external_lex_state = 3},
  [531] = {.lex_state = 2, .external_lex_state = 3},
  [532] = {.lex_state = 2, .external_lex_state = 3},
  [533] = {.lex_state = 2, .external_lex_state = 3},
  [534] = {.lex_state = 2, .external_lex_state = 3},
  [535] = {.lex_state = 2, .external_lex_state = 3},
  [536] = {.lex_state = 2, .external_lex_state = 3},
  [537] = {.lex_state = 2, .external_lex_state = 3},
  [538] = {.lex_state = 2, .external_lex_state = 3},
  [539] = {.lex_state = 71},
  [540] = {.lex_state = 71},
  [541] = {.lex_state = 71},
  [542] = {.lex_state = 71},
  [543] = {.lex_state = 71},
  [544] = {.lex_state = 71},
  [545] = {.lex_state = 71},
  [546] = {.lex_state = 2, .external_lex_state = 3},
  [547] = {.lex_state = 2, .external_lex_state = 3},
  [548] = {.lex_state = 2, .external_lex_state = 3},
  [549] = {.lex_state = 2, .external_lex_state = 3},
  [550] = {.lex_state = 2, .external_lex_state = 3},
  [551] = {.lex_state = 2, .external_lex_state = 3},
  [552] = {.lex_state = 2, .external_lex_state = 2},
  [553] = {.lex_state = 2, .external_lex_state = 2},
  [554] = {.lex_state = 2, .external_lex_state = 2},
  [555] = {.lex_state = 2, .external_lex_state = 2},
  [556] = {.lex_state = 2, .external_lex_state = 2},
  [557] = {.lex_state = 2, .external_lex_state = 3},
  [558] = {.lex_state = 2, .external_lex_state = 3},
  [559] = {.lex_state = 2, .external_lex_state = 3},
  [560] = {.lex_state = 2, .external_lex_state = 3},
  [561] = {.lex_state = 2, .external_lex_state = 3},
  [562] = {.lex_state = 2, .external_lex_state = 3},
  [563] = {.lex_state = 2, .external_lex_state = 2},
  [564] = {.lex_state = 2, .external_lex_state = 3},
  [565] = {.lex_state = 3, .external_lex_state = 2},
  [566] = {.lex_state = 71, .external_lex_state = 4},
  [567] = {.lex_state = 71, .external_lex_state = 4},
  [568] = {.lex_state = 2, .external_lex_state = 2},
  [569] = {.lex_state = 71},
  [570] = {.lex_state = 3, .external_lex_state = 2},
  [571] = {.lex_state = 71, .external_lex_state = 4},
  [572] = {.lex_state = 2, .external_lex_state = 3},
  [573] = {.lex_state = 2, .external_lex_state = 3},
  [574] = {.lex_state = 2, .external_lex_state = 3},
  [575] = {.lex_state = 2, .external_lex_state = 3},
  [576] = {.lex_state = 71, .external_lex_state = 4},
  [577] = {.lex_state = 71, .external_lex_state = 4},
  [578] = {.lex_state = 71},
  [579] = {.lex_state = 2, .external_lex_state = 2},
  [580] = {.lex_state = 71},
  [581] = {.lex_state = 71, .external_lex_state = 4},
  [582] = {.lex_state = 71, .external_lex_state = 4},
  [583] = {.lex_state = 2, .external_lex_state = 2},
  [584] = {.lex_state = 2, .external_lex_state = 2},
  [585] = {.lex_state = 2, .external_lex_state = 2},
  [586] = {.lex_state = 2, .external_lex_state = 2},
  [587] = {.lex_state = 71, .external_lex_state = 4},
  [588] = {.lex_state = 2, .external_lex_state = 3},
  [589] = {.lex_state = 2, .external_lex_state = 2},
  [590] = {.lex_state = 2, .external_lex_state = 2},
  [591] = {.lex_state = 71},
  [592] = {.lex_state = 2, .external_lex_state = 2},
  [593] = {.lex_state = 2, .external_lex_state = 2},
  [594] = {.lex_state = 71},
  [595] = {.lex_state = 71, .external_lex_state = 4},
  [596] = {.lex_state = 71},
  [597] = {.lex_state = 71, .external_lex_state = 4},
  [598] = {.lex_state = 71, .external_lex_state = 4},
  [599] = {.lex_state = 71, .external_lex_state = 4},
  [600] = {.lex_state = 71, .external_lex_state = 4},
  [601] = {.lex_state = 71},
  [602] = {.lex_state = 71},
  [603] = {.lex_state = 71},
  [604] = {.lex_state = 71},
  [605] = {.lex_state = 71, .external_lex_state = 4},
  [606] = {.lex_state = 71, .external_lex_state = 4},
  [607] = {.lex_state = 71},
  [608] = {.lex_state = 71, .external_lex_state = 4},
  [609] = {.lex_state = 71},
  [610] = {.lex_state = 71, .external_lex_state = 4},
  [611] = {.lex_state = 71, .external_lex_state = 4},
  [612] = {.lex_state = 2, .external_lex_state = 2},
  [613] = {.lex_state = 71, .external_lex_state = 4},
  [614] = {.lex_state = 71},
  [615] = {.lex_state = 71, .external_lex_state = 4},
  [616] = {.lex_state = 71},
  [617] = {.lex_state = 71},
  [618] = {.lex_state = 71},
  [619] = {.lex_state = 71},
  [620] = {.lex_state = 71},
  [621] = {.lex_state = 71},
  [622] = {.lex_state = 71},
  [623] = {.lex_state = 71},
  [624] = {.lex_state = 71},
  [625] = {.lex_state = 71},
  [626] = {.lex_state = 71},
  [627] = {.lex_state = 71},
  [628] = {.lex_state = 71},
  [629] = {.lex_state = 71},
  [630] = {.lex_state = 71},
  [631] = {.lex_state = 71},
  [632] = {.lex_state = 71},
  [633] = {.lex_state = 71},
  [634] = {.lex_state = 71},
  [635] = {.lex_state = 71},
  [636] = {.lex_state = 71},
  [637] = {.lex_state = 71},
  [638] = {.lex_state = 71},
  [639] = {.lex_state = 71},
  [640] = {.lex_state = 71},
  [641] = {.lex_state = 71},
  [642] = {.lex_state = 71},
  [643] = {.lex_state = 71},
  [644] = {.lex_state = 71},
  [645] = {.lex_state = 71},
  [646] = {.lex_state = 71},
  [647] = {.lex_state = 71},
  [648] = {.lex_state = 71},
  [649] = {.lex_state = 71},
  [650] = {.lex_state = 71},
  [651] = {.lex_state = 71},
  [652] = {.lex_state = 71},
  [653] = {.lex_state = 71},
  [654] = {.lex_state = 71},
  [655] = {.lex_state = 71},
  [656] = {.lex_state = 71},
  [657] = {.lex_state = 71},
  [658] = {.lex_state = 71},
  [659] = {.lex_state = 71},
  [660] = {.lex_state = 71},
  [661] = {.lex_state = 71},
  [662] = {.lex_state = 71},
  [663] = {.lex_state = 71},
  [664] = {.lex_state = 71},
  [665] = {.lex_state = 71},
  [666] = {.lex_state = 71},
  [667] = {.lex_state = 71},
  [668] = {.lex_state = 71},
  [669] = {.lex_state = 71},
  [670] = {.lex_state = 71},
  [671] = {.lex_state = 71},
  [672] = {.lex_state = 71},
  [673] = {.lex_state = 71},
  [674] = {.lex_state = 71},
  [675] = {.lex_state = 71},
  [676] = {.lex_state = 71},
  [677] = {.lex_state = 71},
  [678] = {.lex_state = 71},
  [679] = {.lex_state = 71},
  [680] = {.lex_state = 71},
  [681] = {.lex_state = 71},
  [682] = {.lex_state = 71},
  [683] = {.lex_state = 71},
  [684] = {.lex_state = 71},
  [685] = {.lex_state = 71},
  [686] = {.lex_state = 71},
  [687] = {.lex_state = 71},
  [688] = {.lex_state = 71},
  [689] = {.lex_state = 71},
  [690] = {.lex_state = 71},
  [691] = {.lex_state = 71},
  [692] = {.lex_state = 71},
  [693] = {.lex_state = 71},
  [694] = {.lex_state = 71},
  [695] = {.lex_state = 71},
  [696] = {.lex_state = 71},
  [697] = {.lex_state = 71},
  [698] = {.lex_state = 71},
  [699] = {.lex_state = 71},
  [700] = {.lex_state = 71},
  [701] = {.lex_state = 71},
  [702] = {.lex_state = 71},
  [703] = {.lex_state = 71},
  [704] = {.lex_state = 71},
  [705] = {.lex_state = 71},
  [706] = {.lex_state = 71},
  [707] = {.lex_state = 71},
  [708] = {.lex_state = 71},
  [709] = {.lex_state = 71},
  [710] = {.lex_state = 71},
  [711] = {.lex_state = 71},
  [712] = {.lex_state = 71},
  [713] = {.lex_state = 71},
  [714] = {.lex_state = 71},
  [715] = {.lex_state = 71},
  [716] = {.lex_state = 71},
  [717] = {.lex_state = 71},
  [718] = {.lex_state = 71},
  [719] = {.lex_state = 71},
  [720] = {.lex_state = 71},
  [721] = {.lex_state = 71},
  [722] = {.lex_state = 71},
  [723] = {.lex_state = 71},
  [724] = {.lex_state = 71},
  [725] = {.lex_state = 71},
  [726] = {.lex_state = 71},
  [727] = {.lex_state = 71},
  [728] = {.lex_state = 71},
  [729] = {.lex_state = 71},
  [730] = {.lex_state = 71},
  [731] = {.lex_state = 71},
  [732] = {.lex_state = 71},
  [733] = {.lex_state = 71},
  [734] = {.lex_state = 71},
  [735] = {.lex_state = 71},
  [736] = {.lex_state = 71},
  [737] = {.lex_state = 71},
  [738] = {.lex_state = 71},
  [739] = {.lex_state = 71},
  [740] = {.lex_state = 71},
  [741] = {.lex_state = 71},
  [742] = {.lex_state = 71},
  [743] = {.lex_state = 71},
  [744] = {.lex_state = 71},
  [745] = {.lex_state = 71},
  [746] = {.lex_state = 71},
  [747] = {.lex_state = 71},
  [748] = {.lex_state = 71},
  [749] = {.lex_state = 71},
  [750] = {.lex_state = 71},
  [751] = {.lex_state = 71},
  [752] = {.lex_state = 71},
  [753] = {.lex_state = 71},
  [754] = {.lex_state = 71},
  [755] = {.lex_state = 71},
  [756] = {.lex_state = 71},
  [757] = {.lex_state = 71},
  [758] = {.lex_state = 71},
  [759] = {.lex_state = 71},
  [760] = {.lex_state = 71},
  [761] = {.lex_state = 71},
  [762] = {.lex_state = 71},
  [763] = {.lex_state = 71},
  [764] = {.lex_state = 71},
  [765] = {.lex_state = 71},
  [766] = {.lex_state = 9},
  [767] = {.lex_state = 9},
  [768] = {.lex_state = 9},
  [769] = {.lex_state = 9},
  [770] = {.lex_state = 9},
  [771] = {.lex_state = 9},
  [772] = {.lex_state = 9},
  [773] = {.lex_state = 9},
  [774] = {.lex_state = 9},
  [775] = {.lex_state = 9},
  [776] = {.lex_state = 9},
  [777] = {.lex_state = 9},
  [778] = {.lex_state = 9},
  [779] = {.lex_state = 9},
  [780] = {.lex_state = 9},
  [781] = {.lex_state = 71},
  [782] = {.lex_state = 71},
  [783] = {.lex_state = 9},
  [784] = {.lex_state = 71},
  [785] = {.lex_state = 71},
  [786] = {.lex_state = 71},
  [787] = {.lex_state = 71},
  [788] = {.lex_state = 71},
  [789] = {.lex_state = 71},
  [790] = {.lex_state = 71},
  [791] = {.lex_state = 71},
  [792] = {.lex_state = 71},
  [793] = {.lex_state = 71},
  [794] = {.lex_state = 71},
  [795] = {.lex_state = 8},
  [796] = {.lex_state = 8},
  [797] = {.lex_state = 8},
  [798] = {.lex_state = 2, .external_lex_state = 3},
  [799] = {.lex_state = 2, .external_lex_state = 3},
  [800] = {.lex_state = 2, .external_lex_state = 3},
  [801] = {.lex_state = 2, .external_lex_state = 3},
  [802] = {.lex_state = 2, .external_lex_state = 3},
  [803] = {.lex_state = 2, .external_lex_state = 3},
  [804] = {.lex_state = 9},
  [805] = {.lex_state = 9},
  [806] = {.lex_state = 9},
  [807] = {.lex_state = 71},
  [808] = {.lex_state = 11},
  [809] = {.lex_state = 9},
  [810] = {.lex_state = 11},
  [811] = {.lex_state = 9},
  [812] = {.lex_state = 11},
  [813] = {.lex_state = 9},
  [814] = {.lex_state = 9},
  [815] = {.lex_state = 9},
  [816] = {.lex_state = 9},
  [817] = {.lex_state = 9},
  [818] = {.lex_state = 9},
  [819] = {.lex_state = 11},
  [820] = {.lex_state = 9},
  [821] = {.lex_state = 9},
  [822] = {.lex_state = 9},
  [823] = {.lex_state = 9},
  [824] = {.lex_state = 9},
  [825] = {.lex_state = 11},
  [826] = {.lex_state = 9},
  [827] = {.lex_state = 9},
  [828] = {.lex_state = 9},
  [829] = {.lex_state = 9},
  [830] = {.lex_state = 9},
  [831] = {.lex_state = 9},
  [832] = {.lex_state = 9},
  [833] = {.lex_state = 11},
  [834] = {.lex_state = 71},
  [835] = {.lex_state = 2, .external_lex_state = 2},
  [836] = {.lex_state = 9},
  [837] = {.lex_state = 11},
  [838] = {.lex_state = 9},
  [839] = {.lex_state = 9},
  [840] = {.lex_state = 11},
  [841] = {.lex_state = 71},
  [842] = {.lex_state = 9},
  [843] = {.lex_state = 2, .external_lex_state = 2},
  [844] = {.lex_state = 9},
  [845] = {.lex_state = 9},
  [846] = {.lex_state = 9},
  [847] = {.lex_state = 2, .external_lex_state = 2},
  [848] = {.lex_state = 11},
  [849] = {.lex_state = 9},
  [850] = {.lex_state = 11},
  [851] = {.lex_state = 11},
  [852] = {.lex_state = 11},
  [853] = {.lex_state = 9},
  [854] = {.lex_state = 9},
  [855] = {.lex_state = 9},
  [856] = {.lex_state = 9},
  [857] = {.lex_state = 9},
  [858] = {.lex_state = 9},
  [859] = {.lex_state = 9},
  [860] = {.lex_state = 9},
  [861] = {.lex_state = 9},
  [862] = {.lex_state = 9},
  [863] = {.lex_state = 9},
  [864] = {.lex_state = 9},
  [865] = {.lex_state = 9},
  [866] = {.lex_state = 9},
  [867] = {.lex_state = 9},
  [868] = {.lex_state = 9},
  [869] = {.lex_state = 9},
  [870] = {.lex_state = 9},
  [871] = {.lex_state = 9},
  [872] = {.lex_state = 9},
  [873] = {.lex_state = 9},
  [874] = {.lex_state = 9},
  [875] = {.lex_state = 9},
  [876] = {.lex_state = 9},
  [877] = {.lex_state = 9},
  [878] = {.lex_state = 9},
  [879] = {.lex_state = 9},
  [880] = {.lex_state = 9},
  [881] = {.lex_state = 9},
  [882] = {.lex_state = 9},
  [883] = {.lex_state = 9},
  [884] = {.lex_state = 9},
  [885] = {.lex_state = 9},
  [886] = {.lex_state = 9},
  [887] = {.lex_state = 9},
  [888] = {.lex_state = 9},
  [889] = {.lex_state = 9},
  [890] = {.lex_state = 9},
  [891] = {.lex_state = 9},
  [892] = {.lex_state = 9},
  [893] = {.lex_state = 9},
  [894] = {.lex_state = 9},
  [895] = {.lex_state = 9},
  [896] = {.lex_state = 9},
  [897] = {.lex_state = 9},
  [898] = {.lex_state = 9},
  [899] = {.lex_state = 9},
  [900] = {.lex_state = 9},
  [901] = {.lex_state = 9},
  [902] = {.lex_state = 9},
  [903] = {.lex_state = 9},
  [904] = {.lex_state = 9},
  [905] = {.lex_state = 9},
  [906] = {.lex_state = 2, .external_lex_state = 2},
  [907] = {.lex_state = 9},
  [908] = {.lex_state = 9},
  [909] = {.lex_state = 9},
  [910] = {.lex_state = 9},
  [911] = {.lex_state = 9},
  [912] = {.lex_state = 9},
  [913] = {.lex_state = 9},
  [914] = {.lex_state = 9},
  [915] = {.lex_state = 9},
  [916] = {.lex_state = 9},
  [917] = {.lex_state = 9},
  [918] = {.lex_state = 9},
  [919] = {.lex_state = 9},
  [920] = {.lex_state = 9},
  [921] = {.lex_state = 9},
  [922] = {.lex_state = 9},
  [923] = {.lex_state = 9},
  [924] = {.lex_state = 9},
  [925] = {.lex_state = 9},
  [926] = {.lex_state = 9},
  [927] = {.lex_state = 9},
  [928] = {.lex_state = 9},
  [929] = {.lex_state = 9},
  [930] = {.lex_state = 9},
  [931] = {.lex_state = 9},
  [932] = {.lex_state = 9},
  [933] = {.lex_state = 2, .external_lex_state = 2},
  [934] = {.lex_state = 9},
  [935] = {.lex_state = 9},
  [936] = {.lex_state = 9},
  [937] = {.lex_state = 9},
  [938] = {.lex_state = 9},
  [939] = {.lex_state = 9},
  [940] = {.lex_state = 9},
  [941] = {.lex_state = 9},
  [942] = {.lex_state = 9},
  [943] = {.lex_state = 9},
  [944] = {.lex_state = 9},
  [945] = {.lex_state = 9},
  [946] = {.lex_state = 9},
  [947] = {.lex_state = 9},
  [948] = {.lex_state = 9},
  [949] = {.lex_state = 9},
  [950] = {.lex_state = 9},
  [951] = {.lex_state = 9},
  [952] = {.lex_state = 9},
  [953] = {.lex_state = 9},
  [954] = {.lex_state = 9},
  [955] = {.lex_state = 9},
  [956] = {.lex_state = 9},
  [957] = {.lex_state = 9},
  [958] = {.lex_state = 9},
  [959] = {.lex_state = 9},
  [960] = {.lex_state = 9},
  [961] = {.lex_state = 9},
  [962] = {.lex_state = 9},
  [963] = {.lex_state = 9},
  [964] = {.lex_state = 9},
  [965] = {.lex_state = 9},
  [966] = {.lex_state = 2, .external_lex_state = 3},
  [967] = {.lex_state = 2, .external_lex_state = 3},
  [968] = {.lex_state = 2, .external_lex_state = 3},
  [969] = {.lex_state = 2, .external_lex_state = 2},
  [970] = {.lex_state = 2, .external_lex_state = 3},
  [971] = {.lex_state = 2, .external_lex_state = 3},
  [972] = {.lex_state = 2, .external_lex_state = 3},
  [973] = {.lex_state = 2, .external_lex_state = 3},
  [974] = {.lex_state = 2, .external_lex_state = 3},
  [975] = {.lex_state = 2, .external_lex_state = 3},
  [976] = {.lex_state = 2, .external_lex_state = 3},
  [977] = {.lex_state = 2, .external_lex_state = 3},
  [978] = {.lex_state = 2, .external_lex_state = 2},
  [979] = {.lex_state = 3, .external_lex_state = 2},
  [980] = {.lex_state = 2, .external_lex_state = 3},
  [981] = {.lex_state = 3, .external_lex_state = 2},
  [982] = {.lex_state = 2, .external_lex_state = 3},
  [983] = {.lex_state = 11},
  [984] = {.lex_state = 11},
  [985] = {.lex_state = 2, .external_lex_state = 2},
  [986] = {.lex_state = 3, .external_lex_state = 2},
  [987] = {.lex_state = 3, .external_lex_state = 2},
  [988] = {.lex_state = 2, .external_lex_state = 2},
  [989] = {.lex_state = 2, .external_lex_state = 3},
  [990] = {.lex_state = 3, .external_lex_state = 2},
  [991] = {.lex_state = 2, .external_lex_state = 2},
  [992] = {.lex_state = 2, .external_lex_state = 3},
  [993] = {.lex_state = 2, .external_lex_state = 3},
  [994] = {.lex_state = 2, .external_lex_state = 2},
  [995] = {.lex_state = 2, .external_lex_state = 3},
  [996] = {.lex_state = 2, .external_lex_state = 3},
  [997] = {.lex_state = 2, .external_lex_state = 3},
  [998] = {.lex_state = 2, .external_lex_state = 3},
  [999] = {.lex_state = 2, .external_lex_state = 3},
  [1000] = {.lex_state = 2, .external_lex_state = 2},
  [1001] = {.lex_state = 3, .external_lex_state = 2},
  [1002] = {.lex_state = 3, .external_lex_state = 2},
  [1003] = {.lex_state = 2, .external_lex_state = 3},
  [1004] = {.lex_state = 2, .external_lex_state = 3},
  [1005] = {.lex_state = 2, .external_lex_state = 2},
  [1006] = {.lex_state = 2, .external_lex_state = 2},
  [1007] = {.lex_state = 2, .external_lex_state = 2},
  [1008] = {.lex_state = 2, .external_lex_state = 2},
  [1009] = {.lex_state = 2, .external_lex_state = 2},
  [1010] = {.lex_state = 2, .external_lex_state = 3},
  [1011] = {.lex_state = 3, .external_lex_state = 2},
  [1012] = {.lex_state = 2, .external_lex_state = 2},
  [1013] = {.lex_state = 3, .external_lex_state = 2},
  [1014] = {.lex_state = 2, .external_lex_state = 3},
  [1015] = {.lex_state = 2, .external_lex_state = 2},
  [1016] = {.lex_state = 3, .external_lex_state = 2},
  [1017] = {.lex_state = 2, .external_lex_state = 3},
  [1018] = {.lex_state = 2, .external_lex_state = 2},
  [1019] = {.lex_state = 2, .external_lex_state = 2},
  [1020] = {.lex_state = 2, .external_lex_state = 2},
  [1021] = {.lex_state = 2, .external_lex_state = 2},
  [1022] = {.lex_state = 2, .external_lex_state = 2},
  [1023] = {.lex_state = 2, .external_lex_state = 3},
  [1024] = {.lex_state = 2, .external_lex_state = 2},
  [1025] = {.lex_state = 2, .external_lex_state = 3},
  [1026] = {.lex_state = 2, .external_lex_state = 2},
  [1027] = {.lex_state = 2, .external_lex_state = 2},
  [1028] = {.lex_state = 2, .external_lex_state = 3},
  [1029] = {.lex_state = 2, .external_lex_state = 2},
  [1030] = {.lex_state = 2, .external_lex_state = 2},
  [1031] = {.lex_state = 2, .external_lex_state = 3},
  [1032] = {.lex_state = 2, .external_lex_state = 2},
  [1033] = {.lex_state = 2, .external_lex_state = 2},
  [1034] = {.lex_state = 2, .external_lex_state = 2},
  [1035] = {.lex_state = 2, .external_lex_state = 3},
  [1036] = {.lex_state = 2, .external_lex_state = 2},
  [1037] = {.lex_state = 2, .external_lex_state = 2},
  [1038] = {.lex_state = 2, .external_lex_state = 3},
  [1039] = {.lex_state = 2, .external_lex_state = 2},
  [1040] = {.lex_state = 2, .external_lex_state = 3},
  [1041] = {.lex_state = 2, .external_lex_state = 3},
  [1042] = {.lex_state = 2, .external_lex_state = 2},
  [1043] = {.lex_state = 2, .external_lex_state = 2},
  [1044] = {.lex_state = 2, .external_lex_state = 2},
  [1045] = {.lex_state = 2, .external_lex_state = 2},
  [1046] = {.lex_state = 2, .external_lex_state = 2},
  [1047] = {.lex_state = 2, .external_lex_state = 2},
  [1048] = {.lex_state = 2, .external_lex_state = 2},
  [1049] = {.lex_state = 2, .external_lex_state = 3},
  [1050] = {.lex_state = 2, .external_lex_state = 3},
  [1051] = {.lex_state = 3, .external_lex_state = 2},
  [1052] = {.lex_state = 2, .external_lex_state = 2},
  [1053] = {.lex_state = 3, .external_lex_state = 2},
  [1054] = {.lex_state = 2, .external_lex_state = 2},
  [1055] = {.lex_state = 2, .external_lex_state = 3},
  [1056] = {.lex_state = 2, .external_lex_state = 3},
  [1057] = {.lex_state = 3, .external_lex_state = 2},
  [1058] = {.lex_state = 2, .external_lex_state = 2},
  [1059] = {.lex_state = 2, .external_lex_state = 3},
  [1060] = {.lex_state = 2, .external_lex_state = 3},
  [1061] = {.lex_state = 2, .external_lex_state = 3},
  [1062] = {.lex_state = 2, .external_lex_state = 2},
  [1063] = {.lex_state = 2, .external_lex_state = 3},
  [1064] = {.lex_state = 2, .external_lex_state = 3},
  [1065] = {.lex_state = 2, .external_lex_state = 3},
  [1066] = {.lex_state = 2, .external_lex_state = 2},
  [1067] = {.lex_state = 2, .external_lex_state = 3},
  [1068] = {.lex_state = 2, .external_lex_state = 3},
  [1069] = {.lex_state = 2, .external_lex_state = 3},
  [1070] = {.lex_state = 2, .external_lex_state = 2},
  [1071] = {.lex_state = 2, .external_lex_state = 3},
  [1072] = {.lex_state = 2, .external_lex_state = 2},
  [1073] = {.lex_state = 2, .external_lex_state = 2},
  [1074] = {.lex_state = 2, .external_lex_state = 3},
  [1075] = {.lex_state = 2, .external_lex_state = 2},
  [1076] = {.lex_state = 2, .external_lex_state = 3},
  [1077] = {.lex_state = 2, .external_lex_state = 2},
  [1078] = {.lex_state = 2, .external_lex_state = 3},
  [1079] = {.lex_state = 2, .external_lex_state = 3},
  [1080] = {.lex_state = 2, .external_lex_state = 2},
  [1081] = {.lex_state = 2, .external_lex_state = 3},
  [1082] = {.lex_state = 2, .external_lex_state = 2},
  [1083] = {.lex_state = 2, .external_lex_state = 3},
  [1084] = {.lex_state = 2, .external_lex_state = 3},
  [1085] = {.lex_state = 2, .external_lex_state = 3},
  [1086] = {.lex_state = 2, .external_lex_state = 3},
  [1087] = {.lex_state = 2, .external_lex_state = 3},
  [1088] = {.lex_state = 2, .external_lex_state = 3},
  [1089] = {.lex_state = 2, .external_lex_state = 3},
  [1090] = {.lex_state = 2, .external_lex_state = 3},
  [1091] = {.lex_state = 2, .external_lex_state = 2},
  [1092] = {.lex_state = 2, .external_lex_state = 2},
  [1093] = {.lex_state = 3, .external_lex_state = 2},
  [1094] = {.lex_state = 2, .external_lex_state = 3},
  [1095] = {.lex_state = 2, .external_lex_state = 2},
  [1096] = {.lex_state = 2, .external_lex_state = 2},
  [1097] = {.lex_state = 2, .external_lex_state = 3},
  [1098] = {.lex_state = 2, .external_lex_state = 2},
  [1099] = {.lex_state = 2, .external_lex_state = 3},
  [1100] = {.lex_state = 71},
  [1101] = {.lex_state = 2, .external_lex_state = 3},
  [1102] = {.lex_state = 3, .external_lex_state = 2},
  [1103] = {.lex_state = 2, .external_lex_state = 2},
  [1104] = {.lex_state = 2, .external_lex_state = 2},
  [1105] = {.lex_state = 3, .external_lex_state = 2},
  [1106] = {.lex_state = 2, .external_lex_state = 2},
  [1107] = {.lex_state = 71},
  [1108] = {.lex_state = 3, .external_lex_state = 2},
  [1109] = {.lex_state = 2, .external_lex_state = 2},
  [1110] = {.lex_state = 2, .external_lex_state = 3},
  [1111] = {.lex_state = 71},
  [1112] = {.lex_state = 2, .external_lex_state = 2},
  [1113] = {.lex_state = 2, .external_lex_state = 2},
  [1114] = {.lex_state = 71},
  [1115] = {.lex_state = 2, .external_lex_state = 3},
  [1116] = {.lex_state = 2, .external_lex_state = 2},
  [1117] = {.lex_state = 2, .external_lex_state = 3},
  [1118] = {.lex_state = 2, .external_lex_state = 2},
  [1119] = {.lex_state = 2, .external_lex_state = 2},
  [1120] = {.lex_state = 2, .external_lex_state = 2},
  [1121] = {.lex_state = 2, .external_lex_state = 2},
  [1122] = {.lex_state = 2, .external_lex_state = 2},
  [1123] = {.lex_state = 3, .external_lex_state = 2},
  [1124] = {.lex_state = 2, .external_lex_state = 3},
  [1125] = {.lex_state = 2, .external_lex_state = 2},
  [1126] = {.lex_state = 2, .external_lex_state = 2},
  [1127] = {.lex_state = 2, .external_lex_state = 2},
  [1128] = {.lex_state = 2, .external_lex_state = 3},
  [1129] = {.lex_state = 2, .external_lex_state = 2},
  [1130] = {.lex_state = 2, .external_lex_state = 2},
  [1131] = {.lex_state = 2, .external_lex_state = 2},
  [1132] = {.lex_state = 2, .external_lex_state = 2},
  [1133] = {.lex_state = 71},
  [1134] = {.lex_state = 71},
  [1135] = {.lex_state = 2, .external_lex_state = 2},
  [1136] = {.lex_state = 2, .external_lex_state = 3},
  [1137] = {.lex_state = 2, .external_lex_state = 2},
  [1138] = {.lex_state = 2, .external_lex_state = 2},
  [1139] = {.lex_state = 2, .external_lex_state = 2},
  [1140] = {.lex_state = 71},
  [1141] = {.lex_state = 2, .external_lex_state = 2},
  [1142] = {.lex_state = 2, .external_lex_state = 2},
  [1143] = {.lex_state = 2, .external_lex_state = 2},
  [1144] = {.lex_state = 2, .external_lex_state = 2},
  [1145] = {.lex_state = 2, .external_lex_state = 2},
  [1146] = {.lex_state = 2, .external_lex_state = 2},
  [1147] = {.lex_state = 9},
  [1148] = {.lex_state = 9},
  [1149] = {.lex_state = 9},
  [1150] = {.lex_state = 9},
  [1151] = {.lex_state = 9},
  [1152] = {.lex_state = 9},
  [1153] = {.lex_state = 71, .external_lex_state = 4},
  [1154] = {.lex_state = 71, .external_lex_state = 4},
  [1155] = {.lex_state = 71, .external_lex_state = 4},
  [1156] = {.lex_state = 71, .external_lex_state = 4},
  [1157] = {.lex_state = 71, .external_lex_state = 4},
  [1158] = {.lex_state = 9},
  [1159] = {.lex_state = 9},
  [1160] = {.lex_state = 70, .external_lex_state = 3},
  [1161] = {.lex_state = 9},
  [1162] = {.lex_state = 9},
  [1163] = {.lex_state = 9},
  [1164] = {.lex_state = 9},
  [1165] = {.lex_state = 9},
  [1166] = {.lex_state = 9},
  [1167] = {.lex_state = 9},
  [1168] = {.lex_state = 9},
  [1169] = {.lex_state = 9},
  [1170] = {.lex_state = 9},
  [1171] = {.lex_state = 9},
  [1172] = {.lex_state = 9},
  [1173] = {.lex_state = 9},
  [1174] = {.lex_state = 9},
  [1175] = {.lex_state = 9},
  [1176] = {.lex_state = 9},
  [1177] = {.lex_state = 71, .external_lex_state = 4},
  [1178] = {.lex_state = 71, .external_lex_state = 4},
  [1179] = {.lex_state = 9},
  [1180] = {.lex_state = 9},
  [1181] = {.lex_state = 9},
  [1182] = {.lex_state = 70, .external_lex_state = 3},
  [1183] = {.lex_state = 9},
  [1184] = {.lex_state = 9},
  [1185] = {.lex_state = 70, .external_lex_state = 3},
  [1186] = {.lex_state = 9},
  [1187] = {.lex_state = 9},
  [1188] = {.lex_state = 71},
  [1189] = {.lex_state = 71},
  [1190] = {.lex_state = 71},
  [1191] = {.lex_state = 71},
  [1192] = {.lex_state = 71},
  [1193] = {.lex_state = 71},
  [1194] = {.lex_state = 71},
  [1195] = {.lex_state = 70, .external_lex_state = 2},
  [1196] = {.lex_state = 70, .external_lex_state = 2},
  [1197] = {.lex_state = 70, .external_lex_state = 2},
  [1198] = {.lex_state = 70, .external_lex_state = 3},
  [1199] = {.lex_state = 70, .external_lex_state = 2},
  [1200] = {.lex_state = 70, .external_lex_state = 2},
  [1201] = {.lex_state = 70, .external_lex_state = 2},
  [1202] = {.lex_state = 70, .external_lex_state = 2},
  [1203] = {.lex_state = 70, .external_lex_state = 2},
  [1204] = {.lex_state = 70, .external_lex_state = 3},
  [1205] = {.lex_state = 70, .external_lex_state = 2},
  [1206] = {.lex_state = 70, .external_lex_state = 2},
  [1207] = {.lex_state = 70, .external_lex_state = 3},
  [1208] = {.lex_state = 70, .external_lex_state = 2},
  [1209] = {.lex_state = 70, .external_lex_state = 2},
  [1210] = {.lex_state = 70, .external_lex_state = 2},
  [1211] = {.lex_state = 70, .external_lex_state = 2},
  [1212] = {.lex_state = 70, .external_lex_state = 3},
  [1213] = {.lex_state = 71},
  [1214] = {.lex_state = 70, .external_lex_state = 2},
  [1215] = {.lex_state = 70, .external_lex_state = 2},
  [1216] = {.lex_state = 70, .external_lex_state = 2},
  [1217] = {.lex_state = 70, .external_lex_state = 2},
  [1218] = {.lex_state = 70, .external_lex_state = 2},
  [1219] = {.lex_state = 70, .external_lex_state = 2},
  [1220] = {.lex_state = 70, .external_lex_state = 2},
  [1221] = {.lex_state = 70, .external_lex_state = 2},
  [1222] = {.lex_state = 70, .external_lex_state = 2},
  [1223] = {.lex_state = 70, .external_lex_state = 2},
  [1224] = {.lex_state = 70, .external_lex_state = 3},
  [1225] = {.lex_state = 70, .external_lex_state = 2},
  [1226] = {.lex_state = 70, .external_lex_state = 3},
  [1227] = {.lex_state = 70, .external_lex_state = 2},
  [1228] = {.lex_state = 70, .external_lex_state = 2},
  [1229] = {.lex_state = 70, .external_lex_state = 2},
  [1230] = {.lex_state = 70, .external_lex_state = 2},
  [1231] = {.lex_state = 70, .external_lex_state = 2},
  [1232] = {.lex_state = 70, .external_lex_state = 2},
  [1233] = {.lex_state = 70, .external_lex_state = 2},
  [1234] = {.lex_state = 70, .external_lex_state = 2},
  [1235] = {.lex_state = 70, .external_lex_state = 2},
  [1236] = {.lex_state = 70, .external_lex_state = 2},
  [1237] = {.lex_state = 70, .external_lex_state = 2},
  [1238] = {.lex_state = 70, .external_lex_state = 2},
  [1239] = {.lex_state = 70, .external_lex_state = 2},
  [1240] = {.lex_state = 70, .external_lex_state = 2},
  [1241] = {.lex_state = 70, .external_lex_state = 2},
  [1242] = {.lex_state = 70, .external_lex_state = 2},
  [1243] = {.lex_state = 70, .external_lex_state = 2},
  [1244] = {.lex_state = 70, .external_lex_state = 2},
  [1245] = {.lex_state = 70, .external_lex_state = 2},
  [1246] = {.lex_state = 70, .external_lex_state = 2},
  [1247] = {.lex_state = 70, .external_lex_state = 2},
  [1248] = {.lex_state = 70, .external_lex_state = 2},
  [1249] = {.lex_state = 70, .external_lex_state = 2},
  [1250] = {.lex_state = 70, .external_lex_state = 2},
  [1251] = {.lex_state = 70, .external_lex_state = 2},
  [1252] = {.lex_state = 70, .external_lex_state = 2},
  [1253] = {.lex_state = 70, .external_lex_state = 2},
  [1254] = {.lex_state = 70, .external_lex_state = 2},
  [1255] = {.lex_state = 70, .external_lex_state = 2},
  [1256] = {.lex_state = 70, .external_lex_state = 2},
  [1257] = {.lex_state = 70, .external_lex_state = 2},
  [1258] = {.lex_state = 70, .external_lex_state = 2},
  [1259] = {.lex_state = 70, .external_lex_state = 2},
  [1260] = {.lex_state = 70, .external_lex_state = 2},
  [1261] = {.lex_state = 70, .external_lex_state = 2},
  [1262] = {.lex_state = 70, .external_lex_state = 2},
  [1263] = {.lex_state = 70, .external_lex_state = 2},
  [1264] = {.lex_state = 70, .external_lex_state = 2},
  [1265] = {.lex_state = 70, .external_lex_state = 2},
  [1266] = {.lex_state = 70, .external_lex_state = 2},
  [1267] = {.lex_state = 70, .external_lex_state = 2},
  [1268] = {.lex_state = 70, .external_lex_state = 2},
  [1269] = {.lex_state = 70, .external_lex_state = 2},
  [1270] = {.lex_state = 70, .external_lex_state = 2},
  [1271] = {.lex_state = 70, .external_lex_state = 2},
  [1272] = {.lex_state = 70, .external_lex_state = 2},
  [1273] = {.lex_state = 70, .external_lex_state = 2},
  [1274] = {.lex_state = 70, .external_lex_state = 2},
  [1275] = {.lex_state = 70, .external_lex_state = 2},
  [1276] = {.lex_state = 70, .external_lex_state = 2},
  [1277] = {.lex_state = 70, .external_lex_state = 2},
  [1278] = {.lex_state = 70, .external_lex_state = 2},
  [1279] = {.lex_state = 70, .external_lex_state = 2},
  [1280] = {.lex_state = 70, .external_lex_state = 2},
  [1281] = {.lex_state = 70, .external_lex_state = 2},
  [1282] = {.lex_state = 70, .external_lex_state = 2},
  [1283] = {.lex_state = 70, .external_lex_state = 2},
  [1284] = {.lex_state = 70, .external_lex_state = 2},
  [1285] = {.lex_state = 70, .external_lex_state = 2},
  [1286] = {.lex_state = 70, .external_lex_state = 2},
  [1287] = {.lex_state = 70, .external_lex_state = 2},
  [1288] = {.lex_state = 70, .external_lex_state = 2},
  [1289] = {.lex_state = 70, .external_lex_state = 2},
  [1290] = {.lex_state = 70, .external_lex_state = 2},
  [1291] = {.lex_state = 70, .external_lex_state = 2},
  [1292] = {.lex_state = 70, .external_lex_state = 2},
  [1293] = {.lex_state = 70, .external_lex_state = 2},
  [1294] = {.lex_state = 70, .external_lex_state = 2},
  [1295] = {.lex_state = 70, .external_lex_state = 2},
  [1296] = {.lex_state = 70, .external_lex_state = 2},
  [1297] = {.lex_state = 70, .external_lex_state = 2},
  [1298] = {.lex_state = 70, .external_lex_state = 2},
  [1299] = {.lex_state = 70, .external_lex_state = 2},
  [1300] = {.lex_state = 70, .external_lex_state = 2},
  [1301] = {.lex_state = 70, .external_lex_state = 2},
  [1302] = {.lex_state = 70, .external_lex_state = 2},
  [1303] = {.lex_state = 70, .external_lex_state = 2},
  [1304] = {.lex_state = 70, .external_lex_state = 2},
  [1305] = {.lex_state = 70, .external_lex_state = 2},
  [1306] = {.lex_state = 70, .external_lex_state = 2},
  [1307] = {.lex_state = 70, .external_lex_state = 2},
  [1308] = {.lex_state = 70, .external_lex_state = 2},
  [1309] = {.lex_state = 70, .external_lex_state = 2},
  [1310] = {.lex_state = 70, .external_lex_state = 2},
  [1311] = {.lex_state = 70, .external_lex_state = 2},
  [1312] = {.lex_state = 70, .external_lex_state = 2},
  [1313] = {.lex_state = 70, .external_lex_state = 2},
  [1314] = {.lex_state = 70, .external_lex_state = 2},
  [1315] = {.lex_state = 70, .external_lex_state = 2},
  [1316] = {.lex_state = 70, .external_lex_state = 2},
  [1317] = {.lex_state = 70, .external_lex_state = 2},
  [1318] = {.lex_state = 70, .external_lex_state = 2},
  [1319] = {.lex_state = 70, .external_lex_state = 2},
  [1320] = {.lex_state = 70, .external_lex_state = 3},
  [1321] = {.lex_state = 70, .external_lex_state = 2},
  [1322] = {.lex_state = 70, .external_lex_state = 3},
  [1323] = {.lex_state = 70, .external_lex_state = 2},
  [1324] = {.lex_state = 70, .external_lex_state = 2},
  [1325] = {.lex_state = 70, .external_lex_state = 2},
  [1326] = {.lex_state = 70, .external_lex_state = 2},
  [1327] = {.lex_state = 70, .external_lex_state = 2},
  [1328] = {.lex_state = 70, .external_lex_state = 2},
  [1329] = {.lex_state = 70, .external_lex_state = 3},
  [1330] = {.lex_state = 70, .external_lex_state = 2},
  [1331] = {.lex_state = 70, .external_lex_state = 2},
  [1332] = {.lex_state = 70, .external_lex_state = 3},
  [1333] = {.lex_state = 70, .external_lex_state = 2},
  [1334] = {.lex_state = 70, .external_lex_state = 2},
  [1335] = {.lex_state = 70, .external_lex_state = 2},
  [1336] = {.lex_state = 70, .external_lex_state = 2},
  [1337] = {.lex_state = 70, .external_lex_state = 3},
  [1338] = {.lex_state = 70, .external_lex_state = 2},
  [1339] = {.lex_state = 70, .external_lex_state = 2},
  [1340] = {.lex_state = 70, .external_lex_state = 2},
  [1341] = {.lex_state = 70, .external_lex_state = 2},
  [1342] = {.lex_state = 70, .external_lex_state = 2},
  [1343] = {.lex_state = 70, .external_lex_state = 2},
  [1344] = {.lex_state = 70, .external_lex_state = 2},
  [1345] = {.lex_state = 70, .external_lex_state = 2},
  [1346] = {.lex_state = 70, .external_lex_state = 2},
  [1347] = {.lex_state = 70, .external_lex_state = 2},
  [1348] = {.lex_state = 70, .external_lex_state = 2},
  [1349] = {.lex_state = 70, .external_lex_state = 2},
  [1350] = {.lex_state = 70, .external_lex_state = 3},
  [1351] = {.lex_state = 70, .external_lex_state = 2},
  [1352] = {.lex_state = 70, .external_lex_state = 2},
  [1353] = {.lex_state = 70, .external_lex_state = 2},
  [1354] = {.lex_state = 70, .external_lex_state = 2},
  [1355] = {.lex_state = 70, .external_lex_state = 2},
  [1356] = {.lex_state = 70, .external_lex_state = 2},
  [1357] = {.lex_state = 70, .external_lex_state = 2},
  [1358] = {.lex_state = 70, .external_lex_state = 2},
  [1359] = {.lex_state = 70, .external_lex_state = 3},
  [1360] = {.lex_state = 70, .external_lex_state = 2},
  [1361] = {.lex_state = 70, .external_lex_state = 2},
  [1362] = {.lex_state = 70, .external_lex_state = 2},
  [1363] = {.lex_state = 70, .external_lex_state = 2},
  [1364] = {.lex_state = 70, .external_lex_state = 2},
  [1365] = {.lex_state = 70, .external_lex_state = 2},
  [1366] = {.lex_state = 70, .external_lex_state = 2},
  [1367] = {.lex_state = 70, .external_lex_state = 2},
  [1368] = {.lex_state = 70, .external_lex_state = 2},
  [1369] = {.lex_state = 70, .external_lex_state = 2},
  [1370] = {.lex_state = 70, .external_lex_state = 2},
  [1371] = {.lex_state = 70, .external_lex_state = 2},
  [1372] = {.lex_state = 70, .external_lex_state = 2},
  [1373] = {.lex_state = 70, .external_lex_state = 2},
  [1374] = {.lex_state = 70, .external_lex_state = 2},
  [1375] = {.lex_state = 70, .external_lex_state = 2},
  [1376] = {.lex_state = 70, .external_lex_state = 2},
  [1377] = {.lex_state = 70, .external_lex_state = 2},
  [1378] = {.lex_state = 70, .external_lex_state = 2},
  [1379] = {.lex_state = 70, .external_lex_state = 2},
  [1380] = {.lex_state = 70, .external_lex_state = 3},
  [1381] = {.lex_state = 70, .external_lex_state = 2},
  [1382] = {.lex_state = 70, .external_lex_state = 2},
  [1383] = {.lex_state = 70, .external_lex_state = 2},
  [1384] = {.lex_state = 70, .external_lex_state = 2},
  [1385] = {.lex_state = 70, .external_lex_state = 2},
  [1386] = {.lex_state = 70, .external_lex_state = 2},
  [1387] = {.lex_state = 70, .external_lex_state = 2},
  [1388] = {.lex_state = 70, .external_lex_state = 2},
  [1389] = {.lex_state = 70, .external_lex_state = 2},
  [1390] = {.lex_state = 70, .external_lex_state = 2},
  [1391] = {.lex_state = 70, .external_lex_state = 2},
  [1392] = {.lex_state = 70, .external_lex_state = 2},
  [1393] = {.lex_state = 70, .external_lex_state = 2},
  [1394] = {.lex_state = 70, .external_lex_state = 2},
  [1395] = {.lex_state = 70, .external_lex_state = 2},
  [1396] = {.lex_state = 70, .external_lex_state = 2},
  [1397] = {.lex_state = 70, .external_lex_state = 3},
  [1398] = {.lex_state = 70, .external_lex_state = 2},
  [1399] = {.lex_state = 70, .external_lex_state = 2},
  [1400] = {.lex_state = 70, .external_lex_state = 2},
  [1401] = {.lex_state = 70, .external_lex_state = 2},
  [1402] = {.lex_state = 70, .external_lex_state = 2},
  [1403] = {.lex_state = 70, .external_lex_state = 2},
  [1404] = {.lex_state = 70, .external_lex_state = 2},
  [1405] = {.lex_state = 70, .external_lex_state = 2},
  [1406] = {.lex_state = 70, .external_lex_state = 2},
  [1407] = {.lex_state = 70, .external_lex_state = 2},
  [1408] = {.lex_state = 70, .external_lex_state = 2},
  [1409] = {.lex_state = 70, .external_lex_state = 2},
  [1410] = {.lex_state = 70, .external_lex_state = 2},
  [1411] = {.lex_state = 9},
  [1412] = {.lex_state = 9},
  [1413] = {.lex_state = 70, .external_lex_state = 3},
  [1414] = {.lex_state = 70, .external_lex_state = 2},
  [1415] = {.lex_state = 9},
  [1416] = {.lex_state = 9},
  [1417] = {.lex_state = 71, .external_lex_state = 4},
  [1418] = {.lex_state = 70, .external_lex_state = 3},
  [1419] = {.lex_state = 70, .external_lex_state = 3},
  [1420] = {.lex_state = 70, .external_lex_state = 3},
  [1421] = {.lex_state = 70, .external_lex_state = 3},
  [1422] = {.lex_state = 9},
  [1423] = {.lex_state = 70, .external_lex_state = 2},
  [1424] = {.lex_state = 70, .external_lex_state = 3},
  [1425] = {.lex_state = 70, .external_lex_state = 3},
  [1426] = {.lex_state = 70, .external_lex_state = 3},
  [1427] = {.lex_state = 70, .external_lex_state = 3},
  [1428] = {.lex_state = 70, .external_lex_state = 2},
  [1429] = {.lex_state = 9},
  [1430] = {.lex_state = 70, .external_lex_state = 3},
  [1431] = {.lex_state = 70, .external_lex_state = 3},
  [1432] = {.lex_state = 70, .external_lex_state = 3},
  [1433] = {.lex_state = 70, .external_lex_state = 3},
  [1434] = {.lex_state = 70, .external_lex_state = 3},
  [1435] = {.lex_state = 70, .external_lex_state = 3},
  [1436] = {.lex_state = 70, .external_lex_state = 3},
  [1437] = {.lex_state = 70, .external_lex_state = 3},
  [1438] = {.lex_state = 70, .external_lex_state = 3},
  [1439] = {.lex_state = 70, .external_lex_state = 3},
  [1440] = {.lex_state = 70, .external_lex_state = 3},
  [1441] = {.lex_state = 70, .external_lex_state = 2},
  [1442] = {.lex_state = 70, .external_lex_state = 2},
  [1443] = {.lex_state = 70, .external_lex_state = 3},
  [1444] = {.lex_state = 70, .external_lex_state = 3},
  [1445] = {.lex_state = 70, .external_lex_state = 3},
  [1446] = {.lex_state = 70, .external_lex_state = 3},
  [1447] = {.lex_state = 70, .external_lex_state = 3},
  [1448] = {.lex_state = 70, .external_lex_state = 3},
  [1449] = {.lex_state = 70, .external_lex_state = 3},
  [1450] = {.lex_state = 70, .external_lex_state = 3},
  [1451] = {.lex_state = 70, .external_lex_state = 3},
  [1452] = {.lex_state = 70, .external_lex_state = 3},
  [1453] = {.lex_state = 70, .external_lex_state = 3},
  [1454] = {.lex_state = 70, .external_lex_state = 3},
  [1455] = {.lex_state = 70, .external_lex_state = 3},
  [1456] = {.lex_state = 70, .external_lex_state = 3},
  [1457] = {.lex_state = 70, .external_lex_state = 3},
  [1458] = {.lex_state = 70, .external_lex_state = 3},
  [1459] = {.lex_state = 70, .external_lex_state = 3},
  [1460] = {.lex_state = 70, .external_lex_state = 3},
  [1461] = {.lex_state = 70, .external_lex_state = 3},
  [1462] = {.lex_state = 70, .external_lex_state = 3},
  [1463] = {.lex_state = 70, .external_lex_state = 3},
  [1464] = {.lex_state = 70, .external_lex_state = 3},
  [1465] = {.lex_state = 70, .external_lex_state = 3},
  [1466] = {.lex_state = 70, .external_lex_state = 3},
  [1467] = {.lex_state = 70, .external_lex_state = 2},
  [1468] = {.lex_state = 70, .external_lex_state = 3},
  [1469] = {.lex_state = 70, .external_lex_state = 3},
  [1470] = {.lex_state = 70, .external_lex_state = 3},
  [1471] = {.lex_state = 70, .external_lex_state = 3},
  [1472] = {.lex_state = 70, .external_lex_state = 3},
  [1473] = {.lex_state = 70, .external_lex_state = 3},
  [1474] = {.lex_state = 70, .external_lex_state = 3},
  [1475] = {.lex_state = 71, .external_lex_state = 4},
  [1476] = {.lex_state = 9},
  [1477] = {.lex_state = 70, .external_lex_state = 3},
  [1478] = {.lex_state = 70, .external_lex_state = 3},
  [1479] = {.lex_state = 70, .external_lex_state = 3},
  [1480] = {.lex_state = 70, .external_lex_state = 3},
  [1481] = {.lex_state = 70, .external_lex_state = 3},
  [1482] = {.lex_state = 70, .external_lex_state = 3},
  [1483] = {.lex_state = 9},
  [1484] = {.lex_state = 70, .external_lex_state = 2},
  [1485] = {.lex_state = 9},
  [1486] = {.lex_state = 70, .external_lex_state = 2},
  [1487] = {.lex_state = 70, .external_lex_state = 3},
  [1488] = {.lex_state = 70, .external_lex_state = 3},
  [1489] = {.lex_state = 70, .external_lex_state = 3},
  [1490] = {.lex_state = 70, .external_lex_state = 3},
  [1491] = {.lex_state = 9},
  [1492] = {.lex_state = 71, .external_lex_state = 4},
  [1493] = {.lex_state = 70, .external_lex_state = 3},
  [1494] = {.lex_state = 70, .external_lex_state = 3},
  [1495] = {.lex_state = 70, .external_lex_state = 2},
  [1496] = {.lex_state = 70, .external_lex_state = 3},
  [1497] = {.lex_state = 70, .external_lex_state = 2},
  [1498] = {.lex_state = 70, .external_lex_state = 2},
  [1499] = {.lex_state = 70, .external_lex_state = 3},
  [1500] = {.lex_state = 71, .external_lex_state = 4},
  [1501] = {.lex_state = 70, .external_lex_state = 2},
  [1502] = {.lex_state = 70, .external_lex_state = 3},
  [1503] = {.lex_state = 70, .external_lex_state = 2},
  [1504] = {.lex_state = 71, .external_lex_state = 4},
  [1505] = {.lex_state = 70, .external_lex_state = 3},
  [1506] = {.lex_state = 9},
  [1507] = {.lex_state = 70, .external_lex_state = 3},
  [1508] = {.lex_state = 70, .external_lex_state = 3},
  [1509] = {.lex_state = 70, .external_lex_state = 3},
  [1510] = {.lex_state = 70, .external_lex_state = 3},
  [1511] = {.lex_state = 70, .external_lex_state = 3},
  [1512] = {.lex_state = 70, .external_lex_state = 2},
  [1513] = {.lex_state = 70, .external_lex_state = 3},
  [1514] = {.lex_state = 70, .external_lex_state = 3},
  [1515] = {.lex_state = 70, .external_lex_state = 3},
  [1516] = {.lex_state = 70, .external_lex_state = 3},
  [1517] = {.lex_state = 70, .external_lex_state = 3},
  [1518] = {.lex_state = 70, .external_lex_state = 3},
  [1519] = {.lex_state = 70, .external_lex_state = 2},
  [1520] = {.lex_state = 70, .external_lex_state = 2},
  [1521] = {.lex_state = 70, .external_lex_state = 2},
  [1522] = {.lex_state = 70, .external_lex_state = 2},
  [1523] = {.lex_state = 70, .external_lex_state = 2},
  [1524] = {.lex_state = 70, .external_lex_state = 2},
  [1525] = {.lex_state = 70, .external_lex_state = 2},
  [1526] = {.lex_state = 70, .external_lex_state = 2},
  [1527] = {.lex_state = 70, .external_lex_state = 3},
  [1528] = {.lex_state = 70, .external_lex_state = 2},
  [1529] = {.lex_state = 70, .external_lex_state = 2},
  [1530] = {.lex_state = 70, .external_lex_state = 2},
  [1531] = {.lex_state = 70, .external_lex_state = 2},
  [1532] = {.lex_state = 70, .external_lex_state = 2},
  [1533] = {.lex_state = 70, .external_lex_state = 2},
  [1534] = {.lex_state = 70, .external_lex_state = 2},
  [1535] = {.lex_state = 70, .external_lex_state = 2},
  [1536] = {.lex_state = 70, .external_lex_state = 2},
  [1537] = {.lex_state = 70, .external_lex_state = 2},
  [1538] = {.lex_state = 70, .external_lex_state = 2},
  [1539] = {.lex_state = 70, .external_lex_state = 2},
  [1540] = {.lex_state = 70, .external_lex_state = 2},
  [1541] = {.lex_state = 70, .external_lex_state = 3},
  [1542] = {.lex_state = 70, .external_lex_state = 3},
  [1543] = {.lex_state = 70, .external_lex_state = 3},
  [1544] = {.lex_state = 70, .external_lex_state = 3},
  [1545] = {.lex_state = 70, .external_lex_state = 3},
  [1546] = {.lex_state = 70, .external_lex_state = 3},
  [1547] = {.lex_state = 70, .external_lex_state = 3},
  [1548] = {.lex_state = 70, .external_lex_state = 3},
  [1549] = {.lex_state = 70, .external_lex_state = 3},
  [1550] = {.lex_state = 70, .external_lex_state = 3},
  [1551] = {.lex_state = 70, .external_lex_state = 3},
  [1552] = {.lex_state = 70, .external_lex_state = 3},
  [1553] = {.lex_state = 70, .external_lex_state = 3},
  [1554] = {.lex_state = 70, .external_lex_state = 3},
  [1555] = {.lex_state = 70, .external_lex_state = 3},
  [1556] = {.lex_state = 70, .external_lex_state = 3},
  [1557] = {.lex_state = 70, .external_lex_state = 3},
  [1558] = {.lex_state = 70, .external_lex_state = 3},
  [1559] = {.lex_state = 70, .external_lex_state = 3},
  [1560] = {.lex_state = 70, .external_lex_state = 2},
  [1561] = {.lex_state = 71, .external_lex_state = 4},
  [1562] = {.lex_state = 70, .external_lex_state = 3},
  [1563] = {.lex_state = 71, .external_lex_state = 4},
  [1564] = {.lex_state = 71, .external_lex_state = 4},
  [1565] = {.lex_state = 70, .external_lex_state = 3},
  [1566] = {.lex_state = 70, .external_lex_state = 3},
  [1567] = {.lex_state = 70, .external_lex_state = 3},
  [1568] = {.lex_state = 70, .external_lex_state = 3},
  [1569] = {.lex_state = 70, .external_lex_state = 2},
  [1570] = {.lex_state = 70, .external_lex_state = 2},
  [1571] = {.lex_state = 70, .external_lex_state = 3},
  [1572] = {.lex_state = 70, .external_lex_state = 3},
  [1573] = {.lex_state = 70, .external_lex_state = 2},
  [1574] = {.lex_state = 70, .external_lex_state = 2},
  [1575] = {.lex_state = 71, .external_lex_state = 4},
  [1576] = {.lex_state = 70, .external_lex_state = 3},
  [1577] = {.lex_state = 71, .external_lex_state = 4},
  [1578] = {.lex_state = 70, .external_lex_state = 2},
  [1579] = {.lex_state = 70, .external_lex_state = 2},
  [1580] = {.lex_state = 70, .external_lex_state = 3},
  [1581] = {.lex_state = 70, .external_lex_state = 3},
  [1582] = {.lex_state = 70, .external_lex_state = 3},
  [1583] = {.lex_state = 70, .external_lex_state = 2},
  [1584] = {.lex_state = 70, .external_lex_state = 3},
  [1585] = {.lex_state = 70, .external_lex_state = 3},
  [1586] = {.lex_state = 70, .external_lex_state = 3},
  [1587] = {.lex_state = 70, .external_lex_state = 3},
  [1588] = {.lex_state = 70, .external_lex_state = 3},
  [1589] = {.lex_state = 70, .external_lex_state = 2},
  [1590] = {.lex_state = 70, .external_lex_state = 3},
  [1591] = {.lex_state = 71, .external_lex_state = 4},
  [1592] = {.lex_state = 71, .external_lex_state = 4},
  [1593] = {.lex_state = 71, .external_lex_state = 4},
  [1594] = {.lex_state = 70, .external_lex_state = 3},
  [1595] = {.lex_state = 70, .external_lex_state = 3},
  [1596] = {.lex_state = 70, .external_lex_state = 3},
  [1597] = {.lex_state = 70, .external_lex_state = 3},
  [1598] = {.lex_state = 70, .external_lex_state = 2},
  [1599] = {.lex_state = 4, .external_lex_state = 2},
  [1600] = {.lex_state = 70, .external_lex_state = 2},
  [1601] = {.lex_state = 70, .external_lex_state = 3},
  [1602] = {.lex_state = 70, .external_lex_state = 2},
  [1603] = {.lex_state = 70, .external_lex_state = 2},
  [1604] = {.lex_state = 70, .external_lex_state = 2},
  [1605] = {.lex_state = 70, .external_lex_state = 3},
  [1606] = {.lex_state = 70, .external_lex_state = 3},
  [1607] = {.lex_state = 70, .external_lex_state = 3},
  [1608] = {.lex_state = 70, .external_lex_state = 3},
  [1609] = {.lex_state = 70, .external_lex_state = 3},
  [1610] = {.lex_state = 70, .external_lex_state = 3},
  [1611] = {.lex_state = 70, .external_lex_state = 3},
  [1612] = {.lex_state = 70, .external_lex_state = 3},
  [1613] = {.lex_state = 70, .external_lex_state = 3},
  [1614] = {.lex_state = 70, .external_lex_state = 2},
  [1615] = {.lex_state = 70, .external_lex_state = 2},
  [1616] = {.lex_state = 70, .external_lex_state = 3},
  [1617] = {.lex_state = 70, .external_lex_state = 3},
  [1618] = {.lex_state = 70, .external_lex_state = 3},
  [1619] = {.lex_state = 70, .external_lex_state = 2},
  [1620] = {.lex_state = 70, .external_lex_state = 2},
  [1621] = {.lex_state = 70, .external_lex_state = 3},
  [1622] = {.lex_state = 70, .external_lex_state = 3},
  [1623] = {.lex_state = 70, .external_lex_state = 2},
  [1624] = {.lex_state = 70, .external_lex_state = 3},
  [1625] = {.lex_state = 70, .external_lex_state = 3},
  [1626] = {.lex_state = 70, .external_lex_state = 3},
  [1627] = {.lex_state = 70, .external_lex_state = 3},
  [1628] = {.lex_state = 70, .external_lex_state = 3},
  [1629] = {.lex_state = 70, .external_lex_state = 3},
  [1630] = {.lex_state = 70, .external_lex_state = 3},
  [1631] = {.lex_state = 70, .external_lex_state = 3},
  [1632] = {.lex_state = 70, .external_lex_state = 3},
  [1633] = {.lex_state = 70, .external_lex_state = 3},
  [1634] = {.lex_state = 70, .external_lex_state = 2},
  [1635] = {.lex_state = 70, .external_lex_state = 2},
  [1636] = {.lex_state = 70, .external_lex_state = 3},
  [1637] = {.lex_state = 70, .external_lex_state = 3},
  [1638] = {.lex_state = 70, .external_lex_state = 3},
  [1639] = {.lex_state = 70, .external_lex_state = 3},
  [1640] = {.lex_state = 70, .external_lex_state = 3},
  [1641] = {.lex_state = 70, .external_lex_state = 3},
  [1642] = {.lex_state = 70, .external_lex_state = 3},
  [1643] = {.lex_state = 70, .external_lex_state = 3},
  [1644] = {.lex_state = 70, .external_lex_state = 3},
  [1645] = {.lex_state = 70, .external_lex_state = 3},
  [1646] = {.lex_state = 70, .external_lex_state = 3},
  [1647] = {.lex_state = 70, .external_lex_state = 3},
  [1648] = {.lex_state = 70, .external_lex_state = 3},
  [1649] = {.lex_state = 70, .external_lex_state = 3},
  [1650] = {.lex_state = 70, .external_lex_state = 3},
  [1651] = {.lex_state = 70, .external_lex_state = 3},
  [1652] = {.lex_state = 70, .external_lex_state = 3},
  [1653] = {.lex_state = 70, .external_lex_state = 3},
  [1654] = {.lex_state = 70, .external_lex_state = 3},
  [1655] = {.lex_state = 70, .external_lex_state = 3},
  [1656] = {.lex_state = 70, .external_lex_state = 3},
  [1657] = {.lex_state = 70, .external_lex_state = 2},
  [1658] = {.lex_state = 70, .external_lex_state = 3},
  [1659] = {.lex_state = 70, .external_lex_state = 3},
  [1660] = {.lex_state = 70, .external_lex_state = 3},
  [1661] = {.lex_state = 70, .external_lex_state = 2},
  [1662] = {.lex_state = 70, .external_lex_state = 3},
  [1663] = {.lex_state = 70, .external_lex_state = 3},
  [1664] = {.lex_state = 70, .external_lex_state = 3},
  [1665] = {.lex_state = 70, .external_lex_state = 3},
  [1666] = {.lex_state = 70, .external_lex_state = 3},
  [1667] = {.lex_state = 70, .external_lex_state = 3},
  [1668] = {.lex_state = 70, .external_lex_state = 3},
  [1669] = {.lex_state = 70, .external_lex_state = 3},
  [1670] = {.lex_state = 70, .external_lex_state = 2},
  [1671] = {.lex_state = 71, .external_lex_state = 4},
  [1672] = {.lex_state = 70, .external_lex_state = 2},
  [1673] = {.lex_state = 70, .external_lex_state = 3},
  [1674] = {.lex_state = 70, .external_lex_state = 2},
  [1675] = {.lex_state = 71, .external_lex_state = 4},
  [1676] = {.lex_state = 70, .external_lex_state = 2},
  [1677] = {.lex_state = 70, .external_lex_state = 3},
  [1678] = {.lex_state = 70, .external_lex_state = 2},
  [1679] = {.lex_state = 70, .external_lex_state = 2},
  [1680] = {.lex_state = 70, .external_lex_state = 2},
  [1681] = {.lex_state = 70, .external_lex_state = 3},
  [1682] = {.lex_state = 70, .external_lex_state = 2},
  [1683] = {.lex_state = 70, .external_lex_state = 2},
  [1684] = {.lex_state = 70, .external_lex_state = 2},
  [1685] = {.lex_state = 70, .external_lex_state = 3},
  [1686] = {.lex_state = 70, .external_lex_state = 2},
  [1687] = {.lex_state = 70, .external_lex_state = 3},
  [1688] = {.lex_state = 70, .external_lex_state = 3},
  [1689] = {.lex_state = 70, .external_lex_state = 3},
  [1690] = {.lex_state = 70, .external_lex_state = 2},
  [1691] = {.lex_state = 70, .external_lex_state = 3},
  [1692] = {.lex_state = 70, .external_lex_state = 2},
  [1693] = {.lex_state = 70, .external_lex_state = 3},
  [1694] = {.lex_state = 71, .external_lex_state = 4},
  [1695] = {.lex_state = 70, .external_lex_state = 2},
  [1696] = {.lex_state = 70, .external_lex_state = 3},
  [1697] = {.lex_state = 70, .external_lex_state = 3},
  [1698] = {.lex_state = 70, .external_lex_state = 3},
  [1699] = {.lex_state = 70, .external_lex_state = 2},
  [1700] = {.lex_state = 70, .external_lex_state = 2},
  [1701] = {.lex_state = 70, .external_lex_state = 2},
  [1702] = {.lex_state = 70, .external_lex_state = 2},
  [1703] = {.lex_state = 70, .external_lex_state = 3},
  [1704] = {.lex_state = 70, .external_lex_state = 3},
  [1705] = {.lex_state = 70, .external_lex_state = 2},
  [1706] = {.lex_state = 70, .external_lex_state = 3},
  [1707] = {.lex_state = 70, .external_lex_state = 2},
  [1708] = {.lex_state = 70, .external_lex_state = 2},
  [1709] = {.lex_state = 70, .external_lex_state = 2},
  [1710] = {.lex_state = 70, .external_lex_state = 2},
  [1711] = {.lex_state = 70, .external_lex_state = 3},
  [1712] = {.lex_state = 70, .external_lex_state = 3},
  [1713] = {.lex_state = 70, .external_lex_state = 2},
  [1714] = {.lex_state = 70, .external_lex_state = 2},
  [1715] = {.lex_state = 70, .external_lex_state = 3},
  [1716] = {.lex_state = 70, .external_lex_state = 3},
  [1717] = {.lex_state = 70, .external_lex_state = 3},
  [1718] = {.lex_state = 70, .external_lex_state = 3},
  [1719] = {.lex_state = 70, .external_lex_state = 3},
  [1720] = {.lex_state = 70, .external_lex_state = 3},
  [1721] = {.lex_state = 70, .external_lex_state = 3},
  [1722] = {.lex_state = 70, .external_lex_state = 3},
  [1723] = {.lex_state = 71, .external_lex_state = 4},
  [1724] = {.lex_state = 70, .external_lex_state = 2},
  [1725] = {.lex_state = 70, .external_lex_state = 2},
  [1726] = {.lex_state = 70, .external_lex_state = 3},
  [1727] = {.lex_state = 70, .external_lex_state = 3},
  [1728] = {.lex_state = 70, .external_lex_state = 3},
  [1729] = {.lex_state = 70, .external_lex_state = 3},
  [1730] = {.lex_state = 70, .external_lex_state = 3},
  [1731] = {.lex_state = 70, .external_lex_state = 3},
  [1732] = {.lex_state = 70, .external_lex_state = 2},
  [1733] = {.lex_state = 70, .external_lex_state = 2},
  [1734] = {.lex_state = 70, .external_lex_state = 3},
  [1735] = {.lex_state = 70, .external_lex_state = 3},
  [1736] = {.lex_state = 70, .external_lex_state = 3},
  [1737] = {.lex_state = 70, .external_lex_state = 3},
  [1738] = {.lex_state = 70, .external_lex_state = 3},
  [1739] = {.lex_state = 70, .external_lex_state = 2},
  [1740] = {.lex_state = 70, .external_lex_state = 3},
  [1741] = {.lex_state = 71, .external_lex_state = 4},
  [1742] = {.lex_state = 70, .external_lex_state = 2},
  [1743] = {.lex_state = 70, .external_lex_state = 3},
  [1744] = {.lex_state = 70, .external_lex_state = 3},
  [1745] = {.lex_state = 70, .external_lex_state = 2},
  [1746] = {.lex_state = 70, .external_lex_state = 2},
  [1747] = {.lex_state = 70, .external_lex_state = 3},
  [1748] = {.lex_state = 70, .external_lex_state = 3},
  [1749] = {.lex_state = 70, .external_lex_state = 2},
  [1750] = {.lex_state = 70, .external_lex_state = 3},
  [1751] = {.lex_state = 70, .external_lex_state = 2},
  [1752] = {.lex_state = 70, .external_lex_state = 2},
  [1753] = {.lex_state = 70, .external_lex_state = 2},
  [1754] = {.lex_state = 70, .external_lex_state = 3},
  [1755] = {.lex_state = 70, .external_lex_state = 2},
  [1756] = {.lex_state = 70, .external_lex_state = 3},
  [1757] = {.lex_state = 70, .external_lex_state = 2},
  [1758] = {.lex_state = 70, .external_lex_state = 3},
  [1759] = {.lex_state = 70, .external_lex_state = 2},
  [1760] = {.lex_state = 70, .external_lex_state = 3},
  [1761] = {.lex_state = 70, .external_lex_state = 2},
  [1762] = {.lex_state = 70, .external_lex_state = 2},
  [1763] = {.lex_state = 70, .external_lex_state = 3},
  [1764] = {.lex_state = 70, .external_lex_state = 2},
  [1765] = {.lex_state = 70, .external_lex_state = 2},
  [1766] = {.lex_state = 70, .external_lex_state = 2},
  [1767] = {.lex_state = 70, .external_lex_state = 2},
  [1768] = {.lex_state = 70, .external_lex_state = 3},
  [1769] = {.lex_state = 70, .external_lex_state = 2},
  [1770] = {.lex_state = 70, .external_lex_state = 2},
  [1771] = {.lex_state = 70, .external_lex_state = 3},
  [1772] = {.lex_state = 70, .external_lex_state = 3},
  [1773] = {.lex_state = 70, .external_lex_state = 3},
  [1774] = {.lex_state = 70, .external_lex_state = 2},
  [1775] = {.lex_state = 70, .external_lex_state = 3},
  [1776] = {.lex_state = 70, .external_lex_state = 3},
  [1777] = {.lex_state = 70, .external_lex_state = 3},
  [1778] = {.lex_state = 70, .external_lex_state = 3},
  [1779] = {.lex_state = 70, .external_lex_state = 3},
  [1780] = {.lex_state = 70, .external_lex_state = 2},
  [1781] = {.lex_state = 70, .external_lex_state = 3},
  [1782] = {.lex_state = 70, .external_lex_state = 2},
  [1783] = {.lex_state = 70, .external_lex_state = 2},
  [1784] = {.lex_state = 70, .external_lex_state = 2},
  [1785] = {.lex_state = 70, .external_lex_state = 2},
  [1786] = {.lex_state = 70, .external_lex_state = 2},
  [1787] = {.lex_state = 70, .external_lex_state = 3},
  [1788] = {.lex_state = 70, .external_lex_state = 3},
  [1789] = {.lex_state = 70, .external_lex_state = 2},
  [1790] = {.lex_state = 70, .external_lex_state = 3},
  [1791] = {.lex_state = 70, .external_lex_state = 3},
  [1792] = {.lex_state = 70, .external_lex_state = 2},
  [1793] = {.lex_state = 70, .external_lex_state = 3},
  [1794] = {.lex_state = 71, .external_lex_state = 4},
  [1795] = {.lex_state = 70, .external_lex_state = 3},
  [1796] = {.lex_state = 70, .external_lex_state = 2},
  [1797] = {.lex_state = 70, .external_lex_state = 3},
  [1798] = {.lex_state = 70, .external_lex_state = 3},
  [1799] = {.lex_state = 70, .external_lex_state = 3},
  [1800] = {.lex_state = 70, .external_lex_state = 3},
  [1801] = {.lex_state = 70, .external_lex_state = 3},
  [1802] = {.lex_state = 70, .external_lex_state = 3},
  [1803] = {.lex_state = 70, .external_lex_state = 3},
  [1804] = {.lex_state = 70, .external_lex_state = 3},
  [1805] = {.lex_state = 70, .external_lex_state = 3},
  [1806] = {.lex_state = 70, .external_lex_state = 2},
  [1807] = {.lex_state = 70, .external_lex_state = 3},
  [1808] = {.lex_state = 70, .external_lex_state = 2},
  [1809] = {.lex_state = 4, .external_lex_state = 3},
  [1810] = {.lex_state = 70, .external_lex_state = 3},
  [1811] = {.lex_state = 70, .external_lex_state = 3},
  [1812] = {.lex_state = 70, .external_lex_state = 3},
  [1813] = {.lex_state = 70, .external_lex_state = 2},
  [1814] = {.lex_state = 70, .external_lex_state = 2},
  [1815] = {.lex_state = 70, .external_lex_state = 3},
  [1816] = {.lex_state = 70, .external_lex_state = 2},
  [1817] = {.lex_state = 70, .external_lex_state = 2},
  [1818] = {.lex_state = 70, .external_lex_state = 2},
  [1819] = {.lex_state = 70, .external_lex_state = 3},
  [1820] = {.lex_state = 70, .external_lex_state = 3},
  [1821] = {.lex_state = 70, .external_lex_state = 3},
  [1822] = {.lex_state = 70, .external_lex_state = 3},
  [1823] = {.lex_state = 70, .external_lex_state = 3},
  [1824] = {.lex_state = 70, .external_lex_state = 2},
  [1825] = {.lex_state = 71, .external_lex_state = 4},
  [1826] = {.lex_state = 70, .external_lex_state = 2},
  [1827] = {.lex_state = 70, .external_lex_state = 2},
  [1828] = {.lex_state = 70, .external_lex_state = 2},
  [1829] = {.lex_state = 70, .external_lex_state = 2},
  [1830] = {.lex_state = 70, .external_lex_state = 2},
  [1831] = {.lex_state = 70, .external_lex_state = 3},
  [1832] = {.lex_state = 70, .external_lex_state = 3},
  [1833] = {.lex_state = 70, .external_lex_state = 3},
  [1834] = {.lex_state = 70, .external_lex_state = 2},
  [1835] = {.lex_state = 70, .external_lex_state = 3},
  [1836] = {.lex_state = 70, .external_lex_state = 2},
  [1837] = {.lex_state = 70, .external_lex_state = 2},
  [1838] = {.lex_state = 70, .external_lex_state = 3},
  [1839] = {.lex_state = 70, .external_lex_state = 2},
  [1840] = {.lex_state = 70, .external_lex_state = 3},
  [1841] = {.lex_state = 70, .external_lex_state = 2},
  [1842] = {.lex_state = 70, .external_lex_state = 3},
  [1843] = {.lex_state = 70, .external_lex_state = 3},
  [1844] = {.lex_state = 70, .external_lex_state = 2},
  [1845] = {.lex_state = 70, .external_lex_state = 3},
  [1846] = {.lex_state = 70, .external_lex_state = 3},
  [1847] = {.lex_state = 70, .external_lex_state = 3},
  [1848] = {.lex_state = 70, .external_lex_state = 3},
  [1849] = {.lex_state = 70, .external_lex_state = 3},
  [1850] = {.lex_state = 70, .external_lex_state = 3},
  [1851] = {.lex_state = 70, .external_lex_state = 3},
  [1852] = {.lex_state = 71, .external_lex_state = 4},
  [1853] = {.lex_state = 4, .external_lex_state = 3},
  [1854] = {.lex_state = 70, .external_lex_state = 2},
  [1855] = {.lex_state = 70, .external_lex_state = 3},
  [1856] = {.lex_state = 70, .external_lex_state = 3},
  [1857] = {.lex_state = 70, .external_lex_state = 3},
  [1858] = {.lex_state = 70, .external_lex_state = 2},
  [1859] = {.lex_state = 70, .external_lex_state = 3},
  [1860] = {.lex_state = 70, .external_lex_state = 3},
  [1861] = {.lex_state = 70, .external_lex_state = 3},
  [1862] = {.lex_state = 70, .external_lex_state = 2},
  [1863] = {.lex_state = 70, .external_lex_state = 3},
  [1864] = {.lex_state = 71, .external_lex_state = 4},
  [1865] = {.lex_state = 70, .external_lex_state = 2},
  [1866] = {.lex_state = 70, .external_lex_state = 3},
  [1867] = {.lex_state = 70, .external_lex_state = 3},
  [1868] = {.lex_state = 70, .external_lex_state = 3},
  [1869] = {.lex_state = 70, .external_lex_state = 3},
  [1870] = {.lex_state = 70, .external_lex_state = 2},
  [1871] = {.lex_state = 70, .external_lex_state = 3},
  [1872] = {.lex_state = 70, .external_lex_state = 3},
  [1873] = {.lex_state = 70, .external_lex_state = 3},
  [1874] = {.lex_state = 70, .external_lex_state = 3},
  [1875] = {.lex_state = 70, .external_lex_state = 3},
  [1876] = {.lex_state = 70, .external_lex_state = 3},
  [1877] = {.lex_state = 70, .external_lex_state = 2},
  [1878] = {.lex_state = 70, .external_lex_state = 3},
  [1879] = {.lex_state = 70, .external_lex_state = 3},
  [1880] = {.lex_state = 70, .external_lex_state = 3},
  [1881] = {.lex_state = 70, .external_lex_state = 3},
  [1882] = {.lex_state = 70, .external_lex_state = 3},
  [1883] = {.lex_state = 70, .external_lex_state = 3},
  [1884] = {.lex_state = 70, .external_lex_state = 3},
  [1885] = {.lex_state = 70, .external_lex_state = 3},
  [1886] = {.lex_state = 70, .external_lex_state = 3},
  [1887] = {.lex_state = 70, .external_lex_state = 2},
  [1888] = {.lex_state = 70, .external_lex_state = 3},
  [1889] = {.lex_state = 70, .external_lex_state = 2},
  [1890] = {.lex_state = 70, .external_lex_state = 3},
  [1891] = {.lex_state = 70, .external_lex_state = 2},
  [1892] = {.lex_state = 70, .external_lex_state = 2},
  [1893] = {.lex_state = 71, .external_lex_state = 4},
  [1894] = {.lex_state = 71, .external_lex_state = 4},
  [1895] = {.lex_state = 71},
  [1896] = {.lex_state = 70, .external_lex_state = 2},
  [1897] = {.lex_state = 71, .external_lex_state = 4},
  [1898] = {.lex_state = 71, .external_lex_state = 4},
  [1899] = {.lex_state = 71, .external_lex_state = 4},
  [1900] = {.lex_state = 70, .external_lex_state = 2},
  [1901] = {.lex_state = 70, .external_lex_state = 2},
  [1902] = {.lex_state = 70, .external_lex_state = 2},
  [1903] = {.lex_state = 70, .external_lex_state = 2},
  [1904] = {.lex_state = 70, .external_lex_state = 2},
  [1905] = {.lex_state = 71},
  [1906] = {.lex_state = 70, .external_lex_state = 2},
  [1907] = {.lex_state = 70, .external_lex_state = 2},
  [1908] = {.lex_state = 70, .external_lex_state = 2},
  [1909] = {.lex_state = 70, .external_lex_state = 2},
  [1910] = {.lex_state = 70, .external_lex_state = 2},
  [1911] = {.lex_state = 70, .external_lex_state = 2},
  [1912] = {.lex_state = 70, .external_lex_state = 2},
  [1913] = {.lex_state = 71},
  [1914] = {.lex_state = 71},
  [1915] = {.lex_state = 70, .external_lex_state = 2},
  [1916] = {.lex_state = 70, .external_lex_state = 3},
  [1917] = {.lex_state = 70, .external_lex_state = 2},
  [1918] = {.lex_state = 70, .external_lex_state = 2},
  [1919] = {.lex_state = 70, .external_lex_state = 3},
  [1920] = {.lex_state = 70, .external_lex_state = 2},
  [1921] = {.lex_state = 70, .external_lex_state = 2},
  [1922] = {.lex_state = 70, .external_lex_state = 3},
  [1923] = {.lex_state = 70, .external_lex_state = 2},
  [1924] = {.lex_state = 70, .external_lex_state = 2},
  [1925] = {.lex_state = 70, .external_lex_state = 2},
  [1926] = {.lex_state = 70, .external_lex_state = 2},
  [1927] = {.lex_state = 70, .external_lex_state = 2},
  [1928] = {.lex_state = 70, .external_lex_state = 2},
  [1929] = {.lex_state = 70, .external_lex_state = 2},
  [1930] = {.lex_state = 70, .external_lex_state = 2},
  [1931] = {.lex_state = 71},
  [1932] = {.lex_state = 70, .external_lex_state = 2},
  [1933] = {.lex_state = 71},
  [1934] = {.lex_state = 70, .external_lex_state = 2},
  [1935] = {.lex_state = 70, .external_lex_state = 2},
  [1936] = {.lex_state = 70, .external_lex_state = 2},
  [1937] = {.lex_state = 70, .external_lex_state = 2},
  [1938] = {.lex_state = 70, .external_lex_state = 2},
  [1939] = {.lex_state = 70, .external_lex_state = 2},
  [1940] = {.lex_state = 70, .external_lex_state = 2},
  [1941] = {.lex_state = 70, .external_lex_state = 2},
  [1942] = {.lex_state = 70, .external_lex_state = 2},
  [1943] = {.lex_state = 70, .external_lex_state = 2},
  [1944] = {.lex_state = 70, .external_lex_state = 2},
  [1945] = {.lex_state = 70, .external_lex_state = 2},
  [1946] = {.lex_state = 70, .external_lex_state = 2},
  [1947] = {.lex_state = 71, .external_lex_state = 4},
  [1948] = {.lex_state = 70, .external_lex_state = 2},
  [1949] = {.lex_state = 71, .external_lex_state = 4},
  [1950] = {.lex_state = 71, .external_lex_state = 4},
  [1951] = {.lex_state = 71, .external_lex_state = 4},
  [1952] = {.lex_state = 70, .external_lex_state = 2},
  [1953] = {.lex_state = 71},
  [1954] = {.lex_state = 71},
  [1955] = {.lex_state = 70, .external_lex_state = 2},
  [1956] = {.lex_state = 70, .external_lex_state = 2},
  [1957] = {.lex_state = 71},
  [1958] = {.lex_state = 70, .external_lex_state = 2},
  [1959] = {.lex_state = 4, .external_lex_state = 2},
  [1960] = {.lex_state = 70, .external_lex_state = 2},
  [1961] = {.lex_state = 71},
  [1962] = {.lex_state = 71, .external_lex_state = 4},
  [1963] = {.lex_state = 71, .external_lex_state = 4},
  [1964] = {.lex_state = 70, .external_lex_state = 2},
  [1965] = {.lex_state = 71, .external_lex_state = 4},
  [1966] = {.lex_state = 70, .external_lex_state = 3},
  [1967] = {.lex_state = 70, .external_lex_state = 2},
  [1968] = {.lex_state = 70, .external_lex_state = 2},
  [1969] = {.lex_state = 71, .external_lex_state = 4},
  [1970] = {.lex_state = 70, .external_lex_state = 2},
  [1971] = {.lex_state = 70, .external_lex_state = 2},
  [1972] = {.lex_state = 71, .external_lex_state = 4},
  [1973] = {.lex_state = 70, .external_lex_state = 2},
  [1974] = {.lex_state = 70, .external_lex_state = 2},
  [1975] = {.lex_state = 71},
  [1976] = {.lex_state = 71},
  [1977] = {.lex_state = 71, .external_lex_state = 4},
  [1978] = {.lex_state = 71},
  [1979] = {.lex_state = 71},
  [1980] = {.lex_state = 71, .external_lex_state = 4},
  [1981] = {.lex_state = 71},
  [1982] = {.lex_state = 70, .external_lex_state = 2},
  [1983] = {.lex_state = 71},
  [1984] = {.lex_state = 70, .external_lex_state = 2},
  [1985] = {.lex_state = 70, .external_lex_state = 2},
  [1986] = {.lex_state = 70, .external_lex_state = 3},
  [1987] = {.lex_state = 70, .external_lex_state = 2},
  [1988] = {.lex_state = 70, .external_lex_state = 2},
  [1989] = {.lex_state = 71, .external_lex_state = 4},
  [1990] = {.lex_state = 70, .external_lex_state = 2},
  [1991] = {.lex_state = 71, .external_lex_state = 4},
  [1992] = {.lex_state = 71},
  [1993] = {.lex_state = 71, .external_lex_state = 4},
  [1994] = {.lex_state = 71, .external_lex_state = 4},
  [1995] = {.lex_state = 71, .external_lex_state = 4},
  [1996] = {.lex_state = 71, .external_lex_state = 4},
  [1997] = {.lex_state = 70, .external_lex_state = 3},
  [1998] = {.lex_state = 71},
  [1999] = {.lex_state = 71, .external_lex_state = 4},
  [2000] = {.lex_state = 71},
  [2001] = {.lex_state = 71},
  [2002] = {.lex_state = 71, .external_lex_state = 4},
  [2003] = {.lex_state = 71},
  [2004] = {.lex_state = 70, .external_lex_state = 2},
  [2005] = {.lex_state = 70, .external_lex_state = 2},
  [2006] = {.lex_state = 70, .external_lex_state = 2},
  [2007] = {.lex_state = 70, .external_lex_state = 2},
  [2008] = {.lex_state = 70, .external_lex_state = 2},
  [2009] = {.lex_state = 71, .external_lex_state = 4},
  [2010] = {.lex_state = 71, .external_lex_state = 4},
  [2011] = {.lex_state = 70, .external_lex_state = 2},
  [2012] = {.lex_state = 70, .external_lex_state = 2},
  [2013] = {.lex_state = 70, .external_lex_state = 2},
  [2014] = {.lex_state = 70, .external_lex_state = 2},
  [2015] = {.lex_state = 71, .external_lex_state = 4},
  [2016] = {.lex_state = 70, .external_lex_state = 2},
  [2017] = {.lex_state = 70, .external_lex_state = 2},
  [2018] = {.lex_state = 70, .external_lex_state = 2},
  [2019] = {.lex_state = 70, .external_lex_state = 2},
  [2020] = {.lex_state = 71, .external_lex_state = 4},
  [2021] = {.lex_state = 70, .external_lex_state = 2},
  [2022] = {.lex_state = 70, .external_lex_state = 2},
  [2023] = {.lex_state = 71},
  [2024] = {.lex_state = 71},
  [2025] = {.lex_state = 71, .external_lex_state = 4},
  [2026] = {.lex_state = 71, .external_lex_state = 4},
  [2027] = {.lex_state = 71, .external_lex_state = 4},
  [2028] = {.lex_state = 71, .external_lex_state = 4},
  [2029] = {.lex_state = 71, .external_lex_state = 4},
  [2030] = {.lex_state = 71, .external_lex_state = 4},
  [2031] = {.lex_state = 71, .external_lex_state = 4},
  [2032] = {.lex_state = 70, .external_lex_state = 2},
  [2033] = {.lex_state = 71, .external_lex_state = 4},
  [2034] = {.lex_state = 70, .external_lex_state = 2},
  [2035] = {.lex_state = 70, .external_lex_state = 2},
  [2036] = {.lex_state = 71, .external_lex_state = 4},
  [2037] = {.lex_state = 70, .external_lex_state = 2},
  [2038] = {.lex_state = 70, .external_lex_state = 2},
  [2039] = {.lex_state = 70, .external_lex_state = 2},
  [2040] = {.lex_state = 70, .external_lex_state = 2},
  [2041] = {.lex_state = 70, .external_lex_state = 2},
  [2042] = {.lex_state = 70, .external_lex_state = 2},
  [2043] = {.lex_state = 70, .external_lex_state = 2},
  [2044] = {.lex_state = 70, .external_lex_state = 2},
  [2045] = {.lex_state = 70, .external_lex_state = 2},
  [2046] = {.lex_state = 71},
  [2047] = {.lex_state = 71, .external_lex_state = 4},
  [2048] = {.lex_state = 70, .external_lex_state = 2},
  [2049] = {.lex_state = 70, .external_lex_state = 2},
  [2050] = {.lex_state = 71, .external_lex_state = 4},
  [2051] = {.lex_state = 70, .external_lex_state = 2},
  [2052] = {.lex_state = 70, .external_lex_state = 2},
  [2053] = {.lex_state = 70, .external_lex_state = 2},
  [2054] = {.lex_state = 71, .external_lex_state = 4},
  [2055] = {.lex_state = 71, .external_lex_state = 4},
  [2056] = {.lex_state = 70, .external_lex_state = 2},
  [2057] = {.lex_state = 70, .external_lex_state = 2},
  [2058] = {.lex_state = 71, .external_lex_state = 4},
  [2059] = {.lex_state = 70, .external_lex_state = 2},
  [2060] = {.lex_state = 71, .external_lex_state = 4},
  [2061] = {.lex_state = 71, .external_lex_state = 4},
  [2062] = {.lex_state = 71, .external_lex_state = 4},
  [2063] = {.lex_state = 70, .external_lex_state = 2},
  [2064] = {.lex_state = 71, .external_lex_state = 4},
  [2065] = {.lex_state = 71, .external_lex_state = 4},
  [2066] = {.lex_state = 71, .external_lex_state = 4},
  [2067] = {.lex_state = 71, .external_lex_state = 4},
  [2068] = {.lex_state = 70, .external_lex_state = 2},
  [2069] = {.lex_state = 70, .external_lex_state = 2},
  [2070] = {.lex_state = 71, .external_lex_state = 4},
  [2071] = {.lex_state = 71, .external_lex_state = 4},
  [2072] = {.lex_state = 71},
  [2073] = {.lex_state = 4, .external_lex_state = 2},
  [2074] = {.lex_state = 71},
  [2075] = {.lex_state = 71},
  [2076] = {.lex_state = 71, .external_lex_state = 4},
  [2077] = {.lex_state = 71, .external_lex_state = 4},
  [2078] = {.lex_state = 71, .external_lex_state = 4},
  [2079] = {.lex_state = 70, .external_lex_state = 2},
  [2080] = {.lex_state = 71, .external_lex_state = 4},
  [2081] = {.lex_state = 71},
  [2082] = {.lex_state = 71, .external_lex_state = 4},
  [2083] = {.lex_state = 71, .external_lex_state = 4},
  [2084] = {.lex_state = 71, .external_lex_state = 4},
  [2085] = {.lex_state = 71, .external_lex_state = 4},
  [2086] = {.lex_state = 71, .external_lex_state = 4},
  [2087] = {.lex_state = 70, .external_lex_state = 2},
  [2088] = {.lex_state = 71},
  [2089] = {.lex_state = 71, .external_lex_state = 4},
  [2090] = {.lex_state = 71},
  [2091] = {.lex_state = 71},
  [2092] = {.lex_state = 71},
  [2093] = {.lex_state = 71, .external_lex_state = 4},
  [2094] = {.lex_state = 71, .external_lex_state = 4},
  [2095] = {.lex_state = 70, .external_lex_state = 2},
  [2096] = {.lex_state = 71, .external_lex_state = 4},
  [2097] = {.lex_state = 71},
  [2098] = {.lex_state = 71, .external_lex_state = 4},
  [2099] = {.lex_state = 71, .external_lex_state = 4},
  [2100] = {.lex_state = 71},
  [2101] = {.lex_state = 71, .external_lex_state = 4},
  [2102] = {.lex_state = 71},
  [2103] = {.lex_state = 71},
  [2104] = {.lex_state = 71, .external_lex_state = 4},
  [2105] = {.lex_state = 71, .external_lex_state = 4},
  [2106] = {.lex_state = 71, .external_lex_state = 4},
  [2107] = {.lex_state = 71},
  [2108] = {.lex_state = 71},
  [2109] = {.lex_state = 71},
  [2110] = {.lex_state = 71},
  [2111] = {.lex_state = 71},
  [2112] = {.lex_state = 71},
  [2113] = {.lex_state = 71},
  [2114] = {.lex_state = 71},
  [2115] = {.lex_state = 71},
  [2116] = {.lex_state = 71},
  [2117] = {.lex_state = 71},
  [2118] = {.lex_state = 71},
  [2119] = {.lex_state = 71, .external_lex_state = 4},
  [2120] = {.lex_state = 71, .external_lex_state = 4},
  [2121] = {.lex_state = 71},
  [2122] = {.lex_state = 71},
  [2123] = {.lex_state = 71},
  [2124] = {.lex_state = 71},
  [2125] = {.lex_state = 71},
  [2126] = {.lex_state = 71},
  [2127] = {.lex_state = 9},
  [2128] = {.lex_state = 71},
  [2129] = {.lex_state = 71},
  [2130] = {.lex_state = 71},
  [2131] = {.lex_state = 71},
  [2132] = {.lex_state = 71},
  [2133] = {.lex_state = 71},
  [2134] = {.lex_state = 71},
  [2135] = {.lex_state = 71},
  [2136] = {.lex_state = 9, .external_lex_state = 4},
  [2137] = {.lex_state = 9, .external_lex_state = 4},
  [2138] = {.lex_state = 9, .external_lex_state = 4},
  [2139] = {.lex_state = 9, .external_lex_state = 4},
  [2140] = {.lex_state = 9, .external_lex_state = 4},
  [2141] = {.lex_state = 9, .external_lex_state = 4},
  [2142] = {.lex_state = 9, .external_lex_state = 4},
  [2143] = {.lex_state = 71},
  [2144] = {.lex_state = 9, .external_lex_state = 4},
  [2145] = {.lex_state = 71},
  [2146] = {.lex_state = 71},
  [2147] = {.lex_state = 9, .external_lex_state = 4},
  [2148] = {.lex_state = 9},
  [2149] = {.lex_state = 71},
  [2150] = {.lex_state = 9, .external_lex_state = 4},
  [2151] = {.lex_state = 9, .external_lex_state = 4},
  [2152] = {.lex_state = 9, .external_lex_state = 4},
  [2153] = {.lex_state = 9, .external_lex_state = 4},
  [2154] = {.lex_state = 9, .external_lex_state = 4},
  [2155] = {.lex_state = 71},
  [2156] = {.lex_state = 9, .external_lex_state = 4},
  [2157] = {.lex_state = 71},
  [2158] = {.lex_state = 9, .external_lex_state = 4},
  [2159] = {.lex_state = 9, .external_lex_state = 4},
  [2160] = {.lex_state = 71},
  [2161] = {.lex_state = 71},
  [2162] = {.lex_state = 9, .external_lex_state = 4},
  [2163] = {.lex_state = 9, .external_lex_state = 4},
  [2164] = {.lex_state = 9, .external_lex_state = 4},
  [2165] = {.lex_state = 9, .external_lex_state = 4},
  [2166] = {.lex_state = 9, .external_lex_state = 4},
  [2167] = {.lex_state = 71},
  [2168] = {.lex_state = 9, .external_lex_state = 4},
  [2169] = {.lex_state = 9, .external_lex_state = 4},
  [2170] = {.lex_state = 9, .external_lex_state = 4},
  [2171] = {.lex_state = 9, .external_lex_state = 4},
  [2172] = {.lex_state = 9, .external_lex_state = 4},
  [2173] = {.lex_state = 71},
  [2174] = {.lex_state = 71},
  [2175] = {.lex_state = 71},
  [2176] = {.lex_state = 71},
  [2177] = {.lex_state = 71},
  [2178] = {.lex_state = 71},
  [2179] = {.lex_state = 71},
  [2180] = {.lex_state = 71},
  [2181] = {.lex_state = 71},
  [2182] = {.lex_state = 71},
  [2183] = {.lex_state = 71},
  [2184] = {.lex_state = 71},
  [2185] = {.lex_state = 71},
  [2186] = {.lex_state = 71},
  [2187] = {.lex_state = 71},
  [2188] = {.lex_state = 71},
  [2189] = {.lex_state = 71},
  [2190] = {.lex_state = 71},
  [2191] = {.lex_state = 71},
  [2192] = {.lex_state = 71},
  [2193] = {.lex_state = 71},
  [2194] = {.lex_state = 71},
  [2195] = {.lex_state = 71},
  [2196] = {.lex_state = 71},
  [2197] = {.lex_state = 71},
  [2198] = {.lex_state = 71},
  [2199] = {.lex_state = 9},
  [2200] = {.lex_state = 71},
  [2201] = {.lex_state = 71},
  [2202] = {.lex_state = 71},
  [2203] = {.lex_state = 9},
  [2204] = {.lex_state = 71},
  [2205] = {.lex_state = 71},
  [2206] = {.lex_state = 71},
  [2207] = {.lex_state = 9},
  [2208] = {.lex_state = 71},
  [2209] = {.lex_state = 9},
  [2210] = {.lex_state = 71},
  [2211] = {.lex_state = 9},
  [2212] = {.lex_state = 71},
  [2213] = {.lex_state = 9},
  [2214] = {.lex_state = 71},
  [2215] = {.lex_state = 71},
  [2216] = {.lex_state = 71},
  [2217] = {.lex_state = 71},
  [2218] = {.lex_state = 71},
  [2219] = {.lex_state = 71},
  [2220] = {.lex_state = 71},
  [2221] = {.lex_state = 71},
  [2222] = {.lex_state = 71},
  [2223] = {.lex_state = 71},
  [2224] = {.lex_state = 71},
  [2225] = {.lex_state = 71},
  [2226] = {.lex_state = 71},
  [2227] = {.lex_state = 71},
  [2228] = {.lex_state = 71},
  [2229] = {.lex_state = 71},
  [2230] = {.lex_state = 71},
  [2231] = {.lex_state = 71},
  [2232] = {.lex_state = 71},
  [2233] = {.lex_state = 71},
  [2234] = {.lex_state = 71},
  [2235] = {.lex_state = 71},
  [2236] = {.lex_state = 71},
  [2237] = {.lex_state = 71},
  [2238] = {.lex_state = 71},
  [2239] = {.lex_state = 71},
  [2240] = {.lex_state = 71},
  [2241] = {.lex_state = 71},
  [2242] = {.lex_state = 71},
  [2243] = {.lex_state = 71},
  [2244] = {.lex_state = 71},
  [2245] = {.lex_state = 71},
  [2246] = {.lex_state = 71},
  [2247] = {.lex_state = 71},
  [2248] = {.lex_state = 71},
  [2249] = {.lex_state = 71},
  [2250] = {.lex_state = 71},
  [2251] = {.lex_state = 71},
  [2252] = {.lex_state = 71},
  [2253] = {.lex_state = 71},
  [2254] = {.lex_state = 71},
  [2255] = {.lex_state = 71},
  [2256] = {.lex_state = 71},
  [2257] = {.lex_state = 71},
  [2258] = {.lex_state = 71},
  [2259] = {.lex_state = 71},
  [2260] = {.lex_state = 71},
  [2261] = {.lex_state = 71},
  [2262] = {.lex_state = 71},
  [2263] = {.lex_state = 71},
  [2264] = {.lex_state = 8},
  [2265] = {.lex_state = 8},
  [2266] = {.lex_state = 8},
  [2267] = {.lex_state = 8},
  [2268] = {.lex_state = 8},
  [2269] = {.lex_state = 8},
  [2270] = {.lex_state = 8},
  [2271] = {.lex_state = 8},
  [2272] = {.lex_state = 8},
  [2273] = {.lex_state = 8},
  [2274] = {.lex_state = 8},
  [2275] = {.lex_state = 8},
  [2276] = {.lex_state = 8},
  [2277] = {.lex_state = 8},
  [2278] = {.lex_state = 8},
  [2279] = {.lex_state = 8},
  [2280] = {.lex_state = 8},
  [2281] = {.lex_state = 8},
  [2282] = {.lex_state = 8},
  [2283] = {.lex_state = 8},
  [2284] = {.lex_state = 8},
  [2285] = {.lex_state = 8},
  [2286] = {.lex_state = 8},
  [2287] = {.lex_state = 8},
  [2288] = {.lex_state = 8},
  [2289] = {.lex_state = 8},
  [2290] = {.lex_state = 8},
  [2291] = {.lex_state = 8},
  [2292] = {.lex_state = 8},
  [2293] = {.lex_state = 8},
  [2294] = {.lex_state = 8},
  [2295] = {.lex_state = 8},
  [2296] = {.lex_state = 8},
  [2297] = {.lex_state = 8},
  [2298] = {.lex_state = 8},
  [2299] = {.lex_state = 8},
  [2300] = {.lex_state = 8},
  [2301] = {.lex_state = 71},
  [2302] = {.lex_state = 71},
  [2303] = {.lex_state = 8},
  [2304] = {.lex_state = 8},
  [2305] = {.lex_state = 8},
  [2306] = {.lex_state = 71},
  [2307] = {.lex_state = 8},
  [2308] = {.lex_state = 71, .external_lex_state = 4},
  [2309] = {.lex_state = 71, .external_lex_state = 4},
  [2310] = {.lex_state = 71},
  [2311] = {.lex_state = 71},
  [2312] = {.lex_state = 71},
  [2313] = {.lex_state = 71},
  [2314] = {.lex_state = 71},
  [2315] = {.lex_state = 71},
  [2316] = {.lex_state = 71},
  [2317] = {.lex_state = 71},
  [2318] = {.lex_state = 71},
  [2319] = {.lex_state = 71},
  [2320] = {.lex_state = 71},
  [2321] = {.lex_state = 71},
  [2322] = {.lex_state = 71},
  [2323] = {.lex_state = 71},
  [2324] = {.lex_state = 71},
  [2325] = {.lex_state = 2},
  [2326] = {.lex_state = 71},
  [2327] = {.lex_state = 71},
  [2328] = {.lex_state = 2},
  [2329] = {.lex_state = 71},
  [2330] = {.lex_state = 71},
  [2331] = {.lex_state = 71, .external_lex_state = 4},
  [2332] = {.lex_state = 71},
  [2333] = {.lex_state = 2},
  [2334] = {.lex_state = 71},
  [2335] = {.lex_state = 71},
  [2336] = {.lex_state = 2},
  [2337] = {.lex_state = 71},
  [2338] = {.lex_state = 2},
  [2339] = {.lex_state = 71},
  [2340] = {.lex_state = 8, .external_lex_state = 4},
  [2341] = {.lex_state = 71},
  [2342] = {.lex_state = 8, .external_lex_state = 4},
  [2343] = {.lex_state = 8, .external_lex_state = 4},
  [2344] = {.lex_state = 71},
  [2345] = {.lex_state = 2},
  [2346] = {.lex_state = 71},
  [2347] = {.lex_state = 71},
  [2348] = {.lex_state = 71},
  [2349] = {.lex_state = 71},
  [2350] = {.lex_state = 2},
  [2351] = {.lex_state = 2},
  [2352] = {.lex_state = 8, .external_lex_state = 4},
  [2353] = {.lex_state = 71, .external_lex_state = 4},
  [2354] = {.lex_state = 71, .external_lex_state = 4},
  [2355] = {.lex_state = 71},
  [2356] = {.lex_state = 71},
  [2357] = {.lex_state = 71, .external_lex_state = 4},
  [2358] = {.lex_state = 8, .external_lex_state = 4},
  [2359] = {.lex_state = 71},
  [2360] = {.lex_state = 8, .external_lex_state = 4},
  [2361] = {.lex_state = 8, .external_lex_state = 4},
  [2362] = {.lex_state = 8, .external_lex_state = 4},
  [2363] = {.lex_state = 8, .external_lex_state = 4},
  [2364] = {.lex_state = 8, .external_lex_state = 4},
  [2365] = {.lex_state = 8, .external_lex_state = 4},
  [2366] = {.lex_state = 8, .external_lex_state = 4},
  [2367] = {.lex_state = 8, .external_lex_state = 4},
  [2368] = {.lex_state = 71},
  [2369] = {.lex_state = 71},
  [2370] = {.lex_state = 71},
  [2371] = {.lex_state = 71},
  [2372] = {.lex_state = 8, .external_lex_state = 4},
  [2373] = {.lex_state = 8, .external_lex_state = 4},
  [2374] = {.lex_state = 8, .external_lex_state = 4},
  [2375] = {.lex_state = 8, .external_lex_state = 4},
  [2376] = {.lex_state = 8, .external_lex_state = 4},
  [2377] = {.lex_state = 8, .external_lex_state = 4},
  [2378] = {.lex_state = 8, .external_lex_state = 4},
  [2379] = {.lex_state = 8, .external_lex_state = 4},
  [2380] = {.lex_state = 8, .external_lex_state = 4},
  [2381] = {.lex_state = 8, .external_lex_state = 4},
  [2382] = {.lex_state = 71},
  [2383] = {.lex_state = 71},
  [2384] = {.lex_state = 71},
  [2385] = {.lex_state = 71},
  [2386] = {.lex_state = 71},
  [2387] = {.lex_state = 71},
  [2388] = {.lex_state = 71},
  [2389] = {.lex_state = 71},
  [2390] = {.lex_state = 71},
  [2391] = {.lex_state = 71},
  [2392] = {.lex_state = 71, .external_lex_state = 4},
  [2393] = {.lex_state = 71},
  [2394] = {.lex_state = 71},
  [2395] = {.lex_state = 71},
  [2396] = {.lex_state = 71},
  [2397] = {.lex_state = 71},
  [2398] = {.lex_state = 71},
  [2399] = {.lex_state = 71},
  [2400] = {.lex_state = 71},
  [2401] = {.lex_state = 71},
  [2402] = {.lex_state = 71, .external_lex_state = 4},
  [2403] = {.lex_state = 71},
  [2404] = {.lex_state = 71},
  [2405] = {.lex_state = 71},
  [2406] = {.lex_state = 71},
  [2407] = {.lex_state = 71},
  [2408] = {.lex_state = 71},
  [2409] = {.lex_state = 71},
  [2410] = {.lex_state = 71},
  [2411] = {.lex_state = 8, .external_lex_state = 4},
  [2412] = {.lex_state = 8, .external_lex_state = 4},
  [2413] = {.lex_state = 71},
  [2414] = {.lex_state = 8, .external_lex_state = 4},
  [2415] = {.lex_state = 8, .external_lex_state = 4},
  [2416] = {.lex_state = 8, .external_lex_state = 4},
  [2417] = {.lex_state = 8, .external_lex_state = 4},
  [2418] = {.lex_state = 71},
  [2419] = {.lex_state = 8, .external_lex_state = 4},
  [2420] = {.lex_state = 8, .external_lex_state = 4},
  [2421] = {.lex_state = 71},
  [2422] = {.lex_state = 8, .external_lex_state = 4},
  [2423] = {.lex_state = 8, .external_lex_state = 4},
  [2424] = {.lex_state = 8, .external_lex_state = 4},
  [2425] = {.lex_state = 8, .external_lex_state = 4},
  [2426] = {.lex_state = 71},
  [2427] = {.lex_state = 71, .external_lex_state = 4},
  [2428] = {.lex_state = 8, .external_lex_state = 4},
  [2429] = {.lex_state = 8, .external_lex_state = 4},
  [2430] = {.lex_state = 71},
  [2431] = {.lex_state = 71},
  [2432] = {.lex_state = 71},
  [2433] = {.lex_state = 71, .external_lex_state = 4},
  [2434] = {.lex_state = 71},
  [2435] = {.lex_state = 71, .external_lex_state = 4},
  [2436] = {.lex_state = 71},
  [2437] = {.lex_state = 71},
  [2438] = {.lex_state = 71},
  [2439] = {.lex_state = 71},
  [2440] = {.lex_state = 71},
  [2441] = {.lex_state = 71, .external_lex_state = 4},
  [2442] = {.lex_state = 71, .external_lex_state = 4},
  [2443] = {.lex_state = 71, .external_lex_state = 4},
  [2444] = {.lex_state = 8, .external_lex_state = 5},
  [2445] = {.lex_state = 8, .external_lex_state = 5},
  [2446] = {.lex_state = 71},
  [2447] = {.lex_state = 8, .external_lex_state = 5},
  [2448] = {.lex_state = 71, .external_lex_state = 4},
  [2449] = {.lex_state = 71, .external_lex_state = 4},
  [2450] = {.lex_state = 71, .external_lex_state = 5},
  [2451] = {.lex_state = 8, .external_lex_state = 4},
  [2452] = {.lex_state = 8, .external_lex_state = 4},
  [2453] = {.lex_state = 8, .external_lex_state = 4},
  [2454] = {.lex_state = 71, .external_lex_state = 4},
  [2455] = {.lex_state = 71, .external_lex_state = 4},
  [2456] = {.lex_state = 8, .external_lex_state = 4},
  [2457] = {.lex_state = 8, .external_lex_state = 4},
  [2458] = {.lex_state = 8, .external_lex_state = 4},
  [2459] = {.lex_state = 71, .external_lex_state = 4},
  [2460] = {.lex_state = 71, .external_lex_state = 4},
  [2461] = {.lex_state = 71, .external_lex_state = 4},
  [2462] = {.lex_state = 71, .external_lex_state = 4},
  [2463] = {.lex_state = 8, .external_lex_state = 4},
  [2464] = {.lex_state = 71, .external_lex_state = 4},
  [2465] = {.lex_state = 8, .external_lex_state = 5},
  [2466] = {.lex_state = 8, .external_lex_state = 5},
  [2467] = {.lex_state = 71, .external_lex_state = 4},
  [2468] = {.lex_state = 8, .external_lex_state = 5},
  [2469] = {.lex_state = 8, .external_lex_state = 5},
  [2470] = {.lex_state = 71},
  [2471] = {.lex_state = 8, .external_lex_state = 5},
  [2472] = {.lex_state = 8, .external_lex_state = 5},
  [2473] = {.lex_state = 8, .external_lex_state = 5},
  [2474] = {.lex_state = 8, .external_lex_state = 5},
  [2475] = {.lex_state = 8, .external_lex_state = 5},
  [2476] = {.lex_state = 8, .external_lex_state = 5},
  [2477] = {.lex_state = 8, .external_lex_state = 5},
  [2478] = {.lex_state = 71, .external_lex_state = 4},
  [2479] = {.lex_state = 8, .external_lex_state = 5},
  [2480] = {.lex_state = 71, .external_lex_state = 4},
  [2481] = {.lex_state = 71, .external_lex_state = 4},
  [2482] = {.lex_state = 71, .external_lex_state = 4},
  [2483] = {.lex_state = 71, .external_lex_state = 4},
  [2484] = {.lex_state = 8, .external_lex_state = 5},
  [2485] = {.lex_state = 8, .external_lex_state = 5},
  [2486] = {.lex_state = 8, .external_lex_state = 5},
  [2487] = {.lex_state = 8, .external_lex_state = 5},
  [2488] = {.lex_state = 71, .external_lex_state = 4},
  [2489] = {.lex_state = 8, .external_lex_state = 5},
  [2490] = {.lex_state = 8, .external_lex_state = 5},
  [2491] = {.lex_state = 8, .external_lex_state = 5},
  [2492] = {.lex_state = 8, .external_lex_state = 5},
  [2493] = {.lex_state = 8, .external_lex_state = 5},
  [2494] = {.lex_state = 8, .external_lex_state = 5},
  [2495] = {.lex_state = 8, .external_lex_state = 5},
  [2496] = {.lex_state = 8, .external_lex_state = 5},
  [2497] = {.lex_state = 71, .external_lex_state = 4},
  [2498] = {.lex_state = 71, .external_lex_state = 5},
  [2499] = {.lex_state = 71, .external_lex_state = 4},
  [2500] = {.lex_state = 71, .external_lex_state = 4},
  [2501] = {.lex_state = 71, .external_lex_state = 4},
  [2502] = {.lex_state = 71, .external_lex_state = 4},
  [2503] = {.lex_state = 71, .external_lex_state = 4},
  [2504] = {.lex_state = 8, .external_lex_state = 5},
  [2505] = {.lex_state = 8, .external_lex_state = 5},
  [2506] = {.lex_state = 71, .external_lex_state = 4},
  [2507] = {.lex_state = 71, .external_lex_state = 4},
  [2508] = {.lex_state = 8, .external_lex_state = 5},
  [2509] = {.lex_state = 8, .external_lex_state = 5},
  [2510] = {.lex_state = 71, .external_lex_state = 4},
  [2511] = {.lex_state = 71, .external_lex_state = 4},
  [2512] = {.lex_state = 71, .external_lex_state = 4},
  [2513] = {.lex_state = 71, .external_lex_state = 4},
  [2514] = {.lex_state = 71, .external_lex_state = 4},
  [2515] = {.lex_state = 71, .external_lex_state = 4},
  [2516] = {.lex_state = 8, .external_lex_state = 5},
  [2517] = {.lex_state = 71, .external_lex_state = 4},
  [2518] = {.lex_state = 8, .external_lex_state = 5},
  [2519] = {.lex_state = 71, .external_lex_state = 4},
  [2520] = {.lex_state = 8, .external_lex_state = 5},
  [2521] = {.lex_state = 8, .external_lex_state = 5},
  [2522] = {.lex_state = 8, .external_lex_state = 5},
  [2523] = {.lex_state = 8, .external_lex_state = 5},
  [2524] = {.lex_state = 71, .external_lex_state = 4},
  [2525] = {.lex_state = 71, .external_lex_state = 4},
  [2526] = {.lex_state = 71, .external_lex_state = 4},
  [2527] = {.lex_state = 71, .external_lex_state = 4},
  [2528] = {.lex_state = 71, .external_lex_state = 4},
  [2529] = {.lex_state = 71, .external_lex_state = 4},
  [2530] = {.lex_state = 71, .external_lex_state = 4},
  [2531] = {.lex_state = 71, .external_lex_state = 4},
  [2532] = {.lex_state = 71, .external_lex_state = 4},
  [2533] = {.lex_state = 71, .external_lex_state = 4},
  [2534] = {.lex_state = 71, .external_lex_state = 5},
  [2535] = {.lex_state = 71, .external_lex_state = 4},
  [2536] = {.lex_state = 71, .external_lex_state = 4},
  [2537] = {.lex_state = 71, .external_lex_state = 4},
  [2538] = {.lex_state = 71, .external_lex_state = 4},
  [2539] = {.lex_state = 71, .external_lex_state = 4},
  [2540] = {.lex_state = 71, .external_lex_state = 4},
  [2541] = {.lex_state = 71, .external_lex_state = 4},
  [2542] = {.lex_state = 71, .external_lex_state = 4},
  [2543] = {.lex_state = 71, .external_lex_state = 4},
  [2544] = {.lex_state = 71, .external_lex_state = 4},
  [2545] = {.lex_state = 71, .external_lex_state = 4},
  [2546] = {.lex_state = 71, .external_lex_state = 4},
  [2547] = {.lex_state = 71, .external_lex_state = 4},
  [2548] = {.lex_state = 71, .external_lex_state = 4},
  [2549] = {.lex_state = 8, .external_lex_state = 5},
  [2550] = {.lex_state = 71, .external_lex_state = 4},
  [2551] = {.lex_state = 71, .external_lex_state = 4},
  [2552] = {.lex_state = 71, .external_lex_state = 4},
  [2553] = {.lex_state = 71, .external_lex_state = 4},
  [2554] = {.lex_state = 71, .external_lex_state = 4},
  [2555] = {.lex_state = 8, .external_lex_state = 5},
  [2556] = {.lex_state = 71, .external_lex_state = 4},
  [2557] = {.lex_state = 71, .external_lex_state = 5},
  [2558] = {.lex_state = 71, .external_lex_state = 4},
  [2559] = {.lex_state = 8, .external_lex_state = 5},
  [2560] = {.lex_state = 71, .external_lex_state = 4},
  [2561] = {.lex_state = 71, .external_lex_state = 4},
  [2562] = {.lex_state = 71, .external_lex_state = 4},
  [2563] = {.lex_state = 8, .external_lex_state = 5},
  [2564] = {.lex_state = 71, .external_lex_state = 4},
  [2565] = {.lex_state = 8, .external_lex_state = 5},
  [2566] = {.lex_state = 71, .external_lex_state = 4},
  [2567] = {.lex_state = 71, .external_lex_state = 4},
  [2568] = {.lex_state = 71, .external_lex_state = 4},
  [2569] = {.lex_state = 71, .external_lex_state = 4},
  [2570] = {.lex_state = 71, .external_lex_state = 4},
  [2571] = {.lex_state = 8, .external_lex_state = 5},
  [2572] = {.lex_state = 71, .external_lex_state = 4},
  [2573] = {.lex_state = 71, .external_lex_state = 4},
  [2574] = {.lex_state = 71, .external_lex_state = 4},
  [2575] = {.lex_state = 71, .external_lex_state = 4},
  [2576] = {.lex_state = 8, .external_lex_state = 5},
  [2577] = {.lex_state = 71, .external_lex_state = 4},
  [2578] = {.lex_state = 71, .external_lex_state = 4},
  [2579] = {.lex_state = 71},
  [2580] = {.lex_state = 71, .external_lex_state = 4},
  [2581] = {.lex_state = 71},
  [2582] = {.lex_state = 71, .external_lex_state = 4},
  [2583] = {.lex_state = 71},
  [2584] = {.lex_state = 71},
  [2585] = {.lex_state = 71},
  [2586] = {.lex_state = 71},
  [2587] = {.lex_state = 71},
  [2588] = {.lex_state = 8},
  [2589] = {.lex_state = 71, .external_lex_state = 4},
  [2590] = {.lex_state = 71},
  [2591] = {.lex_state = 71, .external_lex_state = 4},
  [2592] = {.lex_state = 71},
  [2593] = {.lex_state = 71, .external_lex_state = 4},
  [2594] = {.lex_state = 8},
  [2595] = {.lex_state = 71},
  [2596] = {.lex_state = 71, .external_lex_state = 5},
  [2597] = {.lex_state = 71},
  [2598] = {.lex_state = 71},
  [2599] = {.lex_state = 8},
  [2600] = {.lex_state = 71},
  [2601] = {.lex_state = 71},
  [2602] = {.lex_state = 71, .external_lex_state = 5},
  [2603] = {.lex_state = 71, .external_lex_state = 5},
  [2604] = {.lex_state = 71, .external_lex_state = 5},
  [2605] = {.lex_state = 71},
  [2606] = {.lex_state = 71},
  [2607] = {.lex_state = 71},
  [2608] = {.lex_state = 71, .external_lex_state = 5},
  [2609] = {.lex_state = 71},
  [2610] = {.lex_state = 71, .external_lex_state = 5},
  [2611] = {.lex_state = 71, .external_lex_state = 5},
  [2612] = {.lex_state = 71},
  [2613] = {.lex_state = 71, .external_lex_state = 5},
  [2614] = {.lex_state = 71, .external_lex_state = 5},
  [2615] = {.lex_state = 71, .external_lex_state = 5},
  [2616] = {.lex_state = 71, .external_lex_state = 5},
  [2617] = {.lex_state = 7},
  [2618] = {.lex_state = 71, .external_lex_state = 5},
  [2619] = {.lex_state = 71, .external_lex_state = 4},
  [2620] = {.lex_state = 71, .external_lex_state = 4},
  [2621] = {.lex_state = 71, .external_lex_state = 5},
  [2622] = {.lex_state = 71, .external_lex_state = 5},
  [2623] = {.lex_state = 71},
  [2624] = {.lex_state = 7},
  [2625] = {.lex_state = 71, .external_lex_state = 5},
  [2626] = {.lex_state = 71, .external_lex_state = 5},
  [2627] = {.lex_state = 71, .external_lex_state = 5},
  [2628] = {.lex_state = 71},
  [2629] = {.lex_state = 71},
  [2630] = {.lex_state = 71, .external_lex_state = 5},
  [2631] = {.lex_state = 7},
  [2632] = {.lex_state = 71, .external_lex_state = 5},
  [2633] = {.lex_state = 71, .external_lex_state = 5},
  [2634] = {.lex_state = 71, .external_lex_state = 5},
  [2635] = {.lex_state = 71, .external_lex_state = 5},
  [2636] = {.lex_state = 71, .external_lex_state = 5},
  [2637] = {.lex_state = 71, .external_lex_state = 5},
  [2638] = {.lex_state = 71, .external_lex_state = 5},
  [2639] = {.lex_state = 71, .external_lex_state = 5},
  [2640] = {.lex_state = 71, .external_lex_state = 5},
  [2641] = {.lex_state = 71, .external_lex_state = 5},
  [2642] = {.lex_state = 71, .external_lex_state = 5},
  [2643] = {.lex_state = 71, .external_lex_state = 5},
  [2644] = {.lex_state = 71, .external_lex_state = 5},
  [2645] = {.lex_state = 71, .external_lex_state = 5},
  [2646] = {.lex_state = 71, .external_lex_state = 5},
  [2647] = {.lex_state = 71, .external_lex_state = 4},
  [2648] = {.lex_state = 71},
  [2649] = {.lex_state = 71, .external_lex_state = 5},
  [2650] = {.lex_state = 71, .external_lex_state = 5},
  [2651] = {.lex_state = 71},
  [2652] = {.lex_state = 71},
  [2653] = {.lex_state = 71, .external_lex_state = 5},
  [2654] = {.lex_state = 71, .external_lex_state = 5},
  [2655] = {.lex_state = 71, .external_lex_state = 5},
  [2656] = {.lex_state = 71, .external_lex_state = 5},
  [2657] = {.lex_state = 71, .external_lex_state = 5},
  [2658] = {.lex_state = 71, .external_lex_state = 5},
  [2659] = {.lex_state = 71},
  [2660] = {.lex_state = 71},
  [2661] = {.lex_state = 71},
  [2662] = {.lex_state = 71},
  [2663] = {.lex_state = 71},
  [2664] = {.lex_state = 71},
  [2665] = {.lex_state = 71},
  [2666] = {.lex_state = 71},
  [2667] = {.lex_state = 71},
  [2668] = {.lex_state = 71},
  [2669] = {.lex_state = 71, .external_lex_state = 5},
  [2670] = {.lex_state = 71},
  [2671] = {.lex_state = 71, .external_lex_state = 4},
  [2672] = {.lex_state = 71, .external_lex_state = 5},
  [2673] = {.lex_state = 71},
  [2674] = {.lex_state = 71},
  [2675] = {.lex_state = 71, .external_lex_state = 5},
  [2676] = {.lex_state = 71, .external_lex_state = 5},
  [2677] = {.lex_state = 71},
  [2678] = {.lex_state = 71},
  [2679] = {.lex_state = 71},
  [2680] = {.lex_state = 71, .external_lex_state = 4},
  [2681] = {.lex_state = 71, .external_lex_state = 5},
  [2682] = {.lex_state = 71},
  [2683] = {.lex_state = 71, .external_lex_state = 4},
  [2684] = {.lex_state = 71},
  [2685] = {.lex_state = 71, .external_lex_state = 5},
  [2686] = {.lex_state = 71, .external_lex_state = 4},
  [2687] = {.lex_state = 71},
  [2688] = {.lex_state = 71, .external_lex_state = 5},
  [2689] = {.lex_state = 71},
  [2690] = {.lex_state = 71},
  [2691] = {.lex_state = 71, .external_lex_state = 5},
  [2692] = {.lex_state = 71},
  [2693] = {.lex_state = 13, .external_lex_state = 6},
  [2694] = {.lex_state = 13, .external_lex_state = 6},
  [2695] = {.lex_state = 13, .external_lex_state = 6},
  [2696] = {.lex_state = 13, .external_lex_state = 6},
  [2697] = {.lex_state = 71},
  [2698] = {.lex_state = 71},
  [2699] = {.lex_state = 13, .external_lex_state = 6},
  [2700] = {.lex_state = 71, .external_lex_state = 4},
  [2701] = {.lex_state = 13, .external_lex_state = 6},
  [2702] = {.lex_state = 8},
  [2703] = {.lex_state = 13, .external_lex_state = 6},
  [2704] = {.lex_state = 71, .external_lex_state = 4},
  [2705] = {.lex_state = 8},
  [2706] = {.lex_state = 71},
  [2707] = {.lex_state = 13, .external_lex_state = 6},
  [2708] = {.lex_state = 71, .external_lex_state = 4},
  [2709] = {.lex_state = 71, .external_lex_state = 4},
  [2710] = {.lex_state = 8},
  [2711] = {.lex_state = 71},
  [2712] = {.lex_state = 71},
  [2713] = {.lex_state = 71, .external_lex_state = 4},
  [2714] = {.lex_state = 71},
  [2715] = {.lex_state = 71},
  [2716] = {.lex_state = 71},
  [2717] = {.lex_state = 71},
  [2718] = {.lex_state = 71},
  [2719] = {.lex_state = 7},
  [2720] = {.lex_state = 71, .external_lex_state = 4},
  [2721] = {.lex_state = 71},
  [2722] = {.lex_state = 0, .external_lex_state = 4},
  [2723] = {.lex_state = 71},
  [2724] = {.lex_state = 71, .external_lex_state = 4},
  [2725] = {.lex_state = 71, .external_lex_state = 4},
  [2726] = {.lex_state = 71},
  [2727] = {.lex_state = 71},
  [2728] = {.lex_state = 71},
  [2729] = {.lex_state = 71, .external_lex_state = 4},
  [2730] = {.lex_state = 71, .external_lex_state = 4},
  [2731] = {.lex_state = 71},
  [2732] = {.lex_state = 71},
  [2733] = {.lex_state = 71},
  [2734] = {.lex_state = 71, .external_lex_state = 4},
  [2735] = {.lex_state = 7},
  [2736] = {.lex_state = 71},
  [2737] = {.lex_state = 71},
  [2738] = {.lex_state = 71},
  [2739] = {.lex_state = 71, .external_lex_state = 4},
  [2740] = {.lex_state = 71},
  [2741] = {.lex_state = 71, .external_lex_state = 4},
  [2742] = {.lex_state = 0, .external_lex_state = 4},
  [2743] = {.lex_state = 71, .external_lex_state = 4},
  [2744] = {.lex_state = 71},
  [2745] = {.lex_state = 71},
  [2746] = {.lex_state = 71},
  [2747] = {.lex_state = 71},
  [2748] = {.lex_state = 71},
  [2749] = {.lex_state = 71},
  [2750] = {.lex_state = 71},
  [2751] = {.lex_state = 71},
  [2752] = {.lex_state = 0, .external_lex_state = 4},
  [2753] = {.lex_state = 71},
  [2754] = {.lex_state = 71},
  [2755] = {.lex_state = 71, .external_lex_state = 4},
  [2756] = {.lex_state = 71},
  [2757] = {.lex_state = 71},
  [2758] = {.lex_state = 71, .external_lex_state = 4},
  [2759] = {.lex_state = 71, .external_lex_state = 4},
  [2760] = {.lex_state = 71},
  [2761] = {.lex_state = 71},
  [2762] = {.lex_state = 0, .external_lex_state = 4},
  [2763] = {.lex_state = 71, .external_lex_state = 4},
  [2764] = {.lex_state = 71},
  [2765] = {.lex_state = 71},
  [2766] = {.lex_state = 71},
  [2767] = {.lex_state = 71},
  [2768] = {.lex_state = 71},
  [2769] = {.lex_state = 71},
  [2770] = {.lex_state = 71},
  [2771] = {.lex_state = 71},
  [2772] = {.lex_state = 71},
  [2773] = {.lex_state = 71, .external_lex_state = 4},
  [2774] = {.lex_state = 71, .external_lex_state = 4},
  [2775] = {.lex_state = 71},
  [2776] = {.lex_state = 0, .external_lex_state = 4},
  [2777] = {.lex_state = 71, .external_lex_state = 4},
  [2778] = {.lex_state = 71, .external_lex_state = 4},
  [2779] = {.lex_state = 71, .external_lex_state = 4},
  [2780] = {.lex_state = 71, .external_lex_state = 4},
  [2781] = {.lex_state = 71, .external_lex_state = 4},
  [2782] = {.lex_state = 71, .external_lex_state = 4},
  [2783] = {.lex_state = 71, .external_lex_state = 4},
  [2784] = {.lex_state = 71},
  [2785] = {.lex_state = 71},
  [2786] = {.lex_state = 71, .external_lex_state = 4},
  [2787] = {.lex_state = 71, .external_lex_state = 4},
  [2788] = {.lex_state = 0, .external_lex_state = 4},
  [2789] = {.lex_state = 71, .external_lex_state = 4},
  [2790] = {.lex_state = 71, .external_lex_state = 4},
  [2791] = {.lex_state = 71, .external_lex_state = 4},
  [2792] = {.lex_state = 71, .external_lex_state = 4},
  [2793] = {.lex_state = 71, .external_lex_state = 4},
  [2794] = {.lex_state = 71},
  [2795] = {.lex_state = 71, .external_lex_state = 4},
  [2796] = {.lex_state = 71, .external_lex_state = 4},
  [2797] = {.lex_state = 71, .external_lex_state = 4},
  [2798] = {.lex_state = 0, .external_lex_state = 4},
  [2799] = {.lex_state = 71},
  [2800] = {.lex_state = 0, .external_lex_state = 4},
  [2801] = {.lex_state = 71, .external_lex_state = 4},
  [2802] = {.lex_state = 71},
  [2803] = {.lex_state = 71},
  [2804] = {.lex_state = 71, .external_lex_state = 4},
  [2805] = {.lex_state = 71},
  [2806] = {.lex_state = 71, .external_lex_state = 4},
  [2807] = {.lex_state = 0, .external_lex_state = 4},
  [2808] = {.lex_state = 71, .external_lex_state = 4},
  [2809] = {.lex_state = 71},
  [2810] = {.lex_state = 71},
  [2811] = {.lex_state = 71},
  [2812] = {.lex_state = 71},
  [2813] = {.lex_state = 71},
  [2814] = {.lex_state = 71},
  [2815] = {.lex_state = 7},
  [2816] = {.lex_state = 71},
  [2817] = {.lex_state = 0, .external_lex_state = 4},
  [2818] = {.lex_state = 0, .external_lex_state = 4},
  [2819] = {.lex_state = 71, .external_lex_state = 4},
  [2820] = {.lex_state = 71},
  [2821] = {.lex_state = 71, .external_lex_state = 5},
  [2822] = {.lex_state = 0, .external_lex_state = 4},
  [2823] = {.lex_state = 0, .external_lex_state = 4},
  [2824] = {.lex_state = 71},
  [2825] = {.lex_state = 71, .external_lex_state = 5},
  [2826] = {.lex_state = 71, .external_lex_state = 4},
  [2827] = {.lex_state = 71},
  [2828] = {.lex_state = 71},
  [2829] = {.lex_state = 71},
  [2830] = {.lex_state = 71},
  [2831] = {.lex_state = 71},
  [2832] = {.lex_state = 71, .external_lex_state = 4},
  [2833] = {.lex_state = 71},
  [2834] = {.lex_state = 71, .external_lex_state = 4},
  [2835] = {.lex_state = 71, .external_lex_state = 5},
  [2836] = {.lex_state = 13, .external_lex_state = 6},
  [2837] = {.lex_state = 71},
  [2838] = {.lex_state = 71},
  [2839] = {.lex_state = 71, .external_lex_state = 4},
  [2840] = {.lex_state = 71, .external_lex_state = 5},
  [2841] = {.lex_state = 71, .external_lex_state = 5},
  [2842] = {.lex_state = 0, .external_lex_state = 4},
  [2843] = {.lex_state = 71},
  [2844] = {.lex_state = 13},
  [2845] = {.lex_state = 13},
  [2846] = {.lex_state = 0},
  [2847] = {.lex_state = 71, .external_lex_state = 4},
  [2848] = {.lex_state = 71},
  [2849] = {.lex_state = 71},
  [2850] = {.lex_state = 71},
  [2851] = {.lex_state = 71, .external_lex_state = 5},
  [2852] = {.lex_state = 71},
  [2853] = {.lex_state = 71},
  [2854] = {.lex_state = 0, .external_lex_state = 4},
  [2855] = {.lex_state = 71},
  [2856] = {.lex_state = 13},
  [2857] = {.lex_state = 71},
  [2858] = {.lex_state = 0, .external_lex_state = 4},
  [2859] = {.lex_state = 0, .external_lex_state = 4},
  [2860] = {.lex_state = 71, .external_lex_state = 5},
  [2861] = {.lex_state = 71, .external_lex_state = 5},
  [2862] = {.lex_state = 71},
  [2863] = {.lex_state = 71, .external_lex_state = 5},
  [2864] = {.lex_state = 0, .external_lex_state = 4},
  [2865] = {.lex_state = 71},
  [2866] = {.lex_state = 71},
  [2867] = {.lex_state = 0, .external_lex_state = 4},
  [2868] = {.lex_state = 71},
  [2869] = {.lex_state = 71, .external_lex_state = 5},
  [2870] = {.lex_state = 71, .external_lex_state = 5},
  [2871] = {.lex_state = 71},
  [2872] = {.lex_state = 0, .external_lex_state = 4},
  [2873] = {.lex_state = 71},
  [2874] = {.lex_state = 71},
  [2875] = {.lex_state = 71, .external_lex_state = 5},
  [2876] = {.lex_state = 71},
  [2877] = {.lex_state = 71},
  [2878] = {.lex_state = 71},
  [2879] = {.lex_state = 71, .external_lex_state = 5},
  [2880] = {.lex_state = 71},
  [2881] = {.lex_state = 71, .external_lex_state = 5},
  [2882] = {.lex_state = 0, .external_lex_state = 4},
  [2883] = {.lex_state = 71, .external_lex_state = 5},
  [2884] = {.lex_state = 71},
  [2885] = {.lex_state = 71, .external_lex_state = 5},
  [2886] = {.lex_state = 0, .external_lex_state = 4},
  [2887] = {.lex_state = 71, .external_lex_state = 5},
  [2888] = {.lex_state = 71},
  [2889] = {.lex_state = 71},
  [2890] = {.lex_state = 71},
  [2891] = {.lex_state = 71},
  [2892] = {.lex_state = 71},
  [2893] = {.lex_state = 71},
  [2894] = {.lex_state = 71},
  [2895] = {.lex_state = 71},
  [2896] = {.lex_state = 71},
  [2897] = {.lex_state = 71},
  [2898] = {.lex_state = 71, .external_lex_state = 5},
  [2899] = {.lex_state = 71},
  [2900] = {.lex_state = 13, .external_lex_state = 6},
  [2901] = {.lex_state = 71},
  [2902] = {.lex_state = 71},
  [2903] = {.lex_state = 71, .external_lex_state = 5},
  [2904] = {.lex_state = 71},
  [2905] = {.lex_state = 71},
  [2906] = {.lex_state = 71},
  [2907] = {.lex_state = 13, .external_lex_state = 6},
  [2908] = {.lex_state = 71},
  [2909] = {.lex_state = 0, .external_lex_state = 4},
  [2910] = {.lex_state = 71, .external_lex_state = 5},
  [2911] = {.lex_state = 71},
  [2912] = {.lex_state = 71},
  [2913] = {.lex_state = 71},
  [2914] = {.lex_state = 13, .external_lex_state = 6},
  [2915] = {.lex_state = 0, .external_lex_state = 4},
  [2916] = {.lex_state = 71},
  [2917] = {.lex_state = 71},
  [2918] = {.lex_state = 71},
  [2919] = {.lex_state = 13},
  [2920] = {.lex_state = 71},
  [2921] = {.lex_state = 0, .external_lex_state = 4},
  [2922] = {.lex_state = 71},
  [2923] = {.lex_state = 13},
  [2924] = {.lex_state = 13},
  [2925] = {.lex_state = 71, .external_lex_state = 4},
  [2926] = {.lex_state = 71, .external_lex_state = 5},
  [2927] = {.lex_state = 0, .external_lex_state = 4},
  [2928] = {.lex_state = 71, .external_lex_state = 5},
  [2929] = {.lex_state = 0, .external_lex_state = 4},
  [2930] = {.lex_state = 71, .external_lex_state = 4},
  [2931] = {.lex_state = 71},
  [2932] = {.lex_state = 0, .external_lex_state = 4},
  [2933] = {.lex_state = 71},
  [2934] = {.lex_state = 0, .external_lex_state = 4},
  [2935] = {.lex_state = 71},
  [2936] = {.lex_state = 71},
  [2937] = {.lex_state = 71},
  [2938] = {.lex_state = 71},
  [2939] = {.lex_state = 71},
  [2940] = {.lex_state = 0, .external_lex_state = 4},
  [2941] = {.lex_state = 71},
  [2942] = {.lex_state = 13},
  [2943] = {.lex_state = 13},
  [2944] = {.lex_state = 13},
  [2945] = {.lex_state = 71},
  [2946] = {.lex_state = 71},
  [2947] = {.lex_state = 71, .external_lex_state = 5},
  [2948] = {.lex_state = 71},
  [2949] = {.lex_state = 7},
  [2950] = {.lex_state = 71},
  [2951] = {.lex_state = 71, .external_lex_state = 5},
  [2952] = {.lex_state = 0, .external_lex_state = 4},
  [2953] = {.lex_state = 0, .external_lex_state = 4},
  [2954] = {.lex_state = 71},
  [2955] = {.lex_state = 0, .external_lex_state = 4},
  [2956] = {.lex_state = 71},
  [2957] = {.lex_state = 71},
  [2958] = {.lex_state = 71, .external_lex_state = 5},
  [2959] = {.lex_state = 7},
  [2960] = {.lex_state = 71},
  [2961] = {.lex_state = 71},
  [2962] = {.lex_state = 0, .external_lex_state = 4},
  [2963] = {.lex_state = 71, .external_lex_state = 4},
  [2964] = {.lex_state = 71},
  [2965] = {.lex_state = 71},
  [2966] = {.lex_state = 71},
  [2967] = {.lex_state = 71, .external_lex_state = 5},
  [2968] = {.lex_state = 71},
  [2969] = {.lex_state = 71},
  [2970] = {.lex_state = 71},
  [2971] = {.lex_state = 71, .external_lex_state = 4},
  [2972] = {.lex_state = 71},
  [2973] = {.lex_state = 71},
  [2974] = {.lex_state = 71},
  [2975] = {.lex_state = 71},
  [2976] = {.lex_state = 71, .external_lex_state = 5},
  [2977] = {.lex_state = 71},
  [2978] = {.lex_state = 71},
  [2979] = {.lex_state = 71},
  [2980] = {.lex_state = 13, .external_lex_state = 6},
  [2981] = {.lex_state = 0, .external_lex_state = 4},
  [2982] = {.lex_state = 0, .external_lex_state = 4},
  [2983] = {.lex_state = 0, .external_lex_state = 4},
  [2984] = {.lex_state = 0, .external_lex_state = 4},
  [2985] = {.lex_state = 71, .external_lex_state = 5},
  [2986] = {.lex_state = 71},
  [2987] = {.lex_state = 0},
  [2988] = {.lex_state = 71, .external_lex_state = 5},
  [2989] = {.lex_state = 0},
  [2990] = {.lex_state = 71},
  [2991] = {.lex_state = 71},
  [2992] = {.lex_state = 71},
  [2993] = {.lex_state = 0, .external_lex_state = 4},
  [2994] = {.lex_state = 0},
  [2995] = {.lex_state = 0},
  [2996] = {.lex_state = 71},
  [2997] = {.lex_state = 0},
  [2998] = {.lex_state = 7},
  [2999] = {.lex_state = 71},
  [3000] = {.lex_state = 0, .external_lex_state = 4},
  [3001] = {.lex_state = 71, .external_lex_state = 4},
  [3002] = {.lex_state = 0, .external_lex_state = 4},
  [3003] = {.lex_state = 0, .external_lex_state = 4},
  [3004] = {.lex_state = 0, .external_lex_state = 4},
  [3005] = {.lex_state = 0},
  [3006] = {.lex_state = 71},
  [3007] = {.lex_state = 71},
  [3008] = {.lex_state = 71, .external_lex_state = 5},
  [3009] = {.lex_state = 0, .external_lex_state = 4},
  [3010] = {.lex_state = 0, .external_lex_state = 4},
  [3011] = {.lex_state = 0, .external_lex_state = 4},
  [3012] = {.lex_state = 71, .external_lex_state = 4},
  [3013] = {.lex_state = 71},
  [3014] = {.lex_state = 71},
  [3015] = {.lex_state = 71},
  [3016] = {.lex_state = 0, .external_lex_state = 4},
  [3017] = {.lex_state = 71, .external_lex_state = 4},
  [3018] = {.lex_state = 71, .external_lex_state = 5},
  [3019] = {.lex_state = 0, .external_lex_state = 4},
  [3020] = {.lex_state = 71, .external_lex_state = 5},
  [3021] = {.lex_state = 71},
  [3022] = {.lex_state = 71, .external_lex_state = 5},
  [3023] = {.lex_state = 0, .external_lex_state = 4},
  [3024] = {.lex_state = 71},
  [3025] = {.lex_state = 71},
  [3026] = {.lex_state = 0, .external_lex_state = 4},
  [3027] = {.lex_state = 0, .external_lex_state = 4},
  [3028] = {.lex_state = 0, .external_lex_state = 4},
  [3029] = {.lex_state = 0, .external_lex_state = 4},
  [3030] = {.lex_state = 71},
  [3031] = {.lex_state = 0},
  [3032] = {.lex_state = 71},
  [3033] = {.lex_state = 71},
  [3034] = {.lex_state = 0, .external_lex_state = 4},
  [3035] = {.lex_state = 71},
  [3036] = {.lex_state = 0, .external_lex_state = 4},
  [3037] = {.lex_state = 0, .external_lex_state = 4},
  [3038] = {.lex_state = 71},
  [3039] = {.lex_state = 0, .external_lex_state = 4},
  [3040] = {.lex_state = 0, .external_lex_state = 4},
  [3041] = {.lex_state = 0, .external_lex_state = 4},
  [3042] = {.lex_state = 0, .external_lex_state = 4},
  [3043] = {.lex_state = 13, .external_lex_state = 6},
  [3044] = {.lex_state = 0, .external_lex_state = 4},
  [3045] = {.lex_state = 0, .external_lex_state = 4},
  [3046] = {.lex_state = 0, .external_lex_state = 4},
  [3047] = {.lex_state = 71, .external_lex_state = 4},
  [3048] = {.lex_state = 0, .external_lex_state = 4},
  [3049] = {.lex_state = 0, .external_lex_state = 4},
  [3050] = {.lex_state = 2},
  [3051] = {.lex_state = 0, .external_lex_state = 4},
  [3052] = {.lex_state = 0, .external_lex_state = 4},
  [3053] = {.lex_state = 71},
  [3054] = {.lex_state = 0, .external_lex_state = 4},
  [3055] = {.lex_state = 0, .external_lex_state = 4},
  [3056] = {.lex_state = 71},
  [3057] = {.lex_state = 71},
  [3058] = {.lex_state = 0, .external_lex_state = 4},
  [3059] = {.lex_state = 71, .external_lex_state = 5},
  [3060] = {.lex_state = 71},
  [3061] = {.lex_state = 2},
  [3062] = {.lex_state = 71},
  [3063] = {.lex_state = 0, .external_lex_state = 4},
  [3064] = {.lex_state = 0, .external_lex_state = 4},
  [3065] = {.lex_state = 0, .external_lex_state = 4},
  [3066] = {.lex_state = 71},
  [3067] = {.lex_state = 71},
  [3068] = {.lex_state = 71, .external_lex_state = 4},
  [3069] = {.lex_state = 0, .external_lex_state = 4},
  [3070] = {.lex_state = 71},
  [3071] = {.lex_state = 0, .external_lex_state = 4},
  [3072] = {.lex_state = 0, .external_lex_state = 4},
  [3073] = {.lex_state = 0, .external_lex_state = 4},
  [3074] = {.lex_state = 71},
  [3075] = {.lex_state = 0, .external_lex_state = 4},
  [3076] = {.lex_state = 0, .external_lex_state = 4},
  [3077] = {.lex_state = 71},
  [3078] = {.lex_state = 0, .external_lex_state = 4},
  [3079] = {.lex_state = 71},
  [3080] = {.lex_state = 0, .external_lex_state = 4},
  [3081] = {.lex_state = 71},
  [3082] = {.lex_state = 0, .external_lex_state = 4},
  [3083] = {.lex_state = 0, .external_lex_state = 4},
  [3084] = {.lex_state = 0, .external_lex_state = 4},
  [3085] = {.lex_state = 71},
  [3086] = {.lex_state = 0, .external_lex_state = 4},
  [3087] = {.lex_state = 0, .external_lex_state = 4},
  [3088] = {.lex_state = 13, .external_lex_state = 6},
  [3089] = {.lex_state = 0, .external_lex_state = 4},
  [3090] = {.lex_state = 71},
  [3091] = {.lex_state = 0, .external_lex_state = 4},
  [3092] = {.lex_state = 0},
  [3093] = {.lex_state = 0, .external_lex_state = 4},
  [3094] = {.lex_state = 0, .external_lex_state = 4},
  [3095] = {.lex_state = 0, .external_lex_state = 4},
  [3096] = {.lex_state = 71},
  [3097] = {.lex_state = 71},
  [3098] = {.lex_state = 71},
  [3099] = {.lex_state = 71},
  [3100] = {.lex_state = 0, .external_lex_state = 4},
  [3101] = {.lex_state = 0, .external_lex_state = 4},
  [3102] = {.lex_state = 0, .external_lex_state = 4},
  [3103] = {.lex_state = 0},
  [3104] = {.lex_state = 0, .external_lex_state = 4},
  [3105] = {.lex_state = 0, .external_lex_state = 4},
  [3106] = {.lex_state = 0, .external_lex_state = 4},
  [3107] = {.lex_state = 71, .external_lex_state = 5},
  [3108] = {.lex_state = 13, .external_lex_state = 6},
  [3109] = {.lex_state = 0, .external_lex_state = 4},
  [3110] = {.lex_state = 0, .external_lex_state = 4},
  [3111] = {.lex_state = 71},
  [3112] = {.lex_state = 0, .external_lex_state = 4},
  [3113] = {.lex_state = 0, .external_lex_state = 4},
  [3114] = {.lex_state = 0, .external_lex_state = 4},
  [3115] = {.lex_state = 0, .external_lex_state = 4},
  [3116] = {.lex_state = 71},
  [3117] = {.lex_state = 0, .external_lex_state = 4},
  [3118] = {.lex_state = 0, .external_lex_state = 4},
  [3119] = {.lex_state = 71},
  [3120] = {.lex_state = 71},
  [3121] = {.lex_state = 71, .external_lex_state = 4},
  [3122] = {.lex_state = 0, .external_lex_state = 4},
  [3123] = {.lex_state = 13, .external_lex_state = 6},
  [3124] = {.lex_state = 0},
  [3125] = {.lex_state = 71, .external_lex_state = 5},
  [3126] = {.lex_state = 71},
  [3127] = {.lex_state = 0, .external_lex_state = 4},
  [3128] = {.lex_state = 0, .external_lex_state = 4},
  [3129] = {.lex_state = 0, .external_lex_state = 4},
  [3130] = {.lex_state = 71},
  [3131] = {.lex_state = 71},
  [3132] = {.lex_state = 0, .external_lex_state = 4},
  [3133] = {.lex_state = 71},
  [3134] = {.lex_state = 71},
  [3135] = {.lex_state = 0, .external_lex_state = 4},
  [3136] = {.lex_state = 71},
  [3137] = {.lex_state = 0, .external_lex_state = 4},
  [3138] = {.lex_state = 0, .external_lex_state = 4},
  [3139] = {.lex_state = 71},
  [3140] = {.lex_state = 0, .external_lex_state = 4},
  [3141] = {.lex_state = 0},
  [3142] = {.lex_state = 0, .external_lex_state = 4},
  [3143] = {.lex_state = 71},
  [3144] = {.lex_state = 0, .external_lex_state = 4},
  [3145] = {.lex_state = 71},
  [3146] = {.lex_state = 13, .external_lex_state = 6},
  [3147] = {.lex_state = 0, .external_lex_state = 4},
  [3148] = {.lex_state = 71},
  [3149] = {.lex_state = 71},
  [3150] = {.lex_state = 71},
  [3151] = {.lex_state = 71},
  [3152] = {.lex_state = 71},
  [3153] = {.lex_state = 71},
  [3154] = {.lex_state = 0, .external_lex_state = 4},
  [3155] = {.lex_state = 0, .external_lex_state = 4},
  [3156] = {.lex_state = 0, .external_lex_state = 4},
  [3157] = {.lex_state = 0, .external_lex_state = 4},
  [3158] = {.lex_state = 71},
  [3159] = {.lex_state = 0, .external_lex_state = 4},
  [3160] = {.lex_state = 0, .external_lex_state = 4},
  [3161] = {.lex_state = 13, .external_lex_state = 6},
  [3162] = {.lex_state = 0, .external_lex_state = 4},
  [3163] = {.lex_state = 0, .external_lex_state = 4},
  [3164] = {.lex_state = 71},
  [3165] = {.lex_state = 71},
  [3166] = {.lex_state = 0, .external_lex_state = 4},
  [3167] = {.lex_state = 7},
  [3168] = {.lex_state = 71},
  [3169] = {.lex_state = 0},
  [3170] = {.lex_state = 0, .external_lex_state = 4},
  [3171] = {.lex_state = 0, .external_lex_state = 4},
  [3172] = {.lex_state = 13, .external_lex_state = 6},
  [3173] = {.lex_state = 71},
  [3174] = {.lex_state = 0},
  [3175] = {.lex_state = 0, .external_lex_state = 4},
  [3176] = {.lex_state = 71},
  [3177] = {.lex_state = 71, .external_lex_state = 4},
  [3178] = {.lex_state = 71, .external_lex_state = 4},
  [3179] = {.lex_state = 71},
  [3180] = {.lex_state = 0, .external_lex_state = 4},
  [3181] = {.lex_state = 71},
  [3182] = {.lex_state = 71, .external_lex_state = 5},
  [3183] = {.lex_state = 0, .external_lex_state = 4},
  [3184] = {.lex_state = 0, .external_lex_state = 4},
  [3185] = {.lex_state = 0, .external_lex_state = 4},
  [3186] = {.lex_state = 0, .external_lex_state = 4},
  [3187] = {.lex_state = 0, .external_lex_state = 4},
  [3188] = {.lex_state = 0, .external_lex_state = 4},
  [3189] = {.lex_state = 0, .external_lex_state = 4},
  [3190] = {.lex_state = 0, .external_lex_state = 4},
  [3191] = {.lex_state = 71},
  [3192] = {.lex_state = 71, .external_lex_state = 5},
  [3193] = {.lex_state = 0, .external_lex_state = 4},
  [3194] = {.lex_state = 13, .external_lex_state = 6},
  [3195] = {.lex_state = 0, .external_lex_state = 4},
  [3196] = {.lex_state = 0, .external_lex_state = 4},
  [3197] = {.lex_state = 0, .external_lex_state = 4},
  [3198] = {.lex_state = 0},
  [3199] = {.lex_state = 71},
  [3200] = {.lex_state = 71},
  [3201] = {.lex_state = 71},
  [3202] = {.lex_state = 71},
  [3203] = {.lex_state = 0, .external_lex_state = 4},
  [3204] = {.lex_state = 71},
  [3205] = {.lex_state = 71},
  [3206] = {.lex_state = 71},
  [3207] = {.lex_state = 71},
  [3208] = {.lex_state = 0, .external_lex_state = 4},
  [3209] = {.lex_state = 71},
  [3210] = {.lex_state = 71},
  [3211] = {.lex_state = 71, .external_lex_state = 5},
  [3212] = {.lex_state = 0, .external_lex_state = 4},
  [3213] = {.lex_state = 13, .external_lex_state = 6},
  [3214] = {.lex_state = 71, .external_lex_state = 5},
  [3215] = {.lex_state = 0, .external_lex_state = 4},
  [3216] = {.lex_state = 71},
  [3217] = {.lex_state = 71},
  [3218] = {.lex_state = 13, .external_lex_state = 6},
  [3219] = {.lex_state = 0, .external_lex_state = 4},
  [3220] = {.lex_state = 71},
  [3221] = {.lex_state = 0, .external_lex_state = 4},
  [3222] = {.lex_state = 0, .external_lex_state = 4},
  [3223] = {.lex_state = 0, .external_lex_state = 4},
  [3224] = {.lex_state = 0, .external_lex_state = 4},
  [3225] = {.lex_state = 0, .external_lex_state = 4},
  [3226] = {.lex_state = 0, .external_lex_state = 4},
  [3227] = {.lex_state = 0, .external_lex_state = 4},
  [3228] = {.lex_state = 71},
  [3229] = {.lex_state = 0, .external_lex_state = 4},
  [3230] = {.lex_state = 0, .external_lex_state = 4},
  [3231] = {.lex_state = 0, .external_lex_state = 4},
  [3232] = {.lex_state = 13, .external_lex_state = 6},
  [3233] = {.lex_state = 71},
  [3234] = {.lex_state = 71},
  [3235] = {.lex_state = 0, .external_lex_state = 4},
  [3236] = {.lex_state = 0, .external_lex_state = 4},
  [3237] = {.lex_state = 0, .external_lex_state = 4},
  [3238] = {.lex_state = 0, .external_lex_state = 4},
  [3239] = {.lex_state = 0, .external_lex_state = 4},
  [3240] = {.lex_state = 0, .external_lex_state = 4},
  [3241] = {.lex_state = 71},
  [3242] = {.lex_state = 71},
  [3243] = {.lex_state = 0, .external_lex_state = 4},
  [3244] = {.lex_state = 71},
  [3245] = {.lex_state = 71},
  [3246] = {.lex_state = 0, .external_lex_state = 4},
  [3247] = {.lex_state = 71},
  [3248] = {.lex_state = 0, .external_lex_state = 4},
  [3249] = {.lex_state = 71},
  [3250] = {.lex_state = 0, .external_lex_state = 4},
  [3251] = {.lex_state = 71},
  [3252] = {.lex_state = 0, .external_lex_state = 4},
  [3253] = {.lex_state = 71, .external_lex_state = 5},
  [3254] = {.lex_state = 12},
  [3255] = {.lex_state = 15},
  [3256] = {.lex_state = 71},
  [3257] = {.lex_state = 71},
  [3258] = {.lex_state = 71},
  [3259] = {.lex_state = 71},
  [3260] = {.lex_state = 71},
  [3261] = {.lex_state = 71},
  [3262] = {.lex_state = 71},
  [3263] = {.lex_state = 71},
  [3264] = {.lex_state = 71},
  [3265] = {.lex_state = 71},
  [3266] = {.lex_state = 71},
  [3267] = {.lex_state = 12},
  [3268] = {.lex_state = 15},
  [3269] = {.lex_state = 71},
  [3270] = {.lex_state = 71},
  [3271] = {.lex_state = 0},
  [3272] = {.lex_state = 12},
  [3273] = {.lex_state = 15},
  [3274] = {.lex_state = 71},
  [3275] = {.lex_state = 0},
  [3276] = {.lex_state = 0},
  [3277] = {.lex_state = 71, .external_lex_state = 4},
  [3278] = {.lex_state = 71},
  [3279] = {.lex_state = 0},
  [3280] = {.lex_state = 0, .external_lex_state = 4},
  [3281] = {.lex_state = 0, .external_lex_state = 4},
  [3282] = {.lex_state = 0, .external_lex_state = 4},
  [3283] = {.lex_state = 0, .external_lex_state = 4},
  [3284] = {.lex_state = 0, .external_lex_state = 4},
  [3285] = {.lex_state = 0},
  [3286] = {.lex_state = 0},
  [3287] = {.lex_state = 71},
  [3288] = {.lex_state = 71},
  [3289] = {.lex_state = 12},
  [3290] = {.lex_state = 15},
  [3291] = {.lex_state = 71},
  [3292] = {.lex_state = 71},
  [3293] = {.lex_state = 71},
  [3294] = {.lex_state = 12},
  [3295] = {.lex_state = 15},
  [3296] = {.lex_state = 71},
  [3297] = {.lex_state = 71},
  [3298] = {.lex_state = 0},
  [3299] = {.lex_state = 71},
  [3300] = {.lex_state = 0, .external_lex_state = 5},
  [3301] = {.lex_state = 71},
  [3302] = {.lex_state = 0, .external_lex_state = 4},
  [3303] = {.lex_state = 71},
  [3304] = {.lex_state = 0},
  [3305] = {.lex_state = 0, .external_lex_state = 4},
  [3306] = {.lex_state = 71},
  [3307] = {.lex_state = 71},
  [3308] = {.lex_state = 71},
  [3309] = {.lex_state = 71},
  [3310] = {.lex_state = 12},
  [3311] = {.lex_state = 71},
  [3312] = {.lex_state = 13, .external_lex_state = 6},
  [3313] = {.lex_state = 15},
  [3314] = {.lex_state = 15},
  [3315] = {.lex_state = 12},
  [3316] = {.lex_state = 15},
  [3317] = {.lex_state = 12},
  [3318] = {.lex_state = 71},
  [3319] = {.lex_state = 15},
  [3320] = {.lex_state = 0},
  [3321] = {.lex_state = 0, .external_lex_state = 4},
  [3322] = {.lex_state = 71},
  [3323] = {.lex_state = 71},
  [3324] = {.lex_state = 15},
  [3325] = {.lex_state = 12},
  [3326] = {.lex_state = 15},
  [3327] = {.lex_state = 12},
  [3328] = {.lex_state = 71},
  [3329] = {.lex_state = 71},
  [3330] = {.lex_state = 71},
  [3331] = {.lex_state = 71},
  [3332] = {.lex_state = 15},
  [3333] = {.lex_state = 12},
  [3334] = {.lex_state = 0},
  [3335] = {.lex_state = 0},
  [3336] = {.lex_state = 71},
  [3337] = {.lex_state = 0, .external_lex_state = 4},
  [3338] = {.lex_state = 71},
  [3339] = {.lex_state = 71},
  [3340] = {.lex_state = 12},
  [3341] = {.lex_state = 71},
  [3342] = {.lex_state = 0},
  [3343] = {.lex_state = 0},
  [3344] = {.lex_state = 71},
  [3345] = {.lex_state = 71, .external_lex_state = 4},
  [3346] = {.lex_state = 71},
  [3347] = {.lex_state = 15},
  [3348] = {.lex_state = 13, .external_lex_state = 6},
  [3349] = {.lex_state = 71},
  [3350] = {.lex_state = 71},
  [3351] = {.lex_state = 71},
  [3352] = {.lex_state = 71},
  [3353] = {.lex_state = 71},
  [3354] = {.lex_state = 15},
  [3355] = {.lex_state = 12},
  [3356] = {.lex_state = 71},
  [3357] = {.lex_state = 12},
  [3358] = {.lex_state = 0},
  [3359] = {.lex_state = 0},
  [3360] = {.lex_state = 71},
  [3361] = {.lex_state = 15},
  [3362] = {.lex_state = 71},
  [3363] = {.lex_state = 71},
  [3364] = {.lex_state = 71},
  [3365] = {.lex_state = 12},
  [3366] = {.lex_state = 0},
  [3367] = {.lex_state = 0, .external_lex_state = 4},
  [3368] = {.lex_state = 0},
  [3369] = {.lex_state = 2},
  [3370] = {.lex_state = 71},
  [3371] = {.lex_state = 0},
  [3372] = {.lex_state = 71},
  [3373] = {.lex_state = 0},
  [3374] = {.lex_state = 0, .external_lex_state = 4},
  [3375] = {.lex_state = 0},
  [3376] = {.lex_state = 0},
  [3377] = {.lex_state = 71},
  [3378] = {.lex_state = 0},
  [3379] = {.lex_state = 0},
  [3380] = {.lex_state = 71},
  [3381] = {.lex_state = 0, .external_lex_state = 4},
  [3382] = {.lex_state = 0, .external_lex_state = 4},
  [3383] = {.lex_state = 0, .external_lex_state = 4},
  [3384] = {.lex_state = 0, .external_lex_state = 4},
  [3385] = {.lex_state = 0, .external_lex_state = 4},
  [3386] = {.lex_state = 0, .external_lex_state = 4},
  [3387] = {.lex_state = 71},
  [3388] = {.lex_state = 71},
  [3389] = {.lex_state = 71},
  [3390] = {.lex_state = 0, .external_lex_state = 4},
  [3391] = {.lex_state = 0},
  [3392] = {.lex_state = 0},
  [3393] = {.lex_state = 0},
  [3394] = {.lex_state = 71},
  [3395] = {.lex_state = 71},
  [3396] = {.lex_state = 13, .external_lex_state = 6},
  [3397] = {.lex_state = 71},
  [3398] = {.lex_state = 0, .external_lex_state = 4},
  [3399] = {.lex_state = 71},
  [3400] = {.lex_state = 0},
  [3401] = {.lex_state = 0},
  [3402] = {.lex_state = 0, .external_lex_state = 4},
  [3403] = {.lex_state = 0},
  [3404] = {.lex_state = 0},
  [3405] = {.lex_state = 0},
  [3406] = {.lex_state = 71},
  [3407] = {.lex_state = 0, .external_lex_state = 4},
  [3408] = {.lex_state = 0, .external_lex_state = 4},
  [3409] = {.lex_state = 71},
  [3410] = {.lex_state = 71},
  [3411] = {.lex_state = 0, .external_lex_state = 4},
  [3412] = {.lex_state = 71},
  [3413] = {.lex_state = 71},
  [3414] = {.lex_state = 71},
  [3415] = {.lex_state = 0},
  [3416] = {.lex_state = 71},
  [3417] = {.lex_state = 71},
  [3418] = {.lex_state = 0},
  [3419] = {.lex_state = 0},
  [3420] = {.lex_state = 0, .external_lex_state = 4},
  [3421] = {.lex_state = 0},
  [3422] = {.lex_state = 0},
  [3423] = {.lex_state = 71},
  [3424] = {.lex_state = 0},
  [3425] = {.lex_state = 0},
  [3426] = {.lex_state = 71},
  [3427] = {.lex_state = 0},
  [3428] = {.lex_state = 0},
  [3429] = {.lex_state = 71},
  [3430] = {.lex_state = 0},
  [3431] = {.lex_state = 0},
  [3432] = {.lex_state = 71},
  [3433] = {.lex_state = 0},
  [3434] = {.lex_state = 71},
  [3435] = {.lex_state = 0, .external_lex_state = 4},
  [3436] = {.lex_state = 71},
  [3437] = {.lex_state = 0},
  [3438] = {.lex_state = 0},
  [3439] = {.lex_state = 0, .external_lex_state = 4},
  [3440] = {.lex_state = 0},
  [3441] = {.lex_state = 0},
  [3442] = {.lex_state = 0},
  [3443] = {.lex_state = 0},
  [3444] = {.lex_state = 71},
  [3445] = {.lex_state = 0},
  [3446] = {.lex_state = 71},
  [3447] = {.lex_state = 71},
  [3448] = {.lex_state = 0},
  [3449] = {.lex_state = 0},
  [3450] = {.lex_state = 0, .external_lex_state = 4},
  [3451] = {.lex_state = 71},
  [3452] = {.lex_state = 71},
  [3453] = {.lex_state = 71},
  [3454] = {.lex_state = 71},
  [3455] = {.lex_state = 71},
  [3456] = {.lex_state = 0},
  [3457] = {.lex_state = 71},
  [3458] = {.lex_state = 0, .external_lex_state = 4},
  [3459] = {.lex_state = 71},
  [3460] = {.lex_state = 0, .external_lex_state = 4},
  [3461] = {.lex_state = 0},
  [3462] = {.lex_state = 71},
  [3463] = {.lex_state = 71},
  [3464] = {.lex_state = 0, .external_lex_state = 4},
  [3465] = {.lex_state = 0},
  [3466] = {.lex_state = 0, .external_lex_state = 4},
  [3467] = {.lex_state = 71},
  [3468] = {.lex_state = 0},
  [3469] = {.lex_state = 0},
  [3470] = {.lex_state = 0},
  [3471] = {.lex_state = 0, .external_lex_state = 4},
  [3472] = {.lex_state = 0},
  [3473] = {.lex_state = 71},
  [3474] = {.lex_state = 0, .external_lex_state = 4},
  [3475] = {.lex_state = 0},
  [3476] = {.lex_state = 0, .external_lex_state = 4},
  [3477] = {.lex_state = 0},
  [3478] = {.lex_state = 71},
  [3479] = {.lex_state = 0},
  [3480] = {.lex_state = 71},
  [3481] = {.lex_state = 0},
  [3482] = {.lex_state = 0},
  [3483] = {.lex_state = 0},
  [3484] = {.lex_state = 0},
  [3485] = {.lex_state = 0, .external_lex_state = 4},
  [3486] = {.lex_state = 0},
  [3487] = {.lex_state = 0, .external_lex_state = 4},
  [3488] = {.lex_state = 0},
  [3489] = {.lex_state = 0},
  [3490] = {.lex_state = 0},
  [3491] = {.lex_state = 0},
  [3492] = {.lex_state = 0},
  [3493] = {.lex_state = 0, .external_lex_state = 4},
  [3494] = {.lex_state = 71},
  [3495] = {.lex_state = 71},
  [3496] = {.lex_state = 0},
  [3497] = {.lex_state = 0},
  [3498] = {.lex_state = 71},
  [3499] = {.lex_state = 0},
  [3500] = {.lex_state = 71},
  [3501] = {.lex_state = 0, .external_lex_state = 4},
  [3502] = {.lex_state = 0, .external_lex_state = 4},
  [3503] = {.lex_state = 71},
  [3504] = {.lex_state = 0},
  [3505] = {.lex_state = 0, .external_lex_state = 4},
  [3506] = {.lex_state = 0},
  [3507] = {.lex_state = 71},
  [3508] = {.lex_state = 0},
  [3509] = {.lex_state = 0},
  [3510] = {.lex_state = 71},
  [3511] = {.lex_state = 71},
  [3512] = {.lex_state = 0},
  [3513] = {.lex_state = 71},
  [3514] = {.lex_state = 0, .external_lex_state = 4},
  [3515] = {.lex_state = 0, .external_lex_state = 4},
  [3516] = {.lex_state = 71},
  [3517] = {.lex_state = 0},
  [3518] = {.lex_state = 0},
  [3519] = {.lex_state = 0},
  [3520] = {.lex_state = 0},
  [3521] = {.lex_state = 71},
  [3522] = {.lex_state = 0},
  [3523] = {.lex_state = 0},
  [3524] = {.lex_state = 71},
  [3525] = {.lex_state = 71},
  [3526] = {.lex_state = 0},
  [3527] = {.lex_state = 0},
  [3528] = {.lex_state = 0, .external_lex_state = 4},
  [3529] = {.lex_state = 2},
  [3530] = {.lex_state = 71},
  [3531] = {.lex_state = 71},
  [3532] = {.lex_state = 0},
  [3533] = {.lex_state = 71},
  [3534] = {.lex_state = 0},
  [3535] = {.lex_state = 71},
  [3536] = {.lex_state = 71},
  [3537] = {.lex_state = 71, .external_lex_state = 4},
  [3538] = {.lex_state = 71, .external_lex_state = 4},
  [3539] = {.lex_state = 71},
  [3540] = {.lex_state = 71},
  [3541] = {.lex_state = 0, .external_lex_state = 4},
  [3542] = {.lex_state = 71},
  [3543] = {.lex_state = 0, .external_lex_state = 4},
  [3544] = {.lex_state = 0, .external_lex_state = 4},
  [3545] = {.lex_state = 0, .external_lex_state = 4},
  [3546] = {.lex_state = 0, .external_lex_state = 4},
  [3547] = {.lex_state = 71},
  [3548] = {.lex_state = 0},
  [3549] = {.lex_state = 0},
  [3550] = {.lex_state = 0},
  [3551] = {.lex_state = 0},
  [3552] = {.lex_state = 0},
  [3553] = {.lex_state = 0},
  [3554] = {.lex_state = 71},
  [3555] = {.lex_state = 0},
  [3556] = {.lex_state = 0},
  [3557] = {.lex_state = 71},
  [3558] = {.lex_state = 0},
  [3559] = {.lex_state = 0},
  [3560] = {.lex_state = 0, .external_lex_state = 4},
  [3561] = {.lex_state = 0, .external_lex_state = 4},
  [3562] = {.lex_state = 0},
  [3563] = {.lex_state = 2},
  [3564] = {.lex_state = 0, .external_lex_state = 4},
  [3565] = {.lex_state = 0},
  [3566] = {.lex_state = 0},
  [3567] = {.lex_state = 0, .external_lex_state = 4},
  [3568] = {.lex_state = 0},
  [3569] = {.lex_state = 0},
  [3570] = {.lex_state = 0},
  [3571] = {.lex_state = 71},
  [3572] = {.lex_state = 0, .external_lex_state = 4},
  [3573] = {.lex_state = 0, .external_lex_state = 4},
  [3574] = {.lex_state = 0},
  [3575] = {.lex_state = 0},
  [3576] = {.lex_state = 0, .external_lex_state = 4},
  [3577] = {.lex_state = 0, .external_lex_state = 4},
  [3578] = {.lex_state = 0},
  [3579] = {.lex_state = 0},
  [3580] = {.lex_state = 71},
  [3581] = {.lex_state = 71},
  [3582] = {.lex_state = 71},
  [3583] = {.lex_state = 71},
  [3584] = {.lex_state = 71},
  [3585] = {.lex_state = 71},
  [3586] = {.lex_state = 0},
  [3587] = {.lex_state = 0},
  [3588] = {.lex_state = 0},
  [3589] = {.lex_state = 0},
  [3590] = {.lex_state = 0, .external_lex_state = 4},
  [3591] = {.lex_state = 0, .external_lex_state = 4},
  [3592] = {.lex_state = 0, .external_lex_state = 4},
  [3593] = {.lex_state = 0, .external_lex_state = 4},
  [3594] = {.lex_state = 0, .external_lex_state = 4},
  [3595] = {.lex_state = 0, .external_lex_state = 4},
  [3596] = {.lex_state = 71},
  [3597] = {.lex_state = 0, .external_lex_state = 4},
  [3598] = {.lex_state = 0},
  [3599] = {.lex_state = 0, .external_lex_state = 4},
  [3600] = {.lex_state = 0},
  [3601] = {.lex_state = 0, .external_lex_state = 4},
  [3602] = {.lex_state = 0},
  [3603] = {.lex_state = 0},
  [3604] = {.lex_state = 71},
  [3605] = {.lex_state = 0},
  [3606] = {.lex_state = 0},
  [3607] = {.lex_state = 71},
  [3608] = {.lex_state = 0},
  [3609] = {.lex_state = 71},
  [3610] = {.lex_state = 0},
  [3611] = {.lex_state = 0},
  [3612] = {.lex_state = 0},
  [3613] = {.lex_state = 71},
  [3614] = {.lex_state = 71},
  [3615] = {.lex_state = 0},
  [3616] = {.lex_state = 71},
  [3617] = {.lex_state = 0},
  [3618] = {.lex_state = 71},
  [3619] = {.lex_state = 0, .external_lex_state = 4},
  [3620] = {.lex_state = 0, .external_lex_state = 4},
  [3621] = {.lex_state = 0},
  [3622] = {.lex_state = 71},
  [3623] = {.lex_state = 0},
  [3624] = {.lex_state = 0},
  [3625] = {.lex_state = 0},
  [3626] = {.lex_state = 0},
  [3627] = {.lex_state = 0},
  [3628] = {.lex_state = 71},
  [3629] = {.lex_state = 71},
  [3630] = {.lex_state = 0, .external_lex_state = 4},
  [3631] = {.lex_state = 71},
  [3632] = {.lex_state = 71},
  [3633] = {.lex_state = 71},
  [3634] = {.lex_state = 71},
  [3635] = {.lex_state = 0},
  [3636] = {.lex_state = 71},
  [3637] = {.lex_state = 0},
  [3638] = {.lex_state = 0},
  [3639] = {.lex_state = 0},
  [3640] = {.lex_state = 71},
  [3641] = {.lex_state = 71},
  [3642] = {.lex_state = 0, .external_lex_state = 4},
  [3643] = {.lex_state = 0},
  [3644] = {.lex_state = 0},
  [3645] = {.lex_state = 71},
  [3646] = {.lex_state = 71},
  [3647] = {.lex_state = 0},
  [3648] = {.lex_state = 0},
  [3649] = {.lex_state = 0, .external_lex_state = 4},
  [3650] = {.lex_state = 71},
  [3651] = {.lex_state = 71},
  [3652] = {.lex_state = 0},
  [3653] = {.lex_state = 71},
  [3654] = {.lex_state = 71},
  [3655] = {.lex_state = 0},
  [3656] = {.lex_state = 0},
  [3657] = {.lex_state = 0},
  [3658] = {.lex_state = 0},
  [3659] = {.lex_state = 0},
  [3660] = {.lex_state = 71},
  [3661] = {.lex_state = 0},
  [3662] = {.lex_state = 71},
  [3663] = {.lex_state = 0},
  [3664] = {.lex_state = 0},
  [3665] = {.lex_state = 71},
  [3666] = {.lex_state = 0},
  [3667] = {.lex_state = 71},
  [3668] = {.lex_state = 71},
  [3669] = {.lex_state = 71},
  [3670] = {.lex_state = 71},
  [3671] = {.lex_state = 71},
  [3672] = {.lex_state = 0},
  [3673] = {.lex_state = 71},
  [3674] = {.lex_state = 71},
  [3675] = {.lex_state = 71},
  [3676] = {.lex_state = 71},
  [3677] = {.lex_state = 71},
  [3678] = {.lex_state = 0},
  [3679] = {.lex_state = 0},
  [3680] = {.lex_state = 71},
  [3681] = {.lex_state = 0, .external_lex_state = 4},
  [3682] = {.lex_state = 0, .external_lex_state = 4},
  [3683] = {.lex_state = 0},
  [3684] = {.lex_state = 71},
  [3685] = {.lex_state = 0, .external_lex_state = 4},
  [3686] = {.lex_state = 0},
  [3687] = {.lex_state = 71},
  [3688] = {.lex_state = 71},
  [3689] = {.lex_state = 71},
  [3690] = {.lex_state = 71},
  [3691] = {.lex_state = 71},
  [3692] = {.lex_state = 71},
  [3693] = {.lex_state = 71},
  [3694] = {.lex_state = 71},
  [3695] = {.lex_state = 71},
  [3696] = {.lex_state = 71},
  [3697] = {.lex_state = 71},
  [3698] = {.lex_state = 0, .external_lex_state = 4},
  [3699] = {.lex_state = 0, .external_lex_state = 4},
  [3700] = {.lex_state = 0, .external_lex_state = 4},
  [3701] = {.lex_state = 71},
  [3702] = {.lex_state = 71},
  [3703] = {.lex_state = 0},
  [3704] = {.lex_state = 0, .external_lex_state = 4},
  [3705] = {.lex_state = 71},
  [3706] = {.lex_state = 0},
  [3707] = {.lex_state = 71},
  [3708] = {.lex_state = 71},
  [3709] = {.lex_state = 71},
  [3710] = {.lex_state = 71},
  [3711] = {.lex_state = 71},
  [3712] = {.lex_state = 0},
  [3713] = {.lex_state = 71},
  [3714] = {.lex_state = 71},
  [3715] = {.lex_state = 71},
  [3716] = {.lex_state = 0, .external_lex_state = 4},
  [3717] = {.lex_state = 0, .external_lex_state = 4},
  [3718] = {.lex_state = 0},
  [3719] = {.lex_state = 71},
  [3720] = {.lex_state = 71},
  [3721] = {.lex_state = 71},
  [3722] = {.lex_state = 71},
  [3723] = {.lex_state = 0, .external_lex_state = 4},
  [3724] = {.lex_state = 71},
  [3725] = {.lex_state = 71},
  [3726] = {.lex_state = 71},
  [3727] = {.lex_state = 0, .external_lex_state = 4},
  [3728] = {.lex_state = 71},
  [3729] = {.lex_state = 71},
  [3730] = {.lex_state = 0},
  [3731] = {.lex_state = 71},
  [3732] = {.lex_state = 71},
  [3733] = {.lex_state = 71},
  [3734] = {.lex_state = 0},
  [3735] = {.lex_state = 71},
  [3736] = {.lex_state = 71},
  [3737] = {.lex_state = 0},
  [3738] = {.lex_state = 71},
  [3739] = {.lex_state = 71},
  [3740] = {.lex_state = 0},
  [3741] = {.lex_state = 71},
  [3742] = {.lex_state = 0},
  [3743] = {.lex_state = 0},
  [3744] = {.lex_state = 0},
  [3745] = {.lex_state = 0},
  [3746] = {.lex_state = 0},
  [3747] = {.lex_state = 0},
  [3748] = {.lex_state = 71},
  [3749] = {.lex_state = 0},
  [3750] = {.lex_state = 0},
  [3751] = {.lex_state = 71},
  [3752] = {.lex_state = 0},
  [3753] = {.lex_state = 0},
  [3754] = {.lex_state = 71},
  [3755] = {.lex_state = 71},
  [3756] = {.lex_state = 71},
  [3757] = {.lex_state = 71},
  [3758] = {.lex_state = 0, .external_lex_state = 4},
  [3759] = {.lex_state = 71},
  [3760] = {.lex_state = 71},
  [3761] = {.lex_state = 0},
  [3762] = {.lex_state = 71},
  [3763] = {.lex_state = 71},
  [3764] = {.lex_state = 71},
  [3765] = {.lex_state = 71},
  [3766] = {.lex_state = 71},
  [3767] = {.lex_state = 71},
  [3768] = {.lex_state = 71},
  [3769] = {.lex_state = 0},
  [3770] = {.lex_state = 71},
  [3771] = {.lex_state = 71},
  [3772] = {.lex_state = 71},
  [3773] = {.lex_state = 0, .external_lex_state = 4},
  [3774] = {.lex_state = 0},
  [3775] = {.lex_state = 71},
  [3776] = {.lex_state = 71},
  [3777] = {.lex_state = 71},
  [3778] = {.lex_state = 71},
  [3779] = {.lex_state = 71},
  [3780] = {.lex_state = 71},
  [3781] = {.lex_state = 0},
  [3782] = {.lex_state = 71},
  [3783] = {.lex_state = 71},
  [3784] = {.lex_state = 71},
  [3785] = {.lex_state = 71},
  [3786] = {.lex_state = 71},
  [3787] = {.lex_state = 71},
  [3788] = {.lex_state = 71},
  [3789] = {.lex_state = 0},
  [3790] = {.lex_state = 71},
  [3791] = {.lex_state = 0},
  [3792] = {.lex_state = 71},
  [3793] = {.lex_state = 71},
  [3794] = {.lex_state = 71},
  [3795] = {.lex_state = 71},
  [3796] = {.lex_state = 71},
  [3797] = {.lex_state = 0, .external_lex_state = 4},
  [3798] = {.lex_state = 0},
  [3799] = {.lex_state = 71},
  [3800] = {.lex_state = 71},
  [3801] = {.lex_state = 0, .external_lex_state = 4},
  [3802] = {.lex_state = 0},
  [3803] = {.lex_state = 71},
  [3804] = {.lex_state = 0},
  [3805] = {.lex_state = 0, .external_lex_state = 4},
  [3806] = {.lex_state = 71},
  [3807] = {.lex_state = 0, .external_lex_state = 4},
  [3808] = {.lex_state = 0},
  [3809] = {.lex_state = 71},
  [3810] = {.lex_state = 71},
  [3811] = {.lex_state = 0},
  [3812] = {.lex_state = 71},
  [3813] = {.lex_state = 0},
  [3814] = {.lex_state = 71},
  [3815] = {.lex_state = 0},
  [3816] = {.lex_state = 71},
  [3817] = {.lex_state = 0},
  [3818] = {.lex_state = 71},
  [3819] = {.lex_state = 0},
  [3820] = {.lex_state = 71},
  [3821] = {.lex_state = 71},
  [3822] = {.lex_state = 71},
  [3823] = {.lex_state = 71},
  [3824] = {.lex_state = 71},
  [3825] = {.lex_state = 0},
  [3826] = {.lex_state = 71},
  [3827] = {.lex_state = 0},
  [3828] = {.lex_state = 0},
  [3829] = {.lex_state = 71},
  [3830] = {.lex_state = 71},
  [3831] = {.lex_state = 71},
  [3832] = {.lex_state = 71},
  [3833] = {.lex_state = 71},
  [3834] = {.lex_state = 71},
  [3835] = {.lex_state = 71},
  [3836] = {.lex_state = 71},
  [3837] = {.lex_state = 0},
  [3838] = {.lex_state = 0},
  [3839] = {.lex_state = 71},
  [3840] = {.lex_state = 71},
  [3841] = {.lex_state = 0},
  [3842] = {.lex_state = 71},
  [3843] = {.lex_state = 0},
  [3844] = {.lex_state = 0, .external_lex_state = 4},
  [3845] = {.lex_state = 71},
  [3846] = {.lex_state = 71},
  [3847] = {.lex_state = 0, .external_lex_state = 4},
  [3848] = {.lex_state = 0},
  [3849] = {.lex_state = 0},
  [3850] = {.lex_state = 0},
  [3851] = {.lex_state = 0},
  [3852] = {.lex_state = 0},
  [3853] = {.lex_state = 0},
  [3854] = {.lex_state = 0},
  [3855] = {.lex_state = 0},
  [3856] = {.lex_state = 0},
  [3857] = {.lex_state = 0},
  [3858] = {.lex_state = 0},
  [3859] = {.lex_state = 0},
  [3860] = {.lex_state = 71},
  [3861] = {.lex_state = 71},
  [3862] = {.lex_state = 0},
  [3863] = {.lex_state = 0},
  [3864] = {.lex_state = 0},
  [3865] = {.lex_state = 71},
  [3866] = {.lex_state = 71},
  [3867] = {.lex_state = 1},
  [3868] = {.lex_state = 0},
  [3869] = {.lex_state = 0},
  [3870] = {.lex_state = 0},
  [3871] = {.lex_state = 0},
  [3872] = {.lex_state = 0},
  [3873] = {.lex_state = 0},
  [3874] = {.lex_state = 0},
  [3875] = {.lex_state = 0},
  [3876] = {.lex_state = 0},
  [3877] = {.lex_state = 71},
  [3878] = {.lex_state = 0},
  [3879] = {.lex_state = 0},
  [3880] = {.lex_state = 0},
  [3881] = {.lex_state = 0},
  [3882] = {.lex_state = 0},
  [3883] = {.lex_state = 0},
  [3884] = {.lex_state = 71},
  [3885] = {.lex_state = 0},
  [3886] = {.lex_state = 0},
  [3887] = {.lex_state = 0},
  [3888] = {.lex_state = 0},
  [3889] = {.lex_state = 0},
  [3890] = {.lex_state = 0},
  [3891] = {.lex_state = 0},
  [3892] = {.lex_state = 0},
  [3893] = {.lex_state = 0},
  [3894] = {.lex_state = 0},
  [3895] = {.lex_state = 1},
  [3896] = {.lex_state = 71},
  [3897] = {.lex_state = 0},
  [3898] = {.lex_state = 0},
  [3899] = {.lex_state = 0},
  [3900] = {.lex_state = 9},
  [3901] = {.lex_state = 0},
  [3902] = {.lex_state = 71},
  [3903] = {.lex_state = 0},
  [3904] = {.lex_state = 0},
  [3905] = {.lex_state = 0},
  [3906] = {.lex_state = 0},
  [3907] = {.lex_state = 0},
  [3908] = {.lex_state = 0},
  [3909] = {.lex_state = 0},
  [3910] = {.lex_state = 0},
  [3911] = {.lex_state = 0},
  [3912] = {.lex_state = 71},
  [3913] = {.lex_state = 0},
  [3914] = {.lex_state = 0},
  [3915] = {.lex_state = 0},
  [3916] = {.lex_state = 0},
  [3917] = {.lex_state = 0},
  [3918] = {.lex_state = 0},
  [3919] = {.lex_state = 0},
  [3920] = {.lex_state = 9},
  [3921] = {.lex_state = 0},
  [3922] = {.lex_state = 0},
  [3923] = {.lex_state = 71},
  [3924] = {.lex_state = 0},
  [3925] = {.lex_state = 0},
  [3926] = {.lex_state = 0},
  [3927] = {.lex_state = 0},
  [3928] = {.lex_state = 0},
  [3929] = {.lex_state = 0},
  [3930] = {.lex_state = 0},
  [3931] = {.lex_state = 71},
  [3932] = {.lex_state = 0},
  [3933] = {.lex_state = 0},
  [3934] = {.lex_state = 0},
  [3935] = {.lex_state = 0},
  [3936] = {.lex_state = 71},
  [3937] = {.lex_state = 0},
  [3938] = {.lex_state = 0},
  [3939] = {.lex_state = 0},
  [3940] = {.lex_state = 0},
  [3941] = {.lex_state = 0},
  [3942] = {.lex_state = 0},
  [3943] = {.lex_state = 0},
  [3944] = {.lex_state = 0},
  [3945] = {.lex_state = 71},
  [3946] = {.lex_state = 0},
  [3947] = {.lex_state = 0},
  [3948] = {.lex_state = 0},
  [3949] = {.lex_state = 0},
  [3950] = {.lex_state = 0},
  [3951] = {.lex_state = 0},
  [3952] = {.lex_state = 0},
  [3953] = {.lex_state = 0},
  [3954] = {.lex_state = 71},
  [3955] = {.lex_state = 71},
  [3956] = {.lex_state = 0},
  [3957] = {.lex_state = 0},
  [3958] = {.lex_state = 0},
  [3959] = {.lex_state = 0},
  [3960] = {.lex_state = 0},
  [3961] = {.lex_state = 0},
  [3962] = {.lex_state = 71},
  [3963] = {.lex_state = 0},
  [3964] = {.lex_state = 0},
  [3965] = {.lex_state = 0},
  [3966] = {.lex_state = 0},
  [3967] = {.lex_state = 0},
  [3968] = {.lex_state = 71},
  [3969] = {.lex_state = 0},
  [3970] = {.lex_state = 0},
  [3971] = {.lex_state = 0},
  [3972] = {.lex_state = 0},
  [3973] = {.lex_state = 0},
  [3974] = {.lex_state = 71},
  [3975] = {.lex_state = 0},
  [3976] = {.lex_state = 0},
  [3977] = {.lex_state = 0},
  [3978] = {.lex_state = 0},
  [3979] = {.lex_state = 71},
  [3980] = {.lex_state = 0},
  [3981] = {.lex_state = 0},
  [3982] = {.lex_state = 0},
  [3983] = {.lex_state = 0},
  [3984] = {.lex_state = 71},
  [3985] = {.lex_state = 0},
  [3986] = {.lex_state = 0},
  [3987] = {.lex_state = 0},
  [3988] = {.lex_state = 0},
  [3989] = {.lex_state = 0},
  [3990] = {.lex_state = 0},
  [3991] = {.lex_state = 0},
  [3992] = {.lex_state = 0},
  [3993] = {.lex_state = 0},
  [3994] = {.lex_state = 0},
  [3995] = {.lex_state = 0},
  [3996] = {.lex_state = 71},
  [3997] = {.lex_state = 0},
  [3998] = {.lex_state = 71},
  [3999] = {.lex_state = 0},
  [4000] = {.lex_state = 0},
  [4001] = {.lex_state = 0},
  [4002] = {.lex_state = 71},
  [4003] = {.lex_state = 71},
  [4004] = {.lex_state = 71},
  [4005] = {.lex_state = 9},
  [4006] = {.lex_state = 0},
  [4007] = {.lex_state = 71},
  [4008] = {.lex_state = 0},
  [4009] = {.lex_state = 0},
  [4010] = {.lex_state = 0},
  [4011] = {.lex_state = 0},
  [4012] = {.lex_state = 71},
  [4013] = {.lex_state = 0},
  [4014] = {.lex_state = 9},
  [4015] = {.lex_state = 1},
  [4016] = {.lex_state = 0},
  [4017] = {.lex_state = 71},
  [4018] = {.lex_state = 0},
  [4019] = {.lex_state = 0},
  [4020] = {.lex_state = 0},
  [4021] = {.lex_state = 0},
  [4022] = {.lex_state = 0},
  [4023] = {.lex_state = 0},
  [4024] = {.lex_state = 71},
  [4025] = {.lex_state = 0},
  [4026] = {.lex_state = 0},
  [4027] = {.lex_state = 0},
  [4028] = {.lex_state = 71},
  [4029] = {.lex_state = 0},
  [4030] = {.lex_state = 71},
  [4031] = {.lex_state = 0},
  [4032] = {.lex_state = 71},
  [4033] = {.lex_state = 0},
  [4034] = {.lex_state = 0},
  [4035] = {.lex_state = 0},
  [4036] = {.lex_state = 0},
  [4037] = {.lex_state = 0},
  [4038] = {.lex_state = 0},
  [4039] = {.lex_state = 71},
  [4040] = {.lex_state = 71},
  [4041] = {.lex_state = 0},
  [4042] = {.lex_state = 0},
  [4043] = {.lex_state = 0},
  [4044] = {.lex_state = 0},
  [4045] = {.lex_state = 0},
  [4046] = {.lex_state = 0},
  [4047] = {.lex_state = 0},
  [4048] = {.lex_state = 0},
  [4049] = {.lex_state = 0},
  [4050] = {.lex_state = 0},
  [4051] = {.lex_state = 0},
  [4052] = {.lex_state = 0},
  [4053] = {.lex_state = 71},
  [4054] = {.lex_state = 0},
  [4055] = {.lex_state = 0},
  [4056] = {.lex_state = 1},
  [4057] = {.lex_state = 0},
  [4058] = {.lex_state = 71},
  [4059] = {.lex_state = 0},
  [4060] = {.lex_state = 71},
  [4061] = {.lex_state = 0},
  [4062] = {.lex_state = 0},
  [4063] = {.lex_state = 0},
  [4064] = {.lex_state = 0},
  [4065] = {.lex_state = 0},
  [4066] = {.lex_state = 71},
  [4067] = {.lex_state = 0},
  [4068] = {.lex_state = 0},
  [4069] = {.lex_state = 0},
  [4070] = {.lex_state = 0},
  [4071] = {.lex_state = 0},
  [4072] = {.lex_state = 71},
  [4073] = {.lex_state = 0},
  [4074] = {.lex_state = 71},
  [4075] = {.lex_state = 0},
  [4076] = {.lex_state = 0},
  [4077] = {.lex_state = 71},
  [4078] = {.lex_state = 71},
  [4079] = {.lex_state = 71},
  [4080] = {.lex_state = 0},
  [4081] = {.lex_state = 0},
  [4082] = {.lex_state = 0},
  [4083] = {.lex_state = 0},
  [4084] = {.lex_state = 71},
  [4085] = {.lex_state = 0},
  [4086] = {.lex_state = 0},
  [4087] = {.lex_state = 71},
  [4088] = {.lex_state = 71},
  [4089] = {.lex_state = 9},
  [4090] = {.lex_state = 0},
  [4091] = {.lex_state = 0},
  [4092] = {.lex_state = 0},
  [4093] = {.lex_state = 0},
  [4094] = {.lex_state = 71},
  [4095] = {.lex_state = 0},
  [4096] = {.lex_state = 71},
  [4097] = {.lex_state = 0},
  [4098] = {.lex_state = 0},
  [4099] = {.lex_state = 0},
  [4100] = {.lex_state = 0},
  [4101] = {.lex_state = 0},
  [4102] = {.lex_state = 0},
  [4103] = {.lex_state = 71},
  [4104] = {.lex_state = 0},
  [4105] = {.lex_state = 0},
  [4106] = {.lex_state = 0},
  [4107] = {.lex_state = 0},
  [4108] = {.lex_state = 0},
  [4109] = {.lex_state = 0},
  [4110] = {.lex_state = 0},
  [4111] = {.lex_state = 0},
  [4112] = {.lex_state = 71},
  [4113] = {.lex_state = 0},
  [4114] = {.lex_state = 1},
  [4115] = {.lex_state = 71},
  [4116] = {.lex_state = 0},
  [4117] = {.lex_state = 0},
  [4118] = {.lex_state = 0},
  [4119] = {.lex_state = 71},
  [4120] = {.lex_state = 0},
  [4121] = {.lex_state = 71},
  [4122] = {.lex_state = 0},
  [4123] = {.lex_state = 0},
  [4124] = {.lex_state = 0},
  [4125] = {.lex_state = 71},
  [4126] = {.lex_state = 71},
  [4127] = {.lex_state = 71},
  [4128] = {.lex_state = 0},
  [4129] = {.lex_state = 0},
  [4130] = {.lex_state = 71},
  [4131] = {.lex_state = 71},
  [4132] = {.lex_state = 71},
  [4133] = {.lex_state = 71},
  [4134] = {.lex_state = 71},
  [4135] = {.lex_state = 0},
  [4136] = {.lex_state = 71},
  [4137] = {.lex_state = 71},
  [4138] = {.lex_state = 71},
  [4139] = {.lex_state = 71},
  [4140] = {.lex_state = 71},
  [4141] = {.lex_state = 71},
  [4142] = {.lex_state = 0},
  [4143] = {.lex_state = 0},
  [4144] = {.lex_state = 0},
  [4145] = {.lex_state = 0},
  [4146] = {.lex_state = 0},
  [4147] = {.lex_state = 0},
  [4148] = {.lex_state = 71},
  [4149] = {.lex_state = 0},
  [4150] = {.lex_state = 0},
  [4151] = {.lex_state = 0},
  [4152] = {.lex_state = 0},
  [4153] = {.lex_state = 71},
  [4154] = {.lex_state = 71},
  [4155] = {.lex_state = 71},
  [4156] = {.lex_state = 71},
  [4157] = {.lex_state = 71},
  [4158] = {.lex_state = 71},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token__ternary_qmark = 2,
  ts_external_token_PIPE_PIPE = 3,
  ts_external_token__function_signature_automatic_semicolon = 4,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token__ternary_qmark] = sym__ternary_qmark,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
};

static const bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [2] = {
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [6] = {
    [ts_external_token__template_chars] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_private_property_identifier] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__ternary_qmark] = ACTIONS(1),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(4001),
    [sym_export_statement] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [2] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3204),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(363),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(181),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(189),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [3] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3204),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(363),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(181),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(189),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [4] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3882),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3882),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3882),
    [sym_spread_element] = STATE(3568),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1722),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2785),
    [sym_computed_property_name] = STATE(2785),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_accessibility_modifier] = STATE(2198),
    [sym_override_modifier] = STATE(2224),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(211),
    [anon_sym_export] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(217),
    [anon_sym_namespace] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(223),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(235),
    [anon_sym_readonly] = ACTIONS(237),
    [anon_sym_get] = ACTIONS(239),
    [anon_sym_set] = ACTIONS(239),
    [anon_sym_declare] = ACTIONS(241),
    [anon_sym_public] = ACTIONS(243),
    [anon_sym_private] = ACTIONS(243),
    [anon_sym_protected] = ACTIONS(243),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_module] = ACTIONS(247),
    [anon_sym_any] = ACTIONS(249),
    [anon_sym_number] = ACTIONS(249),
    [anon_sym_boolean] = ACTIONS(249),
    [anon_sym_string] = ACTIONS(249),
    [anon_sym_symbol] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [5] = {
    [sym_export_statement] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3882),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3882),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3882),
    [sym_spread_element] = STATE(3449),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1722),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3449),
    [sym_pair] = STATE(3449),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2785),
    [sym_computed_property_name] = STATE(2785),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_accessibility_modifier] = STATE(2198),
    [sym_override_modifier] = STATE(2224),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [aux_sym_object_repeat1] = STATE(3496),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_export] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(255),
    [anon_sym_namespace] = ACTIONS(257),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(261),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(265),
    [anon_sym_get] = ACTIONS(267),
    [anon_sym_set] = ACTIONS(267),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_override] = ACTIONS(273),
    [anon_sym_module] = ACTIONS(275),
    [anon_sym_any] = ACTIONS(277),
    [anon_sym_number] = ACTIONS(277),
    [anon_sym_boolean] = ACTIONS(277),
    [anon_sym_string] = ACTIONS(277),
    [anon_sym_symbol] = ACTIONS(277),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [6] = {
    [sym_export_statement] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3882),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3882),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3882),
    [sym_spread_element] = STATE(3449),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1722),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3449),
    [sym_pair] = STATE(3449),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2785),
    [sym_computed_property_name] = STATE(2785),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_accessibility_modifier] = STATE(2198),
    [sym_override_modifier] = STATE(2224),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [aux_sym_object_repeat1] = STATE(3496),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_export] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(255),
    [anon_sym_namespace] = ACTIONS(257),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(261),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(265),
    [anon_sym_get] = ACTIONS(267),
    [anon_sym_set] = ACTIONS(267),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_override] = ACTIONS(273),
    [anon_sym_module] = ACTIONS(275),
    [anon_sym_any] = ACTIONS(277),
    [anon_sym_number] = ACTIONS(277),
    [anon_sym_boolean] = ACTIONS(277),
    [anon_sym_string] = ACTIONS(277),
    [anon_sym_symbol] = ACTIONS(277),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [7] = {
    [sym_export_statement] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3882),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3882),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3882),
    [sym_spread_element] = STATE(3449),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1722),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3449),
    [sym_pair] = STATE(3449),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2785),
    [sym_computed_property_name] = STATE(2785),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_accessibility_modifier] = STATE(2198),
    [sym_override_modifier] = STATE(2224),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [aux_sym_object_repeat1] = STATE(3496),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_export] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(255),
    [anon_sym_namespace] = ACTIONS(257),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(281),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(261),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(265),
    [anon_sym_get] = ACTIONS(267),
    [anon_sym_set] = ACTIONS(267),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_override] = ACTIONS(273),
    [anon_sym_module] = ACTIONS(275),
    [anon_sym_any] = ACTIONS(277),
    [anon_sym_number] = ACTIONS(277),
    [anon_sym_boolean] = ACTIONS(277),
    [anon_sym_string] = ACTIONS(277),
    [anon_sym_symbol] = ACTIONS(277),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [8] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3882),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3882),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3882),
    [sym_spread_element] = STATE(3568),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1722),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2785),
    [sym_computed_property_name] = STATE(2785),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_accessibility_modifier] = STATE(2198),
    [sym_override_modifier] = STATE(2224),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(283),
    [anon_sym_export] = ACTIONS(285),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(223),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(291),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(293),
    [anon_sym_readonly] = ACTIONS(295),
    [anon_sym_get] = ACTIONS(297),
    [anon_sym_set] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(299),
    [anon_sym_public] = ACTIONS(301),
    [anon_sym_private] = ACTIONS(301),
    [anon_sym_protected] = ACTIONS(301),
    [anon_sym_override] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_any] = ACTIONS(307),
    [anon_sym_number] = ACTIONS(307),
    [anon_sym_boolean] = ACTIONS(307),
    [anon_sym_string] = ACTIONS(307),
    [anon_sym_symbol] = ACTIONS(307),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [9] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [ts_builtin_sym_end] = ACTIONS(309),
    [sym_identifier] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(314),
    [anon_sym_default] = ACTIONS(317),
    [anon_sym_type] = ACTIONS(319),
    [anon_sym_namespace] = ACTIONS(322),
    [anon_sym_LBRACE] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(309),
    [anon_sym_typeof] = ACTIONS(328),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_var] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_const] = ACTIONS(340),
    [anon_sym_BANG] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(349),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_LPAREN] = ACTIONS(355),
    [anon_sym_await] = ACTIONS(358),
    [anon_sym_while] = ACTIONS(361),
    [anon_sym_do] = ACTIONS(364),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_with] = ACTIONS(370),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_continue] = ACTIONS(376),
    [anon_sym_debugger] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(382),
    [anon_sym_throw] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(388),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_yield] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_SLASH] = ACTIONS(400),
    [anon_sym_class] = ACTIONS(403),
    [anon_sym_async] = ACTIONS(406),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_new] = ACTIONS(412),
    [anon_sym_PLUS] = ACTIONS(328),
    [anon_sym_DASH] = ACTIONS(328),
    [anon_sym_TILDE] = ACTIONS(343),
    [anon_sym_void] = ACTIONS(328),
    [anon_sym_delete] = ACTIONS(328),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [anon_sym_SQUOTE] = ACTIONS(421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(424),
    [sym_number] = ACTIONS(427),
    [sym_this] = ACTIONS(430),
    [sym_super] = ACTIONS(430),
    [sym_true] = ACTIONS(430),
    [sym_false] = ACTIONS(430),
    [sym_null] = ACTIONS(430),
    [sym_undefined] = ACTIONS(433),
    [anon_sym_AT] = ACTIONS(436),
    [anon_sym_static] = ACTIONS(439),
    [anon_sym_readonly] = ACTIONS(439),
    [anon_sym_get] = ACTIONS(439),
    [anon_sym_set] = ACTIONS(439),
    [anon_sym_declare] = ACTIONS(442),
    [anon_sym_public] = ACTIONS(439),
    [anon_sym_private] = ACTIONS(439),
    [anon_sym_protected] = ACTIONS(439),
    [anon_sym_override] = ACTIONS(439),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(439),
    [anon_sym_number] = ACTIONS(439),
    [anon_sym_boolean] = ACTIONS(439),
    [anon_sym_string] = ACTIONS(439),
    [anon_sym_symbol] = ACTIONS(439),
    [anon_sym_abstract] = ACTIONS(448),
    [anon_sym_interface] = ACTIONS(451),
    [anon_sym_enum] = ACTIONS(454),
  },
  [10] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(457),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [11] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(461),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(461),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [12] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(465),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(465),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [13] = {
    [sym_export_statement] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(469),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(471),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(469),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [14] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [15] = {
    [sym_export_statement] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(475),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [16] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [17] = {
    [sym_export_statement] = STATE(14),
    [sym_declaration] = STATE(14),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [18] = {
    [sym_export_statement] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [ts_builtin_sym_end] = ACTIONS(481),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [19] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [20] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [21] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [ts_builtin_sym_end] = ACTIONS(487),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [22] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [23] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [ts_builtin_sym_end] = ACTIONS(481),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [24] = {
    [sym_export_statement] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [25] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [26] = {
    [sym_export_statement] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [27] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(497),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [28] = {
    [sym_export_statement] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [29] = {
    [sym_export_statement] = STATE(762),
    [sym_declaration] = STATE(762),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(762),
    [sym_expression_statement] = STATE(762),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(762),
    [sym_if_statement] = STATE(762),
    [sym_switch_statement] = STATE(762),
    [sym_for_statement] = STATE(762),
    [sym_for_in_statement] = STATE(762),
    [sym_while_statement] = STATE(762),
    [sym_do_statement] = STATE(762),
    [sym_try_statement] = STATE(762),
    [sym_with_statement] = STATE(762),
    [sym_break_statement] = STATE(762),
    [sym_continue_statement] = STATE(762),
    [sym_debugger_statement] = STATE(762),
    [sym_return_statement] = STATE(762),
    [sym_throw_statement] = STATE(762),
    [sym_empty_statement] = STATE(762),
    [sym_labeled_statement] = STATE(762),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [30] = {
    [sym_export_statement] = STATE(678),
    [sym_declaration] = STATE(676),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(673),
    [sym_expression_statement] = STATE(671),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(669),
    [sym_if_statement] = STATE(664),
    [sym_switch_statement] = STATE(663),
    [sym_for_statement] = STATE(662),
    [sym_for_in_statement] = STATE(661),
    [sym_while_statement] = STATE(660),
    [sym_do_statement] = STATE(659),
    [sym_try_statement] = STATE(655),
    [sym_with_statement] = STATE(654),
    [sym_break_statement] = STATE(651),
    [sym_continue_statement] = STATE(649),
    [sym_debugger_statement] = STATE(643),
    [sym_return_statement] = STATE(639),
    [sym_throw_statement] = STATE(636),
    [sym_empty_statement] = STATE(635),
    [sym_labeled_statement] = STATE(634),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [31] = {
    [sym_export_statement] = STATE(722),
    [sym_declaration] = STATE(732),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(739),
    [sym_expression_statement] = STATE(734),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(631),
    [sym_if_statement] = STATE(657),
    [sym_switch_statement] = STATE(670),
    [sym_for_statement] = STATE(656),
    [sym_for_in_statement] = STATE(640),
    [sym_while_statement] = STATE(627),
    [sym_do_statement] = STATE(638),
    [sym_try_statement] = STATE(687),
    [sym_with_statement] = STATE(658),
    [sym_break_statement] = STATE(665),
    [sym_continue_statement] = STATE(684),
    [sym_debugger_statement] = STATE(622),
    [sym_return_statement] = STATE(702),
    [sym_throw_statement] = STATE(742),
    [sym_empty_statement] = STATE(625),
    [sym_labeled_statement] = STATE(632),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [32] = {
    [sym_export_statement] = STATE(763),
    [sym_declaration] = STATE(763),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(763),
    [sym_expression_statement] = STATE(763),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(763),
    [sym_if_statement] = STATE(763),
    [sym_switch_statement] = STATE(763),
    [sym_for_statement] = STATE(763),
    [sym_for_in_statement] = STATE(763),
    [sym_while_statement] = STATE(763),
    [sym_do_statement] = STATE(763),
    [sym_try_statement] = STATE(763),
    [sym_with_statement] = STATE(763),
    [sym_break_statement] = STATE(763),
    [sym_continue_statement] = STATE(763),
    [sym_debugger_statement] = STATE(763),
    [sym_return_statement] = STATE(763),
    [sym_throw_statement] = STATE(763),
    [sym_empty_statement] = STATE(763),
    [sym_labeled_statement] = STATE(763),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [33] = {
    [sym_export_statement] = STATE(678),
    [sym_declaration] = STATE(676),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(673),
    [sym_expression_statement] = STATE(671),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(669),
    [sym_if_statement] = STATE(664),
    [sym_switch_statement] = STATE(663),
    [sym_for_statement] = STATE(662),
    [sym_for_in_statement] = STATE(661),
    [sym_while_statement] = STATE(660),
    [sym_do_statement] = STATE(659),
    [sym_try_statement] = STATE(655),
    [sym_with_statement] = STATE(654),
    [sym_break_statement] = STATE(651),
    [sym_continue_statement] = STATE(649),
    [sym_debugger_statement] = STATE(643),
    [sym_return_statement] = STATE(639),
    [sym_throw_statement] = STATE(636),
    [sym_empty_statement] = STATE(635),
    [sym_labeled_statement] = STATE(634),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [34] = {
    [sym_export_statement] = STATE(762),
    [sym_declaration] = STATE(762),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(762),
    [sym_expression_statement] = STATE(762),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(762),
    [sym_if_statement] = STATE(762),
    [sym_switch_statement] = STATE(762),
    [sym_for_statement] = STATE(762),
    [sym_for_in_statement] = STATE(762),
    [sym_while_statement] = STATE(762),
    [sym_do_statement] = STATE(762),
    [sym_try_statement] = STATE(762),
    [sym_with_statement] = STATE(762),
    [sym_break_statement] = STATE(762),
    [sym_continue_statement] = STATE(762),
    [sym_debugger_statement] = STATE(762),
    [sym_return_statement] = STATE(762),
    [sym_throw_statement] = STATE(762),
    [sym_empty_statement] = STATE(762),
    [sym_labeled_statement] = STATE(762),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [35] = {
    [sym_export_statement] = STATE(747),
    [sym_declaration] = STATE(747),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(747),
    [sym_expression_statement] = STATE(747),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(747),
    [sym_if_statement] = STATE(747),
    [sym_switch_statement] = STATE(747),
    [sym_for_statement] = STATE(747),
    [sym_for_in_statement] = STATE(747),
    [sym_while_statement] = STATE(747),
    [sym_do_statement] = STATE(747),
    [sym_try_statement] = STATE(747),
    [sym_with_statement] = STATE(747),
    [sym_break_statement] = STATE(747),
    [sym_continue_statement] = STATE(747),
    [sym_debugger_statement] = STATE(747),
    [sym_return_statement] = STATE(747),
    [sym_throw_statement] = STATE(747),
    [sym_empty_statement] = STATE(747),
    [sym_labeled_statement] = STATE(747),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [36] = {
    [sym_export_statement] = STATE(648),
    [sym_declaration] = STATE(648),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(648),
    [sym_expression_statement] = STATE(648),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(648),
    [sym_if_statement] = STATE(648),
    [sym_switch_statement] = STATE(648),
    [sym_for_statement] = STATE(648),
    [sym_for_in_statement] = STATE(648),
    [sym_while_statement] = STATE(648),
    [sym_do_statement] = STATE(648),
    [sym_try_statement] = STATE(648),
    [sym_with_statement] = STATE(648),
    [sym_break_statement] = STATE(648),
    [sym_continue_statement] = STATE(648),
    [sym_debugger_statement] = STATE(648),
    [sym_return_statement] = STATE(648),
    [sym_throw_statement] = STATE(648),
    [sym_empty_statement] = STATE(648),
    [sym_labeled_statement] = STATE(648),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [37] = {
    [sym_export_statement] = STATE(652),
    [sym_declaration] = STATE(652),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(652),
    [sym_expression_statement] = STATE(652),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(652),
    [sym_if_statement] = STATE(652),
    [sym_switch_statement] = STATE(652),
    [sym_for_statement] = STATE(652),
    [sym_for_in_statement] = STATE(652),
    [sym_while_statement] = STATE(652),
    [sym_do_statement] = STATE(652),
    [sym_try_statement] = STATE(652),
    [sym_with_statement] = STATE(652),
    [sym_break_statement] = STATE(652),
    [sym_continue_statement] = STATE(652),
    [sym_debugger_statement] = STATE(652),
    [sym_return_statement] = STATE(652),
    [sym_throw_statement] = STATE(652),
    [sym_empty_statement] = STATE(652),
    [sym_labeled_statement] = STATE(652),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [38] = {
    [sym_export_statement] = STATE(648),
    [sym_declaration] = STATE(648),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(648),
    [sym_expression_statement] = STATE(648),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(648),
    [sym_if_statement] = STATE(648),
    [sym_switch_statement] = STATE(648),
    [sym_for_statement] = STATE(648),
    [sym_for_in_statement] = STATE(648),
    [sym_while_statement] = STATE(648),
    [sym_do_statement] = STATE(648),
    [sym_try_statement] = STATE(648),
    [sym_with_statement] = STATE(648),
    [sym_break_statement] = STATE(648),
    [sym_continue_statement] = STATE(648),
    [sym_debugger_statement] = STATE(648),
    [sym_return_statement] = STATE(648),
    [sym_throw_statement] = STATE(648),
    [sym_empty_statement] = STATE(648),
    [sym_labeled_statement] = STATE(648),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [39] = {
    [sym_export_statement] = STATE(3584),
    [sym_declaration] = STATE(3584),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(3584),
    [sym_expression_statement] = STATE(3584),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(3584),
    [sym_if_statement] = STATE(3584),
    [sym_switch_statement] = STATE(3584),
    [sym_for_statement] = STATE(3584),
    [sym_for_in_statement] = STATE(3584),
    [sym_while_statement] = STATE(3584),
    [sym_do_statement] = STATE(3584),
    [sym_try_statement] = STATE(3584),
    [sym_with_statement] = STATE(3584),
    [sym_break_statement] = STATE(3584),
    [sym_continue_statement] = STATE(3584),
    [sym_debugger_statement] = STATE(3584),
    [sym_return_statement] = STATE(3584),
    [sym_throw_statement] = STATE(3584),
    [sym_empty_statement] = STATE(3584),
    [sym_labeled_statement] = STATE(3584),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [40] = {
    [sym_export_statement] = STATE(754),
    [sym_declaration] = STATE(754),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(754),
    [sym_expression_statement] = STATE(754),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(754),
    [sym_if_statement] = STATE(754),
    [sym_switch_statement] = STATE(754),
    [sym_for_statement] = STATE(754),
    [sym_for_in_statement] = STATE(754),
    [sym_while_statement] = STATE(754),
    [sym_do_statement] = STATE(754),
    [sym_try_statement] = STATE(754),
    [sym_with_statement] = STATE(754),
    [sym_break_statement] = STATE(754),
    [sym_continue_statement] = STATE(754),
    [sym_debugger_statement] = STATE(754),
    [sym_return_statement] = STATE(754),
    [sym_throw_statement] = STATE(754),
    [sym_empty_statement] = STATE(754),
    [sym_labeled_statement] = STATE(754),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [41] = {
    [sym_export_statement] = STATE(763),
    [sym_declaration] = STATE(763),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(763),
    [sym_expression_statement] = STATE(763),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(763),
    [sym_if_statement] = STATE(763),
    [sym_switch_statement] = STATE(763),
    [sym_for_statement] = STATE(763),
    [sym_for_in_statement] = STATE(763),
    [sym_while_statement] = STATE(763),
    [sym_do_statement] = STATE(763),
    [sym_try_statement] = STATE(763),
    [sym_with_statement] = STATE(763),
    [sym_break_statement] = STATE(763),
    [sym_continue_statement] = STATE(763),
    [sym_debugger_statement] = STATE(763),
    [sym_return_statement] = STATE(763),
    [sym_throw_statement] = STATE(763),
    [sym_empty_statement] = STATE(763),
    [sym_labeled_statement] = STATE(763),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [42] = {
    [sym_export_statement] = STATE(747),
    [sym_declaration] = STATE(747),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(747),
    [sym_expression_statement] = STATE(747),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(747),
    [sym_if_statement] = STATE(747),
    [sym_switch_statement] = STATE(747),
    [sym_for_statement] = STATE(747),
    [sym_for_in_statement] = STATE(747),
    [sym_while_statement] = STATE(747),
    [sym_do_statement] = STATE(747),
    [sym_try_statement] = STATE(747),
    [sym_with_statement] = STATE(747),
    [sym_break_statement] = STATE(747),
    [sym_continue_statement] = STATE(747),
    [sym_debugger_statement] = STATE(747),
    [sym_return_statement] = STATE(747),
    [sym_throw_statement] = STATE(747),
    [sym_empty_statement] = STATE(747),
    [sym_labeled_statement] = STATE(747),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [43] = {
    [sym_export_statement] = STATE(604),
    [sym_declaration] = STATE(604),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(604),
    [sym_expression_statement] = STATE(604),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_switch_statement] = STATE(604),
    [sym_for_statement] = STATE(604),
    [sym_for_in_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_do_statement] = STATE(604),
    [sym_try_statement] = STATE(604),
    [sym_with_statement] = STATE(604),
    [sym_break_statement] = STATE(604),
    [sym_continue_statement] = STATE(604),
    [sym_debugger_statement] = STATE(604),
    [sym_return_statement] = STATE(604),
    [sym_throw_statement] = STATE(604),
    [sym_empty_statement] = STATE(604),
    [sym_labeled_statement] = STATE(604),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [44] = {
    [sym_export_statement] = STATE(652),
    [sym_declaration] = STATE(652),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(652),
    [sym_expression_statement] = STATE(652),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(652),
    [sym_if_statement] = STATE(652),
    [sym_switch_statement] = STATE(652),
    [sym_for_statement] = STATE(652),
    [sym_for_in_statement] = STATE(652),
    [sym_while_statement] = STATE(652),
    [sym_do_statement] = STATE(652),
    [sym_try_statement] = STATE(652),
    [sym_with_statement] = STATE(652),
    [sym_break_statement] = STATE(652),
    [sym_continue_statement] = STATE(652),
    [sym_debugger_statement] = STATE(652),
    [sym_return_statement] = STATE(652),
    [sym_throw_statement] = STATE(652),
    [sym_empty_statement] = STATE(652),
    [sym_labeled_statement] = STATE(652),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [45] = {
    [sym_export_statement] = STATE(722),
    [sym_declaration] = STATE(732),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(739),
    [sym_expression_statement] = STATE(734),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(631),
    [sym_if_statement] = STATE(657),
    [sym_switch_statement] = STATE(670),
    [sym_for_statement] = STATE(656),
    [sym_for_in_statement] = STATE(640),
    [sym_while_statement] = STATE(627),
    [sym_do_statement] = STATE(638),
    [sym_try_statement] = STATE(687),
    [sym_with_statement] = STATE(658),
    [sym_break_statement] = STATE(665),
    [sym_continue_statement] = STATE(684),
    [sym_debugger_statement] = STATE(622),
    [sym_return_statement] = STATE(702),
    [sym_throw_statement] = STATE(742),
    [sym_empty_statement] = STATE(625),
    [sym_labeled_statement] = STATE(632),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2968),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [46] = {
    [sym_export_statement] = STATE(754),
    [sym_declaration] = STATE(754),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(754),
    [sym_expression_statement] = STATE(754),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(754),
    [sym_if_statement] = STATE(754),
    [sym_switch_statement] = STATE(754),
    [sym_for_statement] = STATE(754),
    [sym_for_in_statement] = STATE(754),
    [sym_while_statement] = STATE(754),
    [sym_do_statement] = STATE(754),
    [sym_try_statement] = STATE(754),
    [sym_with_statement] = STATE(754),
    [sym_break_statement] = STATE(754),
    [sym_continue_statement] = STATE(754),
    [sym_debugger_statement] = STATE(754),
    [sym_return_statement] = STATE(754),
    [sym_throw_statement] = STATE(754),
    [sym_empty_statement] = STATE(754),
    [sym_labeled_statement] = STATE(754),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [47] = {
    [sym_export_statement] = STATE(3902),
    [sym_declaration] = STATE(3902),
    [sym_import] = STATE(1819),
    [sym_import_statement] = STATE(3902),
    [sym_expression_statement] = STATE(3902),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_statement_block] = STATE(3902),
    [sym_if_statement] = STATE(3902),
    [sym_switch_statement] = STATE(3902),
    [sym_for_statement] = STATE(3902),
    [sym_for_in_statement] = STATE(3902),
    [sym_while_statement] = STATE(3902),
    [sym_do_statement] = STATE(3902),
    [sym_try_statement] = STATE(3902),
    [sym_with_statement] = STATE(3902),
    [sym_break_statement] = STATE(3902),
    [sym_continue_statement] = STATE(3902),
    [sym_debugger_statement] = STATE(3902),
    [sym_return_statement] = STATE(3902),
    [sym_throw_statement] = STATE(3902),
    [sym_empty_statement] = STATE(3902),
    [sym_labeled_statement] = STATE(3902),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(2849),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [48] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3247),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(551),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [49] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(3169),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3578),
    [sym_optional_tuple_parameter] = STATE(3578),
    [sym_optional_type] = STATE(3578),
    [sym_rest_type] = STATE(3578),
    [sym__tuple_type_member] = STATE(3578),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_typeof] = ACTIONS(569),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [50] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(3169),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3578),
    [sym_optional_tuple_parameter] = STATE(3578),
    [sym_optional_type] = STATE(3578),
    [sym_rest_type] = STATE(3578),
    [sym__tuple_type_member] = STATE(3578),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_typeof] = ACTIONS(569),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [51] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(2999),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(613),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [52] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1589),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3518),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(3169),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3578),
    [sym_optional_tuple_parameter] = STATE(3578),
    [sym_optional_type] = STATE(3578),
    [sym_rest_type] = STATE(3578),
    [sym__tuple_type_member] = STATE(3578),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3456),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_typeof] = ACTIONS(569),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(615),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [53] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(3169),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3578),
    [sym_optional_tuple_parameter] = STATE(3578),
    [sym_optional_type] = STATE(3578),
    [sym_rest_type] = STATE(3578),
    [sym__tuple_type_member] = STATE(3578),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_typeof] = ACTIONS(569),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [54] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(2991),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(619),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [55] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(3169),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3437),
    [sym_optional_tuple_parameter] = STATE(3437),
    [sym_optional_type] = STATE(3437),
    [sym_rest_type] = STATE(3437),
    [sym__tuple_type_member] = STATE(3437),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(621),
    [anon_sym_typeof] = ACTIONS(569),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [56] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(3169),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3578),
    [sym_optional_tuple_parameter] = STATE(3578),
    [sym_optional_type] = STATE(3578),
    [sym_rest_type] = STATE(3578),
    [sym__tuple_type_member] = STATE(3578),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_typeof] = ACTIONS(569),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(625),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [57] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3207),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(627),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [58] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(3169),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3578),
    [sym_optional_tuple_parameter] = STATE(3578),
    [sym_optional_type] = STATE(3578),
    [sym_rest_type] = STATE(3578),
    [sym__tuple_type_member] = STATE(3578),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_typeof] = ACTIONS(569),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(629),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [59] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3217),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(631),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [60] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(3169),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3578),
    [sym_optional_tuple_parameter] = STATE(3578),
    [sym_optional_type] = STATE(3578),
    [sym_rest_type] = STATE(3578),
    [sym__tuple_type_member] = STATE(3578),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_typeof] = ACTIONS(569),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(633),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [61] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1589),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3518),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(3169),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3578),
    [sym_optional_tuple_parameter] = STATE(3578),
    [sym_optional_type] = STATE(3578),
    [sym_rest_type] = STATE(3578),
    [sym__tuple_type_member] = STATE(3578),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3456),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_typeof] = ACTIONS(569),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [62] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3204),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(637),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [63] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3201),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(639),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [64] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3204),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(546),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(637),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [65] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(3169),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3578),
    [sym_optional_tuple_parameter] = STATE(3578),
    [sym_optional_type] = STATE(3578),
    [sym_rest_type] = STATE(3578),
    [sym__tuple_type_member] = STATE(3578),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(557),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_typeof] = ACTIONS(569),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [66] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1442),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym__formal_parameter] = STATE(3589),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(3906),
    [sym_string] = STATE(1813),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3589),
    [sym_optional_parameter] = STATE(3589),
    [sym__parameter_name] = STATE(2727),
    [sym__type] = STATE(3338),
    [sym_constructor_type] = STATE(3338),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3338),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3338),
    [sym_union_type] = STATE(3338),
    [sym_intersection_type] = STATE(3338),
    [sym_function_type] = STATE(3338),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(643),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_typeof] = ACTIONS(647),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_number] = ACTIONS(657),
    [sym_this] = ACTIONS(659),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_undefined] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(665),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_override] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [67] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1497),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym__formal_parameter] = STATE(3589),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(3897),
    [sym_string] = STATE(1813),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3589),
    [sym_optional_parameter] = STATE(3589),
    [sym__parameter_name] = STATE(2727),
    [sym__type] = STATE(3264),
    [sym_constructor_type] = STATE(3264),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3264),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3264),
    [sym_union_type] = STATE(3264),
    [sym_intersection_type] = STATE(3264),
    [sym_function_type] = STATE(3264),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(643),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_typeof] = ACTIONS(647),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_number] = ACTIONS(657),
    [sym_this] = ACTIONS(659),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_undefined] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(665),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_override] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [68] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1442),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym__formal_parameter] = STATE(3589),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(3906),
    [sym_string] = STATE(1813),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3589),
    [sym_optional_parameter] = STATE(3589),
    [sym__parameter_name] = STATE(2727),
    [sym__type] = STATE(3264),
    [sym_constructor_type] = STATE(3264),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3264),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3264),
    [sym_union_type] = STATE(3264),
    [sym_intersection_type] = STATE(3264),
    [sym_function_type] = STATE(3264),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(643),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_typeof] = ACTIONS(647),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_number] = ACTIONS(657),
    [sym_this] = ACTIONS(659),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_undefined] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(665),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_override] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(671),
    [anon_sym_number] = ACTIONS(671),
    [anon_sym_boolean] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_symbol] = ACTIONS(671),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [69] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3589),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3589),
    [sym_optional_parameter] = STATE(3589),
    [sym__parameter_name] = STATE(2727),
    [sym__type] = STATE(3338),
    [sym_constructor_type] = STATE(3338),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3338),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(363),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3338),
    [sym_union_type] = STATE(3338),
    [sym_intersection_type] = STATE(3338),
    [sym_function_type] = STATE(3338),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [70] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3589),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3589),
    [sym_optional_parameter] = STATE(3589),
    [sym__parameter_name] = STATE(2727),
    [sym__type] = STATE(3307),
    [sym_constructor_type] = STATE(3307),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3307),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(363),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3307),
    [sym_union_type] = STATE(3307),
    [sym_intersection_type] = STATE(3307),
    [sym_function_type] = STATE(3307),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [71] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3589),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3589),
    [sym_optional_parameter] = STATE(3589),
    [sym__parameter_name] = STATE(2727),
    [sym__type] = STATE(3301),
    [sym_constructor_type] = STATE(3301),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3301),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(363),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3301),
    [sym_union_type] = STATE(3301),
    [sym_intersection_type] = STATE(3301),
    [sym_function_type] = STATE(3301),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [72] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3589),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3589),
    [sym_optional_parameter] = STATE(3589),
    [sym__parameter_name] = STATE(2727),
    [sym__type] = STATE(3350),
    [sym_constructor_type] = STATE(3350),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3350),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(363),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3350),
    [sym_union_type] = STATE(3350),
    [sym_intersection_type] = STATE(3350),
    [sym_function_type] = STATE(3350),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [73] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3589),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3589),
    [sym_optional_parameter] = STATE(3589),
    [sym__parameter_name] = STATE(2727),
    [sym__type] = STATE(3264),
    [sym_constructor_type] = STATE(3264),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3264),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(363),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3264),
    [sym_union_type] = STATE(3264),
    [sym_intersection_type] = STATE(3264),
    [sym_function_type] = STATE(3264),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [74] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1816),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3706),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_nested_identifier] = STATE(4008),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1637),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(3092),
    [sym_pattern] = STATE(3488),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2442),
    [sym__type] = STATE(2591),
    [sym_constructor_type] = STATE(2591),
    [sym__primary_type] = STATE(2530),
    [sym_template_literal_type] = STATE(2536),
    [sym_infer_type] = STATE(2591),
    [sym_conditional_type] = STATE(2536),
    [sym_generic_type] = STATE(2536),
    [sym_type_query] = STATE(2536),
    [sym_index_type_query] = STATE(2536),
    [sym_lookup_type] = STATE(2536),
    [sym_literal_type] = STATE(2536),
    [sym__number] = STATE(2540),
    [sym_existential_type] = STATE(2536),
    [sym_flow_maybe_type] = STATE(2536),
    [sym_parenthesized_type] = STATE(2536),
    [sym_predefined_type] = STATE(2536),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2536),
    [sym_type_parameters] = STATE(3608),
    [sym_array_type] = STATE(2536),
    [sym_tuple_type] = STATE(2536),
    [sym_readonly_type] = STATE(2591),
    [sym_union_type] = STATE(2591),
    [sym_intersection_type] = STATE(2591),
    [sym_function_type] = STATE(2591),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(683),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(687),
    [anon_sym_typeof] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(693),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(703),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(705),
    [sym_number] = ACTIONS(707),
    [sym_this] = ACTIONS(709),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(711),
    [sym_false] = ACTIONS(711),
    [sym_null] = ACTIONS(711),
    [sym_undefined] = ACTIONS(713),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(715),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(719),
    [anon_sym_number] = ACTIONS(719),
    [anon_sym_boolean] = ACTIONS(719),
    [anon_sym_string] = ACTIONS(719),
    [anon_sym_symbol] = ACTIONS(719),
    [anon_sym_infer] = ACTIONS(721),
    [anon_sym_keyof] = ACTIONS(723),
    [anon_sym_unknown] = ACTIONS(725),
    [anon_sym_never] = ACTIONS(725),
    [anon_sym_object] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
  },
  [75] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1699),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4143),
    [sym_string] = STATE(1813),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(3432),
    [sym_constructor_type] = STATE(3432),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3265),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3432),
    [sym_union_type] = STATE(3432),
    [sym_intersection_type] = STATE(3432),
    [sym_function_type] = STATE(3432),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(729),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_typeof] = ACTIONS(647),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [sym_number] = ACTIONS(657),
    [sym_this] = ACTIONS(741),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_undefined] = ACTIONS(743),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(747),
    [anon_sym_number] = ACTIONS(747),
    [anon_sym_boolean] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_symbol] = ACTIONS(747),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [76] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1531),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1376),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2880),
    [sym_constructor_type] = STATE(2880),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2880),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(471),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2880),
    [sym_union_type] = STATE(2880),
    [sym_intersection_type] = STATE(2880),
    [sym_function_type] = STATE(2880),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(755),
    [anon_sym_typeof] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(775),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(781),
    [sym_number] = ACTIONS(783),
    [sym_this] = ACTIONS(785),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_null] = ACTIONS(787),
    [sym_undefined] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(793),
    [anon_sym_number] = ACTIONS(793),
    [anon_sym_boolean] = ACTIONS(793),
    [anon_sym_string] = ACTIONS(793),
    [anon_sym_symbol] = ACTIONS(793),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [77] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1453),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1621),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2880),
    [sym_constructor_type] = STATE(2880),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2880),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(402),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2880),
    [sym_union_type] = STATE(2880),
    [sym_intersection_type] = STATE(2880),
    [sym_function_type] = STATE(2880),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(803),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(829),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(835),
    [sym_number] = ACTIONS(837),
    [sym_this] = ACTIONS(839),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(841),
    [sym_false] = ACTIONS(841),
    [sym_null] = ACTIONS(841),
    [sym_undefined] = ACTIONS(843),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(845),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [78] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2022),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1695),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2880),
    [sym_constructor_type] = STATE(2880),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2880),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(363),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2880),
    [sym_union_type] = STATE(2880),
    [sym_intersection_type] = STATE(2880),
    [sym_function_type] = STATE(2880),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(849),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(857),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(865),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(871),
    [sym_undefined] = ACTIONS(873),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(875),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(877),
    [anon_sym_number] = ACTIONS(877),
    [anon_sym_boolean] = ACTIONS(877),
    [anon_sym_string] = ACTIONS(877),
    [anon_sym_symbol] = ACTIONS(877),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [79] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1705),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1695),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2880),
    [sym_constructor_type] = STATE(2880),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2880),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2880),
    [sym_union_type] = STATE(2880),
    [sym_intersection_type] = STATE(2880),
    [sym_function_type] = STATE(2880),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(885),
    [anon_sym_typeof] = ACTIONS(887),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(865),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(871),
    [sym_undefined] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(909),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(911),
    [anon_sym_number] = ACTIONS(911),
    [anon_sym_boolean] = ACTIONS(911),
    [anon_sym_string] = ACTIONS(911),
    [anon_sym_symbol] = ACTIONS(911),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [80] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1338),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1376),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2880),
    [sym_constructor_type] = STATE(2880),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2880),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2880),
    [sym_union_type] = STATE(2880),
    [sym_intersection_type] = STATE(2880),
    [sym_function_type] = STATE(2880),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(913),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(755),
    [anon_sym_typeof] = ACTIONS(915),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(917),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(781),
    [sym_number] = ACTIONS(783),
    [sym_this] = ACTIONS(785),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(787),
    [sym_false] = ACTIONS(787),
    [sym_null] = ACTIONS(787),
    [sym_undefined] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(745),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(921),
    [anon_sym_number] = ACTIONS(921),
    [anon_sym_boolean] = ACTIONS(921),
    [anon_sym_string] = ACTIONS(921),
    [anon_sym_symbol] = ACTIONS(921),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [81] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2738),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2738),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1146),
    [sym_subscript_expression] = STATE(1146),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2738),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(2053),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_non_null_expression] = STATE(1146),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(3202),
    [sym_constructor_type] = STATE(3202),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3202),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(363),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3202),
    [sym_union_type] = STATE(3202),
    [sym_intersection_type] = STATE(3202),
    [sym_function_type] = STATE(3202),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(923),
    [anon_sym_export] = ACTIONS(925),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_typeof] = ACTIONS(931),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(945),
    [sym_false] = ACTIONS(945),
    [sym_null] = ACTIONS(945),
    [sym_undefined] = ACTIONS(947),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(925),
    [anon_sym_readonly] = ACTIONS(949),
    [anon_sym_get] = ACTIONS(925),
    [anon_sym_set] = ACTIONS(925),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(925),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_override] = ACTIONS(925),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_any] = ACTIONS(951),
    [anon_sym_number] = ACTIONS(951),
    [anon_sym_boolean] = ACTIONS(951),
    [anon_sym_string] = ACTIONS(951),
    [anon_sym_symbol] = ACTIONS(951),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [82] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1920),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1695),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2880),
    [sym_constructor_type] = STATE(2880),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2880),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(477),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2880),
    [sym_union_type] = STATE(2880),
    [sym_intersection_type] = STATE(2880),
    [sym_function_type] = STATE(2880),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(953),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_typeof] = ACTIONS(959),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(973),
    [anon_sym_DASH] = ACTIONS(973),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(975),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(865),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(871),
    [sym_undefined] = ACTIONS(981),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(983),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(985),
    [anon_sym_number] = ACTIONS(985),
    [anon_sym_boolean] = ACTIONS(985),
    [anon_sym_string] = ACTIONS(985),
    [anon_sym_symbol] = ACTIONS(985),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [83] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1484),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(3124),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(3124),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1095),
    [sym_subscript_expression] = STATE(1095),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(3124),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1844),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_non_null_expression] = STATE(1095),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(3202),
    [sym_constructor_type] = STATE(3202),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3202),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(524),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3202),
    [sym_union_type] = STATE(3202),
    [sym_intersection_type] = STATE(3202),
    [sym_function_type] = STATE(3202),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_typeof] = ACTIONS(569),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(999),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1001),
    [anon_sym_number] = ACTIONS(1001),
    [anon_sym_boolean] = ACTIONS(1001),
    [anon_sym_string] = ACTIONS(1001),
    [anon_sym_symbol] = ACTIONS(1001),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [84] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1431),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1621),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2880),
    [sym_constructor_type] = STATE(2880),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2880),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(452),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2880),
    [sym_union_type] = STATE(2880),
    [sym_intersection_type] = STATE(2880),
    [sym_function_type] = STATE(2880),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1003),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_DASH] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(1017),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(835),
    [sym_number] = ACTIONS(837),
    [sym_this] = ACTIONS(839),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(841),
    [sym_false] = ACTIONS(841),
    [sym_null] = ACTIONS(841),
    [sym_undefined] = ACTIONS(1019),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1021),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1023),
    [anon_sym_number] = ACTIONS(1023),
    [anon_sym_boolean] = ACTIONS(1023),
    [anon_sym_string] = ACTIONS(1023),
    [anon_sym_symbol] = ACTIONS(1023),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [85] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1856),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_nested_identifier] = STATE(3999),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1922),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2997),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2880),
    [sym_constructor_type] = STATE(2880),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2880),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_type_arguments] = STATE(350),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3815),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2880),
    [sym_union_type] = STATE(2880),
    [sym_intersection_type] = STATE(2880),
    [sym_function_type] = STATE(2880),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1025),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1041),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1049),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1055),
    [sym_number] = ACTIONS(1057),
    [sym_this] = ACTIONS(1059),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1063),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1065),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1067),
    [anon_sym_number] = ACTIONS(1067),
    [anon_sym_boolean] = ACTIONS(1067),
    [anon_sym_string] = ACTIONS(1067),
    [anon_sym_symbol] = ACTIONS(1067),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [86] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1403),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1077),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [87] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1494),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
    [sym__automatic_semicolon] = ACTIONS(1077),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [88] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1509),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_of] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
    [sym__automatic_semicolon] = ACTIONS(1077),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [89] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1748),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
    [sym__automatic_semicolon] = ACTIONS(1077),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [90] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1774),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_STAR] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [91] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1686),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
    [anon_sym_implements] = ACTIONS(1073),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [92] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1943),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_of] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [93] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2034),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(1141),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(168),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_QMARK_DOT] = ACTIONS(1077),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_GT_GT_GT] = ACTIONS(1077),
    [anon_sym_LT_LT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_CARET] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_PERCENT] = ACTIONS(1077),
    [anon_sym_STAR_STAR] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1077),
    [anon_sym_QMARK_QMARK] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
    [sym__ternary_qmark] = ACTIONS(1077),
  },
  [94] = {
    [sym_declaration] = STATE(756),
    [sym_import] = STATE(1819),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1760),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3200),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1145),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1147),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1153),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [95] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [96] = {
    [sym_declaration] = STATE(756),
    [sym_import] = STATE(1819),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1760),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3181),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1145),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1147),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(1189),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1153),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [97] = {
    [sym_declaration] = STATE(3128),
    [sym_import] = STATE(1819),
    [sym_variable_declaration] = STATE(3102),
    [sym_lexical_declaration] = STATE(3102),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1750),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(3102),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(3102),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(3102),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_function_signature] = STATE(3102),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(3102),
    [sym_abstract_class_declaration] = STATE(3102),
    [sym_module] = STATE(3102),
    [sym_internal_module] = STATE(1727),
    [sym_import_alias] = STATE(3102),
    [sym_interface_declaration] = STATE(3102),
    [sym_enum_declaration] = STATE(3102),
    [sym_type_alias_declaration] = STATE(3102),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3130),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1191),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1193),
    [anon_sym_var] = ACTIONS(1195),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1203),
    [anon_sym_function] = ACTIONS(1205),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1209),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
    [anon_sym_abstract] = ACTIONS(1211),
    [anon_sym_interface] = ACTIONS(1213),
    [anon_sym_enum] = ACTIONS(1215),
  },
  [98] = {
    [sym_declaration] = STATE(737),
    [sym_import] = STATE(1819),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1872),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(139),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3181),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1145),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1147),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(1189),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1153),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [99] = {
    [sym_declaration] = STATE(3171),
    [sym_import] = STATE(1819),
    [sym_variable_declaration] = STATE(3102),
    [sym_lexical_declaration] = STATE(3102),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1795),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(3102),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(3102),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(3102),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_function_signature] = STATE(3102),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(3102),
    [sym_abstract_class_declaration] = STATE(3102),
    [sym_module] = STATE(3102),
    [sym_internal_module] = STATE(1727),
    [sym_import_alias] = STATE(3102),
    [sym_interface_declaration] = STATE(3102),
    [sym_enum_declaration] = STATE(3102),
    [sym_type_alias_declaration] = STATE(3102),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3130),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1191),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1193),
    [anon_sym_var] = ACTIONS(1195),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1203),
    [anon_sym_function] = ACTIONS(1205),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1209),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
    [anon_sym_abstract] = ACTIONS(1211),
    [anon_sym_interface] = ACTIONS(1213),
    [anon_sym_enum] = ACTIONS(1215),
  },
  [100] = {
    [sym_declaration] = STATE(737),
    [sym_import] = STATE(1819),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1872),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_class_declaration] = STATE(629),
    [sym_function] = STATE(1819),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function] = STATE(1819),
    [sym_generator_function_declaration] = STATE(629),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_function_signature] = STATE(629),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(1711),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3200),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1145),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(1147),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1153),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [101] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1217),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [102] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [103] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [104] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [105] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1232),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_implements] = ACTIONS(114),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [106] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [107] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1236),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [108] = {
    [sym_nested_identifier] = STATE(4008),
    [sym_string] = STATE(2528),
    [sym_formal_parameters] = STATE(3901),
    [sym_nested_type_identifier] = STATE(2442),
    [sym__type] = STATE(2570),
    [sym_constructor_type] = STATE(2570),
    [sym__primary_type] = STATE(2530),
    [sym_template_literal_type] = STATE(2536),
    [sym_infer_type] = STATE(2570),
    [sym_conditional_type] = STATE(2536),
    [sym_generic_type] = STATE(2536),
    [sym_type_query] = STATE(2536),
    [sym_index_type_query] = STATE(2536),
    [sym_lookup_type] = STATE(2536),
    [sym_literal_type] = STATE(2536),
    [sym__number] = STATE(2540),
    [sym_existential_type] = STATE(2536),
    [sym_flow_maybe_type] = STATE(2536),
    [sym_parenthesized_type] = STATE(2536),
    [sym_predefined_type] = STATE(2536),
    [sym_object_type] = STATE(2536),
    [sym_type_parameters] = STATE(3745),
    [sym_array_type] = STATE(2536),
    [sym_tuple_type] = STATE(2536),
    [sym_readonly_type] = STATE(2570),
    [sym_union_type] = STATE(2570),
    [sym_intersection_type] = STATE(2570),
    [sym_function_type] = STATE(2570),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1240),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_RBRACE] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(1244),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1250),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(1252),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(1254),
    [anon_sym_PLUS] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1256),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1262),
    [sym_number] = ACTIONS(1264),
    [sym_this] = ACTIONS(1266),
    [sym_true] = ACTIONS(1268),
    [sym_false] = ACTIONS(1268),
    [sym_null] = ACTIONS(1268),
    [sym_undefined] = ACTIONS(1268),
    [anon_sym_readonly] = ACTIONS(1270),
    [anon_sym_QMARK] = ACTIONS(1272),
    [anon_sym_any] = ACTIONS(725),
    [anon_sym_number] = ACTIONS(725),
    [anon_sym_boolean] = ACTIONS(725),
    [anon_sym_string] = ACTIONS(725),
    [anon_sym_symbol] = ACTIONS(725),
    [anon_sym_infer] = ACTIONS(721),
    [anon_sym_keyof] = ACTIONS(723),
    [anon_sym_unknown] = ACTIONS(725),
    [anon_sym_never] = ACTIONS(725),
    [anon_sym_object] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [109] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [110] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1280),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [111] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [112] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2405),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2405),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1171),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [113] = {
    [sym_statement_block] = STATE(117),
    [ts_builtin_sym_end] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_export] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_default] = ACTIONS(1286),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_as] = ACTIONS(1286),
    [anon_sym_namespace] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_COMMA] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_typeof] = ACTIONS(1286),
    [anon_sym_import] = ACTIONS(1286),
    [anon_sym_var] = ACTIONS(1286),
    [anon_sym_let] = ACTIONS(1286),
    [anon_sym_const] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_else] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_switch] = ACTIONS(1286),
    [anon_sym_for] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(1286),
    [anon_sym_in] = ACTIONS(1286),
    [anon_sym_while] = ACTIONS(1286),
    [anon_sym_do] = ACTIONS(1286),
    [anon_sym_try] = ACTIONS(1286),
    [anon_sym_with] = ACTIONS(1286),
    [anon_sym_break] = ACTIONS(1286),
    [anon_sym_continue] = ACTIONS(1286),
    [anon_sym_debugger] = ACTIONS(1286),
    [anon_sym_return] = ACTIONS(1286),
    [anon_sym_throw] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1284),
    [anon_sym_case] = ACTIONS(1286),
    [anon_sym_yield] = ACTIONS(1286),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(1286),
    [anon_sym_GT] = ACTIONS(1286),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1286),
    [anon_sym_function] = ACTIONS(1286),
    [anon_sym_QMARK_DOT] = ACTIONS(1284),
    [anon_sym_new] = ACTIONS(1286),
    [anon_sym_AMP_AMP] = ACTIONS(1284),
    [anon_sym_PIPE_PIPE] = ACTIONS(1284),
    [anon_sym_GT_GT] = ACTIONS(1286),
    [anon_sym_GT_GT_GT] = ACTIONS(1284),
    [anon_sym_LT_LT] = ACTIONS(1284),
    [anon_sym_AMP] = ACTIONS(1286),
    [anon_sym_CARET] = ACTIONS(1284),
    [anon_sym_PIPE] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_PERCENT] = ACTIONS(1284),
    [anon_sym_STAR_STAR] = ACTIONS(1284),
    [anon_sym_LT_EQ] = ACTIONS(1284),
    [anon_sym_EQ_EQ] = ACTIONS(1286),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1284),
    [anon_sym_BANG_EQ] = ACTIONS(1286),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1284),
    [anon_sym_GT_EQ] = ACTIONS(1284),
    [anon_sym_QMARK_QMARK] = ACTIONS(1284),
    [anon_sym_instanceof] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_void] = ACTIONS(1286),
    [anon_sym_delete] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [sym_number] = ACTIONS(1284),
    [sym_this] = ACTIONS(1286),
    [sym_super] = ACTIONS(1286),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_null] = ACTIONS(1286),
    [sym_undefined] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_readonly] = ACTIONS(1286),
    [anon_sym_get] = ACTIONS(1286),
    [anon_sym_set] = ACTIONS(1286),
    [anon_sym_declare] = ACTIONS(1286),
    [anon_sym_public] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1286),
    [anon_sym_protected] = ACTIONS(1286),
    [anon_sym_override] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_any] = ACTIONS(1286),
    [anon_sym_number] = ACTIONS(1286),
    [anon_sym_boolean] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [anon_sym_symbol] = ACTIONS(1286),
    [anon_sym_abstract] = ACTIONS(1286),
    [anon_sym_interface] = ACTIONS(1286),
    [anon_sym_enum] = ACTIONS(1286),
    [sym__automatic_semicolon] = ACTIONS(1284),
    [sym__ternary_qmark] = ACTIONS(1284),
  },
  [114] = {
    [sym_statement_block] = STATE(117),
    [ts_builtin_sym_end] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_export] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_default] = ACTIONS(1286),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_as] = ACTIONS(1286),
    [anon_sym_namespace] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_COMMA] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_typeof] = ACTIONS(1286),
    [anon_sym_import] = ACTIONS(1286),
    [anon_sym_var] = ACTIONS(1286),
    [anon_sym_let] = ACTIONS(1286),
    [anon_sym_const] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_else] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_switch] = ACTIONS(1286),
    [anon_sym_for] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(1286),
    [anon_sym_in] = ACTIONS(1286),
    [anon_sym_while] = ACTIONS(1286),
    [anon_sym_do] = ACTIONS(1286),
    [anon_sym_try] = ACTIONS(1286),
    [anon_sym_with] = ACTIONS(1286),
    [anon_sym_break] = ACTIONS(1286),
    [anon_sym_continue] = ACTIONS(1286),
    [anon_sym_debugger] = ACTIONS(1286),
    [anon_sym_return] = ACTIONS(1286),
    [anon_sym_throw] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1284),
    [anon_sym_case] = ACTIONS(1286),
    [anon_sym_yield] = ACTIONS(1286),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(1286),
    [anon_sym_GT] = ACTIONS(1286),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1286),
    [anon_sym_function] = ACTIONS(1286),
    [anon_sym_QMARK_DOT] = ACTIONS(1284),
    [anon_sym_new] = ACTIONS(1286),
    [anon_sym_AMP_AMP] = ACTIONS(1284),
    [anon_sym_PIPE_PIPE] = ACTIONS(1284),
    [anon_sym_GT_GT] = ACTIONS(1286),
    [anon_sym_GT_GT_GT] = ACTIONS(1284),
    [anon_sym_LT_LT] = ACTIONS(1284),
    [anon_sym_AMP] = ACTIONS(1286),
    [anon_sym_CARET] = ACTIONS(1284),
    [anon_sym_PIPE] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_PERCENT] = ACTIONS(1284),
    [anon_sym_STAR_STAR] = ACTIONS(1284),
    [anon_sym_LT_EQ] = ACTIONS(1284),
    [anon_sym_EQ_EQ] = ACTIONS(1286),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1284),
    [anon_sym_BANG_EQ] = ACTIONS(1286),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1284),
    [anon_sym_GT_EQ] = ACTIONS(1284),
    [anon_sym_QMARK_QMARK] = ACTIONS(1284),
    [anon_sym_instanceof] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_void] = ACTIONS(1286),
    [anon_sym_delete] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [sym_number] = ACTIONS(1284),
    [sym_this] = ACTIONS(1286),
    [sym_super] = ACTIONS(1286),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_null] = ACTIONS(1286),
    [sym_undefined] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_readonly] = ACTIONS(1286),
    [anon_sym_get] = ACTIONS(1286),
    [anon_sym_set] = ACTIONS(1286),
    [anon_sym_declare] = ACTIONS(1286),
    [anon_sym_public] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1286),
    [anon_sym_protected] = ACTIONS(1286),
    [anon_sym_override] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_any] = ACTIONS(1286),
    [anon_sym_number] = ACTIONS(1286),
    [anon_sym_boolean] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [anon_sym_symbol] = ACTIONS(1286),
    [anon_sym_abstract] = ACTIONS(1286),
    [anon_sym_interface] = ACTIONS(1286),
    [anon_sym_enum] = ACTIONS(1286),
    [sym__automatic_semicolon] = ACTIONS(1284),
    [sym__ternary_qmark] = ACTIONS(1284),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(1292),
    [sym_identifier] = ACTIONS(1294),
    [anon_sym_export] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1294),
    [anon_sym_type] = ACTIONS(1294),
    [anon_sym_EQ] = ACTIONS(1298),
    [anon_sym_as] = ACTIONS(1296),
    [anon_sym_namespace] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(1292),
    [anon_sym_COMMA] = ACTIONS(1300),
    [anon_sym_RBRACE] = ACTIONS(1292),
    [anon_sym_typeof] = ACTIONS(1294),
    [anon_sym_import] = ACTIONS(1294),
    [anon_sym_var] = ACTIONS(1294),
    [anon_sym_let] = ACTIONS(1294),
    [anon_sym_const] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_else] = ACTIONS(1294),
    [anon_sym_if] = ACTIONS(1294),
    [anon_sym_switch] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1294),
    [anon_sym_LPAREN] = ACTIONS(1292),
    [anon_sym_await] = ACTIONS(1294),
    [anon_sym_in] = ACTIONS(1296),
    [anon_sym_while] = ACTIONS(1294),
    [anon_sym_do] = ACTIONS(1294),
    [anon_sym_try] = ACTIONS(1294),
    [anon_sym_with] = ACTIONS(1294),
    [anon_sym_break] = ACTIONS(1294),
    [anon_sym_continue] = ACTIONS(1294),
    [anon_sym_debugger] = ACTIONS(1294),
    [anon_sym_return] = ACTIONS(1294),
    [anon_sym_throw] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1294),
    [anon_sym_yield] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_GT] = ACTIONS(1296),
    [anon_sym_SLASH] = ACTIONS(1294),
    [anon_sym_DOT] = ACTIONS(1296),
    [anon_sym_class] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1294),
    [anon_sym_function] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(1300),
    [anon_sym_new] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1300),
    [anon_sym_GT_GT] = ACTIONS(1296),
    [anon_sym_GT_GT_GT] = ACTIONS(1300),
    [anon_sym_LT_LT] = ACTIONS(1300),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_CARET] = ACTIONS(1300),
    [anon_sym_PIPE] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_PERCENT] = ACTIONS(1300),
    [anon_sym_STAR_STAR] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(1296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1300),
    [anon_sym_BANG_EQ] = ACTIONS(1296),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1300),
    [anon_sym_GT_EQ] = ACTIONS(1300),
    [anon_sym_QMARK_QMARK] = ACTIONS(1300),
    [anon_sym_instanceof] = ACTIONS(1296),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_void] = ACTIONS(1294),
    [anon_sym_delete] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1292),
    [anon_sym_DQUOTE] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1292),
    [sym_number] = ACTIONS(1292),
    [sym_this] = ACTIONS(1294),
    [sym_super] = ACTIONS(1294),
    [sym_true] = ACTIONS(1294),
    [sym_false] = ACTIONS(1294),
    [sym_null] = ACTIONS(1294),
    [sym_undefined] = ACTIONS(1294),
    [anon_sym_AT] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1294),
    [anon_sym_readonly] = ACTIONS(1294),
    [anon_sym_get] = ACTIONS(1294),
    [anon_sym_set] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_public] = ACTIONS(1294),
    [anon_sym_private] = ACTIONS(1294),
    [anon_sym_protected] = ACTIONS(1294),
    [anon_sym_override] = ACTIONS(1294),
    [anon_sym_module] = ACTIONS(1294),
    [anon_sym_any] = ACTIONS(1294),
    [anon_sym_number] = ACTIONS(1294),
    [anon_sym_boolean] = ACTIONS(1294),
    [anon_sym_string] = ACTIONS(1294),
    [anon_sym_symbol] = ACTIONS(1294),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_interface] = ACTIONS(1294),
    [anon_sym_enum] = ACTIONS(1294),
    [sym__automatic_semicolon] = ACTIONS(1302),
    [sym__ternary_qmark] = ACTIONS(1300),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(1304),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_export] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1306),
    [anon_sym_default] = ACTIONS(1306),
    [anon_sym_type] = ACTIONS(1306),
    [anon_sym_as] = ACTIONS(1306),
    [anon_sym_namespace] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1304),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_typeof] = ACTIONS(1306),
    [anon_sym_import] = ACTIONS(1306),
    [anon_sym_var] = ACTIONS(1306),
    [anon_sym_let] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_BANG] = ACTIONS(1306),
    [anon_sym_else] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_switch] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_LPAREN] = ACTIONS(1304),
    [anon_sym_await] = ACTIONS(1306),
    [anon_sym_in] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_do] = ACTIONS(1306),
    [anon_sym_try] = ACTIONS(1306),
    [anon_sym_with] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_debugger] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_throw] = ACTIONS(1306),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_case] = ACTIONS(1306),
    [anon_sym_yield] = ACTIONS(1306),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1306),
    [anon_sym_SLASH] = ACTIONS(1306),
    [anon_sym_DOT] = ACTIONS(1306),
    [anon_sym_class] = ACTIONS(1306),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_function] = ACTIONS(1306),
    [anon_sym_QMARK_DOT] = ACTIONS(1304),
    [anon_sym_new] = ACTIONS(1306),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1306),
    [anon_sym_GT_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1306),
    [anon_sym_CARET] = ACTIONS(1304),
    [anon_sym_PIPE] = ACTIONS(1306),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_PERCENT] = ACTIONS(1304),
    [anon_sym_STAR_STAR] = ACTIONS(1304),
    [anon_sym_LT_EQ] = ACTIONS(1304),
    [anon_sym_EQ_EQ] = ACTIONS(1306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1304),
    [anon_sym_BANG_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1304),
    [anon_sym_QMARK_QMARK] = ACTIONS(1304),
    [anon_sym_instanceof] = ACTIONS(1306),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_void] = ACTIONS(1306),
    [anon_sym_delete] = ACTIONS(1306),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [sym_number] = ACTIONS(1304),
    [sym_this] = ACTIONS(1306),
    [sym_super] = ACTIONS(1306),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [sym_null] = ACTIONS(1306),
    [sym_undefined] = ACTIONS(1306),
    [anon_sym_AT] = ACTIONS(1304),
    [anon_sym_static] = ACTIONS(1306),
    [anon_sym_readonly] = ACTIONS(1306),
    [anon_sym_get] = ACTIONS(1306),
    [anon_sym_set] = ACTIONS(1306),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_public] = ACTIONS(1306),
    [anon_sym_private] = ACTIONS(1306),
    [anon_sym_protected] = ACTIONS(1306),
    [anon_sym_override] = ACTIONS(1306),
    [anon_sym_module] = ACTIONS(1306),
    [anon_sym_any] = ACTIONS(1306),
    [anon_sym_number] = ACTIONS(1306),
    [anon_sym_boolean] = ACTIONS(1306),
    [anon_sym_string] = ACTIONS(1306),
    [anon_sym_symbol] = ACTIONS(1306),
    [anon_sym_abstract] = ACTIONS(1306),
    [anon_sym_interface] = ACTIONS(1306),
    [anon_sym_enum] = ACTIONS(1306),
    [sym__automatic_semicolon] = ACTIONS(1304),
    [sym__ternary_qmark] = ACTIONS(1304),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(1308),
    [sym_identifier] = ACTIONS(1310),
    [anon_sym_export] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1310),
    [anon_sym_default] = ACTIONS(1310),
    [anon_sym_type] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(1310),
    [anon_sym_namespace] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(1310),
    [anon_sym_import] = ACTIONS(1310),
    [anon_sym_var] = ACTIONS(1310),
    [anon_sym_let] = ACTIONS(1310),
    [anon_sym_const] = ACTIONS(1310),
    [anon_sym_BANG] = ACTIONS(1310),
    [anon_sym_else] = ACTIONS(1310),
    [anon_sym_if] = ACTIONS(1310),
    [anon_sym_switch] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1310),
    [anon_sym_LPAREN] = ACTIONS(1308),
    [anon_sym_await] = ACTIONS(1310),
    [anon_sym_in] = ACTIONS(1310),
    [anon_sym_while] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1310),
    [anon_sym_with] = ACTIONS(1310),
    [anon_sym_break] = ACTIONS(1310),
    [anon_sym_continue] = ACTIONS(1310),
    [anon_sym_debugger] = ACTIONS(1310),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_throw] = ACTIONS(1310),
    [anon_sym_SEMI] = ACTIONS(1308),
    [anon_sym_case] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_SLASH] = ACTIONS(1310),
    [anon_sym_DOT] = ACTIONS(1310),
    [anon_sym_class] = ACTIONS(1310),
    [anon_sym_async] = ACTIONS(1310),
    [anon_sym_function] = ACTIONS(1310),
    [anon_sym_QMARK_DOT] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1310),
    [anon_sym_AMP_AMP] = ACTIONS(1308),
    [anon_sym_PIPE_PIPE] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(1310),
    [anon_sym_GT_GT_GT] = ACTIONS(1308),
    [anon_sym_LT_LT] = ACTIONS(1308),
    [anon_sym_AMP] = ACTIONS(1310),
    [anon_sym_CARET] = ACTIONS(1308),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_PERCENT] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(1308),
    [anon_sym_LT_EQ] = ACTIONS(1308),
    [anon_sym_EQ_EQ] = ACTIONS(1310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1308),
    [anon_sym_BANG_EQ] = ACTIONS(1310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1308),
    [anon_sym_GT_EQ] = ACTIONS(1308),
    [anon_sym_QMARK_QMARK] = ACTIONS(1308),
    [anon_sym_instanceof] = ACTIONS(1310),
    [anon_sym_TILDE] = ACTIONS(1308),
    [anon_sym_void] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1310),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [anon_sym_DASH_DASH] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(1308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1308),
    [sym_number] = ACTIONS(1308),
    [sym_this] = ACTIONS(1310),
    [sym_super] = ACTIONS(1310),
    [sym_true] = ACTIONS(1310),
    [sym_false] = ACTIONS(1310),
    [sym_null] = ACTIONS(1310),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1310),
    [anon_sym_readonly] = ACTIONS(1310),
    [anon_sym_get] = ACTIONS(1310),
    [anon_sym_set] = ACTIONS(1310),
    [anon_sym_declare] = ACTIONS(1310),
    [anon_sym_public] = ACTIONS(1310),
    [anon_sym_private] = ACTIONS(1310),
    [anon_sym_protected] = ACTIONS(1310),
    [anon_sym_override] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1310),
    [anon_sym_any] = ACTIONS(1310),
    [anon_sym_number] = ACTIONS(1310),
    [anon_sym_boolean] = ACTIONS(1310),
    [anon_sym_string] = ACTIONS(1310),
    [anon_sym_symbol] = ACTIONS(1310),
    [anon_sym_abstract] = ACTIONS(1310),
    [anon_sym_interface] = ACTIONS(1310),
    [anon_sym_enum] = ACTIONS(1310),
    [sym__automatic_semicolon] = ACTIONS(1308),
    [sym__ternary_qmark] = ACTIONS(1308),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(1312),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_export] = ACTIONS(1314),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1316),
    [anon_sym_namespace] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_COMMA] = ACTIONS(1318),
    [anon_sym_RBRACE] = ACTIONS(1312),
    [anon_sym_typeof] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(1314),
    [anon_sym_var] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_BANG] = ACTIONS(1314),
    [anon_sym_else] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_switch] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_LPAREN] = ACTIONS(1312),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_in] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_do] = ACTIONS(1314),
    [anon_sym_try] = ACTIONS(1314),
    [anon_sym_with] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_debugger] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_throw] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1312),
    [anon_sym_case] = ACTIONS(1314),
    [anon_sym_yield] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LT] = ACTIONS(1314),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_SLASH] = ACTIONS(1314),
    [anon_sym_DOT] = ACTIONS(1316),
    [anon_sym_class] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_function] = ACTIONS(1314),
    [anon_sym_QMARK_DOT] = ACTIONS(1318),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1318),
    [anon_sym_PIPE_PIPE] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1316),
    [anon_sym_GT_GT_GT] = ACTIONS(1318),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1318),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(1314),
    [anon_sym_DASH] = ACTIONS(1314),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_STAR_STAR] = ACTIONS(1318),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_EQ_EQ] = ACTIONS(1316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1316),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1318),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_QMARK_QMARK] = ACTIONS(1318),
    [anon_sym_instanceof] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_void] = ACTIONS(1314),
    [anon_sym_delete] = ACTIONS(1314),
    [anon_sym_PLUS_PLUS] = ACTIONS(1312),
    [anon_sym_DASH_DASH] = ACTIONS(1312),
    [anon_sym_DQUOTE] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1312),
    [sym_number] = ACTIONS(1312),
    [sym_this] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_true] = ACTIONS(1314),
    [sym_false] = ACTIONS(1314),
    [sym_null] = ACTIONS(1314),
    [sym_undefined] = ACTIONS(1314),
    [anon_sym_AT] = ACTIONS(1312),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_readonly] = ACTIONS(1314),
    [anon_sym_get] = ACTIONS(1314),
    [anon_sym_set] = ACTIONS(1314),
    [anon_sym_declare] = ACTIONS(1314),
    [anon_sym_public] = ACTIONS(1314),
    [anon_sym_private] = ACTIONS(1314),
    [anon_sym_protected] = ACTIONS(1314),
    [anon_sym_override] = ACTIONS(1314),
    [anon_sym_module] = ACTIONS(1314),
    [anon_sym_any] = ACTIONS(1314),
    [anon_sym_number] = ACTIONS(1314),
    [anon_sym_boolean] = ACTIONS(1314),
    [anon_sym_string] = ACTIONS(1314),
    [anon_sym_symbol] = ACTIONS(1314),
    [anon_sym_abstract] = ACTIONS(1314),
    [anon_sym_interface] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [sym__automatic_semicolon] = ACTIONS(1320),
    [sym__ternary_qmark] = ACTIONS(1318),
  },
  [119] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1442),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym__formal_parameter] = STATE(3589),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(3906),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3589),
    [sym_optional_parameter] = STATE(3589),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1324),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(1328),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_override] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(1330),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_export] = ACTIONS(1332),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_default] = ACTIONS(1332),
    [anon_sym_type] = ACTIONS(1332),
    [anon_sym_as] = ACTIONS(1332),
    [anon_sym_namespace] = ACTIONS(1332),
    [anon_sym_LBRACE] = ACTIONS(1330),
    [anon_sym_COMMA] = ACTIONS(1330),
    [anon_sym_RBRACE] = ACTIONS(1330),
    [anon_sym_typeof] = ACTIONS(1332),
    [anon_sym_import] = ACTIONS(1332),
    [anon_sym_var] = ACTIONS(1332),
    [anon_sym_let] = ACTIONS(1332),
    [anon_sym_const] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_else] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(1332),
    [anon_sym_switch] = ACTIONS(1332),
    [anon_sym_for] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1330),
    [anon_sym_await] = ACTIONS(1332),
    [anon_sym_in] = ACTIONS(1332),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_do] = ACTIONS(1332),
    [anon_sym_try] = ACTIONS(1332),
    [anon_sym_with] = ACTIONS(1332),
    [anon_sym_break] = ACTIONS(1332),
    [anon_sym_continue] = ACTIONS(1332),
    [anon_sym_debugger] = ACTIONS(1332),
    [anon_sym_return] = ACTIONS(1332),
    [anon_sym_throw] = ACTIONS(1332),
    [anon_sym_SEMI] = ACTIONS(1330),
    [anon_sym_case] = ACTIONS(1332),
    [anon_sym_yield] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1330),
    [anon_sym_LT] = ACTIONS(1332),
    [anon_sym_GT] = ACTIONS(1332),
    [anon_sym_SLASH] = ACTIONS(1332),
    [anon_sym_DOT] = ACTIONS(1332),
    [anon_sym_class] = ACTIONS(1332),
    [anon_sym_async] = ACTIONS(1332),
    [anon_sym_function] = ACTIONS(1332),
    [anon_sym_QMARK_DOT] = ACTIONS(1330),
    [anon_sym_new] = ACTIONS(1332),
    [anon_sym_AMP_AMP] = ACTIONS(1330),
    [anon_sym_PIPE_PIPE] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1330),
    [anon_sym_LT_LT] = ACTIONS(1330),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_CARET] = ACTIONS(1330),
    [anon_sym_PIPE] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1332),
    [anon_sym_PERCENT] = ACTIONS(1330),
    [anon_sym_STAR_STAR] = ACTIONS(1330),
    [anon_sym_LT_EQ] = ACTIONS(1330),
    [anon_sym_EQ_EQ] = ACTIONS(1332),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1330),
    [anon_sym_BANG_EQ] = ACTIONS(1332),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1330),
    [anon_sym_GT_EQ] = ACTIONS(1330),
    [anon_sym_QMARK_QMARK] = ACTIONS(1330),
    [anon_sym_instanceof] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1330),
    [anon_sym_void] = ACTIONS(1332),
    [anon_sym_delete] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1330),
    [anon_sym_DASH_DASH] = ACTIONS(1330),
    [anon_sym_DQUOTE] = ACTIONS(1330),
    [anon_sym_SQUOTE] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1330),
    [sym_number] = ACTIONS(1330),
    [sym_this] = ACTIONS(1332),
    [sym_super] = ACTIONS(1332),
    [sym_true] = ACTIONS(1332),
    [sym_false] = ACTIONS(1332),
    [sym_null] = ACTIONS(1332),
    [sym_undefined] = ACTIONS(1332),
    [anon_sym_AT] = ACTIONS(1330),
    [anon_sym_static] = ACTIONS(1332),
    [anon_sym_readonly] = ACTIONS(1332),
    [anon_sym_get] = ACTIONS(1332),
    [anon_sym_set] = ACTIONS(1332),
    [anon_sym_declare] = ACTIONS(1332),
    [anon_sym_public] = ACTIONS(1332),
    [anon_sym_private] = ACTIONS(1332),
    [anon_sym_protected] = ACTIONS(1332),
    [anon_sym_override] = ACTIONS(1332),
    [anon_sym_module] = ACTIONS(1332),
    [anon_sym_any] = ACTIONS(1332),
    [anon_sym_number] = ACTIONS(1332),
    [anon_sym_boolean] = ACTIONS(1332),
    [anon_sym_string] = ACTIONS(1332),
    [anon_sym_symbol] = ACTIONS(1332),
    [anon_sym_abstract] = ACTIONS(1332),
    [anon_sym_interface] = ACTIONS(1332),
    [anon_sym_enum] = ACTIONS(1332),
    [sym__automatic_semicolon] = ACTIONS(1330),
    [sym__ternary_qmark] = ACTIONS(1330),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(1334),
    [sym_identifier] = ACTIONS(1336),
    [anon_sym_export] = ACTIONS(1336),
    [anon_sym_STAR] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1338),
    [anon_sym_namespace] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_COMMA] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [anon_sym_typeof] = ACTIONS(1336),
    [anon_sym_import] = ACTIONS(1336),
    [anon_sym_var] = ACTIONS(1336),
    [anon_sym_let] = ACTIONS(1336),
    [anon_sym_const] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_else] = ACTIONS(1336),
    [anon_sym_if] = ACTIONS(1336),
    [anon_sym_switch] = ACTIONS(1336),
    [anon_sym_for] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_await] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1336),
    [anon_sym_do] = ACTIONS(1336),
    [anon_sym_try] = ACTIONS(1336),
    [anon_sym_with] = ACTIONS(1336),
    [anon_sym_break] = ACTIONS(1336),
    [anon_sym_continue] = ACTIONS(1336),
    [anon_sym_debugger] = ACTIONS(1336),
    [anon_sym_return] = ACTIONS(1336),
    [anon_sym_throw] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1338),
    [anon_sym_SLASH] = ACTIONS(1336),
    [anon_sym_DOT] = ACTIONS(1338),
    [anon_sym_class] = ACTIONS(1336),
    [anon_sym_async] = ACTIONS(1336),
    [anon_sym_function] = ACTIONS(1336),
    [anon_sym_QMARK_DOT] = ACTIONS(1340),
    [anon_sym_new] = ACTIONS(1336),
    [anon_sym_AMP_AMP] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1340),
    [anon_sym_GT_GT] = ACTIONS(1338),
    [anon_sym_GT_GT_GT] = ACTIONS(1340),
    [anon_sym_LT_LT] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1338),
    [anon_sym_PLUS] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1336),
    [anon_sym_PERCENT] = ACTIONS(1340),
    [anon_sym_STAR_STAR] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1340),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1340),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1340),
    [anon_sym_QMARK_QMARK] = ACTIONS(1340),
    [anon_sym_instanceof] = ACTIONS(1338),
    [anon_sym_TILDE] = ACTIONS(1334),
    [anon_sym_void] = ACTIONS(1336),
    [anon_sym_delete] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1334),
    [anon_sym_DQUOTE] = ACTIONS(1334),
    [anon_sym_SQUOTE] = ACTIONS(1334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1334),
    [sym_number] = ACTIONS(1334),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(1336),
    [sym_true] = ACTIONS(1336),
    [sym_false] = ACTIONS(1336),
    [sym_null] = ACTIONS(1336),
    [sym_undefined] = ACTIONS(1336),
    [anon_sym_AT] = ACTIONS(1334),
    [anon_sym_static] = ACTIONS(1336),
    [anon_sym_readonly] = ACTIONS(1336),
    [anon_sym_get] = ACTIONS(1336),
    [anon_sym_set] = ACTIONS(1336),
    [anon_sym_declare] = ACTIONS(1336),
    [anon_sym_public] = ACTIONS(1336),
    [anon_sym_private] = ACTIONS(1336),
    [anon_sym_protected] = ACTIONS(1336),
    [anon_sym_override] = ACTIONS(1336),
    [anon_sym_module] = ACTIONS(1336),
    [anon_sym_any] = ACTIONS(1336),
    [anon_sym_number] = ACTIONS(1336),
    [anon_sym_boolean] = ACTIONS(1336),
    [anon_sym_string] = ACTIONS(1336),
    [anon_sym_symbol] = ACTIONS(1336),
    [anon_sym_abstract] = ACTIONS(1336),
    [anon_sym_interface] = ACTIONS(1336),
    [anon_sym_enum] = ACTIONS(1336),
    [sym__automatic_semicolon] = ACTIONS(1342),
    [sym__ternary_qmark] = ACTIONS(1340),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_export] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_as] = ACTIONS(1346),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_var] = ACTIONS(1346),
    [anon_sym_let] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1346),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_debugger] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_throw] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1346),
    [anon_sym_DOT] = ACTIONS(1346),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1346),
    [anon_sym_QMARK_DOT] = ACTIONS(1344),
    [anon_sym_new] = ACTIONS(1346),
    [anon_sym_AMP_AMP] = ACTIONS(1344),
    [anon_sym_PIPE_PIPE] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1346),
    [anon_sym_GT_GT_GT] = ACTIONS(1344),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_AMP] = ACTIONS(1346),
    [anon_sym_CARET] = ACTIONS(1344),
    [anon_sym_PIPE] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1344),
    [anon_sym_STAR_STAR] = ACTIONS(1344),
    [anon_sym_LT_EQ] = ACTIONS(1344),
    [anon_sym_EQ_EQ] = ACTIONS(1346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1344),
    [anon_sym_BANG_EQ] = ACTIONS(1346),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1344),
    [anon_sym_GT_EQ] = ACTIONS(1344),
    [anon_sym_QMARK_QMARK] = ACTIONS(1344),
    [anon_sym_instanceof] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_void] = ACTIONS(1346),
    [anon_sym_delete] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1344),
    [sym_number] = ACTIONS(1344),
    [sym_this] = ACTIONS(1346),
    [sym_super] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_null] = ACTIONS(1346),
    [sym_undefined] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_readonly] = ACTIONS(1346),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_declare] = ACTIONS(1346),
    [anon_sym_public] = ACTIONS(1346),
    [anon_sym_private] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1346),
    [anon_sym_override] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_any] = ACTIONS(1346),
    [anon_sym_number] = ACTIONS(1346),
    [anon_sym_boolean] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [anon_sym_symbol] = ACTIONS(1346),
    [anon_sym_abstract] = ACTIONS(1346),
    [anon_sym_interface] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1348),
    [sym__ternary_qmark] = ACTIONS(1344),
  },
  [123] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1497),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym__formal_parameter] = STATE(3589),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(3897),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3589),
    [sym_optional_parameter] = STATE(3589),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1324),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(1328),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_override] = ACTIONS(669),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(1350),
    [sym_identifier] = ACTIONS(1352),
    [anon_sym_export] = ACTIONS(1352),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_default] = ACTIONS(1352),
    [anon_sym_type] = ACTIONS(1352),
    [anon_sym_as] = ACTIONS(1352),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_typeof] = ACTIONS(1352),
    [anon_sym_import] = ACTIONS(1352),
    [anon_sym_var] = ACTIONS(1352),
    [anon_sym_let] = ACTIONS(1352),
    [anon_sym_const] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_else] = ACTIONS(1352),
    [anon_sym_if] = ACTIONS(1352),
    [anon_sym_switch] = ACTIONS(1352),
    [anon_sym_for] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [anon_sym_await] = ACTIONS(1352),
    [anon_sym_in] = ACTIONS(1352),
    [anon_sym_while] = ACTIONS(1352),
    [anon_sym_do] = ACTIONS(1352),
    [anon_sym_try] = ACTIONS(1352),
    [anon_sym_with] = ACTIONS(1352),
    [anon_sym_break] = ACTIONS(1352),
    [anon_sym_continue] = ACTIONS(1352),
    [anon_sym_debugger] = ACTIONS(1352),
    [anon_sym_return] = ACTIONS(1352),
    [anon_sym_throw] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1352),
    [anon_sym_yield] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1352),
    [anon_sym_SLASH] = ACTIONS(1352),
    [anon_sym_DOT] = ACTIONS(1352),
    [anon_sym_class] = ACTIONS(1352),
    [anon_sym_async] = ACTIONS(1352),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_QMARK_DOT] = ACTIONS(1350),
    [anon_sym_new] = ACTIONS(1352),
    [anon_sym_AMP_AMP] = ACTIONS(1350),
    [anon_sym_PIPE_PIPE] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1352),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PIPE] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_LT_EQ] = ACTIONS(1350),
    [anon_sym_EQ_EQ] = ACTIONS(1352),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1350),
    [anon_sym_BANG_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1350),
    [anon_sym_QMARK_QMARK] = ACTIONS(1350),
    [anon_sym_instanceof] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_void] = ACTIONS(1352),
    [anon_sym_delete] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1350),
    [sym_number] = ACTIONS(1350),
    [sym_this] = ACTIONS(1352),
    [sym_super] = ACTIONS(1352),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [sym_null] = ACTIONS(1352),
    [sym_undefined] = ACTIONS(1352),
    [anon_sym_AT] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1352),
    [anon_sym_readonly] = ACTIONS(1352),
    [anon_sym_get] = ACTIONS(1352),
    [anon_sym_set] = ACTIONS(1352),
    [anon_sym_declare] = ACTIONS(1352),
    [anon_sym_public] = ACTIONS(1352),
    [anon_sym_private] = ACTIONS(1352),
    [anon_sym_protected] = ACTIONS(1352),
    [anon_sym_override] = ACTIONS(1352),
    [anon_sym_module] = ACTIONS(1352),
    [anon_sym_any] = ACTIONS(1352),
    [anon_sym_number] = ACTIONS(1352),
    [anon_sym_boolean] = ACTIONS(1352),
    [anon_sym_string] = ACTIONS(1352),
    [anon_sym_symbol] = ACTIONS(1352),
    [anon_sym_abstract] = ACTIONS(1352),
    [anon_sym_interface] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1352),
    [sym__automatic_semicolon] = ACTIONS(1350),
    [sym__ternary_qmark] = ACTIONS(1350),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(1354),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(1356),
    [anon_sym_STAR] = ACTIONS(1356),
    [anon_sym_default] = ACTIONS(1356),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_as] = ACTIONS(1356),
    [anon_sym_namespace] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_COMMA] = ACTIONS(1354),
    [anon_sym_RBRACE] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1356),
    [anon_sym_var] = ACTIONS(1356),
    [anon_sym_let] = ACTIONS(1356),
    [anon_sym_const] = ACTIONS(1356),
    [anon_sym_BANG] = ACTIONS(1356),
    [anon_sym_else] = ACTIONS(1356),
    [anon_sym_if] = ACTIONS(1356),
    [anon_sym_switch] = ACTIONS(1356),
    [anon_sym_for] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1354),
    [anon_sym_await] = ACTIONS(1356),
    [anon_sym_in] = ACTIONS(1356),
    [anon_sym_while] = ACTIONS(1356),
    [anon_sym_do] = ACTIONS(1356),
    [anon_sym_try] = ACTIONS(1356),
    [anon_sym_with] = ACTIONS(1356),
    [anon_sym_break] = ACTIONS(1356),
    [anon_sym_continue] = ACTIONS(1356),
    [anon_sym_debugger] = ACTIONS(1356),
    [anon_sym_return] = ACTIONS(1356),
    [anon_sym_throw] = ACTIONS(1356),
    [anon_sym_SEMI] = ACTIONS(1354),
    [anon_sym_case] = ACTIONS(1356),
    [anon_sym_yield] = ACTIONS(1356),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_LT] = ACTIONS(1356),
    [anon_sym_GT] = ACTIONS(1356),
    [anon_sym_SLASH] = ACTIONS(1356),
    [anon_sym_DOT] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1356),
    [anon_sym_async] = ACTIONS(1356),
    [anon_sym_function] = ACTIONS(1356),
    [anon_sym_QMARK_DOT] = ACTIONS(1354),
    [anon_sym_new] = ACTIONS(1356),
    [anon_sym_AMP_AMP] = ACTIONS(1354),
    [anon_sym_PIPE_PIPE] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(1356),
    [anon_sym_GT_GT_GT] = ACTIONS(1354),
    [anon_sym_LT_LT] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1354),
    [anon_sym_PIPE] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_PERCENT] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(1354),
    [anon_sym_LT_EQ] = ACTIONS(1354),
    [anon_sym_EQ_EQ] = ACTIONS(1356),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1354),
    [anon_sym_BANG_EQ] = ACTIONS(1356),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1354),
    [anon_sym_GT_EQ] = ACTIONS(1354),
    [anon_sym_QMARK_QMARK] = ACTIONS(1354),
    [anon_sym_instanceof] = ACTIONS(1356),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_void] = ACTIONS(1356),
    [anon_sym_delete] = ACTIONS(1356),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(1354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [sym_number] = ACTIONS(1354),
    [sym_this] = ACTIONS(1356),
    [sym_super] = ACTIONS(1356),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [sym_null] = ACTIONS(1356),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_AT] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1356),
    [anon_sym_readonly] = ACTIONS(1356),
    [anon_sym_get] = ACTIONS(1356),
    [anon_sym_set] = ACTIONS(1356),
    [anon_sym_declare] = ACTIONS(1356),
    [anon_sym_public] = ACTIONS(1356),
    [anon_sym_private] = ACTIONS(1356),
    [anon_sym_protected] = ACTIONS(1356),
    [anon_sym_override] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1356),
    [anon_sym_any] = ACTIONS(1356),
    [anon_sym_number] = ACTIONS(1356),
    [anon_sym_boolean] = ACTIONS(1356),
    [anon_sym_string] = ACTIONS(1356),
    [anon_sym_symbol] = ACTIONS(1356),
    [anon_sym_abstract] = ACTIONS(1356),
    [anon_sym_interface] = ACTIONS(1356),
    [anon_sym_enum] = ACTIONS(1356),
    [sym__automatic_semicolon] = ACTIONS(1354),
    [sym__ternary_qmark] = ACTIONS(1354),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_export] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_as] = ACTIONS(1346),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_var] = ACTIONS(1346),
    [anon_sym_let] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1346),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_debugger] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_throw] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1346),
    [anon_sym_DOT] = ACTIONS(1346),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1346),
    [anon_sym_QMARK_DOT] = ACTIONS(1344),
    [anon_sym_new] = ACTIONS(1346),
    [anon_sym_AMP_AMP] = ACTIONS(1344),
    [anon_sym_PIPE_PIPE] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1346),
    [anon_sym_GT_GT_GT] = ACTIONS(1344),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_AMP] = ACTIONS(1346),
    [anon_sym_CARET] = ACTIONS(1344),
    [anon_sym_PIPE] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1344),
    [anon_sym_STAR_STAR] = ACTIONS(1344),
    [anon_sym_LT_EQ] = ACTIONS(1344),
    [anon_sym_EQ_EQ] = ACTIONS(1346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1344),
    [anon_sym_BANG_EQ] = ACTIONS(1346),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1344),
    [anon_sym_GT_EQ] = ACTIONS(1344),
    [anon_sym_QMARK_QMARK] = ACTIONS(1344),
    [anon_sym_instanceof] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_void] = ACTIONS(1346),
    [anon_sym_delete] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1344),
    [sym_number] = ACTIONS(1344),
    [sym_this] = ACTIONS(1346),
    [sym_super] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_null] = ACTIONS(1346),
    [sym_undefined] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_readonly] = ACTIONS(1346),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_declare] = ACTIONS(1346),
    [anon_sym_public] = ACTIONS(1346),
    [anon_sym_private] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1346),
    [anon_sym_override] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_any] = ACTIONS(1346),
    [anon_sym_number] = ACTIONS(1346),
    [anon_sym_boolean] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [anon_sym_symbol] = ACTIONS(1346),
    [anon_sym_abstract] = ACTIONS(1346),
    [anon_sym_interface] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1344),
    [sym__ternary_qmark] = ACTIONS(1344),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(1358),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_STAR] = ACTIONS(1360),
    [anon_sym_default] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_as] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [anon_sym_typeof] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(1360),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1360),
    [anon_sym_const] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1360),
    [anon_sym_else] = ACTIONS(1360),
    [anon_sym_if] = ACTIONS(1360),
    [anon_sym_switch] = ACTIONS(1360),
    [anon_sym_for] = ACTIONS(1360),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_await] = ACTIONS(1360),
    [anon_sym_in] = ACTIONS(1360),
    [anon_sym_while] = ACTIONS(1360),
    [anon_sym_do] = ACTIONS(1360),
    [anon_sym_try] = ACTIONS(1360),
    [anon_sym_with] = ACTIONS(1360),
    [anon_sym_break] = ACTIONS(1360),
    [anon_sym_continue] = ACTIONS(1360),
    [anon_sym_debugger] = ACTIONS(1360),
    [anon_sym_return] = ACTIONS(1360),
    [anon_sym_throw] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1358),
    [anon_sym_case] = ACTIONS(1360),
    [anon_sym_yield] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1358),
    [anon_sym_LT] = ACTIONS(1360),
    [anon_sym_GT] = ACTIONS(1360),
    [anon_sym_SLASH] = ACTIONS(1360),
    [anon_sym_DOT] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1360),
    [anon_sym_QMARK_DOT] = ACTIONS(1358),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_AMP_AMP] = ACTIONS(1358),
    [anon_sym_PIPE_PIPE] = ACTIONS(1358),
    [anon_sym_GT_GT] = ACTIONS(1360),
    [anon_sym_GT_GT_GT] = ACTIONS(1358),
    [anon_sym_LT_LT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1358),
    [anon_sym_PIPE] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1360),
    [anon_sym_PERCENT] = ACTIONS(1358),
    [anon_sym_STAR_STAR] = ACTIONS(1358),
    [anon_sym_LT_EQ] = ACTIONS(1358),
    [anon_sym_EQ_EQ] = ACTIONS(1360),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1358),
    [anon_sym_BANG_EQ] = ACTIONS(1360),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1358),
    [anon_sym_GT_EQ] = ACTIONS(1358),
    [anon_sym_QMARK_QMARK] = ACTIONS(1358),
    [anon_sym_instanceof] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_void] = ACTIONS(1360),
    [anon_sym_delete] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1358),
    [anon_sym_DQUOTE] = ACTIONS(1358),
    [anon_sym_SQUOTE] = ACTIONS(1358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1358),
    [sym_number] = ACTIONS(1358),
    [sym_this] = ACTIONS(1360),
    [sym_super] = ACTIONS(1360),
    [sym_true] = ACTIONS(1360),
    [sym_false] = ACTIONS(1360),
    [sym_null] = ACTIONS(1360),
    [sym_undefined] = ACTIONS(1360),
    [anon_sym_AT] = ACTIONS(1358),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_readonly] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_override] = ACTIONS(1360),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_abstract] = ACTIONS(1360),
    [anon_sym_interface] = ACTIONS(1360),
    [anon_sym_enum] = ACTIONS(1360),
    [sym__automatic_semicolon] = ACTIONS(1358),
    [sym__ternary_qmark] = ACTIONS(1358),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(1362),
    [sym_identifier] = ACTIONS(1364),
    [anon_sym_export] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_default] = ACTIONS(1364),
    [anon_sym_type] = ACTIONS(1364),
    [anon_sym_as] = ACTIONS(1364),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1362),
    [anon_sym_COMMA] = ACTIONS(1362),
    [anon_sym_RBRACE] = ACTIONS(1362),
    [anon_sym_typeof] = ACTIONS(1364),
    [anon_sym_import] = ACTIONS(1364),
    [anon_sym_var] = ACTIONS(1364),
    [anon_sym_let] = ACTIONS(1364),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_else] = ACTIONS(1364),
    [anon_sym_if] = ACTIONS(1364),
    [anon_sym_switch] = ACTIONS(1364),
    [anon_sym_for] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1362),
    [anon_sym_await] = ACTIONS(1364),
    [anon_sym_in] = ACTIONS(1364),
    [anon_sym_while] = ACTIONS(1364),
    [anon_sym_do] = ACTIONS(1364),
    [anon_sym_try] = ACTIONS(1364),
    [anon_sym_with] = ACTIONS(1364),
    [anon_sym_break] = ACTIONS(1364),
    [anon_sym_continue] = ACTIONS(1364),
    [anon_sym_debugger] = ACTIONS(1364),
    [anon_sym_return] = ACTIONS(1364),
    [anon_sym_throw] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1362),
    [anon_sym_case] = ACTIONS(1364),
    [anon_sym_yield] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_LT] = ACTIONS(1364),
    [anon_sym_GT] = ACTIONS(1364),
    [anon_sym_SLASH] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1364),
    [anon_sym_class] = ACTIONS(1364),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(1364),
    [anon_sym_QMARK_DOT] = ACTIONS(1362),
    [anon_sym_new] = ACTIONS(1364),
    [anon_sym_AMP_AMP] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1362),
    [anon_sym_GT_GT] = ACTIONS(1364),
    [anon_sym_GT_GT_GT] = ACTIONS(1362),
    [anon_sym_LT_LT] = ACTIONS(1362),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_CARET] = ACTIONS(1362),
    [anon_sym_PIPE] = ACTIONS(1364),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_PERCENT] = ACTIONS(1362),
    [anon_sym_STAR_STAR] = ACTIONS(1362),
    [anon_sym_LT_EQ] = ACTIONS(1362),
    [anon_sym_EQ_EQ] = ACTIONS(1364),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1362),
    [anon_sym_BANG_EQ] = ACTIONS(1364),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1362),
    [anon_sym_GT_EQ] = ACTIONS(1362),
    [anon_sym_QMARK_QMARK] = ACTIONS(1362),
    [anon_sym_instanceof] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1362),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_delete] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(1362),
    [anon_sym_DQUOTE] = ACTIONS(1362),
    [anon_sym_SQUOTE] = ACTIONS(1362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1362),
    [sym_number] = ACTIONS(1362),
    [sym_this] = ACTIONS(1364),
    [sym_super] = ACTIONS(1364),
    [sym_true] = ACTIONS(1364),
    [sym_false] = ACTIONS(1364),
    [sym_null] = ACTIONS(1364),
    [sym_undefined] = ACTIONS(1364),
    [anon_sym_AT] = ACTIONS(1362),
    [anon_sym_static] = ACTIONS(1364),
    [anon_sym_readonly] = ACTIONS(1364),
    [anon_sym_get] = ACTIONS(1364),
    [anon_sym_set] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1364),
    [anon_sym_public] = ACTIONS(1364),
    [anon_sym_private] = ACTIONS(1364),
    [anon_sym_protected] = ACTIONS(1364),
    [anon_sym_override] = ACTIONS(1364),
    [anon_sym_module] = ACTIONS(1364),
    [anon_sym_any] = ACTIONS(1364),
    [anon_sym_number] = ACTIONS(1364),
    [anon_sym_boolean] = ACTIONS(1364),
    [anon_sym_string] = ACTIONS(1364),
    [anon_sym_symbol] = ACTIONS(1364),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_interface] = ACTIONS(1364),
    [anon_sym_enum] = ACTIONS(1364),
    [sym__automatic_semicolon] = ACTIONS(1362),
    [sym__ternary_qmark] = ACTIONS(1362),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(1366),
    [sym_identifier] = ACTIONS(1368),
    [anon_sym_export] = ACTIONS(1368),
    [anon_sym_STAR] = ACTIONS(1370),
    [anon_sym_default] = ACTIONS(1368),
    [anon_sym_type] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(1370),
    [anon_sym_namespace] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_COMMA] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [anon_sym_typeof] = ACTIONS(1368),
    [anon_sym_import] = ACTIONS(1368),
    [anon_sym_var] = ACTIONS(1368),
    [anon_sym_let] = ACTIONS(1368),
    [anon_sym_const] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_else] = ACTIONS(1368),
    [anon_sym_if] = ACTIONS(1368),
    [anon_sym_switch] = ACTIONS(1368),
    [anon_sym_for] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_await] = ACTIONS(1368),
    [anon_sym_in] = ACTIONS(1370),
    [anon_sym_while] = ACTIONS(1368),
    [anon_sym_do] = ACTIONS(1368),
    [anon_sym_try] = ACTIONS(1368),
    [anon_sym_with] = ACTIONS(1368),
    [anon_sym_break] = ACTIONS(1368),
    [anon_sym_continue] = ACTIONS(1368),
    [anon_sym_debugger] = ACTIONS(1368),
    [anon_sym_return] = ACTIONS(1368),
    [anon_sym_throw] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1366),
    [anon_sym_case] = ACTIONS(1368),
    [anon_sym_yield] = ACTIONS(1368),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_LT] = ACTIONS(1368),
    [anon_sym_GT] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1368),
    [anon_sym_DOT] = ACTIONS(1370),
    [anon_sym_class] = ACTIONS(1368),
    [anon_sym_async] = ACTIONS(1368),
    [anon_sym_function] = ACTIONS(1368),
    [anon_sym_QMARK_DOT] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1368),
    [anon_sym_AMP_AMP] = ACTIONS(1372),
    [anon_sym_PIPE_PIPE] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1370),
    [anon_sym_GT_GT_GT] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1370),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_STAR_STAR] = ACTIONS(1372),
    [anon_sym_LT_EQ] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1370),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1372),
    [anon_sym_BANG_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1372),
    [anon_sym_GT_EQ] = ACTIONS(1372),
    [anon_sym_QMARK_QMARK] = ACTIONS(1372),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1366),
    [anon_sym_void] = ACTIONS(1368),
    [anon_sym_delete] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [sym_number] = ACTIONS(1366),
    [sym_this] = ACTIONS(1368),
    [sym_super] = ACTIONS(1368),
    [sym_true] = ACTIONS(1368),
    [sym_false] = ACTIONS(1368),
    [sym_null] = ACTIONS(1368),
    [sym_undefined] = ACTIONS(1368),
    [anon_sym_AT] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_readonly] = ACTIONS(1368),
    [anon_sym_get] = ACTIONS(1368),
    [anon_sym_set] = ACTIONS(1368),
    [anon_sym_declare] = ACTIONS(1368),
    [anon_sym_public] = ACTIONS(1368),
    [anon_sym_private] = ACTIONS(1368),
    [anon_sym_protected] = ACTIONS(1368),
    [anon_sym_override] = ACTIONS(1368),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_any] = ACTIONS(1368),
    [anon_sym_number] = ACTIONS(1368),
    [anon_sym_boolean] = ACTIONS(1368),
    [anon_sym_string] = ACTIONS(1368),
    [anon_sym_symbol] = ACTIONS(1368),
    [anon_sym_abstract] = ACTIONS(1368),
    [anon_sym_interface] = ACTIONS(1368),
    [anon_sym_enum] = ACTIONS(1368),
    [sym__automatic_semicolon] = ACTIONS(1374),
    [sym__ternary_qmark] = ACTIONS(1372),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(1376),
    [sym_identifier] = ACTIONS(1378),
    [anon_sym_export] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_type] = ACTIONS(1378),
    [anon_sym_as] = ACTIONS(1380),
    [anon_sym_namespace] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_COMMA] = ACTIONS(1382),
    [anon_sym_RBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(1378),
    [anon_sym_import] = ACTIONS(1378),
    [anon_sym_var] = ACTIONS(1378),
    [anon_sym_let] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_BANG] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_LPAREN] = ACTIONS(1376),
    [anon_sym_await] = ACTIONS(1378),
    [anon_sym_in] = ACTIONS(1380),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_try] = ACTIONS(1378),
    [anon_sym_with] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_debugger] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_throw] = ACTIONS(1378),
    [anon_sym_SEMI] = ACTIONS(1376),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_yield] = ACTIONS(1378),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_LT] = ACTIONS(1378),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_SLASH] = ACTIONS(1378),
    [anon_sym_DOT] = ACTIONS(1380),
    [anon_sym_class] = ACTIONS(1378),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1378),
    [anon_sym_QMARK_DOT] = ACTIONS(1382),
    [anon_sym_new] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_GT_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_CARET] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_PERCENT] = ACTIONS(1382),
    [anon_sym_STAR_STAR] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1382),
    [anon_sym_EQ_EQ] = ACTIONS(1380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1382),
    [anon_sym_BANG_EQ] = ACTIONS(1380),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1382),
    [anon_sym_GT_EQ] = ACTIONS(1382),
    [anon_sym_QMARK_QMARK] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_void] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(1376),
    [anon_sym_DASH_DASH] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_number] = ACTIONS(1376),
    [sym_this] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_null] = ACTIONS(1378),
    [sym_undefined] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(1376),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_readonly] = ACTIONS(1378),
    [anon_sym_get] = ACTIONS(1378),
    [anon_sym_set] = ACTIONS(1378),
    [anon_sym_declare] = ACTIONS(1378),
    [anon_sym_public] = ACTIONS(1378),
    [anon_sym_private] = ACTIONS(1378),
    [anon_sym_protected] = ACTIONS(1378),
    [anon_sym_override] = ACTIONS(1378),
    [anon_sym_module] = ACTIONS(1378),
    [anon_sym_any] = ACTIONS(1378),
    [anon_sym_number] = ACTIONS(1378),
    [anon_sym_boolean] = ACTIONS(1378),
    [anon_sym_string] = ACTIONS(1378),
    [anon_sym_symbol] = ACTIONS(1378),
    [anon_sym_abstract] = ACTIONS(1378),
    [anon_sym_interface] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [sym__automatic_semicolon] = ACTIONS(1384),
    [sym__ternary_qmark] = ACTIONS(1382),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(1292),
    [sym_identifier] = ACTIONS(1294),
    [anon_sym_export] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_default] = ACTIONS(1294),
    [anon_sym_type] = ACTIONS(1294),
    [anon_sym_as] = ACTIONS(1294),
    [anon_sym_namespace] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(1292),
    [anon_sym_COMMA] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1292),
    [anon_sym_typeof] = ACTIONS(1294),
    [anon_sym_import] = ACTIONS(1294),
    [anon_sym_var] = ACTIONS(1294),
    [anon_sym_let] = ACTIONS(1294),
    [anon_sym_const] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_else] = ACTIONS(1294),
    [anon_sym_if] = ACTIONS(1294),
    [anon_sym_switch] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1294),
    [anon_sym_LPAREN] = ACTIONS(1292),
    [anon_sym_await] = ACTIONS(1294),
    [anon_sym_in] = ACTIONS(1294),
    [anon_sym_while] = ACTIONS(1294),
    [anon_sym_do] = ACTIONS(1294),
    [anon_sym_try] = ACTIONS(1294),
    [anon_sym_with] = ACTIONS(1294),
    [anon_sym_break] = ACTIONS(1294),
    [anon_sym_continue] = ACTIONS(1294),
    [anon_sym_debugger] = ACTIONS(1294),
    [anon_sym_return] = ACTIONS(1294),
    [anon_sym_throw] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1294),
    [anon_sym_yield] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1294),
    [anon_sym_DOT] = ACTIONS(1294),
    [anon_sym_class] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1294),
    [anon_sym_function] = ACTIONS(1294),
    [anon_sym_QMARK_DOT] = ACTIONS(1292),
    [anon_sym_new] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1292),
    [anon_sym_PIPE_PIPE] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_GT_GT_GT] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_CARET] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_PERCENT] = ACTIONS(1292),
    [anon_sym_STAR_STAR] = ACTIONS(1292),
    [anon_sym_LT_EQ] = ACTIONS(1292),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1292),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1292),
    [anon_sym_GT_EQ] = ACTIONS(1292),
    [anon_sym_QMARK_QMARK] = ACTIONS(1292),
    [anon_sym_instanceof] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_void] = ACTIONS(1294),
    [anon_sym_delete] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1292),
    [anon_sym_DQUOTE] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1292),
    [sym_number] = ACTIONS(1292),
    [sym_this] = ACTIONS(1294),
    [sym_super] = ACTIONS(1294),
    [sym_true] = ACTIONS(1294),
    [sym_false] = ACTIONS(1294),
    [sym_null] = ACTIONS(1294),
    [sym_undefined] = ACTIONS(1294),
    [anon_sym_AT] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1294),
    [anon_sym_readonly] = ACTIONS(1294),
    [anon_sym_get] = ACTIONS(1294),
    [anon_sym_set] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_public] = ACTIONS(1294),
    [anon_sym_private] = ACTIONS(1294),
    [anon_sym_protected] = ACTIONS(1294),
    [anon_sym_override] = ACTIONS(1294),
    [anon_sym_module] = ACTIONS(1294),
    [anon_sym_any] = ACTIONS(1294),
    [anon_sym_number] = ACTIONS(1294),
    [anon_sym_boolean] = ACTIONS(1294),
    [anon_sym_string] = ACTIONS(1294),
    [anon_sym_symbol] = ACTIONS(1294),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_interface] = ACTIONS(1294),
    [anon_sym_enum] = ACTIONS(1294),
    [sym__automatic_semicolon] = ACTIONS(1386),
    [sym__ternary_qmark] = ACTIONS(1292),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(1388),
    [sym_identifier] = ACTIONS(1390),
    [anon_sym_export] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_default] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(1390),
    [anon_sym_as] = ACTIONS(1392),
    [anon_sym_namespace] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_RBRACE] = ACTIONS(1388),
    [anon_sym_typeof] = ACTIONS(1390),
    [anon_sym_import] = ACTIONS(1390),
    [anon_sym_var] = ACTIONS(1390),
    [anon_sym_let] = ACTIONS(1390),
    [anon_sym_const] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1390),
    [anon_sym_else] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_switch] = ACTIONS(1390),
    [anon_sym_for] = ACTIONS(1390),
    [anon_sym_LPAREN] = ACTIONS(1388),
    [anon_sym_await] = ACTIONS(1390),
    [anon_sym_in] = ACTIONS(1392),
    [anon_sym_while] = ACTIONS(1390),
    [anon_sym_do] = ACTIONS(1390),
    [anon_sym_try] = ACTIONS(1390),
    [anon_sym_with] = ACTIONS(1390),
    [anon_sym_break] = ACTIONS(1390),
    [anon_sym_continue] = ACTIONS(1390),
    [anon_sym_debugger] = ACTIONS(1390),
    [anon_sym_return] = ACTIONS(1390),
    [anon_sym_throw] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym_case] = ACTIONS(1390),
    [anon_sym_yield] = ACTIONS(1390),
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1390),
    [anon_sym_DOT] = ACTIONS(1392),
    [anon_sym_class] = ACTIONS(1390),
    [anon_sym_async] = ACTIONS(1390),
    [anon_sym_function] = ACTIONS(1390),
    [anon_sym_QMARK_DOT] = ACTIONS(1394),
    [anon_sym_new] = ACTIONS(1390),
    [anon_sym_AMP_AMP] = ACTIONS(1394),
    [anon_sym_PIPE_PIPE] = ACTIONS(1394),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_GT_GT_GT] = ACTIONS(1394),
    [anon_sym_LT_LT] = ACTIONS(1394),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1394),
    [anon_sym_PIPE] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_PERCENT] = ACTIONS(1394),
    [anon_sym_STAR_STAR] = ACTIONS(1394),
    [anon_sym_LT_EQ] = ACTIONS(1394),
    [anon_sym_EQ_EQ] = ACTIONS(1392),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1392),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1394),
    [anon_sym_GT_EQ] = ACTIONS(1394),
    [anon_sym_QMARK_QMARK] = ACTIONS(1394),
    [anon_sym_instanceof] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1388),
    [anon_sym_void] = ACTIONS(1390),
    [anon_sym_delete] = ACTIONS(1390),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [anon_sym_DQUOTE] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1388),
    [sym_number] = ACTIONS(1388),
    [sym_this] = ACTIONS(1390),
    [sym_super] = ACTIONS(1390),
    [sym_true] = ACTIONS(1390),
    [sym_false] = ACTIONS(1390),
    [sym_null] = ACTIONS(1390),
    [sym_undefined] = ACTIONS(1390),
    [anon_sym_AT] = ACTIONS(1388),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_readonly] = ACTIONS(1390),
    [anon_sym_get] = ACTIONS(1390),
    [anon_sym_set] = ACTIONS(1390),
    [anon_sym_declare] = ACTIONS(1390),
    [anon_sym_public] = ACTIONS(1390),
    [anon_sym_private] = ACTIONS(1390),
    [anon_sym_protected] = ACTIONS(1390),
    [anon_sym_override] = ACTIONS(1390),
    [anon_sym_module] = ACTIONS(1390),
    [anon_sym_any] = ACTIONS(1390),
    [anon_sym_number] = ACTIONS(1390),
    [anon_sym_boolean] = ACTIONS(1390),
    [anon_sym_string] = ACTIONS(1390),
    [anon_sym_symbol] = ACTIONS(1390),
    [anon_sym_abstract] = ACTIONS(1390),
    [anon_sym_interface] = ACTIONS(1390),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(1396),
    [sym__ternary_qmark] = ACTIONS(1394),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_export] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_type] = ACTIONS(1400),
    [anon_sym_as] = ACTIONS(1400),
    [anon_sym_namespace] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_COMMA] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_typeof] = ACTIONS(1400),
    [anon_sym_import] = ACTIONS(1400),
    [anon_sym_var] = ACTIONS(1400),
    [anon_sym_let] = ACTIONS(1400),
    [anon_sym_const] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_else] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1400),
    [anon_sym_switch] = ACTIONS(1400),
    [anon_sym_for] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_await] = ACTIONS(1400),
    [anon_sym_in] = ACTIONS(1400),
    [anon_sym_while] = ACTIONS(1400),
    [anon_sym_do] = ACTIONS(1400),
    [anon_sym_try] = ACTIONS(1400),
    [anon_sym_with] = ACTIONS(1400),
    [anon_sym_break] = ACTIONS(1400),
    [anon_sym_continue] = ACTIONS(1400),
    [anon_sym_debugger] = ACTIONS(1400),
    [anon_sym_return] = ACTIONS(1400),
    [anon_sym_throw] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1398),
    [anon_sym_case] = ACTIONS(1400),
    [anon_sym_yield] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_DOT] = ACTIONS(1400),
    [anon_sym_class] = ACTIONS(1400),
    [anon_sym_async] = ACTIONS(1400),
    [anon_sym_function] = ACTIONS(1400),
    [anon_sym_QMARK_DOT] = ACTIONS(1398),
    [anon_sym_new] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1398),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_STAR_STAR] = ACTIONS(1398),
    [anon_sym_LT_EQ] = ACTIONS(1398),
    [anon_sym_EQ_EQ] = ACTIONS(1400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1398),
    [anon_sym_BANG_EQ] = ACTIONS(1400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1398),
    [anon_sym_GT_EQ] = ACTIONS(1398),
    [anon_sym_QMARK_QMARK] = ACTIONS(1398),
    [anon_sym_instanceof] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1398),
    [anon_sym_void] = ACTIONS(1400),
    [anon_sym_delete] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [sym_number] = ACTIONS(1398),
    [sym_this] = ACTIONS(1400),
    [sym_super] = ACTIONS(1400),
    [sym_true] = ACTIONS(1400),
    [sym_false] = ACTIONS(1400),
    [sym_null] = ACTIONS(1400),
    [sym_undefined] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_readonly] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1400),
    [anon_sym_set] = ACTIONS(1400),
    [anon_sym_declare] = ACTIONS(1400),
    [anon_sym_public] = ACTIONS(1400),
    [anon_sym_private] = ACTIONS(1400),
    [anon_sym_protected] = ACTIONS(1400),
    [anon_sym_override] = ACTIONS(1400),
    [anon_sym_module] = ACTIONS(1400),
    [anon_sym_any] = ACTIONS(1400),
    [anon_sym_number] = ACTIONS(1400),
    [anon_sym_boolean] = ACTIONS(1400),
    [anon_sym_string] = ACTIONS(1400),
    [anon_sym_symbol] = ACTIONS(1400),
    [anon_sym_abstract] = ACTIONS(1400),
    [anon_sym_interface] = ACTIONS(1400),
    [anon_sym_enum] = ACTIONS(1400),
    [sym__automatic_semicolon] = ACTIONS(1398),
    [sym__ternary_qmark] = ACTIONS(1398),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(1402),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_export] = ACTIONS(1404),
    [anon_sym_STAR] = ACTIONS(1406),
    [anon_sym_default] = ACTIONS(1404),
    [anon_sym_type] = ACTIONS(1404),
    [anon_sym_as] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1402),
    [anon_sym_COMMA] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1402),
    [anon_sym_typeof] = ACTIONS(1404),
    [anon_sym_import] = ACTIONS(1404),
    [anon_sym_var] = ACTIONS(1404),
    [anon_sym_let] = ACTIONS(1404),
    [anon_sym_const] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_else] = ACTIONS(1404),
    [anon_sym_if] = ACTIONS(1404),
    [anon_sym_switch] = ACTIONS(1404),
    [anon_sym_for] = ACTIONS(1404),
    [anon_sym_LPAREN] = ACTIONS(1402),
    [anon_sym_await] = ACTIONS(1404),
    [anon_sym_in] = ACTIONS(1406),
    [anon_sym_while] = ACTIONS(1404),
    [anon_sym_do] = ACTIONS(1404),
    [anon_sym_try] = ACTIONS(1404),
    [anon_sym_with] = ACTIONS(1404),
    [anon_sym_break] = ACTIONS(1404),
    [anon_sym_continue] = ACTIONS(1404),
    [anon_sym_debugger] = ACTIONS(1404),
    [anon_sym_return] = ACTIONS(1404),
    [anon_sym_throw] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_case] = ACTIONS(1404),
    [anon_sym_yield] = ACTIONS(1404),
    [anon_sym_LBRACK] = ACTIONS(1402),
    [anon_sym_LT] = ACTIONS(1404),
    [anon_sym_GT] = ACTIONS(1406),
    [anon_sym_SLASH] = ACTIONS(1404),
    [anon_sym_DOT] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(1404),
    [anon_sym_async] = ACTIONS(1404),
    [anon_sym_function] = ACTIONS(1404),
    [anon_sym_QMARK_DOT] = ACTIONS(1408),
    [anon_sym_new] = ACTIONS(1404),
    [anon_sym_AMP_AMP] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1408),
    [anon_sym_GT_GT] = ACTIONS(1406),
    [anon_sym_GT_GT_GT] = ACTIONS(1408),
    [anon_sym_LT_LT] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_CARET] = ACTIONS(1408),
    [anon_sym_PIPE] = ACTIONS(1406),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_PERCENT] = ACTIONS(1408),
    [anon_sym_STAR_STAR] = ACTIONS(1408),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_EQ_EQ] = ACTIONS(1406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG_EQ] = ACTIONS(1406),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_QMARK_QMARK] = ACTIONS(1408),
    [anon_sym_instanceof] = ACTIONS(1406),
    [anon_sym_TILDE] = ACTIONS(1402),
    [anon_sym_void] = ACTIONS(1404),
    [anon_sym_delete] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1402),
    [anon_sym_DASH_DASH] = ACTIONS(1402),
    [anon_sym_DQUOTE] = ACTIONS(1402),
    [anon_sym_SQUOTE] = ACTIONS(1402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1402),
    [sym_number] = ACTIONS(1402),
    [sym_this] = ACTIONS(1404),
    [sym_super] = ACTIONS(1404),
    [sym_true] = ACTIONS(1404),
    [sym_false] = ACTIONS(1404),
    [sym_null] = ACTIONS(1404),
    [sym_undefined] = ACTIONS(1404),
    [anon_sym_AT] = ACTIONS(1402),
    [anon_sym_static] = ACTIONS(1404),
    [anon_sym_readonly] = ACTIONS(1404),
    [anon_sym_get] = ACTIONS(1404),
    [anon_sym_set] = ACTIONS(1404),
    [anon_sym_declare] = ACTIONS(1404),
    [anon_sym_public] = ACTIONS(1404),
    [anon_sym_private] = ACTIONS(1404),
    [anon_sym_protected] = ACTIONS(1404),
    [anon_sym_override] = ACTIONS(1404),
    [anon_sym_module] = ACTIONS(1404),
    [anon_sym_any] = ACTIONS(1404),
    [anon_sym_number] = ACTIONS(1404),
    [anon_sym_boolean] = ACTIONS(1404),
    [anon_sym_string] = ACTIONS(1404),
    [anon_sym_symbol] = ACTIONS(1404),
    [anon_sym_abstract] = ACTIONS(1404),
    [anon_sym_interface] = ACTIONS(1404),
    [anon_sym_enum] = ACTIONS(1404),
    [sym__automatic_semicolon] = ACTIONS(1410),
    [sym__ternary_qmark] = ACTIONS(1408),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(1412),
    [sym_identifier] = ACTIONS(1414),
    [anon_sym_export] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_type] = ACTIONS(1414),
    [anon_sym_as] = ACTIONS(1416),
    [anon_sym_namespace] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1412),
    [anon_sym_COMMA] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1412),
    [anon_sym_typeof] = ACTIONS(1414),
    [anon_sym_import] = ACTIONS(1414),
    [anon_sym_var] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_BANG] = ACTIONS(1414),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_LPAREN] = ACTIONS(1412),
    [anon_sym_await] = ACTIONS(1414),
    [anon_sym_in] = ACTIONS(1416),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_try] = ACTIONS(1414),
    [anon_sym_with] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_debugger] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_throw] = ACTIONS(1414),
    [anon_sym_SEMI] = ACTIONS(1412),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_yield] = ACTIONS(1414),
    [anon_sym_LBRACK] = ACTIONS(1412),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_GT] = ACTIONS(1416),
    [anon_sym_SLASH] = ACTIONS(1414),
    [anon_sym_DOT] = ACTIONS(1416),
    [anon_sym_class] = ACTIONS(1414),
    [anon_sym_async] = ACTIONS(1414),
    [anon_sym_function] = ACTIONS(1414),
    [anon_sym_QMARK_DOT] = ACTIONS(1418),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_PIPE_PIPE] = ACTIONS(1418),
    [anon_sym_GT_GT] = ACTIONS(1416),
    [anon_sym_GT_GT_GT] = ACTIONS(1418),
    [anon_sym_LT_LT] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym_PIPE] = ACTIONS(1416),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_STAR_STAR] = ACTIONS(1418),
    [anon_sym_LT_EQ] = ACTIONS(1418),
    [anon_sym_EQ_EQ] = ACTIONS(1416),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1418),
    [anon_sym_BANG_EQ] = ACTIONS(1416),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1418),
    [anon_sym_GT_EQ] = ACTIONS(1418),
    [anon_sym_QMARK_QMARK] = ACTIONS(1418),
    [anon_sym_instanceof] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1412),
    [anon_sym_void] = ACTIONS(1414),
    [anon_sym_delete] = ACTIONS(1414),
    [anon_sym_PLUS_PLUS] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1412),
    [anon_sym_DQUOTE] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(1412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1412),
    [sym_number] = ACTIONS(1412),
    [sym_this] = ACTIONS(1414),
    [sym_super] = ACTIONS(1414),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [sym_null] = ACTIONS(1414),
    [sym_undefined] = ACTIONS(1414),
    [anon_sym_AT] = ACTIONS(1412),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_readonly] = ACTIONS(1414),
    [anon_sym_get] = ACTIONS(1414),
    [anon_sym_set] = ACTIONS(1414),
    [anon_sym_declare] = ACTIONS(1414),
    [anon_sym_public] = ACTIONS(1414),
    [anon_sym_private] = ACTIONS(1414),
    [anon_sym_protected] = ACTIONS(1414),
    [anon_sym_override] = ACTIONS(1414),
    [anon_sym_module] = ACTIONS(1414),
    [anon_sym_any] = ACTIONS(1414),
    [anon_sym_number] = ACTIONS(1414),
    [anon_sym_boolean] = ACTIONS(1414),
    [anon_sym_string] = ACTIONS(1414),
    [anon_sym_symbol] = ACTIONS(1414),
    [anon_sym_abstract] = ACTIONS(1414),
    [anon_sym_interface] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [sym__automatic_semicolon] = ACTIONS(1420),
    [sym__ternary_qmark] = ACTIONS(1418),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(1422),
    [sym_identifier] = ACTIONS(1424),
    [anon_sym_export] = ACTIONS(1424),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_default] = ACTIONS(1424),
    [anon_sym_type] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1426),
    [anon_sym_namespace] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1422),
    [anon_sym_COMMA] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1422),
    [anon_sym_typeof] = ACTIONS(1424),
    [anon_sym_import] = ACTIONS(1424),
    [anon_sym_var] = ACTIONS(1424),
    [anon_sym_let] = ACTIONS(1424),
    [anon_sym_const] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_else] = ACTIONS(1424),
    [anon_sym_if] = ACTIONS(1424),
    [anon_sym_switch] = ACTIONS(1424),
    [anon_sym_for] = ACTIONS(1424),
    [anon_sym_LPAREN] = ACTIONS(1422),
    [anon_sym_await] = ACTIONS(1424),
    [anon_sym_in] = ACTIONS(1426),
    [anon_sym_while] = ACTIONS(1424),
    [anon_sym_do] = ACTIONS(1424),
    [anon_sym_try] = ACTIONS(1424),
    [anon_sym_with] = ACTIONS(1424),
    [anon_sym_break] = ACTIONS(1424),
    [anon_sym_continue] = ACTIONS(1424),
    [anon_sym_debugger] = ACTIONS(1424),
    [anon_sym_return] = ACTIONS(1424),
    [anon_sym_throw] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1422),
    [anon_sym_case] = ACTIONS(1424),
    [anon_sym_yield] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(1426),
    [anon_sym_SLASH] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1426),
    [anon_sym_class] = ACTIONS(1424),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_function] = ACTIONS(1424),
    [anon_sym_QMARK_DOT] = ACTIONS(1428),
    [anon_sym_new] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_GT_GT] = ACTIONS(1426),
    [anon_sym_GT_GT_GT] = ACTIONS(1428),
    [anon_sym_LT_LT] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1424),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_STAR_STAR] = ACTIONS(1428),
    [anon_sym_LT_EQ] = ACTIONS(1428),
    [anon_sym_EQ_EQ] = ACTIONS(1426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1428),
    [anon_sym_BANG_EQ] = ACTIONS(1426),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1428),
    [anon_sym_GT_EQ] = ACTIONS(1428),
    [anon_sym_QMARK_QMARK] = ACTIONS(1428),
    [anon_sym_instanceof] = ACTIONS(1426),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_void] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1422),
    [anon_sym_DASH_DASH] = ACTIONS(1422),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [anon_sym_SQUOTE] = ACTIONS(1422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1422),
    [sym_this] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_true] = ACTIONS(1424),
    [sym_false] = ACTIONS(1424),
    [sym_null] = ACTIONS(1424),
    [sym_undefined] = ACTIONS(1424),
    [anon_sym_AT] = ACTIONS(1422),
    [anon_sym_static] = ACTIONS(1424),
    [anon_sym_readonly] = ACTIONS(1424),
    [anon_sym_get] = ACTIONS(1424),
    [anon_sym_set] = ACTIONS(1424),
    [anon_sym_declare] = ACTIONS(1424),
    [anon_sym_public] = ACTIONS(1424),
    [anon_sym_private] = ACTIONS(1424),
    [anon_sym_protected] = ACTIONS(1424),
    [anon_sym_override] = ACTIONS(1424),
    [anon_sym_module] = ACTIONS(1424),
    [anon_sym_any] = ACTIONS(1424),
    [anon_sym_number] = ACTIONS(1424),
    [anon_sym_boolean] = ACTIONS(1424),
    [anon_sym_string] = ACTIONS(1424),
    [anon_sym_symbol] = ACTIONS(1424),
    [anon_sym_abstract] = ACTIONS(1424),
    [anon_sym_interface] = ACTIONS(1424),
    [anon_sym_enum] = ACTIONS(1424),
    [sym__automatic_semicolon] = ACTIONS(1430),
    [sym__ternary_qmark] = ACTIONS(1428),
  },
  [137] = {
    [ts_builtin_sym_end] = ACTIONS(1432),
    [sym_identifier] = ACTIONS(1434),
    [anon_sym_export] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_type] = ACTIONS(1434),
    [anon_sym_as] = ACTIONS(1436),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1432),
    [anon_sym_typeof] = ACTIONS(1434),
    [anon_sym_import] = ACTIONS(1434),
    [anon_sym_var] = ACTIONS(1434),
    [anon_sym_let] = ACTIONS(1434),
    [anon_sym_const] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1434),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1432),
    [anon_sym_await] = ACTIONS(1434),
    [anon_sym_in] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1434),
    [anon_sym_do] = ACTIONS(1434),
    [anon_sym_try] = ACTIONS(1434),
    [anon_sym_with] = ACTIONS(1434),
    [anon_sym_break] = ACTIONS(1434),
    [anon_sym_continue] = ACTIONS(1434),
    [anon_sym_debugger] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1434),
    [anon_sym_throw] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1432),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_yield] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(1436),
    [anon_sym_class] = ACTIONS(1434),
    [anon_sym_async] = ACTIONS(1434),
    [anon_sym_function] = ACTIONS(1434),
    [anon_sym_QMARK_DOT] = ACTIONS(1438),
    [anon_sym_new] = ACTIONS(1434),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_GT_GT_GT] = ACTIONS(1438),
    [anon_sym_LT_LT] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1438),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_PERCENT] = ACTIONS(1438),
    [anon_sym_STAR_STAR] = ACTIONS(1438),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym_EQ_EQ] = ACTIONS(1436),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1436),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1438),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_QMARK_QMARK] = ACTIONS(1438),
    [anon_sym_instanceof] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1432),
    [anon_sym_void] = ACTIONS(1434),
    [anon_sym_delete] = ACTIONS(1434),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [anon_sym_DASH_DASH] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1432),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1432),
    [sym_number] = ACTIONS(1432),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(1434),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [sym_null] = ACTIONS(1434),
    [sym_undefined] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1432),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_readonly] = ACTIONS(1434),
    [anon_sym_get] = ACTIONS(1434),
    [anon_sym_set] = ACTIONS(1434),
    [anon_sym_declare] = ACTIONS(1434),
    [anon_sym_public] = ACTIONS(1434),
    [anon_sym_private] = ACTIONS(1434),
    [anon_sym_protected] = ACTIONS(1434),
    [anon_sym_override] = ACTIONS(1434),
    [anon_sym_module] = ACTIONS(1434),
    [anon_sym_any] = ACTIONS(1434),
    [anon_sym_number] = ACTIONS(1434),
    [anon_sym_boolean] = ACTIONS(1434),
    [anon_sym_string] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1434),
    [anon_sym_abstract] = ACTIONS(1434),
    [anon_sym_interface] = ACTIONS(1434),
    [anon_sym_enum] = ACTIONS(1434),
    [sym__automatic_semicolon] = ACTIONS(1440),
    [sym__ternary_qmark] = ACTIONS(1438),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_export] = ACTIONS(1444),
    [anon_sym_STAR] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1444),
    [anon_sym_type] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(1446),
    [anon_sym_namespace] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_COMMA] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_typeof] = ACTIONS(1444),
    [anon_sym_import] = ACTIONS(1444),
    [anon_sym_var] = ACTIONS(1444),
    [anon_sym_let] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_else] = ACTIONS(1444),
    [anon_sym_if] = ACTIONS(1444),
    [anon_sym_switch] = ACTIONS(1444),
    [anon_sym_for] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [anon_sym_await] = ACTIONS(1444),
    [anon_sym_in] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_do] = ACTIONS(1444),
    [anon_sym_try] = ACTIONS(1444),
    [anon_sym_with] = ACTIONS(1444),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1444),
    [anon_sym_debugger] = ACTIONS(1444),
    [anon_sym_return] = ACTIONS(1444),
    [anon_sym_throw] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_case] = ACTIONS(1444),
    [anon_sym_yield] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_DOT] = ACTIONS(1446),
    [anon_sym_class] = ACTIONS(1444),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_function] = ACTIONS(1444),
    [anon_sym_QMARK_DOT] = ACTIONS(1448),
    [anon_sym_new] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1448),
    [anon_sym_PIPE_PIPE] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_GT_GT_GT] = ACTIONS(1448),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1446),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_STAR_STAR] = ACTIONS(1448),
    [anon_sym_LT_EQ] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1448),
    [anon_sym_BANG_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1448),
    [anon_sym_GT_EQ] = ACTIONS(1448),
    [anon_sym_QMARK_QMARK] = ACTIONS(1448),
    [anon_sym_instanceof] = ACTIONS(1446),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_void] = ACTIONS(1444),
    [anon_sym_delete] = ACTIONS(1444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1442),
    [sym_number] = ACTIONS(1442),
    [sym_this] = ACTIONS(1444),
    [sym_super] = ACTIONS(1444),
    [sym_true] = ACTIONS(1444),
    [sym_false] = ACTIONS(1444),
    [sym_null] = ACTIONS(1444),
    [sym_undefined] = ACTIONS(1444),
    [anon_sym_AT] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_readonly] = ACTIONS(1444),
    [anon_sym_get] = ACTIONS(1444),
    [anon_sym_set] = ACTIONS(1444),
    [anon_sym_declare] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1444),
    [anon_sym_private] = ACTIONS(1444),
    [anon_sym_protected] = ACTIONS(1444),
    [anon_sym_override] = ACTIONS(1444),
    [anon_sym_module] = ACTIONS(1444),
    [anon_sym_any] = ACTIONS(1444),
    [anon_sym_number] = ACTIONS(1444),
    [anon_sym_boolean] = ACTIONS(1444),
    [anon_sym_string] = ACTIONS(1444),
    [anon_sym_symbol] = ACTIONS(1444),
    [anon_sym_abstract] = ACTIONS(1444),
    [anon_sym_interface] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [sym__automatic_semicolon] = ACTIONS(1450),
    [sym__ternary_qmark] = ACTIONS(1448),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(1452),
    [sym_identifier] = ACTIONS(1454),
    [anon_sym_export] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_type] = ACTIONS(1454),
    [anon_sym_as] = ACTIONS(1456),
    [anon_sym_namespace] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_COMMA] = ACTIONS(1458),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [anon_sym_typeof] = ACTIONS(1454),
    [anon_sym_import] = ACTIONS(1454),
    [anon_sym_var] = ACTIONS(1454),
    [anon_sym_let] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_BANG] = ACTIONS(1454),
    [anon_sym_else] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(1452),
    [anon_sym_await] = ACTIONS(1454),
    [anon_sym_in] = ACTIONS(1456),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_try] = ACTIONS(1454),
    [anon_sym_with] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_debugger] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_throw] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_yield] = ACTIONS(1454),
    [anon_sym_LBRACK] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1454),
    [anon_sym_GT] = ACTIONS(1456),
    [anon_sym_SLASH] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1456),
    [anon_sym_class] = ACTIONS(1454),
    [anon_sym_async] = ACTIONS(1454),
    [anon_sym_function] = ACTIONS(1454),
    [anon_sym_QMARK_DOT] = ACTIONS(1458),
    [anon_sym_new] = ACTIONS(1454),
    [anon_sym_AMP_AMP] = ACTIONS(1458),
    [anon_sym_PIPE_PIPE] = ACTIONS(1458),
    [anon_sym_GT_GT] = ACTIONS(1456),
    [anon_sym_GT_GT_GT] = ACTIONS(1458),
    [anon_sym_LT_LT] = ACTIONS(1458),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_CARET] = ACTIONS(1458),
    [anon_sym_PIPE] = ACTIONS(1456),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PERCENT] = ACTIONS(1458),
    [anon_sym_STAR_STAR] = ACTIONS(1458),
    [anon_sym_LT_EQ] = ACTIONS(1458),
    [anon_sym_EQ_EQ] = ACTIONS(1456),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1458),
    [anon_sym_BANG_EQ] = ACTIONS(1456),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1458),
    [anon_sym_GT_EQ] = ACTIONS(1458),
    [anon_sym_QMARK_QMARK] = ACTIONS(1458),
    [anon_sym_instanceof] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_void] = ACTIONS(1454),
    [anon_sym_delete] = ACTIONS(1454),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1452),
    [sym_number] = ACTIONS(1452),
    [sym_this] = ACTIONS(1454),
    [sym_super] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_undefined] = ACTIONS(1454),
    [anon_sym_AT] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_readonly] = ACTIONS(1454),
    [anon_sym_get] = ACTIONS(1454),
    [anon_sym_set] = ACTIONS(1454),
    [anon_sym_declare] = ACTIONS(1454),
    [anon_sym_public] = ACTIONS(1454),
    [anon_sym_private] = ACTIONS(1454),
    [anon_sym_protected] = ACTIONS(1454),
    [anon_sym_override] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_any] = ACTIONS(1454),
    [anon_sym_number] = ACTIONS(1454),
    [anon_sym_boolean] = ACTIONS(1454),
    [anon_sym_string] = ACTIONS(1454),
    [anon_sym_symbol] = ACTIONS(1454),
    [anon_sym_abstract] = ACTIONS(1454),
    [anon_sym_interface] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [sym__automatic_semicolon] = ACTIONS(1458),
    [sym__ternary_qmark] = ACTIONS(1458),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(1460),
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_export] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1464),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(1462),
    [anon_sym_as] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1460),
    [anon_sym_COMMA] = ACTIONS(1466),
    [anon_sym_RBRACE] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(1462),
    [anon_sym_import] = ACTIONS(1462),
    [anon_sym_var] = ACTIONS(1462),
    [anon_sym_let] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_LPAREN] = ACTIONS(1460),
    [anon_sym_await] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1464),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_try] = ACTIONS(1462),
    [anon_sym_with] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_debugger] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_throw] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_yield] = ACTIONS(1462),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LT] = ACTIONS(1462),
    [anon_sym_GT] = ACTIONS(1464),
    [anon_sym_SLASH] = ACTIONS(1462),
    [anon_sym_DOT] = ACTIONS(1464),
    [anon_sym_class] = ACTIONS(1462),
    [anon_sym_async] = ACTIONS(1462),
    [anon_sym_function] = ACTIONS(1462),
    [anon_sym_QMARK_DOT] = ACTIONS(1466),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_AMP_AMP] = ACTIONS(1466),
    [anon_sym_PIPE_PIPE] = ACTIONS(1466),
    [anon_sym_GT_GT] = ACTIONS(1464),
    [anon_sym_GT_GT_GT] = ACTIONS(1466),
    [anon_sym_LT_LT] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1464),
    [anon_sym_CARET] = ACTIONS(1466),
    [anon_sym_PIPE] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_PERCENT] = ACTIONS(1466),
    [anon_sym_STAR_STAR] = ACTIONS(1466),
    [anon_sym_LT_EQ] = ACTIONS(1466),
    [anon_sym_EQ_EQ] = ACTIONS(1464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1466),
    [anon_sym_BANG_EQ] = ACTIONS(1464),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1466),
    [anon_sym_GT_EQ] = ACTIONS(1466),
    [anon_sym_QMARK_QMARK] = ACTIONS(1466),
    [anon_sym_instanceof] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1460),
    [anon_sym_void] = ACTIONS(1462),
    [anon_sym_delete] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [anon_sym_SQUOTE] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1460),
    [sym_number] = ACTIONS(1460),
    [sym_this] = ACTIONS(1462),
    [sym_super] = ACTIONS(1462),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [sym_null] = ACTIONS(1462),
    [sym_undefined] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_readonly] = ACTIONS(1462),
    [anon_sym_get] = ACTIONS(1462),
    [anon_sym_set] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_public] = ACTIONS(1462),
    [anon_sym_private] = ACTIONS(1462),
    [anon_sym_protected] = ACTIONS(1462),
    [anon_sym_override] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_any] = ACTIONS(1462),
    [anon_sym_number] = ACTIONS(1462),
    [anon_sym_boolean] = ACTIONS(1462),
    [anon_sym_string] = ACTIONS(1462),
    [anon_sym_symbol] = ACTIONS(1462),
    [anon_sym_abstract] = ACTIONS(1462),
    [anon_sym_interface] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [sym__automatic_semicolon] = ACTIONS(1468),
    [sym__ternary_qmark] = ACTIONS(1466),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(1470),
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_export] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_type] = ACTIONS(1472),
    [anon_sym_as] = ACTIONS(1474),
    [anon_sym_namespace] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1470),
    [anon_sym_typeof] = ACTIONS(1472),
    [anon_sym_import] = ACTIONS(1472),
    [anon_sym_var] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_in] = ACTIONS(1474),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_try] = ACTIONS(1472),
    [anon_sym_with] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_debugger] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_throw] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1470),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_GT] = ACTIONS(1474),
    [anon_sym_SLASH] = ACTIONS(1472),
    [anon_sym_DOT] = ACTIONS(1474),
    [anon_sym_class] = ACTIONS(1472),
    [anon_sym_async] = ACTIONS(1472),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_QMARK_DOT] = ACTIONS(1476),
    [anon_sym_new] = ACTIONS(1472),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1474),
    [anon_sym_GT_GT_GT] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_PERCENT] = ACTIONS(1476),
    [anon_sym_STAR_STAR] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1476),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1476),
    [anon_sym_QMARK_QMARK] = ACTIONS(1476),
    [anon_sym_instanceof] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1472),
    [anon_sym_delete] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1470),
    [sym_number] = ACTIONS(1470),
    [sym_this] = ACTIONS(1472),
    [sym_super] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_undefined] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(1470),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_readonly] = ACTIONS(1472),
    [anon_sym_get] = ACTIONS(1472),
    [anon_sym_set] = ACTIONS(1472),
    [anon_sym_declare] = ACTIONS(1472),
    [anon_sym_public] = ACTIONS(1472),
    [anon_sym_private] = ACTIONS(1472),
    [anon_sym_protected] = ACTIONS(1472),
    [anon_sym_override] = ACTIONS(1472),
    [anon_sym_module] = ACTIONS(1472),
    [anon_sym_any] = ACTIONS(1472),
    [anon_sym_number] = ACTIONS(1472),
    [anon_sym_boolean] = ACTIONS(1472),
    [anon_sym_string] = ACTIONS(1472),
    [anon_sym_symbol] = ACTIONS(1472),
    [anon_sym_abstract] = ACTIONS(1472),
    [anon_sym_interface] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [sym__automatic_semicolon] = ACTIONS(1478),
    [sym__ternary_qmark] = ACTIONS(1476),
  },
  [142] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3744),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3744),
    [sym_optional_parameter] = STATE(3744),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1480),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [143] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3481),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3481),
    [sym_optional_parameter] = STATE(3481),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1488),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [144] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3744),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3744),
    [sym_optional_parameter] = STATE(3744),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [145] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3589),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3589),
    [sym_optional_parameter] = STATE(3589),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [146] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3744),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3744),
    [sym_optional_parameter] = STATE(3744),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1492),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [147] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3559),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3559),
    [sym_optional_parameter] = STATE(3559),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1494),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [148] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3744),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3744),
    [sym_optional_parameter] = STATE(3744),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1496),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [149] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3744),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3744),
    [sym_optional_parameter] = STATE(3744),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1498),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [150] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3744),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3744),
    [sym_optional_parameter] = STATE(3744),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1500),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [151] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym__formal_parameter] = STATE(3744),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3244),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(198),
    [sym_override_modifier] = STATE(202),
    [sym_required_parameter] = STATE(3744),
    [sym_optional_parameter] = STATE(3744),
    [sym__parameter_name] = STATE(2727),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [152] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1504),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [153] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [154] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1508),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_QMARK] = ACTIONS(1508),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [155] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1512),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [156] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1678),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3518),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3456),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1514),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [157] = {
    [sym_import] = STATE(1819),
    [sym_expression_statement] = STATE(197),
    [sym_variable_declaration] = STATE(197),
    [sym_lexical_declaration] = STATE(197),
    [sym_empty_statement] = STATE(197),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3462),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3462),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3462),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1101),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_export] = ACTIONS(1518),
    [anon_sym_type] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1520),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_var] = ACTIONS(1524),
    [anon_sym_let] = ACTIONS(1526),
    [anon_sym_const] = ACTIONS(1526),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1528),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1530),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1532),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_readonly] = ACTIONS(1518),
    [anon_sym_get] = ACTIONS(1518),
    [anon_sym_set] = ACTIONS(1518),
    [anon_sym_declare] = ACTIONS(1518),
    [anon_sym_public] = ACTIONS(1518),
    [anon_sym_private] = ACTIONS(1518),
    [anon_sym_protected] = ACTIONS(1518),
    [anon_sym_override] = ACTIONS(1518),
    [anon_sym_module] = ACTIONS(1518),
    [anon_sym_any] = ACTIONS(1518),
    [anon_sym_number] = ACTIONS(1518),
    [anon_sym_boolean] = ACTIONS(1518),
    [anon_sym_string] = ACTIONS(1518),
    [anon_sym_symbol] = ACTIONS(1518),
  },
  [158] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1589),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3518),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3456),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1514),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [159] = {
    [sym_import] = STATE(1819),
    [sym_expression_statement] = STATE(196),
    [sym_variable_declaration] = STATE(196),
    [sym_lexical_declaration] = STATE(196),
    [sym_empty_statement] = STATE(196),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3462),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3462),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3462),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1101),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_export] = ACTIONS(1518),
    [anon_sym_type] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1520),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_var] = ACTIONS(1524),
    [anon_sym_let] = ACTIONS(1526),
    [anon_sym_const] = ACTIONS(1526),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1528),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1530),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1532),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_readonly] = ACTIONS(1518),
    [anon_sym_get] = ACTIONS(1518),
    [anon_sym_set] = ACTIONS(1518),
    [anon_sym_declare] = ACTIONS(1518),
    [anon_sym_public] = ACTIONS(1518),
    [anon_sym_private] = ACTIONS(1518),
    [anon_sym_protected] = ACTIONS(1518),
    [anon_sym_override] = ACTIONS(1518),
    [anon_sym_module] = ACTIONS(1518),
    [anon_sym_any] = ACTIONS(1518),
    [anon_sym_number] = ACTIONS(1518),
    [anon_sym_boolean] = ACTIONS(1518),
    [anon_sym_string] = ACTIONS(1518),
    [anon_sym_symbol] = ACTIONS(1518),
  },
  [160] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [161] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1589),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3518),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3456),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [162] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1570),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3555),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3550),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1502),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [163] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1903),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(3558),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(3558),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(3558),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_mapped_type_clause] = STATE(3944),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_export] = ACTIONS(1542),
    [anon_sym_type] = ACTIONS(1542),
    [anon_sym_namespace] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1554),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1542),
    [anon_sym_readonly] = ACTIONS(1542),
    [anon_sym_get] = ACTIONS(1542),
    [anon_sym_set] = ACTIONS(1542),
    [anon_sym_declare] = ACTIONS(1542),
    [anon_sym_public] = ACTIONS(1542),
    [anon_sym_private] = ACTIONS(1542),
    [anon_sym_protected] = ACTIONS(1542),
    [anon_sym_override] = ACTIONS(1542),
    [anon_sym_module] = ACTIONS(1542),
    [anon_sym_any] = ACTIONS(1542),
    [anon_sym_number] = ACTIONS(1542),
    [anon_sym_boolean] = ACTIONS(1542),
    [anon_sym_string] = ACTIONS(1542),
    [anon_sym_symbol] = ACTIONS(1542),
  },
  [164] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
    [anon_sym_extends] = ACTIONS(1510),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1508),
    [sym__automatic_semicolon] = ACTIONS(1508),
  },
  [165] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_assignment_pattern] = STATE(3556),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3285),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_pattern_repeat1] = STATE(3549),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_RBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [166] = {
    [sym_identifier] = ACTIONS(1560),
    [anon_sym_export] = ACTIONS(1560),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1560),
    [anon_sym_LBRACE] = ACTIONS(1562),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(1560),
    [anon_sym_import] = ACTIONS(1560),
    [anon_sym_BANG] = ACTIONS(1560),
    [anon_sym_LPAREN] = ACTIONS(1562),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(1560),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1560),
    [anon_sym_async] = ACTIONS(1560),
    [anon_sym_function] = ACTIONS(1560),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1560),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1562),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1560),
    [anon_sym_DASH] = ACTIONS(1560),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1562),
    [anon_sym_void] = ACTIONS(1560),
    [anon_sym_delete] = ACTIONS(1560),
    [anon_sym_PLUS_PLUS] = ACTIONS(1562),
    [anon_sym_DASH_DASH] = ACTIONS(1562),
    [anon_sym_DQUOTE] = ACTIONS(1562),
    [anon_sym_SQUOTE] = ACTIONS(1562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1562),
    [sym_number] = ACTIONS(1562),
    [sym_this] = ACTIONS(1560),
    [sym_super] = ACTIONS(1560),
    [sym_true] = ACTIONS(1560),
    [sym_false] = ACTIONS(1560),
    [sym_null] = ACTIONS(1560),
    [sym_undefined] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(1562),
    [anon_sym_static] = ACTIONS(1560),
    [anon_sym_readonly] = ACTIONS(1560),
    [anon_sym_get] = ACTIONS(1560),
    [anon_sym_set] = ACTIONS(1560),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(1560),
    [anon_sym_public] = ACTIONS(1560),
    [anon_sym_private] = ACTIONS(1560),
    [anon_sym_protected] = ACTIONS(1560),
    [anon_sym_override] = ACTIONS(1560),
    [anon_sym_module] = ACTIONS(1560),
    [anon_sym_any] = ACTIONS(1560),
    [anon_sym_number] = ACTIONS(1560),
    [anon_sym_boolean] = ACTIONS(1560),
    [anon_sym_string] = ACTIONS(1560),
    [anon_sym_symbol] = ACTIONS(1560),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [167] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1911),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(3558),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(3558),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1130),
    [sym_subscript_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(3558),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(1564),
    [anon_sym_export] = ACTIONS(1566),
    [anon_sym_type] = ACTIONS(1566),
    [anon_sym_namespace] = ACTIONS(1568),
    [anon_sym_LBRACE] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_readonly] = ACTIONS(1566),
    [anon_sym_get] = ACTIONS(1566),
    [anon_sym_set] = ACTIONS(1566),
    [anon_sym_declare] = ACTIONS(1566),
    [anon_sym_public] = ACTIONS(1566),
    [anon_sym_private] = ACTIONS(1566),
    [anon_sym_protected] = ACTIONS(1566),
    [anon_sym_override] = ACTIONS(1566),
    [anon_sym_module] = ACTIONS(1566),
    [anon_sym_any] = ACTIONS(1566),
    [anon_sym_number] = ACTIONS(1566),
    [anon_sym_boolean] = ACTIONS(1566),
    [anon_sym_string] = ACTIONS(1566),
    [anon_sym_symbol] = ACTIONS(1566),
  },
  [168] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1657),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3623),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3373),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3425),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1572),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [169] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_assignment_pattern] = STATE(3532),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3304),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_pattern_repeat1] = STATE(3415),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [170] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1508),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [171] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1657),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3623),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3373),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3425),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1572),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1572),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [172] = {
    [sym_identifier] = ACTIONS(1579),
    [anon_sym_export] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1579),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1581),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(1579),
    [anon_sym_import] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1579),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_await] = ACTIONS(1579),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_yield] = ACTIONS(1579),
    [anon_sym_LBRACK] = ACTIONS(1581),
    [anon_sym_LT] = ACTIONS(1579),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1579),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1579),
    [anon_sym_async] = ACTIONS(1579),
    [anon_sym_function] = ACTIONS(1579),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1579),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1581),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1579),
    [anon_sym_DASH] = ACTIONS(1579),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1581),
    [anon_sym_void] = ACTIONS(1579),
    [anon_sym_delete] = ACTIONS(1579),
    [anon_sym_PLUS_PLUS] = ACTIONS(1581),
    [anon_sym_DASH_DASH] = ACTIONS(1581),
    [anon_sym_DQUOTE] = ACTIONS(1581),
    [anon_sym_SQUOTE] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1581),
    [sym_number] = ACTIONS(1581),
    [sym_this] = ACTIONS(1579),
    [sym_super] = ACTIONS(1579),
    [sym_true] = ACTIONS(1579),
    [sym_false] = ACTIONS(1579),
    [sym_null] = ACTIONS(1579),
    [sym_undefined] = ACTIONS(1579),
    [anon_sym_AT] = ACTIONS(1581),
    [anon_sym_static] = ACTIONS(1579),
    [anon_sym_readonly] = ACTIONS(1579),
    [anon_sym_get] = ACTIONS(1579),
    [anon_sym_set] = ACTIONS(1579),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(1579),
    [anon_sym_public] = ACTIONS(1579),
    [anon_sym_private] = ACTIONS(1579),
    [anon_sym_protected] = ACTIONS(1579),
    [anon_sym_override] = ACTIONS(1579),
    [anon_sym_module] = ACTIONS(1579),
    [anon_sym_any] = ACTIONS(1579),
    [anon_sym_number] = ACTIONS(1579),
    [anon_sym_boolean] = ACTIONS(1579),
    [anon_sym_string] = ACTIONS(1579),
    [anon_sym_symbol] = ACTIONS(1579),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [173] = {
    [sym_identifier] = ACTIONS(1560),
    [anon_sym_export] = ACTIONS(1560),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1560),
    [anon_sym_LBRACE] = ACTIONS(1562),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(1560),
    [anon_sym_import] = ACTIONS(1560),
    [anon_sym_BANG] = ACTIONS(1560),
    [anon_sym_LPAREN] = ACTIONS(1562),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_await] = ACTIONS(1560),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_yield] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1560),
    [anon_sym_async] = ACTIONS(1560),
    [anon_sym_function] = ACTIONS(1560),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1560),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1562),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1560),
    [anon_sym_DASH] = ACTIONS(1560),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1562),
    [anon_sym_void] = ACTIONS(1560),
    [anon_sym_delete] = ACTIONS(1560),
    [anon_sym_PLUS_PLUS] = ACTIONS(1562),
    [anon_sym_DASH_DASH] = ACTIONS(1562),
    [anon_sym_DQUOTE] = ACTIONS(1562),
    [anon_sym_SQUOTE] = ACTIONS(1562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1562),
    [sym_number] = ACTIONS(1562),
    [sym_this] = ACTIONS(1560),
    [sym_super] = ACTIONS(1560),
    [sym_true] = ACTIONS(1560),
    [sym_false] = ACTIONS(1560),
    [sym_null] = ACTIONS(1560),
    [sym_undefined] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(1562),
    [anon_sym_static] = ACTIONS(1560),
    [anon_sym_readonly] = ACTIONS(1560),
    [anon_sym_get] = ACTIONS(1560),
    [anon_sym_set] = ACTIONS(1560),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(1560),
    [anon_sym_public] = ACTIONS(1560),
    [anon_sym_private] = ACTIONS(1560),
    [anon_sym_protected] = ACTIONS(1560),
    [anon_sym_override] = ACTIONS(1560),
    [anon_sym_module] = ACTIONS(1560),
    [anon_sym_any] = ACTIONS(1560),
    [anon_sym_number] = ACTIONS(1560),
    [anon_sym_boolean] = ACTIONS(1560),
    [anon_sym_string] = ACTIONS(1560),
    [anon_sym_symbol] = ACTIONS(1560),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [174] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1657),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3623),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_spread_element] = STATE(3373),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3425),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1572),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1583),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [175] = {
    [sym_identifier] = ACTIONS(1579),
    [anon_sym_export] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1579),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1581),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(1579),
    [anon_sym_import] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1579),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(1579),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(1579),
    [anon_sym_LBRACK] = ACTIONS(1581),
    [anon_sym_LT] = ACTIONS(1579),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1579),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1579),
    [anon_sym_async] = ACTIONS(1579),
    [anon_sym_function] = ACTIONS(1579),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1579),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1581),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1579),
    [anon_sym_DASH] = ACTIONS(1579),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1581),
    [anon_sym_void] = ACTIONS(1579),
    [anon_sym_delete] = ACTIONS(1579),
    [anon_sym_PLUS_PLUS] = ACTIONS(1581),
    [anon_sym_DASH_DASH] = ACTIONS(1581),
    [anon_sym_DQUOTE] = ACTIONS(1581),
    [anon_sym_SQUOTE] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1581),
    [sym_number] = ACTIONS(1581),
    [sym_this] = ACTIONS(1579),
    [sym_super] = ACTIONS(1579),
    [sym_true] = ACTIONS(1579),
    [sym_false] = ACTIONS(1579),
    [sym_null] = ACTIONS(1579),
    [sym_undefined] = ACTIONS(1579),
    [anon_sym_AT] = ACTIONS(1581),
    [anon_sym_static] = ACTIONS(1579),
    [anon_sym_readonly] = ACTIONS(1579),
    [anon_sym_get] = ACTIONS(1579),
    [anon_sym_set] = ACTIONS(1579),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(1579),
    [anon_sym_public] = ACTIONS(1579),
    [anon_sym_private] = ACTIONS(1579),
    [anon_sym_protected] = ACTIONS(1579),
    [anon_sym_override] = ACTIONS(1579),
    [anon_sym_module] = ACTIONS(1579),
    [anon_sym_any] = ACTIONS(1579),
    [anon_sym_number] = ACTIONS(1579),
    [anon_sym_boolean] = ACTIONS(1579),
    [anon_sym_string] = ACTIONS(1579),
    [anon_sym_symbol] = ACTIONS(1579),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [176] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_assignment_pattern] = STATE(3623),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3425),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_RBRACK] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [177] = {
    [sym_export_clause] = STATE(3345),
    [sym_declaration] = STATE(623),
    [sym_namespace_import_export] = STATE(3792),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_class_declaration] = STATE(629),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function_declaration] = STATE(629),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(629),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(624),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_default] = ACTIONS(1591),
    [anon_sym_type] = ACTIONS(1593),
    [anon_sym_EQ] = ACTIONS(1595),
    [anon_sym_as] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1632),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1638),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [178] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1661),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_spread_element] = STATE(3465),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3472),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [179] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1682),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_spread_element] = STATE(3469),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3470),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1646),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [180] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1657),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_spread_element] = STATE(3373),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1648),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [181] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_spread_element] = STATE(3461),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3477),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [182] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3145),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_accessibility_modifier] = STATE(195),
    [sym_override_modifier] = STATE(217),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(1111),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(1652),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1654),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1656),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [183] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1530),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_spread_element] = STATE(3482),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3479),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1658),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [184] = {
    [sym_export_clause] = STATE(3345),
    [sym_declaration] = STATE(623),
    [sym_namespace_import_export] = STATE(3792),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_class_declaration] = STATE(629),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function_declaration] = STATE(629),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(629),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(624),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [aux_sym_object_repeat1] = STATE(3499),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_default] = ACTIONS(1591),
    [anon_sym_type] = ACTIONS(1593),
    [anon_sym_EQ] = ACTIONS(1595),
    [anon_sym_as] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1632),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1638),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [185] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1806),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [186] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1499),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [187] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1941),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [188] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1670),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_spread_element] = STATE(3489),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3484),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [189] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1505),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [190] = {
    [sym_export_clause] = STATE(3345),
    [sym_declaration] = STATE(623),
    [sym_namespace_import_export] = STATE(3792),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_class_declaration] = STATE(629),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function_declaration] = STATE(629),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(629),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(624),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_default] = ACTIONS(1591),
    [anon_sym_type] = ACTIONS(1593),
    [anon_sym_EQ] = ACTIONS(1595),
    [anon_sym_as] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1632),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1638),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [191] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1679),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [192] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1743),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
    [anon_sym_extends] = ACTIONS(1510),
  },
  [193] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1680),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_spread_element] = STATE(3404),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3405),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1666),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [194] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1684),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_spread_element] = STATE(3490),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [aux_sym_array_repeat1] = STATE(3491),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1640),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1668),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1644),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [195] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3007),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_override_modifier] = STATE(201),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1670),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1672),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [196] = {
    [sym_import] = STATE(1819),
    [sym_expression_statement] = STATE(222),
    [sym_empty_statement] = STATE(222),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [197] = {
    [sym_import] = STATE(1819),
    [sym_expression_statement] = STATE(221),
    [sym_empty_statement] = STATE(221),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1556),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3758),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [198] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3204),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_override_modifier] = STATE(216),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(637),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1674),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [199] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1816),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2732),
    [sym_assignment_pattern] = STATE(3706),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2732),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1043),
    [sym_subscript_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2732),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3488),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1043),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_export] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(559),
    [anon_sym_namespace] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_readonly] = ACTIONS(559),
    [anon_sym_get] = ACTIONS(559),
    [anon_sym_set] = ACTIONS(559),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_override] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_any] = ACTIONS(559),
    [anon_sym_number] = ACTIONS(559),
    [anon_sym_boolean] = ACTIONS(559),
    [anon_sym_string] = ACTIONS(559),
    [anon_sym_symbol] = ACTIONS(559),
  },
  [200] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_assignment_pattern] = STATE(3706),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3488),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [201] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3210),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1676),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1678),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [202] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3204),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(637),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1674),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [203] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1941),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1680),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [204] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1682),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [205] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1684),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [206] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [207] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1688),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [208] = {
    [sym_import] = STATE(2056),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym__type_query_member_expression] = STATE(2342),
    [sym__type_query_subscript_expression] = STATE(2343),
    [sym__type_query_call_expression] = STATE(2451),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1690),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [209] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1679),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1692),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [210] = {
    [sym_import] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1743),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1694),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [211] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1806),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1696),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [212] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1584),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3801),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
    [sym__automatic_semicolon] = ACTIONS(1698),
  },
  [213] = {
    [sym_import] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1499),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1700),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [214] = {
    [sym_import] = STATE(1559),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1505),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1702),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [215] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [216] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(2991),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(619),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1706),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [217] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2756),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2756),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1052),
    [sym_subscript_expression] = STATE(1052),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2756),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_pattern] = STATE(3014),
    [sym_rest_pattern] = STATE(2728),
    [sym_non_null_expression] = STATE(1052),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(1708),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1710),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [218] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1144),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(3395),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(3395),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1144),
    [sym_subscript_expression] = STATE(1144),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(3395),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1712),
    [anon_sym_export] = ACTIONS(1714),
    [anon_sym_type] = ACTIONS(1714),
    [anon_sym_namespace] = ACTIONS(1716),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_var] = ACTIONS(1720),
    [anon_sym_let] = ACTIONS(1722),
    [anon_sym_const] = ACTIONS(1722),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1724),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1726),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1728),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1714),
    [anon_sym_readonly] = ACTIONS(1714),
    [anon_sym_get] = ACTIONS(1714),
    [anon_sym_set] = ACTIONS(1714),
    [anon_sym_declare] = ACTIONS(1714),
    [anon_sym_public] = ACTIONS(1714),
    [anon_sym_private] = ACTIONS(1714),
    [anon_sym_protected] = ACTIONS(1714),
    [anon_sym_override] = ACTIONS(1714),
    [anon_sym_module] = ACTIONS(1714),
    [anon_sym_any] = ACTIONS(1714),
    [anon_sym_number] = ACTIONS(1714),
    [anon_sym_boolean] = ACTIONS(1714),
    [anon_sym_string] = ACTIONS(1714),
    [anon_sym_symbol] = ACTIONS(1714),
  },
  [219] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym__type_query_member_expression] = STATE(2267),
    [sym__type_query_subscript_expression] = STATE(2268),
    [sym__type_query_call_expression] = STATE(2303),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1730),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [220] = {
    [sym_declaration] = STATE(738),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_class_declaration] = STATE(629),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function_declaration] = STATE(629),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(629),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(624),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [aux_sym_object_repeat1] = STATE(3499),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1736),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_global] = ACTIONS(1738),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1638),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [221] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1784),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4150),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1740),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [222] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1829),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4113),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_RPAREN] = ACTIONS(1742),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [223] = {
    [sym_declaration] = STATE(738),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_class_declaration] = STATE(629),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function_declaration] = STATE(629),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(629),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(624),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1736),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_global] = ACTIONS(1738),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1638),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [224] = {
    [sym_declaration] = STATE(738),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_class_declaration] = STATE(629),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function_declaration] = STATE(629),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(629),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(624),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1736),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_global] = ACTIONS(1738),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1638),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [225] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1356),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1985),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [226] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1339),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1603),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [227] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1335),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(3286),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [228] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1325),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1326),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [229] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1356),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1935),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [230] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1339),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1937),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [231] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1740),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1432),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [232] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1401),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1938),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [233] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1939),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [234] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1903),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_mapped_type_clause] = STATE(3944),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(1752),
    [anon_sym_type] = ACTIONS(1752),
    [anon_sym_namespace] = ACTIONS(1754),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1756),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1752),
    [anon_sym_readonly] = ACTIONS(1752),
    [anon_sym_get] = ACTIONS(1752),
    [anon_sym_set] = ACTIONS(1752),
    [anon_sym_declare] = ACTIONS(1752),
    [anon_sym_public] = ACTIONS(1752),
    [anon_sym_private] = ACTIONS(1752),
    [anon_sym_protected] = ACTIONS(1752),
    [anon_sym_override] = ACTIONS(1752),
    [anon_sym_module] = ACTIONS(1752),
    [anon_sym_any] = ACTIONS(1752),
    [anon_sym_number] = ACTIONS(1752),
    [anon_sym_boolean] = ACTIONS(1752),
    [anon_sym_string] = ACTIONS(1752),
    [anon_sym_symbol] = ACTIONS(1752),
  },
  [235] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1357),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [236] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [237] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(3174),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3828),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [238] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1967),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [239] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1401),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1968),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [240] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1339),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1973),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [241] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2989),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3643),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1762),
    [anon_sym_export] = ACTIONS(1764),
    [anon_sym_type] = ACTIONS(1764),
    [anon_sym_namespace] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1768),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1764),
    [anon_sym_readonly] = ACTIONS(1764),
    [anon_sym_get] = ACTIONS(1764),
    [anon_sym_set] = ACTIONS(1764),
    [anon_sym_declare] = ACTIONS(1764),
    [anon_sym_public] = ACTIONS(1764),
    [anon_sym_private] = ACTIONS(1764),
    [anon_sym_protected] = ACTIONS(1764),
    [anon_sym_override] = ACTIONS(1764),
    [anon_sym_module] = ACTIONS(1764),
    [anon_sym_any] = ACTIONS(1764),
    [anon_sym_number] = ACTIONS(1764),
    [anon_sym_boolean] = ACTIONS(1764),
    [anon_sym_string] = ACTIONS(1764),
    [anon_sym_symbol] = ACTIONS(1764),
  },
  [242] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1055),
    [sym_expression] = STATE(2017),
    [sym_primary_expression] = STATE(1450),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1055),
    [sym_subscript_expression] = STATE(1055),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(3174),
    [sym_non_null_expression] = STATE(1055),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3828),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_export] = ACTIONS(1772),
    [anon_sym_type] = ACTIONS(1772),
    [anon_sym_namespace] = ACTIONS(1774),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1776),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1772),
    [anon_sym_readonly] = ACTIONS(1772),
    [anon_sym_get] = ACTIONS(1772),
    [anon_sym_set] = ACTIONS(1772),
    [anon_sym_declare] = ACTIONS(1772),
    [anon_sym_public] = ACTIONS(1772),
    [anon_sym_private] = ACTIONS(1772),
    [anon_sym_protected] = ACTIONS(1772),
    [anon_sym_override] = ACTIONS(1772),
    [anon_sym_module] = ACTIONS(1772),
    [anon_sym_any] = ACTIONS(1772),
    [anon_sym_number] = ACTIONS(1772),
    [anon_sym_boolean] = ACTIONS(1772),
    [anon_sym_string] = ACTIONS(1772),
    [anon_sym_symbol] = ACTIONS(1772),
  },
  [243] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1356),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1764),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [244] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1356),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1308),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [245] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1841),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4036),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [246] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1839),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4035),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [247] = {
    [sym_export_clause] = STATE(3345),
    [sym_declaration] = STATE(623),
    [sym_namespace_import_export] = STATE(3792),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_class_declaration] = STATE(629),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function_declaration] = STATE(629),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(629),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(624),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_default] = ACTIONS(1591),
    [anon_sym_type] = ACTIONS(1593),
    [anon_sym_EQ] = ACTIONS(1782),
    [anon_sym_as] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1784),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1632),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1638),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [248] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1055),
    [sym_expression] = STATE(2017),
    [sym_primary_expression] = STATE(1450),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1055),
    [sym_subscript_expression] = STATE(1055),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(3174),
    [sym_non_null_expression] = STATE(1055),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3828),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_readonly] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_override] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
  },
  [249] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1910),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [250] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1836),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4029),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [251] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1834),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4027),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [252] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1055),
    [sym_expression] = STATE(2017),
    [sym_primary_expression] = STATE(1450),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1055),
    [sym_subscript_expression] = STATE(1055),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1055),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_export] = ACTIONS(1772),
    [anon_sym_type] = ACTIONS(1772),
    [anon_sym_namespace] = ACTIONS(1774),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1776),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1772),
    [anon_sym_readonly] = ACTIONS(1772),
    [anon_sym_get] = ACTIONS(1772),
    [anon_sym_set] = ACTIONS(1772),
    [anon_sym_declare] = ACTIONS(1772),
    [anon_sym_public] = ACTIONS(1772),
    [anon_sym_private] = ACTIONS(1772),
    [anon_sym_protected] = ACTIONS(1772),
    [anon_sym_override] = ACTIONS(1772),
    [anon_sym_module] = ACTIONS(1772),
    [anon_sym_any] = ACTIONS(1772),
    [anon_sym_number] = ACTIONS(1772),
    [anon_sym_boolean] = ACTIONS(1772),
    [anon_sym_string] = ACTIONS(1772),
    [anon_sym_symbol] = ACTIONS(1772),
  },
  [253] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1699),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4143),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [254] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1740),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1413),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [255] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(3174),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3828),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1794),
    [anon_sym_export] = ACTIONS(1796),
    [anon_sym_type] = ACTIONS(1796),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1796),
    [anon_sym_readonly] = ACTIONS(1796),
    [anon_sym_get] = ACTIONS(1796),
    [anon_sym_set] = ACTIONS(1796),
    [anon_sym_declare] = ACTIONS(1796),
    [anon_sym_public] = ACTIONS(1796),
    [anon_sym_private] = ACTIONS(1796),
    [anon_sym_protected] = ACTIONS(1796),
    [anon_sym_override] = ACTIONS(1796),
    [anon_sym_module] = ACTIONS(1796),
    [anon_sym_any] = ACTIONS(1796),
    [anon_sym_number] = ACTIONS(1796),
    [anon_sym_boolean] = ACTIONS(1796),
    [anon_sym_string] = ACTIONS(1796),
    [anon_sym_symbol] = ACTIONS(1796),
  },
  [256] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1704),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1420),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [257] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [258] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(3174),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3828),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1802),
    [anon_sym_export] = ACTIONS(1804),
    [anon_sym_type] = ACTIONS(1804),
    [anon_sym_namespace] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1808),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1804),
    [anon_sym_readonly] = ACTIONS(1804),
    [anon_sym_get] = ACTIONS(1804),
    [anon_sym_set] = ACTIONS(1804),
    [anon_sym_declare] = ACTIONS(1804),
    [anon_sym_public] = ACTIONS(1804),
    [anon_sym_private] = ACTIONS(1804),
    [anon_sym_protected] = ACTIONS(1804),
    [anon_sym_override] = ACTIONS(1804),
    [anon_sym_module] = ACTIONS(1804),
    [anon_sym_any] = ACTIONS(1804),
    [anon_sym_number] = ACTIONS(1804),
    [anon_sym_boolean] = ACTIONS(1804),
    [anon_sym_string] = ACTIONS(1804),
    [anon_sym_symbol] = ACTIONS(1804),
  },
  [259] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1721),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1465),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [260] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1325),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2037),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [261] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1501),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4105),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [262] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(3174),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3828),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1810),
    [anon_sym_export] = ACTIONS(1812),
    [anon_sym_type] = ACTIONS(1812),
    [anon_sym_namespace] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1816),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1812),
    [anon_sym_readonly] = ACTIONS(1812),
    [anon_sym_get] = ACTIONS(1812),
    [anon_sym_set] = ACTIONS(1812),
    [anon_sym_declare] = ACTIONS(1812),
    [anon_sym_public] = ACTIONS(1812),
    [anon_sym_private] = ACTIONS(1812),
    [anon_sym_protected] = ACTIONS(1812),
    [anon_sym_override] = ACTIONS(1812),
    [anon_sym_module] = ACTIONS(1812),
    [anon_sym_any] = ACTIONS(1812),
    [anon_sym_number] = ACTIONS(1812),
    [anon_sym_boolean] = ACTIONS(1812),
    [anon_sym_string] = ACTIONS(1812),
    [anon_sym_symbol] = ACTIONS(1812),
  },
  [263] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1536),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [264] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1325),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1533),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [265] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2041),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [266] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1887),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(3871),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [267] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1356),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [268] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1704),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1451),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [269] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1401),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1615),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [270] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1512),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [271] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1667),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3630),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [272] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1903),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_mapped_type_clause] = STATE(4123),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1820),
    [anon_sym_type] = ACTIONS(1820),
    [anon_sym_namespace] = ACTIONS(1822),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1824),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1820),
    [anon_sym_readonly] = ACTIONS(1820),
    [anon_sym_get] = ACTIONS(1820),
    [anon_sym_set] = ACTIONS(1820),
    [anon_sym_declare] = ACTIONS(1820),
    [anon_sym_public] = ACTIONS(1820),
    [anon_sym_private] = ACTIONS(1820),
    [anon_sym_protected] = ACTIONS(1820),
    [anon_sym_override] = ACTIONS(1820),
    [anon_sym_module] = ACTIONS(1820),
    [anon_sym_any] = ACTIONS(1820),
    [anon_sym_number] = ACTIONS(1820),
    [anon_sym_boolean] = ACTIONS(1820),
    [anon_sym_string] = ACTIONS(1820),
    [anon_sym_symbol] = ACTIONS(1820),
  },
  [273] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1339),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1405),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [274] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1871),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1468),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [275] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1710),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4124),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [276] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1055),
    [sym_expression] = STATE(2017),
    [sym_primary_expression] = STATE(1450),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1055),
    [sym_subscript_expression] = STATE(1055),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1055),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_readonly] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_override] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
  },
  [277] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1810),
    [anon_sym_export] = ACTIONS(1812),
    [anon_sym_type] = ACTIONS(1812),
    [anon_sym_namespace] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1816),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1812),
    [anon_sym_readonly] = ACTIONS(1812),
    [anon_sym_get] = ACTIONS(1812),
    [anon_sym_set] = ACTIONS(1812),
    [anon_sym_declare] = ACTIONS(1812),
    [anon_sym_public] = ACTIONS(1812),
    [anon_sym_private] = ACTIONS(1812),
    [anon_sym_protected] = ACTIONS(1812),
    [anon_sym_override] = ACTIONS(1812),
    [anon_sym_module] = ACTIONS(1812),
    [anon_sym_any] = ACTIONS(1812),
    [anon_sym_number] = ACTIONS(1812),
    [anon_sym_boolean] = ACTIONS(1812),
    [anon_sym_string] = ACTIONS(1812),
    [anon_sym_symbol] = ACTIONS(1812),
  },
  [278] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1890),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1469),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [279] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1854),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4038),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [280] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1888),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1470),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [281] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1401),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1407),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [282] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1865),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [283] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1704),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1867),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [284] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1401),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1858),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [285] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1786),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4149),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [286] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1585),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_sequence_expression] = STATE(3797),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [287] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1486),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(3903),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [288] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1382),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [289] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1796),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(3987),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [290] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1802),
    [anon_sym_export] = ACTIONS(1804),
    [anon_sym_type] = ACTIONS(1804),
    [anon_sym_namespace] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1808),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1804),
    [anon_sym_readonly] = ACTIONS(1804),
    [anon_sym_get] = ACTIONS(1804),
    [anon_sym_set] = ACTIONS(1804),
    [anon_sym_declare] = ACTIONS(1804),
    [anon_sym_public] = ACTIONS(1804),
    [anon_sym_private] = ACTIONS(1804),
    [anon_sym_protected] = ACTIONS(1804),
    [anon_sym_override] = ACTIONS(1804),
    [anon_sym_module] = ACTIONS(1804),
    [anon_sym_any] = ACTIONS(1804),
    [anon_sym_number] = ACTIONS(1804),
    [anon_sym_boolean] = ACTIONS(1804),
    [anon_sym_string] = ACTIONS(1804),
    [anon_sym_symbol] = ACTIONS(1804),
  },
  [291] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1888),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1797),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [292] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1890),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1799),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [293] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1721),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1446),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [294] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1361),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1733),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [295] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1871),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1801),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [296] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1789),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4147),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [297] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1339),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1826),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [298] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(3174),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3828),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1762),
    [anon_sym_export] = ACTIONS(1764),
    [anon_sym_type] = ACTIONS(1764),
    [anon_sym_namespace] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1768),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1764),
    [anon_sym_readonly] = ACTIONS(1764),
    [anon_sym_get] = ACTIONS(1764),
    [anon_sym_set] = ACTIONS(1764),
    [anon_sym_declare] = ACTIONS(1764),
    [anon_sym_public] = ACTIONS(1764),
    [anon_sym_private] = ACTIONS(1764),
    [anon_sym_protected] = ACTIONS(1764),
    [anon_sym_override] = ACTIONS(1764),
    [anon_sym_module] = ACTIONS(1764),
    [anon_sym_any] = ACTIONS(1764),
    [anon_sym_number] = ACTIONS(1764),
    [anon_sym_boolean] = ACTIONS(1764),
    [anon_sym_string] = ACTIONS(1764),
    [anon_sym_symbol] = ACTIONS(1764),
  },
  [299] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1792),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4145),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [300] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1055),
    [sym_expression] = STATE(2017),
    [sym_primary_expression] = STATE(1450),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1055),
    [sym_subscript_expression] = STATE(1055),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(3174),
    [sym_non_null_expression] = STATE(1055),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3828),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_export] = ACTIONS(1828),
    [anon_sym_type] = ACTIONS(1828),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1832),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1828),
    [anon_sym_readonly] = ACTIONS(1828),
    [anon_sym_get] = ACTIONS(1828),
    [anon_sym_set] = ACTIONS(1828),
    [anon_sym_declare] = ACTIONS(1828),
    [anon_sym_public] = ACTIONS(1828),
    [anon_sym_private] = ACTIONS(1828),
    [anon_sym_protected] = ACTIONS(1828),
    [anon_sym_override] = ACTIONS(1828),
    [anon_sym_module] = ACTIONS(1828),
    [anon_sym_any] = ACTIONS(1828),
    [anon_sym_number] = ACTIONS(1828),
    [anon_sym_boolean] = ACTIONS(1828),
    [anon_sym_string] = ACTIONS(1828),
    [anon_sym_symbol] = ACTIONS(1828),
  },
  [301] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1762),
    [anon_sym_export] = ACTIONS(1764),
    [anon_sym_type] = ACTIONS(1764),
    [anon_sym_namespace] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1768),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1764),
    [anon_sym_readonly] = ACTIONS(1764),
    [anon_sym_get] = ACTIONS(1764),
    [anon_sym_set] = ACTIONS(1764),
    [anon_sym_declare] = ACTIONS(1764),
    [anon_sym_public] = ACTIONS(1764),
    [anon_sym_private] = ACTIONS(1764),
    [anon_sym_protected] = ACTIONS(1764),
    [anon_sym_override] = ACTIONS(1764),
    [anon_sym_module] = ACTIONS(1764),
    [anon_sym_any] = ACTIONS(1764),
    [anon_sym_number] = ACTIONS(1764),
    [anon_sym_boolean] = ACTIONS(1764),
    [anon_sym_string] = ACTIONS(1764),
    [anon_sym_symbol] = ACTIONS(1764),
  },
  [302] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1740),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1778),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [303] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1877),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(4064),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [304] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1721),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1835),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [305] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1325),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1917),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1744),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [306] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1325),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1701),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [307] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1055),
    [sym_expression] = STATE(2017),
    [sym_primary_expression] = STATE(1450),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1055),
    [sym_subscript_expression] = STATE(1055),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1055),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_export] = ACTIONS(1828),
    [anon_sym_type] = ACTIONS(1828),
    [anon_sym_namespace] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1832),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1778),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1828),
    [anon_sym_readonly] = ACTIONS(1828),
    [anon_sym_get] = ACTIONS(1828),
    [anon_sym_set] = ACTIONS(1828),
    [anon_sym_declare] = ACTIONS(1828),
    [anon_sym_public] = ACTIONS(1828),
    [anon_sym_private] = ACTIONS(1828),
    [anon_sym_protected] = ACTIONS(1828),
    [anon_sym_override] = ACTIONS(1828),
    [anon_sym_module] = ACTIONS(1828),
    [anon_sym_any] = ACTIONS(1828),
    [anon_sym_number] = ACTIONS(1828),
    [anon_sym_boolean] = ACTIONS(1828),
    [anon_sym_string] = ACTIONS(1828),
    [anon_sym_symbol] = ACTIONS(1828),
  },
  [308] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1890),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1489),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [309] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1201),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1794),
    [anon_sym_export] = ACTIONS(1796),
    [anon_sym_type] = ACTIONS(1796),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1796),
    [anon_sym_readonly] = ACTIONS(1796),
    [anon_sym_get] = ACTIONS(1796),
    [anon_sym_set] = ACTIONS(1796),
    [anon_sym_declare] = ACTIONS(1796),
    [anon_sym_public] = ACTIONS(1796),
    [anon_sym_private] = ACTIONS(1796),
    [anon_sym_protected] = ACTIONS(1796),
    [anon_sym_override] = ACTIONS(1796),
    [anon_sym_module] = ACTIONS(1796),
    [anon_sym_any] = ACTIONS(1796),
    [anon_sym_number] = ACTIONS(1796),
    [anon_sym_boolean] = ACTIONS(1796),
    [anon_sym_string] = ACTIONS(1796),
    [anon_sym_symbol] = ACTIONS(1796),
  },
  [310] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1871),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1490),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [311] = {
    [sym_export_clause] = STATE(3345),
    [sym_declaration] = STATE(623),
    [sym_namespace_import_export] = STATE(3792),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_class_declaration] = STATE(629),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function_declaration] = STATE(629),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(629),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(624),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_default] = ACTIONS(1834),
    [anon_sym_type] = ACTIONS(1593),
    [anon_sym_EQ] = ACTIONS(1782),
    [anon_sym_as] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1836),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1632),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1638),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [312] = {
    [sym_import] = STATE(1819),
    [sym_statement_block] = STATE(1888),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1488),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [313] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1845),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [314] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1484),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(3124),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(3124),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1095),
    [sym_subscript_expression] = STATE(1095),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(3124),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1095),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1838),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
  },
  [315] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2019),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [316] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1431),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [317] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1771),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [318] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [319] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1435),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [320] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1436),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [321] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1437),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [322] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1438),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [323] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1439),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [324] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1440),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [325] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1443),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [326] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1444),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [327] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1445),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [328] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1447),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [329] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [330] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1903),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [331] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1833),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [332] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1838),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [333] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1840),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [334] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1842),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [335] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1909),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [336] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1499),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [337] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1846),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [338] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1847),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [339] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1848),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [340] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1849),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [341] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1850),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [342] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1851),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [343] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1856),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [344] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [345] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1900),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [346] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1881),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [347] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1779),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [348] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1484),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [349] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1777),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [350] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1747),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [351] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1767),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [352] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1510),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [353] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1508),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [354] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1461),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [355] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1911),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [356] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1461),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [357] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1846),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [358] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1848),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [359] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1496),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [360] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [361] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1956),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [362] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1505),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [363] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2045),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [364] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1850),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [365] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2043),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [366] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1828),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [367] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1827),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [368] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2039),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [369] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [370] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2035),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [371] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2022),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [372] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1477),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [373] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [374] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1418),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [375] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2018),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [376] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2014),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [377] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1850),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [378] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2012),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [379] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2011),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [380] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2008),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [381] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1478),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [382] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2007),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [383] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2006),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [384] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1990),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [385] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1988),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [386] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1906),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [387] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1941),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1848),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [388] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1984),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [389] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1679),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1848),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [390] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1487),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [391] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1683),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [392] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1679),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [393] = {
    [sym__call_signature] = STATE(4045),
    [sym_string] = STATE(2901),
    [sym_formal_parameters] = STATE(2972),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1852),
    [anon_sym_export] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1854),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1866),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_readonly] = ACTIONS(1854),
    [anon_sym_get] = ACTIONS(1874),
    [anon_sym_set] = ACTIONS(1874),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1854),
    [anon_sym_public] = ACTIONS(1854),
    [anon_sym_private] = ACTIONS(1854),
    [anon_sym_protected] = ACTIONS(1854),
    [anon_sym_override] = ACTIONS(1854),
    [anon_sym_module] = ACTIONS(1854),
    [anon_sym_any] = ACTIONS(1854),
    [anon_sym_number] = ACTIONS(1854),
    [anon_sym_boolean] = ACTIONS(1854),
    [anon_sym_string] = ACTIONS(1854),
    [anon_sym_symbol] = ACTIONS(1854),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [394] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1743),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(1876),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [395] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1971),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [396] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1623),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [397] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [398] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1503),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [399] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [400] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1892),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [401] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1806),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1848),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [402] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1427),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [403] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1430),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [404] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1602),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [405] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1433),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [406] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1425),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [407] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1848),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [408] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1891),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [409] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1452),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [410] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1453),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [411] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1454),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [412] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1455),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [413] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1419),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [414] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1598),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [415] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1583),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [416] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1456),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [417] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1457),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [418] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1458),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [419] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1459),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [420] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1460),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [421] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1462),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [422] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1527),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [423] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1463),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [424] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1464),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [425] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1466),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [426] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1471),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [427] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1519),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [428] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1520),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [429] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1945),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [430] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1522),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [431] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [432] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1524),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [433] = {
    [sym__call_signature] = STATE(4045),
    [sym_string] = STATE(2901),
    [sym_formal_parameters] = STATE(2972),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1852),
    [anon_sym_export] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1854),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1866),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_readonly] = ACTIONS(1854),
    [anon_sym_get] = ACTIONS(1874),
    [anon_sym_set] = ACTIONS(1874),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1854),
    [anon_sym_public] = ACTIONS(1854),
    [anon_sym_private] = ACTIONS(1854),
    [anon_sym_protected] = ACTIONS(1854),
    [anon_sym_override] = ACTIONS(1854),
    [anon_sym_module] = ACTIONS(1854),
    [anon_sym_any] = ACTIONS(1854),
    [anon_sym_number] = ACTIONS(1854),
    [anon_sym_boolean] = ACTIONS(1854),
    [anon_sym_string] = ACTIONS(1854),
    [anon_sym_symbol] = ACTIONS(1854),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [434] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1604),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [435] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1746),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [436] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1745),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [437] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1448),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [438] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1525),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [439] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1824),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [440] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1404),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [441] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1528),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [442] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1389),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [443] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1692),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [444] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1702),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [445] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1493),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [446] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1529),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [447] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1705),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [448] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1708),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [449] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1816),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [450] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1531),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [451] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1532),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [452] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1449),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [453] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1534),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [454] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1709),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [455] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1714),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [456] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1724),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [457] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1535),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [458] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1725),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [459] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1739),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [460] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1753),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [461] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1757),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [462] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1828),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1878),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [463] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1537),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [464] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1315),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [465] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1761),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [466] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1426),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [467] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1762),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [468] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1765),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [469] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_expression] = STATE(1505),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(4101),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(4101),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(4099),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1099),
    [sym_subscript_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2336),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(4101),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(402),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(1876),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_readonly] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(797),
    [anon_sym_private] = ACTIONS(797),
    [anon_sym_protected] = ACTIONS(797),
    [anon_sym_override] = ACTIONS(797),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
  },
  [470] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(2738),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(2738),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1045),
    [sym_subscript_expression] = STATE(1045),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(2738),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1045),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1880),
    [anon_sym_export] = ACTIONS(1882),
    [anon_sym_type] = ACTIONS(1882),
    [anon_sym_namespace] = ACTIONS(1884),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1886),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1888),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1882),
    [anon_sym_readonly] = ACTIONS(1882),
    [anon_sym_get] = ACTIONS(1882),
    [anon_sym_set] = ACTIONS(1882),
    [anon_sym_declare] = ACTIONS(1882),
    [anon_sym_public] = ACTIONS(1882),
    [anon_sym_private] = ACTIONS(1882),
    [anon_sym_protected] = ACTIONS(1882),
    [anon_sym_override] = ACTIONS(1882),
    [anon_sym_module] = ACTIONS(1882),
    [anon_sym_any] = ACTIONS(1882),
    [anon_sym_number] = ACTIONS(1882),
    [anon_sym_boolean] = ACTIONS(1882),
    [anon_sym_string] = ACTIONS(1882),
    [anon_sym_symbol] = ACTIONS(1882),
  },
  [471] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [472] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1889),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [473] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_expression] = STATE(1560),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4092),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4092),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4047),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1123),
    [sym_subscript_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2345),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4092),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1123),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_void] = ACTIONS(777),
    [anon_sym_delete] = ACTIONS(777),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(751),
    [anon_sym_readonly] = ACTIONS(751),
    [anon_sym_get] = ACTIONS(751),
    [anon_sym_set] = ACTIONS(751),
    [anon_sym_declare] = ACTIONS(751),
    [anon_sym_public] = ACTIONS(751),
    [anon_sym_private] = ACTIONS(751),
    [anon_sym_protected] = ACTIONS(751),
    [anon_sym_override] = ACTIONS(751),
    [anon_sym_module] = ACTIONS(751),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
  },
  [474] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1806),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [475] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1785),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [476] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1930),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [477] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1907),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [478] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1499),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(1876),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [479] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1908),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [480] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1912),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [481] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1923),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [482] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1758),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [483] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1918),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [484] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1573),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [485] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1920),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [486] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1921),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [487] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1744),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [488] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1360),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [489] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1946),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [490] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_expression] = STATE(1743),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3935),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3935),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3933),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1136),
    [sym_subscript_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3935),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1136),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(350),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1027),
    [anon_sym_type] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(1051),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_void] = ACTIONS(1051),
    [anon_sym_delete] = ACTIONS(1051),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1109),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_readonly] = ACTIONS(1027),
    [anon_sym_get] = ACTIONS(1027),
    [anon_sym_set] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_override] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
  },
  [491] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1353),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [492] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1352),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [493] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1426),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [494] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1351),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [495] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1349),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [496] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1346),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [497] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1345),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [498] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1344),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [499] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1343),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [500] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1342),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [501] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1341),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [502] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1924),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [503] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1338),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [504] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1925),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [505] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1141),
    [sym_expression] = STATE(1948),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4049),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4049),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3876),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1141),
    [sym_subscript_expression] = STATE(1141),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2325),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4049),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1141),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_type] = ACTIONS(881),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(895),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_void] = ACTIONS(903),
    [anon_sym_delete] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(881),
    [anon_sym_readonly] = ACTIONS(881),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [anon_sym_declare] = ACTIONS(881),
    [anon_sym_public] = ACTIONS(881),
    [anon_sym_private] = ACTIONS(881),
    [anon_sym_protected] = ACTIONS(881),
    [anon_sym_override] = ACTIONS(881),
    [anon_sym_module] = ACTIONS(881),
    [anon_sym_any] = ACTIONS(881),
    [anon_sym_number] = ACTIONS(881),
    [anon_sym_boolean] = ACTIONS(881),
    [anon_sym_string] = ACTIONS(881),
    [anon_sym_symbol] = ACTIONS(881),
  },
  [506] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1331),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [507] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1926),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [508] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1324),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [509] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1927),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [510] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1540),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [511] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1928),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [512] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1327),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [513] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1929),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [514] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1932),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [515] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1934),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [516] = {
    [sym__call_signature] = STATE(4045),
    [sym_string] = STATE(2901),
    [sym_formal_parameters] = STATE(2972),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_object_repeat1] = STATE(3499),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1852),
    [anon_sym_export] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1854),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1866),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_readonly] = ACTIONS(1854),
    [anon_sym_get] = ACTIONS(1874),
    [anon_sym_set] = ACTIONS(1874),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1854),
    [anon_sym_public] = ACTIONS(1854),
    [anon_sym_private] = ACTIONS(1854),
    [anon_sym_protected] = ACTIONS(1854),
    [anon_sym_override] = ACTIONS(1854),
    [anon_sym_module] = ACTIONS(1854),
    [anon_sym_any] = ACTIONS(1854),
    [anon_sym_number] = ACTIONS(1854),
    [anon_sym_boolean] = ACTIONS(1854),
    [anon_sym_string] = ACTIONS(1854),
    [anon_sym_symbol] = ACTIONS(1854),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [517] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1936),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [518] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1013),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4116),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4116),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4023),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1013),
    [sym_subscript_expression] = STATE(1013),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2333),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4116),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1013),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(363),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(851),
    [anon_sym_type] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_readonly] = ACTIONS(851),
    [anon_sym_get] = ACTIONS(851),
    [anon_sym_set] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_override] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_any] = ACTIONS(851),
    [anon_sym_number] = ACTIONS(851),
    [anon_sym_boolean] = ACTIONS(851),
    [anon_sym_string] = ACTIONS(851),
    [anon_sym_symbol] = ACTIONS(851),
  },
  [519] = {
    [sym_import] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(1869),
    [sym_yield_expression] = STATE(1857),
    [sym_object] = STATE(1819),
    [sym_object_pattern] = STATE(3993),
    [sym_array] = STATE(1819),
    [sym_array_pattern] = STATE(3993),
    [sym_class] = STATE(1819),
    [sym_function] = STATE(1819),
    [sym_generator_function] = STATE(1819),
    [sym_arrow_function] = STATE(1819),
    [sym__call_signature] = STATE(3995),
    [sym_call_expression] = STATE(1819),
    [sym_new_expression] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(1094),
    [sym_subscript_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1857),
    [sym__augmented_assignment_lhs] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym__destructuring_pattern] = STATE(3993),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_string] = STATE(1819),
    [sym_template_string] = STATE(1819),
    [sym_regex] = STATE(1819),
    [sym_meta_property] = STATE(1819),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1094),
    [sym_type_assertion] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_type_arguments] = STATE(452),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3288),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(1005),
    [anon_sym_type] = ACTIONS(1005),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1005),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(1005),
    [anon_sym_set] = ACTIONS(1005),
    [anon_sym_declare] = ACTIONS(1005),
    [anon_sym_public] = ACTIONS(1005),
    [anon_sym_private] = ACTIONS(1005),
    [anon_sym_protected] = ACTIONS(1005),
    [anon_sym_override] = ACTIONS(1005),
    [anon_sym_module] = ACTIONS(1005),
    [anon_sym_any] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_boolean] = ACTIONS(1005),
    [anon_sym_string] = ACTIONS(1005),
    [anon_sym_symbol] = ACTIONS(1005),
  },
  [520] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1942),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [521] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1941),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [522] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1362),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [523] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1940),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4122),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4122),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3889),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2338),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4122),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(477),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_type] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_typeof] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(963),
    [anon_sym_yield] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_readonly] = ACTIONS(955),
    [anon_sym_get] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_override] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
  },
  [524] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1366),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [525] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(1058),
    [sym_expression] = STATE(1393),
    [sym_primary_expression] = STATE(1379),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1372),
    [sym_object_pattern] = STATE(4022),
    [sym_array] = STATE(1372),
    [sym_array_pattern] = STATE(4022),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1372),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(4068),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1384),
    [sym__augmented_assignment_lhs] = STATE(2328),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym__destructuring_pattern] = STATE(4022),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2972),
    [sym_non_null_expression] = STATE(1058),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(524),
    [sym_type_parameters] = STATE(3761),
    [aux_sym_export_statement_repeat1] = STATE(3293),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_await] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(571),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(549),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_readonly] = ACTIONS(731),
    [anon_sym_get] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
  },
  [526] = {
    [sym_declaration] = STATE(738),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_class_declaration] = STATE(629),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function_declaration] = STATE(629),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(629),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(624),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1836),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1736),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_global] = ACTIONS(1738),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1638),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [527] = {
    [sym_declaration] = STATE(738),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_class_declaration] = STATE(629),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function_declaration] = STATE(629),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(629),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(624),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1784),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1736),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_global] = ACTIONS(1738),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1638),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [528] = {
    [sym_string] = STATE(2901),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [sym_override_modifier] = STATE(2225),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_export] = ACTIONS(1890),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1892),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1890),
    [anon_sym_readonly] = ACTIONS(1894),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1890),
    [anon_sym_public] = ACTIONS(1890),
    [anon_sym_private] = ACTIONS(1890),
    [anon_sym_protected] = ACTIONS(1890),
    [anon_sym_override] = ACTIONS(1898),
    [anon_sym_module] = ACTIONS(1890),
    [anon_sym_any] = ACTIONS(1890),
    [anon_sym_number] = ACTIONS(1890),
    [anon_sym_boolean] = ACTIONS(1890),
    [anon_sym_string] = ACTIONS(1890),
    [anon_sym_symbol] = ACTIONS(1890),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [529] = {
    [sym_string] = STATE(2901),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [sym_override_modifier] = STATE(2225),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_export] = ACTIONS(1890),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1892),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1890),
    [anon_sym_readonly] = ACTIONS(1894),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1890),
    [anon_sym_public] = ACTIONS(1890),
    [anon_sym_private] = ACTIONS(1890),
    [anon_sym_protected] = ACTIONS(1890),
    [anon_sym_override] = ACTIONS(1898),
    [anon_sym_module] = ACTIONS(1890),
    [anon_sym_any] = ACTIONS(1890),
    [anon_sym_number] = ACTIONS(1890),
    [anon_sym_boolean] = ACTIONS(1890),
    [anon_sym_string] = ACTIONS(1890),
    [anon_sym_symbol] = ACTIONS(1890),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [530] = {
    [sym_string] = STATE(2901),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [sym_override_modifier] = STATE(2225),
    [aux_sym_object_repeat1] = STATE(3499),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_export] = ACTIONS(1890),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1892),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1890),
    [anon_sym_readonly] = ACTIONS(1894),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1890),
    [anon_sym_public] = ACTIONS(1890),
    [anon_sym_private] = ACTIONS(1890),
    [anon_sym_protected] = ACTIONS(1890),
    [anon_sym_override] = ACTIONS(1898),
    [anon_sym_module] = ACTIONS(1890),
    [anon_sym_any] = ACTIONS(1890),
    [anon_sym_number] = ACTIONS(1890),
    [anon_sym_boolean] = ACTIONS(1890),
    [anon_sym_string] = ACTIONS(1890),
    [anon_sym_symbol] = ACTIONS(1890),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [531] = {
    [sym_string] = STATE(2901),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_export] = ACTIONS(1890),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1892),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1890),
    [anon_sym_readonly] = ACTIONS(1890),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1890),
    [anon_sym_public] = ACTIONS(1890),
    [anon_sym_private] = ACTIONS(1890),
    [anon_sym_protected] = ACTIONS(1890),
    [anon_sym_override] = ACTIONS(1890),
    [anon_sym_module] = ACTIONS(1890),
    [anon_sym_any] = ACTIONS(1890),
    [anon_sym_number] = ACTIONS(1890),
    [anon_sym_boolean] = ACTIONS(1890),
    [anon_sym_string] = ACTIONS(1890),
    [anon_sym_symbol] = ACTIONS(1890),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [532] = {
    [sym_declaration] = STATE(738),
    [sym_variable_declaration] = STATE(629),
    [sym_lexical_declaration] = STATE(629),
    [sym_class_declaration] = STATE(629),
    [sym_function_declaration] = STATE(629),
    [sym_generator_function_declaration] = STATE(629),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(629),
    [sym_ambient_declaration] = STATE(629),
    [sym_abstract_class_declaration] = STATE(629),
    [sym_module] = STATE(629),
    [sym_internal_module] = STATE(624),
    [sym_import_alias] = STATE(629),
    [sym_interface_declaration] = STATE(629),
    [sym_enum_declaration] = STATE(629),
    [sym_type_alias_declaration] = STATE(629),
    [aux_sym_export_statement_repeat1] = STATE(3062),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1732),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_import] = ACTIONS(1605),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1622),
    [anon_sym_async] = ACTIONS(1624),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1630),
    [anon_sym_module] = ACTIONS(1736),
    [anon_sym_abstract] = ACTIONS(1634),
    [anon_sym_global] = ACTIONS(1738),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1638),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [533] = {
    [sym_string] = STATE(2901),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_export] = ACTIONS(1890),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1892),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1890),
    [anon_sym_readonly] = ACTIONS(1890),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1890),
    [anon_sym_public] = ACTIONS(1890),
    [anon_sym_private] = ACTIONS(1890),
    [anon_sym_protected] = ACTIONS(1890),
    [anon_sym_override] = ACTIONS(1890),
    [anon_sym_module] = ACTIONS(1890),
    [anon_sym_any] = ACTIONS(1890),
    [anon_sym_number] = ACTIONS(1890),
    [anon_sym_boolean] = ACTIONS(1890),
    [anon_sym_string] = ACTIONS(1890),
    [anon_sym_symbol] = ACTIONS(1890),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [534] = {
    [sym_declaration] = STATE(3117),
    [sym_variable_declaration] = STATE(3102),
    [sym_lexical_declaration] = STATE(3102),
    [sym_class_declaration] = STATE(3102),
    [sym_function_declaration] = STATE(3102),
    [sym_generator_function_declaration] = STATE(3102),
    [sym_decorator] = STATE(1140),
    [sym_function_signature] = STATE(3102),
    [sym_ambient_declaration] = STATE(3102),
    [sym_abstract_class_declaration] = STATE(3102),
    [sym_module] = STATE(3102),
    [sym_internal_module] = STATE(3084),
    [sym_import_alias] = STATE(3102),
    [sym_interface_declaration] = STATE(3102),
    [sym_enum_declaration] = STATE(3102),
    [sym_type_alias_declaration] = STATE(3102),
    [aux_sym_export_statement_repeat1] = STATE(3056),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1900),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1902),
    [anon_sym_import] = ACTIONS(1904),
    [anon_sym_var] = ACTIONS(1906),
    [anon_sym_let] = ACTIONS(1908),
    [anon_sym_const] = ACTIONS(1910),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1912),
    [anon_sym_async] = ACTIONS(1914),
    [anon_sym_function] = ACTIONS(1916),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1918),
    [anon_sym_module] = ACTIONS(1920),
    [anon_sym_abstract] = ACTIONS(1922),
    [anon_sym_global] = ACTIONS(1924),
    [anon_sym_interface] = ACTIONS(1926),
    [anon_sym_enum] = ACTIONS(1928),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [535] = {
    [sym_string] = STATE(2901),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_export] = ACTIONS(1890),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1890),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1890),
    [anon_sym_readonly] = ACTIONS(1890),
    [anon_sym_get] = ACTIONS(1890),
    [anon_sym_set] = ACTIONS(1890),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1890),
    [anon_sym_public] = ACTIONS(1890),
    [anon_sym_private] = ACTIONS(1890),
    [anon_sym_protected] = ACTIONS(1890),
    [anon_sym_override] = ACTIONS(1890),
    [anon_sym_module] = ACTIONS(1890),
    [anon_sym_any] = ACTIONS(1890),
    [anon_sym_number] = ACTIONS(1890),
    [anon_sym_boolean] = ACTIONS(1890),
    [anon_sym_string] = ACTIONS(1890),
    [anon_sym_symbol] = ACTIONS(1890),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [536] = {
    [sym_string] = STATE(2901),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_export] = ACTIONS(1890),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1890),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1890),
    [anon_sym_readonly] = ACTIONS(1890),
    [anon_sym_get] = ACTIONS(1890),
    [anon_sym_set] = ACTIONS(1890),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1890),
    [anon_sym_public] = ACTIONS(1890),
    [anon_sym_private] = ACTIONS(1890),
    [anon_sym_protected] = ACTIONS(1890),
    [anon_sym_override] = ACTIONS(1890),
    [anon_sym_module] = ACTIONS(1890),
    [anon_sym_any] = ACTIONS(1890),
    [anon_sym_number] = ACTIONS(1890),
    [anon_sym_boolean] = ACTIONS(1890),
    [anon_sym_string] = ACTIONS(1890),
    [anon_sym_symbol] = ACTIONS(1890),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [537] = {
    [sym_string] = STATE(2901),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [aux_sym_object_repeat1] = STATE(3499),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_export] = ACTIONS(1890),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1890),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1890),
    [anon_sym_readonly] = ACTIONS(1890),
    [anon_sym_get] = ACTIONS(1890),
    [anon_sym_set] = ACTIONS(1890),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1890),
    [anon_sym_public] = ACTIONS(1890),
    [anon_sym_private] = ACTIONS(1890),
    [anon_sym_protected] = ACTIONS(1890),
    [anon_sym_override] = ACTIONS(1890),
    [anon_sym_module] = ACTIONS(1890),
    [anon_sym_any] = ACTIONS(1890),
    [anon_sym_number] = ACTIONS(1890),
    [anon_sym_boolean] = ACTIONS(1890),
    [anon_sym_string] = ACTIONS(1890),
    [anon_sym_symbol] = ACTIONS(1890),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [538] = {
    [sym_string] = STATE(2901),
    [sym__property_name] = STATE(2901),
    [sym_computed_property_name] = STATE(2901),
    [aux_sym_object_repeat1] = STATE(3499),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1890),
    [anon_sym_export] = ACTIONS(1890),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1890),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1892),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1872),
    [sym_private_property_identifier] = ACTIONS(1872),
    [anon_sym_static] = ACTIONS(1890),
    [anon_sym_readonly] = ACTIONS(1890),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1890),
    [anon_sym_public] = ACTIONS(1890),
    [anon_sym_private] = ACTIONS(1890),
    [anon_sym_protected] = ACTIONS(1890),
    [anon_sym_override] = ACTIONS(1890),
    [anon_sym_module] = ACTIONS(1890),
    [anon_sym_any] = ACTIONS(1890),
    [anon_sym_number] = ACTIONS(1890),
    [anon_sym_boolean] = ACTIONS(1890),
    [anon_sym_string] = ACTIONS(1890),
    [anon_sym_symbol] = ACTIONS(1890),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(1930),
    [sym_identifier] = ACTIONS(1932),
    [anon_sym_export] = ACTIONS(1932),
    [anon_sym_default] = ACTIONS(1932),
    [anon_sym_type] = ACTIONS(1932),
    [anon_sym_EQ] = ACTIONS(1932),
    [anon_sym_namespace] = ACTIONS(1932),
    [anon_sym_LBRACE] = ACTIONS(1930),
    [anon_sym_COMMA] = ACTIONS(1930),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_typeof] = ACTIONS(1932),
    [anon_sym_import] = ACTIONS(1932),
    [anon_sym_var] = ACTIONS(1932),
    [anon_sym_let] = ACTIONS(1932),
    [anon_sym_const] = ACTIONS(1932),
    [anon_sym_BANG] = ACTIONS(1930),
    [anon_sym_else] = ACTIONS(1932),
    [anon_sym_if] = ACTIONS(1932),
    [anon_sym_switch] = ACTIONS(1932),
    [anon_sym_for] = ACTIONS(1932),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [anon_sym_RPAREN] = ACTIONS(1930),
    [anon_sym_await] = ACTIONS(1932),
    [anon_sym_while] = ACTIONS(1932),
    [anon_sym_do] = ACTIONS(1932),
    [anon_sym_try] = ACTIONS(1932),
    [anon_sym_with] = ACTIONS(1932),
    [anon_sym_break] = ACTIONS(1932),
    [anon_sym_continue] = ACTIONS(1932),
    [anon_sym_debugger] = ACTIONS(1932),
    [anon_sym_return] = ACTIONS(1932),
    [anon_sym_throw] = ACTIONS(1932),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_COLON] = ACTIONS(1930),
    [anon_sym_case] = ACTIONS(1932),
    [anon_sym_yield] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(1930),
    [anon_sym_RBRACK] = ACTIONS(1930),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_GT] = ACTIONS(1930),
    [anon_sym_SLASH] = ACTIONS(1932),
    [anon_sym_class] = ACTIONS(1932),
    [anon_sym_async] = ACTIONS(1932),
    [anon_sym_function] = ACTIONS(1932),
    [anon_sym_EQ_GT] = ACTIONS(1930),
    [anon_sym_new] = ACTIONS(1932),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_PIPE] = ACTIONS(1930),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1930),
    [anon_sym_void] = ACTIONS(1932),
    [anon_sym_delete] = ACTIONS(1932),
    [anon_sym_PLUS_PLUS] = ACTIONS(1930),
    [anon_sym_DASH_DASH] = ACTIONS(1930),
    [anon_sym_DQUOTE] = ACTIONS(1930),
    [anon_sym_SQUOTE] = ACTIONS(1930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1930),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_super] = ACTIONS(1932),
    [sym_true] = ACTIONS(1932),
    [sym_false] = ACTIONS(1932),
    [sym_null] = ACTIONS(1932),
    [sym_undefined] = ACTIONS(1932),
    [anon_sym_AT] = ACTIONS(1930),
    [anon_sym_static] = ACTIONS(1932),
    [anon_sym_readonly] = ACTIONS(1932),
    [anon_sym_get] = ACTIONS(1932),
    [anon_sym_set] = ACTIONS(1932),
    [anon_sym_QMARK] = ACTIONS(1930),
    [anon_sym_declare] = ACTIONS(1932),
    [anon_sym_public] = ACTIONS(1932),
    [anon_sym_private] = ACTIONS(1932),
    [anon_sym_protected] = ACTIONS(1932),
    [anon_sym_override] = ACTIONS(1932),
    [anon_sym_module] = ACTIONS(1932),
    [anon_sym_any] = ACTIONS(1932),
    [anon_sym_number] = ACTIONS(1932),
    [anon_sym_boolean] = ACTIONS(1932),
    [anon_sym_string] = ACTIONS(1932),
    [anon_sym_symbol] = ACTIONS(1932),
    [anon_sym_abstract] = ACTIONS(1932),
    [anon_sym_extends] = ACTIONS(1932),
    [anon_sym_interface] = ACTIONS(1932),
    [anon_sym_enum] = ACTIONS(1932),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(1934),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(1936),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_type] = ACTIONS(1936),
    [anon_sym_EQ] = ACTIONS(1936),
    [anon_sym_namespace] = ACTIONS(1936),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(1934),
    [anon_sym_RBRACE] = ACTIONS(1934),
    [anon_sym_typeof] = ACTIONS(1936),
    [anon_sym_import] = ACTIONS(1936),
    [anon_sym_var] = ACTIONS(1936),
    [anon_sym_let] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_else] = ACTIONS(1936),
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_switch] = ACTIONS(1936),
    [anon_sym_for] = ACTIONS(1936),
    [anon_sym_LPAREN] = ACTIONS(1934),
    [anon_sym_RPAREN] = ACTIONS(1934),
    [anon_sym_await] = ACTIONS(1936),
    [anon_sym_while] = ACTIONS(1936),
    [anon_sym_do] = ACTIONS(1936),
    [anon_sym_try] = ACTIONS(1936),
    [anon_sym_with] = ACTIONS(1936),
    [anon_sym_break] = ACTIONS(1936),
    [anon_sym_continue] = ACTIONS(1936),
    [anon_sym_debugger] = ACTIONS(1936),
    [anon_sym_return] = ACTIONS(1936),
    [anon_sym_throw] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym_COLON] = ACTIONS(1934),
    [anon_sym_case] = ACTIONS(1936),
    [anon_sym_yield] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [anon_sym_RBRACK] = ACTIONS(1934),
    [anon_sym_LT] = ACTIONS(1934),
    [anon_sym_GT] = ACTIONS(1934),
    [anon_sym_SLASH] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_async] = ACTIONS(1936),
    [anon_sym_function] = ACTIONS(1936),
    [anon_sym_EQ_GT] = ACTIONS(1934),
    [anon_sym_new] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1934),
    [anon_sym_PIPE] = ACTIONS(1934),
    [anon_sym_PLUS] = ACTIONS(1936),
    [anon_sym_DASH] = ACTIONS(1936),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_void] = ACTIONS(1936),
    [anon_sym_delete] = ACTIONS(1936),
    [anon_sym_PLUS_PLUS] = ACTIONS(1934),
    [anon_sym_DASH_DASH] = ACTIONS(1934),
    [anon_sym_DQUOTE] = ACTIONS(1934),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1934),
    [sym_number] = ACTIONS(1934),
    [sym_this] = ACTIONS(1936),
    [sym_super] = ACTIONS(1936),
    [sym_true] = ACTIONS(1936),
    [sym_false] = ACTIONS(1936),
    [sym_null] = ACTIONS(1936),
    [sym_undefined] = ACTIONS(1936),
    [anon_sym_AT] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_readonly] = ACTIONS(1936),
    [anon_sym_get] = ACTIONS(1936),
    [anon_sym_set] = ACTIONS(1936),
    [anon_sym_QMARK] = ACTIONS(1934),
    [anon_sym_declare] = ACTIONS(1936),
    [anon_sym_public] = ACTIONS(1936),
    [anon_sym_private] = ACTIONS(1936),
    [anon_sym_protected] = ACTIONS(1936),
    [anon_sym_override] = ACTIONS(1936),
    [anon_sym_module] = ACTIONS(1936),
    [anon_sym_any] = ACTIONS(1936),
    [anon_sym_number] = ACTIONS(1936),
    [anon_sym_boolean] = ACTIONS(1936),
    [anon_sym_string] = ACTIONS(1936),
    [anon_sym_symbol] = ACTIONS(1936),
    [anon_sym_abstract] = ACTIONS(1936),
    [anon_sym_extends] = ACTIONS(1936),
    [anon_sym_interface] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [anon_sym_export] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_type] = ACTIONS(1940),
    [anon_sym_EQ] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_COMMA] = ACTIONS(1938),
    [anon_sym_RBRACE] = ACTIONS(1938),
    [anon_sym_typeof] = ACTIONS(1940),
    [anon_sym_import] = ACTIONS(1940),
    [anon_sym_var] = ACTIONS(1940),
    [anon_sym_let] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_else] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_LPAREN] = ACTIONS(1938),
    [anon_sym_RPAREN] = ACTIONS(1938),
    [anon_sym_await] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_with] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_debugger] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_COLON] = ACTIONS(1938),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_yield] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1938),
    [anon_sym_RBRACK] = ACTIONS(1938),
    [anon_sym_LT] = ACTIONS(1938),
    [anon_sym_GT] = ACTIONS(1938),
    [anon_sym_SLASH] = ACTIONS(1940),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_async] = ACTIONS(1940),
    [anon_sym_function] = ACTIONS(1940),
    [anon_sym_EQ_GT] = ACTIONS(1938),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1938),
    [anon_sym_PIPE] = ACTIONS(1938),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_void] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [sym_number] = ACTIONS(1938),
    [sym_this] = ACTIONS(1940),
    [sym_super] = ACTIONS(1940),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [sym_null] = ACTIONS(1940),
    [sym_undefined] = ACTIONS(1940),
    [anon_sym_AT] = ACTIONS(1938),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_readonly] = ACTIONS(1940),
    [anon_sym_get] = ACTIONS(1940),
    [anon_sym_set] = ACTIONS(1940),
    [anon_sym_QMARK] = ACTIONS(1938),
    [anon_sym_declare] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_override] = ACTIONS(1940),
    [anon_sym_module] = ACTIONS(1940),
    [anon_sym_any] = ACTIONS(1940),
    [anon_sym_number] = ACTIONS(1940),
    [anon_sym_boolean] = ACTIONS(1940),
    [anon_sym_string] = ACTIONS(1940),
    [anon_sym_symbol] = ACTIONS(1940),
    [anon_sym_abstract] = ACTIONS(1940),
    [anon_sym_extends] = ACTIONS(1940),
    [anon_sym_interface] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(1304),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_export] = ACTIONS(1306),
    [anon_sym_default] = ACTIONS(1306),
    [anon_sym_type] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_namespace] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1304),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_typeof] = ACTIONS(1306),
    [anon_sym_import] = ACTIONS(1306),
    [anon_sym_var] = ACTIONS(1306),
    [anon_sym_let] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_else] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_switch] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_LPAREN] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_await] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_do] = ACTIONS(1306),
    [anon_sym_try] = ACTIONS(1306),
    [anon_sym_with] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_debugger] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_throw] = ACTIONS(1306),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_COLON] = ACTIONS(1304),
    [anon_sym_case] = ACTIONS(1306),
    [anon_sym_yield] = ACTIONS(1306),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_RBRACK] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_SLASH] = ACTIONS(1306),
    [anon_sym_class] = ACTIONS(1306),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_function] = ACTIONS(1306),
    [anon_sym_EQ_GT] = ACTIONS(1304),
    [anon_sym_new] = ACTIONS(1306),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_void] = ACTIONS(1306),
    [anon_sym_delete] = ACTIONS(1306),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [sym_number] = ACTIONS(1304),
    [sym_this] = ACTIONS(1306),
    [sym_super] = ACTIONS(1306),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [sym_null] = ACTIONS(1306),
    [sym_undefined] = ACTIONS(1306),
    [anon_sym_AT] = ACTIONS(1304),
    [anon_sym_static] = ACTIONS(1306),
    [anon_sym_readonly] = ACTIONS(1306),
    [anon_sym_get] = ACTIONS(1306),
    [anon_sym_set] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1304),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_public] = ACTIONS(1306),
    [anon_sym_private] = ACTIONS(1306),
    [anon_sym_protected] = ACTIONS(1306),
    [anon_sym_override] = ACTIONS(1306),
    [anon_sym_module] = ACTIONS(1306),
    [anon_sym_any] = ACTIONS(1306),
    [anon_sym_number] = ACTIONS(1306),
    [anon_sym_boolean] = ACTIONS(1306),
    [anon_sym_string] = ACTIONS(1306),
    [anon_sym_symbol] = ACTIONS(1306),
    [anon_sym_abstract] = ACTIONS(1306),
    [anon_sym_extends] = ACTIONS(1306),
    [anon_sym_interface] = ACTIONS(1306),
    [anon_sym_enum] = ACTIONS(1306),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(1942),
    [sym_identifier] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_default] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_EQ] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1944),
    [anon_sym_LBRACE] = ACTIONS(1942),
    [anon_sym_COMMA] = ACTIONS(1942),
    [anon_sym_RBRACE] = ACTIONS(1942),
    [anon_sym_typeof] = ACTIONS(1944),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_var] = ACTIONS(1944),
    [anon_sym_let] = ACTIONS(1944),
    [anon_sym_const] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1944),
    [anon_sym_if] = ACTIONS(1944),
    [anon_sym_switch] = ACTIONS(1944),
    [anon_sym_for] = ACTIONS(1944),
    [anon_sym_LPAREN] = ACTIONS(1942),
    [anon_sym_RPAREN] = ACTIONS(1942),
    [anon_sym_await] = ACTIONS(1944),
    [anon_sym_while] = ACTIONS(1944),
    [anon_sym_do] = ACTIONS(1944),
    [anon_sym_try] = ACTIONS(1944),
    [anon_sym_with] = ACTIONS(1944),
    [anon_sym_break] = ACTIONS(1944),
    [anon_sym_continue] = ACTIONS(1944),
    [anon_sym_debugger] = ACTIONS(1944),
    [anon_sym_return] = ACTIONS(1944),
    [anon_sym_throw] = ACTIONS(1944),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_COLON] = ACTIONS(1942),
    [anon_sym_case] = ACTIONS(1944),
    [anon_sym_yield] = ACTIONS(1944),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_RBRACK] = ACTIONS(1942),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_GT] = ACTIONS(1942),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_class] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(1944),
    [anon_sym_EQ_GT] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_PIPE] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1942),
    [anon_sym_void] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(1942),
    [anon_sym_SQUOTE] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [sym_number] = ACTIONS(1942),
    [sym_this] = ACTIONS(1944),
    [sym_super] = ACTIONS(1944),
    [sym_true] = ACTIONS(1944),
    [sym_false] = ACTIONS(1944),
    [sym_null] = ACTIONS(1944),
    [sym_undefined] = ACTIONS(1944),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1944),
    [anon_sym_readonly] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_override] = ACTIONS(1944),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_abstract] = ACTIONS(1944),
    [anon_sym_extends] = ACTIONS(1944),
    [anon_sym_interface] = ACTIONS(1944),
    [anon_sym_enum] = ACTIONS(1944),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(1946),
    [sym_identifier] = ACTIONS(1948),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_default] = ACTIONS(1948),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_EQ] = ACTIONS(1948),
    [anon_sym_namespace] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(1946),
    [anon_sym_COMMA] = ACTIONS(1946),
    [anon_sym_RBRACE] = ACTIONS(1946),
    [anon_sym_typeof] = ACTIONS(1948),
    [anon_sym_import] = ACTIONS(1948),
    [anon_sym_var] = ACTIONS(1948),
    [anon_sym_let] = ACTIONS(1948),
    [anon_sym_const] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(1946),
    [anon_sym_else] = ACTIONS(1948),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_switch] = ACTIONS(1948),
    [anon_sym_for] = ACTIONS(1948),
    [anon_sym_LPAREN] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(1946),
    [anon_sym_await] = ACTIONS(1948),
    [anon_sym_while] = ACTIONS(1948),
    [anon_sym_do] = ACTIONS(1948),
    [anon_sym_try] = ACTIONS(1948),
    [anon_sym_with] = ACTIONS(1948),
    [anon_sym_break] = ACTIONS(1948),
    [anon_sym_continue] = ACTIONS(1948),
    [anon_sym_debugger] = ACTIONS(1948),
    [anon_sym_return] = ACTIONS(1948),
    [anon_sym_throw] = ACTIONS(1948),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_COLON] = ACTIONS(1946),
    [anon_sym_case] = ACTIONS(1948),
    [anon_sym_yield] = ACTIONS(1948),
    [anon_sym_LBRACK] = ACTIONS(1946),
    [anon_sym_RBRACK] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_GT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1948),
    [anon_sym_class] = ACTIONS(1948),
    [anon_sym_async] = ACTIONS(1948),
    [anon_sym_function] = ACTIONS(1948),
    [anon_sym_EQ_GT] = ACTIONS(1946),
    [anon_sym_new] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1946),
    [anon_sym_PIPE] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1946),
    [anon_sym_void] = ACTIONS(1948),
    [anon_sym_delete] = ACTIONS(1948),
    [anon_sym_PLUS_PLUS] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1946),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(1946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1946),
    [sym_number] = ACTIONS(1946),
    [sym_this] = ACTIONS(1948),
    [sym_super] = ACTIONS(1948),
    [sym_true] = ACTIONS(1948),
    [sym_false] = ACTIONS(1948),
    [sym_null] = ACTIONS(1948),
    [sym_undefined] = ACTIONS(1948),
    [anon_sym_AT] = ACTIONS(1946),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_readonly] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_QMARK] = ACTIONS(1946),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_override] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [anon_sym_abstract] = ACTIONS(1948),
    [anon_sym_extends] = ACTIONS(1948),
    [anon_sym_interface] = ACTIONS(1948),
    [anon_sym_enum] = ACTIONS(1948),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(1362),
    [sym_identifier] = ACTIONS(1364),
    [anon_sym_export] = ACTIONS(1364),
    [anon_sym_default] = ACTIONS(1364),
    [anon_sym_type] = ACTIONS(1364),
    [anon_sym_EQ] = ACTIONS(1364),
    [anon_sym_namespace] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1362),
    [anon_sym_COMMA] = ACTIONS(1362),
    [anon_sym_RBRACE] = ACTIONS(1362),
    [anon_sym_typeof] = ACTIONS(1364),
    [anon_sym_import] = ACTIONS(1364),
    [anon_sym_var] = ACTIONS(1364),
    [anon_sym_let] = ACTIONS(1364),
    [anon_sym_const] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1362),
    [anon_sym_else] = ACTIONS(1364),
    [anon_sym_if] = ACTIONS(1364),
    [anon_sym_switch] = ACTIONS(1364),
    [anon_sym_for] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1362),
    [anon_sym_RPAREN] = ACTIONS(1362),
    [anon_sym_await] = ACTIONS(1364),
    [anon_sym_while] = ACTIONS(1364),
    [anon_sym_do] = ACTIONS(1364),
    [anon_sym_try] = ACTIONS(1364),
    [anon_sym_with] = ACTIONS(1364),
    [anon_sym_break] = ACTIONS(1364),
    [anon_sym_continue] = ACTIONS(1364),
    [anon_sym_debugger] = ACTIONS(1364),
    [anon_sym_return] = ACTIONS(1364),
    [anon_sym_throw] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1362),
    [anon_sym_COLON] = ACTIONS(1362),
    [anon_sym_case] = ACTIONS(1364),
    [anon_sym_yield] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_RBRACK] = ACTIONS(1362),
    [anon_sym_LT] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1362),
    [anon_sym_SLASH] = ACTIONS(1364),
    [anon_sym_class] = ACTIONS(1364),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(1364),
    [anon_sym_EQ_GT] = ACTIONS(1362),
    [anon_sym_new] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1362),
    [anon_sym_PIPE] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1362),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_delete] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(1362),
    [anon_sym_DQUOTE] = ACTIONS(1362),
    [anon_sym_SQUOTE] = ACTIONS(1362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1362),
    [sym_number] = ACTIONS(1362),
    [sym_this] = ACTIONS(1364),
    [sym_super] = ACTIONS(1364),
    [sym_true] = ACTIONS(1364),
    [sym_false] = ACTIONS(1364),
    [sym_null] = ACTIONS(1364),
    [sym_undefined] = ACTIONS(1364),
    [anon_sym_AT] = ACTIONS(1362),
    [anon_sym_static] = ACTIONS(1364),
    [anon_sym_readonly] = ACTIONS(1364),
    [anon_sym_get] = ACTIONS(1364),
    [anon_sym_set] = ACTIONS(1364),
    [anon_sym_QMARK] = ACTIONS(1362),
    [anon_sym_declare] = ACTIONS(1364),
    [anon_sym_public] = ACTIONS(1364),
    [anon_sym_private] = ACTIONS(1364),
    [anon_sym_protected] = ACTIONS(1364),
    [anon_sym_override] = ACTIONS(1364),
    [anon_sym_module] = ACTIONS(1364),
    [anon_sym_any] = ACTIONS(1364),
    [anon_sym_number] = ACTIONS(1364),
    [anon_sym_boolean] = ACTIONS(1364),
    [anon_sym_string] = ACTIONS(1364),
    [anon_sym_symbol] = ACTIONS(1364),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_extends] = ACTIONS(1364),
    [anon_sym_interface] = ACTIONS(1364),
    [anon_sym_enum] = ACTIONS(1364),
  },
  [546] = {
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1579),
    [anon_sym_export] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_type] = ACTIONS(1579),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1581),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1579),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1581),
    [anon_sym_SQUOTE] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1581),
    [sym_private_property_identifier] = ACTIONS(1581),
    [anon_sym_static] = ACTIONS(1579),
    [anon_sym_readonly] = ACTIONS(1579),
    [anon_sym_get] = ACTIONS(1579),
    [anon_sym_set] = ACTIONS(1579),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1579),
    [anon_sym_public] = ACTIONS(1579),
    [anon_sym_private] = ACTIONS(1579),
    [anon_sym_protected] = ACTIONS(1579),
    [anon_sym_override] = ACTIONS(1579),
    [anon_sym_module] = ACTIONS(1579),
    [anon_sym_any] = ACTIONS(1579),
    [anon_sym_number] = ACTIONS(1579),
    [anon_sym_boolean] = ACTIONS(1579),
    [anon_sym_string] = ACTIONS(1579),
    [anon_sym_symbol] = ACTIONS(1579),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [547] = {
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1560),
    [anon_sym_export] = ACTIONS(1560),
    [anon_sym_STAR] = ACTIONS(1560),
    [anon_sym_type] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1560),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1560),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1562),
    [anon_sym_SQUOTE] = ACTIONS(1562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1562),
    [sym_private_property_identifier] = ACTIONS(1562),
    [anon_sym_static] = ACTIONS(1560),
    [anon_sym_readonly] = ACTIONS(1560),
    [anon_sym_get] = ACTIONS(1560),
    [anon_sym_set] = ACTIONS(1560),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1560),
    [anon_sym_public] = ACTIONS(1560),
    [anon_sym_private] = ACTIONS(1560),
    [anon_sym_protected] = ACTIONS(1560),
    [anon_sym_override] = ACTIONS(1560),
    [anon_sym_module] = ACTIONS(1560),
    [anon_sym_any] = ACTIONS(1560),
    [anon_sym_number] = ACTIONS(1560),
    [anon_sym_boolean] = ACTIONS(1560),
    [anon_sym_string] = ACTIONS(1560),
    [anon_sym_symbol] = ACTIONS(1560),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [548] = {
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1560),
    [anon_sym_export] = ACTIONS(1560),
    [anon_sym_STAR] = ACTIONS(1560),
    [anon_sym_type] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1560),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1560),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1562),
    [anon_sym_SQUOTE] = ACTIONS(1562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1562),
    [sym_private_property_identifier] = ACTIONS(1562),
    [anon_sym_static] = ACTIONS(1560),
    [anon_sym_readonly] = ACTIONS(1560),
    [anon_sym_get] = ACTIONS(1560),
    [anon_sym_set] = ACTIONS(1560),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1560),
    [anon_sym_public] = ACTIONS(1560),
    [anon_sym_private] = ACTIONS(1560),
    [anon_sym_protected] = ACTIONS(1560),
    [anon_sym_override] = ACTIONS(1560),
    [anon_sym_module] = ACTIONS(1560),
    [anon_sym_any] = ACTIONS(1560),
    [anon_sym_number] = ACTIONS(1560),
    [anon_sym_boolean] = ACTIONS(1560),
    [anon_sym_string] = ACTIONS(1560),
    [anon_sym_symbol] = ACTIONS(1560),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [549] = {
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1579),
    [anon_sym_export] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_type] = ACTIONS(1579),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1581),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1579),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1581),
    [anon_sym_SQUOTE] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1581),
    [sym_private_property_identifier] = ACTIONS(1581),
    [anon_sym_static] = ACTIONS(1579),
    [anon_sym_readonly] = ACTIONS(1579),
    [anon_sym_get] = ACTIONS(1579),
    [anon_sym_set] = ACTIONS(1579),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1579),
    [anon_sym_public] = ACTIONS(1579),
    [anon_sym_private] = ACTIONS(1579),
    [anon_sym_protected] = ACTIONS(1579),
    [anon_sym_override] = ACTIONS(1579),
    [anon_sym_module] = ACTIONS(1579),
    [anon_sym_any] = ACTIONS(1579),
    [anon_sym_number] = ACTIONS(1579),
    [anon_sym_boolean] = ACTIONS(1579),
    [anon_sym_string] = ACTIONS(1579),
    [anon_sym_symbol] = ACTIONS(1579),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [550] = {
    [aux_sym_object_repeat1] = STATE(3499),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1560),
    [anon_sym_export] = ACTIONS(1560),
    [anon_sym_STAR] = ACTIONS(1560),
    [anon_sym_type] = ACTIONS(1560),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1560),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1560),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1562),
    [anon_sym_SQUOTE] = ACTIONS(1562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1562),
    [sym_private_property_identifier] = ACTIONS(1562),
    [anon_sym_static] = ACTIONS(1560),
    [anon_sym_readonly] = ACTIONS(1560),
    [anon_sym_get] = ACTIONS(1560),
    [anon_sym_set] = ACTIONS(1560),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1560),
    [anon_sym_public] = ACTIONS(1560),
    [anon_sym_private] = ACTIONS(1560),
    [anon_sym_protected] = ACTIONS(1560),
    [anon_sym_override] = ACTIONS(1560),
    [anon_sym_module] = ACTIONS(1560),
    [anon_sym_any] = ACTIONS(1560),
    [anon_sym_number] = ACTIONS(1560),
    [anon_sym_boolean] = ACTIONS(1560),
    [anon_sym_string] = ACTIONS(1560),
    [anon_sym_symbol] = ACTIONS(1560),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [551] = {
    [aux_sym_object_repeat1] = STATE(3499),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(1579),
    [anon_sym_export] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_type] = ACTIONS(1579),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1581),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1579),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1581),
    [anon_sym_SQUOTE] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1581),
    [sym_private_property_identifier] = ACTIONS(1581),
    [anon_sym_static] = ACTIONS(1579),
    [anon_sym_readonly] = ACTIONS(1579),
    [anon_sym_get] = ACTIONS(1579),
    [anon_sym_set] = ACTIONS(1579),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_declare] = ACTIONS(1579),
    [anon_sym_public] = ACTIONS(1579),
    [anon_sym_private] = ACTIONS(1579),
    [anon_sym_protected] = ACTIONS(1579),
    [anon_sym_override] = ACTIONS(1579),
    [anon_sym_module] = ACTIONS(1579),
    [anon_sym_any] = ACTIONS(1579),
    [anon_sym_number] = ACTIONS(1579),
    [anon_sym_boolean] = ACTIONS(1579),
    [anon_sym_string] = ACTIONS(1579),
    [anon_sym_symbol] = ACTIONS(1579),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [552] = {
    [sym__call_signature] = STATE(4080),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1950),
    [anon_sym_export] = ACTIONS(1952),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1952),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1952),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_RBRACE] = ACTIONS(206),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1952),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(1952),
    [anon_sym_set] = ACTIONS(1952),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1952),
    [anon_sym_private] = ACTIONS(1952),
    [anon_sym_protected] = ACTIONS(1952),
    [anon_sym_override] = ACTIONS(1952),
    [anon_sym_module] = ACTIONS(1952),
    [anon_sym_any] = ACTIONS(1952),
    [anon_sym_number] = ACTIONS(1952),
    [anon_sym_boolean] = ACTIONS(1952),
    [anon_sym_string] = ACTIONS(1952),
    [anon_sym_symbol] = ACTIONS(1952),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [553] = {
    [sym__call_signature] = STATE(4019),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1962),
    [anon_sym_export] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1964),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_COMMA] = ACTIONS(1228),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(1228),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1964),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_readonly] = ACTIONS(1964),
    [anon_sym_get] = ACTIONS(1964),
    [anon_sym_set] = ACTIONS(1964),
    [anon_sym_QMARK] = ACTIONS(1966),
    [anon_sym_declare] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_override] = ACTIONS(1964),
    [anon_sym_module] = ACTIONS(1964),
    [anon_sym_any] = ACTIONS(1964),
    [anon_sym_number] = ACTIONS(1964),
    [anon_sym_boolean] = ACTIONS(1964),
    [anon_sym_string] = ACTIONS(1964),
    [anon_sym_symbol] = ACTIONS(1964),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [554] = {
    [sym__call_signature] = STATE(4019),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1962),
    [anon_sym_export] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1964),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_RBRACE] = ACTIONS(120),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(120),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1964),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_readonly] = ACTIONS(1964),
    [anon_sym_get] = ACTIONS(1964),
    [anon_sym_set] = ACTIONS(1964),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_declare] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_override] = ACTIONS(1964),
    [anon_sym_module] = ACTIONS(1964),
    [anon_sym_any] = ACTIONS(1964),
    [anon_sym_number] = ACTIONS(1964),
    [anon_sym_boolean] = ACTIONS(1964),
    [anon_sym_string] = ACTIONS(1964),
    [anon_sym_symbol] = ACTIONS(1964),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [555] = {
    [sym__call_signature] = STATE(4080),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1950),
    [anon_sym_export] = ACTIONS(1952),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1952),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1952),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1952),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(1952),
    [anon_sym_set] = ACTIONS(1952),
    [anon_sym_declare] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1952),
    [anon_sym_private] = ACTIONS(1952),
    [anon_sym_protected] = ACTIONS(1952),
    [anon_sym_override] = ACTIONS(1952),
    [anon_sym_module] = ACTIONS(1952),
    [anon_sym_any] = ACTIONS(1952),
    [anon_sym_number] = ACTIONS(1952),
    [anon_sym_boolean] = ACTIONS(1952),
    [anon_sym_string] = ACTIONS(1952),
    [anon_sym_symbol] = ACTIONS(1952),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [556] = {
    [sym__call_signature] = STATE(4080),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1950),
    [anon_sym_export] = ACTIONS(1952),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1952),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1952),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_RPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1952),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(1952),
    [anon_sym_set] = ACTIONS(1952),
    [anon_sym_declare] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1952),
    [anon_sym_private] = ACTIONS(1952),
    [anon_sym_protected] = ACTIONS(1952),
    [anon_sym_override] = ACTIONS(1952),
    [anon_sym_module] = ACTIONS(1952),
    [anon_sym_any] = ACTIONS(1952),
    [anon_sym_number] = ACTIONS(1952),
    [anon_sym_boolean] = ACTIONS(1952),
    [anon_sym_string] = ACTIONS(1952),
    [anon_sym_symbol] = ACTIONS(1952),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [557] = {
    [sym__call_signature] = STATE(4045),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1968),
    [anon_sym_export] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1970),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1836),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1970),
    [anon_sym_function] = ACTIONS(1972),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1970),
    [anon_sym_readonly] = ACTIONS(1970),
    [anon_sym_get] = ACTIONS(1970),
    [anon_sym_set] = ACTIONS(1970),
    [anon_sym_declare] = ACTIONS(1970),
    [anon_sym_public] = ACTIONS(1970),
    [anon_sym_private] = ACTIONS(1970),
    [anon_sym_protected] = ACTIONS(1970),
    [anon_sym_override] = ACTIONS(1970),
    [anon_sym_module] = ACTIONS(1970),
    [anon_sym_any] = ACTIONS(1970),
    [anon_sym_number] = ACTIONS(1970),
    [anon_sym_boolean] = ACTIONS(1970),
    [anon_sym_string] = ACTIONS(1970),
    [anon_sym_symbol] = ACTIONS(1970),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [558] = {
    [sym__call_signature] = STATE(4107),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1974),
    [anon_sym_export] = ACTIONS(1976),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1976),
    [anon_sym_EQ] = ACTIONS(1217),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1976),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1976),
    [anon_sym_function] = ACTIONS(1978),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_readonly] = ACTIONS(1976),
    [anon_sym_get] = ACTIONS(1976),
    [anon_sym_set] = ACTIONS(1976),
    [anon_sym_declare] = ACTIONS(1976),
    [anon_sym_public] = ACTIONS(1976),
    [anon_sym_private] = ACTIONS(1976),
    [anon_sym_protected] = ACTIONS(1976),
    [anon_sym_override] = ACTIONS(1976),
    [anon_sym_module] = ACTIONS(1976),
    [anon_sym_any] = ACTIONS(1976),
    [anon_sym_number] = ACTIONS(1976),
    [anon_sym_boolean] = ACTIONS(1976),
    [anon_sym_string] = ACTIONS(1976),
    [anon_sym_symbol] = ACTIONS(1976),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [559] = {
    [sym__call_signature] = STATE(4045),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1968),
    [anon_sym_export] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1970),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1784),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1970),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1970),
    [anon_sym_readonly] = ACTIONS(1970),
    [anon_sym_get] = ACTIONS(1970),
    [anon_sym_set] = ACTIONS(1970),
    [anon_sym_declare] = ACTIONS(1970),
    [anon_sym_public] = ACTIONS(1970),
    [anon_sym_private] = ACTIONS(1970),
    [anon_sym_protected] = ACTIONS(1970),
    [anon_sym_override] = ACTIONS(1970),
    [anon_sym_module] = ACTIONS(1970),
    [anon_sym_any] = ACTIONS(1970),
    [anon_sym_number] = ACTIONS(1970),
    [anon_sym_boolean] = ACTIONS(1970),
    [anon_sym_string] = ACTIONS(1970),
    [anon_sym_symbol] = ACTIONS(1970),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [560] = {
    [sym__call_signature] = STATE(4045),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1968),
    [anon_sym_export] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1970),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1970),
    [anon_sym_function] = ACTIONS(1978),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1970),
    [anon_sym_readonly] = ACTIONS(1970),
    [anon_sym_get] = ACTIONS(1970),
    [anon_sym_set] = ACTIONS(1970),
    [anon_sym_declare] = ACTIONS(1970),
    [anon_sym_public] = ACTIONS(1970),
    [anon_sym_private] = ACTIONS(1970),
    [anon_sym_protected] = ACTIONS(1970),
    [anon_sym_override] = ACTIONS(1970),
    [anon_sym_module] = ACTIONS(1970),
    [anon_sym_any] = ACTIONS(1970),
    [anon_sym_number] = ACTIONS(1970),
    [anon_sym_boolean] = ACTIONS(1970),
    [anon_sym_string] = ACTIONS(1970),
    [anon_sym_symbol] = ACTIONS(1970),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [561] = {
    [sym__call_signature] = STATE(4045),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1968),
    [anon_sym_export] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1970),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1970),
    [anon_sym_function] = ACTIONS(1978),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1970),
    [anon_sym_readonly] = ACTIONS(1970),
    [anon_sym_get] = ACTIONS(1970),
    [anon_sym_set] = ACTIONS(1970),
    [anon_sym_declare] = ACTIONS(1970),
    [anon_sym_public] = ACTIONS(1970),
    [anon_sym_private] = ACTIONS(1970),
    [anon_sym_protected] = ACTIONS(1970),
    [anon_sym_override] = ACTIONS(1970),
    [anon_sym_module] = ACTIONS(1970),
    [anon_sym_any] = ACTIONS(1970),
    [anon_sym_number] = ACTIONS(1970),
    [anon_sym_boolean] = ACTIONS(1970),
    [anon_sym_string] = ACTIONS(1970),
    [anon_sym_symbol] = ACTIONS(1970),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [562] = {
    [sym__call_signature] = STATE(4107),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1974),
    [anon_sym_export] = ACTIONS(1976),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1976),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1976),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1976),
    [anon_sym_function] = ACTIONS(1978),
    [anon_sym_EQ_GT] = ACTIONS(1219),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_readonly] = ACTIONS(1976),
    [anon_sym_get] = ACTIONS(1976),
    [anon_sym_set] = ACTIONS(1976),
    [anon_sym_declare] = ACTIONS(1976),
    [anon_sym_public] = ACTIONS(1976),
    [anon_sym_private] = ACTIONS(1976),
    [anon_sym_protected] = ACTIONS(1976),
    [anon_sym_override] = ACTIONS(1976),
    [anon_sym_module] = ACTIONS(1976),
    [anon_sym_any] = ACTIONS(1976),
    [anon_sym_number] = ACTIONS(1976),
    [anon_sym_boolean] = ACTIONS(1976),
    [anon_sym_string] = ACTIONS(1976),
    [anon_sym_symbol] = ACTIONS(1976),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [563] = {
    [sym__call_signature] = STATE(4080),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1950),
    [anon_sym_export] = ACTIONS(1952),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1952),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1952),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1952),
    [anon_sym_readonly] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(1952),
    [anon_sym_set] = ACTIONS(1952),
    [anon_sym_declare] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1952),
    [anon_sym_private] = ACTIONS(1952),
    [anon_sym_protected] = ACTIONS(1952),
    [anon_sym_override] = ACTIONS(1952),
    [anon_sym_module] = ACTIONS(1952),
    [anon_sym_any] = ACTIONS(1952),
    [anon_sym_number] = ACTIONS(1952),
    [anon_sym_boolean] = ACTIONS(1952),
    [anon_sym_string] = ACTIONS(1952),
    [anon_sym_symbol] = ACTIONS(1952),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [564] = {
    [sym__call_signature] = STATE(4045),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1968),
    [anon_sym_export] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1970),
    [anon_sym_EQ] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_of] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1970),
    [anon_sym_function] = ACTIONS(1978),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1970),
    [anon_sym_readonly] = ACTIONS(1970),
    [anon_sym_get] = ACTIONS(1970),
    [anon_sym_set] = ACTIONS(1970),
    [anon_sym_declare] = ACTIONS(1970),
    [anon_sym_public] = ACTIONS(1970),
    [anon_sym_private] = ACTIONS(1970),
    [anon_sym_protected] = ACTIONS(1970),
    [anon_sym_override] = ACTIONS(1970),
    [anon_sym_module] = ACTIONS(1970),
    [anon_sym_any] = ACTIONS(1970),
    [anon_sym_number] = ACTIONS(1970),
    [anon_sym_boolean] = ACTIONS(1970),
    [anon_sym_string] = ACTIONS(1970),
    [anon_sym_symbol] = ACTIONS(1970),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [565] = {
    [sym__call_signature] = STATE(4052),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_export] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1987),
    [anon_sym_EQ] = ACTIONS(1230),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(150),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1987),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(1232),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_readonly] = ACTIONS(1987),
    [anon_sym_get] = ACTIONS(1987),
    [anon_sym_set] = ACTIONS(1987),
    [anon_sym_declare] = ACTIONS(1987),
    [anon_sym_public] = ACTIONS(1987),
    [anon_sym_private] = ACTIONS(1987),
    [anon_sym_protected] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_module] = ACTIONS(1987),
    [anon_sym_any] = ACTIONS(1987),
    [anon_sym_number] = ACTIONS(1987),
    [anon_sym_boolean] = ACTIONS(1987),
    [anon_sym_string] = ACTIONS(1987),
    [anon_sym_symbol] = ACTIONS(1987),
    [anon_sym_implements] = ACTIONS(114),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(1292),
    [sym_identifier] = ACTIONS(1294),
    [anon_sym_export] = ACTIONS(1294),
    [anon_sym_default] = ACTIONS(1294),
    [anon_sym_type] = ACTIONS(1294),
    [anon_sym_namespace] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(1292),
    [anon_sym_COMMA] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1292),
    [anon_sym_typeof] = ACTIONS(1294),
    [anon_sym_import] = ACTIONS(1294),
    [anon_sym_var] = ACTIONS(1294),
    [anon_sym_let] = ACTIONS(1294),
    [anon_sym_const] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1294),
    [anon_sym_if] = ACTIONS(1294),
    [anon_sym_switch] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1294),
    [anon_sym_LPAREN] = ACTIONS(1292),
    [anon_sym_await] = ACTIONS(1294),
    [anon_sym_while] = ACTIONS(1294),
    [anon_sym_do] = ACTIONS(1294),
    [anon_sym_try] = ACTIONS(1294),
    [anon_sym_with] = ACTIONS(1294),
    [anon_sym_break] = ACTIONS(1294),
    [anon_sym_continue] = ACTIONS(1294),
    [anon_sym_debugger] = ACTIONS(1294),
    [anon_sym_return] = ACTIONS(1294),
    [anon_sym_throw] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1294),
    [anon_sym_catch] = ACTIONS(1294),
    [anon_sym_finally] = ACTIONS(1294),
    [anon_sym_yield] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_LT] = ACTIONS(1292),
    [anon_sym_SLASH] = ACTIONS(1294),
    [anon_sym_class] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1294),
    [anon_sym_function] = ACTIONS(1294),
    [anon_sym_new] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_void] = ACTIONS(1294),
    [anon_sym_delete] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1292),
    [anon_sym_DQUOTE] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1292),
    [sym_number] = ACTIONS(1292),
    [sym_this] = ACTIONS(1294),
    [sym_super] = ACTIONS(1294),
    [sym_true] = ACTIONS(1294),
    [sym_false] = ACTIONS(1294),
    [sym_null] = ACTIONS(1294),
    [sym_undefined] = ACTIONS(1294),
    [anon_sym_AT] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1294),
    [anon_sym_readonly] = ACTIONS(1294),
    [anon_sym_get] = ACTIONS(1294),
    [anon_sym_set] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_public] = ACTIONS(1294),
    [anon_sym_private] = ACTIONS(1294),
    [anon_sym_protected] = ACTIONS(1294),
    [anon_sym_override] = ACTIONS(1294),
    [anon_sym_module] = ACTIONS(1294),
    [anon_sym_any] = ACTIONS(1294),
    [anon_sym_number] = ACTIONS(1294),
    [anon_sym_boolean] = ACTIONS(1294),
    [anon_sym_string] = ACTIONS(1294),
    [anon_sym_symbol] = ACTIONS(1294),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_interface] = ACTIONS(1294),
    [anon_sym_enum] = ACTIONS(1294),
    [sym__automatic_semicolon] = ACTIONS(1302),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_export] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_var] = ACTIONS(1346),
    [anon_sym_let] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_debugger] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_throw] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_catch] = ACTIONS(1346),
    [anon_sym_finally] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1346),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1346),
    [anon_sym_new] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_void] = ACTIONS(1346),
    [anon_sym_delete] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1344),
    [sym_number] = ACTIONS(1344),
    [sym_this] = ACTIONS(1346),
    [sym_super] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_null] = ACTIONS(1346),
    [sym_undefined] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_readonly] = ACTIONS(1346),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_declare] = ACTIONS(1346),
    [anon_sym_public] = ACTIONS(1346),
    [anon_sym_private] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1346),
    [anon_sym_override] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_any] = ACTIONS(1346),
    [anon_sym_number] = ACTIONS(1346),
    [anon_sym_boolean] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [anon_sym_symbol] = ACTIONS(1346),
    [anon_sym_abstract] = ACTIONS(1346),
    [anon_sym_interface] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1989),
  },
  [568] = {
    [sym__call_signature] = STATE(3869),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(1236),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_readonly] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_override] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_symbol] = ACTIONS(1993),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [569] = {
    [sym_catch_clause] = STATE(594),
    [sym_finally_clause] = STATE(764),
    [ts_builtin_sym_end] = ACTIONS(2000),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_export] = ACTIONS(2002),
    [anon_sym_default] = ACTIONS(2002),
    [anon_sym_type] = ACTIONS(2002),
    [anon_sym_namespace] = ACTIONS(2002),
    [anon_sym_LBRACE] = ACTIONS(2000),
    [anon_sym_RBRACE] = ACTIONS(2000),
    [anon_sym_typeof] = ACTIONS(2002),
    [anon_sym_import] = ACTIONS(2002),
    [anon_sym_var] = ACTIONS(2002),
    [anon_sym_let] = ACTIONS(2002),
    [anon_sym_const] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2000),
    [anon_sym_else] = ACTIONS(2002),
    [anon_sym_if] = ACTIONS(2002),
    [anon_sym_switch] = ACTIONS(2002),
    [anon_sym_for] = ACTIONS(2002),
    [anon_sym_LPAREN] = ACTIONS(2000),
    [anon_sym_await] = ACTIONS(2002),
    [anon_sym_while] = ACTIONS(2002),
    [anon_sym_do] = ACTIONS(2002),
    [anon_sym_try] = ACTIONS(2002),
    [anon_sym_with] = ACTIONS(2002),
    [anon_sym_break] = ACTIONS(2002),
    [anon_sym_continue] = ACTIONS(2002),
    [anon_sym_debugger] = ACTIONS(2002),
    [anon_sym_return] = ACTIONS(2002),
    [anon_sym_throw] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2000),
    [anon_sym_case] = ACTIONS(2002),
    [anon_sym_catch] = ACTIONS(2004),
    [anon_sym_finally] = ACTIONS(2006),
    [anon_sym_yield] = ACTIONS(2002),
    [anon_sym_LBRACK] = ACTIONS(2000),
    [anon_sym_LT] = ACTIONS(2000),
    [anon_sym_SLASH] = ACTIONS(2002),
    [anon_sym_class] = ACTIONS(2002),
    [anon_sym_async] = ACTIONS(2002),
    [anon_sym_function] = ACTIONS(2002),
    [anon_sym_new] = ACTIONS(2002),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_DASH] = ACTIONS(2002),
    [anon_sym_TILDE] = ACTIONS(2000),
    [anon_sym_void] = ACTIONS(2002),
    [anon_sym_delete] = ACTIONS(2002),
    [anon_sym_PLUS_PLUS] = ACTIONS(2000),
    [anon_sym_DASH_DASH] = ACTIONS(2000),
    [anon_sym_DQUOTE] = ACTIONS(2000),
    [anon_sym_SQUOTE] = ACTIONS(2000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2000),
    [sym_number] = ACTIONS(2000),
    [sym_this] = ACTIONS(2002),
    [sym_super] = ACTIONS(2002),
    [sym_true] = ACTIONS(2002),
    [sym_false] = ACTIONS(2002),
    [sym_null] = ACTIONS(2002),
    [sym_undefined] = ACTIONS(2002),
    [anon_sym_AT] = ACTIONS(2000),
    [anon_sym_static] = ACTIONS(2002),
    [anon_sym_readonly] = ACTIONS(2002),
    [anon_sym_get] = ACTIONS(2002),
    [anon_sym_set] = ACTIONS(2002),
    [anon_sym_declare] = ACTIONS(2002),
    [anon_sym_public] = ACTIONS(2002),
    [anon_sym_private] = ACTIONS(2002),
    [anon_sym_protected] = ACTIONS(2002),
    [anon_sym_override] = ACTIONS(2002),
    [anon_sym_module] = ACTIONS(2002),
    [anon_sym_any] = ACTIONS(2002),
    [anon_sym_number] = ACTIONS(2002),
    [anon_sym_boolean] = ACTIONS(2002),
    [anon_sym_string] = ACTIONS(2002),
    [anon_sym_symbol] = ACTIONS(2002),
    [anon_sym_abstract] = ACTIONS(2002),
    [anon_sym_interface] = ACTIONS(2002),
    [anon_sym_enum] = ACTIONS(2002),
  },
  [570] = {
    [sym__call_signature] = STATE(4052),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1985),
    [anon_sym_export] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1987),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(150),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1987),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(1232),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_readonly] = ACTIONS(1987),
    [anon_sym_get] = ACTIONS(1987),
    [anon_sym_set] = ACTIONS(1987),
    [anon_sym_declare] = ACTIONS(1987),
    [anon_sym_public] = ACTIONS(1987),
    [anon_sym_private] = ACTIONS(1987),
    [anon_sym_protected] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_module] = ACTIONS(1987),
    [anon_sym_any] = ACTIONS(1987),
    [anon_sym_number] = ACTIONS(1987),
    [anon_sym_boolean] = ACTIONS(1987),
    [anon_sym_string] = ACTIONS(1987),
    [anon_sym_symbol] = ACTIONS(1987),
    [anon_sym_implements] = ACTIONS(114),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_export] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_var] = ACTIONS(1346),
    [anon_sym_let] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_debugger] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_throw] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1346),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1346),
    [anon_sym_new] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_void] = ACTIONS(1346),
    [anon_sym_delete] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1344),
    [sym_number] = ACTIONS(1344),
    [sym_this] = ACTIONS(1346),
    [sym_super] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_null] = ACTIONS(1346),
    [sym_undefined] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_readonly] = ACTIONS(1346),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_declare] = ACTIONS(1346),
    [anon_sym_public] = ACTIONS(1346),
    [anon_sym_private] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1346),
    [anon_sym_override] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_any] = ACTIONS(1346),
    [anon_sym_number] = ACTIONS(1346),
    [anon_sym_boolean] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [anon_sym_symbol] = ACTIONS(1346),
    [anon_sym_abstract] = ACTIONS(1346),
    [anon_sym_interface] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1344),
    [sym__automatic_semicolon] = ACTIONS(1344),
  },
  [572] = {
    [sym__call_signature] = STATE(3951),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2010),
    [anon_sym_function] = ACTIONS(1978),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2010),
    [anon_sym_readonly] = ACTIONS(2010),
    [anon_sym_get] = ACTIONS(2010),
    [anon_sym_set] = ACTIONS(2010),
    [anon_sym_declare] = ACTIONS(2010),
    [anon_sym_public] = ACTIONS(2010),
    [anon_sym_private] = ACTIONS(2010),
    [anon_sym_protected] = ACTIONS(2010),
    [anon_sym_override] = ACTIONS(2010),
    [anon_sym_module] = ACTIONS(2010),
    [anon_sym_any] = ACTIONS(2010),
    [anon_sym_number] = ACTIONS(2010),
    [anon_sym_boolean] = ACTIONS(2010),
    [anon_sym_string] = ACTIONS(2010),
    [anon_sym_symbol] = ACTIONS(2010),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [573] = {
    [sym__call_signature] = STATE(3951),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2010),
    [anon_sym_function] = ACTIONS(1870),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2010),
    [anon_sym_readonly] = ACTIONS(2010),
    [anon_sym_get] = ACTIONS(2010),
    [anon_sym_set] = ACTIONS(2010),
    [anon_sym_declare] = ACTIONS(2010),
    [anon_sym_public] = ACTIONS(2010),
    [anon_sym_private] = ACTIONS(2010),
    [anon_sym_protected] = ACTIONS(2010),
    [anon_sym_override] = ACTIONS(2010),
    [anon_sym_module] = ACTIONS(2010),
    [anon_sym_any] = ACTIONS(2010),
    [anon_sym_number] = ACTIONS(2010),
    [anon_sym_boolean] = ACTIONS(2010),
    [anon_sym_string] = ACTIONS(2010),
    [anon_sym_symbol] = ACTIONS(2010),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [574] = {
    [sym__call_signature] = STATE(3951),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2010),
    [anon_sym_function] = ACTIONS(1978),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2010),
    [anon_sym_readonly] = ACTIONS(2010),
    [anon_sym_get] = ACTIONS(2010),
    [anon_sym_set] = ACTIONS(2010),
    [anon_sym_declare] = ACTIONS(2010),
    [anon_sym_public] = ACTIONS(2010),
    [anon_sym_private] = ACTIONS(2010),
    [anon_sym_protected] = ACTIONS(2010),
    [anon_sym_override] = ACTIONS(2010),
    [anon_sym_module] = ACTIONS(2010),
    [anon_sym_any] = ACTIONS(2010),
    [anon_sym_number] = ACTIONS(2010),
    [anon_sym_boolean] = ACTIONS(2010),
    [anon_sym_string] = ACTIONS(2010),
    [anon_sym_symbol] = ACTIONS(2010),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [575] = {
    [sym__call_signature] = STATE(3951),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2010),
    [anon_sym_function] = ACTIONS(2012),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2010),
    [anon_sym_readonly] = ACTIONS(2010),
    [anon_sym_get] = ACTIONS(2010),
    [anon_sym_set] = ACTIONS(2010),
    [anon_sym_declare] = ACTIONS(2010),
    [anon_sym_public] = ACTIONS(2010),
    [anon_sym_private] = ACTIONS(2010),
    [anon_sym_protected] = ACTIONS(2010),
    [anon_sym_override] = ACTIONS(2010),
    [anon_sym_module] = ACTIONS(2010),
    [anon_sym_any] = ACTIONS(2010),
    [anon_sym_number] = ACTIONS(2010),
    [anon_sym_boolean] = ACTIONS(2010),
    [anon_sym_string] = ACTIONS(2010),
    [anon_sym_symbol] = ACTIONS(2010),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(1292),
    [sym_identifier] = ACTIONS(1294),
    [anon_sym_export] = ACTIONS(1294),
    [anon_sym_default] = ACTIONS(1294),
    [anon_sym_type] = ACTIONS(1294),
    [anon_sym_namespace] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(1292),
    [anon_sym_COMMA] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1292),
    [anon_sym_typeof] = ACTIONS(1294),
    [anon_sym_import] = ACTIONS(1294),
    [anon_sym_var] = ACTIONS(1294),
    [anon_sym_let] = ACTIONS(1294),
    [anon_sym_const] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1294),
    [anon_sym_if] = ACTIONS(1294),
    [anon_sym_switch] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1294),
    [anon_sym_LPAREN] = ACTIONS(1292),
    [anon_sym_await] = ACTIONS(1294),
    [anon_sym_while] = ACTIONS(1294),
    [anon_sym_do] = ACTIONS(1294),
    [anon_sym_try] = ACTIONS(1294),
    [anon_sym_with] = ACTIONS(1294),
    [anon_sym_break] = ACTIONS(1294),
    [anon_sym_continue] = ACTIONS(1294),
    [anon_sym_debugger] = ACTIONS(1294),
    [anon_sym_return] = ACTIONS(1294),
    [anon_sym_throw] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1294),
    [anon_sym_yield] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_LT] = ACTIONS(1292),
    [anon_sym_SLASH] = ACTIONS(1294),
    [anon_sym_class] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1294),
    [anon_sym_function] = ACTIONS(1294),
    [anon_sym_new] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_void] = ACTIONS(1294),
    [anon_sym_delete] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1292),
    [anon_sym_DQUOTE] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1292),
    [sym_number] = ACTIONS(1292),
    [sym_this] = ACTIONS(1294),
    [sym_super] = ACTIONS(1294),
    [sym_true] = ACTIONS(1294),
    [sym_false] = ACTIONS(1294),
    [sym_null] = ACTIONS(1294),
    [sym_undefined] = ACTIONS(1294),
    [anon_sym_AT] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1294),
    [anon_sym_readonly] = ACTIONS(1294),
    [anon_sym_get] = ACTIONS(1294),
    [anon_sym_set] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1294),
    [anon_sym_public] = ACTIONS(1294),
    [anon_sym_private] = ACTIONS(1294),
    [anon_sym_protected] = ACTIONS(1294),
    [anon_sym_override] = ACTIONS(1294),
    [anon_sym_module] = ACTIONS(1294),
    [anon_sym_any] = ACTIONS(1294),
    [anon_sym_number] = ACTIONS(1294),
    [anon_sym_boolean] = ACTIONS(1294),
    [anon_sym_string] = ACTIONS(1294),
    [anon_sym_symbol] = ACTIONS(1294),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_interface] = ACTIONS(1294),
    [anon_sym_enum] = ACTIONS(1294),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1292),
    [sym__automatic_semicolon] = ACTIONS(2014),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_export] = ACTIONS(1400),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_type] = ACTIONS(1400),
    [anon_sym_namespace] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_COMMA] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_typeof] = ACTIONS(1400),
    [anon_sym_import] = ACTIONS(1400),
    [anon_sym_var] = ACTIONS(1400),
    [anon_sym_let] = ACTIONS(1400),
    [anon_sym_const] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1398),
    [anon_sym_else] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1400),
    [anon_sym_switch] = ACTIONS(1400),
    [anon_sym_for] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_await] = ACTIONS(1400),
    [anon_sym_while] = ACTIONS(1400),
    [anon_sym_do] = ACTIONS(1400),
    [anon_sym_try] = ACTIONS(1400),
    [anon_sym_with] = ACTIONS(1400),
    [anon_sym_break] = ACTIONS(1400),
    [anon_sym_continue] = ACTIONS(1400),
    [anon_sym_debugger] = ACTIONS(1400),
    [anon_sym_return] = ACTIONS(1400),
    [anon_sym_throw] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1398),
    [anon_sym_case] = ACTIONS(1400),
    [anon_sym_yield] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1398),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_class] = ACTIONS(1400),
    [anon_sym_async] = ACTIONS(1400),
    [anon_sym_function] = ACTIONS(1400),
    [anon_sym_new] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1398),
    [anon_sym_void] = ACTIONS(1400),
    [anon_sym_delete] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [sym_number] = ACTIONS(1398),
    [sym_this] = ACTIONS(1400),
    [sym_super] = ACTIONS(1400),
    [sym_true] = ACTIONS(1400),
    [sym_false] = ACTIONS(1400),
    [sym_null] = ACTIONS(1400),
    [sym_undefined] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_readonly] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1400),
    [anon_sym_set] = ACTIONS(1400),
    [anon_sym_declare] = ACTIONS(1400),
    [anon_sym_public] = ACTIONS(1400),
    [anon_sym_private] = ACTIONS(1400),
    [anon_sym_protected] = ACTIONS(1400),
    [anon_sym_override] = ACTIONS(1400),
    [anon_sym_module] = ACTIONS(1400),
    [anon_sym_any] = ACTIONS(1400),
    [anon_sym_number] = ACTIONS(1400),
    [anon_sym_boolean] = ACTIONS(1400),
    [anon_sym_string] = ACTIONS(1400),
    [anon_sym_symbol] = ACTIONS(1400),
    [anon_sym_abstract] = ACTIONS(1400),
    [anon_sym_interface] = ACTIONS(1400),
    [anon_sym_enum] = ACTIONS(1400),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1398),
    [sym__automatic_semicolon] = ACTIONS(1398),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_export] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_var] = ACTIONS(1346),
    [anon_sym_let] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_debugger] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_throw] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_catch] = ACTIONS(1346),
    [anon_sym_finally] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1346),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1346),
    [anon_sym_new] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_void] = ACTIONS(1346),
    [anon_sym_delete] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1344),
    [sym_number] = ACTIONS(1344),
    [sym_this] = ACTIONS(1346),
    [sym_super] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_null] = ACTIONS(1346),
    [sym_undefined] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_readonly] = ACTIONS(1346),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_declare] = ACTIONS(1346),
    [anon_sym_public] = ACTIONS(1346),
    [anon_sym_private] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1346),
    [anon_sym_override] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_any] = ACTIONS(1346),
    [anon_sym_number] = ACTIONS(1346),
    [anon_sym_boolean] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [anon_sym_symbol] = ACTIONS(1346),
    [anon_sym_abstract] = ACTIONS(1346),
    [anon_sym_interface] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
  },
  [579] = {
    [sym__call_signature] = STATE(3869),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(1236),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_readonly] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_override] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_symbol] = ACTIONS(1993),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_export] = ACTIONS(1400),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_type] = ACTIONS(1400),
    [anon_sym_namespace] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_COMMA] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_typeof] = ACTIONS(1400),
    [anon_sym_import] = ACTIONS(1400),
    [anon_sym_var] = ACTIONS(1400),
    [anon_sym_let] = ACTIONS(1400),
    [anon_sym_const] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1398),
    [anon_sym_else] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1400),
    [anon_sym_switch] = ACTIONS(1400),
    [anon_sym_for] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_await] = ACTIONS(1400),
    [anon_sym_while] = ACTIONS(1400),
    [anon_sym_do] = ACTIONS(1400),
    [anon_sym_try] = ACTIONS(1400),
    [anon_sym_with] = ACTIONS(1400),
    [anon_sym_break] = ACTIONS(1400),
    [anon_sym_continue] = ACTIONS(1400),
    [anon_sym_debugger] = ACTIONS(1400),
    [anon_sym_return] = ACTIONS(1400),
    [anon_sym_throw] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1398),
    [anon_sym_case] = ACTIONS(1400),
    [anon_sym_catch] = ACTIONS(1400),
    [anon_sym_finally] = ACTIONS(1400),
    [anon_sym_yield] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1398),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_class] = ACTIONS(1400),
    [anon_sym_async] = ACTIONS(1400),
    [anon_sym_function] = ACTIONS(1400),
    [anon_sym_new] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1398),
    [anon_sym_void] = ACTIONS(1400),
    [anon_sym_delete] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [sym_number] = ACTIONS(1398),
    [sym_this] = ACTIONS(1400),
    [sym_super] = ACTIONS(1400),
    [sym_true] = ACTIONS(1400),
    [sym_false] = ACTIONS(1400),
    [sym_null] = ACTIONS(1400),
    [sym_undefined] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_readonly] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1400),
    [anon_sym_set] = ACTIONS(1400),
    [anon_sym_declare] = ACTIONS(1400),
    [anon_sym_public] = ACTIONS(1400),
    [anon_sym_private] = ACTIONS(1400),
    [anon_sym_protected] = ACTIONS(1400),
    [anon_sym_override] = ACTIONS(1400),
    [anon_sym_module] = ACTIONS(1400),
    [anon_sym_any] = ACTIONS(1400),
    [anon_sym_number] = ACTIONS(1400),
    [anon_sym_boolean] = ACTIONS(1400),
    [anon_sym_string] = ACTIONS(1400),
    [anon_sym_symbol] = ACTIONS(1400),
    [anon_sym_abstract] = ACTIONS(1400),
    [anon_sym_interface] = ACTIONS(1400),
    [anon_sym_enum] = ACTIONS(1400),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(1354),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(1356),
    [anon_sym_default] = ACTIONS(1356),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_namespace] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_COMMA] = ACTIONS(1354),
    [anon_sym_RBRACE] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1356),
    [anon_sym_var] = ACTIONS(1356),
    [anon_sym_let] = ACTIONS(1356),
    [anon_sym_const] = ACTIONS(1356),
    [anon_sym_BANG] = ACTIONS(1354),
    [anon_sym_else] = ACTIONS(1356),
    [anon_sym_if] = ACTIONS(1356),
    [anon_sym_switch] = ACTIONS(1356),
    [anon_sym_for] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1354),
    [anon_sym_await] = ACTIONS(1356),
    [anon_sym_while] = ACTIONS(1356),
    [anon_sym_do] = ACTIONS(1356),
    [anon_sym_try] = ACTIONS(1356),
    [anon_sym_with] = ACTIONS(1356),
    [anon_sym_break] = ACTIONS(1356),
    [anon_sym_continue] = ACTIONS(1356),
    [anon_sym_debugger] = ACTIONS(1356),
    [anon_sym_return] = ACTIONS(1356),
    [anon_sym_throw] = ACTIONS(1356),
    [anon_sym_SEMI] = ACTIONS(1354),
    [anon_sym_case] = ACTIONS(1356),
    [anon_sym_yield] = ACTIONS(1356),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_LT] = ACTIONS(1354),
    [anon_sym_SLASH] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1356),
    [anon_sym_async] = ACTIONS(1356),
    [anon_sym_function] = ACTIONS(1356),
    [anon_sym_new] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_void] = ACTIONS(1356),
    [anon_sym_delete] = ACTIONS(1356),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(1354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [sym_number] = ACTIONS(1354),
    [sym_this] = ACTIONS(1356),
    [sym_super] = ACTIONS(1356),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [sym_null] = ACTIONS(1356),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_AT] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1356),
    [anon_sym_readonly] = ACTIONS(1356),
    [anon_sym_get] = ACTIONS(1356),
    [anon_sym_set] = ACTIONS(1356),
    [anon_sym_declare] = ACTIONS(1356),
    [anon_sym_public] = ACTIONS(1356),
    [anon_sym_private] = ACTIONS(1356),
    [anon_sym_protected] = ACTIONS(1356),
    [anon_sym_override] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1356),
    [anon_sym_any] = ACTIONS(1356),
    [anon_sym_number] = ACTIONS(1356),
    [anon_sym_boolean] = ACTIONS(1356),
    [anon_sym_string] = ACTIONS(1356),
    [anon_sym_symbol] = ACTIONS(1356),
    [anon_sym_abstract] = ACTIONS(1356),
    [anon_sym_interface] = ACTIONS(1356),
    [anon_sym_enum] = ACTIONS(1356),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1354),
    [sym__automatic_semicolon] = ACTIONS(1354),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(1330),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_export] = ACTIONS(1332),
    [anon_sym_default] = ACTIONS(1332),
    [anon_sym_type] = ACTIONS(1332),
    [anon_sym_namespace] = ACTIONS(1332),
    [anon_sym_LBRACE] = ACTIONS(1330),
    [anon_sym_COMMA] = ACTIONS(1330),
    [anon_sym_RBRACE] = ACTIONS(1330),
    [anon_sym_typeof] = ACTIONS(1332),
    [anon_sym_import] = ACTIONS(1332),
    [anon_sym_var] = ACTIONS(1332),
    [anon_sym_let] = ACTIONS(1332),
    [anon_sym_const] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1330),
    [anon_sym_else] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(1332),
    [anon_sym_switch] = ACTIONS(1332),
    [anon_sym_for] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1330),
    [anon_sym_await] = ACTIONS(1332),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_do] = ACTIONS(1332),
    [anon_sym_try] = ACTIONS(1332),
    [anon_sym_with] = ACTIONS(1332),
    [anon_sym_break] = ACTIONS(1332),
    [anon_sym_continue] = ACTIONS(1332),
    [anon_sym_debugger] = ACTIONS(1332),
    [anon_sym_return] = ACTIONS(1332),
    [anon_sym_throw] = ACTIONS(1332),
    [anon_sym_SEMI] = ACTIONS(1330),
    [anon_sym_case] = ACTIONS(1332),
    [anon_sym_yield] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1330),
    [anon_sym_LT] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1332),
    [anon_sym_class] = ACTIONS(1332),
    [anon_sym_async] = ACTIONS(1332),
    [anon_sym_function] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1330),
    [anon_sym_void] = ACTIONS(1332),
    [anon_sym_delete] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1330),
    [anon_sym_DASH_DASH] = ACTIONS(1330),
    [anon_sym_DQUOTE] = ACTIONS(1330),
    [anon_sym_SQUOTE] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1330),
    [sym_number] = ACTIONS(1330),
    [sym_this] = ACTIONS(1332),
    [sym_super] = ACTIONS(1332),
    [sym_true] = ACTIONS(1332),
    [sym_false] = ACTIONS(1332),
    [sym_null] = ACTIONS(1332),
    [sym_undefined] = ACTIONS(1332),
    [anon_sym_AT] = ACTIONS(1330),
    [anon_sym_static] = ACTIONS(1332),
    [anon_sym_readonly] = ACTIONS(1332),
    [anon_sym_get] = ACTIONS(1332),
    [anon_sym_set] = ACTIONS(1332),
    [anon_sym_declare] = ACTIONS(1332),
    [anon_sym_public] = ACTIONS(1332),
    [anon_sym_private] = ACTIONS(1332),
    [anon_sym_protected] = ACTIONS(1332),
    [anon_sym_override] = ACTIONS(1332),
    [anon_sym_module] = ACTIONS(1332),
    [anon_sym_any] = ACTIONS(1332),
    [anon_sym_number] = ACTIONS(1332),
    [anon_sym_boolean] = ACTIONS(1332),
    [anon_sym_string] = ACTIONS(1332),
    [anon_sym_symbol] = ACTIONS(1332),
    [anon_sym_abstract] = ACTIONS(1332),
    [anon_sym_interface] = ACTIONS(1332),
    [anon_sym_enum] = ACTIONS(1332),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1330),
    [sym__automatic_semicolon] = ACTIONS(1330),
  },
  [583] = {
    [sym__call_signature] = STATE(3869),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(1236),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_readonly] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_override] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_symbol] = ACTIONS(1993),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [584] = {
    [sym__call_signature] = STATE(3869),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(1236),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_readonly] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_override] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_symbol] = ACTIONS(1993),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [585] = {
    [sym__call_signature] = STATE(3869),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(1236),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_readonly] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_override] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_symbol] = ACTIONS(1993),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [586] = {
    [sym__call_signature] = STATE(3869),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1234),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1993),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(1236),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_readonly] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_override] = ACTIONS(1993),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_symbol] = ACTIONS(1993),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_export] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_var] = ACTIONS(1346),
    [anon_sym_let] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_debugger] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_throw] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1346),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1346),
    [anon_sym_new] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_void] = ACTIONS(1346),
    [anon_sym_delete] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1344),
    [sym_number] = ACTIONS(1344),
    [sym_this] = ACTIONS(1346),
    [sym_super] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_null] = ACTIONS(1346),
    [sym_undefined] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_readonly] = ACTIONS(1346),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_declare] = ACTIONS(1346),
    [anon_sym_public] = ACTIONS(1346),
    [anon_sym_private] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1346),
    [anon_sym_override] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_any] = ACTIONS(1346),
    [anon_sym_number] = ACTIONS(1346),
    [anon_sym_boolean] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [anon_sym_symbol] = ACTIONS(1346),
    [anon_sym_abstract] = ACTIONS(1346),
    [anon_sym_interface] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1344),
    [sym__automatic_semicolon] = ACTIONS(2018),
  },
  [588] = {
    [sym__call_signature] = STATE(3951),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2010),
    [anon_sym_function] = ACTIONS(1972),
    [anon_sym_EQ_GT] = ACTIONS(1276),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2010),
    [anon_sym_readonly] = ACTIONS(2010),
    [anon_sym_get] = ACTIONS(2010),
    [anon_sym_set] = ACTIONS(2010),
    [anon_sym_declare] = ACTIONS(2010),
    [anon_sym_public] = ACTIONS(2010),
    [anon_sym_private] = ACTIONS(2010),
    [anon_sym_protected] = ACTIONS(2010),
    [anon_sym_override] = ACTIONS(2010),
    [anon_sym_module] = ACTIONS(2010),
    [anon_sym_any] = ACTIONS(2010),
    [anon_sym_number] = ACTIONS(2010),
    [anon_sym_boolean] = ACTIONS(2010),
    [anon_sym_string] = ACTIONS(2010),
    [anon_sym_symbol] = ACTIONS(2010),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [589] = {
    [sym__call_signature] = STATE(4019),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1962),
    [anon_sym_export] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1964),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1964),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_readonly] = ACTIONS(1964),
    [anon_sym_get] = ACTIONS(1964),
    [anon_sym_set] = ACTIONS(1964),
    [anon_sym_declare] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_override] = ACTIONS(1964),
    [anon_sym_module] = ACTIONS(1964),
    [anon_sym_any] = ACTIONS(1964),
    [anon_sym_number] = ACTIONS(1964),
    [anon_sym_boolean] = ACTIONS(1964),
    [anon_sym_string] = ACTIONS(1964),
    [anon_sym_symbol] = ACTIONS(1964),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [590] = {
    [sym__call_signature] = STATE(4019),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1962),
    [anon_sym_export] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1964),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_of] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1964),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_readonly] = ACTIONS(1964),
    [anon_sym_get] = ACTIONS(1964),
    [anon_sym_set] = ACTIONS(1964),
    [anon_sym_declare] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_override] = ACTIONS(1964),
    [anon_sym_module] = ACTIONS(1964),
    [anon_sym_any] = ACTIONS(1964),
    [anon_sym_number] = ACTIONS(1964),
    [anon_sym_boolean] = ACTIONS(1964),
    [anon_sym_string] = ACTIONS(1964),
    [anon_sym_symbol] = ACTIONS(1964),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [591] = {
    [sym_statement_block] = STATE(750),
    [ts_builtin_sym_end] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_export] = ACTIONS(1286),
    [anon_sym_default] = ACTIONS(1286),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_namespace] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(2020),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_typeof] = ACTIONS(1286),
    [anon_sym_import] = ACTIONS(1286),
    [anon_sym_var] = ACTIONS(1286),
    [anon_sym_let] = ACTIONS(1286),
    [anon_sym_const] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1284),
    [anon_sym_else] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_switch] = ACTIONS(1286),
    [anon_sym_for] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(1286),
    [anon_sym_while] = ACTIONS(1286),
    [anon_sym_do] = ACTIONS(1286),
    [anon_sym_try] = ACTIONS(1286),
    [anon_sym_with] = ACTIONS(1286),
    [anon_sym_break] = ACTIONS(1286),
    [anon_sym_continue] = ACTIONS(1286),
    [anon_sym_debugger] = ACTIONS(1286),
    [anon_sym_return] = ACTIONS(1286),
    [anon_sym_throw] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1284),
    [anon_sym_case] = ACTIONS(1286),
    [anon_sym_yield] = ACTIONS(1286),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(1284),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_DOT] = ACTIONS(2022),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1286),
    [anon_sym_function] = ACTIONS(1286),
    [anon_sym_new] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_void] = ACTIONS(1286),
    [anon_sym_delete] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [sym_number] = ACTIONS(1284),
    [sym_this] = ACTIONS(1286),
    [sym_super] = ACTIONS(1286),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_null] = ACTIONS(1286),
    [sym_undefined] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_readonly] = ACTIONS(1286),
    [anon_sym_get] = ACTIONS(1286),
    [anon_sym_set] = ACTIONS(1286),
    [anon_sym_declare] = ACTIONS(1286),
    [anon_sym_public] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1286),
    [anon_sym_protected] = ACTIONS(1286),
    [anon_sym_override] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_any] = ACTIONS(1286),
    [anon_sym_number] = ACTIONS(1286),
    [anon_sym_boolean] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [anon_sym_symbol] = ACTIONS(1286),
    [anon_sym_abstract] = ACTIONS(1286),
    [anon_sym_interface] = ACTIONS(1286),
    [anon_sym_enum] = ACTIONS(1286),
  },
  [592] = {
    [sym__call_signature] = STATE(3893),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(2024),
    [anon_sym_export] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2026),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2026),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(1280),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2026),
    [anon_sym_readonly] = ACTIONS(2026),
    [anon_sym_get] = ACTIONS(2026),
    [anon_sym_set] = ACTIONS(2026),
    [anon_sym_declare] = ACTIONS(2026),
    [anon_sym_public] = ACTIONS(2026),
    [anon_sym_private] = ACTIONS(2026),
    [anon_sym_protected] = ACTIONS(2026),
    [anon_sym_override] = ACTIONS(2026),
    [anon_sym_module] = ACTIONS(2026),
    [anon_sym_any] = ACTIONS(2026),
    [anon_sym_number] = ACTIONS(2026),
    [anon_sym_boolean] = ACTIONS(2026),
    [anon_sym_string] = ACTIONS(2026),
    [anon_sym_symbol] = ACTIONS(2026),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [593] = {
    [sym__call_signature] = STATE(3893),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(2024),
    [anon_sym_export] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2026),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2026),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(1280),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2026),
    [anon_sym_readonly] = ACTIONS(2026),
    [anon_sym_get] = ACTIONS(2026),
    [anon_sym_set] = ACTIONS(2026),
    [anon_sym_declare] = ACTIONS(2026),
    [anon_sym_public] = ACTIONS(2026),
    [anon_sym_private] = ACTIONS(2026),
    [anon_sym_protected] = ACTIONS(2026),
    [anon_sym_override] = ACTIONS(2026),
    [anon_sym_module] = ACTIONS(2026),
    [anon_sym_any] = ACTIONS(2026),
    [anon_sym_number] = ACTIONS(2026),
    [anon_sym_boolean] = ACTIONS(2026),
    [anon_sym_string] = ACTIONS(2026),
    [anon_sym_symbol] = ACTIONS(2026),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [594] = {
    [sym_finally_clause] = STATE(619),
    [ts_builtin_sym_end] = ACTIONS(2028),
    [sym_identifier] = ACTIONS(2030),
    [anon_sym_export] = ACTIONS(2030),
    [anon_sym_default] = ACTIONS(2030),
    [anon_sym_type] = ACTIONS(2030),
    [anon_sym_namespace] = ACTIONS(2030),
    [anon_sym_LBRACE] = ACTIONS(2028),
    [anon_sym_RBRACE] = ACTIONS(2028),
    [anon_sym_typeof] = ACTIONS(2030),
    [anon_sym_import] = ACTIONS(2030),
    [anon_sym_var] = ACTIONS(2030),
    [anon_sym_let] = ACTIONS(2030),
    [anon_sym_const] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2028),
    [anon_sym_else] = ACTIONS(2030),
    [anon_sym_if] = ACTIONS(2030),
    [anon_sym_switch] = ACTIONS(2030),
    [anon_sym_for] = ACTIONS(2030),
    [anon_sym_LPAREN] = ACTIONS(2028),
    [anon_sym_await] = ACTIONS(2030),
    [anon_sym_while] = ACTIONS(2030),
    [anon_sym_do] = ACTIONS(2030),
    [anon_sym_try] = ACTIONS(2030),
    [anon_sym_with] = ACTIONS(2030),
    [anon_sym_break] = ACTIONS(2030),
    [anon_sym_continue] = ACTIONS(2030),
    [anon_sym_debugger] = ACTIONS(2030),
    [anon_sym_return] = ACTIONS(2030),
    [anon_sym_throw] = ACTIONS(2030),
    [anon_sym_SEMI] = ACTIONS(2028),
    [anon_sym_case] = ACTIONS(2030),
    [anon_sym_finally] = ACTIONS(2006),
    [anon_sym_yield] = ACTIONS(2030),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_SLASH] = ACTIONS(2030),
    [anon_sym_class] = ACTIONS(2030),
    [anon_sym_async] = ACTIONS(2030),
    [anon_sym_function] = ACTIONS(2030),
    [anon_sym_new] = ACTIONS(2030),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_DASH] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2028),
    [anon_sym_void] = ACTIONS(2030),
    [anon_sym_delete] = ACTIONS(2030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2028),
    [anon_sym_DASH_DASH] = ACTIONS(2028),
    [anon_sym_DQUOTE] = ACTIONS(2028),
    [anon_sym_SQUOTE] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2028),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_super] = ACTIONS(2030),
    [sym_true] = ACTIONS(2030),
    [sym_false] = ACTIONS(2030),
    [sym_null] = ACTIONS(2030),
    [sym_undefined] = ACTIONS(2030),
    [anon_sym_AT] = ACTIONS(2028),
    [anon_sym_static] = ACTIONS(2030),
    [anon_sym_readonly] = ACTIONS(2030),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2030),
    [anon_sym_declare] = ACTIONS(2030),
    [anon_sym_public] = ACTIONS(2030),
    [anon_sym_private] = ACTIONS(2030),
    [anon_sym_protected] = ACTIONS(2030),
    [anon_sym_override] = ACTIONS(2030),
    [anon_sym_module] = ACTIONS(2030),
    [anon_sym_any] = ACTIONS(2030),
    [anon_sym_number] = ACTIONS(2030),
    [anon_sym_boolean] = ACTIONS(2030),
    [anon_sym_string] = ACTIONS(2030),
    [anon_sym_symbol] = ACTIONS(2030),
    [anon_sym_abstract] = ACTIONS(2030),
    [anon_sym_interface] = ACTIONS(2030),
    [anon_sym_enum] = ACTIONS(2030),
  },
  [595] = {
    [ts_builtin_sym_end] = ACTIONS(1376),
    [sym_identifier] = ACTIONS(1378),
    [anon_sym_export] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_type] = ACTIONS(1378),
    [anon_sym_namespace] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_RBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(1378),
    [anon_sym_import] = ACTIONS(1378),
    [anon_sym_var] = ACTIONS(1378),
    [anon_sym_let] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_LPAREN] = ACTIONS(1376),
    [anon_sym_await] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_try] = ACTIONS(1378),
    [anon_sym_with] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_debugger] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_throw] = ACTIONS(1378),
    [anon_sym_SEMI] = ACTIONS(1376),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_yield] = ACTIONS(1378),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_SLASH] = ACTIONS(1378),
    [anon_sym_class] = ACTIONS(1378),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1378),
    [anon_sym_new] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_void] = ACTIONS(1378),
    [anon_sym_delete] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(1376),
    [anon_sym_DASH_DASH] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [sym_number] = ACTIONS(1376),
    [sym_this] = ACTIONS(1378),
    [sym_super] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_null] = ACTIONS(1378),
    [sym_undefined] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(1376),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_readonly] = ACTIONS(1378),
    [anon_sym_get] = ACTIONS(1378),
    [anon_sym_set] = ACTIONS(1378),
    [anon_sym_declare] = ACTIONS(1378),
    [anon_sym_public] = ACTIONS(1378),
    [anon_sym_private] = ACTIONS(1378),
    [anon_sym_protected] = ACTIONS(1378),
    [anon_sym_override] = ACTIONS(1378),
    [anon_sym_module] = ACTIONS(1378),
    [anon_sym_any] = ACTIONS(1378),
    [anon_sym_number] = ACTIONS(1378),
    [anon_sym_boolean] = ACTIONS(1378),
    [anon_sym_string] = ACTIONS(1378),
    [anon_sym_symbol] = ACTIONS(1378),
    [anon_sym_abstract] = ACTIONS(1378),
    [anon_sym_interface] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [sym__automatic_semicolon] = ACTIONS(1384),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(2032),
    [sym_identifier] = ACTIONS(2034),
    [anon_sym_export] = ACTIONS(2034),
    [anon_sym_default] = ACTIONS(2034),
    [anon_sym_type] = ACTIONS(2034),
    [anon_sym_namespace] = ACTIONS(2034),
    [anon_sym_LBRACE] = ACTIONS(2032),
    [anon_sym_RBRACE] = ACTIONS(2032),
    [anon_sym_typeof] = ACTIONS(2034),
    [anon_sym_import] = ACTIONS(2034),
    [anon_sym_var] = ACTIONS(2034),
    [anon_sym_let] = ACTIONS(2034),
    [anon_sym_const] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_else] = ACTIONS(2034),
    [anon_sym_if] = ACTIONS(2034),
    [anon_sym_switch] = ACTIONS(2034),
    [anon_sym_for] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(2032),
    [anon_sym_await] = ACTIONS(2034),
    [anon_sym_while] = ACTIONS(2034),
    [anon_sym_do] = ACTIONS(2034),
    [anon_sym_try] = ACTIONS(2034),
    [anon_sym_with] = ACTIONS(2034),
    [anon_sym_break] = ACTIONS(2034),
    [anon_sym_continue] = ACTIONS(2034),
    [anon_sym_debugger] = ACTIONS(2034),
    [anon_sym_return] = ACTIONS(2034),
    [anon_sym_throw] = ACTIONS(2034),
    [anon_sym_SEMI] = ACTIONS(2032),
    [anon_sym_case] = ACTIONS(2034),
    [anon_sym_finally] = ACTIONS(2034),
    [anon_sym_yield] = ACTIONS(2034),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [anon_sym_LT] = ACTIONS(2032),
    [anon_sym_SLASH] = ACTIONS(2034),
    [anon_sym_class] = ACTIONS(2034),
    [anon_sym_async] = ACTIONS(2034),
    [anon_sym_function] = ACTIONS(2034),
    [anon_sym_new] = ACTIONS(2034),
    [anon_sym_PLUS] = ACTIONS(2034),
    [anon_sym_DASH] = ACTIONS(2034),
    [anon_sym_TILDE] = ACTIONS(2032),
    [anon_sym_void] = ACTIONS(2034),
    [anon_sym_delete] = ACTIONS(2034),
    [anon_sym_PLUS_PLUS] = ACTIONS(2032),
    [anon_sym_DASH_DASH] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(2032),
    [anon_sym_SQUOTE] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2032),
    [sym_number] = ACTIONS(2032),
    [sym_this] = ACTIONS(2034),
    [sym_super] = ACTIONS(2034),
    [sym_true] = ACTIONS(2034),
    [sym_false] = ACTIONS(2034),
    [sym_null] = ACTIONS(2034),
    [sym_undefined] = ACTIONS(2034),
    [anon_sym_AT] = ACTIONS(2032),
    [anon_sym_static] = ACTIONS(2034),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_get] = ACTIONS(2034),
    [anon_sym_set] = ACTIONS(2034),
    [anon_sym_declare] = ACTIONS(2034),
    [anon_sym_public] = ACTIONS(2034),
    [anon_sym_private] = ACTIONS(2034),
    [anon_sym_protected] = ACTIONS(2034),
    [anon_sym_override] = ACTIONS(2034),
    [anon_sym_module] = ACTIONS(2034),
    [anon_sym_any] = ACTIONS(2034),
    [anon_sym_number] = ACTIONS(2034),
    [anon_sym_boolean] = ACTIONS(2034),
    [anon_sym_string] = ACTIONS(2034),
    [anon_sym_symbol] = ACTIONS(2034),
    [anon_sym_abstract] = ACTIONS(2034),
    [anon_sym_interface] = ACTIONS(2034),
    [anon_sym_enum] = ACTIONS(2034),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(1422),
    [sym_identifier] = ACTIONS(1424),
    [anon_sym_export] = ACTIONS(1424),
    [anon_sym_default] = ACTIONS(1424),
    [anon_sym_type] = ACTIONS(1424),
    [anon_sym_namespace] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1422),
    [anon_sym_typeof] = ACTIONS(1424),
    [anon_sym_import] = ACTIONS(1424),
    [anon_sym_var] = ACTIONS(1424),
    [anon_sym_let] = ACTIONS(1424),
    [anon_sym_const] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(1422),
    [anon_sym_else] = ACTIONS(1424),
    [anon_sym_if] = ACTIONS(1424),
    [anon_sym_switch] = ACTIONS(1424),
    [anon_sym_for] = ACTIONS(1424),
    [anon_sym_LPAREN] = ACTIONS(1422),
    [anon_sym_await] = ACTIONS(1424),
    [anon_sym_while] = ACTIONS(1424),
    [anon_sym_do] = ACTIONS(1424),
    [anon_sym_try] = ACTIONS(1424),
    [anon_sym_with] = ACTIONS(1424),
    [anon_sym_break] = ACTIONS(1424),
    [anon_sym_continue] = ACTIONS(1424),
    [anon_sym_debugger] = ACTIONS(1424),
    [anon_sym_return] = ACTIONS(1424),
    [anon_sym_throw] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1422),
    [anon_sym_case] = ACTIONS(1424),
    [anon_sym_yield] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(1422),
    [anon_sym_SLASH] = ACTIONS(1424),
    [anon_sym_class] = ACTIONS(1424),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_function] = ACTIONS(1424),
    [anon_sym_new] = ACTIONS(1424),
    [anon_sym_PLUS] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1424),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_void] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1422),
    [anon_sym_DASH_DASH] = ACTIONS(1422),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [anon_sym_SQUOTE] = ACTIONS(1422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1422),
    [sym_this] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_true] = ACTIONS(1424),
    [sym_false] = ACTIONS(1424),
    [sym_null] = ACTIONS(1424),
    [sym_undefined] = ACTIONS(1424),
    [anon_sym_AT] = ACTIONS(1422),
    [anon_sym_static] = ACTIONS(1424),
    [anon_sym_readonly] = ACTIONS(1424),
    [anon_sym_get] = ACTIONS(1424),
    [anon_sym_set] = ACTIONS(1424),
    [anon_sym_declare] = ACTIONS(1424),
    [anon_sym_public] = ACTIONS(1424),
    [anon_sym_private] = ACTIONS(1424),
    [anon_sym_protected] = ACTIONS(1424),
    [anon_sym_override] = ACTIONS(1424),
    [anon_sym_module] = ACTIONS(1424),
    [anon_sym_any] = ACTIONS(1424),
    [anon_sym_number] = ACTIONS(1424),
    [anon_sym_boolean] = ACTIONS(1424),
    [anon_sym_string] = ACTIONS(1424),
    [anon_sym_symbol] = ACTIONS(1424),
    [anon_sym_abstract] = ACTIONS(1424),
    [anon_sym_interface] = ACTIONS(1424),
    [anon_sym_enum] = ACTIONS(1424),
    [sym__automatic_semicolon] = ACTIONS(1430),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(1312),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_export] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_namespace] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_RBRACE] = ACTIONS(1312),
    [anon_sym_typeof] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(1314),
    [anon_sym_var] = ACTIONS(1314),
    [anon_sym_let] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_BANG] = ACTIONS(1312),
    [anon_sym_else] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_switch] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_LPAREN] = ACTIONS(1312),
    [anon_sym_await] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_do] = ACTIONS(1314),
    [anon_sym_try] = ACTIONS(1314),
    [anon_sym_with] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_debugger] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_throw] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1312),
    [anon_sym_case] = ACTIONS(1314),
    [anon_sym_yield] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LT] = ACTIONS(1312),
    [anon_sym_SLASH] = ACTIONS(1314),
    [anon_sym_class] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_function] = ACTIONS(1314),
    [anon_sym_new] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1314),
    [anon_sym_DASH] = ACTIONS(1314),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_void] = ACTIONS(1314),
    [anon_sym_delete] = ACTIONS(1314),
    [anon_sym_PLUS_PLUS] = ACTIONS(1312),
    [anon_sym_DASH_DASH] = ACTIONS(1312),
    [anon_sym_DQUOTE] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1312),
    [sym_number] = ACTIONS(1312),
    [sym_this] = ACTIONS(1314),
    [sym_super] = ACTIONS(1314),
    [sym_true] = ACTIONS(1314),
    [sym_false] = ACTIONS(1314),
    [sym_null] = ACTIONS(1314),
    [sym_undefined] = ACTIONS(1314),
    [anon_sym_AT] = ACTIONS(1312),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_readonly] = ACTIONS(1314),
    [anon_sym_get] = ACTIONS(1314),
    [anon_sym_set] = ACTIONS(1314),
    [anon_sym_declare] = ACTIONS(1314),
    [anon_sym_public] = ACTIONS(1314),
    [anon_sym_private] = ACTIONS(1314),
    [anon_sym_protected] = ACTIONS(1314),
    [anon_sym_override] = ACTIONS(1314),
    [anon_sym_module] = ACTIONS(1314),
    [anon_sym_any] = ACTIONS(1314),
    [anon_sym_number] = ACTIONS(1314),
    [anon_sym_boolean] = ACTIONS(1314),
    [anon_sym_string] = ACTIONS(1314),
    [anon_sym_symbol] = ACTIONS(1314),
    [anon_sym_abstract] = ACTIONS(1314),
    [anon_sym_interface] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [sym__automatic_semicolon] = ACTIONS(1320),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(1460),
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_export] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(1462),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1460),
    [anon_sym_RBRACE] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(1462),
    [anon_sym_import] = ACTIONS(1462),
    [anon_sym_var] = ACTIONS(1462),
    [anon_sym_let] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_LPAREN] = ACTIONS(1460),
    [anon_sym_await] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_try] = ACTIONS(1462),
    [anon_sym_with] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_debugger] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_throw] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_yield] = ACTIONS(1462),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(1462),
    [anon_sym_class] = ACTIONS(1462),
    [anon_sym_async] = ACTIONS(1462),
    [anon_sym_function] = ACTIONS(1462),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1460),
    [anon_sym_void] = ACTIONS(1462),
    [anon_sym_delete] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [anon_sym_SQUOTE] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1460),
    [sym_number] = ACTIONS(1460),
    [sym_this] = ACTIONS(1462),
    [sym_super] = ACTIONS(1462),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [sym_null] = ACTIONS(1462),
    [sym_undefined] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_readonly] = ACTIONS(1462),
    [anon_sym_get] = ACTIONS(1462),
    [anon_sym_set] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_public] = ACTIONS(1462),
    [anon_sym_private] = ACTIONS(1462),
    [anon_sym_protected] = ACTIONS(1462),
    [anon_sym_override] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_any] = ACTIONS(1462),
    [anon_sym_number] = ACTIONS(1462),
    [anon_sym_boolean] = ACTIONS(1462),
    [anon_sym_string] = ACTIONS(1462),
    [anon_sym_symbol] = ACTIONS(1462),
    [anon_sym_abstract] = ACTIONS(1462),
    [anon_sym_interface] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [sym__automatic_semicolon] = ACTIONS(1468),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(1432),
    [sym_identifier] = ACTIONS(1434),
    [anon_sym_export] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_type] = ACTIONS(1434),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_RBRACE] = ACTIONS(1432),
    [anon_sym_typeof] = ACTIONS(1434),
    [anon_sym_import] = ACTIONS(1434),
    [anon_sym_var] = ACTIONS(1434),
    [anon_sym_let] = ACTIONS(1434),
    [anon_sym_const] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1432),
    [anon_sym_await] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(1434),
    [anon_sym_do] = ACTIONS(1434),
    [anon_sym_try] = ACTIONS(1434),
    [anon_sym_with] = ACTIONS(1434),
    [anon_sym_break] = ACTIONS(1434),
    [anon_sym_continue] = ACTIONS(1434),
    [anon_sym_debugger] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1434),
    [anon_sym_throw] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1432),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_yield] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_LT] = ACTIONS(1432),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_class] = ACTIONS(1434),
    [anon_sym_async] = ACTIONS(1434),
    [anon_sym_function] = ACTIONS(1434),
    [anon_sym_new] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_TILDE] = ACTIONS(1432),
    [anon_sym_void] = ACTIONS(1434),
    [anon_sym_delete] = ACTIONS(1434),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [anon_sym_DASH_DASH] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1432),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1432),
    [sym_number] = ACTIONS(1432),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(1434),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [sym_null] = ACTIONS(1434),
    [sym_undefined] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1432),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_readonly] = ACTIONS(1434),
    [anon_sym_get] = ACTIONS(1434),
    [anon_sym_set] = ACTIONS(1434),
    [anon_sym_declare] = ACTIONS(1434),
    [anon_sym_public] = ACTIONS(1434),
    [anon_sym_private] = ACTIONS(1434),
    [anon_sym_protected] = ACTIONS(1434),
    [anon_sym_override] = ACTIONS(1434),
    [anon_sym_module] = ACTIONS(1434),
    [anon_sym_any] = ACTIONS(1434),
    [anon_sym_number] = ACTIONS(1434),
    [anon_sym_boolean] = ACTIONS(1434),
    [anon_sym_string] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1434),
    [anon_sym_abstract] = ACTIONS(1434),
    [anon_sym_interface] = ACTIONS(1434),
    [anon_sym_enum] = ACTIONS(1434),
    [sym__automatic_semicolon] = ACTIONS(1440),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(2036),
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_export] = ACTIONS(2038),
    [anon_sym_default] = ACTIONS(2038),
    [anon_sym_type] = ACTIONS(2038),
    [anon_sym_namespace] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2036),
    [anon_sym_RBRACE] = ACTIONS(2036),
    [anon_sym_typeof] = ACTIONS(2038),
    [anon_sym_import] = ACTIONS(2038),
    [anon_sym_var] = ACTIONS(2038),
    [anon_sym_let] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_BANG] = ACTIONS(2036),
    [anon_sym_else] = ACTIONS(2038),
    [anon_sym_if] = ACTIONS(2038),
    [anon_sym_switch] = ACTIONS(2038),
    [anon_sym_for] = ACTIONS(2038),
    [anon_sym_LPAREN] = ACTIONS(2036),
    [anon_sym_RPAREN] = ACTIONS(2036),
    [anon_sym_await] = ACTIONS(2038),
    [anon_sym_while] = ACTIONS(2038),
    [anon_sym_do] = ACTIONS(2038),
    [anon_sym_try] = ACTIONS(2038),
    [anon_sym_with] = ACTIONS(2038),
    [anon_sym_break] = ACTIONS(2038),
    [anon_sym_continue] = ACTIONS(2038),
    [anon_sym_debugger] = ACTIONS(2038),
    [anon_sym_return] = ACTIONS(2038),
    [anon_sym_throw] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2036),
    [anon_sym_case] = ACTIONS(2038),
    [anon_sym_yield] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2036),
    [anon_sym_LT] = ACTIONS(2036),
    [anon_sym_SLASH] = ACTIONS(2038),
    [anon_sym_class] = ACTIONS(2038),
    [anon_sym_async] = ACTIONS(2038),
    [anon_sym_function] = ACTIONS(2038),
    [anon_sym_new] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2038),
    [anon_sym_DASH] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2036),
    [anon_sym_void] = ACTIONS(2038),
    [anon_sym_delete] = ACTIONS(2038),
    [anon_sym_PLUS_PLUS] = ACTIONS(2036),
    [anon_sym_DASH_DASH] = ACTIONS(2036),
    [anon_sym_DQUOTE] = ACTIONS(2036),
    [anon_sym_SQUOTE] = ACTIONS(2036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2036),
    [sym_number] = ACTIONS(2036),
    [sym_this] = ACTIONS(2038),
    [sym_super] = ACTIONS(2038),
    [sym_true] = ACTIONS(2038),
    [sym_false] = ACTIONS(2038),
    [sym_null] = ACTIONS(2038),
    [sym_undefined] = ACTIONS(2038),
    [anon_sym_AT] = ACTIONS(2036),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_readonly] = ACTIONS(2038),
    [anon_sym_get] = ACTIONS(2038),
    [anon_sym_set] = ACTIONS(2038),
    [anon_sym_declare] = ACTIONS(2038),
    [anon_sym_public] = ACTIONS(2038),
    [anon_sym_private] = ACTIONS(2038),
    [anon_sym_protected] = ACTIONS(2038),
    [anon_sym_override] = ACTIONS(2038),
    [anon_sym_module] = ACTIONS(2038),
    [anon_sym_any] = ACTIONS(2038),
    [anon_sym_number] = ACTIONS(2038),
    [anon_sym_boolean] = ACTIONS(2038),
    [anon_sym_string] = ACTIONS(2038),
    [anon_sym_symbol] = ACTIONS(2038),
    [anon_sym_abstract] = ACTIONS(2038),
    [anon_sym_interface] = ACTIONS(2038),
    [anon_sym_enum] = ACTIONS(2038),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(1358),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_export] = ACTIONS(1360),
    [anon_sym_default] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_namespace] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [anon_sym_typeof] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(1360),
    [anon_sym_var] = ACTIONS(1360),
    [anon_sym_let] = ACTIONS(1360),
    [anon_sym_const] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1358),
    [anon_sym_else] = ACTIONS(1360),
    [anon_sym_if] = ACTIONS(1360),
    [anon_sym_switch] = ACTIONS(1360),
    [anon_sym_for] = ACTIONS(1360),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_await] = ACTIONS(1360),
    [anon_sym_while] = ACTIONS(1360),
    [anon_sym_do] = ACTIONS(1360),
    [anon_sym_try] = ACTIONS(1360),
    [anon_sym_with] = ACTIONS(1360),
    [anon_sym_break] = ACTIONS(1360),
    [anon_sym_continue] = ACTIONS(1360),
    [anon_sym_debugger] = ACTIONS(1360),
    [anon_sym_return] = ACTIONS(1360),
    [anon_sym_throw] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1358),
    [anon_sym_case] = ACTIONS(1360),
    [anon_sym_yield] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1358),
    [anon_sym_LT] = ACTIONS(1358),
    [anon_sym_SLASH] = ACTIONS(1360),
    [anon_sym_DOT] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_void] = ACTIONS(1360),
    [anon_sym_delete] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1358),
    [anon_sym_DQUOTE] = ACTIONS(1358),
    [anon_sym_SQUOTE] = ACTIONS(1358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1358),
    [sym_number] = ACTIONS(1358),
    [sym_this] = ACTIONS(1360),
    [sym_super] = ACTIONS(1360),
    [sym_true] = ACTIONS(1360),
    [sym_false] = ACTIONS(1360),
    [sym_null] = ACTIONS(1360),
    [sym_undefined] = ACTIONS(1360),
    [anon_sym_AT] = ACTIONS(1358),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_readonly] = ACTIONS(1360),
    [anon_sym_get] = ACTIONS(1360),
    [anon_sym_set] = ACTIONS(1360),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_override] = ACTIONS(1360),
    [anon_sym_module] = ACTIONS(1360),
    [anon_sym_any] = ACTIONS(1360),
    [anon_sym_number] = ACTIONS(1360),
    [anon_sym_boolean] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_symbol] = ACTIONS(1360),
    [anon_sym_abstract] = ACTIONS(1360),
    [anon_sym_interface] = ACTIONS(1360),
    [anon_sym_enum] = ACTIONS(1360),
  },
  [603] = {
    [sym_statement_block] = STATE(750),
    [ts_builtin_sym_end] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_export] = ACTIONS(1286),
    [anon_sym_default] = ACTIONS(1286),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_namespace] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(2020),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_typeof] = ACTIONS(1286),
    [anon_sym_import] = ACTIONS(1286),
    [anon_sym_var] = ACTIONS(1286),
    [anon_sym_let] = ACTIONS(1286),
    [anon_sym_const] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1284),
    [anon_sym_else] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_switch] = ACTIONS(1286),
    [anon_sym_for] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(1286),
    [anon_sym_while] = ACTIONS(1286),
    [anon_sym_do] = ACTIONS(1286),
    [anon_sym_try] = ACTIONS(1286),
    [anon_sym_with] = ACTIONS(1286),
    [anon_sym_break] = ACTIONS(1286),
    [anon_sym_continue] = ACTIONS(1286),
    [anon_sym_debugger] = ACTIONS(1286),
    [anon_sym_return] = ACTIONS(1286),
    [anon_sym_throw] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1284),
    [anon_sym_case] = ACTIONS(1286),
    [anon_sym_yield] = ACTIONS(1286),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(1284),
    [anon_sym_SLASH] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1286),
    [anon_sym_function] = ACTIONS(1286),
    [anon_sym_new] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_void] = ACTIONS(1286),
    [anon_sym_delete] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [sym_number] = ACTIONS(1284),
    [sym_this] = ACTIONS(1286),
    [sym_super] = ACTIONS(1286),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_null] = ACTIONS(1286),
    [sym_undefined] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_static] = ACTIONS(1286),
    [anon_sym_readonly] = ACTIONS(1286),
    [anon_sym_get] = ACTIONS(1286),
    [anon_sym_set] = ACTIONS(1286),
    [anon_sym_declare] = ACTIONS(1286),
    [anon_sym_public] = ACTIONS(1286),
    [anon_sym_private] = ACTIONS(1286),
    [anon_sym_protected] = ACTIONS(1286),
    [anon_sym_override] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_any] = ACTIONS(1286),
    [anon_sym_number] = ACTIONS(1286),
    [anon_sym_boolean] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [anon_sym_symbol] = ACTIONS(1286),
    [anon_sym_abstract] = ACTIONS(1286),
    [anon_sym_interface] = ACTIONS(1286),
    [anon_sym_enum] = ACTIONS(1286),
  },
  [604] = {
    [sym_else_clause] = STATE(713),
    [ts_builtin_sym_end] = ACTIONS(2040),
    [sym_identifier] = ACTIONS(2042),
    [anon_sym_export] = ACTIONS(2042),
    [anon_sym_default] = ACTIONS(2042),
    [anon_sym_type] = ACTIONS(2042),
    [anon_sym_namespace] = ACTIONS(2042),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_RBRACE] = ACTIONS(2040),
    [anon_sym_typeof] = ACTIONS(2042),
    [anon_sym_import] = ACTIONS(2042),
    [anon_sym_var] = ACTIONS(2042),
    [anon_sym_let] = ACTIONS(2042),
    [anon_sym_const] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2040),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2042),
    [anon_sym_switch] = ACTIONS(2042),
    [anon_sym_for] = ACTIONS(2042),
    [anon_sym_LPAREN] = ACTIONS(2040),
    [anon_sym_await] = ACTIONS(2042),
    [anon_sym_while] = ACTIONS(2042),
    [anon_sym_do] = ACTIONS(2042),
    [anon_sym_try] = ACTIONS(2042),
    [anon_sym_with] = ACTIONS(2042),
    [anon_sym_break] = ACTIONS(2042),
    [anon_sym_continue] = ACTIONS(2042),
    [anon_sym_debugger] = ACTIONS(2042),
    [anon_sym_return] = ACTIONS(2042),
    [anon_sym_throw] = ACTIONS(2042),
    [anon_sym_SEMI] = ACTIONS(2040),
    [anon_sym_case] = ACTIONS(2042),
    [anon_sym_yield] = ACTIONS(2042),
    [anon_sym_LBRACK] = ACTIONS(2040),
    [anon_sym_LT] = ACTIONS(2040),
    [anon_sym_SLASH] = ACTIONS(2042),
    [anon_sym_class] = ACTIONS(2042),
    [anon_sym_async] = ACTIONS(2042),
    [anon_sym_function] = ACTIONS(2042),
    [anon_sym_new] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2042),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_void] = ACTIONS(2042),
    [anon_sym_delete] = ACTIONS(2042),
    [anon_sym_PLUS_PLUS] = ACTIONS(2040),
    [anon_sym_DASH_DASH] = ACTIONS(2040),
    [anon_sym_DQUOTE] = ACTIONS(2040),
    [anon_sym_SQUOTE] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2040),
    [sym_number] = ACTIONS(2040),
    [sym_this] = ACTIONS(2042),
    [sym_super] = ACTIONS(2042),
    [sym_true] = ACTIONS(2042),
    [sym_false] = ACTIONS(2042),
    [sym_null] = ACTIONS(2042),
    [sym_undefined] = ACTIONS(2042),
    [anon_sym_AT] = ACTIONS(2040),
    [anon_sym_static] = ACTIONS(2042),
    [anon_sym_readonly] = ACTIONS(2042),
    [anon_sym_get] = ACTIONS(2042),
    [anon_sym_set] = ACTIONS(2042),
    [anon_sym_declare] = ACTIONS(2042),
    [anon_sym_public] = ACTIONS(2042),
    [anon_sym_private] = ACTIONS(2042),
    [anon_sym_protected] = ACTIONS(2042),
    [anon_sym_override] = ACTIONS(2042),
    [anon_sym_module] = ACTIONS(2042),
    [anon_sym_any] = ACTIONS(2042),
    [anon_sym_number] = ACTIONS(2042),
    [anon_sym_boolean] = ACTIONS(2042),
    [anon_sym_string] = ACTIONS(2042),
    [anon_sym_symbol] = ACTIONS(2042),
    [anon_sym_abstract] = ACTIONS(2042),
    [anon_sym_interface] = ACTIONS(2042),
    [anon_sym_enum] = ACTIONS(2042),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(1412),
    [sym_identifier] = ACTIONS(1414),
    [anon_sym_export] = ACTIONS(1414),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_type] = ACTIONS(1414),
    [anon_sym_namespace] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1412),
    [anon_sym_RBRACE] = ACTIONS(1412),
    [anon_sym_typeof] = ACTIONS(1414),
    [anon_sym_import] = ACTIONS(1414),
    [anon_sym_var] = ACTIONS(1414),
    [anon_sym_let] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_LPAREN] = ACTIONS(1412),
    [anon_sym_await] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_try] = ACTIONS(1414),
    [anon_sym_with] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_debugger] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_throw] = ACTIONS(1414),
    [anon_sym_SEMI] = ACTIONS(1412),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_yield] = ACTIONS(1414),
    [anon_sym_LBRACK] = ACTIONS(1412),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_SLASH] = ACTIONS(1414),
    [anon_sym_class] = ACTIONS(1414),
    [anon_sym_async] = ACTIONS(1414),
    [anon_sym_function] = ACTIONS(1414),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_TILDE] = ACTIONS(1412),
    [anon_sym_void] = ACTIONS(1414),
    [anon_sym_delete] = ACTIONS(1414),
    [anon_sym_PLUS_PLUS] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1412),
    [anon_sym_DQUOTE] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(1412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1412),
    [sym_number] = ACTIONS(1412),
    [sym_this] = ACTIONS(1414),
    [sym_super] = ACTIONS(1414),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [sym_null] = ACTIONS(1414),
    [sym_undefined] = ACTIONS(1414),
    [anon_sym_AT] = ACTIONS(1412),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_readonly] = ACTIONS(1414),
    [anon_sym_get] = ACTIONS(1414),
    [anon_sym_set] = ACTIONS(1414),
    [anon_sym_declare] = ACTIONS(1414),
    [anon_sym_public] = ACTIONS(1414),
    [anon_sym_private] = ACTIONS(1414),
    [anon_sym_protected] = ACTIONS(1414),
    [anon_sym_override] = ACTIONS(1414),
    [anon_sym_module] = ACTIONS(1414),
    [anon_sym_any] = ACTIONS(1414),
    [anon_sym_number] = ACTIONS(1414),
    [anon_sym_boolean] = ACTIONS(1414),
    [anon_sym_string] = ACTIONS(1414),
    [anon_sym_symbol] = ACTIONS(1414),
    [anon_sym_abstract] = ACTIONS(1414),
    [anon_sym_interface] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [sym__automatic_semicolon] = ACTIONS(1420),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_export] = ACTIONS(1444),
    [anon_sym_default] = ACTIONS(1444),
    [anon_sym_type] = ACTIONS(1444),
    [anon_sym_namespace] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_typeof] = ACTIONS(1444),
    [anon_sym_import] = ACTIONS(1444),
    [anon_sym_var] = ACTIONS(1444),
    [anon_sym_let] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_else] = ACTIONS(1444),
    [anon_sym_if] = ACTIONS(1444),
    [anon_sym_switch] = ACTIONS(1444),
    [anon_sym_for] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [anon_sym_await] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_do] = ACTIONS(1444),
    [anon_sym_try] = ACTIONS(1444),
    [anon_sym_with] = ACTIONS(1444),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1444),
    [anon_sym_debugger] = ACTIONS(1444),
    [anon_sym_return] = ACTIONS(1444),
    [anon_sym_throw] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_case] = ACTIONS(1444),
    [anon_sym_yield] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1442),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_class] = ACTIONS(1444),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_function] = ACTIONS(1444),
    [anon_sym_new] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_void] = ACTIONS(1444),
    [anon_sym_delete] = ACTIONS(1444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1442),
    [sym_number] = ACTIONS(1442),
    [sym_this] = ACTIONS(1444),
    [sym_super] = ACTIONS(1444),
    [sym_true] = ACTIONS(1444),
    [sym_false] = ACTIONS(1444),
    [sym_null] = ACTIONS(1444),
    [sym_undefined] = ACTIONS(1444),
    [anon_sym_AT] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_readonly] = ACTIONS(1444),
    [anon_sym_get] = ACTIONS(1444),
    [anon_sym_set] = ACTIONS(1444),
    [anon_sym_declare] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1444),
    [anon_sym_private] = ACTIONS(1444),
    [anon_sym_protected] = ACTIONS(1444),
    [anon_sym_override] = ACTIONS(1444),
    [anon_sym_module] = ACTIONS(1444),
    [anon_sym_any] = ACTIONS(1444),
    [anon_sym_number] = ACTIONS(1444),
    [anon_sym_boolean] = ACTIONS(1444),
    [anon_sym_string] = ACTIONS(1444),
    [anon_sym_symbol] = ACTIONS(1444),
    [anon_sym_abstract] = ACTIONS(1444),
    [anon_sym_interface] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [sym__automatic_semicolon] = ACTIONS(1450),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(2046),
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_export] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2048),
    [anon_sym_type] = ACTIONS(2048),
    [anon_sym_namespace] = ACTIONS(2048),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_RBRACE] = ACTIONS(2046),
    [anon_sym_typeof] = ACTIONS(2048),
    [anon_sym_import] = ACTIONS(2048),
    [anon_sym_var] = ACTIONS(2048),
    [anon_sym_let] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_else] = ACTIONS(2048),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2048),
    [anon_sym_for] = ACTIONS(2048),
    [anon_sym_LPAREN] = ACTIONS(2046),
    [anon_sym_RPAREN] = ACTIONS(2046),
    [anon_sym_await] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2048),
    [anon_sym_do] = ACTIONS(2048),
    [anon_sym_try] = ACTIONS(2048),
    [anon_sym_with] = ACTIONS(2048),
    [anon_sym_break] = ACTIONS(2048),
    [anon_sym_continue] = ACTIONS(2048),
    [anon_sym_debugger] = ACTIONS(2048),
    [anon_sym_return] = ACTIONS(2048),
    [anon_sym_throw] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_yield] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(2046),
    [anon_sym_LT] = ACTIONS(2046),
    [anon_sym_SLASH] = ACTIONS(2048),
    [anon_sym_class] = ACTIONS(2048),
    [anon_sym_async] = ACTIONS(2048),
    [anon_sym_function] = ACTIONS(2048),
    [anon_sym_new] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_void] = ACTIONS(2048),
    [anon_sym_delete] = ACTIONS(2048),
    [anon_sym_PLUS_PLUS] = ACTIONS(2046),
    [anon_sym_DASH_DASH] = ACTIONS(2046),
    [anon_sym_DQUOTE] = ACTIONS(2046),
    [anon_sym_SQUOTE] = ACTIONS(2046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2046),
    [sym_number] = ACTIONS(2046),
    [sym_this] = ACTIONS(2048),
    [sym_super] = ACTIONS(2048),
    [sym_true] = ACTIONS(2048),
    [sym_false] = ACTIONS(2048),
    [sym_null] = ACTIONS(2048),
    [sym_undefined] = ACTIONS(2048),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_readonly] = ACTIONS(2048),
    [anon_sym_get] = ACTIONS(2048),
    [anon_sym_set] = ACTIONS(2048),
    [anon_sym_declare] = ACTIONS(2048),
    [anon_sym_public] = ACTIONS(2048),
    [anon_sym_private] = ACTIONS(2048),
    [anon_sym_protected] = ACTIONS(2048),
    [anon_sym_override] = ACTIONS(2048),
    [anon_sym_module] = ACTIONS(2048),
    [anon_sym_any] = ACTIONS(2048),
    [anon_sym_number] = ACTIONS(2048),
    [anon_sym_boolean] = ACTIONS(2048),
    [anon_sym_string] = ACTIONS(2048),
    [anon_sym_symbol] = ACTIONS(2048),
    [anon_sym_abstract] = ACTIONS(2048),
    [anon_sym_interface] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(1334),
    [sym_identifier] = ACTIONS(1336),
    [anon_sym_export] = ACTIONS(1336),
    [anon_sym_default] = ACTIONS(1336),
    [anon_sym_type] = ACTIONS(1336),
    [anon_sym_namespace] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [anon_sym_typeof] = ACTIONS(1336),
    [anon_sym_import] = ACTIONS(1336),
    [anon_sym_var] = ACTIONS(1336),
    [anon_sym_let] = ACTIONS(1336),
    [anon_sym_const] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1336),
    [anon_sym_if] = ACTIONS(1336),
    [anon_sym_switch] = ACTIONS(1336),
    [anon_sym_for] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_await] = ACTIONS(1336),
    [anon_sym_while] = ACTIONS(1336),
    [anon_sym_do] = ACTIONS(1336),
    [anon_sym_try] = ACTIONS(1336),
    [anon_sym_with] = ACTIONS(1336),
    [anon_sym_break] = ACTIONS(1336),
    [anon_sym_continue] = ACTIONS(1336),
    [anon_sym_debugger] = ACTIONS(1336),
    [anon_sym_return] = ACTIONS(1336),
    [anon_sym_throw] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(1334),
    [anon_sym_SLASH] = ACTIONS(1336),
    [anon_sym_class] = ACTIONS(1336),
    [anon_sym_async] = ACTIONS(1336),
    [anon_sym_function] = ACTIONS(1336),
    [anon_sym_new] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1334),
    [anon_sym_void] = ACTIONS(1336),
    [anon_sym_delete] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1334),
    [anon_sym_DQUOTE] = ACTIONS(1334),
    [anon_sym_SQUOTE] = ACTIONS(1334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1334),
    [sym_number] = ACTIONS(1334),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(1336),
    [sym_true] = ACTIONS(1336),
    [sym_false] = ACTIONS(1336),
    [sym_null] = ACTIONS(1336),
    [sym_undefined] = ACTIONS(1336),
    [anon_sym_AT] = ACTIONS(1334),
    [anon_sym_static] = ACTIONS(1336),
    [anon_sym_readonly] = ACTIONS(1336),
    [anon_sym_get] = ACTIONS(1336),
    [anon_sym_set] = ACTIONS(1336),
    [anon_sym_declare] = ACTIONS(1336),
    [anon_sym_public] = ACTIONS(1336),
    [anon_sym_private] = ACTIONS(1336),
    [anon_sym_protected] = ACTIONS(1336),
    [anon_sym_override] = ACTIONS(1336),
    [anon_sym_module] = ACTIONS(1336),
    [anon_sym_any] = ACTIONS(1336),
    [anon_sym_number] = ACTIONS(1336),
    [anon_sym_boolean] = ACTIONS(1336),
    [anon_sym_string] = ACTIONS(1336),
    [anon_sym_symbol] = ACTIONS(1336),
    [anon_sym_abstract] = ACTIONS(1336),
    [anon_sym_interface] = ACTIONS(1336),
    [anon_sym_enum] = ACTIONS(1336),
    [sym__automatic_semicolon] = ACTIONS(1342),
  },
  [609] = {
    [ts_builtin_sym_end] = ACTIONS(2050),
    [sym_identifier] = ACTIONS(2052),
    [anon_sym_export] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2052),
    [anon_sym_type] = ACTIONS(2052),
    [anon_sym_namespace] = ACTIONS(2052),
    [anon_sym_LBRACE] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [anon_sym_typeof] = ACTIONS(2052),
    [anon_sym_import] = ACTIONS(2052),
    [anon_sym_var] = ACTIONS(2052),
    [anon_sym_let] = ACTIONS(2052),
    [anon_sym_const] = ACTIONS(2052),
    [anon_sym_BANG] = ACTIONS(2050),
    [anon_sym_else] = ACTIONS(2052),
    [anon_sym_if] = ACTIONS(2052),
    [anon_sym_switch] = ACTIONS(2052),
    [anon_sym_for] = ACTIONS(2052),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_await] = ACTIONS(2052),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2052),
    [anon_sym_try] = ACTIONS(2052),
    [anon_sym_with] = ACTIONS(2052),
    [anon_sym_break] = ACTIONS(2052),
    [anon_sym_continue] = ACTIONS(2052),
    [anon_sym_debugger] = ACTIONS(2052),
    [anon_sym_return] = ACTIONS(2052),
    [anon_sym_throw] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_finally] = ACTIONS(2052),
    [anon_sym_yield] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2052),
    [anon_sym_class] = ACTIONS(2052),
    [anon_sym_async] = ACTIONS(2052),
    [anon_sym_function] = ACTIONS(2052),
    [anon_sym_new] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2052),
    [anon_sym_DASH] = ACTIONS(2052),
    [anon_sym_TILDE] = ACTIONS(2050),
    [anon_sym_void] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2052),
    [anon_sym_PLUS_PLUS] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2050),
    [anon_sym_DQUOTE] = ACTIONS(2050),
    [anon_sym_SQUOTE] = ACTIONS(2050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2050),
    [sym_number] = ACTIONS(2050),
    [sym_this] = ACTIONS(2052),
    [sym_super] = ACTIONS(2052),
    [sym_true] = ACTIONS(2052),
    [sym_false] = ACTIONS(2052),
    [sym_null] = ACTIONS(2052),
    [sym_undefined] = ACTIONS(2052),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_static] = ACTIONS(2052),
    [anon_sym_readonly] = ACTIONS(2052),
    [anon_sym_get] = ACTIONS(2052),
    [anon_sym_set] = ACTIONS(2052),
    [anon_sym_declare] = ACTIONS(2052),
    [anon_sym_public] = ACTIONS(2052),
    [anon_sym_private] = ACTIONS(2052),
    [anon_sym_protected] = ACTIONS(2052),
    [anon_sym_override] = ACTIONS(2052),
    [anon_sym_module] = ACTIONS(2052),
    [anon_sym_any] = ACTIONS(2052),
    [anon_sym_number] = ACTIONS(2052),
    [anon_sym_boolean] = ACTIONS(2052),
    [anon_sym_string] = ACTIONS(2052),
    [anon_sym_symbol] = ACTIONS(2052),
    [anon_sym_abstract] = ACTIONS(2052),
    [anon_sym_interface] = ACTIONS(2052),
    [anon_sym_enum] = ACTIONS(2052),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(1366),
    [sym_identifier] = ACTIONS(1368),
    [anon_sym_export] = ACTIONS(1368),
    [anon_sym_default] = ACTIONS(1368),
    [anon_sym_type] = ACTIONS(1368),
    [anon_sym_namespace] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [anon_sym_typeof] = ACTIONS(1368),
    [anon_sym_import] = ACTIONS(1368),
    [anon_sym_var] = ACTIONS(1368),
    [anon_sym_let] = ACTIONS(1368),
    [anon_sym_const] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1366),
    [anon_sym_else] = ACTIONS(1368),
    [anon_sym_if] = ACTIONS(1368),
    [anon_sym_switch] = ACTIONS(1368),
    [anon_sym_for] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_await] = ACTIONS(1368),
    [anon_sym_while] = ACTIONS(1368),
    [anon_sym_do] = ACTIONS(1368),
    [anon_sym_try] = ACTIONS(1368),
    [anon_sym_with] = ACTIONS(1368),
    [anon_sym_break] = ACTIONS(1368),
    [anon_sym_continue] = ACTIONS(1368),
    [anon_sym_debugger] = ACTIONS(1368),
    [anon_sym_return] = ACTIONS(1368),
    [anon_sym_throw] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1366),
    [anon_sym_case] = ACTIONS(1368),
    [anon_sym_yield] = ACTIONS(1368),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_SLASH] = ACTIONS(1368),
    [anon_sym_class] = ACTIONS(1368),
    [anon_sym_async] = ACTIONS(1368),
    [anon_sym_function] = ACTIONS(1368),
    [anon_sym_new] = ACTIONS(1368),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_TILDE] = ACTIONS(1366),
    [anon_sym_void] = ACTIONS(1368),
    [anon_sym_delete] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [sym_number] = ACTIONS(1366),
    [sym_this] = ACTIONS(1368),
    [sym_super] = ACTIONS(1368),
    [sym_true] = ACTIONS(1368),
    [sym_false] = ACTIONS(1368),
    [sym_null] = ACTIONS(1368),
    [sym_undefined] = ACTIONS(1368),
    [anon_sym_AT] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_readonly] = ACTIONS(1368),
    [anon_sym_get] = ACTIONS(1368),
    [anon_sym_set] = ACTIONS(1368),
    [anon_sym_declare] = ACTIONS(1368),
    [anon_sym_public] = ACTIONS(1368),
    [anon_sym_private] = ACTIONS(1368),
    [anon_sym_protected] = ACTIONS(1368),
    [anon_sym_override] = ACTIONS(1368),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_any] = ACTIONS(1368),
    [anon_sym_number] = ACTIONS(1368),
    [anon_sym_boolean] = ACTIONS(1368),
    [anon_sym_string] = ACTIONS(1368),
    [anon_sym_symbol] = ACTIONS(1368),
    [anon_sym_abstract] = ACTIONS(1368),
    [anon_sym_interface] = ACTIONS(1368),
    [anon_sym_enum] = ACTIONS(1368),
    [sym__automatic_semicolon] = ACTIONS(1374),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(1388),
    [sym_identifier] = ACTIONS(1390),
    [anon_sym_export] = ACTIONS(1390),
    [anon_sym_default] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(1390),
    [anon_sym_namespace] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_RBRACE] = ACTIONS(1388),
    [anon_sym_typeof] = ACTIONS(1390),
    [anon_sym_import] = ACTIONS(1390),
    [anon_sym_var] = ACTIONS(1390),
    [anon_sym_let] = ACTIONS(1390),
    [anon_sym_const] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_else] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_switch] = ACTIONS(1390),
    [anon_sym_for] = ACTIONS(1390),
    [anon_sym_LPAREN] = ACTIONS(1388),
    [anon_sym_await] = ACTIONS(1390),
    [anon_sym_while] = ACTIONS(1390),
    [anon_sym_do] = ACTIONS(1390),
    [anon_sym_try] = ACTIONS(1390),
    [anon_sym_with] = ACTIONS(1390),
    [anon_sym_break] = ACTIONS(1390),
    [anon_sym_continue] = ACTIONS(1390),
    [anon_sym_debugger] = ACTIONS(1390),
    [anon_sym_return] = ACTIONS(1390),
    [anon_sym_throw] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym_case] = ACTIONS(1390),
    [anon_sym_yield] = ACTIONS(1390),
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_LT] = ACTIONS(1388),
    [anon_sym_SLASH] = ACTIONS(1390),
    [anon_sym_class] = ACTIONS(1390),
    [anon_sym_async] = ACTIONS(1390),
    [anon_sym_function] = ACTIONS(1390),
    [anon_sym_new] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_TILDE] = ACTIONS(1388),
    [anon_sym_void] = ACTIONS(1390),
    [anon_sym_delete] = ACTIONS(1390),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [anon_sym_DQUOTE] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1388),
    [sym_number] = ACTIONS(1388),
    [sym_this] = ACTIONS(1390),
    [sym_super] = ACTIONS(1390),
    [sym_true] = ACTIONS(1390),
    [sym_false] = ACTIONS(1390),
    [sym_null] = ACTIONS(1390),
    [sym_undefined] = ACTIONS(1390),
    [anon_sym_AT] = ACTIONS(1388),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_readonly] = ACTIONS(1390),
    [anon_sym_get] = ACTIONS(1390),
    [anon_sym_set] = ACTIONS(1390),
    [anon_sym_declare] = ACTIONS(1390),
    [anon_sym_public] = ACTIONS(1390),
    [anon_sym_private] = ACTIONS(1390),
    [anon_sym_protected] = ACTIONS(1390),
    [anon_sym_override] = ACTIONS(1390),
    [anon_sym_module] = ACTIONS(1390),
    [anon_sym_any] = ACTIONS(1390),
    [anon_sym_number] = ACTIONS(1390),
    [anon_sym_boolean] = ACTIONS(1390),
    [anon_sym_string] = ACTIONS(1390),
    [anon_sym_symbol] = ACTIONS(1390),
    [anon_sym_abstract] = ACTIONS(1390),
    [anon_sym_interface] = ACTIONS(1390),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(1396),
  },
  [612] = {
    [sym__call_signature] = STATE(4019),
    [sym_formal_parameters] = STATE(2972),
    [sym_type_parameters] = STATE(3761),
    [sym_identifier] = ACTIONS(1962),
    [anon_sym_export] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1964),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(1964),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_readonly] = ACTIONS(1964),
    [anon_sym_get] = ACTIONS(1964),
    [anon_sym_set] = ACTIONS(1964),
    [anon_sym_declare] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_override] = ACTIONS(1964),
    [anon_sym_module] = ACTIONS(1964),
    [anon_sym_any] = ACTIONS(1964),
    [anon_sym_number] = ACTIONS(1964),
    [anon_sym_boolean] = ACTIONS(1964),
    [anon_sym_string] = ACTIONS(1964),
    [anon_sym_symbol] = ACTIONS(1964),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(1470),
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_export] = ACTIONS(1472),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_type] = ACTIONS(1472),
    [anon_sym_namespace] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_RBRACE] = ACTIONS(1470),
    [anon_sym_typeof] = ACTIONS(1472),
    [anon_sym_import] = ACTIONS(1472),
    [anon_sym_var] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_try] = ACTIONS(1472),
    [anon_sym_with] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_debugger] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_throw] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1470),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1472),
    [anon_sym_class] = ACTIONS(1472),
    [anon_sym_async] = ACTIONS(1472),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_new] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1472),
    [anon_sym_delete] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1470),
    [sym_number] = ACTIONS(1470),
    [sym_this] = ACTIONS(1472),
    [sym_super] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_undefined] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(1470),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_readonly] = ACTIONS(1472),
    [anon_sym_get] = ACTIONS(1472),
    [anon_sym_set] = ACTIONS(1472),
    [anon_sym_declare] = ACTIONS(1472),
    [anon_sym_public] = ACTIONS(1472),
    [anon_sym_private] = ACTIONS(1472),
    [anon_sym_protected] = ACTIONS(1472),
    [anon_sym_override] = ACTIONS(1472),
    [anon_sym_module] = ACTIONS(1472),
    [anon_sym_any] = ACTIONS(1472),
    [anon_sym_number] = ACTIONS(1472),
    [anon_sym_boolean] = ACTIONS(1472),
    [anon_sym_string] = ACTIONS(1472),
    [anon_sym_symbol] = ACTIONS(1472),
    [anon_sym_abstract] = ACTIONS(1472),
    [anon_sym_interface] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [sym__automatic_semicolon] = ACTIONS(1478),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_type] = ACTIONS(2056),
    [anon_sym_namespace] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_typeof] = ACTIONS(2056),
    [anon_sym_import] = ACTIONS(2056),
    [anon_sym_var] = ACTIONS(2056),
    [anon_sym_let] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_LPAREN] = ACTIONS(2054),
    [anon_sym_await] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_with] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_debugger] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2056),
    [anon_sym_finally] = ACTIONS(2056),
    [anon_sym_yield] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(2054),
    [anon_sym_SLASH] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_async] = ACTIONS(2056),
    [anon_sym_function] = ACTIONS(2056),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_void] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2054),
    [sym_number] = ACTIONS(2054),
    [sym_this] = ACTIONS(2056),
    [sym_super] = ACTIONS(2056),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [sym_null] = ACTIONS(2056),
    [sym_undefined] = ACTIONS(2056),
    [anon_sym_AT] = ACTIONS(2054),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_readonly] = ACTIONS(2056),
    [anon_sym_get] = ACTIONS(2056),
    [anon_sym_set] = ACTIONS(2056),
    [anon_sym_declare] = ACTIONS(2056),
    [anon_sym_public] = ACTIONS(2056),
    [anon_sym_private] = ACTIONS(2056),
    [anon_sym_protected] = ACTIONS(2056),
    [anon_sym_override] = ACTIONS(2056),
    [anon_sym_module] = ACTIONS(2056),
    [anon_sym_any] = ACTIONS(2056),
    [anon_sym_number] = ACTIONS(2056),
    [anon_sym_boolean] = ACTIONS(2056),
    [anon_sym_string] = ACTIONS(2056),
    [anon_sym_symbol] = ACTIONS(2056),
    [anon_sym_abstract] = ACTIONS(2056),
    [anon_sym_interface] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(1402),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_export] = ACTIONS(1404),
    [anon_sym_default] = ACTIONS(1404),
    [anon_sym_type] = ACTIONS(1404),
    [anon_sym_namespace] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1402),
    [anon_sym_RBRACE] = ACTIONS(1402),
    [anon_sym_typeof] = ACTIONS(1404),
    [anon_sym_import] = ACTIONS(1404),
    [anon_sym_var] = ACTIONS(1404),
    [anon_sym_let] = ACTIONS(1404),
    [anon_sym_const] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1402),
    [anon_sym_else] = ACTIONS(1404),
    [anon_sym_if] = ACTIONS(1404),
    [anon_sym_switch] = ACTIONS(1404),
    [anon_sym_for] = ACTIONS(1404),
    [anon_sym_LPAREN] = ACTIONS(1402),
    [anon_sym_await] = ACTIONS(1404),
    [anon_sym_while] = ACTIONS(1404),
    [anon_sym_do] = ACTIONS(1404),
    [anon_sym_try] = ACTIONS(1404),
    [anon_sym_with] = ACTIONS(1404),
    [anon_sym_break] = ACTIONS(1404),
    [anon_sym_continue] = ACTIONS(1404),
    [anon_sym_debugger] = ACTIONS(1404),
    [anon_sym_return] = ACTIONS(1404),
    [anon_sym_throw] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_case] = ACTIONS(1404),
    [anon_sym_yield] = ACTIONS(1404),
    [anon_sym_LBRACK] = ACTIONS(1402),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_SLASH] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(1404),
    [anon_sym_async] = ACTIONS(1404),
    [anon_sym_function] = ACTIONS(1404),
    [anon_sym_new] = ACTIONS(1404),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_TILDE] = ACTIONS(1402),
    [anon_sym_void] = ACTIONS(1404),
    [anon_sym_delete] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1402),
    [anon_sym_DASH_DASH] = ACTIONS(1402),
    [anon_sym_DQUOTE] = ACTIONS(1402),
    [anon_sym_SQUOTE] = ACTIONS(1402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1402),
    [sym_number] = ACTIONS(1402),
    [sym_this] = ACTIONS(1404),
    [sym_super] = ACTIONS(1404),
    [sym_true] = ACTIONS(1404),
    [sym_false] = ACTIONS(1404),
    [sym_null] = ACTIONS(1404),
    [sym_undefined] = ACTIONS(1404),
    [anon_sym_AT] = ACTIONS(1402),
    [anon_sym_static] = ACTIONS(1404),
    [anon_sym_readonly] = ACTIONS(1404),
    [anon_sym_get] = ACTIONS(1404),
    [anon_sym_set] = ACTIONS(1404),
    [anon_sym_declare] = ACTIONS(1404),
    [anon_sym_public] = ACTIONS(1404),
    [anon_sym_private] = ACTIONS(1404),
    [anon_sym_protected] = ACTIONS(1404),
    [anon_sym_override] = ACTIONS(1404),
    [anon_sym_module] = ACTIONS(1404),
    [anon_sym_any] = ACTIONS(1404),
    [anon_sym_number] = ACTIONS(1404),
    [anon_sym_boolean] = ACTIONS(1404),
    [anon_sym_string] = ACTIONS(1404),
    [anon_sym_symbol] = ACTIONS(1404),
    [anon_sym_abstract] = ACTIONS(1404),
    [anon_sym_interface] = ACTIONS(1404),
    [anon_sym_enum] = ACTIONS(1404),
    [sym__automatic_semicolon] = ACTIONS(1410),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [sym_undefined] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_readonly] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_override] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
  },
  [617] = {
    [ts_builtin_sym_end] = ACTIONS(2062),
    [sym_identifier] = ACTIONS(2064),
    [anon_sym_export] = ACTIONS(2064),
    [anon_sym_default] = ACTIONS(2064),
    [anon_sym_type] = ACTIONS(2064),
    [anon_sym_namespace] = ACTIONS(2064),
    [anon_sym_LBRACE] = ACTIONS(2062),
    [anon_sym_RBRACE] = ACTIONS(2062),
    [anon_sym_typeof] = ACTIONS(2064),
    [anon_sym_import] = ACTIONS(2064),
    [anon_sym_var] = ACTIONS(2064),
    [anon_sym_let] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(2064),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_else] = ACTIONS(2064),
    [anon_sym_if] = ACTIONS(2064),
    [anon_sym_switch] = ACTIONS(2064),
    [anon_sym_for] = ACTIONS(2064),
    [anon_sym_LPAREN] = ACTIONS(2062),
    [anon_sym_await] = ACTIONS(2064),
    [anon_sym_while] = ACTIONS(2064),
    [anon_sym_do] = ACTIONS(2064),
    [anon_sym_try] = ACTIONS(2064),
    [anon_sym_with] = ACTIONS(2064),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2064),
    [anon_sym_debugger] = ACTIONS(2064),
    [anon_sym_return] = ACTIONS(2064),
    [anon_sym_throw] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2062),
    [anon_sym_case] = ACTIONS(2064),
    [anon_sym_yield] = ACTIONS(2064),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [anon_sym_LT] = ACTIONS(2062),
    [anon_sym_SLASH] = ACTIONS(2064),
    [anon_sym_class] = ACTIONS(2064),
    [anon_sym_async] = ACTIONS(2064),
    [anon_sym_function] = ACTIONS(2064),
    [anon_sym_new] = ACTIONS(2064),
    [anon_sym_PLUS] = ACTIONS(2064),
    [anon_sym_DASH] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2062),
    [anon_sym_void] = ACTIONS(2064),
    [anon_sym_delete] = ACTIONS(2064),
    [anon_sym_PLUS_PLUS] = ACTIONS(2062),
    [anon_sym_DASH_DASH] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [anon_sym_SQUOTE] = ACTIONS(2062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [sym_number] = ACTIONS(2062),
    [sym_this] = ACTIONS(2064),
    [sym_super] = ACTIONS(2064),
    [sym_true] = ACTIONS(2064),
    [sym_false] = ACTIONS(2064),
    [sym_null] = ACTIONS(2064),
    [sym_undefined] = ACTIONS(2064),
    [anon_sym_AT] = ACTIONS(2062),
    [anon_sym_static] = ACTIONS(2064),
    [anon_sym_readonly] = ACTIONS(2064),
    [anon_sym_get] = ACTIONS(2064),
    [anon_sym_set] = ACTIONS(2064),
    [anon_sym_declare] = ACTIONS(2064),
    [anon_sym_public] = ACTIONS(2064),
    [anon_sym_private] = ACTIONS(2064),
    [anon_sym_protected] = ACTIONS(2064),
    [anon_sym_override] = ACTIONS(2064),
    [anon_sym_module] = ACTIONS(2064),
    [anon_sym_any] = ACTIONS(2064),
    [anon_sym_number] = ACTIONS(2064),
    [anon_sym_boolean] = ACTIONS(2064),
    [anon_sym_string] = ACTIONS(2064),
    [anon_sym_symbol] = ACTIONS(2064),
    [anon_sym_abstract] = ACTIONS(2064),
    [anon_sym_interface] = ACTIONS(2064),
    [anon_sym_enum] = ACTIONS(2064),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(2068),
    [anon_sym_export] = ACTIONS(2068),
    [anon_sym_default] = ACTIONS(2068),
    [anon_sym_type] = ACTIONS(2068),
    [anon_sym_namespace] = ACTIONS(2068),
    [anon_sym_LBRACE] = ACTIONS(2066),
    [anon_sym_RBRACE] = ACTIONS(2066),
    [anon_sym_typeof] = ACTIONS(2068),
    [anon_sym_import] = ACTIONS(2068),
    [anon_sym_var] = ACTIONS(2068),
    [anon_sym_let] = ACTIONS(2068),
    [anon_sym_const] = ACTIONS(2068),
    [anon_sym_BANG] = ACTIONS(2066),
    [anon_sym_else] = ACTIONS(2068),
    [anon_sym_if] = ACTIONS(2068),
    [anon_sym_switch] = ACTIONS(2068),
    [anon_sym_for] = ACTIONS(2068),
    [anon_sym_LPAREN] = ACTIONS(2066),
    [anon_sym_await] = ACTIONS(2068),
    [anon_sym_while] = ACTIONS(2068),
    [anon_sym_do] = ACTIONS(2068),
    [anon_sym_try] = ACTIONS(2068),
    [anon_sym_with] = ACTIONS(2068),
    [anon_sym_break] = ACTIONS(2068),
    [anon_sym_continue] = ACTIONS(2068),
    [anon_sym_debugger] = ACTIONS(2068),
    [anon_sym_return] = ACTIONS(2068),
    [anon_sym_throw] = ACTIONS(2068),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_case] = ACTIONS(2068),
    [anon_sym_yield] = ACTIONS(2068),
    [anon_sym_LBRACK] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_SLASH] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2068),
    [anon_sym_async] = ACTIONS(2068),
    [anon_sym_function] = ACTIONS(2068),
    [anon_sym_new] = ACTIONS(2068),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_DASH] = ACTIONS(2068),
    [anon_sym_TILDE] = ACTIONS(2066),
    [anon_sym_void] = ACTIONS(2068),
    [anon_sym_delete] = ACTIONS(2068),
    [anon_sym_PLUS_PLUS] = ACTIONS(2066),
    [anon_sym_DASH_DASH] = ACTIONS(2066),
    [anon_sym_DQUOTE] = ACTIONS(2066),
    [anon_sym_SQUOTE] = ACTIONS(2066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2066),
    [sym_number] = ACTIONS(2066),
    [sym_this] = ACTIONS(2068),
    [sym_super] = ACTIONS(2068),
    [sym_true] = ACTIONS(2068),
    [sym_false] = ACTIONS(2068),
    [sym_null] = ACTIONS(2068),
    [sym_undefined] = ACTIONS(2068),
    [anon_sym_AT] = ACTIONS(2066),
    [anon_sym_static] = ACTIONS(2068),
    [anon_sym_readonly] = ACTIONS(2068),
    [anon_sym_get] = ACTIONS(2068),
    [anon_sym_set] = ACTIONS(2068),
    [anon_sym_declare] = ACTIONS(2068),
    [anon_sym_public] = ACTIONS(2068),
    [anon_sym_private] = ACTIONS(2068),
    [anon_sym_protected] = ACTIONS(2068),
    [anon_sym_override] = ACTIONS(2068),
    [anon_sym_module] = ACTIONS(2068),
    [anon_sym_any] = ACTIONS(2068),
    [anon_sym_number] = ACTIONS(2068),
    [anon_sym_boolean] = ACTIONS(2068),
    [anon_sym_string] = ACTIONS(2068),
    [anon_sym_symbol] = ACTIONS(2068),
    [anon_sym_abstract] = ACTIONS(2068),
    [anon_sym_interface] = ACTIONS(2068),
    [anon_sym_enum] = ACTIONS(2068),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(2070),
    [sym_identifier] = ACTIONS(2072),
    [anon_sym_export] = ACTIONS(2072),
    [anon_sym_default] = ACTIONS(2072),
    [anon_sym_type] = ACTIONS(2072),
    [anon_sym_namespace] = ACTIONS(2072),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_RBRACE] = ACTIONS(2070),
    [anon_sym_typeof] = ACTIONS(2072),
    [anon_sym_import] = ACTIONS(2072),
    [anon_sym_var] = ACTIONS(2072),
    [anon_sym_let] = ACTIONS(2072),
    [anon_sym_const] = ACTIONS(2072),
    [anon_sym_BANG] = ACTIONS(2070),
    [anon_sym_else] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2072),
    [anon_sym_switch] = ACTIONS(2072),
    [anon_sym_for] = ACTIONS(2072),
    [anon_sym_LPAREN] = ACTIONS(2070),
    [anon_sym_await] = ACTIONS(2072),
    [anon_sym_while] = ACTIONS(2072),
    [anon_sym_do] = ACTIONS(2072),
    [anon_sym_try] = ACTIONS(2072),
    [anon_sym_with] = ACTIONS(2072),
    [anon_sym_break] = ACTIONS(2072),
    [anon_sym_continue] = ACTIONS(2072),
    [anon_sym_debugger] = ACTIONS(2072),
    [anon_sym_return] = ACTIONS(2072),
    [anon_sym_throw] = ACTIONS(2072),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym_case] = ACTIONS(2072),
    [anon_sym_yield] = ACTIONS(2072),
    [anon_sym_LBRACK] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_SLASH] = ACTIONS(2072),
    [anon_sym_class] = ACTIONS(2072),
    [anon_sym_async] = ACTIONS(2072),
    [anon_sym_function] = ACTIONS(2072),
    [anon_sym_new] = ACTIONS(2072),
    [anon_sym_PLUS] = ACTIONS(2072),
    [anon_sym_DASH] = ACTIONS(2072),
    [anon_sym_TILDE] = ACTIONS(2070),
    [anon_sym_void] = ACTIONS(2072),
    [anon_sym_delete] = ACTIONS(2072),
    [anon_sym_PLUS_PLUS] = ACTIONS(2070),
    [anon_sym_DASH_DASH] = ACTIONS(2070),
    [anon_sym_DQUOTE] = ACTIONS(2070),
    [anon_sym_SQUOTE] = ACTIONS(2070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2070),
    [sym_number] = ACTIONS(2070),
    [sym_this] = ACTIONS(2072),
    [sym_super] = ACTIONS(2072),
    [sym_true] = ACTIONS(2072),
    [sym_false] = ACTIONS(2072),
    [sym_null] = ACTIONS(2072),
    [sym_undefined] = ACTIONS(2072),
    [anon_sym_AT] = ACTIONS(2070),
    [anon_sym_static] = ACTIONS(2072),
    [anon_sym_readonly] = ACTIONS(2072),
    [anon_sym_get] = ACTIONS(2072),
    [anon_sym_set] = ACTIONS(2072),
    [anon_sym_declare] = ACTIONS(2072),
    [anon_sym_public] = ACTIONS(2072),
    [anon_sym_private] = ACTIONS(2072),
    [anon_sym_protected] = ACTIONS(2072),
    [anon_sym_override] = ACTIONS(2072),
    [anon_sym_module] = ACTIONS(2072),
    [anon_sym_any] = ACTIONS(2072),
    [anon_sym_number] = ACTIONS(2072),
    [anon_sym_boolean] = ACTIONS(2072),
    [anon_sym_string] = ACTIONS(2072),
    [anon_sym_symbol] = ACTIONS(2072),
    [anon_sym_abstract] = ACTIONS(2072),
    [anon_sym_interface] = ACTIONS(2072),
    [anon_sym_enum] = ACTIONS(2072),
  },
  [620] = {
    [ts_builtin_sym_end] = ACTIONS(2074),
    [sym_identifier] = ACTIONS(2076),
    [anon_sym_export] = ACTIONS(2076),
    [anon_sym_default] = ACTIONS(2076),
    [anon_sym_type] = ACTIONS(2076),
    [anon_sym_namespace] = ACTIONS(2076),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_RBRACE] = ACTIONS(2074),
    [anon_sym_typeof] = ACTIONS(2076),
    [anon_sym_import] = ACTIONS(2076),
    [anon_sym_var] = ACTIONS(2076),
    [anon_sym_let] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_else] = ACTIONS(2076),
    [anon_sym_if] = ACTIONS(2076),
    [anon_sym_switch] = ACTIONS(2076),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_LPAREN] = ACTIONS(2074),
    [anon_sym_await] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2076),
    [anon_sym_do] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_with] = ACTIONS(2076),
    [anon_sym_break] = ACTIONS(2076),
    [anon_sym_continue] = ACTIONS(2076),
    [anon_sym_debugger] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2076),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_case] = ACTIONS(2076),
    [anon_sym_yield] = ACTIONS(2076),
    [anon_sym_LBRACK] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_SLASH] = ACTIONS(2076),
    [anon_sym_class] = ACTIONS(2076),
    [anon_sym_async] = ACTIONS(2076),
    [anon_sym_function] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_DASH] = ACTIONS(2076),
    [anon_sym_TILDE] = ACTIONS(2074),
    [anon_sym_void] = ACTIONS(2076),
    [anon_sym_delete] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2074),
    [anon_sym_DASH_DASH] = ACTIONS(2074),
    [anon_sym_DQUOTE] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2074),
    [sym_number] = ACTIONS(2074),
    [sym_this] = ACTIONS(2076),
    [sym_super] = ACTIONS(2076),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [sym_null] = ACTIONS(2076),
    [sym_undefined] = ACTIONS(2076),
    [anon_sym_AT] = ACTIONS(2074),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_readonly] = ACTIONS(2076),
    [anon_sym_get] = ACTIONS(2076),
    [anon_sym_set] = ACTIONS(2076),
    [anon_sym_declare] = ACTIONS(2076),
    [anon_sym_public] = ACTIONS(2076),
    [anon_sym_private] = ACTIONS(2076),
    [anon_sym_protected] = ACTIONS(2076),
    [anon_sym_override] = ACTIONS(2076),
    [anon_sym_module] = ACTIONS(2076),
    [anon_sym_any] = ACTIONS(2076),
    [anon_sym_number] = ACTIONS(2076),
    [anon_sym_boolean] = ACTIONS(2076),
    [anon_sym_string] = ACTIONS(2076),
    [anon_sym_symbol] = ACTIONS(2076),
    [anon_sym_abstract] = ACTIONS(2076),
    [anon_sym_interface] = ACTIONS(2076),
    [anon_sym_enum] = ACTIONS(2076),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(2078),
    [sym_identifier] = ACTIONS(2080),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_default] = ACTIONS(2080),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_LBRACE] = ACTIONS(2078),
    [anon_sym_RBRACE] = ACTIONS(2078),
    [anon_sym_typeof] = ACTIONS(2080),
    [anon_sym_import] = ACTIONS(2080),
    [anon_sym_var] = ACTIONS(2080),
    [anon_sym_let] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2078),
    [anon_sym_else] = ACTIONS(2080),
    [anon_sym_if] = ACTIONS(2080),
    [anon_sym_switch] = ACTIONS(2080),
    [anon_sym_for] = ACTIONS(2080),
    [anon_sym_LPAREN] = ACTIONS(2078),
    [anon_sym_await] = ACTIONS(2080),
    [anon_sym_while] = ACTIONS(2080),
    [anon_sym_do] = ACTIONS(2080),
    [anon_sym_try] = ACTIONS(2080),
    [anon_sym_with] = ACTIONS(2080),
    [anon_sym_break] = ACTIONS(2080),
    [anon_sym_continue] = ACTIONS(2080),
    [anon_sym_debugger] = ACTIONS(2080),
    [anon_sym_return] = ACTIONS(2080),
    [anon_sym_throw] = ACTIONS(2080),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_case] = ACTIONS(2080),
    [anon_sym_yield] = ACTIONS(2080),
    [anon_sym_LBRACK] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_SLASH] = ACTIONS(2080),
    [anon_sym_class] = ACTIONS(2080),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2080),
    [anon_sym_new] = ACTIONS(2080),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_DASH] = ACTIONS(2080),
    [anon_sym_TILDE] = ACTIONS(2078),
    [anon_sym_void] = ACTIONS(2080),
    [anon_sym_delete] = ACTIONS(2080),
    [anon_sym_PLUS_PLUS] = ACTIONS(2078),
    [anon_sym_DASH_DASH] = ACTIONS(2078),
    [anon_sym_DQUOTE] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2078),
    [sym_number] = ACTIONS(2078),
    [sym_this] = ACTIONS(2080),
    [sym_super] = ACTIONS(2080),
    [sym_true] = ACTIONS(2080),
    [sym_false] = ACTIONS(2080),
    [sym_null] = ACTIONS(2080),
    [sym_undefined] = ACTIONS(2080),
    [anon_sym_AT] = ACTIONS(2078),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_override] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [anon_sym_abstract] = ACTIONS(2080),
    [anon_sym_interface] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
  },
  [622] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [623] = {
    [ts_builtin_sym_end] = ACTIONS(2086),
    [sym_identifier] = ACTIONS(2088),
    [anon_sym_export] = ACTIONS(2088),
    [anon_sym_default] = ACTIONS(2088),
    [anon_sym_type] = ACTIONS(2088),
    [anon_sym_namespace] = ACTIONS(2088),
    [anon_sym_LBRACE] = ACTIONS(2086),
    [anon_sym_RBRACE] = ACTIONS(2086),
    [anon_sym_typeof] = ACTIONS(2088),
    [anon_sym_import] = ACTIONS(2088),
    [anon_sym_var] = ACTIONS(2088),
    [anon_sym_let] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(2088),
    [anon_sym_BANG] = ACTIONS(2086),
    [anon_sym_else] = ACTIONS(2088),
    [anon_sym_if] = ACTIONS(2088),
    [anon_sym_switch] = ACTIONS(2088),
    [anon_sym_for] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(2086),
    [anon_sym_await] = ACTIONS(2088),
    [anon_sym_while] = ACTIONS(2088),
    [anon_sym_do] = ACTIONS(2088),
    [anon_sym_try] = ACTIONS(2088),
    [anon_sym_with] = ACTIONS(2088),
    [anon_sym_break] = ACTIONS(2088),
    [anon_sym_continue] = ACTIONS(2088),
    [anon_sym_debugger] = ACTIONS(2088),
    [anon_sym_return] = ACTIONS(2088),
    [anon_sym_throw] = ACTIONS(2088),
    [anon_sym_SEMI] = ACTIONS(2086),
    [anon_sym_case] = ACTIONS(2088),
    [anon_sym_yield] = ACTIONS(2088),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_LT] = ACTIONS(2086),
    [anon_sym_SLASH] = ACTIONS(2088),
    [anon_sym_class] = ACTIONS(2088),
    [anon_sym_async] = ACTIONS(2088),
    [anon_sym_function] = ACTIONS(2088),
    [anon_sym_new] = ACTIONS(2088),
    [anon_sym_PLUS] = ACTIONS(2088),
    [anon_sym_DASH] = ACTIONS(2088),
    [anon_sym_TILDE] = ACTIONS(2086),
    [anon_sym_void] = ACTIONS(2088),
    [anon_sym_delete] = ACTIONS(2088),
    [anon_sym_PLUS_PLUS] = ACTIONS(2086),
    [anon_sym_DASH_DASH] = ACTIONS(2086),
    [anon_sym_DQUOTE] = ACTIONS(2086),
    [anon_sym_SQUOTE] = ACTIONS(2086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2086),
    [sym_number] = ACTIONS(2086),
    [sym_this] = ACTIONS(2088),
    [sym_super] = ACTIONS(2088),
    [sym_true] = ACTIONS(2088),
    [sym_false] = ACTIONS(2088),
    [sym_null] = ACTIONS(2088),
    [sym_undefined] = ACTIONS(2088),
    [anon_sym_AT] = ACTIONS(2086),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_readonly] = ACTIONS(2088),
    [anon_sym_get] = ACTIONS(2088),
    [anon_sym_set] = ACTIONS(2088),
    [anon_sym_declare] = ACTIONS(2088),
    [anon_sym_public] = ACTIONS(2088),
    [anon_sym_private] = ACTIONS(2088),
    [anon_sym_protected] = ACTIONS(2088),
    [anon_sym_override] = ACTIONS(2088),
    [anon_sym_module] = ACTIONS(2088),
    [anon_sym_any] = ACTIONS(2088),
    [anon_sym_number] = ACTIONS(2088),
    [anon_sym_boolean] = ACTIONS(2088),
    [anon_sym_string] = ACTIONS(2088),
    [anon_sym_symbol] = ACTIONS(2088),
    [anon_sym_abstract] = ACTIONS(2088),
    [anon_sym_interface] = ACTIONS(2088),
    [anon_sym_enum] = ACTIONS(2088),
  },
  [624] = {
    [ts_builtin_sym_end] = ACTIONS(1452),
    [sym_identifier] = ACTIONS(1454),
    [anon_sym_export] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_type] = ACTIONS(1454),
    [anon_sym_namespace] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [anon_sym_typeof] = ACTIONS(1454),
    [anon_sym_import] = ACTIONS(1454),
    [anon_sym_var] = ACTIONS(1454),
    [anon_sym_let] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_else] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(1452),
    [anon_sym_await] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_try] = ACTIONS(1454),
    [anon_sym_with] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_debugger] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_throw] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_yield] = ACTIONS(1454),
    [anon_sym_LBRACK] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1454),
    [anon_sym_class] = ACTIONS(1454),
    [anon_sym_async] = ACTIONS(1454),
    [anon_sym_function] = ACTIONS(1454),
    [anon_sym_new] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_void] = ACTIONS(1454),
    [anon_sym_delete] = ACTIONS(1454),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1452),
    [sym_number] = ACTIONS(1452),
    [sym_this] = ACTIONS(1454),
    [sym_super] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_undefined] = ACTIONS(1454),
    [anon_sym_AT] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_readonly] = ACTIONS(1454),
    [anon_sym_get] = ACTIONS(1454),
    [anon_sym_set] = ACTIONS(1454),
    [anon_sym_declare] = ACTIONS(1454),
    [anon_sym_public] = ACTIONS(1454),
    [anon_sym_private] = ACTIONS(1454),
    [anon_sym_protected] = ACTIONS(1454),
    [anon_sym_override] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_any] = ACTIONS(1454),
    [anon_sym_number] = ACTIONS(1454),
    [anon_sym_boolean] = ACTIONS(1454),
    [anon_sym_string] = ACTIONS(1454),
    [anon_sym_symbol] = ACTIONS(1454),
    [anon_sym_abstract] = ACTIONS(1454),
    [anon_sym_interface] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
  },
  [625] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [626] = {
    [ts_builtin_sym_end] = ACTIONS(2090),
    [sym_identifier] = ACTIONS(2092),
    [anon_sym_export] = ACTIONS(2092),
    [anon_sym_default] = ACTIONS(2092),
    [anon_sym_type] = ACTIONS(2092),
    [anon_sym_namespace] = ACTIONS(2092),
    [anon_sym_LBRACE] = ACTIONS(2090),
    [anon_sym_RBRACE] = ACTIONS(2090),
    [anon_sym_typeof] = ACTIONS(2092),
    [anon_sym_import] = ACTIONS(2092),
    [anon_sym_var] = ACTIONS(2092),
    [anon_sym_let] = ACTIONS(2092),
    [anon_sym_const] = ACTIONS(2092),
    [anon_sym_BANG] = ACTIONS(2090),
    [anon_sym_else] = ACTIONS(2092),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(2092),
    [anon_sym_for] = ACTIONS(2092),
    [anon_sym_LPAREN] = ACTIONS(2090),
    [anon_sym_await] = ACTIONS(2092),
    [anon_sym_while] = ACTIONS(2092),
    [anon_sym_do] = ACTIONS(2092),
    [anon_sym_try] = ACTIONS(2092),
    [anon_sym_with] = ACTIONS(2092),
    [anon_sym_break] = ACTIONS(2092),
    [anon_sym_continue] = ACTIONS(2092),
    [anon_sym_debugger] = ACTIONS(2092),
    [anon_sym_return] = ACTIONS(2092),
    [anon_sym_throw] = ACTIONS(2092),
    [anon_sym_SEMI] = ACTIONS(2090),
    [anon_sym_case] = ACTIONS(2092),
    [anon_sym_yield] = ACTIONS(2092),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_LT] = ACTIONS(2090),
    [anon_sym_SLASH] = ACTIONS(2092),
    [anon_sym_class] = ACTIONS(2092),
    [anon_sym_async] = ACTIONS(2092),
    [anon_sym_function] = ACTIONS(2092),
    [anon_sym_new] = ACTIONS(2092),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_DASH] = ACTIONS(2092),
    [anon_sym_TILDE] = ACTIONS(2090),
    [anon_sym_void] = ACTIONS(2092),
    [anon_sym_delete] = ACTIONS(2092),
    [anon_sym_PLUS_PLUS] = ACTIONS(2090),
    [anon_sym_DASH_DASH] = ACTIONS(2090),
    [anon_sym_DQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2090),
    [sym_number] = ACTIONS(2090),
    [sym_this] = ACTIONS(2092),
    [sym_super] = ACTIONS(2092),
    [sym_true] = ACTIONS(2092),
    [sym_false] = ACTIONS(2092),
    [sym_null] = ACTIONS(2092),
    [sym_undefined] = ACTIONS(2092),
    [anon_sym_AT] = ACTIONS(2090),
    [anon_sym_static] = ACTIONS(2092),
    [anon_sym_readonly] = ACTIONS(2092),
    [anon_sym_get] = ACTIONS(2092),
    [anon_sym_set] = ACTIONS(2092),
    [anon_sym_declare] = ACTIONS(2092),
    [anon_sym_public] = ACTIONS(2092),
    [anon_sym_private] = ACTIONS(2092),
    [anon_sym_protected] = ACTIONS(2092),
    [anon_sym_override] = ACTIONS(2092),
    [anon_sym_module] = ACTIONS(2092),
    [anon_sym_any] = ACTIONS(2092),
    [anon_sym_number] = ACTIONS(2092),
    [anon_sym_boolean] = ACTIONS(2092),
    [anon_sym_string] = ACTIONS(2092),
    [anon_sym_symbol] = ACTIONS(2092),
    [anon_sym_abstract] = ACTIONS(2092),
    [anon_sym_interface] = ACTIONS(2092),
    [anon_sym_enum] = ACTIONS(2092),
  },
  [627] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [628] = {
    [ts_builtin_sym_end] = ACTIONS(2094),
    [sym_identifier] = ACTIONS(2096),
    [anon_sym_export] = ACTIONS(2096),
    [anon_sym_default] = ACTIONS(2096),
    [anon_sym_type] = ACTIONS(2096),
    [anon_sym_namespace] = ACTIONS(2096),
    [anon_sym_LBRACE] = ACTIONS(2094),
    [anon_sym_RBRACE] = ACTIONS(2094),
    [anon_sym_typeof] = ACTIONS(2096),
    [anon_sym_import] = ACTIONS(2096),
    [anon_sym_var] = ACTIONS(2096),
    [anon_sym_let] = ACTIONS(2096),
    [anon_sym_const] = ACTIONS(2096),
    [anon_sym_BANG] = ACTIONS(2094),
    [anon_sym_else] = ACTIONS(2096),
    [anon_sym_if] = ACTIONS(2096),
    [anon_sym_switch] = ACTIONS(2096),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_LPAREN] = ACTIONS(2094),
    [anon_sym_await] = ACTIONS(2096),
    [anon_sym_while] = ACTIONS(2096),
    [anon_sym_do] = ACTIONS(2096),
    [anon_sym_try] = ACTIONS(2096),
    [anon_sym_with] = ACTIONS(2096),
    [anon_sym_break] = ACTIONS(2096),
    [anon_sym_continue] = ACTIONS(2096),
    [anon_sym_debugger] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(2096),
    [anon_sym_throw] = ACTIONS(2096),
    [anon_sym_SEMI] = ACTIONS(2094),
    [anon_sym_case] = ACTIONS(2096),
    [anon_sym_yield] = ACTIONS(2096),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_LT] = ACTIONS(2094),
    [anon_sym_SLASH] = ACTIONS(2096),
    [anon_sym_class] = ACTIONS(2096),
    [anon_sym_async] = ACTIONS(2096),
    [anon_sym_function] = ACTIONS(2096),
    [anon_sym_new] = ACTIONS(2096),
    [anon_sym_PLUS] = ACTIONS(2096),
    [anon_sym_DASH] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(2094),
    [anon_sym_void] = ACTIONS(2096),
    [anon_sym_delete] = ACTIONS(2096),
    [anon_sym_PLUS_PLUS] = ACTIONS(2094),
    [anon_sym_DASH_DASH] = ACTIONS(2094),
    [anon_sym_DQUOTE] = ACTIONS(2094),
    [anon_sym_SQUOTE] = ACTIONS(2094),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2094),
    [sym_number] = ACTIONS(2094),
    [sym_this] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_true] = ACTIONS(2096),
    [sym_false] = ACTIONS(2096),
    [sym_null] = ACTIONS(2096),
    [sym_undefined] = ACTIONS(2096),
    [anon_sym_AT] = ACTIONS(2094),
    [anon_sym_static] = ACTIONS(2096),
    [anon_sym_readonly] = ACTIONS(2096),
    [anon_sym_get] = ACTIONS(2096),
    [anon_sym_set] = ACTIONS(2096),
    [anon_sym_declare] = ACTIONS(2096),
    [anon_sym_public] = ACTIONS(2096),
    [anon_sym_private] = ACTIONS(2096),
    [anon_sym_protected] = ACTIONS(2096),
    [anon_sym_override] = ACTIONS(2096),
    [anon_sym_module] = ACTIONS(2096),
    [anon_sym_any] = ACTIONS(2096),
    [anon_sym_number] = ACTIONS(2096),
    [anon_sym_boolean] = ACTIONS(2096),
    [anon_sym_string] = ACTIONS(2096),
    [anon_sym_symbol] = ACTIONS(2096),
    [anon_sym_abstract] = ACTIONS(2096),
    [anon_sym_interface] = ACTIONS(2096),
    [anon_sym_enum] = ACTIONS(2096),
  },
  [629] = {
    [ts_builtin_sym_end] = ACTIONS(1452),
    [sym_identifier] = ACTIONS(1454),
    [anon_sym_export] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_type] = ACTIONS(1454),
    [anon_sym_namespace] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [anon_sym_typeof] = ACTIONS(1454),
    [anon_sym_import] = ACTIONS(1454),
    [anon_sym_var] = ACTIONS(1454),
    [anon_sym_let] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_else] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(1452),
    [anon_sym_await] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_try] = ACTIONS(1454),
    [anon_sym_with] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_debugger] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_throw] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_yield] = ACTIONS(1454),
    [anon_sym_LBRACK] = ACTIONS(1452),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1454),
    [anon_sym_class] = ACTIONS(1454),
    [anon_sym_async] = ACTIONS(1454),
    [anon_sym_function] = ACTIONS(1454),
    [anon_sym_new] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_void] = ACTIONS(1454),
    [anon_sym_delete] = ACTIONS(1454),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1452),
    [sym_number] = ACTIONS(1452),
    [sym_this] = ACTIONS(1454),
    [sym_super] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_undefined] = ACTIONS(1454),
    [anon_sym_AT] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_readonly] = ACTIONS(1454),
    [anon_sym_get] = ACTIONS(1454),
    [anon_sym_set] = ACTIONS(1454),
    [anon_sym_declare] = ACTIONS(1454),
    [anon_sym_public] = ACTIONS(1454),
    [anon_sym_private] = ACTIONS(1454),
    [anon_sym_protected] = ACTIONS(1454),
    [anon_sym_override] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_any] = ACTIONS(1454),
    [anon_sym_number] = ACTIONS(1454),
    [anon_sym_boolean] = ACTIONS(1454),
    [anon_sym_string] = ACTIONS(1454),
    [anon_sym_symbol] = ACTIONS(1454),
    [anon_sym_abstract] = ACTIONS(1454),
    [anon_sym_interface] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
  },
  [630] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_readonly] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_override] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
  },
  [631] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [632] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [633] = {
    [ts_builtin_sym_end] = ACTIONS(2102),
    [sym_identifier] = ACTIONS(2104),
    [anon_sym_export] = ACTIONS(2104),
    [anon_sym_default] = ACTIONS(2104),
    [anon_sym_type] = ACTIONS(2104),
    [anon_sym_namespace] = ACTIONS(2104),
    [anon_sym_LBRACE] = ACTIONS(2102),
    [anon_sym_RBRACE] = ACTIONS(2102),
    [anon_sym_typeof] = ACTIONS(2104),
    [anon_sym_import] = ACTIONS(2104),
    [anon_sym_var] = ACTIONS(2104),
    [anon_sym_let] = ACTIONS(2104),
    [anon_sym_const] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2102),
    [anon_sym_else] = ACTIONS(2104),
    [anon_sym_if] = ACTIONS(2104),
    [anon_sym_switch] = ACTIONS(2104),
    [anon_sym_for] = ACTIONS(2104),
    [anon_sym_LPAREN] = ACTIONS(2102),
    [anon_sym_await] = ACTIONS(2104),
    [anon_sym_while] = ACTIONS(2104),
    [anon_sym_do] = ACTIONS(2104),
    [anon_sym_try] = ACTIONS(2104),
    [anon_sym_with] = ACTIONS(2104),
    [anon_sym_break] = ACTIONS(2104),
    [anon_sym_continue] = ACTIONS(2104),
    [anon_sym_debugger] = ACTIONS(2104),
    [anon_sym_return] = ACTIONS(2104),
    [anon_sym_throw] = ACTIONS(2104),
    [anon_sym_SEMI] = ACTIONS(2102),
    [anon_sym_case] = ACTIONS(2104),
    [anon_sym_yield] = ACTIONS(2104),
    [anon_sym_LBRACK] = ACTIONS(2102),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_SLASH] = ACTIONS(2104),
    [anon_sym_class] = ACTIONS(2104),
    [anon_sym_async] = ACTIONS(2104),
    [anon_sym_function] = ACTIONS(2104),
    [anon_sym_new] = ACTIONS(2104),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_DASH] = ACTIONS(2104),
    [anon_sym_TILDE] = ACTIONS(2102),
    [anon_sym_void] = ACTIONS(2104),
    [anon_sym_delete] = ACTIONS(2104),
    [anon_sym_PLUS_PLUS] = ACTIONS(2102),
    [anon_sym_DASH_DASH] = ACTIONS(2102),
    [anon_sym_DQUOTE] = ACTIONS(2102),
    [anon_sym_SQUOTE] = ACTIONS(2102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2102),
    [sym_number] = ACTIONS(2102),
    [sym_this] = ACTIONS(2104),
    [sym_super] = ACTIONS(2104),
    [sym_true] = ACTIONS(2104),
    [sym_false] = ACTIONS(2104),
    [sym_null] = ACTIONS(2104),
    [sym_undefined] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2102),
    [anon_sym_static] = ACTIONS(2104),
    [anon_sym_readonly] = ACTIONS(2104),
    [anon_sym_get] = ACTIONS(2104),
    [anon_sym_set] = ACTIONS(2104),
    [anon_sym_declare] = ACTIONS(2104),
    [anon_sym_public] = ACTIONS(2104),
    [anon_sym_private] = ACTIONS(2104),
    [anon_sym_protected] = ACTIONS(2104),
    [anon_sym_override] = ACTIONS(2104),
    [anon_sym_module] = ACTIONS(2104),
    [anon_sym_any] = ACTIONS(2104),
    [anon_sym_number] = ACTIONS(2104),
    [anon_sym_boolean] = ACTIONS(2104),
    [anon_sym_string] = ACTIONS(2104),
    [anon_sym_symbol] = ACTIONS(2104),
    [anon_sym_abstract] = ACTIONS(2104),
    [anon_sym_interface] = ACTIONS(2104),
    [anon_sym_enum] = ACTIONS(2104),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [635] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [636] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [637] = {
    [ts_builtin_sym_end] = ACTIONS(2110),
    [sym_identifier] = ACTIONS(2112),
    [anon_sym_export] = ACTIONS(2112),
    [anon_sym_default] = ACTIONS(2112),
    [anon_sym_type] = ACTIONS(2112),
    [anon_sym_namespace] = ACTIONS(2112),
    [anon_sym_LBRACE] = ACTIONS(2110),
    [anon_sym_RBRACE] = ACTIONS(2110),
    [anon_sym_typeof] = ACTIONS(2112),
    [anon_sym_import] = ACTIONS(2112),
    [anon_sym_var] = ACTIONS(2112),
    [anon_sym_let] = ACTIONS(2112),
    [anon_sym_const] = ACTIONS(2112),
    [anon_sym_BANG] = ACTIONS(2110),
    [anon_sym_else] = ACTIONS(2112),
    [anon_sym_if] = ACTIONS(2112),
    [anon_sym_switch] = ACTIONS(2112),
    [anon_sym_for] = ACTIONS(2112),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_await] = ACTIONS(2112),
    [anon_sym_while] = ACTIONS(2112),
    [anon_sym_do] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2112),
    [anon_sym_with] = ACTIONS(2112),
    [anon_sym_break] = ACTIONS(2112),
    [anon_sym_continue] = ACTIONS(2112),
    [anon_sym_debugger] = ACTIONS(2112),
    [anon_sym_return] = ACTIONS(2112),
    [anon_sym_throw] = ACTIONS(2112),
    [anon_sym_SEMI] = ACTIONS(2110),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_yield] = ACTIONS(2112),
    [anon_sym_LBRACK] = ACTIONS(2110),
    [anon_sym_LT] = ACTIONS(2110),
    [anon_sym_SLASH] = ACTIONS(2112),
    [anon_sym_class] = ACTIONS(2112),
    [anon_sym_async] = ACTIONS(2112),
    [anon_sym_function] = ACTIONS(2112),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_PLUS] = ACTIONS(2112),
    [anon_sym_DASH] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2110),
    [anon_sym_void] = ACTIONS(2112),
    [anon_sym_delete] = ACTIONS(2112),
    [anon_sym_PLUS_PLUS] = ACTIONS(2110),
    [anon_sym_DASH_DASH] = ACTIONS(2110),
    [anon_sym_DQUOTE] = ACTIONS(2110),
    [anon_sym_SQUOTE] = ACTIONS(2110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2110),
    [sym_number] = ACTIONS(2110),
    [sym_this] = ACTIONS(2112),
    [sym_super] = ACTIONS(2112),
    [sym_true] = ACTIONS(2112),
    [sym_false] = ACTIONS(2112),
    [sym_null] = ACTIONS(2112),
    [sym_undefined] = ACTIONS(2112),
    [anon_sym_AT] = ACTIONS(2110),
    [anon_sym_static] = ACTIONS(2112),
    [anon_sym_readonly] = ACTIONS(2112),
    [anon_sym_get] = ACTIONS(2112),
    [anon_sym_set] = ACTIONS(2112),
    [anon_sym_declare] = ACTIONS(2112),
    [anon_sym_public] = ACTIONS(2112),
    [anon_sym_private] = ACTIONS(2112),
    [anon_sym_protected] = ACTIONS(2112),
    [anon_sym_override] = ACTIONS(2112),
    [anon_sym_module] = ACTIONS(2112),
    [anon_sym_any] = ACTIONS(2112),
    [anon_sym_number] = ACTIONS(2112),
    [anon_sym_boolean] = ACTIONS(2112),
    [anon_sym_string] = ACTIONS(2112),
    [anon_sym_symbol] = ACTIONS(2112),
    [anon_sym_abstract] = ACTIONS(2112),
    [anon_sym_interface] = ACTIONS(2112),
    [anon_sym_enum] = ACTIONS(2112),
  },
  [638] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [639] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [640] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [641] = {
    [ts_builtin_sym_end] = ACTIONS(2114),
    [sym_identifier] = ACTIONS(2116),
    [anon_sym_export] = ACTIONS(2116),
    [anon_sym_default] = ACTIONS(2116),
    [anon_sym_type] = ACTIONS(2116),
    [anon_sym_namespace] = ACTIONS(2116),
    [anon_sym_LBRACE] = ACTIONS(2114),
    [anon_sym_RBRACE] = ACTIONS(2114),
    [anon_sym_typeof] = ACTIONS(2116),
    [anon_sym_import] = ACTIONS(2116),
    [anon_sym_var] = ACTIONS(2116),
    [anon_sym_let] = ACTIONS(2116),
    [anon_sym_const] = ACTIONS(2116),
    [anon_sym_BANG] = ACTIONS(2114),
    [anon_sym_else] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(2116),
    [anon_sym_switch] = ACTIONS(2116),
    [anon_sym_for] = ACTIONS(2116),
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_await] = ACTIONS(2116),
    [anon_sym_while] = ACTIONS(2116),
    [anon_sym_do] = ACTIONS(2116),
    [anon_sym_try] = ACTIONS(2116),
    [anon_sym_with] = ACTIONS(2116),
    [anon_sym_break] = ACTIONS(2116),
    [anon_sym_continue] = ACTIONS(2116),
    [anon_sym_debugger] = ACTIONS(2116),
    [anon_sym_return] = ACTIONS(2116),
    [anon_sym_throw] = ACTIONS(2116),
    [anon_sym_SEMI] = ACTIONS(2114),
    [anon_sym_case] = ACTIONS(2116),
    [anon_sym_yield] = ACTIONS(2116),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_LT] = ACTIONS(2114),
    [anon_sym_SLASH] = ACTIONS(2116),
    [anon_sym_class] = ACTIONS(2116),
    [anon_sym_async] = ACTIONS(2116),
    [anon_sym_function] = ACTIONS(2116),
    [anon_sym_new] = ACTIONS(2116),
    [anon_sym_PLUS] = ACTIONS(2116),
    [anon_sym_DASH] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2114),
    [anon_sym_void] = ACTIONS(2116),
    [anon_sym_delete] = ACTIONS(2116),
    [anon_sym_PLUS_PLUS] = ACTIONS(2114),
    [anon_sym_DASH_DASH] = ACTIONS(2114),
    [anon_sym_DQUOTE] = ACTIONS(2114),
    [anon_sym_SQUOTE] = ACTIONS(2114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2114),
    [sym_number] = ACTIONS(2114),
    [sym_this] = ACTIONS(2116),
    [sym_super] = ACTIONS(2116),
    [sym_true] = ACTIONS(2116),
    [sym_false] = ACTIONS(2116),
    [sym_null] = ACTIONS(2116),
    [sym_undefined] = ACTIONS(2116),
    [anon_sym_AT] = ACTIONS(2114),
    [anon_sym_static] = ACTIONS(2116),
    [anon_sym_readonly] = ACTIONS(2116),
    [anon_sym_get] = ACTIONS(2116),
    [anon_sym_set] = ACTIONS(2116),
    [anon_sym_declare] = ACTIONS(2116),
    [anon_sym_public] = ACTIONS(2116),
    [anon_sym_private] = ACTIONS(2116),
    [anon_sym_protected] = ACTIONS(2116),
    [anon_sym_override] = ACTIONS(2116),
    [anon_sym_module] = ACTIONS(2116),
    [anon_sym_any] = ACTIONS(2116),
    [anon_sym_number] = ACTIONS(2116),
    [anon_sym_boolean] = ACTIONS(2116),
    [anon_sym_string] = ACTIONS(2116),
    [anon_sym_symbol] = ACTIONS(2116),
    [anon_sym_abstract] = ACTIONS(2116),
    [anon_sym_interface] = ACTIONS(2116),
    [anon_sym_enum] = ACTIONS(2116),
  },
  [642] = {
    [ts_builtin_sym_end] = ACTIONS(2118),
    [sym_identifier] = ACTIONS(2120),
    [anon_sym_export] = ACTIONS(2120),
    [anon_sym_default] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(2120),
    [anon_sym_namespace] = ACTIONS(2120),
    [anon_sym_LBRACE] = ACTIONS(2118),
    [anon_sym_RBRACE] = ACTIONS(2118),
    [anon_sym_typeof] = ACTIONS(2120),
    [anon_sym_import] = ACTIONS(2120),
    [anon_sym_var] = ACTIONS(2120),
    [anon_sym_let] = ACTIONS(2120),
    [anon_sym_const] = ACTIONS(2120),
    [anon_sym_BANG] = ACTIONS(2118),
    [anon_sym_else] = ACTIONS(2120),
    [anon_sym_if] = ACTIONS(2120),
    [anon_sym_switch] = ACTIONS(2120),
    [anon_sym_for] = ACTIONS(2120),
    [anon_sym_LPAREN] = ACTIONS(2118),
    [anon_sym_await] = ACTIONS(2120),
    [anon_sym_while] = ACTIONS(2120),
    [anon_sym_do] = ACTIONS(2120),
    [anon_sym_try] = ACTIONS(2120),
    [anon_sym_with] = ACTIONS(2120),
    [anon_sym_break] = ACTIONS(2120),
    [anon_sym_continue] = ACTIONS(2120),
    [anon_sym_debugger] = ACTIONS(2120),
    [anon_sym_return] = ACTIONS(2120),
    [anon_sym_throw] = ACTIONS(2120),
    [anon_sym_SEMI] = ACTIONS(2118),
    [anon_sym_case] = ACTIONS(2120),
    [anon_sym_yield] = ACTIONS(2120),
    [anon_sym_LBRACK] = ACTIONS(2118),
    [anon_sym_LT] = ACTIONS(2118),
    [anon_sym_SLASH] = ACTIONS(2120),
    [anon_sym_class] = ACTIONS(2120),
    [anon_sym_async] = ACTIONS(2120),
    [anon_sym_function] = ACTIONS(2120),
    [anon_sym_new] = ACTIONS(2120),
    [anon_sym_PLUS] = ACTIONS(2120),
    [anon_sym_DASH] = ACTIONS(2120),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_void] = ACTIONS(2120),
    [anon_sym_delete] = ACTIONS(2120),
    [anon_sym_PLUS_PLUS] = ACTIONS(2118),
    [anon_sym_DASH_DASH] = ACTIONS(2118),
    [anon_sym_DQUOTE] = ACTIONS(2118),
    [anon_sym_SQUOTE] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2118),
    [sym_number] = ACTIONS(2118),
    [sym_this] = ACTIONS(2120),
    [sym_super] = ACTIONS(2120),
    [sym_true] = ACTIONS(2120),
    [sym_false] = ACTIONS(2120),
    [sym_null] = ACTIONS(2120),
    [sym_undefined] = ACTIONS(2120),
    [anon_sym_AT] = ACTIONS(2118),
    [anon_sym_static] = ACTIONS(2120),
    [anon_sym_readonly] = ACTIONS(2120),
    [anon_sym_get] = ACTIONS(2120),
    [anon_sym_set] = ACTIONS(2120),
    [anon_sym_declare] = ACTIONS(2120),
    [anon_sym_public] = ACTIONS(2120),
    [anon_sym_private] = ACTIONS(2120),
    [anon_sym_protected] = ACTIONS(2120),
    [anon_sym_override] = ACTIONS(2120),
    [anon_sym_module] = ACTIONS(2120),
    [anon_sym_any] = ACTIONS(2120),
    [anon_sym_number] = ACTIONS(2120),
    [anon_sym_boolean] = ACTIONS(2120),
    [anon_sym_string] = ACTIONS(2120),
    [anon_sym_symbol] = ACTIONS(2120),
    [anon_sym_abstract] = ACTIONS(2120),
    [anon_sym_interface] = ACTIONS(2120),
    [anon_sym_enum] = ACTIONS(2120),
  },
  [643] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [644] = {
    [ts_builtin_sym_end] = ACTIONS(2122),
    [sym_identifier] = ACTIONS(2124),
    [anon_sym_export] = ACTIONS(2124),
    [anon_sym_default] = ACTIONS(2124),
    [anon_sym_type] = ACTIONS(2124),
    [anon_sym_namespace] = ACTIONS(2124),
    [anon_sym_LBRACE] = ACTIONS(2122),
    [anon_sym_RBRACE] = ACTIONS(2122),
    [anon_sym_typeof] = ACTIONS(2124),
    [anon_sym_import] = ACTIONS(2124),
    [anon_sym_var] = ACTIONS(2124),
    [anon_sym_let] = ACTIONS(2124),
    [anon_sym_const] = ACTIONS(2124),
    [anon_sym_BANG] = ACTIONS(2122),
    [anon_sym_else] = ACTIONS(2124),
    [anon_sym_if] = ACTIONS(2124),
    [anon_sym_switch] = ACTIONS(2124),
    [anon_sym_for] = ACTIONS(2124),
    [anon_sym_LPAREN] = ACTIONS(2122),
    [anon_sym_await] = ACTIONS(2124),
    [anon_sym_while] = ACTIONS(2124),
    [anon_sym_do] = ACTIONS(2124),
    [anon_sym_try] = ACTIONS(2124),
    [anon_sym_with] = ACTIONS(2124),
    [anon_sym_break] = ACTIONS(2124),
    [anon_sym_continue] = ACTIONS(2124),
    [anon_sym_debugger] = ACTIONS(2124),
    [anon_sym_return] = ACTIONS(2124),
    [anon_sym_throw] = ACTIONS(2124),
    [anon_sym_SEMI] = ACTIONS(2122),
    [anon_sym_case] = ACTIONS(2124),
    [anon_sym_yield] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(2122),
    [anon_sym_SLASH] = ACTIONS(2124),
    [anon_sym_class] = ACTIONS(2124),
    [anon_sym_async] = ACTIONS(2124),
    [anon_sym_function] = ACTIONS(2124),
    [anon_sym_new] = ACTIONS(2124),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2122),
    [anon_sym_void] = ACTIONS(2124),
    [anon_sym_delete] = ACTIONS(2124),
    [anon_sym_PLUS_PLUS] = ACTIONS(2122),
    [anon_sym_DASH_DASH] = ACTIONS(2122),
    [anon_sym_DQUOTE] = ACTIONS(2122),
    [anon_sym_SQUOTE] = ACTIONS(2122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2122),
    [sym_number] = ACTIONS(2122),
    [sym_this] = ACTIONS(2124),
    [sym_super] = ACTIONS(2124),
    [sym_true] = ACTIONS(2124),
    [sym_false] = ACTIONS(2124),
    [sym_null] = ACTIONS(2124),
    [sym_undefined] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(2122),
    [anon_sym_static] = ACTIONS(2124),
    [anon_sym_readonly] = ACTIONS(2124),
    [anon_sym_get] = ACTIONS(2124),
    [anon_sym_set] = ACTIONS(2124),
    [anon_sym_declare] = ACTIONS(2124),
    [anon_sym_public] = ACTIONS(2124),
    [anon_sym_private] = ACTIONS(2124),
    [anon_sym_protected] = ACTIONS(2124),
    [anon_sym_override] = ACTIONS(2124),
    [anon_sym_module] = ACTIONS(2124),
    [anon_sym_any] = ACTIONS(2124),
    [anon_sym_number] = ACTIONS(2124),
    [anon_sym_boolean] = ACTIONS(2124),
    [anon_sym_string] = ACTIONS(2124),
    [anon_sym_symbol] = ACTIONS(2124),
    [anon_sym_abstract] = ACTIONS(2124),
    [anon_sym_interface] = ACTIONS(2124),
    [anon_sym_enum] = ACTIONS(2124),
  },
  [645] = {
    [ts_builtin_sym_end] = ACTIONS(2126),
    [sym_identifier] = ACTIONS(2128),
    [anon_sym_export] = ACTIONS(2128),
    [anon_sym_default] = ACTIONS(2128),
    [anon_sym_type] = ACTIONS(2128),
    [anon_sym_namespace] = ACTIONS(2128),
    [anon_sym_LBRACE] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2128),
    [anon_sym_import] = ACTIONS(2128),
    [anon_sym_var] = ACTIONS(2128),
    [anon_sym_let] = ACTIONS(2128),
    [anon_sym_const] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2128),
    [anon_sym_if] = ACTIONS(2128),
    [anon_sym_switch] = ACTIONS(2128),
    [anon_sym_for] = ACTIONS(2128),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2128),
    [anon_sym_while] = ACTIONS(2128),
    [anon_sym_do] = ACTIONS(2128),
    [anon_sym_try] = ACTIONS(2128),
    [anon_sym_with] = ACTIONS(2128),
    [anon_sym_break] = ACTIONS(2128),
    [anon_sym_continue] = ACTIONS(2128),
    [anon_sym_debugger] = ACTIONS(2128),
    [anon_sym_return] = ACTIONS(2128),
    [anon_sym_throw] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2128),
    [anon_sym_yield] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_class] = ACTIONS(2128),
    [anon_sym_async] = ACTIONS(2128),
    [anon_sym_function] = ACTIONS(2128),
    [anon_sym_new] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2128),
    [anon_sym_delete] = ACTIONS(2128),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_this] = ACTIONS(2128),
    [sym_super] = ACTIONS(2128),
    [sym_true] = ACTIONS(2128),
    [sym_false] = ACTIONS(2128),
    [sym_null] = ACTIONS(2128),
    [sym_undefined] = ACTIONS(2128),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2128),
    [anon_sym_readonly] = ACTIONS(2128),
    [anon_sym_get] = ACTIONS(2128),
    [anon_sym_set] = ACTIONS(2128),
    [anon_sym_declare] = ACTIONS(2128),
    [anon_sym_public] = ACTIONS(2128),
    [anon_sym_private] = ACTIONS(2128),
    [anon_sym_protected] = ACTIONS(2128),
    [anon_sym_override] = ACTIONS(2128),
    [anon_sym_module] = ACTIONS(2128),
    [anon_sym_any] = ACTIONS(2128),
    [anon_sym_number] = ACTIONS(2128),
    [anon_sym_boolean] = ACTIONS(2128),
    [anon_sym_string] = ACTIONS(2128),
    [anon_sym_symbol] = ACTIONS(2128),
    [anon_sym_abstract] = ACTIONS(2128),
    [anon_sym_interface] = ACTIONS(2128),
    [anon_sym_enum] = ACTIONS(2128),
  },
  [646] = {
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2132),
    [anon_sym_export] = ACTIONS(2132),
    [anon_sym_default] = ACTIONS(2132),
    [anon_sym_type] = ACTIONS(2132),
    [anon_sym_namespace] = ACTIONS(2132),
    [anon_sym_LBRACE] = ACTIONS(2130),
    [anon_sym_RBRACE] = ACTIONS(2130),
    [anon_sym_typeof] = ACTIONS(2132),
    [anon_sym_import] = ACTIONS(2132),
    [anon_sym_var] = ACTIONS(2132),
    [anon_sym_let] = ACTIONS(2132),
    [anon_sym_const] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2130),
    [anon_sym_else] = ACTIONS(2132),
    [anon_sym_if] = ACTIONS(2132),
    [anon_sym_switch] = ACTIONS(2132),
    [anon_sym_for] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_await] = ACTIONS(2132),
    [anon_sym_while] = ACTIONS(2132),
    [anon_sym_do] = ACTIONS(2132),
    [anon_sym_try] = ACTIONS(2132),
    [anon_sym_with] = ACTIONS(2132),
    [anon_sym_break] = ACTIONS(2132),
    [anon_sym_continue] = ACTIONS(2132),
    [anon_sym_debugger] = ACTIONS(2132),
    [anon_sym_return] = ACTIONS(2132),
    [anon_sym_throw] = ACTIONS(2132),
    [anon_sym_SEMI] = ACTIONS(2130),
    [anon_sym_case] = ACTIONS(2132),
    [anon_sym_yield] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_LT] = ACTIONS(2130),
    [anon_sym_SLASH] = ACTIONS(2132),
    [anon_sym_class] = ACTIONS(2132),
    [anon_sym_async] = ACTIONS(2132),
    [anon_sym_function] = ACTIONS(2132),
    [anon_sym_new] = ACTIONS(2132),
    [anon_sym_PLUS] = ACTIONS(2132),
    [anon_sym_DASH] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2130),
    [anon_sym_void] = ACTIONS(2132),
    [anon_sym_delete] = ACTIONS(2132),
    [anon_sym_PLUS_PLUS] = ACTIONS(2130),
    [anon_sym_DASH_DASH] = ACTIONS(2130),
    [anon_sym_DQUOTE] = ACTIONS(2130),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2130),
    [sym_number] = ACTIONS(2130),
    [sym_this] = ACTIONS(2132),
    [sym_super] = ACTIONS(2132),
    [sym_true] = ACTIONS(2132),
    [sym_false] = ACTIONS(2132),
    [sym_null] = ACTIONS(2132),
    [sym_undefined] = ACTIONS(2132),
    [anon_sym_AT] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(2132),
    [anon_sym_readonly] = ACTIONS(2132),
    [anon_sym_get] = ACTIONS(2132),
    [anon_sym_set] = ACTIONS(2132),
    [anon_sym_declare] = ACTIONS(2132),
    [anon_sym_public] = ACTIONS(2132),
    [anon_sym_private] = ACTIONS(2132),
    [anon_sym_protected] = ACTIONS(2132),
    [anon_sym_override] = ACTIONS(2132),
    [anon_sym_module] = ACTIONS(2132),
    [anon_sym_any] = ACTIONS(2132),
    [anon_sym_number] = ACTIONS(2132),
    [anon_sym_boolean] = ACTIONS(2132),
    [anon_sym_string] = ACTIONS(2132),
    [anon_sym_symbol] = ACTIONS(2132),
    [anon_sym_abstract] = ACTIONS(2132),
    [anon_sym_interface] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2132),
  },
  [647] = {
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_identifier] = ACTIONS(2136),
    [anon_sym_export] = ACTIONS(2136),
    [anon_sym_default] = ACTIONS(2136),
    [anon_sym_type] = ACTIONS(2136),
    [anon_sym_namespace] = ACTIONS(2136),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [anon_sym_typeof] = ACTIONS(2136),
    [anon_sym_import] = ACTIONS(2136),
    [anon_sym_var] = ACTIONS(2136),
    [anon_sym_let] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(2136),
    [anon_sym_BANG] = ACTIONS(2134),
    [anon_sym_else] = ACTIONS(2136),
    [anon_sym_if] = ACTIONS(2136),
    [anon_sym_switch] = ACTIONS(2136),
    [anon_sym_for] = ACTIONS(2136),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_await] = ACTIONS(2136),
    [anon_sym_while] = ACTIONS(2136),
    [anon_sym_do] = ACTIONS(2136),
    [anon_sym_try] = ACTIONS(2136),
    [anon_sym_with] = ACTIONS(2136),
    [anon_sym_break] = ACTIONS(2136),
    [anon_sym_continue] = ACTIONS(2136),
    [anon_sym_debugger] = ACTIONS(2136),
    [anon_sym_return] = ACTIONS(2136),
    [anon_sym_throw] = ACTIONS(2136),
    [anon_sym_SEMI] = ACTIONS(2134),
    [anon_sym_case] = ACTIONS(2136),
    [anon_sym_yield] = ACTIONS(2136),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2136),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_async] = ACTIONS(2136),
    [anon_sym_function] = ACTIONS(2136),
    [anon_sym_new] = ACTIONS(2136),
    [anon_sym_PLUS] = ACTIONS(2136),
    [anon_sym_DASH] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2134),
    [anon_sym_void] = ACTIONS(2136),
    [anon_sym_delete] = ACTIONS(2136),
    [anon_sym_PLUS_PLUS] = ACTIONS(2134),
    [anon_sym_DASH_DASH] = ACTIONS(2134),
    [anon_sym_DQUOTE] = ACTIONS(2134),
    [anon_sym_SQUOTE] = ACTIONS(2134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2134),
    [sym_number] = ACTIONS(2134),
    [sym_this] = ACTIONS(2136),
    [sym_super] = ACTIONS(2136),
    [sym_true] = ACTIONS(2136),
    [sym_false] = ACTIONS(2136),
    [sym_null] = ACTIONS(2136),
    [sym_undefined] = ACTIONS(2136),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_static] = ACTIONS(2136),
    [anon_sym_readonly] = ACTIONS(2136),
    [anon_sym_get] = ACTIONS(2136),
    [anon_sym_set] = ACTIONS(2136),
    [anon_sym_declare] = ACTIONS(2136),
    [anon_sym_public] = ACTIONS(2136),
    [anon_sym_private] = ACTIONS(2136),
    [anon_sym_protected] = ACTIONS(2136),
    [anon_sym_override] = ACTIONS(2136),
    [anon_sym_module] = ACTIONS(2136),
    [anon_sym_any] = ACTIONS(2136),
    [anon_sym_number] = ACTIONS(2136),
    [anon_sym_boolean] = ACTIONS(2136),
    [anon_sym_string] = ACTIONS(2136),
    [anon_sym_symbol] = ACTIONS(2136),
    [anon_sym_abstract] = ACTIONS(2136),
    [anon_sym_interface] = ACTIONS(2136),
    [anon_sym_enum] = ACTIONS(2136),
  },
  [648] = {
    [ts_builtin_sym_end] = ACTIONS(2138),
    [sym_identifier] = ACTIONS(2140),
    [anon_sym_export] = ACTIONS(2140),
    [anon_sym_default] = ACTIONS(2140),
    [anon_sym_type] = ACTIONS(2140),
    [anon_sym_namespace] = ACTIONS(2140),
    [anon_sym_LBRACE] = ACTIONS(2138),
    [anon_sym_RBRACE] = ACTIONS(2138),
    [anon_sym_typeof] = ACTIONS(2140),
    [anon_sym_import] = ACTIONS(2140),
    [anon_sym_var] = ACTIONS(2140),
    [anon_sym_let] = ACTIONS(2140),
    [anon_sym_const] = ACTIONS(2140),
    [anon_sym_BANG] = ACTIONS(2138),
    [anon_sym_else] = ACTIONS(2140),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_switch] = ACTIONS(2140),
    [anon_sym_for] = ACTIONS(2140),
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_await] = ACTIONS(2140),
    [anon_sym_while] = ACTIONS(2140),
    [anon_sym_do] = ACTIONS(2140),
    [anon_sym_try] = ACTIONS(2140),
    [anon_sym_with] = ACTIONS(2140),
    [anon_sym_break] = ACTIONS(2140),
    [anon_sym_continue] = ACTIONS(2140),
    [anon_sym_debugger] = ACTIONS(2140),
    [anon_sym_return] = ACTIONS(2140),
    [anon_sym_throw] = ACTIONS(2140),
    [anon_sym_SEMI] = ACTIONS(2138),
    [anon_sym_case] = ACTIONS(2140),
    [anon_sym_yield] = ACTIONS(2140),
    [anon_sym_LBRACK] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(2138),
    [anon_sym_SLASH] = ACTIONS(2140),
    [anon_sym_class] = ACTIONS(2140),
    [anon_sym_async] = ACTIONS(2140),
    [anon_sym_function] = ACTIONS(2140),
    [anon_sym_new] = ACTIONS(2140),
    [anon_sym_PLUS] = ACTIONS(2140),
    [anon_sym_DASH] = ACTIONS(2140),
    [anon_sym_TILDE] = ACTIONS(2138),
    [anon_sym_void] = ACTIONS(2140),
    [anon_sym_delete] = ACTIONS(2140),
    [anon_sym_PLUS_PLUS] = ACTIONS(2138),
    [anon_sym_DASH_DASH] = ACTIONS(2138),
    [anon_sym_DQUOTE] = ACTIONS(2138),
    [anon_sym_SQUOTE] = ACTIONS(2138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2138),
    [sym_number] = ACTIONS(2138),
    [sym_this] = ACTIONS(2140),
    [sym_super] = ACTIONS(2140),
    [sym_true] = ACTIONS(2140),
    [sym_false] = ACTIONS(2140),
    [sym_null] = ACTIONS(2140),
    [sym_undefined] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(2138),
    [anon_sym_static] = ACTIONS(2140),
    [anon_sym_readonly] = ACTIONS(2140),
    [anon_sym_get] = ACTIONS(2140),
    [anon_sym_set] = ACTIONS(2140),
    [anon_sym_declare] = ACTIONS(2140),
    [anon_sym_public] = ACTIONS(2140),
    [anon_sym_private] = ACTIONS(2140),
    [anon_sym_protected] = ACTIONS(2140),
    [anon_sym_override] = ACTIONS(2140),
    [anon_sym_module] = ACTIONS(2140),
    [anon_sym_any] = ACTIONS(2140),
    [anon_sym_number] = ACTIONS(2140),
    [anon_sym_boolean] = ACTIONS(2140),
    [anon_sym_string] = ACTIONS(2140),
    [anon_sym_symbol] = ACTIONS(2140),
    [anon_sym_abstract] = ACTIONS(2140),
    [anon_sym_interface] = ACTIONS(2140),
    [anon_sym_enum] = ACTIONS(2140),
  },
  [649] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [650] = {
    [ts_builtin_sym_end] = ACTIONS(2142),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_export] = ACTIONS(2144),
    [anon_sym_default] = ACTIONS(2144),
    [anon_sym_type] = ACTIONS(2144),
    [anon_sym_namespace] = ACTIONS(2144),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2144),
    [anon_sym_import] = ACTIONS(2144),
    [anon_sym_var] = ACTIONS(2144),
    [anon_sym_let] = ACTIONS(2144),
    [anon_sym_const] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(2144),
    [anon_sym_switch] = ACTIONS(2144),
    [anon_sym_for] = ACTIONS(2144),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2144),
    [anon_sym_while] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_try] = ACTIONS(2144),
    [anon_sym_with] = ACTIONS(2144),
    [anon_sym_break] = ACTIONS(2144),
    [anon_sym_continue] = ACTIONS(2144),
    [anon_sym_debugger] = ACTIONS(2144),
    [anon_sym_return] = ACTIONS(2144),
    [anon_sym_throw] = ACTIONS(2144),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2144),
    [anon_sym_yield] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2144),
    [anon_sym_class] = ACTIONS(2144),
    [anon_sym_async] = ACTIONS(2144),
    [anon_sym_function] = ACTIONS(2144),
    [anon_sym_new] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2144),
    [anon_sym_DASH] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2144),
    [anon_sym_delete] = ACTIONS(2144),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_this] = ACTIONS(2144),
    [sym_super] = ACTIONS(2144),
    [sym_true] = ACTIONS(2144),
    [sym_false] = ACTIONS(2144),
    [sym_null] = ACTIONS(2144),
    [sym_undefined] = ACTIONS(2144),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2144),
    [anon_sym_readonly] = ACTIONS(2144),
    [anon_sym_get] = ACTIONS(2144),
    [anon_sym_set] = ACTIONS(2144),
    [anon_sym_declare] = ACTIONS(2144),
    [anon_sym_public] = ACTIONS(2144),
    [anon_sym_private] = ACTIONS(2144),
    [anon_sym_protected] = ACTIONS(2144),
    [anon_sym_override] = ACTIONS(2144),
    [anon_sym_module] = ACTIONS(2144),
    [anon_sym_any] = ACTIONS(2144),
    [anon_sym_number] = ACTIONS(2144),
    [anon_sym_boolean] = ACTIONS(2144),
    [anon_sym_string] = ACTIONS(2144),
    [anon_sym_symbol] = ACTIONS(2144),
    [anon_sym_abstract] = ACTIONS(2144),
    [anon_sym_interface] = ACTIONS(2144),
    [anon_sym_enum] = ACTIONS(2144),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [652] = {
    [ts_builtin_sym_end] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2148),
    [anon_sym_export] = ACTIONS(2148),
    [anon_sym_default] = ACTIONS(2148),
    [anon_sym_type] = ACTIONS(2148),
    [anon_sym_namespace] = ACTIONS(2148),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [anon_sym_typeof] = ACTIONS(2148),
    [anon_sym_import] = ACTIONS(2148),
    [anon_sym_var] = ACTIONS(2148),
    [anon_sym_let] = ACTIONS(2148),
    [anon_sym_const] = ACTIONS(2148),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_else] = ACTIONS(2148),
    [anon_sym_if] = ACTIONS(2148),
    [anon_sym_switch] = ACTIONS(2148),
    [anon_sym_for] = ACTIONS(2148),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_await] = ACTIONS(2148),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(2148),
    [anon_sym_try] = ACTIONS(2148),
    [anon_sym_with] = ACTIONS(2148),
    [anon_sym_break] = ACTIONS(2148),
    [anon_sym_continue] = ACTIONS(2148),
    [anon_sym_debugger] = ACTIONS(2148),
    [anon_sym_return] = ACTIONS(2148),
    [anon_sym_throw] = ACTIONS(2148),
    [anon_sym_SEMI] = ACTIONS(2146),
    [anon_sym_case] = ACTIONS(2148),
    [anon_sym_yield] = ACTIONS(2148),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2148),
    [anon_sym_class] = ACTIONS(2148),
    [anon_sym_async] = ACTIONS(2148),
    [anon_sym_function] = ACTIONS(2148),
    [anon_sym_new] = ACTIONS(2148),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2148),
    [anon_sym_TILDE] = ACTIONS(2146),
    [anon_sym_void] = ACTIONS(2148),
    [anon_sym_delete] = ACTIONS(2148),
    [anon_sym_PLUS_PLUS] = ACTIONS(2146),
    [anon_sym_DASH_DASH] = ACTIONS(2146),
    [anon_sym_DQUOTE] = ACTIONS(2146),
    [anon_sym_SQUOTE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2146),
    [sym_number] = ACTIONS(2146),
    [sym_this] = ACTIONS(2148),
    [sym_super] = ACTIONS(2148),
    [sym_true] = ACTIONS(2148),
    [sym_false] = ACTIONS(2148),
    [sym_null] = ACTIONS(2148),
    [sym_undefined] = ACTIONS(2148),
    [anon_sym_AT] = ACTIONS(2146),
    [anon_sym_static] = ACTIONS(2148),
    [anon_sym_readonly] = ACTIONS(2148),
    [anon_sym_get] = ACTIONS(2148),
    [anon_sym_set] = ACTIONS(2148),
    [anon_sym_declare] = ACTIONS(2148),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_override] = ACTIONS(2148),
    [anon_sym_module] = ACTIONS(2148),
    [anon_sym_any] = ACTIONS(2148),
    [anon_sym_number] = ACTIONS(2148),
    [anon_sym_boolean] = ACTIONS(2148),
    [anon_sym_string] = ACTIONS(2148),
    [anon_sym_symbol] = ACTIONS(2148),
    [anon_sym_abstract] = ACTIONS(2148),
    [anon_sym_interface] = ACTIONS(2148),
    [anon_sym_enum] = ACTIONS(2148),
  },
  [653] = {
    [ts_builtin_sym_end] = ACTIONS(2150),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_export] = ACTIONS(2152),
    [anon_sym_default] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_namespace] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2150),
    [anon_sym_RBRACE] = ACTIONS(2150),
    [anon_sym_typeof] = ACTIONS(2152),
    [anon_sym_import] = ACTIONS(2152),
    [anon_sym_var] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2150),
    [anon_sym_else] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_await] = ACTIONS(2152),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_do] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [anon_sym_with] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_debugger] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2150),
    [anon_sym_case] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_SLASH] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_function] = ACTIONS(2152),
    [anon_sym_new] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_TILDE] = ACTIONS(2150),
    [anon_sym_void] = ACTIONS(2152),
    [anon_sym_delete] = ACTIONS(2152),
    [anon_sym_PLUS_PLUS] = ACTIONS(2150),
    [anon_sym_DASH_DASH] = ACTIONS(2150),
    [anon_sym_DQUOTE] = ACTIONS(2150),
    [anon_sym_SQUOTE] = ACTIONS(2150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2150),
    [sym_number] = ACTIONS(2150),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2150),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_readonly] = ACTIONS(2152),
    [anon_sym_get] = ACTIONS(2152),
    [anon_sym_set] = ACTIONS(2152),
    [anon_sym_declare] = ACTIONS(2152),
    [anon_sym_public] = ACTIONS(2152),
    [anon_sym_private] = ACTIONS(2152),
    [anon_sym_protected] = ACTIONS(2152),
    [anon_sym_override] = ACTIONS(2152),
    [anon_sym_module] = ACTIONS(2152),
    [anon_sym_any] = ACTIONS(2152),
    [anon_sym_number] = ACTIONS(2152),
    [anon_sym_boolean] = ACTIONS(2152),
    [anon_sym_string] = ACTIONS(2152),
    [anon_sym_symbol] = ACTIONS(2152),
    [anon_sym_abstract] = ACTIONS(2152),
    [anon_sym_interface] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
  },
  [654] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [655] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [656] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [657] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [658] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [659] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [660] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [661] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [662] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [663] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [664] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [665] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [666] = {
    [ts_builtin_sym_end] = ACTIONS(2154),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_export] = ACTIONS(2156),
    [anon_sym_default] = ACTIONS(2156),
    [anon_sym_type] = ACTIONS(2156),
    [anon_sym_namespace] = ACTIONS(2156),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(2156),
    [anon_sym_import] = ACTIONS(2156),
    [anon_sym_var] = ACTIONS(2156),
    [anon_sym_let] = ACTIONS(2156),
    [anon_sym_const] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2154),
    [anon_sym_else] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(2156),
    [anon_sym_switch] = ACTIONS(2156),
    [anon_sym_for] = ACTIONS(2156),
    [anon_sym_LPAREN] = ACTIONS(2154),
    [anon_sym_await] = ACTIONS(2156),
    [anon_sym_while] = ACTIONS(2156),
    [anon_sym_do] = ACTIONS(2156),
    [anon_sym_try] = ACTIONS(2156),
    [anon_sym_with] = ACTIONS(2156),
    [anon_sym_break] = ACTIONS(2156),
    [anon_sym_continue] = ACTIONS(2156),
    [anon_sym_debugger] = ACTIONS(2156),
    [anon_sym_return] = ACTIONS(2156),
    [anon_sym_throw] = ACTIONS(2156),
    [anon_sym_SEMI] = ACTIONS(2154),
    [anon_sym_case] = ACTIONS(2156),
    [anon_sym_yield] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(2154),
    [anon_sym_SLASH] = ACTIONS(2156),
    [anon_sym_class] = ACTIONS(2156),
    [anon_sym_async] = ACTIONS(2156),
    [anon_sym_function] = ACTIONS(2156),
    [anon_sym_new] = ACTIONS(2156),
    [anon_sym_PLUS] = ACTIONS(2156),
    [anon_sym_DASH] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_void] = ACTIONS(2156),
    [anon_sym_delete] = ACTIONS(2156),
    [anon_sym_PLUS_PLUS] = ACTIONS(2154),
    [anon_sym_DASH_DASH] = ACTIONS(2154),
    [anon_sym_DQUOTE] = ACTIONS(2154),
    [anon_sym_SQUOTE] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2154),
    [sym_number] = ACTIONS(2154),
    [sym_this] = ACTIONS(2156),
    [sym_super] = ACTIONS(2156),
    [sym_true] = ACTIONS(2156),
    [sym_false] = ACTIONS(2156),
    [sym_null] = ACTIONS(2156),
    [sym_undefined] = ACTIONS(2156),
    [anon_sym_AT] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2156),
    [anon_sym_readonly] = ACTIONS(2156),
    [anon_sym_get] = ACTIONS(2156),
    [anon_sym_set] = ACTIONS(2156),
    [anon_sym_declare] = ACTIONS(2156),
    [anon_sym_public] = ACTIONS(2156),
    [anon_sym_private] = ACTIONS(2156),
    [anon_sym_protected] = ACTIONS(2156),
    [anon_sym_override] = ACTIONS(2156),
    [anon_sym_module] = ACTIONS(2156),
    [anon_sym_any] = ACTIONS(2156),
    [anon_sym_number] = ACTIONS(2156),
    [anon_sym_boolean] = ACTIONS(2156),
    [anon_sym_string] = ACTIONS(2156),
    [anon_sym_symbol] = ACTIONS(2156),
    [anon_sym_abstract] = ACTIONS(2156),
    [anon_sym_interface] = ACTIONS(2156),
    [anon_sym_enum] = ACTIONS(2156),
  },
  [667] = {
    [ts_builtin_sym_end] = ACTIONS(2158),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(2158),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2158),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LT] = ACTIONS(2158),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2158),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2158),
    [anon_sym_DASH_DASH] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_SQUOTE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2158),
    [sym_number] = ACTIONS(2158),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2158),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
  },
  [668] = {
    [ts_builtin_sym_end] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_export] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_namespace] = ACTIONS(2164),
    [anon_sym_LBRACE] = ACTIONS(2162),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_typeof] = ACTIONS(2164),
    [anon_sym_import] = ACTIONS(2164),
    [anon_sym_var] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_else] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_switch] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2162),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [anon_sym_do] = ACTIONS(2164),
    [anon_sym_try] = ACTIONS(2164),
    [anon_sym_with] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_debugger] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_throw] = ACTIONS(2164),
    [anon_sym_SEMI] = ACTIONS(2162),
    [anon_sym_case] = ACTIONS(2164),
    [anon_sym_yield] = ACTIONS(2164),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_LT] = ACTIONS(2162),
    [anon_sym_SLASH] = ACTIONS(2164),
    [anon_sym_class] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_function] = ACTIONS(2164),
    [anon_sym_new] = ACTIONS(2164),
    [anon_sym_PLUS] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2164),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_void] = ACTIONS(2164),
    [anon_sym_delete] = ACTIONS(2164),
    [anon_sym_PLUS_PLUS] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2162),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [anon_sym_SQUOTE] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [sym_number] = ACTIONS(2162),
    [sym_this] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_true] = ACTIONS(2164),
    [sym_false] = ACTIONS(2164),
    [sym_null] = ACTIONS(2164),
    [sym_undefined] = ACTIONS(2164),
    [anon_sym_AT] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_readonly] = ACTIONS(2164),
    [anon_sym_get] = ACTIONS(2164),
    [anon_sym_set] = ACTIONS(2164),
    [anon_sym_declare] = ACTIONS(2164),
    [anon_sym_public] = ACTIONS(2164),
    [anon_sym_private] = ACTIONS(2164),
    [anon_sym_protected] = ACTIONS(2164),
    [anon_sym_override] = ACTIONS(2164),
    [anon_sym_module] = ACTIONS(2164),
    [anon_sym_any] = ACTIONS(2164),
    [anon_sym_number] = ACTIONS(2164),
    [anon_sym_boolean] = ACTIONS(2164),
    [anon_sym_string] = ACTIONS(2164),
    [anon_sym_symbol] = ACTIONS(2164),
    [anon_sym_abstract] = ACTIONS(2164),
    [anon_sym_interface] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
  },
  [669] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [670] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [671] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [672] = {
    [ts_builtin_sym_end] = ACTIONS(2166),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2168),
    [anon_sym_import] = ACTIONS(2168),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_else] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_switch] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_do] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [anon_sym_with] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_debugger] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_throw] = ACTIONS(2168),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2168),
    [anon_sym_yield] = ACTIONS(2168),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2168),
    [anon_sym_class] = ACTIONS(2168),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_function] = ACTIONS(2168),
    [anon_sym_new] = ACTIONS(2168),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2168),
    [anon_sym_delete] = ACTIONS(2168),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_this] = ACTIONS(2168),
    [sym_super] = ACTIONS(2168),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [sym_null] = ACTIONS(2168),
    [sym_undefined] = ACTIONS(2168),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2168),
    [anon_sym_set] = ACTIONS(2168),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_abstract] = ACTIONS(2168),
    [anon_sym_interface] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
  },
  [673] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [674] = {
    [ts_builtin_sym_end] = ACTIONS(2170),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2170),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_typeof] = ACTIONS(2172),
    [anon_sym_import] = ACTIONS(2172),
    [anon_sym_var] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2170),
    [anon_sym_else] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2170),
    [anon_sym_await] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_with] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_debugger] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_case] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_LT] = ACTIONS(2170),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_function] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2170),
    [anon_sym_void] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_DQUOTE] = ACTIONS(2170),
    [anon_sym_SQUOTE] = ACTIONS(2170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2170),
    [sym_number] = ACTIONS(2170),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(2170),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_abstract] = ACTIONS(2172),
    [anon_sym_interface] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
  },
  [675] = {
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_identifier] = ACTIONS(2176),
    [anon_sym_export] = ACTIONS(2176),
    [anon_sym_default] = ACTIONS(2176),
    [anon_sym_type] = ACTIONS(2176),
    [anon_sym_namespace] = ACTIONS(2176),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [anon_sym_typeof] = ACTIONS(2176),
    [anon_sym_import] = ACTIONS(2176),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_else] = ACTIONS(2176),
    [anon_sym_if] = ACTIONS(2176),
    [anon_sym_switch] = ACTIONS(2176),
    [anon_sym_for] = ACTIONS(2176),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_await] = ACTIONS(2176),
    [anon_sym_while] = ACTIONS(2176),
    [anon_sym_do] = ACTIONS(2176),
    [anon_sym_try] = ACTIONS(2176),
    [anon_sym_with] = ACTIONS(2176),
    [anon_sym_break] = ACTIONS(2176),
    [anon_sym_continue] = ACTIONS(2176),
    [anon_sym_debugger] = ACTIONS(2176),
    [anon_sym_return] = ACTIONS(2176),
    [anon_sym_throw] = ACTIONS(2176),
    [anon_sym_SEMI] = ACTIONS(2174),
    [anon_sym_case] = ACTIONS(2176),
    [anon_sym_yield] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2176),
    [anon_sym_class] = ACTIONS(2176),
    [anon_sym_async] = ACTIONS(2176),
    [anon_sym_function] = ACTIONS(2176),
    [anon_sym_new] = ACTIONS(2176),
    [anon_sym_PLUS] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2174),
    [anon_sym_void] = ACTIONS(2176),
    [anon_sym_delete] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2174),
    [anon_sym_DASH_DASH] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2174),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2174),
    [sym_number] = ACTIONS(2174),
    [sym_this] = ACTIONS(2176),
    [sym_super] = ACTIONS(2176),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [sym_null] = ACTIONS(2176),
    [sym_undefined] = ACTIONS(2176),
    [anon_sym_AT] = ACTIONS(2174),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_readonly] = ACTIONS(2176),
    [anon_sym_get] = ACTIONS(2176),
    [anon_sym_set] = ACTIONS(2176),
    [anon_sym_declare] = ACTIONS(2176),
    [anon_sym_public] = ACTIONS(2176),
    [anon_sym_private] = ACTIONS(2176),
    [anon_sym_protected] = ACTIONS(2176),
    [anon_sym_override] = ACTIONS(2176),
    [anon_sym_module] = ACTIONS(2176),
    [anon_sym_any] = ACTIONS(2176),
    [anon_sym_number] = ACTIONS(2176),
    [anon_sym_boolean] = ACTIONS(2176),
    [anon_sym_string] = ACTIONS(2176),
    [anon_sym_symbol] = ACTIONS(2176),
    [anon_sym_abstract] = ACTIONS(2176),
    [anon_sym_interface] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
  },
  [676] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [677] = {
    [ts_builtin_sym_end] = ACTIONS(2178),
    [sym_identifier] = ACTIONS(2180),
    [anon_sym_export] = ACTIONS(2180),
    [anon_sym_default] = ACTIONS(2180),
    [anon_sym_type] = ACTIONS(2180),
    [anon_sym_namespace] = ACTIONS(2180),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2180),
    [anon_sym_import] = ACTIONS(2180),
    [anon_sym_var] = ACTIONS(2180),
    [anon_sym_let] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_else] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2180),
    [anon_sym_switch] = ACTIONS(2180),
    [anon_sym_for] = ACTIONS(2180),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_await] = ACTIONS(2180),
    [anon_sym_while] = ACTIONS(2180),
    [anon_sym_do] = ACTIONS(2180),
    [anon_sym_try] = ACTIONS(2180),
    [anon_sym_with] = ACTIONS(2180),
    [anon_sym_break] = ACTIONS(2180),
    [anon_sym_continue] = ACTIONS(2180),
    [anon_sym_debugger] = ACTIONS(2180),
    [anon_sym_return] = ACTIONS(2180),
    [anon_sym_throw] = ACTIONS(2180),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_case] = ACTIONS(2180),
    [anon_sym_yield] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2180),
    [anon_sym_class] = ACTIONS(2180),
    [anon_sym_async] = ACTIONS(2180),
    [anon_sym_function] = ACTIONS(2180),
    [anon_sym_new] = ACTIONS(2180),
    [anon_sym_PLUS] = ACTIONS(2180),
    [anon_sym_DASH] = ACTIONS(2180),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_void] = ACTIONS(2180),
    [anon_sym_delete] = ACTIONS(2180),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2178),
    [sym_number] = ACTIONS(2178),
    [sym_this] = ACTIONS(2180),
    [sym_super] = ACTIONS(2180),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [sym_null] = ACTIONS(2180),
    [sym_undefined] = ACTIONS(2180),
    [anon_sym_AT] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_readonly] = ACTIONS(2180),
    [anon_sym_get] = ACTIONS(2180),
    [anon_sym_set] = ACTIONS(2180),
    [anon_sym_declare] = ACTIONS(2180),
    [anon_sym_public] = ACTIONS(2180),
    [anon_sym_private] = ACTIONS(2180),
    [anon_sym_protected] = ACTIONS(2180),
    [anon_sym_override] = ACTIONS(2180),
    [anon_sym_module] = ACTIONS(2180),
    [anon_sym_any] = ACTIONS(2180),
    [anon_sym_number] = ACTIONS(2180),
    [anon_sym_boolean] = ACTIONS(2180),
    [anon_sym_string] = ACTIONS(2180),
    [anon_sym_symbol] = ACTIONS(2180),
    [anon_sym_abstract] = ACTIONS(2180),
    [anon_sym_interface] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
  },
  [678] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [679] = {
    [ts_builtin_sym_end] = ACTIONS(2182),
    [sym_identifier] = ACTIONS(2184),
    [anon_sym_export] = ACTIONS(2184),
    [anon_sym_default] = ACTIONS(2184),
    [anon_sym_type] = ACTIONS(2184),
    [anon_sym_namespace] = ACTIONS(2184),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2184),
    [anon_sym_import] = ACTIONS(2184),
    [anon_sym_var] = ACTIONS(2184),
    [anon_sym_let] = ACTIONS(2184),
    [anon_sym_const] = ACTIONS(2184),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2184),
    [anon_sym_if] = ACTIONS(2184),
    [anon_sym_switch] = ACTIONS(2184),
    [anon_sym_for] = ACTIONS(2184),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2184),
    [anon_sym_while] = ACTIONS(2184),
    [anon_sym_do] = ACTIONS(2184),
    [anon_sym_try] = ACTIONS(2184),
    [anon_sym_with] = ACTIONS(2184),
    [anon_sym_break] = ACTIONS(2184),
    [anon_sym_continue] = ACTIONS(2184),
    [anon_sym_debugger] = ACTIONS(2184),
    [anon_sym_return] = ACTIONS(2184),
    [anon_sym_throw] = ACTIONS(2184),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_case] = ACTIONS(2184),
    [anon_sym_yield] = ACTIONS(2184),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2184),
    [anon_sym_class] = ACTIONS(2184),
    [anon_sym_async] = ACTIONS(2184),
    [anon_sym_function] = ACTIONS(2184),
    [anon_sym_new] = ACTIONS(2184),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_DASH] = ACTIONS(2184),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2184),
    [anon_sym_delete] = ACTIONS(2184),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_this] = ACTIONS(2184),
    [sym_super] = ACTIONS(2184),
    [sym_true] = ACTIONS(2184),
    [sym_false] = ACTIONS(2184),
    [sym_null] = ACTIONS(2184),
    [sym_undefined] = ACTIONS(2184),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2184),
    [anon_sym_readonly] = ACTIONS(2184),
    [anon_sym_get] = ACTIONS(2184),
    [anon_sym_set] = ACTIONS(2184),
    [anon_sym_declare] = ACTIONS(2184),
    [anon_sym_public] = ACTIONS(2184),
    [anon_sym_private] = ACTIONS(2184),
    [anon_sym_protected] = ACTIONS(2184),
    [anon_sym_override] = ACTIONS(2184),
    [anon_sym_module] = ACTIONS(2184),
    [anon_sym_any] = ACTIONS(2184),
    [anon_sym_number] = ACTIONS(2184),
    [anon_sym_boolean] = ACTIONS(2184),
    [anon_sym_string] = ACTIONS(2184),
    [anon_sym_symbol] = ACTIONS(2184),
    [anon_sym_abstract] = ACTIONS(2184),
    [anon_sym_interface] = ACTIONS(2184),
    [anon_sym_enum] = ACTIONS(2184),
  },
  [680] = {
    [ts_builtin_sym_end] = ACTIONS(2186),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_default] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_RBRACE] = ACTIONS(2186),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2186),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2186),
    [anon_sym_DQUOTE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [sym_number] = ACTIONS(2186),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
  },
  [681] = {
    [ts_builtin_sym_end] = ACTIONS(2190),
    [sym_identifier] = ACTIONS(2192),
    [anon_sym_export] = ACTIONS(2192),
    [anon_sym_default] = ACTIONS(2192),
    [anon_sym_type] = ACTIONS(2192),
    [anon_sym_namespace] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2190),
    [anon_sym_typeof] = ACTIONS(2192),
    [anon_sym_import] = ACTIONS(2192),
    [anon_sym_var] = ACTIONS(2192),
    [anon_sym_let] = ACTIONS(2192),
    [anon_sym_const] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(2192),
    [anon_sym_switch] = ACTIONS(2192),
    [anon_sym_for] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2190),
    [anon_sym_await] = ACTIONS(2192),
    [anon_sym_while] = ACTIONS(2192),
    [anon_sym_do] = ACTIONS(2192),
    [anon_sym_try] = ACTIONS(2192),
    [anon_sym_with] = ACTIONS(2192),
    [anon_sym_break] = ACTIONS(2192),
    [anon_sym_continue] = ACTIONS(2192),
    [anon_sym_debugger] = ACTIONS(2192),
    [anon_sym_return] = ACTIONS(2192),
    [anon_sym_throw] = ACTIONS(2192),
    [anon_sym_SEMI] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2192),
    [anon_sym_yield] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_class] = ACTIONS(2192),
    [anon_sym_async] = ACTIONS(2192),
    [anon_sym_function] = ACTIONS(2192),
    [anon_sym_new] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2190),
    [anon_sym_void] = ACTIONS(2192),
    [anon_sym_delete] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2190),
    [anon_sym_DQUOTE] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2190),
    [sym_number] = ACTIONS(2190),
    [sym_this] = ACTIONS(2192),
    [sym_super] = ACTIONS(2192),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_undefined] = ACTIONS(2192),
    [anon_sym_AT] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2192),
    [anon_sym_readonly] = ACTIONS(2192),
    [anon_sym_get] = ACTIONS(2192),
    [anon_sym_set] = ACTIONS(2192),
    [anon_sym_declare] = ACTIONS(2192),
    [anon_sym_public] = ACTIONS(2192),
    [anon_sym_private] = ACTIONS(2192),
    [anon_sym_protected] = ACTIONS(2192),
    [anon_sym_override] = ACTIONS(2192),
    [anon_sym_module] = ACTIONS(2192),
    [anon_sym_any] = ACTIONS(2192),
    [anon_sym_number] = ACTIONS(2192),
    [anon_sym_boolean] = ACTIONS(2192),
    [anon_sym_string] = ACTIONS(2192),
    [anon_sym_symbol] = ACTIONS(2192),
    [anon_sym_abstract] = ACTIONS(2192),
    [anon_sym_interface] = ACTIONS(2192),
    [anon_sym_enum] = ACTIONS(2192),
  },
  [682] = {
    [ts_builtin_sym_end] = ACTIONS(2190),
    [sym_identifier] = ACTIONS(2192),
    [anon_sym_export] = ACTIONS(2192),
    [anon_sym_default] = ACTIONS(2192),
    [anon_sym_type] = ACTIONS(2192),
    [anon_sym_namespace] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2190),
    [anon_sym_typeof] = ACTIONS(2192),
    [anon_sym_import] = ACTIONS(2192),
    [anon_sym_var] = ACTIONS(2192),
    [anon_sym_let] = ACTIONS(2192),
    [anon_sym_const] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(2192),
    [anon_sym_switch] = ACTIONS(2192),
    [anon_sym_for] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2190),
    [anon_sym_await] = ACTIONS(2192),
    [anon_sym_while] = ACTIONS(2192),
    [anon_sym_do] = ACTIONS(2192),
    [anon_sym_try] = ACTIONS(2192),
    [anon_sym_with] = ACTIONS(2192),
    [anon_sym_break] = ACTIONS(2192),
    [anon_sym_continue] = ACTIONS(2192),
    [anon_sym_debugger] = ACTIONS(2192),
    [anon_sym_return] = ACTIONS(2192),
    [anon_sym_throw] = ACTIONS(2192),
    [anon_sym_SEMI] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2192),
    [anon_sym_yield] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_class] = ACTIONS(2192),
    [anon_sym_async] = ACTIONS(2192),
    [anon_sym_function] = ACTIONS(2192),
    [anon_sym_new] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2190),
    [anon_sym_void] = ACTIONS(2192),
    [anon_sym_delete] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2190),
    [anon_sym_DQUOTE] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2190),
    [sym_number] = ACTIONS(2190),
    [sym_this] = ACTIONS(2192),
    [sym_super] = ACTIONS(2192),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_undefined] = ACTIONS(2192),
    [anon_sym_AT] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2192),
    [anon_sym_readonly] = ACTIONS(2192),
    [anon_sym_get] = ACTIONS(2192),
    [anon_sym_set] = ACTIONS(2192),
    [anon_sym_declare] = ACTIONS(2192),
    [anon_sym_public] = ACTIONS(2192),
    [anon_sym_private] = ACTIONS(2192),
    [anon_sym_protected] = ACTIONS(2192),
    [anon_sym_override] = ACTIONS(2192),
    [anon_sym_module] = ACTIONS(2192),
    [anon_sym_any] = ACTIONS(2192),
    [anon_sym_number] = ACTIONS(2192),
    [anon_sym_boolean] = ACTIONS(2192),
    [anon_sym_string] = ACTIONS(2192),
    [anon_sym_symbol] = ACTIONS(2192),
    [anon_sym_abstract] = ACTIONS(2192),
    [anon_sym_interface] = ACTIONS(2192),
    [anon_sym_enum] = ACTIONS(2192),
  },
  [683] = {
    [ts_builtin_sym_end] = ACTIONS(2194),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_default] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2194),
    [anon_sym_RBRACE] = ACTIONS(2194),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_else] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2194),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2194),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2194),
    [anon_sym_DQUOTE] = ACTIONS(2194),
    [anon_sym_SQUOTE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2194),
    [sym_number] = ACTIONS(2194),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
  },
  [684] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [685] = {
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_identifier] = ACTIONS(2200),
    [anon_sym_export] = ACTIONS(2200),
    [anon_sym_default] = ACTIONS(2200),
    [anon_sym_type] = ACTIONS(2200),
    [anon_sym_namespace] = ACTIONS(2200),
    [anon_sym_LBRACE] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(2198),
    [anon_sym_typeof] = ACTIONS(2200),
    [anon_sym_import] = ACTIONS(2200),
    [anon_sym_var] = ACTIONS(2200),
    [anon_sym_let] = ACTIONS(2200),
    [anon_sym_const] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_else] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(2200),
    [anon_sym_switch] = ACTIONS(2200),
    [anon_sym_for] = ACTIONS(2200),
    [anon_sym_LPAREN] = ACTIONS(2198),
    [anon_sym_await] = ACTIONS(2200),
    [anon_sym_while] = ACTIONS(2200),
    [anon_sym_do] = ACTIONS(2200),
    [anon_sym_try] = ACTIONS(2200),
    [anon_sym_with] = ACTIONS(2200),
    [anon_sym_break] = ACTIONS(2200),
    [anon_sym_continue] = ACTIONS(2200),
    [anon_sym_debugger] = ACTIONS(2200),
    [anon_sym_return] = ACTIONS(2200),
    [anon_sym_throw] = ACTIONS(2200),
    [anon_sym_SEMI] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2200),
    [anon_sym_yield] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2200),
    [anon_sym_class] = ACTIONS(2200),
    [anon_sym_async] = ACTIONS(2200),
    [anon_sym_function] = ACTIONS(2200),
    [anon_sym_new] = ACTIONS(2200),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2198),
    [anon_sym_void] = ACTIONS(2200),
    [anon_sym_delete] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2198),
    [anon_sym_DQUOTE] = ACTIONS(2198),
    [anon_sym_SQUOTE] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2198),
    [sym_number] = ACTIONS(2198),
    [sym_this] = ACTIONS(2200),
    [sym_super] = ACTIONS(2200),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_undefined] = ACTIONS(2200),
    [anon_sym_AT] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2200),
    [anon_sym_readonly] = ACTIONS(2200),
    [anon_sym_get] = ACTIONS(2200),
    [anon_sym_set] = ACTIONS(2200),
    [anon_sym_declare] = ACTIONS(2200),
    [anon_sym_public] = ACTIONS(2200),
    [anon_sym_private] = ACTIONS(2200),
    [anon_sym_protected] = ACTIONS(2200),
    [anon_sym_override] = ACTIONS(2200),
    [anon_sym_module] = ACTIONS(2200),
    [anon_sym_any] = ACTIONS(2200),
    [anon_sym_number] = ACTIONS(2200),
    [anon_sym_boolean] = ACTIONS(2200),
    [anon_sym_string] = ACTIONS(2200),
    [anon_sym_symbol] = ACTIONS(2200),
    [anon_sym_abstract] = ACTIONS(2200),
    [anon_sym_interface] = ACTIONS(2200),
    [anon_sym_enum] = ACTIONS(2200),
  },
  [686] = {
    [ts_builtin_sym_end] = ACTIONS(2202),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_default] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2202),
    [anon_sym_RBRACE] = ACTIONS(2202),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2202),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2202),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2202),
    [anon_sym_case] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2202),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2202),
    [anon_sym_DQUOTE] = ACTIONS(2202),
    [anon_sym_SQUOTE] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2202),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_readonly] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
  },
  [687] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [688] = {
    [ts_builtin_sym_end] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2208),
    [anon_sym_export] = ACTIONS(2208),
    [anon_sym_default] = ACTIONS(2208),
    [anon_sym_type] = ACTIONS(2208),
    [anon_sym_namespace] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2206),
    [anon_sym_typeof] = ACTIONS(2208),
    [anon_sym_import] = ACTIONS(2208),
    [anon_sym_var] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_else] = ACTIONS(2208),
    [anon_sym_if] = ACTIONS(2208),
    [anon_sym_switch] = ACTIONS(2208),
    [anon_sym_for] = ACTIONS(2208),
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2208),
    [anon_sym_while] = ACTIONS(2208),
    [anon_sym_do] = ACTIONS(2208),
    [anon_sym_try] = ACTIONS(2208),
    [anon_sym_with] = ACTIONS(2208),
    [anon_sym_break] = ACTIONS(2208),
    [anon_sym_continue] = ACTIONS(2208),
    [anon_sym_debugger] = ACTIONS(2208),
    [anon_sym_return] = ACTIONS(2208),
    [anon_sym_throw] = ACTIONS(2208),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2208),
    [anon_sym_yield] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2208),
    [anon_sym_class] = ACTIONS(2208),
    [anon_sym_async] = ACTIONS(2208),
    [anon_sym_function] = ACTIONS(2208),
    [anon_sym_new] = ACTIONS(2208),
    [anon_sym_PLUS] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_void] = ACTIONS(2208),
    [anon_sym_delete] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2206),
    [anon_sym_DQUOTE] = ACTIONS(2206),
    [anon_sym_SQUOTE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2206),
    [sym_number] = ACTIONS(2206),
    [sym_this] = ACTIONS(2208),
    [sym_super] = ACTIONS(2208),
    [sym_true] = ACTIONS(2208),
    [sym_false] = ACTIONS(2208),
    [sym_null] = ACTIONS(2208),
    [sym_undefined] = ACTIONS(2208),
    [anon_sym_AT] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_readonly] = ACTIONS(2208),
    [anon_sym_get] = ACTIONS(2208),
    [anon_sym_set] = ACTIONS(2208),
    [anon_sym_declare] = ACTIONS(2208),
    [anon_sym_public] = ACTIONS(2208),
    [anon_sym_private] = ACTIONS(2208),
    [anon_sym_protected] = ACTIONS(2208),
    [anon_sym_override] = ACTIONS(2208),
    [anon_sym_module] = ACTIONS(2208),
    [anon_sym_any] = ACTIONS(2208),
    [anon_sym_number] = ACTIONS(2208),
    [anon_sym_boolean] = ACTIONS(2208),
    [anon_sym_string] = ACTIONS(2208),
    [anon_sym_symbol] = ACTIONS(2208),
    [anon_sym_abstract] = ACTIONS(2208),
    [anon_sym_interface] = ACTIONS(2208),
    [anon_sym_enum] = ACTIONS(2208),
  },
  [689] = {
    [ts_builtin_sym_end] = ACTIONS(2210),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_default] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2210),
    [anon_sym_RBRACE] = ACTIONS(2210),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_import] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_else] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2210),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2210),
    [anon_sym_case] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_LT] = ACTIONS(2210),
    [anon_sym_SLASH] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_function] = ACTIONS(2212),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2210),
    [anon_sym_void] = ACTIONS(2212),
    [anon_sym_delete] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2210),
    [anon_sym_DQUOTE] = ACTIONS(2210),
    [anon_sym_SQUOTE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2210),
    [sym_number] = ACTIONS(2210),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
  },
  [690] = {
    [ts_builtin_sym_end] = ACTIONS(2214),
    [sym_identifier] = ACTIONS(2216),
    [anon_sym_export] = ACTIONS(2216),
    [anon_sym_default] = ACTIONS(2216),
    [anon_sym_type] = ACTIONS(2216),
    [anon_sym_namespace] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2214),
    [anon_sym_typeof] = ACTIONS(2216),
    [anon_sym_import] = ACTIONS(2216),
    [anon_sym_var] = ACTIONS(2216),
    [anon_sym_let] = ACTIONS(2216),
    [anon_sym_const] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_else] = ACTIONS(2216),
    [anon_sym_if] = ACTIONS(2216),
    [anon_sym_switch] = ACTIONS(2216),
    [anon_sym_for] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_await] = ACTIONS(2216),
    [anon_sym_while] = ACTIONS(2216),
    [anon_sym_do] = ACTIONS(2216),
    [anon_sym_try] = ACTIONS(2216),
    [anon_sym_with] = ACTIONS(2216),
    [anon_sym_break] = ACTIONS(2216),
    [anon_sym_continue] = ACTIONS(2216),
    [anon_sym_debugger] = ACTIONS(2216),
    [anon_sym_return] = ACTIONS(2216),
    [anon_sym_throw] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_case] = ACTIONS(2216),
    [anon_sym_yield] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_class] = ACTIONS(2216),
    [anon_sym_async] = ACTIONS(2216),
    [anon_sym_function] = ACTIONS(2216),
    [anon_sym_new] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2214),
    [anon_sym_void] = ACTIONS(2216),
    [anon_sym_delete] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_DQUOTE] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2214),
    [sym_number] = ACTIONS(2214),
    [sym_this] = ACTIONS(2216),
    [sym_super] = ACTIONS(2216),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_undefined] = ACTIONS(2216),
    [anon_sym_AT] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2216),
    [anon_sym_readonly] = ACTIONS(2216),
    [anon_sym_get] = ACTIONS(2216),
    [anon_sym_set] = ACTIONS(2216),
    [anon_sym_declare] = ACTIONS(2216),
    [anon_sym_public] = ACTIONS(2216),
    [anon_sym_private] = ACTIONS(2216),
    [anon_sym_protected] = ACTIONS(2216),
    [anon_sym_override] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(2216),
    [anon_sym_any] = ACTIONS(2216),
    [anon_sym_number] = ACTIONS(2216),
    [anon_sym_boolean] = ACTIONS(2216),
    [anon_sym_string] = ACTIONS(2216),
    [anon_sym_symbol] = ACTIONS(2216),
    [anon_sym_abstract] = ACTIONS(2216),
    [anon_sym_interface] = ACTIONS(2216),
    [anon_sym_enum] = ACTIONS(2216),
  },
  [691] = {
    [ts_builtin_sym_end] = ACTIONS(2218),
    [sym_identifier] = ACTIONS(2220),
    [anon_sym_export] = ACTIONS(2220),
    [anon_sym_default] = ACTIONS(2220),
    [anon_sym_type] = ACTIONS(2220),
    [anon_sym_namespace] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_RBRACE] = ACTIONS(2218),
    [anon_sym_typeof] = ACTIONS(2220),
    [anon_sym_import] = ACTIONS(2220),
    [anon_sym_var] = ACTIONS(2220),
    [anon_sym_let] = ACTIONS(2220),
    [anon_sym_const] = ACTIONS(2220),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_else] = ACTIONS(2220),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_await] = ACTIONS(2220),
    [anon_sym_while] = ACTIONS(2220),
    [anon_sym_do] = ACTIONS(2220),
    [anon_sym_try] = ACTIONS(2220),
    [anon_sym_with] = ACTIONS(2220),
    [anon_sym_break] = ACTIONS(2220),
    [anon_sym_continue] = ACTIONS(2220),
    [anon_sym_debugger] = ACTIONS(2220),
    [anon_sym_return] = ACTIONS(2220),
    [anon_sym_throw] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_case] = ACTIONS(2220),
    [anon_sym_yield] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_LT] = ACTIONS(2218),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_class] = ACTIONS(2220),
    [anon_sym_async] = ACTIONS(2220),
    [anon_sym_function] = ACTIONS(2220),
    [anon_sym_new] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_void] = ACTIONS(2220),
    [anon_sym_delete] = ACTIONS(2220),
    [anon_sym_PLUS_PLUS] = ACTIONS(2218),
    [anon_sym_DASH_DASH] = ACTIONS(2218),
    [anon_sym_DQUOTE] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2218),
    [sym_number] = ACTIONS(2218),
    [sym_this] = ACTIONS(2220),
    [sym_super] = ACTIONS(2220),
    [sym_true] = ACTIONS(2220),
    [sym_false] = ACTIONS(2220),
    [sym_null] = ACTIONS(2220),
    [sym_undefined] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2220),
    [anon_sym_readonly] = ACTIONS(2220),
    [anon_sym_get] = ACTIONS(2220),
    [anon_sym_set] = ACTIONS(2220),
    [anon_sym_declare] = ACTIONS(2220),
    [anon_sym_public] = ACTIONS(2220),
    [anon_sym_private] = ACTIONS(2220),
    [anon_sym_protected] = ACTIONS(2220),
    [anon_sym_override] = ACTIONS(2220),
    [anon_sym_module] = ACTIONS(2220),
    [anon_sym_any] = ACTIONS(2220),
    [anon_sym_number] = ACTIONS(2220),
    [anon_sym_boolean] = ACTIONS(2220),
    [anon_sym_string] = ACTIONS(2220),
    [anon_sym_symbol] = ACTIONS(2220),
    [anon_sym_abstract] = ACTIONS(2220),
    [anon_sym_interface] = ACTIONS(2220),
    [anon_sym_enum] = ACTIONS(2220),
  },
  [692] = {
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_export] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_RBRACE] = ACTIONS(2222),
    [anon_sym_typeof] = ACTIONS(2224),
    [anon_sym_import] = ACTIONS(2224),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_await] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_with] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_debugger] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_yield] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2224),
    [anon_sym_function] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2222),
    [anon_sym_void] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2222),
    [anon_sym_DQUOTE] = ACTIONS(2222),
    [anon_sym_SQUOTE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2222),
    [sym_number] = ACTIONS(2222),
    [sym_this] = ACTIONS(2224),
    [sym_super] = ACTIONS(2224),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_undefined] = ACTIONS(2224),
    [anon_sym_AT] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_readonly] = ACTIONS(2224),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_declare] = ACTIONS(2224),
    [anon_sym_public] = ACTIONS(2224),
    [anon_sym_private] = ACTIONS(2224),
    [anon_sym_protected] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [anon_sym_module] = ACTIONS(2224),
    [anon_sym_any] = ACTIONS(2224),
    [anon_sym_number] = ACTIONS(2224),
    [anon_sym_boolean] = ACTIONS(2224),
    [anon_sym_string] = ACTIONS(2224),
    [anon_sym_symbol] = ACTIONS(2224),
    [anon_sym_abstract] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
  },
  [693] = {
    [ts_builtin_sym_end] = ACTIONS(2226),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_export] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_type] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2228),
    [anon_sym_import] = ACTIONS(2228),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_with] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_debugger] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_case] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_void] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_number] = ACTIONS(2226),
    [sym_this] = ACTIONS(2228),
    [sym_super] = ACTIONS(2228),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [sym_null] = ACTIONS(2228),
    [sym_undefined] = ACTIONS(2228),
    [anon_sym_AT] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_readonly] = ACTIONS(2228),
    [anon_sym_get] = ACTIONS(2228),
    [anon_sym_set] = ACTIONS(2228),
    [anon_sym_declare] = ACTIONS(2228),
    [anon_sym_public] = ACTIONS(2228),
    [anon_sym_private] = ACTIONS(2228),
    [anon_sym_protected] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [anon_sym_module] = ACTIONS(2228),
    [anon_sym_any] = ACTIONS(2228),
    [anon_sym_number] = ACTIONS(2228),
    [anon_sym_boolean] = ACTIONS(2228),
    [anon_sym_string] = ACTIONS(2228),
    [anon_sym_symbol] = ACTIONS(2228),
    [anon_sym_abstract] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
  },
  [694] = {
    [ts_builtin_sym_end] = ACTIONS(2230),
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_export] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_type] = ACTIONS(2232),
    [anon_sym_namespace] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_typeof] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(2232),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_else] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_await] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_with] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_debugger] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_yield] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LT] = ACTIONS(2230),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_async] = ACTIONS(2232),
    [anon_sym_function] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_void] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2230),
    [sym_number] = ACTIONS(2230),
    [sym_this] = ACTIONS(2232),
    [sym_super] = ACTIONS(2232),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [sym_null] = ACTIONS(2232),
    [sym_undefined] = ACTIONS(2232),
    [anon_sym_AT] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_readonly] = ACTIONS(2232),
    [anon_sym_get] = ACTIONS(2232),
    [anon_sym_set] = ACTIONS(2232),
    [anon_sym_declare] = ACTIONS(2232),
    [anon_sym_public] = ACTIONS(2232),
    [anon_sym_private] = ACTIONS(2232),
    [anon_sym_protected] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [anon_sym_module] = ACTIONS(2232),
    [anon_sym_any] = ACTIONS(2232),
    [anon_sym_number] = ACTIONS(2232),
    [anon_sym_boolean] = ACTIONS(2232),
    [anon_sym_string] = ACTIONS(2232),
    [anon_sym_symbol] = ACTIONS(2232),
    [anon_sym_abstract] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
  },
  [695] = {
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_export] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_type] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_typeof] = ACTIONS(2236),
    [anon_sym_import] = ACTIONS(2236),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_with] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_debugger] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_yield] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2236),
    [anon_sym_function] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_void] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [sym_number] = ACTIONS(2234),
    [sym_this] = ACTIONS(2236),
    [sym_super] = ACTIONS(2236),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [sym_null] = ACTIONS(2236),
    [sym_undefined] = ACTIONS(2236),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_readonly] = ACTIONS(2236),
    [anon_sym_get] = ACTIONS(2236),
    [anon_sym_set] = ACTIONS(2236),
    [anon_sym_declare] = ACTIONS(2236),
    [anon_sym_public] = ACTIONS(2236),
    [anon_sym_private] = ACTIONS(2236),
    [anon_sym_protected] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [anon_sym_module] = ACTIONS(2236),
    [anon_sym_any] = ACTIONS(2236),
    [anon_sym_number] = ACTIONS(2236),
    [anon_sym_boolean] = ACTIONS(2236),
    [anon_sym_string] = ACTIONS(2236),
    [anon_sym_symbol] = ACTIONS(2236),
    [anon_sym_abstract] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
  },
  [696] = {
    [ts_builtin_sym_end] = ACTIONS(2238),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_export] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_type] = ACTIONS(2240),
    [anon_sym_namespace] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_typeof] = ACTIONS(2240),
    [anon_sym_import] = ACTIONS(2240),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_else] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2238),
    [anon_sym_await] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_with] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_debugger] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_async] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_void] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2238),
    [sym_number] = ACTIONS(2238),
    [sym_this] = ACTIONS(2240),
    [sym_super] = ACTIONS(2240),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [sym_null] = ACTIONS(2240),
    [sym_undefined] = ACTIONS(2240),
    [anon_sym_AT] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_readonly] = ACTIONS(2240),
    [anon_sym_get] = ACTIONS(2240),
    [anon_sym_set] = ACTIONS(2240),
    [anon_sym_declare] = ACTIONS(2240),
    [anon_sym_public] = ACTIONS(2240),
    [anon_sym_private] = ACTIONS(2240),
    [anon_sym_protected] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [anon_sym_module] = ACTIONS(2240),
    [anon_sym_any] = ACTIONS(2240),
    [anon_sym_number] = ACTIONS(2240),
    [anon_sym_boolean] = ACTIONS(2240),
    [anon_sym_string] = ACTIONS(2240),
    [anon_sym_symbol] = ACTIONS(2240),
    [anon_sym_abstract] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
  },
  [697] = {
    [ts_builtin_sym_end] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_export] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_type] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2244),
    [anon_sym_import] = ACTIONS(2244),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_with] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_debugger] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_async] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_void] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2242),
    [sym_number] = ACTIONS(2242),
    [sym_this] = ACTIONS(2244),
    [sym_super] = ACTIONS(2244),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [sym_null] = ACTIONS(2244),
    [sym_undefined] = ACTIONS(2244),
    [anon_sym_AT] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_readonly] = ACTIONS(2244),
    [anon_sym_get] = ACTIONS(2244),
    [anon_sym_set] = ACTIONS(2244),
    [anon_sym_declare] = ACTIONS(2244),
    [anon_sym_public] = ACTIONS(2244),
    [anon_sym_private] = ACTIONS(2244),
    [anon_sym_protected] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [anon_sym_module] = ACTIONS(2244),
    [anon_sym_any] = ACTIONS(2244),
    [anon_sym_number] = ACTIONS(2244),
    [anon_sym_boolean] = ACTIONS(2244),
    [anon_sym_string] = ACTIONS(2244),
    [anon_sym_symbol] = ACTIONS(2244),
    [anon_sym_abstract] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
  },
  [698] = {
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_export] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_typeof] = ACTIONS(2248),
    [anon_sym_import] = ACTIONS(2248),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_await] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_with] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_debugger] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(2246),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_async] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_void] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2246),
    [sym_number] = ACTIONS(2246),
    [sym_this] = ACTIONS(2248),
    [sym_super] = ACTIONS(2248),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [sym_null] = ACTIONS(2248),
    [sym_undefined] = ACTIONS(2248),
    [anon_sym_AT] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_readonly] = ACTIONS(2248),
    [anon_sym_get] = ACTIONS(2248),
    [anon_sym_set] = ACTIONS(2248),
    [anon_sym_declare] = ACTIONS(2248),
    [anon_sym_public] = ACTIONS(2248),
    [anon_sym_private] = ACTIONS(2248),
    [anon_sym_protected] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [anon_sym_module] = ACTIONS(2248),
    [anon_sym_any] = ACTIONS(2248),
    [anon_sym_number] = ACTIONS(2248),
    [anon_sym_boolean] = ACTIONS(2248),
    [anon_sym_string] = ACTIONS(2248),
    [anon_sym_symbol] = ACTIONS(2248),
    [anon_sym_abstract] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
  },
  [699] = {
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_export] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_type] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_typeof] = ACTIONS(2252),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_with] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_debugger] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_async] = ACTIONS(2252),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_this] = ACTIONS(2252),
    [sym_super] = ACTIONS(2252),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [sym_null] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_readonly] = ACTIONS(2252),
    [anon_sym_get] = ACTIONS(2252),
    [anon_sym_set] = ACTIONS(2252),
    [anon_sym_declare] = ACTIONS(2252),
    [anon_sym_public] = ACTIONS(2252),
    [anon_sym_private] = ACTIONS(2252),
    [anon_sym_protected] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [anon_sym_module] = ACTIONS(2252),
    [anon_sym_any] = ACTIONS(2252),
    [anon_sym_number] = ACTIONS(2252),
    [anon_sym_boolean] = ACTIONS(2252),
    [anon_sym_string] = ACTIONS(2252),
    [anon_sym_symbol] = ACTIONS(2252),
    [anon_sym_abstract] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
  },
  [700] = {
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_export] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_type] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_typeof] = ACTIONS(2256),
    [anon_sym_import] = ACTIONS(2256),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_await] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_with] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_debugger] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_yield] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_async] = ACTIONS(2256),
    [anon_sym_function] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_void] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2254),
    [sym_number] = ACTIONS(2254),
    [sym_this] = ACTIONS(2256),
    [sym_super] = ACTIONS(2256),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_readonly] = ACTIONS(2256),
    [anon_sym_get] = ACTIONS(2256),
    [anon_sym_set] = ACTIONS(2256),
    [anon_sym_declare] = ACTIONS(2256),
    [anon_sym_public] = ACTIONS(2256),
    [anon_sym_private] = ACTIONS(2256),
    [anon_sym_protected] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [anon_sym_module] = ACTIONS(2256),
    [anon_sym_any] = ACTIONS(2256),
    [anon_sym_number] = ACTIONS(2256),
    [anon_sym_boolean] = ACTIONS(2256),
    [anon_sym_string] = ACTIONS(2256),
    [anon_sym_symbol] = ACTIONS(2256),
    [anon_sym_abstract] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
  },
  [701] = {
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_export] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_type] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_typeof] = ACTIONS(2256),
    [anon_sym_import] = ACTIONS(2256),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_await] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_with] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_debugger] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_yield] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_async] = ACTIONS(2256),
    [anon_sym_function] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_void] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2254),
    [sym_number] = ACTIONS(2254),
    [sym_this] = ACTIONS(2256),
    [sym_super] = ACTIONS(2256),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_readonly] = ACTIONS(2256),
    [anon_sym_get] = ACTIONS(2256),
    [anon_sym_set] = ACTIONS(2256),
    [anon_sym_declare] = ACTIONS(2256),
    [anon_sym_public] = ACTIONS(2256),
    [anon_sym_private] = ACTIONS(2256),
    [anon_sym_protected] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [anon_sym_module] = ACTIONS(2256),
    [anon_sym_any] = ACTIONS(2256),
    [anon_sym_number] = ACTIONS(2256),
    [anon_sym_boolean] = ACTIONS(2256),
    [anon_sym_string] = ACTIONS(2256),
    [anon_sym_symbol] = ACTIONS(2256),
    [anon_sym_abstract] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
  },
  [702] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [703] = {
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_export] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_type] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_typeof] = ACTIONS(2256),
    [anon_sym_import] = ACTIONS(2256),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_await] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_with] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_debugger] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_yield] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_async] = ACTIONS(2256),
    [anon_sym_function] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_void] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2254),
    [sym_number] = ACTIONS(2254),
    [sym_this] = ACTIONS(2256),
    [sym_super] = ACTIONS(2256),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_readonly] = ACTIONS(2256),
    [anon_sym_get] = ACTIONS(2256),
    [anon_sym_set] = ACTIONS(2256),
    [anon_sym_declare] = ACTIONS(2256),
    [anon_sym_public] = ACTIONS(2256),
    [anon_sym_private] = ACTIONS(2256),
    [anon_sym_protected] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [anon_sym_module] = ACTIONS(2256),
    [anon_sym_any] = ACTIONS(2256),
    [anon_sym_number] = ACTIONS(2256),
    [anon_sym_boolean] = ACTIONS(2256),
    [anon_sym_string] = ACTIONS(2256),
    [anon_sym_symbol] = ACTIONS(2256),
    [anon_sym_abstract] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
  },
  [704] = {
    [ts_builtin_sym_end] = ACTIONS(2258),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2258),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_with] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2258),
    [sym_number] = ACTIONS(2258),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2258),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
  },
  [705] = {
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2262),
    [sym_number] = ACTIONS(2262),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2262),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
  },
  [706] = {
    [ts_builtin_sym_end] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_export] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_type] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_typeof] = ACTIONS(2268),
    [anon_sym_import] = ACTIONS(2268),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_else] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_LPAREN] = ACTIONS(2266),
    [anon_sym_await] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_with] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_debugger] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_yield] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_async] = ACTIONS(2268),
    [anon_sym_function] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_void] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2266),
    [sym_number] = ACTIONS(2266),
    [sym_this] = ACTIONS(2268),
    [sym_super] = ACTIONS(2268),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [sym_null] = ACTIONS(2268),
    [sym_undefined] = ACTIONS(2268),
    [anon_sym_AT] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_readonly] = ACTIONS(2268),
    [anon_sym_get] = ACTIONS(2268),
    [anon_sym_set] = ACTIONS(2268),
    [anon_sym_declare] = ACTIONS(2268),
    [anon_sym_public] = ACTIONS(2268),
    [anon_sym_private] = ACTIONS(2268),
    [anon_sym_protected] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_module] = ACTIONS(2268),
    [anon_sym_any] = ACTIONS(2268),
    [anon_sym_number] = ACTIONS(2268),
    [anon_sym_boolean] = ACTIONS(2268),
    [anon_sym_string] = ACTIONS(2268),
    [anon_sym_symbol] = ACTIONS(2268),
    [anon_sym_abstract] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
  },
  [707] = {
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2270),
    [sym_number] = ACTIONS(2270),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
  },
  [708] = {
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2270),
    [sym_number] = ACTIONS(2270),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
  },
  [709] = {
    [ts_builtin_sym_end] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_export] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_type] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_typeof] = ACTIONS(2276),
    [anon_sym_import] = ACTIONS(2276),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [anon_sym_await] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_with] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_debugger] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_yield] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2274),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_async] = ACTIONS(2276),
    [anon_sym_function] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_void] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2274),
    [sym_number] = ACTIONS(2274),
    [sym_this] = ACTIONS(2276),
    [sym_super] = ACTIONS(2276),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [sym_null] = ACTIONS(2276),
    [sym_undefined] = ACTIONS(2276),
    [anon_sym_AT] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_readonly] = ACTIONS(2276),
    [anon_sym_get] = ACTIONS(2276),
    [anon_sym_set] = ACTIONS(2276),
    [anon_sym_declare] = ACTIONS(2276),
    [anon_sym_public] = ACTIONS(2276),
    [anon_sym_private] = ACTIONS(2276),
    [anon_sym_protected] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_module] = ACTIONS(2276),
    [anon_sym_any] = ACTIONS(2276),
    [anon_sym_number] = ACTIONS(2276),
    [anon_sym_boolean] = ACTIONS(2276),
    [anon_sym_string] = ACTIONS(2276),
    [anon_sym_symbol] = ACTIONS(2276),
    [anon_sym_abstract] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
  },
  [710] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [711] = {
    [ts_builtin_sym_end] = ACTIONS(2282),
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_export] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_type] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_typeof] = ACTIONS(2284),
    [anon_sym_import] = ACTIONS(2284),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_LPAREN] = ACTIONS(2282),
    [anon_sym_await] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_with] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_debugger] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_yield] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_LT] = ACTIONS(2282),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_async] = ACTIONS(2284),
    [anon_sym_function] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_void] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2282),
    [sym_number] = ACTIONS(2282),
    [sym_this] = ACTIONS(2284),
    [sym_super] = ACTIONS(2284),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [sym_null] = ACTIONS(2284),
    [sym_undefined] = ACTIONS(2284),
    [anon_sym_AT] = ACTIONS(2282),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_readonly] = ACTIONS(2284),
    [anon_sym_get] = ACTIONS(2284),
    [anon_sym_set] = ACTIONS(2284),
    [anon_sym_declare] = ACTIONS(2284),
    [anon_sym_public] = ACTIONS(2284),
    [anon_sym_private] = ACTIONS(2284),
    [anon_sym_protected] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_module] = ACTIONS(2284),
    [anon_sym_any] = ACTIONS(2284),
    [anon_sym_number] = ACTIONS(2284),
    [anon_sym_boolean] = ACTIONS(2284),
    [anon_sym_string] = ACTIONS(2284),
    [anon_sym_symbol] = ACTIONS(2284),
    [anon_sym_abstract] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
  },
  [712] = {
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2286),
    [sym_number] = ACTIONS(2286),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
  },
  [713] = {
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [sym_number] = ACTIONS(2290),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2290),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
  },
  [714] = {
    [ts_builtin_sym_end] = ACTIONS(2294),
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_export] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_type] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_typeof] = ACTIONS(2296),
    [anon_sym_import] = ACTIONS(2296),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_await] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_with] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_debugger] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_yield] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_LT] = ACTIONS(2294),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_async] = ACTIONS(2296),
    [anon_sym_function] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_void] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2294),
    [sym_number] = ACTIONS(2294),
    [sym_this] = ACTIONS(2296),
    [sym_super] = ACTIONS(2296),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [sym_null] = ACTIONS(2296),
    [sym_undefined] = ACTIONS(2296),
    [anon_sym_AT] = ACTIONS(2294),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_readonly] = ACTIONS(2296),
    [anon_sym_get] = ACTIONS(2296),
    [anon_sym_set] = ACTIONS(2296),
    [anon_sym_declare] = ACTIONS(2296),
    [anon_sym_public] = ACTIONS(2296),
    [anon_sym_private] = ACTIONS(2296),
    [anon_sym_protected] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_module] = ACTIONS(2296),
    [anon_sym_any] = ACTIONS(2296),
    [anon_sym_number] = ACTIONS(2296),
    [anon_sym_boolean] = ACTIONS(2296),
    [anon_sym_string] = ACTIONS(2296),
    [anon_sym_symbol] = ACTIONS(2296),
    [anon_sym_abstract] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
  },
  [715] = {
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2286),
    [sym_number] = ACTIONS(2286),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
  },
  [716] = {
    [ts_builtin_sym_end] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2298),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_LT] = ACTIONS(2298),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2298),
    [sym_number] = ACTIONS(2298),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2298),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
  },
  [717] = {
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2302),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_LT] = ACTIONS(2302),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2302),
    [sym_number] = ACTIONS(2302),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2302),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
  },
  [718] = {
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2306),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_with] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_debugger] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2306),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_function] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_void] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [sym_number] = ACTIONS(2306),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2306),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_declare] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_any] = ACTIONS(2308),
    [anon_sym_number] = ACTIONS(2308),
    [anon_sym_boolean] = ACTIONS(2308),
    [anon_sym_string] = ACTIONS(2308),
    [anon_sym_symbol] = ACTIONS(2308),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
  },
  [719] = {
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2286),
    [sym_number] = ACTIONS(2286),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
  },
  [720] = {
    [ts_builtin_sym_end] = ACTIONS(1354),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(1356),
    [anon_sym_default] = ACTIONS(1356),
    [anon_sym_type] = ACTIONS(1356),
    [anon_sym_namespace] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_RBRACE] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1356),
    [anon_sym_var] = ACTIONS(1356),
    [anon_sym_let] = ACTIONS(1356),
    [anon_sym_const] = ACTIONS(1356),
    [anon_sym_BANG] = ACTIONS(1354),
    [anon_sym_else] = ACTIONS(1356),
    [anon_sym_if] = ACTIONS(1356),
    [anon_sym_switch] = ACTIONS(1356),
    [anon_sym_for] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1354),
    [anon_sym_await] = ACTIONS(1356),
    [anon_sym_while] = ACTIONS(1356),
    [anon_sym_do] = ACTIONS(1356),
    [anon_sym_try] = ACTIONS(1356),
    [anon_sym_with] = ACTIONS(1356),
    [anon_sym_break] = ACTIONS(1356),
    [anon_sym_continue] = ACTIONS(1356),
    [anon_sym_debugger] = ACTIONS(1356),
    [anon_sym_return] = ACTIONS(1356),
    [anon_sym_throw] = ACTIONS(1356),
    [anon_sym_SEMI] = ACTIONS(1354),
    [anon_sym_case] = ACTIONS(1356),
    [anon_sym_yield] = ACTIONS(1356),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_LT] = ACTIONS(1354),
    [anon_sym_SLASH] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1356),
    [anon_sym_async] = ACTIONS(1356),
    [anon_sym_function] = ACTIONS(1356),
    [anon_sym_new] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_void] = ACTIONS(1356),
    [anon_sym_delete] = ACTIONS(1356),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(1354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [sym_number] = ACTIONS(1354),
    [sym_this] = ACTIONS(1356),
    [sym_super] = ACTIONS(1356),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [sym_null] = ACTIONS(1356),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_AT] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1356),
    [anon_sym_readonly] = ACTIONS(1356),
    [anon_sym_get] = ACTIONS(1356),
    [anon_sym_set] = ACTIONS(1356),
    [anon_sym_declare] = ACTIONS(1356),
    [anon_sym_public] = ACTIONS(1356),
    [anon_sym_private] = ACTIONS(1356),
    [anon_sym_protected] = ACTIONS(1356),
    [anon_sym_override] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1356),
    [anon_sym_any] = ACTIONS(1356),
    [anon_sym_number] = ACTIONS(1356),
    [anon_sym_boolean] = ACTIONS(1356),
    [anon_sym_string] = ACTIONS(1356),
    [anon_sym_symbol] = ACTIONS(1356),
    [anon_sym_abstract] = ACTIONS(1356),
    [anon_sym_interface] = ACTIONS(1356),
    [anon_sym_enum] = ACTIONS(1356),
  },
  [721] = {
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_typeof] = ACTIONS(2312),
    [anon_sym_import] = ACTIONS(2312),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2310),
    [anon_sym_await] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_with] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_debugger] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_LT] = ACTIONS(2310),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_void] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2310),
    [sym_number] = ACTIONS(2310),
    [sym_this] = ACTIONS(2312),
    [sym_super] = ACTIONS(2312),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [sym_null] = ACTIONS(2312),
    [sym_undefined] = ACTIONS(2312),
    [anon_sym_AT] = ACTIONS(2310),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_readonly] = ACTIONS(2312),
    [anon_sym_get] = ACTIONS(2312),
    [anon_sym_set] = ACTIONS(2312),
    [anon_sym_declare] = ACTIONS(2312),
    [anon_sym_public] = ACTIONS(2312),
    [anon_sym_private] = ACTIONS(2312),
    [anon_sym_protected] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_any] = ACTIONS(2312),
    [anon_sym_number] = ACTIONS(2312),
    [anon_sym_boolean] = ACTIONS(2312),
    [anon_sym_string] = ACTIONS(2312),
    [anon_sym_symbol] = ACTIONS(2312),
    [anon_sym_abstract] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
  },
  [722] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [723] = {
    [ts_builtin_sym_end] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_export] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_type] = ACTIONS(2316),
    [anon_sym_namespace] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_typeof] = ACTIONS(2316),
    [anon_sym_import] = ACTIONS(2316),
    [anon_sym_var] = ACTIONS(2316),
    [anon_sym_let] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_else] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_switch] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_LPAREN] = ACTIONS(2314),
    [anon_sym_await] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_do] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [anon_sym_with] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_debugger] = ACTIONS(2316),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_throw] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym_case] = ACTIONS(2316),
    [anon_sym_yield] = ACTIONS(2316),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_SLASH] = ACTIONS(2316),
    [anon_sym_class] = ACTIONS(2316),
    [anon_sym_async] = ACTIONS(2316),
    [anon_sym_function] = ACTIONS(2316),
    [anon_sym_new] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_void] = ACTIONS(2316),
    [anon_sym_delete] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2314),
    [sym_number] = ACTIONS(2314),
    [sym_this] = ACTIONS(2316),
    [sym_super] = ACTIONS(2316),
    [sym_true] = ACTIONS(2316),
    [sym_false] = ACTIONS(2316),
    [sym_null] = ACTIONS(2316),
    [sym_undefined] = ACTIONS(2316),
    [anon_sym_AT] = ACTIONS(2314),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_readonly] = ACTIONS(2316),
    [anon_sym_get] = ACTIONS(2316),
    [anon_sym_set] = ACTIONS(2316),
    [anon_sym_declare] = ACTIONS(2316),
    [anon_sym_public] = ACTIONS(2316),
    [anon_sym_private] = ACTIONS(2316),
    [anon_sym_protected] = ACTIONS(2316),
    [anon_sym_override] = ACTIONS(2316),
    [anon_sym_module] = ACTIONS(2316),
    [anon_sym_any] = ACTIONS(2316),
    [anon_sym_number] = ACTIONS(2316),
    [anon_sym_boolean] = ACTIONS(2316),
    [anon_sym_string] = ACTIONS(2316),
    [anon_sym_symbol] = ACTIONS(2316),
    [anon_sym_abstract] = ACTIONS(2316),
    [anon_sym_interface] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
  },
  [724] = {
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2320),
    [anon_sym_export] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_type] = ACTIONS(2320),
    [anon_sym_namespace] = ACTIONS(2320),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_typeof] = ACTIONS(2320),
    [anon_sym_import] = ACTIONS(2320),
    [anon_sym_var] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_switch] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_await] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_do] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [anon_sym_with] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_debugger] = ACTIONS(2320),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_throw] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2320),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_SLASH] = ACTIONS(2320),
    [anon_sym_class] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_function] = ACTIONS(2320),
    [anon_sym_new] = ACTIONS(2320),
    [anon_sym_PLUS] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_void] = ACTIONS(2320),
    [anon_sym_delete] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2318),
    [sym_number] = ACTIONS(2318),
    [sym_this] = ACTIONS(2320),
    [sym_super] = ACTIONS(2320),
    [sym_true] = ACTIONS(2320),
    [sym_false] = ACTIONS(2320),
    [sym_null] = ACTIONS(2320),
    [sym_undefined] = ACTIONS(2320),
    [anon_sym_AT] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_readonly] = ACTIONS(2320),
    [anon_sym_get] = ACTIONS(2320),
    [anon_sym_set] = ACTIONS(2320),
    [anon_sym_declare] = ACTIONS(2320),
    [anon_sym_public] = ACTIONS(2320),
    [anon_sym_private] = ACTIONS(2320),
    [anon_sym_protected] = ACTIONS(2320),
    [anon_sym_override] = ACTIONS(2320),
    [anon_sym_module] = ACTIONS(2320),
    [anon_sym_any] = ACTIONS(2320),
    [anon_sym_number] = ACTIONS(2320),
    [anon_sym_boolean] = ACTIONS(2320),
    [anon_sym_string] = ACTIONS(2320),
    [anon_sym_symbol] = ACTIONS(2320),
    [anon_sym_abstract] = ACTIONS(2320),
    [anon_sym_interface] = ACTIONS(2320),
    [anon_sym_enum] = ACTIONS(2320),
  },
  [725] = {
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2320),
    [anon_sym_export] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_type] = ACTIONS(2320),
    [anon_sym_namespace] = ACTIONS(2320),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_typeof] = ACTIONS(2320),
    [anon_sym_import] = ACTIONS(2320),
    [anon_sym_var] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_switch] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_await] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_do] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [anon_sym_with] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_debugger] = ACTIONS(2320),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_throw] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2320),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_SLASH] = ACTIONS(2320),
    [anon_sym_class] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_function] = ACTIONS(2320),
    [anon_sym_new] = ACTIONS(2320),
    [anon_sym_PLUS] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_void] = ACTIONS(2320),
    [anon_sym_delete] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2318),
    [sym_number] = ACTIONS(2318),
    [sym_this] = ACTIONS(2320),
    [sym_super] = ACTIONS(2320),
    [sym_true] = ACTIONS(2320),
    [sym_false] = ACTIONS(2320),
    [sym_null] = ACTIONS(2320),
    [sym_undefined] = ACTIONS(2320),
    [anon_sym_AT] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_readonly] = ACTIONS(2320),
    [anon_sym_get] = ACTIONS(2320),
    [anon_sym_set] = ACTIONS(2320),
    [anon_sym_declare] = ACTIONS(2320),
    [anon_sym_public] = ACTIONS(2320),
    [anon_sym_private] = ACTIONS(2320),
    [anon_sym_protected] = ACTIONS(2320),
    [anon_sym_override] = ACTIONS(2320),
    [anon_sym_module] = ACTIONS(2320),
    [anon_sym_any] = ACTIONS(2320),
    [anon_sym_number] = ACTIONS(2320),
    [anon_sym_boolean] = ACTIONS(2320),
    [anon_sym_string] = ACTIONS(2320),
    [anon_sym_symbol] = ACTIONS(2320),
    [anon_sym_abstract] = ACTIONS(2320),
    [anon_sym_interface] = ACTIONS(2320),
    [anon_sym_enum] = ACTIONS(2320),
  },
  [726] = {
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2270),
    [sym_number] = ACTIONS(2270),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
  },
  [727] = {
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2270),
    [sym_number] = ACTIONS(2270),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
  },
  [728] = {
    [ts_builtin_sym_end] = ACTIONS(2322),
    [sym_identifier] = ACTIONS(2324),
    [anon_sym_export] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_type] = ACTIONS(2324),
    [anon_sym_namespace] = ACTIONS(2324),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_typeof] = ACTIONS(2324),
    [anon_sym_import] = ACTIONS(2324),
    [anon_sym_var] = ACTIONS(2324),
    [anon_sym_let] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_else] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_switch] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_await] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_do] = ACTIONS(2324),
    [anon_sym_try] = ACTIONS(2324),
    [anon_sym_with] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_debugger] = ACTIONS(2324),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_throw] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_case] = ACTIONS(2324),
    [anon_sym_yield] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_LT] = ACTIONS(2322),
    [anon_sym_SLASH] = ACTIONS(2324),
    [anon_sym_class] = ACTIONS(2324),
    [anon_sym_async] = ACTIONS(2324),
    [anon_sym_function] = ACTIONS(2324),
    [anon_sym_new] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2324),
    [anon_sym_TILDE] = ACTIONS(2322),
    [anon_sym_void] = ACTIONS(2324),
    [anon_sym_delete] = ACTIONS(2324),
    [anon_sym_PLUS_PLUS] = ACTIONS(2322),
    [anon_sym_DASH_DASH] = ACTIONS(2322),
    [anon_sym_DQUOTE] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2322),
    [sym_number] = ACTIONS(2322),
    [sym_this] = ACTIONS(2324),
    [sym_super] = ACTIONS(2324),
    [sym_true] = ACTIONS(2324),
    [sym_false] = ACTIONS(2324),
    [sym_null] = ACTIONS(2324),
    [sym_undefined] = ACTIONS(2324),
    [anon_sym_AT] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_readonly] = ACTIONS(2324),
    [anon_sym_get] = ACTIONS(2324),
    [anon_sym_set] = ACTIONS(2324),
    [anon_sym_declare] = ACTIONS(2324),
    [anon_sym_public] = ACTIONS(2324),
    [anon_sym_private] = ACTIONS(2324),
    [anon_sym_protected] = ACTIONS(2324),
    [anon_sym_override] = ACTIONS(2324),
    [anon_sym_module] = ACTIONS(2324),
    [anon_sym_any] = ACTIONS(2324),
    [anon_sym_number] = ACTIONS(2324),
    [anon_sym_boolean] = ACTIONS(2324),
    [anon_sym_string] = ACTIONS(2324),
    [anon_sym_symbol] = ACTIONS(2324),
    [anon_sym_abstract] = ACTIONS(2324),
    [anon_sym_interface] = ACTIONS(2324),
    [anon_sym_enum] = ACTIONS(2324),
  },
  [729] = {
    [ts_builtin_sym_end] = ACTIONS(2322),
    [sym_identifier] = ACTIONS(2324),
    [anon_sym_export] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_type] = ACTIONS(2324),
    [anon_sym_namespace] = ACTIONS(2324),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_typeof] = ACTIONS(2324),
    [anon_sym_import] = ACTIONS(2324),
    [anon_sym_var] = ACTIONS(2324),
    [anon_sym_let] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_else] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_switch] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_await] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_do] = ACTIONS(2324),
    [anon_sym_try] = ACTIONS(2324),
    [anon_sym_with] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_debugger] = ACTIONS(2324),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_throw] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_case] = ACTIONS(2324),
    [anon_sym_yield] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_LT] = ACTIONS(2322),
    [anon_sym_SLASH] = ACTIONS(2324),
    [anon_sym_class] = ACTIONS(2324),
    [anon_sym_async] = ACTIONS(2324),
    [anon_sym_function] = ACTIONS(2324),
    [anon_sym_new] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2324),
    [anon_sym_TILDE] = ACTIONS(2322),
    [anon_sym_void] = ACTIONS(2324),
    [anon_sym_delete] = ACTIONS(2324),
    [anon_sym_PLUS_PLUS] = ACTIONS(2322),
    [anon_sym_DASH_DASH] = ACTIONS(2322),
    [anon_sym_DQUOTE] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2322),
    [sym_number] = ACTIONS(2322),
    [sym_this] = ACTIONS(2324),
    [sym_super] = ACTIONS(2324),
    [sym_true] = ACTIONS(2324),
    [sym_false] = ACTIONS(2324),
    [sym_null] = ACTIONS(2324),
    [sym_undefined] = ACTIONS(2324),
    [anon_sym_AT] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_readonly] = ACTIONS(2324),
    [anon_sym_get] = ACTIONS(2324),
    [anon_sym_set] = ACTIONS(2324),
    [anon_sym_declare] = ACTIONS(2324),
    [anon_sym_public] = ACTIONS(2324),
    [anon_sym_private] = ACTIONS(2324),
    [anon_sym_protected] = ACTIONS(2324),
    [anon_sym_override] = ACTIONS(2324),
    [anon_sym_module] = ACTIONS(2324),
    [anon_sym_any] = ACTIONS(2324),
    [anon_sym_number] = ACTIONS(2324),
    [anon_sym_boolean] = ACTIONS(2324),
    [anon_sym_string] = ACTIONS(2324),
    [anon_sym_symbol] = ACTIONS(2324),
    [anon_sym_abstract] = ACTIONS(2324),
    [anon_sym_interface] = ACTIONS(2324),
    [anon_sym_enum] = ACTIONS(2324),
  },
  [730] = {
    [ts_builtin_sym_end] = ACTIONS(1330),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_export] = ACTIONS(1332),
    [anon_sym_default] = ACTIONS(1332),
    [anon_sym_type] = ACTIONS(1332),
    [anon_sym_namespace] = ACTIONS(1332),
    [anon_sym_LBRACE] = ACTIONS(1330),
    [anon_sym_RBRACE] = ACTIONS(1330),
    [anon_sym_typeof] = ACTIONS(1332),
    [anon_sym_import] = ACTIONS(1332),
    [anon_sym_var] = ACTIONS(1332),
    [anon_sym_let] = ACTIONS(1332),
    [anon_sym_const] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1330),
    [anon_sym_else] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(1332),
    [anon_sym_switch] = ACTIONS(1332),
    [anon_sym_for] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1330),
    [anon_sym_await] = ACTIONS(1332),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_do] = ACTIONS(1332),
    [anon_sym_try] = ACTIONS(1332),
    [anon_sym_with] = ACTIONS(1332),
    [anon_sym_break] = ACTIONS(1332),
    [anon_sym_continue] = ACTIONS(1332),
    [anon_sym_debugger] = ACTIONS(1332),
    [anon_sym_return] = ACTIONS(1332),
    [anon_sym_throw] = ACTIONS(1332),
    [anon_sym_SEMI] = ACTIONS(1330),
    [anon_sym_case] = ACTIONS(1332),
    [anon_sym_yield] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1330),
    [anon_sym_LT] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1332),
    [anon_sym_class] = ACTIONS(1332),
    [anon_sym_async] = ACTIONS(1332),
    [anon_sym_function] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1330),
    [anon_sym_void] = ACTIONS(1332),
    [anon_sym_delete] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1330),
    [anon_sym_DASH_DASH] = ACTIONS(1330),
    [anon_sym_DQUOTE] = ACTIONS(1330),
    [anon_sym_SQUOTE] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1330),
    [sym_number] = ACTIONS(1330),
    [sym_this] = ACTIONS(1332),
    [sym_super] = ACTIONS(1332),
    [sym_true] = ACTIONS(1332),
    [sym_false] = ACTIONS(1332),
    [sym_null] = ACTIONS(1332),
    [sym_undefined] = ACTIONS(1332),
    [anon_sym_AT] = ACTIONS(1330),
    [anon_sym_static] = ACTIONS(1332),
    [anon_sym_readonly] = ACTIONS(1332),
    [anon_sym_get] = ACTIONS(1332),
    [anon_sym_set] = ACTIONS(1332),
    [anon_sym_declare] = ACTIONS(1332),
    [anon_sym_public] = ACTIONS(1332),
    [anon_sym_private] = ACTIONS(1332),
    [anon_sym_protected] = ACTIONS(1332),
    [anon_sym_override] = ACTIONS(1332),
    [anon_sym_module] = ACTIONS(1332),
    [anon_sym_any] = ACTIONS(1332),
    [anon_sym_number] = ACTIONS(1332),
    [anon_sym_boolean] = ACTIONS(1332),
    [anon_sym_string] = ACTIONS(1332),
    [anon_sym_symbol] = ACTIONS(1332),
    [anon_sym_abstract] = ACTIONS(1332),
    [anon_sym_interface] = ACTIONS(1332),
    [anon_sym_enum] = ACTIONS(1332),
  },
  [731] = {
    [ts_builtin_sym_end] = ACTIONS(2326),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_export] = ACTIONS(2328),
    [anon_sym_default] = ACTIONS(2328),
    [anon_sym_type] = ACTIONS(2328),
    [anon_sym_namespace] = ACTIONS(2328),
    [anon_sym_LBRACE] = ACTIONS(2326),
    [anon_sym_RBRACE] = ACTIONS(2326),
    [anon_sym_typeof] = ACTIONS(2328),
    [anon_sym_import] = ACTIONS(2328),
    [anon_sym_var] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2326),
    [anon_sym_else] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_switch] = ACTIONS(2328),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_LPAREN] = ACTIONS(2326),
    [anon_sym_await] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_with] = ACTIONS(2328),
    [anon_sym_break] = ACTIONS(2328),
    [anon_sym_continue] = ACTIONS(2328),
    [anon_sym_debugger] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_throw] = ACTIONS(2328),
    [anon_sym_SEMI] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2328),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2328),
    [anon_sym_class] = ACTIONS(2328),
    [anon_sym_async] = ACTIONS(2328),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2326),
    [anon_sym_void] = ACTIONS(2328),
    [anon_sym_delete] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2326),
    [anon_sym_DQUOTE] = ACTIONS(2326),
    [anon_sym_SQUOTE] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2326),
    [sym_number] = ACTIONS(2326),
    [sym_this] = ACTIONS(2328),
    [sym_super] = ACTIONS(2328),
    [sym_true] = ACTIONS(2328),
    [sym_false] = ACTIONS(2328),
    [sym_null] = ACTIONS(2328),
    [sym_undefined] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2328),
    [anon_sym_readonly] = ACTIONS(2328),
    [anon_sym_get] = ACTIONS(2328),
    [anon_sym_set] = ACTIONS(2328),
    [anon_sym_declare] = ACTIONS(2328),
    [anon_sym_public] = ACTIONS(2328),
    [anon_sym_private] = ACTIONS(2328),
    [anon_sym_protected] = ACTIONS(2328),
    [anon_sym_override] = ACTIONS(2328),
    [anon_sym_module] = ACTIONS(2328),
    [anon_sym_any] = ACTIONS(2328),
    [anon_sym_number] = ACTIONS(2328),
    [anon_sym_boolean] = ACTIONS(2328),
    [anon_sym_string] = ACTIONS(2328),
    [anon_sym_symbol] = ACTIONS(2328),
    [anon_sym_abstract] = ACTIONS(2328),
    [anon_sym_interface] = ACTIONS(2328),
    [anon_sym_enum] = ACTIONS(2328),
  },
  [732] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [733] = {
    [ts_builtin_sym_end] = ACTIONS(2330),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_export] = ACTIONS(2332),
    [anon_sym_default] = ACTIONS(2332),
    [anon_sym_type] = ACTIONS(2332),
    [anon_sym_namespace] = ACTIONS(2332),
    [anon_sym_LBRACE] = ACTIONS(2330),
    [anon_sym_RBRACE] = ACTIONS(2330),
    [anon_sym_typeof] = ACTIONS(2332),
    [anon_sym_import] = ACTIONS(2332),
    [anon_sym_var] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_const] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2330),
    [anon_sym_else] = ACTIONS(2332),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_switch] = ACTIONS(2332),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2330),
    [anon_sym_await] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_with] = ACTIONS(2332),
    [anon_sym_break] = ACTIONS(2332),
    [anon_sym_continue] = ACTIONS(2332),
    [anon_sym_debugger] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_throw] = ACTIONS(2332),
    [anon_sym_SEMI] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2332),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_SLASH] = ACTIONS(2332),
    [anon_sym_class] = ACTIONS(2332),
    [anon_sym_async] = ACTIONS(2332),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2330),
    [anon_sym_void] = ACTIONS(2332),
    [anon_sym_delete] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2330),
    [anon_sym_DQUOTE] = ACTIONS(2330),
    [anon_sym_SQUOTE] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2330),
    [sym_number] = ACTIONS(2330),
    [sym_this] = ACTIONS(2332),
    [sym_super] = ACTIONS(2332),
    [sym_true] = ACTIONS(2332),
    [sym_false] = ACTIONS(2332),
    [sym_null] = ACTIONS(2332),
    [sym_undefined] = ACTIONS(2332),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2332),
    [anon_sym_readonly] = ACTIONS(2332),
    [anon_sym_get] = ACTIONS(2332),
    [anon_sym_set] = ACTIONS(2332),
    [anon_sym_declare] = ACTIONS(2332),
    [anon_sym_public] = ACTIONS(2332),
    [anon_sym_private] = ACTIONS(2332),
    [anon_sym_protected] = ACTIONS(2332),
    [anon_sym_override] = ACTIONS(2332),
    [anon_sym_module] = ACTIONS(2332),
    [anon_sym_any] = ACTIONS(2332),
    [anon_sym_number] = ACTIONS(2332),
    [anon_sym_boolean] = ACTIONS(2332),
    [anon_sym_string] = ACTIONS(2332),
    [anon_sym_symbol] = ACTIONS(2332),
    [anon_sym_abstract] = ACTIONS(2332),
    [anon_sym_interface] = ACTIONS(2332),
    [anon_sym_enum] = ACTIONS(2332),
  },
  [734] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [735] = {
    [ts_builtin_sym_end] = ACTIONS(2334),
    [sym_identifier] = ACTIONS(2336),
    [anon_sym_export] = ACTIONS(2336),
    [anon_sym_default] = ACTIONS(2336),
    [anon_sym_type] = ACTIONS(2336),
    [anon_sym_namespace] = ACTIONS(2336),
    [anon_sym_LBRACE] = ACTIONS(2334),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_typeof] = ACTIONS(2336),
    [anon_sym_import] = ACTIONS(2336),
    [anon_sym_var] = ACTIONS(2336),
    [anon_sym_let] = ACTIONS(2336),
    [anon_sym_const] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2334),
    [anon_sym_else] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(2336),
    [anon_sym_switch] = ACTIONS(2336),
    [anon_sym_for] = ACTIONS(2336),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_await] = ACTIONS(2336),
    [anon_sym_while] = ACTIONS(2336),
    [anon_sym_do] = ACTIONS(2336),
    [anon_sym_try] = ACTIONS(2336),
    [anon_sym_with] = ACTIONS(2336),
    [anon_sym_break] = ACTIONS(2336),
    [anon_sym_continue] = ACTIONS(2336),
    [anon_sym_debugger] = ACTIONS(2336),
    [anon_sym_return] = ACTIONS(2336),
    [anon_sym_throw] = ACTIONS(2336),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_SLASH] = ACTIONS(2336),
    [anon_sym_class] = ACTIONS(2336),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_function] = ACTIONS(2336),
    [anon_sym_new] = ACTIONS(2336),
    [anon_sym_PLUS] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2334),
    [anon_sym_void] = ACTIONS(2336),
    [anon_sym_delete] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2334),
    [anon_sym_DQUOTE] = ACTIONS(2334),
    [anon_sym_SQUOTE] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2334),
    [sym_number] = ACTIONS(2334),
    [sym_this] = ACTIONS(2336),
    [sym_super] = ACTIONS(2336),
    [sym_true] = ACTIONS(2336),
    [sym_false] = ACTIONS(2336),
    [sym_null] = ACTIONS(2336),
    [sym_undefined] = ACTIONS(2336),
    [anon_sym_AT] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2336),
    [anon_sym_readonly] = ACTIONS(2336),
    [anon_sym_get] = ACTIONS(2336),
    [anon_sym_set] = ACTIONS(2336),
    [anon_sym_declare] = ACTIONS(2336),
    [anon_sym_public] = ACTIONS(2336),
    [anon_sym_private] = ACTIONS(2336),
    [anon_sym_protected] = ACTIONS(2336),
    [anon_sym_override] = ACTIONS(2336),
    [anon_sym_module] = ACTIONS(2336),
    [anon_sym_any] = ACTIONS(2336),
    [anon_sym_number] = ACTIONS(2336),
    [anon_sym_boolean] = ACTIONS(2336),
    [anon_sym_string] = ACTIONS(2336),
    [anon_sym_symbol] = ACTIONS(2336),
    [anon_sym_abstract] = ACTIONS(2336),
    [anon_sym_interface] = ACTIONS(2336),
    [anon_sym_enum] = ACTIONS(2336),
  },
  [736] = {
    [ts_builtin_sym_end] = ACTIONS(2334),
    [sym_identifier] = ACTIONS(2336),
    [anon_sym_export] = ACTIONS(2336),
    [anon_sym_default] = ACTIONS(2336),
    [anon_sym_type] = ACTIONS(2336),
    [anon_sym_namespace] = ACTIONS(2336),
    [anon_sym_LBRACE] = ACTIONS(2334),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_typeof] = ACTIONS(2336),
    [anon_sym_import] = ACTIONS(2336),
    [anon_sym_var] = ACTIONS(2336),
    [anon_sym_let] = ACTIONS(2336),
    [anon_sym_const] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2334),
    [anon_sym_else] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(2336),
    [anon_sym_switch] = ACTIONS(2336),
    [anon_sym_for] = ACTIONS(2336),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_await] = ACTIONS(2336),
    [anon_sym_while] = ACTIONS(2336),
    [anon_sym_do] = ACTIONS(2336),
    [anon_sym_try] = ACTIONS(2336),
    [anon_sym_with] = ACTIONS(2336),
    [anon_sym_break] = ACTIONS(2336),
    [anon_sym_continue] = ACTIONS(2336),
    [anon_sym_debugger] = ACTIONS(2336),
    [anon_sym_return] = ACTIONS(2336),
    [anon_sym_throw] = ACTIONS(2336),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_SLASH] = ACTIONS(2336),
    [anon_sym_class] = ACTIONS(2336),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_function] = ACTIONS(2336),
    [anon_sym_new] = ACTIONS(2336),
    [anon_sym_PLUS] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2334),
    [anon_sym_void] = ACTIONS(2336),
    [anon_sym_delete] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2334),
    [anon_sym_DQUOTE] = ACTIONS(2334),
    [anon_sym_SQUOTE] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2334),
    [sym_number] = ACTIONS(2334),
    [sym_this] = ACTIONS(2336),
    [sym_super] = ACTIONS(2336),
    [sym_true] = ACTIONS(2336),
    [sym_false] = ACTIONS(2336),
    [sym_null] = ACTIONS(2336),
    [sym_undefined] = ACTIONS(2336),
    [anon_sym_AT] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2336),
    [anon_sym_readonly] = ACTIONS(2336),
    [anon_sym_get] = ACTIONS(2336),
    [anon_sym_set] = ACTIONS(2336),
    [anon_sym_declare] = ACTIONS(2336),
    [anon_sym_public] = ACTIONS(2336),
    [anon_sym_private] = ACTIONS(2336),
    [anon_sym_protected] = ACTIONS(2336),
    [anon_sym_override] = ACTIONS(2336),
    [anon_sym_module] = ACTIONS(2336),
    [anon_sym_any] = ACTIONS(2336),
    [anon_sym_number] = ACTIONS(2336),
    [anon_sym_boolean] = ACTIONS(2336),
    [anon_sym_string] = ACTIONS(2336),
    [anon_sym_symbol] = ACTIONS(2336),
    [anon_sym_abstract] = ACTIONS(2336),
    [anon_sym_interface] = ACTIONS(2336),
    [anon_sym_enum] = ACTIONS(2336),
  },
  [737] = {
    [ts_builtin_sym_end] = ACTIONS(2338),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_export] = ACTIONS(2340),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_type] = ACTIONS(2340),
    [anon_sym_namespace] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_typeof] = ACTIONS(2340),
    [anon_sym_import] = ACTIONS(2340),
    [anon_sym_var] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_const] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2338),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_switch] = ACTIONS(2340),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_await] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_break] = ACTIONS(2340),
    [anon_sym_continue] = ACTIONS(2340),
    [anon_sym_debugger] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_throw] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2340),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2338),
    [anon_sym_SLASH] = ACTIONS(2340),
    [anon_sym_class] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2340),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2338),
    [anon_sym_void] = ACTIONS(2340),
    [anon_sym_delete] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2338),
    [anon_sym_DQUOTE] = ACTIONS(2338),
    [anon_sym_SQUOTE] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2338),
    [sym_number] = ACTIONS(2338),
    [sym_this] = ACTIONS(2340),
    [sym_super] = ACTIONS(2340),
    [sym_true] = ACTIONS(2340),
    [sym_false] = ACTIONS(2340),
    [sym_null] = ACTIONS(2340),
    [sym_undefined] = ACTIONS(2340),
    [anon_sym_AT] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_readonly] = ACTIONS(2340),
    [anon_sym_get] = ACTIONS(2340),
    [anon_sym_set] = ACTIONS(2340),
    [anon_sym_declare] = ACTIONS(2340),
    [anon_sym_public] = ACTIONS(2340),
    [anon_sym_private] = ACTIONS(2340),
    [anon_sym_protected] = ACTIONS(2340),
    [anon_sym_override] = ACTIONS(2340),
    [anon_sym_module] = ACTIONS(2340),
    [anon_sym_any] = ACTIONS(2340),
    [anon_sym_number] = ACTIONS(2340),
    [anon_sym_boolean] = ACTIONS(2340),
    [anon_sym_string] = ACTIONS(2340),
    [anon_sym_symbol] = ACTIONS(2340),
    [anon_sym_abstract] = ACTIONS(2340),
    [anon_sym_interface] = ACTIONS(2340),
    [anon_sym_enum] = ACTIONS(2340),
  },
  [738] = {
    [ts_builtin_sym_end] = ACTIONS(2342),
    [sym_identifier] = ACTIONS(2344),
    [anon_sym_export] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2344),
    [anon_sym_type] = ACTIONS(2344),
    [anon_sym_namespace] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_typeof] = ACTIONS(2344),
    [anon_sym_import] = ACTIONS(2344),
    [anon_sym_var] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2344),
    [anon_sym_const] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2344),
    [anon_sym_switch] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_await] = ACTIONS(2344),
    [anon_sym_while] = ACTIONS(2344),
    [anon_sym_do] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2344),
    [anon_sym_with] = ACTIONS(2344),
    [anon_sym_break] = ACTIONS(2344),
    [anon_sym_continue] = ACTIONS(2344),
    [anon_sym_debugger] = ACTIONS(2344),
    [anon_sym_return] = ACTIONS(2344),
    [anon_sym_throw] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2344),
    [anon_sym_yield] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_SLASH] = ACTIONS(2344),
    [anon_sym_class] = ACTIONS(2344),
    [anon_sym_async] = ACTIONS(2344),
    [anon_sym_function] = ACTIONS(2344),
    [anon_sym_new] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2342),
    [anon_sym_void] = ACTIONS(2344),
    [anon_sym_delete] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [anon_sym_DQUOTE] = ACTIONS(2342),
    [anon_sym_SQUOTE] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2342),
    [sym_number] = ACTIONS(2342),
    [sym_this] = ACTIONS(2344),
    [sym_super] = ACTIONS(2344),
    [sym_true] = ACTIONS(2344),
    [sym_false] = ACTIONS(2344),
    [sym_null] = ACTIONS(2344),
    [sym_undefined] = ACTIONS(2344),
    [anon_sym_AT] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2344),
    [anon_sym_readonly] = ACTIONS(2344),
    [anon_sym_get] = ACTIONS(2344),
    [anon_sym_set] = ACTIONS(2344),
    [anon_sym_declare] = ACTIONS(2344),
    [anon_sym_public] = ACTIONS(2344),
    [anon_sym_private] = ACTIONS(2344),
    [anon_sym_protected] = ACTIONS(2344),
    [anon_sym_override] = ACTIONS(2344),
    [anon_sym_module] = ACTIONS(2344),
    [anon_sym_any] = ACTIONS(2344),
    [anon_sym_number] = ACTIONS(2344),
    [anon_sym_boolean] = ACTIONS(2344),
    [anon_sym_string] = ACTIONS(2344),
    [anon_sym_symbol] = ACTIONS(2344),
    [anon_sym_abstract] = ACTIONS(2344),
    [anon_sym_interface] = ACTIONS(2344),
    [anon_sym_enum] = ACTIONS(2344),
  },
  [739] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [740] = {
    [ts_builtin_sym_end] = ACTIONS(2346),
    [sym_identifier] = ACTIONS(2348),
    [anon_sym_export] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_type] = ACTIONS(2348),
    [anon_sym_namespace] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2346),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_typeof] = ACTIONS(2348),
    [anon_sym_import] = ACTIONS(2348),
    [anon_sym_var] = ACTIONS(2348),
    [anon_sym_let] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_switch] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_LPAREN] = ACTIONS(2346),
    [anon_sym_await] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_do] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [anon_sym_with] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_debugger] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_throw] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_case] = ACTIONS(2348),
    [anon_sym_yield] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(2348),
    [anon_sym_async] = ACTIONS(2348),
    [anon_sym_function] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_TILDE] = ACTIONS(2346),
    [anon_sym_void] = ACTIONS(2348),
    [anon_sym_delete] = ACTIONS(2348),
    [anon_sym_PLUS_PLUS] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2346),
    [anon_sym_SQUOTE] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2346),
    [sym_number] = ACTIONS(2346),
    [sym_this] = ACTIONS(2348),
    [sym_super] = ACTIONS(2348),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [sym_null] = ACTIONS(2348),
    [sym_undefined] = ACTIONS(2348),
    [anon_sym_AT] = ACTIONS(2346),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_readonly] = ACTIONS(2348),
    [anon_sym_get] = ACTIONS(2348),
    [anon_sym_set] = ACTIONS(2348),
    [anon_sym_declare] = ACTIONS(2348),
    [anon_sym_public] = ACTIONS(2348),
    [anon_sym_private] = ACTIONS(2348),
    [anon_sym_protected] = ACTIONS(2348),
    [anon_sym_override] = ACTIONS(2348),
    [anon_sym_module] = ACTIONS(2348),
    [anon_sym_any] = ACTIONS(2348),
    [anon_sym_number] = ACTIONS(2348),
    [anon_sym_boolean] = ACTIONS(2348),
    [anon_sym_string] = ACTIONS(2348),
    [anon_sym_symbol] = ACTIONS(2348),
    [anon_sym_abstract] = ACTIONS(2348),
    [anon_sym_interface] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
  },
  [741] = {
    [ts_builtin_sym_end] = ACTIONS(2350),
    [sym_identifier] = ACTIONS(2352),
    [anon_sym_export] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_type] = ACTIONS(2352),
    [anon_sym_namespace] = ACTIONS(2352),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_RBRACE] = ACTIONS(2350),
    [anon_sym_typeof] = ACTIONS(2352),
    [anon_sym_import] = ACTIONS(2352),
    [anon_sym_var] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_switch] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_LPAREN] = ACTIONS(2350),
    [anon_sym_await] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [anon_sym_with] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_debugger] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_throw] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_case] = ACTIONS(2352),
    [anon_sym_yield] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_LT] = ACTIONS(2350),
    [anon_sym_SLASH] = ACTIONS(2352),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_async] = ACTIONS(2352),
    [anon_sym_function] = ACTIONS(2352),
    [anon_sym_new] = ACTIONS(2352),
    [anon_sym_PLUS] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2350),
    [anon_sym_void] = ACTIONS(2352),
    [anon_sym_delete] = ACTIONS(2352),
    [anon_sym_PLUS_PLUS] = ACTIONS(2350),
    [anon_sym_DASH_DASH] = ACTIONS(2350),
    [anon_sym_DQUOTE] = ACTIONS(2350),
    [anon_sym_SQUOTE] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2350),
    [sym_number] = ACTIONS(2350),
    [sym_this] = ACTIONS(2352),
    [sym_super] = ACTIONS(2352),
    [sym_true] = ACTIONS(2352),
    [sym_false] = ACTIONS(2352),
    [sym_null] = ACTIONS(2352),
    [sym_undefined] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(2350),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_readonly] = ACTIONS(2352),
    [anon_sym_get] = ACTIONS(2352),
    [anon_sym_set] = ACTIONS(2352),
    [anon_sym_declare] = ACTIONS(2352),
    [anon_sym_public] = ACTIONS(2352),
    [anon_sym_private] = ACTIONS(2352),
    [anon_sym_protected] = ACTIONS(2352),
    [anon_sym_override] = ACTIONS(2352),
    [anon_sym_module] = ACTIONS(2352),
    [anon_sym_any] = ACTIONS(2352),
    [anon_sym_number] = ACTIONS(2352),
    [anon_sym_boolean] = ACTIONS(2352),
    [anon_sym_string] = ACTIONS(2352),
    [anon_sym_symbol] = ACTIONS(2352),
    [anon_sym_abstract] = ACTIONS(2352),
    [anon_sym_interface] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2352),
  },
  [742] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_readonly] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_override] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
  },
  [743] = {
    [ts_builtin_sym_end] = ACTIONS(1350),
    [sym_identifier] = ACTIONS(1352),
    [anon_sym_export] = ACTIONS(1352),
    [anon_sym_default] = ACTIONS(1352),
    [anon_sym_type] = ACTIONS(1352),
    [anon_sym_namespace] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_typeof] = ACTIONS(1352),
    [anon_sym_import] = ACTIONS(1352),
    [anon_sym_var] = ACTIONS(1352),
    [anon_sym_let] = ACTIONS(1352),
    [anon_sym_const] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1352),
    [anon_sym_if] = ACTIONS(1352),
    [anon_sym_switch] = ACTIONS(1352),
    [anon_sym_for] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [anon_sym_await] = ACTIONS(1352),
    [anon_sym_while] = ACTIONS(1352),
    [anon_sym_do] = ACTIONS(1352),
    [anon_sym_try] = ACTIONS(1352),
    [anon_sym_with] = ACTIONS(1352),
    [anon_sym_break] = ACTIONS(1352),
    [anon_sym_continue] = ACTIONS(1352),
    [anon_sym_debugger] = ACTIONS(1352),
    [anon_sym_return] = ACTIONS(1352),
    [anon_sym_throw] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1352),
    [anon_sym_yield] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1352),
    [anon_sym_class] = ACTIONS(1352),
    [anon_sym_async] = ACTIONS(1352),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_new] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_void] = ACTIONS(1352),
    [anon_sym_delete] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1350),
    [sym_number] = ACTIONS(1350),
    [sym_this] = ACTIONS(1352),
    [sym_super] = ACTIONS(1352),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [sym_null] = ACTIONS(1352),
    [sym_undefined] = ACTIONS(1352),
    [anon_sym_AT] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1352),
    [anon_sym_readonly] = ACTIONS(1352),
    [anon_sym_get] = ACTIONS(1352),
    [anon_sym_set] = ACTIONS(1352),
    [anon_sym_declare] = ACTIONS(1352),
    [anon_sym_public] = ACTIONS(1352),
    [anon_sym_private] = ACTIONS(1352),
    [anon_sym_protected] = ACTIONS(1352),
    [anon_sym_override] = ACTIONS(1352),
    [anon_sym_module] = ACTIONS(1352),
    [anon_sym_any] = ACTIONS(1352),
    [anon_sym_number] = ACTIONS(1352),
    [anon_sym_boolean] = ACTIONS(1352),
    [anon_sym_string] = ACTIONS(1352),
    [anon_sym_symbol] = ACTIONS(1352),
    [anon_sym_abstract] = ACTIONS(1352),
    [anon_sym_interface] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1352),
  },
  [744] = {
    [ts_builtin_sym_end] = ACTIONS(2354),
    [sym_identifier] = ACTIONS(2356),
    [anon_sym_export] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_type] = ACTIONS(2356),
    [anon_sym_namespace] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_RBRACE] = ACTIONS(2354),
    [anon_sym_typeof] = ACTIONS(2356),
    [anon_sym_import] = ACTIONS(2356),
    [anon_sym_var] = ACTIONS(2356),
    [anon_sym_let] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_else] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_switch] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(2354),
    [anon_sym_await] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_do] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [anon_sym_with] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_debugger] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_throw] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_case] = ACTIONS(2356),
    [anon_sym_yield] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_async] = ACTIONS(2356),
    [anon_sym_function] = ACTIONS(2356),
    [anon_sym_new] = ACTIONS(2356),
    [anon_sym_PLUS] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2356),
    [anon_sym_TILDE] = ACTIONS(2354),
    [anon_sym_void] = ACTIONS(2356),
    [anon_sym_delete] = ACTIONS(2356),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [anon_sym_SQUOTE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [sym_number] = ACTIONS(2354),
    [sym_this] = ACTIONS(2356),
    [sym_super] = ACTIONS(2356),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [sym_null] = ACTIONS(2356),
    [sym_undefined] = ACTIONS(2356),
    [anon_sym_AT] = ACTIONS(2354),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_readonly] = ACTIONS(2356),
    [anon_sym_get] = ACTIONS(2356),
    [anon_sym_set] = ACTIONS(2356),
    [anon_sym_declare] = ACTIONS(2356),
    [anon_sym_public] = ACTIONS(2356),
    [anon_sym_private] = ACTIONS(2356),
    [anon_sym_protected] = ACTIONS(2356),
    [anon_sym_override] = ACTIONS(2356),
    [anon_sym_module] = ACTIONS(2356),
    [anon_sym_any] = ACTIONS(2356),
    [anon_sym_number] = ACTIONS(2356),
    [anon_sym_boolean] = ACTIONS(2356),
    [anon_sym_string] = ACTIONS(2356),
    [anon_sym_symbol] = ACTIONS(2356),
    [anon_sym_abstract] = ACTIONS(2356),
    [anon_sym_interface] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(2358),
    [sym_identifier] = ACTIONS(2360),
    [anon_sym_export] = ACTIONS(2360),
    [anon_sym_default] = ACTIONS(2360),
    [anon_sym_type] = ACTIONS(2360),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_RBRACE] = ACTIONS(2358),
    [anon_sym_typeof] = ACTIONS(2360),
    [anon_sym_import] = ACTIONS(2360),
    [anon_sym_var] = ACTIONS(2360),
    [anon_sym_let] = ACTIONS(2360),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2358),
    [anon_sym_else] = ACTIONS(2360),
    [anon_sym_if] = ACTIONS(2360),
    [anon_sym_switch] = ACTIONS(2360),
    [anon_sym_for] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(2358),
    [anon_sym_await] = ACTIONS(2360),
    [anon_sym_while] = ACTIONS(2360),
    [anon_sym_do] = ACTIONS(2360),
    [anon_sym_try] = ACTIONS(2360),
    [anon_sym_with] = ACTIONS(2360),
    [anon_sym_break] = ACTIONS(2360),
    [anon_sym_continue] = ACTIONS(2360),
    [anon_sym_debugger] = ACTIONS(2360),
    [anon_sym_return] = ACTIONS(2360),
    [anon_sym_throw] = ACTIONS(2360),
    [anon_sym_SEMI] = ACTIONS(2358),
    [anon_sym_case] = ACTIONS(2360),
    [anon_sym_yield] = ACTIONS(2360),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_LT] = ACTIONS(2358),
    [anon_sym_SLASH] = ACTIONS(2360),
    [anon_sym_class] = ACTIONS(2360),
    [anon_sym_async] = ACTIONS(2360),
    [anon_sym_function] = ACTIONS(2360),
    [anon_sym_new] = ACTIONS(2360),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(2360),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_void] = ACTIONS(2360),
    [anon_sym_delete] = ACTIONS(2360),
    [anon_sym_PLUS_PLUS] = ACTIONS(2358),
    [anon_sym_DASH_DASH] = ACTIONS(2358),
    [anon_sym_DQUOTE] = ACTIONS(2358),
    [anon_sym_SQUOTE] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2358),
    [sym_number] = ACTIONS(2358),
    [sym_this] = ACTIONS(2360),
    [sym_super] = ACTIONS(2360),
    [sym_true] = ACTIONS(2360),
    [sym_false] = ACTIONS(2360),
    [sym_null] = ACTIONS(2360),
    [sym_undefined] = ACTIONS(2360),
    [anon_sym_AT] = ACTIONS(2358),
    [anon_sym_static] = ACTIONS(2360),
    [anon_sym_readonly] = ACTIONS(2360),
    [anon_sym_get] = ACTIONS(2360),
    [anon_sym_set] = ACTIONS(2360),
    [anon_sym_declare] = ACTIONS(2360),
    [anon_sym_public] = ACTIONS(2360),
    [anon_sym_private] = ACTIONS(2360),
    [anon_sym_protected] = ACTIONS(2360),
    [anon_sym_override] = ACTIONS(2360),
    [anon_sym_module] = ACTIONS(2360),
    [anon_sym_any] = ACTIONS(2360),
    [anon_sym_number] = ACTIONS(2360),
    [anon_sym_boolean] = ACTIONS(2360),
    [anon_sym_string] = ACTIONS(2360),
    [anon_sym_symbol] = ACTIONS(2360),
    [anon_sym_abstract] = ACTIONS(2360),
    [anon_sym_interface] = ACTIONS(2360),
    [anon_sym_enum] = ACTIONS(2360),
  },
  [746] = {
    [ts_builtin_sym_end] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2364),
    [anon_sym_export] = ACTIONS(2364),
    [anon_sym_default] = ACTIONS(2364),
    [anon_sym_type] = ACTIONS(2364),
    [anon_sym_namespace] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_typeof] = ACTIONS(2364),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2364),
    [anon_sym_let] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_if] = ACTIONS(2364),
    [anon_sym_switch] = ACTIONS(2364),
    [anon_sym_for] = ACTIONS(2364),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_await] = ACTIONS(2364),
    [anon_sym_while] = ACTIONS(2364),
    [anon_sym_do] = ACTIONS(2364),
    [anon_sym_try] = ACTIONS(2364),
    [anon_sym_with] = ACTIONS(2364),
    [anon_sym_break] = ACTIONS(2364),
    [anon_sym_continue] = ACTIONS(2364),
    [anon_sym_debugger] = ACTIONS(2364),
    [anon_sym_return] = ACTIONS(2364),
    [anon_sym_throw] = ACTIONS(2364),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_case] = ACTIONS(2364),
    [anon_sym_yield] = ACTIONS(2364),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2362),
    [anon_sym_SLASH] = ACTIONS(2364),
    [anon_sym_class] = ACTIONS(2364),
    [anon_sym_async] = ACTIONS(2364),
    [anon_sym_function] = ACTIONS(2364),
    [anon_sym_new] = ACTIONS(2364),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2362),
    [anon_sym_void] = ACTIONS(2364),
    [anon_sym_delete] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [anon_sym_SQUOTE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [sym_number] = ACTIONS(2362),
    [sym_this] = ACTIONS(2364),
    [sym_super] = ACTIONS(2364),
    [sym_true] = ACTIONS(2364),
    [sym_false] = ACTIONS(2364),
    [sym_null] = ACTIONS(2364),
    [sym_undefined] = ACTIONS(2364),
    [anon_sym_AT] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_readonly] = ACTIONS(2364),
    [anon_sym_get] = ACTIONS(2364),
    [anon_sym_set] = ACTIONS(2364),
    [anon_sym_declare] = ACTIONS(2364),
    [anon_sym_public] = ACTIONS(2364),
    [anon_sym_private] = ACTIONS(2364),
    [anon_sym_protected] = ACTIONS(2364),
    [anon_sym_override] = ACTIONS(2364),
    [anon_sym_module] = ACTIONS(2364),
    [anon_sym_any] = ACTIONS(2364),
    [anon_sym_number] = ACTIONS(2364),
    [anon_sym_boolean] = ACTIONS(2364),
    [anon_sym_string] = ACTIONS(2364),
    [anon_sym_symbol] = ACTIONS(2364),
    [anon_sym_abstract] = ACTIONS(2364),
    [anon_sym_interface] = ACTIONS(2364),
    [anon_sym_enum] = ACTIONS(2364),
  },
  [747] = {
    [ts_builtin_sym_end] = ACTIONS(2366),
    [sym_identifier] = ACTIONS(2368),
    [anon_sym_export] = ACTIONS(2368),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_type] = ACTIONS(2368),
    [anon_sym_namespace] = ACTIONS(2368),
    [anon_sym_LBRACE] = ACTIONS(2366),
    [anon_sym_RBRACE] = ACTIONS(2366),
    [anon_sym_typeof] = ACTIONS(2368),
    [anon_sym_import] = ACTIONS(2368),
    [anon_sym_var] = ACTIONS(2368),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_switch] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_LPAREN] = ACTIONS(2366),
    [anon_sym_await] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_do] = ACTIONS(2368),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_with] = ACTIONS(2368),
    [anon_sym_break] = ACTIONS(2368),
    [anon_sym_continue] = ACTIONS(2368),
    [anon_sym_debugger] = ACTIONS(2368),
    [anon_sym_return] = ACTIONS(2368),
    [anon_sym_throw] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2368),
    [anon_sym_yield] = ACTIONS(2368),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_LT] = ACTIONS(2366),
    [anon_sym_SLASH] = ACTIONS(2368),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_async] = ACTIONS(2368),
    [anon_sym_function] = ACTIONS(2368),
    [anon_sym_new] = ACTIONS(2368),
    [anon_sym_PLUS] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2366),
    [anon_sym_void] = ACTIONS(2368),
    [anon_sym_delete] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2366),
    [anon_sym_DQUOTE] = ACTIONS(2366),
    [anon_sym_SQUOTE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2366),
    [sym_number] = ACTIONS(2366),
    [sym_this] = ACTIONS(2368),
    [sym_super] = ACTIONS(2368),
    [sym_true] = ACTIONS(2368),
    [sym_false] = ACTIONS(2368),
    [sym_null] = ACTIONS(2368),
    [sym_undefined] = ACTIONS(2368),
    [anon_sym_AT] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2368),
    [anon_sym_readonly] = ACTIONS(2368),
    [anon_sym_get] = ACTIONS(2368),
    [anon_sym_set] = ACTIONS(2368),
    [anon_sym_declare] = ACTIONS(2368),
    [anon_sym_public] = ACTIONS(2368),
    [anon_sym_private] = ACTIONS(2368),
    [anon_sym_protected] = ACTIONS(2368),
    [anon_sym_override] = ACTIONS(2368),
    [anon_sym_module] = ACTIONS(2368),
    [anon_sym_any] = ACTIONS(2368),
    [anon_sym_number] = ACTIONS(2368),
    [anon_sym_boolean] = ACTIONS(2368),
    [anon_sym_string] = ACTIONS(2368),
    [anon_sym_symbol] = ACTIONS(2368),
    [anon_sym_abstract] = ACTIONS(2368),
    [anon_sym_interface] = ACTIONS(2368),
    [anon_sym_enum] = ACTIONS(2368),
  },
  [748] = {
    [ts_builtin_sym_end] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(2372),
    [anon_sym_export] = ACTIONS(2372),
    [anon_sym_default] = ACTIONS(2372),
    [anon_sym_type] = ACTIONS(2372),
    [anon_sym_namespace] = ACTIONS(2372),
    [anon_sym_LBRACE] = ACTIONS(2370),
    [anon_sym_RBRACE] = ACTIONS(2370),
    [anon_sym_typeof] = ACTIONS(2372),
    [anon_sym_import] = ACTIONS(2372),
    [anon_sym_var] = ACTIONS(2372),
    [anon_sym_let] = ACTIONS(2372),
    [anon_sym_const] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2370),
    [anon_sym_else] = ACTIONS(2372),
    [anon_sym_if] = ACTIONS(2372),
    [anon_sym_switch] = ACTIONS(2372),
    [anon_sym_for] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(2370),
    [anon_sym_await] = ACTIONS(2372),
    [anon_sym_while] = ACTIONS(2372),
    [anon_sym_do] = ACTIONS(2372),
    [anon_sym_try] = ACTIONS(2372),
    [anon_sym_with] = ACTIONS(2372),
    [anon_sym_break] = ACTIONS(2372),
    [anon_sym_continue] = ACTIONS(2372),
    [anon_sym_debugger] = ACTIONS(2372),
    [anon_sym_return] = ACTIONS(2372),
    [anon_sym_throw] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2372),
    [anon_sym_yield] = ACTIONS(2372),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2370),
    [anon_sym_SLASH] = ACTIONS(2372),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2372),
    [anon_sym_function] = ACTIONS(2372),
    [anon_sym_new] = ACTIONS(2372),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2370),
    [anon_sym_void] = ACTIONS(2372),
    [anon_sym_delete] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2370),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2370),
    [sym_number] = ACTIONS(2370),
    [sym_this] = ACTIONS(2372),
    [sym_super] = ACTIONS(2372),
    [sym_true] = ACTIONS(2372),
    [sym_false] = ACTIONS(2372),
    [sym_null] = ACTIONS(2372),
    [sym_undefined] = ACTIONS(2372),
    [anon_sym_AT] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2372),
    [anon_sym_readonly] = ACTIONS(2372),
    [anon_sym_get] = ACTIONS(2372),
    [anon_sym_set] = ACTIONS(2372),
    [anon_sym_declare] = ACTIONS(2372),
    [anon_sym_public] = ACTIONS(2372),
    [anon_sym_private] = ACTIONS(2372),
    [anon_sym_protected] = ACTIONS(2372),
    [anon_sym_override] = ACTIONS(2372),
    [anon_sym_module] = ACTIONS(2372),
    [anon_sym_any] = ACTIONS(2372),
    [anon_sym_number] = ACTIONS(2372),
    [anon_sym_boolean] = ACTIONS(2372),
    [anon_sym_string] = ACTIONS(2372),
    [anon_sym_symbol] = ACTIONS(2372),
    [anon_sym_abstract] = ACTIONS(2372),
    [anon_sym_interface] = ACTIONS(2372),
    [anon_sym_enum] = ACTIONS(2372),
  },
  [749] = {
    [ts_builtin_sym_end] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(2372),
    [anon_sym_export] = ACTIONS(2372),
    [anon_sym_default] = ACTIONS(2372),
    [anon_sym_type] = ACTIONS(2372),
    [anon_sym_namespace] = ACTIONS(2372),
    [anon_sym_LBRACE] = ACTIONS(2370),
    [anon_sym_RBRACE] = ACTIONS(2370),
    [anon_sym_typeof] = ACTIONS(2372),
    [anon_sym_import] = ACTIONS(2372),
    [anon_sym_var] = ACTIONS(2372),
    [anon_sym_let] = ACTIONS(2372),
    [anon_sym_const] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2370),
    [anon_sym_else] = ACTIONS(2372),
    [anon_sym_if] = ACTIONS(2372),
    [anon_sym_switch] = ACTIONS(2372),
    [anon_sym_for] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(2370),
    [anon_sym_await] = ACTIONS(2372),
    [anon_sym_while] = ACTIONS(2372),
    [anon_sym_do] = ACTIONS(2372),
    [anon_sym_try] = ACTIONS(2372),
    [anon_sym_with] = ACTIONS(2372),
    [anon_sym_break] = ACTIONS(2372),
    [anon_sym_continue] = ACTIONS(2372),
    [anon_sym_debugger] = ACTIONS(2372),
    [anon_sym_return] = ACTIONS(2372),
    [anon_sym_throw] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2372),
    [anon_sym_yield] = ACTIONS(2372),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2370),
    [anon_sym_SLASH] = ACTIONS(2372),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2372),
    [anon_sym_function] = ACTIONS(2372),
    [anon_sym_new] = ACTIONS(2372),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2370),
    [anon_sym_void] = ACTIONS(2372),
    [anon_sym_delete] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2370),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2370),
    [sym_number] = ACTIONS(2370),
    [sym_this] = ACTIONS(2372),
    [sym_super] = ACTIONS(2372),
    [sym_true] = ACTIONS(2372),
    [sym_false] = ACTIONS(2372),
    [sym_null] = ACTIONS(2372),
    [sym_undefined] = ACTIONS(2372),
    [anon_sym_AT] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2372),
    [anon_sym_readonly] = ACTIONS(2372),
    [anon_sym_get] = ACTIONS(2372),
    [anon_sym_set] = ACTIONS(2372),
    [anon_sym_declare] = ACTIONS(2372),
    [anon_sym_public] = ACTIONS(2372),
    [anon_sym_private] = ACTIONS(2372),
    [anon_sym_protected] = ACTIONS(2372),
    [anon_sym_override] = ACTIONS(2372),
    [anon_sym_module] = ACTIONS(2372),
    [anon_sym_any] = ACTIONS(2372),
    [anon_sym_number] = ACTIONS(2372),
    [anon_sym_boolean] = ACTIONS(2372),
    [anon_sym_string] = ACTIONS(2372),
    [anon_sym_symbol] = ACTIONS(2372),
    [anon_sym_abstract] = ACTIONS(2372),
    [anon_sym_interface] = ACTIONS(2372),
    [anon_sym_enum] = ACTIONS(2372),
  },
  [750] = {
    [ts_builtin_sym_end] = ACTIONS(1308),
    [sym_identifier] = ACTIONS(1310),
    [anon_sym_export] = ACTIONS(1310),
    [anon_sym_default] = ACTIONS(1310),
    [anon_sym_type] = ACTIONS(1310),
    [anon_sym_namespace] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_typeof] = ACTIONS(1310),
    [anon_sym_import] = ACTIONS(1310),
    [anon_sym_var] = ACTIONS(1310),
    [anon_sym_let] = ACTIONS(1310),
    [anon_sym_const] = ACTIONS(1310),
    [anon_sym_BANG] = ACTIONS(1308),
    [anon_sym_else] = ACTIONS(1310),
    [anon_sym_if] = ACTIONS(1310),
    [anon_sym_switch] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1310),
    [anon_sym_LPAREN] = ACTIONS(1308),
    [anon_sym_await] = ACTIONS(1310),
    [anon_sym_while] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1310),
    [anon_sym_with] = ACTIONS(1310),
    [anon_sym_break] = ACTIONS(1310),
    [anon_sym_continue] = ACTIONS(1310),
    [anon_sym_debugger] = ACTIONS(1310),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_throw] = ACTIONS(1310),
    [anon_sym_SEMI] = ACTIONS(1308),
    [anon_sym_case] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_LT] = ACTIONS(1308),
    [anon_sym_SLASH] = ACTIONS(1310),
    [anon_sym_class] = ACTIONS(1310),
    [anon_sym_async] = ACTIONS(1310),
    [anon_sym_function] = ACTIONS(1310),
    [anon_sym_new] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_TILDE] = ACTIONS(1308),
    [anon_sym_void] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1310),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [anon_sym_DASH_DASH] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(1308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1308),
    [sym_number] = ACTIONS(1308),
    [sym_this] = ACTIONS(1310),
    [sym_super] = ACTIONS(1310),
    [sym_true] = ACTIONS(1310),
    [sym_false] = ACTIONS(1310),
    [sym_null] = ACTIONS(1310),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1310),
    [anon_sym_readonly] = ACTIONS(1310),
    [anon_sym_get] = ACTIONS(1310),
    [anon_sym_set] = ACTIONS(1310),
    [anon_sym_declare] = ACTIONS(1310),
    [anon_sym_public] = ACTIONS(1310),
    [anon_sym_private] = ACTIONS(1310),
    [anon_sym_protected] = ACTIONS(1310),
    [anon_sym_override] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1310),
    [anon_sym_any] = ACTIONS(1310),
    [anon_sym_number] = ACTIONS(1310),
    [anon_sym_boolean] = ACTIONS(1310),
    [anon_sym_string] = ACTIONS(1310),
    [anon_sym_symbol] = ACTIONS(1310),
    [anon_sym_abstract] = ACTIONS(1310),
    [anon_sym_interface] = ACTIONS(1310),
    [anon_sym_enum] = ACTIONS(1310),
  },
  [751] = {
    [ts_builtin_sym_end] = ACTIONS(2374),
    [sym_identifier] = ACTIONS(2376),
    [anon_sym_export] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_type] = ACTIONS(2376),
    [anon_sym_namespace] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2374),
    [anon_sym_RBRACE] = ACTIONS(2374),
    [anon_sym_typeof] = ACTIONS(2376),
    [anon_sym_import] = ACTIONS(2376),
    [anon_sym_var] = ACTIONS(2376),
    [anon_sym_let] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2374),
    [anon_sym_else] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_switch] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2374),
    [anon_sym_await] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_do] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [anon_sym_with] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_debugger] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_throw] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2374),
    [anon_sym_case] = ACTIONS(2376),
    [anon_sym_yield] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_LT] = ACTIONS(2374),
    [anon_sym_SLASH] = ACTIONS(2376),
    [anon_sym_class] = ACTIONS(2376),
    [anon_sym_async] = ACTIONS(2376),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_new] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_TILDE] = ACTIONS(2374),
    [anon_sym_void] = ACTIONS(2376),
    [anon_sym_delete] = ACTIONS(2376),
    [anon_sym_PLUS_PLUS] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2374),
    [anon_sym_DQUOTE] = ACTIONS(2374),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2374),
    [sym_number] = ACTIONS(2374),
    [sym_this] = ACTIONS(2376),
    [sym_super] = ACTIONS(2376),
    [sym_true] = ACTIONS(2376),
    [sym_false] = ACTIONS(2376),
    [sym_null] = ACTIONS(2376),
    [sym_undefined] = ACTIONS(2376),
    [anon_sym_AT] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_readonly] = ACTIONS(2376),
    [anon_sym_get] = ACTIONS(2376),
    [anon_sym_set] = ACTIONS(2376),
    [anon_sym_declare] = ACTIONS(2376),
    [anon_sym_public] = ACTIONS(2376),
    [anon_sym_private] = ACTIONS(2376),
    [anon_sym_protected] = ACTIONS(2376),
    [anon_sym_override] = ACTIONS(2376),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_any] = ACTIONS(2376),
    [anon_sym_number] = ACTIONS(2376),
    [anon_sym_boolean] = ACTIONS(2376),
    [anon_sym_string] = ACTIONS(2376),
    [anon_sym_symbol] = ACTIONS(2376),
    [anon_sym_abstract] = ACTIONS(2376),
    [anon_sym_interface] = ACTIONS(2376),
    [anon_sym_enum] = ACTIONS(2376),
  },
  [752] = {
    [ts_builtin_sym_end] = ACTIONS(2378),
    [sym_identifier] = ACTIONS(2380),
    [anon_sym_export] = ACTIONS(2380),
    [anon_sym_default] = ACTIONS(2380),
    [anon_sym_type] = ACTIONS(2380),
    [anon_sym_namespace] = ACTIONS(2380),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_typeof] = ACTIONS(2380),
    [anon_sym_import] = ACTIONS(2380),
    [anon_sym_var] = ACTIONS(2380),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_const] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2380),
    [anon_sym_for] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_await] = ACTIONS(2380),
    [anon_sym_while] = ACTIONS(2380),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_try] = ACTIONS(2380),
    [anon_sym_with] = ACTIONS(2380),
    [anon_sym_break] = ACTIONS(2380),
    [anon_sym_continue] = ACTIONS(2380),
    [anon_sym_debugger] = ACTIONS(2380),
    [anon_sym_return] = ACTIONS(2380),
    [anon_sym_throw] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2380),
    [anon_sym_yield] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(2378),
    [anon_sym_SLASH] = ACTIONS(2380),
    [anon_sym_class] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2380),
    [anon_sym_function] = ACTIONS(2380),
    [anon_sym_new] = ACTIONS(2380),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2378),
    [anon_sym_void] = ACTIONS(2380),
    [anon_sym_delete] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2378),
    [sym_number] = ACTIONS(2378),
    [sym_this] = ACTIONS(2380),
    [sym_super] = ACTIONS(2380),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [sym_null] = ACTIONS(2380),
    [sym_undefined] = ACTIONS(2380),
    [anon_sym_AT] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2380),
    [anon_sym_readonly] = ACTIONS(2380),
    [anon_sym_get] = ACTIONS(2380),
    [anon_sym_set] = ACTIONS(2380),
    [anon_sym_declare] = ACTIONS(2380),
    [anon_sym_public] = ACTIONS(2380),
    [anon_sym_private] = ACTIONS(2380),
    [anon_sym_protected] = ACTIONS(2380),
    [anon_sym_override] = ACTIONS(2380),
    [anon_sym_module] = ACTIONS(2380),
    [anon_sym_any] = ACTIONS(2380),
    [anon_sym_number] = ACTIONS(2380),
    [anon_sym_boolean] = ACTIONS(2380),
    [anon_sym_string] = ACTIONS(2380),
    [anon_sym_symbol] = ACTIONS(2380),
    [anon_sym_abstract] = ACTIONS(2380),
    [anon_sym_interface] = ACTIONS(2380),
    [anon_sym_enum] = ACTIONS(2380),
  },
  [753] = {
    [ts_builtin_sym_end] = ACTIONS(2382),
    [sym_identifier] = ACTIONS(2384),
    [anon_sym_export] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_type] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2382),
    [anon_sym_typeof] = ACTIONS(2384),
    [anon_sym_import] = ACTIONS(2384),
    [anon_sym_var] = ACTIONS(2384),
    [anon_sym_let] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_else] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_await] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_with] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_debugger] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_yield] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(2382),
    [anon_sym_SLASH] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_async] = ACTIONS(2384),
    [anon_sym_function] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2382),
    [anon_sym_void] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2382),
    [anon_sym_DQUOTE] = ACTIONS(2382),
    [anon_sym_SQUOTE] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2382),
    [sym_number] = ACTIONS(2382),
    [sym_this] = ACTIONS(2384),
    [sym_super] = ACTIONS(2384),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [sym_null] = ACTIONS(2384),
    [sym_undefined] = ACTIONS(2384),
    [anon_sym_AT] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_readonly] = ACTIONS(2384),
    [anon_sym_get] = ACTIONS(2384),
    [anon_sym_set] = ACTIONS(2384),
    [anon_sym_declare] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_override] = ACTIONS(2384),
    [anon_sym_module] = ACTIONS(2384),
    [anon_sym_any] = ACTIONS(2384),
    [anon_sym_number] = ACTIONS(2384),
    [anon_sym_boolean] = ACTIONS(2384),
    [anon_sym_string] = ACTIONS(2384),
    [anon_sym_symbol] = ACTIONS(2384),
    [anon_sym_abstract] = ACTIONS(2384),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
  },
  [754] = {
    [ts_builtin_sym_end] = ACTIONS(2386),
    [sym_identifier] = ACTIONS(2388),
    [anon_sym_export] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_type] = ACTIONS(2388),
    [anon_sym_namespace] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_RBRACE] = ACTIONS(2386),
    [anon_sym_typeof] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2388),
    [anon_sym_var] = ACTIONS(2388),
    [anon_sym_let] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_else] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_switch] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2386),
    [anon_sym_await] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [anon_sym_with] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_debugger] = ACTIONS(2388),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_throw] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym_case] = ACTIONS(2388),
    [anon_sym_yield] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_LT] = ACTIONS(2386),
    [anon_sym_SLASH] = ACTIONS(2388),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_async] = ACTIONS(2388),
    [anon_sym_function] = ACTIONS(2388),
    [anon_sym_new] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_void] = ACTIONS(2388),
    [anon_sym_delete] = ACTIONS(2388),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [sym_number] = ACTIONS(2386),
    [sym_this] = ACTIONS(2388),
    [sym_super] = ACTIONS(2388),
    [sym_true] = ACTIONS(2388),
    [sym_false] = ACTIONS(2388),
    [sym_null] = ACTIONS(2388),
    [sym_undefined] = ACTIONS(2388),
    [anon_sym_AT] = ACTIONS(2386),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_readonly] = ACTIONS(2388),
    [anon_sym_get] = ACTIONS(2388),
    [anon_sym_set] = ACTIONS(2388),
    [anon_sym_declare] = ACTIONS(2388),
    [anon_sym_public] = ACTIONS(2388),
    [anon_sym_private] = ACTIONS(2388),
    [anon_sym_protected] = ACTIONS(2388),
    [anon_sym_override] = ACTIONS(2388),
    [anon_sym_module] = ACTIONS(2388),
    [anon_sym_any] = ACTIONS(2388),
    [anon_sym_number] = ACTIONS(2388),
    [anon_sym_boolean] = ACTIONS(2388),
    [anon_sym_string] = ACTIONS(2388),
    [anon_sym_symbol] = ACTIONS(2388),
    [anon_sym_abstract] = ACTIONS(2388),
    [anon_sym_interface] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
  },
  [755] = {
    [ts_builtin_sym_end] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2392),
    [anon_sym_export] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_type] = ACTIONS(2392),
    [anon_sym_namespace] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_RBRACE] = ACTIONS(2390),
    [anon_sym_typeof] = ACTIONS(2392),
    [anon_sym_import] = ACTIONS(2392),
    [anon_sym_var] = ACTIONS(2392),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_switch] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_do] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [anon_sym_with] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_debugger] = ACTIONS(2392),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_throw] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2390),
    [anon_sym_case] = ACTIONS(2392),
    [anon_sym_yield] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2392),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_async] = ACTIONS(2392),
    [anon_sym_function] = ACTIONS(2392),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_void] = ACTIONS(2392),
    [anon_sym_delete] = ACTIONS(2392),
    [anon_sym_PLUS_PLUS] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2390),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2390),
    [sym_number] = ACTIONS(2390),
    [sym_this] = ACTIONS(2392),
    [sym_super] = ACTIONS(2392),
    [sym_true] = ACTIONS(2392),
    [sym_false] = ACTIONS(2392),
    [sym_null] = ACTIONS(2392),
    [sym_undefined] = ACTIONS(2392),
    [anon_sym_AT] = ACTIONS(2390),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_readonly] = ACTIONS(2392),
    [anon_sym_get] = ACTIONS(2392),
    [anon_sym_set] = ACTIONS(2392),
    [anon_sym_declare] = ACTIONS(2392),
    [anon_sym_public] = ACTIONS(2392),
    [anon_sym_private] = ACTIONS(2392),
    [anon_sym_protected] = ACTIONS(2392),
    [anon_sym_override] = ACTIONS(2392),
    [anon_sym_module] = ACTIONS(2392),
    [anon_sym_any] = ACTIONS(2392),
    [anon_sym_number] = ACTIONS(2392),
    [anon_sym_boolean] = ACTIONS(2392),
    [anon_sym_string] = ACTIONS(2392),
    [anon_sym_symbol] = ACTIONS(2392),
    [anon_sym_abstract] = ACTIONS(2392),
    [anon_sym_interface] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
  },
  [756] = {
    [ts_builtin_sym_end] = ACTIONS(2394),
    [sym_identifier] = ACTIONS(2396),
    [anon_sym_export] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_type] = ACTIONS(2396),
    [anon_sym_namespace] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_typeof] = ACTIONS(2396),
    [anon_sym_import] = ACTIONS(2396),
    [anon_sym_var] = ACTIONS(2396),
    [anon_sym_let] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_else] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_await] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_with] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_debugger] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2396),
    [anon_sym_yield] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_async] = ACTIONS(2396),
    [anon_sym_function] = ACTIONS(2396),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_void] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2394),
    [sym_number] = ACTIONS(2394),
    [sym_this] = ACTIONS(2396),
    [sym_super] = ACTIONS(2396),
    [sym_true] = ACTIONS(2396),
    [sym_false] = ACTIONS(2396),
    [sym_null] = ACTIONS(2396),
    [sym_undefined] = ACTIONS(2396),
    [anon_sym_AT] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_readonly] = ACTIONS(2396),
    [anon_sym_get] = ACTIONS(2396),
    [anon_sym_set] = ACTIONS(2396),
    [anon_sym_declare] = ACTIONS(2396),
    [anon_sym_public] = ACTIONS(2396),
    [anon_sym_private] = ACTIONS(2396),
    [anon_sym_protected] = ACTIONS(2396),
    [anon_sym_override] = ACTIONS(2396),
    [anon_sym_module] = ACTIONS(2396),
    [anon_sym_any] = ACTIONS(2396),
    [anon_sym_number] = ACTIONS(2396),
    [anon_sym_boolean] = ACTIONS(2396),
    [anon_sym_string] = ACTIONS(2396),
    [anon_sym_symbol] = ACTIONS(2396),
    [anon_sym_abstract] = ACTIONS(2396),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
  },
  [757] = {
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2400),
    [anon_sym_export] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_type] = ACTIONS(2400),
    [anon_sym_namespace] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_typeof] = ACTIONS(2400),
    [anon_sym_import] = ACTIONS(2400),
    [anon_sym_var] = ACTIONS(2400),
    [anon_sym_let] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_else] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_await] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_do] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [anon_sym_with] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_debugger] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_throw] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_case] = ACTIONS(2400),
    [anon_sym_yield] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_class] = ACTIONS(2400),
    [anon_sym_async] = ACTIONS(2400),
    [anon_sym_function] = ACTIONS(2400),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_void] = ACTIONS(2400),
    [anon_sym_delete] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [sym_number] = ACTIONS(2398),
    [sym_this] = ACTIONS(2400),
    [sym_super] = ACTIONS(2400),
    [sym_true] = ACTIONS(2400),
    [sym_false] = ACTIONS(2400),
    [sym_null] = ACTIONS(2400),
    [sym_undefined] = ACTIONS(2400),
    [anon_sym_AT] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_readonly] = ACTIONS(2400),
    [anon_sym_get] = ACTIONS(2400),
    [anon_sym_set] = ACTIONS(2400),
    [anon_sym_declare] = ACTIONS(2400),
    [anon_sym_public] = ACTIONS(2400),
    [anon_sym_private] = ACTIONS(2400),
    [anon_sym_protected] = ACTIONS(2400),
    [anon_sym_override] = ACTIONS(2400),
    [anon_sym_module] = ACTIONS(2400),
    [anon_sym_any] = ACTIONS(2400),
    [anon_sym_number] = ACTIONS(2400),
    [anon_sym_boolean] = ACTIONS(2400),
    [anon_sym_string] = ACTIONS(2400),
    [anon_sym_symbol] = ACTIONS(2400),
    [anon_sym_abstract] = ACTIONS(2400),
    [anon_sym_interface] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
  },
  [758] = {
    [ts_builtin_sym_end] = ACTIONS(2402),
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_typeof] = ACTIONS(2404),
    [anon_sym_import] = ACTIONS(2404),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_else] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_await] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_with] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_debugger] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_yield] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_SLASH] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [sym_number] = ACTIONS(2402),
    [sym_this] = ACTIONS(2404),
    [sym_super] = ACTIONS(2404),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [sym_null] = ACTIONS(2404),
    [sym_undefined] = ACTIONS(2404),
    [anon_sym_AT] = ACTIONS(2402),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_readonly] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2404),
    [anon_sym_set] = ACTIONS(2404),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_override] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2404),
    [anon_sym_abstract] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
  },
  [759] = {
    [ts_builtin_sym_end] = ACTIONS(2406),
    [sym_identifier] = ACTIONS(2408),
    [anon_sym_export] = ACTIONS(2408),
    [anon_sym_default] = ACTIONS(2408),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_namespace] = ACTIONS(2408),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_typeof] = ACTIONS(2408),
    [anon_sym_import] = ACTIONS(2408),
    [anon_sym_var] = ACTIONS(2408),
    [anon_sym_let] = ACTIONS(2408),
    [anon_sym_const] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_else] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2408),
    [anon_sym_switch] = ACTIONS(2408),
    [anon_sym_for] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_await] = ACTIONS(2408),
    [anon_sym_while] = ACTIONS(2408),
    [anon_sym_do] = ACTIONS(2408),
    [anon_sym_try] = ACTIONS(2408),
    [anon_sym_with] = ACTIONS(2408),
    [anon_sym_break] = ACTIONS(2408),
    [anon_sym_continue] = ACTIONS(2408),
    [anon_sym_debugger] = ACTIONS(2408),
    [anon_sym_return] = ACTIONS(2408),
    [anon_sym_throw] = ACTIONS(2408),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym_case] = ACTIONS(2408),
    [anon_sym_yield] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_SLASH] = ACTIONS(2408),
    [anon_sym_class] = ACTIONS(2408),
    [anon_sym_async] = ACTIONS(2408),
    [anon_sym_function] = ACTIONS(2408),
    [anon_sym_new] = ACTIONS(2408),
    [anon_sym_PLUS] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_void] = ACTIONS(2408),
    [anon_sym_delete] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [sym_number] = ACTIONS(2406),
    [sym_this] = ACTIONS(2408),
    [sym_super] = ACTIONS(2408),
    [sym_true] = ACTIONS(2408),
    [sym_false] = ACTIONS(2408),
    [sym_null] = ACTIONS(2408),
    [sym_undefined] = ACTIONS(2408),
    [anon_sym_AT] = ACTIONS(2406),
    [anon_sym_static] = ACTIONS(2408),
    [anon_sym_readonly] = ACTIONS(2408),
    [anon_sym_get] = ACTIONS(2408),
    [anon_sym_set] = ACTIONS(2408),
    [anon_sym_declare] = ACTIONS(2408),
    [anon_sym_public] = ACTIONS(2408),
    [anon_sym_private] = ACTIONS(2408),
    [anon_sym_protected] = ACTIONS(2408),
    [anon_sym_override] = ACTIONS(2408),
    [anon_sym_module] = ACTIONS(2408),
    [anon_sym_any] = ACTIONS(2408),
    [anon_sym_number] = ACTIONS(2408),
    [anon_sym_boolean] = ACTIONS(2408),
    [anon_sym_string] = ACTIONS(2408),
    [anon_sym_symbol] = ACTIONS(2408),
    [anon_sym_abstract] = ACTIONS(2408),
    [anon_sym_interface] = ACTIONS(2408),
    [anon_sym_enum] = ACTIONS(2408),
  },
  [760] = {
    [ts_builtin_sym_end] = ACTIONS(2410),
    [sym_identifier] = ACTIONS(2412),
    [anon_sym_export] = ACTIONS(2412),
    [anon_sym_default] = ACTIONS(2412),
    [anon_sym_type] = ACTIONS(2412),
    [anon_sym_namespace] = ACTIONS(2412),
    [anon_sym_LBRACE] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(2410),
    [anon_sym_typeof] = ACTIONS(2412),
    [anon_sym_import] = ACTIONS(2412),
    [anon_sym_var] = ACTIONS(2412),
    [anon_sym_let] = ACTIONS(2412),
    [anon_sym_const] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2412),
    [anon_sym_if] = ACTIONS(2412),
    [anon_sym_switch] = ACTIONS(2412),
    [anon_sym_for] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [anon_sym_await] = ACTIONS(2412),
    [anon_sym_while] = ACTIONS(2412),
    [anon_sym_do] = ACTIONS(2412),
    [anon_sym_try] = ACTIONS(2412),
    [anon_sym_with] = ACTIONS(2412),
    [anon_sym_break] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(2412),
    [anon_sym_debugger] = ACTIONS(2412),
    [anon_sym_return] = ACTIONS(2412),
    [anon_sym_throw] = ACTIONS(2412),
    [anon_sym_SEMI] = ACTIONS(2410),
    [anon_sym_case] = ACTIONS(2412),
    [anon_sym_yield] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(2410),
    [anon_sym_SLASH] = ACTIONS(2412),
    [anon_sym_class] = ACTIONS(2412),
    [anon_sym_async] = ACTIONS(2412),
    [anon_sym_function] = ACTIONS(2412),
    [anon_sym_new] = ACTIONS(2412),
    [anon_sym_PLUS] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2410),
    [anon_sym_void] = ACTIONS(2412),
    [anon_sym_delete] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2410),
    [anon_sym_SQUOTE] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2410),
    [sym_number] = ACTIONS(2410),
    [sym_this] = ACTIONS(2412),
    [sym_super] = ACTIONS(2412),
    [sym_true] = ACTIONS(2412),
    [sym_false] = ACTIONS(2412),
    [sym_null] = ACTIONS(2412),
    [sym_undefined] = ACTIONS(2412),
    [anon_sym_AT] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2412),
    [anon_sym_readonly] = ACTIONS(2412),
    [anon_sym_get] = ACTIONS(2412),
    [anon_sym_set] = ACTIONS(2412),
    [anon_sym_declare] = ACTIONS(2412),
    [anon_sym_public] = ACTIONS(2412),
    [anon_sym_private] = ACTIONS(2412),
    [anon_sym_protected] = ACTIONS(2412),
    [anon_sym_override] = ACTIONS(2412),
    [anon_sym_module] = ACTIONS(2412),
    [anon_sym_any] = ACTIONS(2412),
    [anon_sym_number] = ACTIONS(2412),
    [anon_sym_boolean] = ACTIONS(2412),
    [anon_sym_string] = ACTIONS(2412),
    [anon_sym_symbol] = ACTIONS(2412),
    [anon_sym_abstract] = ACTIONS(2412),
    [anon_sym_interface] = ACTIONS(2412),
    [anon_sym_enum] = ACTIONS(2412),
  },
  [761] = {
    [ts_builtin_sym_end] = ACTIONS(2414),
    [sym_identifier] = ACTIONS(2416),
    [anon_sym_export] = ACTIONS(2416),
    [anon_sym_default] = ACTIONS(2416),
    [anon_sym_type] = ACTIONS(2416),
    [anon_sym_namespace] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_typeof] = ACTIONS(2416),
    [anon_sym_import] = ACTIONS(2416),
    [anon_sym_var] = ACTIONS(2416),
    [anon_sym_let] = ACTIONS(2416),
    [anon_sym_const] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2416),
    [anon_sym_if] = ACTIONS(2416),
    [anon_sym_switch] = ACTIONS(2416),
    [anon_sym_for] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2414),
    [anon_sym_await] = ACTIONS(2416),
    [anon_sym_while] = ACTIONS(2416),
    [anon_sym_do] = ACTIONS(2416),
    [anon_sym_try] = ACTIONS(2416),
    [anon_sym_with] = ACTIONS(2416),
    [anon_sym_break] = ACTIONS(2416),
    [anon_sym_continue] = ACTIONS(2416),
    [anon_sym_debugger] = ACTIONS(2416),
    [anon_sym_return] = ACTIONS(2416),
    [anon_sym_throw] = ACTIONS(2416),
    [anon_sym_SEMI] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2416),
    [anon_sym_yield] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_SLASH] = ACTIONS(2416),
    [anon_sym_class] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2416),
    [anon_sym_function] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2416),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2414),
    [anon_sym_void] = ACTIONS(2416),
    [anon_sym_delete] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2414),
    [anon_sym_DQUOTE] = ACTIONS(2414),
    [anon_sym_SQUOTE] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2414),
    [sym_number] = ACTIONS(2414),
    [sym_this] = ACTIONS(2416),
    [sym_super] = ACTIONS(2416),
    [sym_true] = ACTIONS(2416),
    [sym_false] = ACTIONS(2416),
    [sym_null] = ACTIONS(2416),
    [sym_undefined] = ACTIONS(2416),
    [anon_sym_AT] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_readonly] = ACTIONS(2416),
    [anon_sym_get] = ACTIONS(2416),
    [anon_sym_set] = ACTIONS(2416),
    [anon_sym_declare] = ACTIONS(2416),
    [anon_sym_public] = ACTIONS(2416),
    [anon_sym_private] = ACTIONS(2416),
    [anon_sym_protected] = ACTIONS(2416),
    [anon_sym_override] = ACTIONS(2416),
    [anon_sym_module] = ACTIONS(2416),
    [anon_sym_any] = ACTIONS(2416),
    [anon_sym_number] = ACTIONS(2416),
    [anon_sym_boolean] = ACTIONS(2416),
    [anon_sym_string] = ACTIONS(2416),
    [anon_sym_symbol] = ACTIONS(2416),
    [anon_sym_abstract] = ACTIONS(2416),
    [anon_sym_interface] = ACTIONS(2416),
    [anon_sym_enum] = ACTIONS(2416),
  },
  [762] = {
    [ts_builtin_sym_end] = ACTIONS(2418),
    [sym_identifier] = ACTIONS(2420),
    [anon_sym_export] = ACTIONS(2420),
    [anon_sym_default] = ACTIONS(2420),
    [anon_sym_type] = ACTIONS(2420),
    [anon_sym_namespace] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_RBRACE] = ACTIONS(2418),
    [anon_sym_typeof] = ACTIONS(2420),
    [anon_sym_import] = ACTIONS(2420),
    [anon_sym_var] = ACTIONS(2420),
    [anon_sym_let] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_else] = ACTIONS(2420),
    [anon_sym_if] = ACTIONS(2420),
    [anon_sym_switch] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_await] = ACTIONS(2420),
    [anon_sym_while] = ACTIONS(2420),
    [anon_sym_do] = ACTIONS(2420),
    [anon_sym_try] = ACTIONS(2420),
    [anon_sym_with] = ACTIONS(2420),
    [anon_sym_break] = ACTIONS(2420),
    [anon_sym_continue] = ACTIONS(2420),
    [anon_sym_debugger] = ACTIONS(2420),
    [anon_sym_return] = ACTIONS(2420),
    [anon_sym_throw] = ACTIONS(2420),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_case] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2420),
    [anon_sym_class] = ACTIONS(2420),
    [anon_sym_async] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2418),
    [anon_sym_void] = ACTIONS(2420),
    [anon_sym_delete] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_SQUOTE] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2418),
    [sym_number] = ACTIONS(2418),
    [sym_this] = ACTIONS(2420),
    [sym_super] = ACTIONS(2420),
    [sym_true] = ACTIONS(2420),
    [sym_false] = ACTIONS(2420),
    [sym_null] = ACTIONS(2420),
    [sym_undefined] = ACTIONS(2420),
    [anon_sym_AT] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2420),
    [anon_sym_readonly] = ACTIONS(2420),
    [anon_sym_get] = ACTIONS(2420),
    [anon_sym_set] = ACTIONS(2420),
    [anon_sym_declare] = ACTIONS(2420),
    [anon_sym_public] = ACTIONS(2420),
    [anon_sym_private] = ACTIONS(2420),
    [anon_sym_protected] = ACTIONS(2420),
    [anon_sym_override] = ACTIONS(2420),
    [anon_sym_module] = ACTIONS(2420),
    [anon_sym_any] = ACTIONS(2420),
    [anon_sym_number] = ACTIONS(2420),
    [anon_sym_boolean] = ACTIONS(2420),
    [anon_sym_string] = ACTIONS(2420),
    [anon_sym_symbol] = ACTIONS(2420),
    [anon_sym_abstract] = ACTIONS(2420),
    [anon_sym_interface] = ACTIONS(2420),
    [anon_sym_enum] = ACTIONS(2420),
  },
  [763] = {
    [ts_builtin_sym_end] = ACTIONS(2422),
    [sym_identifier] = ACTIONS(2424),
    [anon_sym_export] = ACTIONS(2424),
    [anon_sym_default] = ACTIONS(2424),
    [anon_sym_type] = ACTIONS(2424),
    [anon_sym_namespace] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_RBRACE] = ACTIONS(2422),
    [anon_sym_typeof] = ACTIONS(2424),
    [anon_sym_import] = ACTIONS(2424),
    [anon_sym_var] = ACTIONS(2424),
    [anon_sym_let] = ACTIONS(2424),
    [anon_sym_const] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2424),
    [anon_sym_if] = ACTIONS(2424),
    [anon_sym_switch] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_await] = ACTIONS(2424),
    [anon_sym_while] = ACTIONS(2424),
    [anon_sym_do] = ACTIONS(2424),
    [anon_sym_try] = ACTIONS(2424),
    [anon_sym_with] = ACTIONS(2424),
    [anon_sym_break] = ACTIONS(2424),
    [anon_sym_continue] = ACTIONS(2424),
    [anon_sym_debugger] = ACTIONS(2424),
    [anon_sym_return] = ACTIONS(2424),
    [anon_sym_throw] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2424),
    [anon_sym_class] = ACTIONS(2424),
    [anon_sym_async] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2424),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2422),
    [anon_sym_void] = ACTIONS(2424),
    [anon_sym_delete] = ACTIONS(2424),
    [anon_sym_PLUS_PLUS] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [sym_number] = ACTIONS(2422),
    [sym_this] = ACTIONS(2424),
    [sym_super] = ACTIONS(2424),
    [sym_true] = ACTIONS(2424),
    [sym_false] = ACTIONS(2424),
    [sym_null] = ACTIONS(2424),
    [sym_undefined] = ACTIONS(2424),
    [anon_sym_AT] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2424),
    [anon_sym_readonly] = ACTIONS(2424),
    [anon_sym_get] = ACTIONS(2424),
    [anon_sym_set] = ACTIONS(2424),
    [anon_sym_declare] = ACTIONS(2424),
    [anon_sym_public] = ACTIONS(2424),
    [anon_sym_private] = ACTIONS(2424),
    [anon_sym_protected] = ACTIONS(2424),
    [anon_sym_override] = ACTIONS(2424),
    [anon_sym_module] = ACTIONS(2424),
    [anon_sym_any] = ACTIONS(2424),
    [anon_sym_number] = ACTIONS(2424),
    [anon_sym_boolean] = ACTIONS(2424),
    [anon_sym_string] = ACTIONS(2424),
    [anon_sym_symbol] = ACTIONS(2424),
    [anon_sym_abstract] = ACTIONS(2424),
    [anon_sym_interface] = ACTIONS(2424),
    [anon_sym_enum] = ACTIONS(2424),
  },
  [764] = {
    [ts_builtin_sym_end] = ACTIONS(2426),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2428),
    [anon_sym_default] = ACTIONS(2428),
    [anon_sym_type] = ACTIONS(2428),
    [anon_sym_namespace] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_RBRACE] = ACTIONS(2426),
    [anon_sym_typeof] = ACTIONS(2428),
    [anon_sym_import] = ACTIONS(2428),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_else] = ACTIONS(2428),
    [anon_sym_if] = ACTIONS(2428),
    [anon_sym_switch] = ACTIONS(2428),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2426),
    [anon_sym_await] = ACTIONS(2428),
    [anon_sym_while] = ACTIONS(2428),
    [anon_sym_do] = ACTIONS(2428),
    [anon_sym_try] = ACTIONS(2428),
    [anon_sym_with] = ACTIONS(2428),
    [anon_sym_break] = ACTIONS(2428),
    [anon_sym_continue] = ACTIONS(2428),
    [anon_sym_debugger] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2428),
    [anon_sym_throw] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(2428),
    [anon_sym_yield] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2426),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(2428),
    [anon_sym_async] = ACTIONS(2428),
    [anon_sym_function] = ACTIONS(2428),
    [anon_sym_new] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_void] = ACTIONS(2428),
    [anon_sym_delete] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2426),
    [anon_sym_DASH_DASH] = ACTIONS(2426),
    [anon_sym_DQUOTE] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2426),
    [sym_number] = ACTIONS(2426),
    [sym_this] = ACTIONS(2428),
    [sym_super] = ACTIONS(2428),
    [sym_true] = ACTIONS(2428),
    [sym_false] = ACTIONS(2428),
    [sym_null] = ACTIONS(2428),
    [sym_undefined] = ACTIONS(2428),
    [anon_sym_AT] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_readonly] = ACTIONS(2428),
    [anon_sym_get] = ACTIONS(2428),
    [anon_sym_set] = ACTIONS(2428),
    [anon_sym_declare] = ACTIONS(2428),
    [anon_sym_public] = ACTIONS(2428),
    [anon_sym_private] = ACTIONS(2428),
    [anon_sym_protected] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_module] = ACTIONS(2428),
    [anon_sym_any] = ACTIONS(2428),
    [anon_sym_number] = ACTIONS(2428),
    [anon_sym_boolean] = ACTIONS(2428),
    [anon_sym_string] = ACTIONS(2428),
    [anon_sym_symbol] = ACTIONS(2428),
    [anon_sym_abstract] = ACTIONS(2428),
    [anon_sym_interface] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
  },
  [765] = {
    [ts_builtin_sym_end] = ACTIONS(2430),
    [sym_identifier] = ACTIONS(2432),
    [anon_sym_export] = ACTIONS(2432),
    [anon_sym_default] = ACTIONS(2432),
    [anon_sym_type] = ACTIONS(2432),
    [anon_sym_namespace] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_typeof] = ACTIONS(2432),
    [anon_sym_import] = ACTIONS(2432),
    [anon_sym_var] = ACTIONS(2432),
    [anon_sym_let] = ACTIONS(2432),
    [anon_sym_const] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_else] = ACTIONS(2432),
    [anon_sym_if] = ACTIONS(2432),
    [anon_sym_switch] = ACTIONS(2432),
    [anon_sym_for] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_await] = ACTIONS(2432),
    [anon_sym_while] = ACTIONS(2432),
    [anon_sym_do] = ACTIONS(2432),
    [anon_sym_try] = ACTIONS(2432),
    [anon_sym_with] = ACTIONS(2432),
    [anon_sym_break] = ACTIONS(2432),
    [anon_sym_continue] = ACTIONS(2432),
    [anon_sym_debugger] = ACTIONS(2432),
    [anon_sym_return] = ACTIONS(2432),
    [anon_sym_throw] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(2432),
    [anon_sym_yield] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2432),
    [anon_sym_class] = ACTIONS(2432),
    [anon_sym_async] = ACTIONS(2432),
    [anon_sym_function] = ACTIONS(2432),
    [anon_sym_new] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_TILDE] = ACTIONS(2430),
    [anon_sym_void] = ACTIONS(2432),
    [anon_sym_delete] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(2430),
    [anon_sym_SQUOTE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2430),
    [sym_number] = ACTIONS(2430),
    [sym_this] = ACTIONS(2432),
    [sym_super] = ACTIONS(2432),
    [sym_true] = ACTIONS(2432),
    [sym_false] = ACTIONS(2432),
    [sym_null] = ACTIONS(2432),
    [sym_undefined] = ACTIONS(2432),
    [anon_sym_AT] = ACTIONS(2430),
    [anon_sym_static] = ACTIONS(2432),
    [anon_sym_readonly] = ACTIONS(2432),
    [anon_sym_get] = ACTIONS(2432),
    [anon_sym_set] = ACTIONS(2432),
    [anon_sym_declare] = ACTIONS(2432),
    [anon_sym_public] = ACTIONS(2432),
    [anon_sym_private] = ACTIONS(2432),
    [anon_sym_protected] = ACTIONS(2432),
    [anon_sym_override] = ACTIONS(2432),
    [anon_sym_module] = ACTIONS(2432),
    [anon_sym_any] = ACTIONS(2432),
    [anon_sym_number] = ACTIONS(2432),
    [anon_sym_boolean] = ACTIONS(2432),
    [anon_sym_string] = ACTIONS(2432),
    [anon_sym_symbol] = ACTIONS(2432),
    [anon_sym_abstract] = ACTIONS(2432),
    [anon_sym_interface] = ACTIONS(2432),
    [anon_sym_enum] = ACTIONS(2432),
  },
  [766] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3517),
    [sym_optional_tuple_parameter] = STATE(3517),
    [sym_optional_type] = STATE(3517),
    [sym_rest_type] = STATE(3517),
    [sym__tuple_type_member] = STATE(3517),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(2436),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [767] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3504),
    [sym_optional_tuple_parameter] = STATE(3504),
    [sym_optional_type] = STATE(3504),
    [sym_rest_type] = STATE(3504),
    [sym__tuple_type_member] = STATE(3504),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [768] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3393),
    [sym_optional_tuple_parameter] = STATE(3393),
    [sym_optional_type] = STATE(3393),
    [sym_rest_type] = STATE(3393),
    [sym__tuple_type_member] = STATE(3393),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [769] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3437),
    [sym_optional_tuple_parameter] = STATE(3437),
    [sym_optional_type] = STATE(3437),
    [sym_rest_type] = STATE(3437),
    [sym__tuple_type_member] = STATE(3437),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(2454),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [770] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3578),
    [sym_optional_tuple_parameter] = STATE(3578),
    [sym_optional_type] = STATE(3578),
    [sym_rest_type] = STATE(3578),
    [sym__tuple_type_member] = STATE(3578),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [771] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3734),
    [sym_optional_tuple_parameter] = STATE(3734),
    [sym_optional_type] = STATE(3734),
    [sym_rest_type] = STATE(3734),
    [sym__tuple_type_member] = STATE(3734),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [772] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3734),
    [sym_optional_tuple_parameter] = STATE(3734),
    [sym_optional_type] = STATE(3734),
    [sym_rest_type] = STATE(3734),
    [sym__tuple_type_member] = STATE(3734),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [773] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3734),
    [sym_optional_tuple_parameter] = STATE(3734),
    [sym_optional_type] = STATE(3734),
    [sym_rest_type] = STATE(3734),
    [sym__tuple_type_member] = STATE(3734),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [774] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3734),
    [sym_optional_tuple_parameter] = STATE(3734),
    [sym_optional_type] = STATE(3734),
    [sym_rest_type] = STATE(3734),
    [sym__tuple_type_member] = STATE(3734),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [775] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3734),
    [sym_optional_tuple_parameter] = STATE(3734),
    [sym_optional_type] = STATE(3734),
    [sym_rest_type] = STATE(3734),
    [sym__tuple_type_member] = STATE(3734),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2470),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [776] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3734),
    [sym_optional_tuple_parameter] = STATE(3734),
    [sym_optional_type] = STATE(3734),
    [sym_rest_type] = STATE(3734),
    [sym__tuple_type_member] = STATE(3734),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [777] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3734),
    [sym_optional_tuple_parameter] = STATE(3734),
    [sym_optional_type] = STATE(3734),
    [sym_rest_type] = STATE(3734),
    [sym__tuple_type_member] = STATE(3734),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2474),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [778] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3734),
    [sym_optional_tuple_parameter] = STATE(3734),
    [sym_optional_type] = STATE(3734),
    [sym_rest_type] = STATE(3734),
    [sym__tuple_type_member] = STATE(3734),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [779] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3734),
    [sym_optional_tuple_parameter] = STATE(3734),
    [sym_optional_type] = STATE(3734),
    [sym_rest_type] = STATE(3734),
    [sym__tuple_type_member] = STATE(3734),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2478),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [780] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3734),
    [sym_optional_tuple_parameter] = STATE(3734),
    [sym_optional_type] = STATE(3734),
    [sym_rest_type] = STATE(3734),
    [sym__tuple_type_member] = STATE(3734),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [781] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [782] = {
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_export] = ACTIONS(2486),
    [anon_sym_type] = ACTIONS(2486),
    [anon_sym_namespace] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_typeof] = ACTIONS(2486),
    [anon_sym_import] = ACTIONS(2486),
    [anon_sym_var] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_switch] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2488),
    [anon_sym_await] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [anon_sym_do] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [anon_sym_with] = ACTIONS(2486),
    [anon_sym_break] = ACTIONS(2486),
    [anon_sym_continue] = ACTIONS(2486),
    [anon_sym_debugger] = ACTIONS(2486),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_throw] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_yield] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(2488),
    [anon_sym_SLASH] = ACTIONS(2486),
    [anon_sym_class] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2486),
    [anon_sym_function] = ACTIONS(2486),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2486),
    [anon_sym_TILDE] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2486),
    [anon_sym_delete] = ACTIONS(2486),
    [anon_sym_PLUS_PLUS] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2488),
    [anon_sym_SQUOTE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2488),
    [sym_number] = ACTIONS(2488),
    [sym_this] = ACTIONS(2486),
    [sym_super] = ACTIONS(2486),
    [sym_true] = ACTIONS(2486),
    [sym_false] = ACTIONS(2486),
    [sym_null] = ACTIONS(2486),
    [sym_undefined] = ACTIONS(2486),
    [anon_sym_AT] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2486),
    [anon_sym_readonly] = ACTIONS(2486),
    [anon_sym_get] = ACTIONS(2486),
    [anon_sym_set] = ACTIONS(2486),
    [anon_sym_declare] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2486),
    [anon_sym_private] = ACTIONS(2486),
    [anon_sym_protected] = ACTIONS(2486),
    [anon_sym_override] = ACTIONS(2486),
    [anon_sym_module] = ACTIONS(2486),
    [anon_sym_any] = ACTIONS(2486),
    [anon_sym_number] = ACTIONS(2486),
    [anon_sym_boolean] = ACTIONS(2486),
    [anon_sym_string] = ACTIONS(2486),
    [anon_sym_symbol] = ACTIONS(2486),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_interface] = ACTIONS(2486),
    [anon_sym_enum] = ACTIONS(2486),
  },
  [783] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_rest_pattern] = STATE(3808),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2965),
    [sym_tuple_parameter] = STATE(3734),
    [sym_optional_tuple_parameter] = STATE(3734),
    [sym_optional_type] = STATE(3734),
    [sym_rest_type] = STATE(3734),
    [sym__tuple_type_member] = STATE(3734),
    [sym_constructor_type] = STATE(2965),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2965),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2965),
    [sym_union_type] = STATE(2965),
    [sym_intersection_type] = STATE(2965),
    [sym_function_type] = STATE(2965),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [784] = {
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_export] = ACTIONS(2490),
    [anon_sym_type] = ACTIONS(2490),
    [anon_sym_namespace] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_typeof] = ACTIONS(2490),
    [anon_sym_import] = ACTIONS(2490),
    [anon_sym_var] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_switch] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2492),
    [anon_sym_await] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_with] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2490),
    [anon_sym_continue] = ACTIONS(2490),
    [anon_sym_debugger] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_throw] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_yield] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_function] = ACTIONS(2490),
    [anon_sym_new] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(2490),
    [anon_sym_delete] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [sym_number] = ACTIONS(2492),
    [sym_this] = ACTIONS(2490),
    [sym_super] = ACTIONS(2490),
    [sym_true] = ACTIONS(2490),
    [sym_false] = ACTIONS(2490),
    [sym_null] = ACTIONS(2490),
    [sym_undefined] = ACTIONS(2490),
    [anon_sym_AT] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_readonly] = ACTIONS(2490),
    [anon_sym_get] = ACTIONS(2490),
    [anon_sym_set] = ACTIONS(2490),
    [anon_sym_declare] = ACTIONS(2490),
    [anon_sym_public] = ACTIONS(2490),
    [anon_sym_private] = ACTIONS(2490),
    [anon_sym_protected] = ACTIONS(2490),
    [anon_sym_override] = ACTIONS(2490),
    [anon_sym_module] = ACTIONS(2490),
    [anon_sym_any] = ACTIONS(2490),
    [anon_sym_number] = ACTIONS(2490),
    [anon_sym_boolean] = ACTIONS(2490),
    [anon_sym_string] = ACTIONS(2490),
    [anon_sym_symbol] = ACTIONS(2490),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
  },
  [785] = {
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_export] = ACTIONS(2494),
    [anon_sym_type] = ACTIONS(2494),
    [anon_sym_namespace] = ACTIONS(2494),
    [anon_sym_LBRACE] = ACTIONS(2496),
    [anon_sym_typeof] = ACTIONS(2494),
    [anon_sym_import] = ACTIONS(2494),
    [anon_sym_var] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_switch] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_await] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [anon_sym_with] = ACTIONS(2494),
    [anon_sym_break] = ACTIONS(2494),
    [anon_sym_continue] = ACTIONS(2494),
    [anon_sym_debugger] = ACTIONS(2494),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_throw] = ACTIONS(2494),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_yield] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(2496),
    [anon_sym_SLASH] = ACTIONS(2494),
    [anon_sym_class] = ACTIONS(2494),
    [anon_sym_async] = ACTIONS(2494),
    [anon_sym_function] = ACTIONS(2494),
    [anon_sym_new] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_void] = ACTIONS(2494),
    [anon_sym_delete] = ACTIONS(2494),
    [anon_sym_PLUS_PLUS] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2496),
    [anon_sym_DQUOTE] = ACTIONS(2496),
    [anon_sym_SQUOTE] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2496),
    [sym_number] = ACTIONS(2496),
    [sym_this] = ACTIONS(2494),
    [sym_super] = ACTIONS(2494),
    [sym_true] = ACTIONS(2494),
    [sym_false] = ACTIONS(2494),
    [sym_null] = ACTIONS(2494),
    [sym_undefined] = ACTIONS(2494),
    [anon_sym_AT] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2494),
    [anon_sym_readonly] = ACTIONS(2494),
    [anon_sym_get] = ACTIONS(2494),
    [anon_sym_set] = ACTIONS(2494),
    [anon_sym_declare] = ACTIONS(2494),
    [anon_sym_public] = ACTIONS(2494),
    [anon_sym_private] = ACTIONS(2494),
    [anon_sym_protected] = ACTIONS(2494),
    [anon_sym_override] = ACTIONS(2494),
    [anon_sym_module] = ACTIONS(2494),
    [anon_sym_any] = ACTIONS(2494),
    [anon_sym_number] = ACTIONS(2494),
    [anon_sym_boolean] = ACTIONS(2494),
    [anon_sym_string] = ACTIONS(2494),
    [anon_sym_symbol] = ACTIONS(2494),
    [anon_sym_abstract] = ACTIONS(2494),
    [anon_sym_interface] = ACTIONS(2494),
    [anon_sym_enum] = ACTIONS(2494),
  },
  [786] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [787] = {
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_type] = ACTIONS(2498),
    [anon_sym_namespace] = ACTIONS(2498),
    [anon_sym_LBRACE] = ACTIONS(2500),
    [anon_sym_typeof] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2498),
    [anon_sym_var] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_switch] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2500),
    [anon_sym_await] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [anon_sym_do] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_with] = ACTIONS(2498),
    [anon_sym_break] = ACTIONS(2498),
    [anon_sym_continue] = ACTIONS(2498),
    [anon_sym_debugger] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_throw] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2500),
    [anon_sym_yield] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2500),
    [anon_sym_SLASH] = ACTIONS(2498),
    [anon_sym_class] = ACTIONS(2498),
    [anon_sym_async] = ACTIONS(2498),
    [anon_sym_function] = ACTIONS(2498),
    [anon_sym_new] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2500),
    [anon_sym_void] = ACTIONS(2498),
    [anon_sym_delete] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_SQUOTE] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [sym_number] = ACTIONS(2500),
    [sym_this] = ACTIONS(2498),
    [sym_super] = ACTIONS(2498),
    [sym_true] = ACTIONS(2498),
    [sym_false] = ACTIONS(2498),
    [sym_null] = ACTIONS(2498),
    [sym_undefined] = ACTIONS(2498),
    [anon_sym_AT] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2498),
    [anon_sym_readonly] = ACTIONS(2498),
    [anon_sym_get] = ACTIONS(2498),
    [anon_sym_set] = ACTIONS(2498),
    [anon_sym_declare] = ACTIONS(2498),
    [anon_sym_public] = ACTIONS(2498),
    [anon_sym_private] = ACTIONS(2498),
    [anon_sym_protected] = ACTIONS(2498),
    [anon_sym_override] = ACTIONS(2498),
    [anon_sym_module] = ACTIONS(2498),
    [anon_sym_any] = ACTIONS(2498),
    [anon_sym_number] = ACTIONS(2498),
    [anon_sym_boolean] = ACTIONS(2498),
    [anon_sym_string] = ACTIONS(2498),
    [anon_sym_symbol] = ACTIONS(2498),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_interface] = ACTIONS(2498),
    [anon_sym_enum] = ACTIONS(2498),
  },
  [788] = {
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_export] = ACTIONS(2502),
    [anon_sym_type] = ACTIONS(2502),
    [anon_sym_namespace] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2504),
    [anon_sym_typeof] = ACTIONS(2502),
    [anon_sym_import] = ACTIONS(2502),
    [anon_sym_var] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_switch] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2504),
    [anon_sym_await] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [anon_sym_do] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [anon_sym_with] = ACTIONS(2502),
    [anon_sym_break] = ACTIONS(2502),
    [anon_sym_continue] = ACTIONS(2502),
    [anon_sym_debugger] = ACTIONS(2502),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_throw] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_yield] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_SLASH] = ACTIONS(2502),
    [anon_sym_class] = ACTIONS(2502),
    [anon_sym_async] = ACTIONS(2502),
    [anon_sym_function] = ACTIONS(2502),
    [anon_sym_new] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2504),
    [anon_sym_void] = ACTIONS(2502),
    [anon_sym_delete] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(2504),
    [anon_sym_SQUOTE] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2504),
    [sym_number] = ACTIONS(2504),
    [sym_this] = ACTIONS(2502),
    [sym_super] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_null] = ACTIONS(2502),
    [sym_undefined] = ACTIONS(2502),
    [anon_sym_AT] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2502),
    [anon_sym_readonly] = ACTIONS(2502),
    [anon_sym_get] = ACTIONS(2502),
    [anon_sym_set] = ACTIONS(2502),
    [anon_sym_declare] = ACTIONS(2502),
    [anon_sym_public] = ACTIONS(2502),
    [anon_sym_private] = ACTIONS(2502),
    [anon_sym_protected] = ACTIONS(2502),
    [anon_sym_override] = ACTIONS(2502),
    [anon_sym_module] = ACTIONS(2502),
    [anon_sym_any] = ACTIONS(2502),
    [anon_sym_number] = ACTIONS(2502),
    [anon_sym_boolean] = ACTIONS(2502),
    [anon_sym_string] = ACTIONS(2502),
    [anon_sym_symbol] = ACTIONS(2502),
    [anon_sym_abstract] = ACTIONS(2502),
    [anon_sym_interface] = ACTIONS(2502),
    [anon_sym_enum] = ACTIONS(2502),
  },
  [789] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [790] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [791] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [792] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [793] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [794] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [795] = {
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_export] = ACTIONS(2506),
    [anon_sym_type] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2506),
    [anon_sym_namespace] = ACTIONS(2506),
    [anon_sym_LBRACE] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [anon_sym_typeof] = ACTIONS(2506),
    [anon_sym_import] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2508),
    [anon_sym_RPAREN] = ACTIONS(2508),
    [anon_sym_await] = ACTIONS(2506),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_RBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_class] = ACTIONS(2506),
    [anon_sym_async] = ACTIONS(2506),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_EQ_GT] = ACTIONS(2508),
    [anon_sym_QMARK_DOT] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [anon_sym_void] = ACTIONS(2506),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2508),
    [anon_sym_DQUOTE] = ACTIONS(2508),
    [anon_sym_SQUOTE] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2508),
    [sym_number] = ACTIONS(2508),
    [sym_this] = ACTIONS(2506),
    [sym_super] = ACTIONS(2506),
    [sym_true] = ACTIONS(2506),
    [sym_false] = ACTIONS(2506),
    [sym_null] = ACTIONS(2506),
    [sym_undefined] = ACTIONS(2506),
    [anon_sym_AT] = ACTIONS(2508),
    [anon_sym_static] = ACTIONS(2506),
    [anon_sym_readonly] = ACTIONS(2506),
    [anon_sym_get] = ACTIONS(2506),
    [anon_sym_set] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_declare] = ACTIONS(2506),
    [anon_sym_public] = ACTIONS(2506),
    [anon_sym_private] = ACTIONS(2506),
    [anon_sym_protected] = ACTIONS(2506),
    [anon_sym_override] = ACTIONS(2506),
    [anon_sym_module] = ACTIONS(2506),
    [anon_sym_any] = ACTIONS(2506),
    [anon_sym_number] = ACTIONS(2506),
    [anon_sym_boolean] = ACTIONS(2506),
    [anon_sym_string] = ACTIONS(2506),
    [anon_sym_symbol] = ACTIONS(2506),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_extends] = ACTIONS(2506),
  },
  [796] = {
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_export] = ACTIONS(2510),
    [anon_sym_type] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2510),
    [anon_sym_namespace] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_typeof] = ACTIONS(2510),
    [anon_sym_import] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_await] = ACTIONS(2510),
    [anon_sym_COLON] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_RBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_GT] = ACTIONS(2512),
    [anon_sym_SLASH] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_async] = ACTIONS(2510),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_EQ_GT] = ACTIONS(2512),
    [anon_sym_QMARK_DOT] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_void] = ACTIONS(2510),
    [anon_sym_delete] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [sym_number] = ACTIONS(2512),
    [sym_this] = ACTIONS(2510),
    [sym_super] = ACTIONS(2510),
    [sym_true] = ACTIONS(2510),
    [sym_false] = ACTIONS(2510),
    [sym_null] = ACTIONS(2510),
    [sym_undefined] = ACTIONS(2510),
    [anon_sym_AT] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_readonly] = ACTIONS(2510),
    [anon_sym_get] = ACTIONS(2510),
    [anon_sym_set] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_declare] = ACTIONS(2510),
    [anon_sym_public] = ACTIONS(2510),
    [anon_sym_private] = ACTIONS(2510),
    [anon_sym_protected] = ACTIONS(2510),
    [anon_sym_override] = ACTIONS(2510),
    [anon_sym_module] = ACTIONS(2510),
    [anon_sym_any] = ACTIONS(2510),
    [anon_sym_number] = ACTIONS(2510),
    [anon_sym_boolean] = ACTIONS(2510),
    [anon_sym_string] = ACTIONS(2510),
    [anon_sym_symbol] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_extends] = ACTIONS(2510),
  },
  [797] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_RPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_COLON] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_RBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_GT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_EQ_GT] = ACTIONS(2516),
    [anon_sym_QMARK_DOT] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_PIPE] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_extends] = ACTIONS(2514),
  },
  [798] = {
    [sym_nested_identifier] = STATE(591),
    [sym_string] = STATE(603),
    [sym__module] = STATE(740),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1628),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [799] = {
    [sym_nested_identifier] = STATE(113),
    [sym_string] = STATE(114),
    [sym__module] = STATE(124),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(2520),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1628),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [800] = {
    [sym_nested_identifier] = STATE(591),
    [sym_string] = STATE(603),
    [sym__module] = STATE(740),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1628),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [801] = {
    [sym_nested_identifier] = STATE(113),
    [sym_string] = STATE(114),
    [sym__module] = STATE(124),
    [aux_sym_object_repeat1] = STATE(3523),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(2520),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1628),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [802] = {
    [sym_nested_identifier] = STATE(591),
    [sym_string] = STATE(603),
    [sym__module] = STATE(740),
    [aux_sym_object_repeat1] = STATE(3499),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1628),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [803] = {
    [sym_nested_identifier] = STATE(113),
    [sym_string] = STATE(114),
    [sym__module] = STATE(124),
    [aux_sym_object_repeat1] = STATE(3499),
    [aux_sym_object_pattern_repeat1] = STATE(3497),
    [sym_identifier] = ACTIONS(2520),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1734),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1223),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1628),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [804] = {
    [sym_nested_identifier] = STATE(4008),
    [sym_string] = STATE(2528),
    [sym_formal_parameters] = STATE(3901),
    [sym_nested_type_identifier] = STATE(2442),
    [sym__type] = STATE(2591),
    [sym_constructor_type] = STATE(2591),
    [sym__primary_type] = STATE(2530),
    [sym_template_literal_type] = STATE(2536),
    [sym_infer_type] = STATE(2591),
    [sym_conditional_type] = STATE(2536),
    [sym_generic_type] = STATE(2536),
    [sym_type_predicate] = STATE(2925),
    [sym_type_query] = STATE(2536),
    [sym_index_type_query] = STATE(2536),
    [sym_lookup_type] = STATE(2536),
    [sym_literal_type] = STATE(2536),
    [sym__number] = STATE(2540),
    [sym_existential_type] = STATE(2536),
    [sym_flow_maybe_type] = STATE(2536),
    [sym_parenthesized_type] = STATE(2536),
    [sym_predefined_type] = STATE(2536),
    [sym_object_type] = STATE(2536),
    [sym_type_parameters] = STATE(3745),
    [sym_array_type] = STATE(2536),
    [sym_tuple_type] = STATE(2536),
    [sym_readonly_type] = STATE(2591),
    [sym_union_type] = STATE(2591),
    [sym_intersection_type] = STATE(2591),
    [sym_function_type] = STATE(2591),
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_typeof] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(2528),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_void] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1262),
    [sym_number] = ACTIONS(1264),
    [sym_this] = ACTIONS(2530),
    [sym_true] = ACTIONS(1268),
    [sym_false] = ACTIONS(1268),
    [sym_null] = ACTIONS(1268),
    [sym_undefined] = ACTIONS(1268),
    [anon_sym_readonly] = ACTIONS(1270),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_any] = ACTIONS(725),
    [anon_sym_number] = ACTIONS(725),
    [anon_sym_boolean] = ACTIONS(725),
    [anon_sym_string] = ACTIONS(725),
    [anon_sym_symbol] = ACTIONS(725),
    [anon_sym_asserts] = ACTIONS(2532),
    [anon_sym_infer] = ACTIONS(721),
    [anon_sym_keyof] = ACTIONS(723),
    [anon_sym_unknown] = ACTIONS(725),
    [anon_sym_never] = ACTIONS(725),
    [anon_sym_object] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
  },
  [805] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2678),
    [sym_constructor_type] = STATE(2678),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2678),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_predicate] = STATE(3668),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2678),
    [sym_union_type] = STATE(2678),
    [sym_intersection_type] = STATE(2678),
    [sym_function_type] = STATE(2678),
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(2536),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_asserts] = ACTIONS(2538),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [806] = {
    [sym_nested_identifier] = STATE(3916),
    [sym_string] = STATE(2654),
    [sym_formal_parameters] = STATE(3997),
    [sym_nested_type_identifier] = STATE(2534),
    [sym__type] = STATE(2691),
    [sym_constructor_type] = STATE(2691),
    [sym__primary_type] = STATE(2618),
    [sym_template_literal_type] = STATE(2650),
    [sym_infer_type] = STATE(2691),
    [sym_conditional_type] = STATE(2650),
    [sym_generic_type] = STATE(2650),
    [sym_type_predicate] = STATE(3022),
    [sym_type_query] = STATE(2650),
    [sym_index_type_query] = STATE(2650),
    [sym_lookup_type] = STATE(2650),
    [sym_literal_type] = STATE(2650),
    [sym__number] = STATE(2649),
    [sym_existential_type] = STATE(2650),
    [sym_flow_maybe_type] = STATE(2650),
    [sym_parenthesized_type] = STATE(2650),
    [sym_predefined_type] = STATE(2650),
    [sym_object_type] = STATE(2650),
    [sym_type_parameters] = STATE(3813),
    [sym_array_type] = STATE(2650),
    [sym_tuple_type] = STATE(2650),
    [sym_readonly_type] = STATE(2691),
    [sym_union_type] = STATE(2691),
    [sym_intersection_type] = STATE(2691),
    [sym_function_type] = STATE(2691),
    [sym_identifier] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_LBRACE] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2558),
    [anon_sym_void] = ACTIONS(2560),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2566),
    [sym_number] = ACTIONS(2568),
    [sym_this] = ACTIONS(2570),
    [sym_true] = ACTIONS(2572),
    [sym_false] = ACTIONS(2572),
    [sym_null] = ACTIONS(2572),
    [sym_undefined] = ACTIONS(2572),
    [anon_sym_readonly] = ACTIONS(2574),
    [anon_sym_QMARK] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2560),
    [anon_sym_number] = ACTIONS(2560),
    [anon_sym_boolean] = ACTIONS(2560),
    [anon_sym_string] = ACTIONS(2560),
    [anon_sym_symbol] = ACTIONS(2560),
    [anon_sym_asserts] = ACTIONS(2578),
    [anon_sym_infer] = ACTIONS(2580),
    [anon_sym_keyof] = ACTIONS(2582),
    [anon_sym_unknown] = ACTIONS(2560),
    [anon_sym_never] = ACTIONS(2560),
    [anon_sym_object] = ACTIONS(2560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2584),
  },
  [807] = {
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_export] = ACTIONS(2586),
    [anon_sym_type] = ACTIONS(2586),
    [anon_sym_EQ] = ACTIONS(2586),
    [anon_sym_namespace] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_typeof] = ACTIONS(2586),
    [anon_sym_import] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_await] = ACTIONS(2586),
    [anon_sym_COLON] = ACTIONS(2588),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_RBRACK] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_async] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(2586),
    [anon_sym_EQ_GT] = ACTIONS(2588),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_DASH] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2588),
    [anon_sym_void] = ACTIONS(2586),
    [anon_sym_delete] = ACTIONS(2586),
    [anon_sym_PLUS_PLUS] = ACTIONS(2588),
    [anon_sym_DASH_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2588),
    [anon_sym_SQUOTE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2588),
    [sym_number] = ACTIONS(2588),
    [sym_this] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_null] = ACTIONS(2586),
    [sym_undefined] = ACTIONS(2586),
    [anon_sym_AT] = ACTIONS(2588),
    [anon_sym_static] = ACTIONS(2586),
    [anon_sym_readonly] = ACTIONS(2586),
    [anon_sym_get] = ACTIONS(2586),
    [anon_sym_set] = ACTIONS(2586),
    [anon_sym_QMARK] = ACTIONS(2588),
    [anon_sym_declare] = ACTIONS(2586),
    [anon_sym_public] = ACTIONS(2586),
    [anon_sym_private] = ACTIONS(2586),
    [anon_sym_protected] = ACTIONS(2586),
    [anon_sym_override] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_any] = ACTIONS(2586),
    [anon_sym_number] = ACTIONS(2586),
    [anon_sym_boolean] = ACTIONS(2586),
    [anon_sym_string] = ACTIONS(2586),
    [anon_sym_symbol] = ACTIONS(2586),
    [anon_sym_extends] = ACTIONS(2586),
    [anon_sym_implements] = ACTIONS(2586),
  },
  [808] = {
    [sym_export_statement] = STATE(2859),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3568),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2859),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2859),
    [sym_property_signature] = STATE(2859),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2859),
    [sym_index_signature] = STATE(2859),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2590),
    [anon_sym_export] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2590),
    [anon_sym_namespace] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2616),
    [anon_sym_readonly] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2620),
    [anon_sym_set] = ACTIONS(2620),
    [anon_sym_declare] = ACTIONS(2590),
    [anon_sym_public] = ACTIONS(2622),
    [anon_sym_private] = ACTIONS(2622),
    [anon_sym_protected] = ACTIONS(2622),
    [anon_sym_override] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_any] = ACTIONS(2590),
    [anon_sym_number] = ACTIONS(2590),
    [anon_sym_boolean] = ACTIONS(2590),
    [anon_sym_string] = ACTIONS(2590),
    [anon_sym_symbol] = ACTIONS(2590),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2626),
  },
  [809] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2421),
    [sym_constructor_type] = STATE(2421),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2421),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_predicate] = STATE(2323),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2421),
    [sym_union_type] = STATE(2421),
    [sym_intersection_type] = STATE(2421),
    [sym_function_type] = STATE(2421),
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(2536),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [810] = {
    [sym_export_statement] = STATE(2859),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3568),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2859),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2859),
    [sym_property_signature] = STATE(2859),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2859),
    [sym_index_signature] = STATE(2859),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_export] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2628),
    [anon_sym_namespace] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2634),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_readonly] = ACTIONS(2638),
    [anon_sym_get] = ACTIONS(2640),
    [anon_sym_set] = ACTIONS(2640),
    [anon_sym_declare] = ACTIONS(2628),
    [anon_sym_public] = ACTIONS(2642),
    [anon_sym_private] = ACTIONS(2642),
    [anon_sym_protected] = ACTIONS(2642),
    [anon_sym_override] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_any] = ACTIONS(2628),
    [anon_sym_number] = ACTIONS(2628),
    [anon_sym_boolean] = ACTIONS(2628),
    [anon_sym_string] = ACTIONS(2628),
    [anon_sym_symbol] = ACTIONS(2628),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2626),
  },
  [811] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2880),
    [sym_constructor_type] = STATE(2880),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2880),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_type_parameter] = STATE(3397),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2880),
    [sym_union_type] = STATE(2880),
    [sym_intersection_type] = STATE(2880),
    [sym_function_type] = STATE(2880),
    [sym_identifier] = ACTIONS(2646),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [812] = {
    [sym_export_statement] = STATE(2859),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3568),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2859),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2859),
    [sym_property_signature] = STATE(2859),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2859),
    [sym_index_signature] = STATE(2859),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_export] = ACTIONS(2650),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2648),
    [anon_sym_namespace] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_readonly] = ACTIONS(2658),
    [anon_sym_get] = ACTIONS(2660),
    [anon_sym_set] = ACTIONS(2660),
    [anon_sym_declare] = ACTIONS(2648),
    [anon_sym_public] = ACTIONS(2662),
    [anon_sym_private] = ACTIONS(2662),
    [anon_sym_protected] = ACTIONS(2662),
    [anon_sym_override] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_any] = ACTIONS(2648),
    [anon_sym_number] = ACTIONS(2648),
    [anon_sym_boolean] = ACTIONS(2648),
    [anon_sym_string] = ACTIONS(2648),
    [anon_sym_symbol] = ACTIONS(2648),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2626),
  },
  [813] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2666),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [814] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2668),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [815] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(3336),
    [sym_constructor_type] = STATE(3336),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3336),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3336),
    [sym_union_type] = STATE(3336),
    [sym_intersection_type] = STATE(3336),
    [sym_function_type] = STATE(3336),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2670),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [816] = {
    [sym_nested_identifier] = STATE(3916),
    [sym_string] = STATE(2654),
    [sym_formal_parameters] = STATE(3997),
    [sym_nested_type_identifier] = STATE(2534),
    [sym__type] = STATE(2626),
    [sym_constructor_type] = STATE(2626),
    [sym__primary_type] = STATE(2618),
    [sym_template_literal_type] = STATE(2650),
    [sym_infer_type] = STATE(2626),
    [sym_conditional_type] = STATE(2650),
    [sym_generic_type] = STATE(2650),
    [sym_type_predicate] = STATE(2627),
    [sym_type_query] = STATE(2650),
    [sym_index_type_query] = STATE(2650),
    [sym_lookup_type] = STATE(2650),
    [sym_literal_type] = STATE(2650),
    [sym__number] = STATE(2649),
    [sym_existential_type] = STATE(2650),
    [sym_flow_maybe_type] = STATE(2650),
    [sym_parenthesized_type] = STATE(2650),
    [sym_predefined_type] = STATE(2650),
    [sym_object_type] = STATE(2650),
    [sym_type_parameters] = STATE(3813),
    [sym_array_type] = STATE(2650),
    [sym_tuple_type] = STATE(2650),
    [sym_readonly_type] = STATE(2626),
    [sym_union_type] = STATE(2626),
    [sym_intersection_type] = STATE(2626),
    [sym_function_type] = STATE(2626),
    [sym_identifier] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_LBRACE] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2558),
    [anon_sym_void] = ACTIONS(2560),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2566),
    [sym_number] = ACTIONS(2568),
    [sym_this] = ACTIONS(2570),
    [sym_true] = ACTIONS(2572),
    [sym_false] = ACTIONS(2572),
    [sym_null] = ACTIONS(2572),
    [sym_undefined] = ACTIONS(2572),
    [anon_sym_readonly] = ACTIONS(2574),
    [anon_sym_QMARK] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2560),
    [anon_sym_number] = ACTIONS(2560),
    [anon_sym_boolean] = ACTIONS(2560),
    [anon_sym_string] = ACTIONS(2560),
    [anon_sym_symbol] = ACTIONS(2560),
    [anon_sym_infer] = ACTIONS(2580),
    [anon_sym_keyof] = ACTIONS(2582),
    [anon_sym_unknown] = ACTIONS(2560),
    [anon_sym_never] = ACTIONS(2560),
    [anon_sym_object] = ACTIONS(2560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2584),
  },
  [817] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2672),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [818] = {
    [sym_nested_identifier] = STATE(4008),
    [sym_string] = STATE(2528),
    [sym_formal_parameters] = STATE(3901),
    [sym_nested_type_identifier] = STATE(2442),
    [sym__type] = STATE(2561),
    [sym_constructor_type] = STATE(2561),
    [sym__primary_type] = STATE(2530),
    [sym_template_literal_type] = STATE(2536),
    [sym_infer_type] = STATE(2561),
    [sym_conditional_type] = STATE(2536),
    [sym_generic_type] = STATE(2536),
    [sym_type_predicate] = STATE(2524),
    [sym_type_query] = STATE(2536),
    [sym_index_type_query] = STATE(2536),
    [sym_lookup_type] = STATE(2536),
    [sym_literal_type] = STATE(2536),
    [sym__number] = STATE(2540),
    [sym_existential_type] = STATE(2536),
    [sym_flow_maybe_type] = STATE(2536),
    [sym_parenthesized_type] = STATE(2536),
    [sym_predefined_type] = STATE(2536),
    [sym_object_type] = STATE(2536),
    [sym_type_parameters] = STATE(3745),
    [sym_array_type] = STATE(2536),
    [sym_tuple_type] = STATE(2536),
    [sym_readonly_type] = STATE(2561),
    [sym_union_type] = STATE(2561),
    [sym_intersection_type] = STATE(2561),
    [sym_function_type] = STATE(2561),
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_typeof] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(2528),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_void] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1262),
    [sym_number] = ACTIONS(1264),
    [sym_this] = ACTIONS(2530),
    [sym_true] = ACTIONS(1268),
    [sym_false] = ACTIONS(1268),
    [sym_null] = ACTIONS(1268),
    [sym_undefined] = ACTIONS(1268),
    [anon_sym_readonly] = ACTIONS(1270),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_any] = ACTIONS(725),
    [anon_sym_number] = ACTIONS(725),
    [anon_sym_boolean] = ACTIONS(725),
    [anon_sym_string] = ACTIONS(725),
    [anon_sym_symbol] = ACTIONS(725),
    [anon_sym_infer] = ACTIONS(721),
    [anon_sym_keyof] = ACTIONS(723),
    [anon_sym_unknown] = ACTIONS(725),
    [anon_sym_never] = ACTIONS(725),
    [anon_sym_object] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
  },
  [819] = {
    [sym_export_statement] = STATE(2859),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3449),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3449),
    [sym_pair] = STATE(3449),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2859),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2859),
    [sym_property_signature] = STATE(2859),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2859),
    [sym_index_signature] = STATE(2859),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3496),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2676),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2674),
    [anon_sym_namespace] = ACTIONS(2674),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2682),
    [anon_sym_readonly] = ACTIONS(2684),
    [anon_sym_get] = ACTIONS(2686),
    [anon_sym_set] = ACTIONS(2686),
    [anon_sym_declare] = ACTIONS(2674),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_override] = ACTIONS(2690),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_any] = ACTIONS(2674),
    [anon_sym_number] = ACTIONS(2674),
    [anon_sym_boolean] = ACTIONS(2674),
    [anon_sym_string] = ACTIONS(2674),
    [anon_sym_symbol] = ACTIONS(2674),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2626),
  },
  [820] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4129),
    [sym_nested_type_identifier] = STATE(2706),
    [sym__type] = STATE(2977),
    [sym_constructor_type] = STATE(2977),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2977),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_predicate] = STATE(2314),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3781),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2977),
    [sym_union_type] = STATE(2977),
    [sym_intersection_type] = STATE(2977),
    [sym_function_type] = STATE(2977),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_typeof] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(2704),
    [anon_sym_SQUOTE] = ACTIONS(2706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(2708),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(2710),
    [anon_sym_QMARK] = ACTIONS(2712),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(2714),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2716),
  },
  [821] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2718),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [822] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(3331),
    [sym_constructor_type] = STATE(3331),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3331),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3331),
    [sym_union_type] = STATE(3331),
    [sym_intersection_type] = STATE(3331),
    [sym_function_type] = STATE(3331),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2720),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [823] = {
    [sym_nested_identifier] = STATE(3916),
    [sym_string] = STATE(2654),
    [sym_formal_parameters] = STATE(3997),
    [sym_nested_type_identifier] = STATE(2534),
    [sym__type] = STATE(2615),
    [sym_constructor_type] = STATE(2615),
    [sym__primary_type] = STATE(2618),
    [sym_template_literal_type] = STATE(2650),
    [sym_infer_type] = STATE(2615),
    [sym_conditional_type] = STATE(2650),
    [sym_generic_type] = STATE(2650),
    [sym_type_predicate] = STATE(2616),
    [sym_type_query] = STATE(2650),
    [sym_index_type_query] = STATE(2650),
    [sym_lookup_type] = STATE(2650),
    [sym_literal_type] = STATE(2650),
    [sym__number] = STATE(2649),
    [sym_existential_type] = STATE(2650),
    [sym_flow_maybe_type] = STATE(2650),
    [sym_parenthesized_type] = STATE(2650),
    [sym_predefined_type] = STATE(2650),
    [sym_object_type] = STATE(2650),
    [sym_type_parameters] = STATE(3813),
    [sym_array_type] = STATE(2650),
    [sym_tuple_type] = STATE(2650),
    [sym_readonly_type] = STATE(2615),
    [sym_union_type] = STATE(2615),
    [sym_intersection_type] = STATE(2615),
    [sym_function_type] = STATE(2615),
    [sym_identifier] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_LBRACE] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2554),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2558),
    [anon_sym_void] = ACTIONS(2560),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2566),
    [sym_number] = ACTIONS(2568),
    [sym_this] = ACTIONS(2570),
    [sym_true] = ACTIONS(2572),
    [sym_false] = ACTIONS(2572),
    [sym_null] = ACTIONS(2572),
    [sym_undefined] = ACTIONS(2572),
    [anon_sym_readonly] = ACTIONS(2574),
    [anon_sym_QMARK] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2560),
    [anon_sym_number] = ACTIONS(2560),
    [anon_sym_boolean] = ACTIONS(2560),
    [anon_sym_string] = ACTIONS(2560),
    [anon_sym_symbol] = ACTIONS(2560),
    [anon_sym_infer] = ACTIONS(2580),
    [anon_sym_keyof] = ACTIONS(2582),
    [anon_sym_unknown] = ACTIONS(2560),
    [anon_sym_never] = ACTIONS(2560),
    [anon_sym_object] = ACTIONS(2560),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2584),
  },
  [824] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2722),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [825] = {
    [sym_export_statement] = STATE(2859),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3568),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2859),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2859),
    [sym_property_signature] = STATE(2859),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2859),
    [sym_index_signature] = STATE(2859),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_export] = ACTIONS(2650),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2648),
    [anon_sym_namespace] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_readonly] = ACTIONS(2658),
    [anon_sym_get] = ACTIONS(2660),
    [anon_sym_set] = ACTIONS(2660),
    [anon_sym_declare] = ACTIONS(2648),
    [anon_sym_public] = ACTIONS(2662),
    [anon_sym_private] = ACTIONS(2662),
    [anon_sym_protected] = ACTIONS(2662),
    [anon_sym_override] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_any] = ACTIONS(2648),
    [anon_sym_number] = ACTIONS(2648),
    [anon_sym_boolean] = ACTIONS(2648),
    [anon_sym_string] = ACTIONS(2648),
    [anon_sym_symbol] = ACTIONS(2648),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2626),
  },
  [826] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [827] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(3339),
    [sym_constructor_type] = STATE(3339),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3339),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3339),
    [sym_union_type] = STATE(3339),
    [sym_intersection_type] = STATE(3339),
    [sym_function_type] = STATE(3339),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2728),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [828] = {
    [sym_nested_identifier] = STATE(4128),
    [sym_string] = STATE(1617),
    [sym_formal_parameters] = STATE(4095),
    [sym_nested_type_identifier] = STATE(1424),
    [sym__type] = STATE(1547),
    [sym_constructor_type] = STATE(1547),
    [sym__primary_type] = STATE(1666),
    [sym_template_literal_type] = STATE(1665),
    [sym_infer_type] = STATE(1547),
    [sym_conditional_type] = STATE(1665),
    [sym_generic_type] = STATE(1665),
    [sym_type_predicate] = STATE(1546),
    [sym_type_query] = STATE(1665),
    [sym_index_type_query] = STATE(1665),
    [sym_lookup_type] = STATE(1665),
    [sym_literal_type] = STATE(1665),
    [sym__number] = STATE(1664),
    [sym_existential_type] = STATE(1665),
    [sym_flow_maybe_type] = STATE(1665),
    [sym_parenthesized_type] = STATE(1665),
    [sym_predefined_type] = STATE(1665),
    [sym_object_type] = STATE(1665),
    [sym_type_parameters] = STATE(3624),
    [sym_array_type] = STATE(1665),
    [sym_tuple_type] = STATE(1665),
    [sym_readonly_type] = STATE(1547),
    [sym_union_type] = STATE(1547),
    [sym_intersection_type] = STATE(1547),
    [sym_function_type] = STATE(1547),
    [sym_identifier] = ACTIONS(2730),
    [anon_sym_STAR] = ACTIONS(2732),
    [anon_sym_LBRACE] = ACTIONS(2734),
    [anon_sym_typeof] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_AMP] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(2750),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2752),
    [sym_number] = ACTIONS(2754),
    [sym_this] = ACTIONS(2756),
    [sym_true] = ACTIONS(2758),
    [sym_false] = ACTIONS(2758),
    [sym_null] = ACTIONS(2758),
    [sym_undefined] = ACTIONS(2758),
    [anon_sym_readonly] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2762),
    [anon_sym_any] = ACTIONS(2750),
    [anon_sym_number] = ACTIONS(2750),
    [anon_sym_boolean] = ACTIONS(2750),
    [anon_sym_string] = ACTIONS(2750),
    [anon_sym_symbol] = ACTIONS(2750),
    [anon_sym_infer] = ACTIONS(2764),
    [anon_sym_keyof] = ACTIONS(2766),
    [anon_sym_unknown] = ACTIONS(2750),
    [anon_sym_never] = ACTIONS(2750),
    [anon_sym_object] = ACTIONS(2750),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
  },
  [829] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [830] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2431),
    [sym_constructor_type] = STATE(2431),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2431),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_predicate] = STATE(2314),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2431),
    [sym_union_type] = STATE(2431),
    [sym_intersection_type] = STATE(2431),
    [sym_function_type] = STATE(2431),
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(2536),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [831] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(3287),
    [sym_constructor_type] = STATE(3287),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3287),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3287),
    [sym_union_type] = STATE(3287),
    [sym_intersection_type] = STATE(3287),
    [sym_function_type] = STATE(3287),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [832] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2774),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [833] = {
    [sym_export_statement] = STATE(2859),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3568),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2859),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2859),
    [sym_property_signature] = STATE(2859),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2859),
    [sym_index_signature] = STATE(2859),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_export] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2628),
    [anon_sym_namespace] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2776),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2634),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_readonly] = ACTIONS(2638),
    [anon_sym_get] = ACTIONS(2640),
    [anon_sym_set] = ACTIONS(2640),
    [anon_sym_declare] = ACTIONS(2628),
    [anon_sym_public] = ACTIONS(2642),
    [anon_sym_private] = ACTIONS(2642),
    [anon_sym_protected] = ACTIONS(2642),
    [anon_sym_override] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_any] = ACTIONS(2628),
    [anon_sym_number] = ACTIONS(2628),
    [anon_sym_boolean] = ACTIONS(2628),
    [anon_sym_string] = ACTIONS(2628),
    [anon_sym_symbol] = ACTIONS(2628),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2626),
  },
  [834] = {
    [sym_identifier] = ACTIONS(2778),
    [anon_sym_export] = ACTIONS(2778),
    [anon_sym_type] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2778),
    [anon_sym_namespace] = ACTIONS(2778),
    [anon_sym_LBRACE] = ACTIONS(2780),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_RBRACE] = ACTIONS(2780),
    [anon_sym_typeof] = ACTIONS(2778),
    [anon_sym_import] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_RPAREN] = ACTIONS(2780),
    [anon_sym_await] = ACTIONS(2778),
    [anon_sym_COLON] = ACTIONS(2780),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_LBRACK] = ACTIONS(2780),
    [anon_sym_RBRACK] = ACTIONS(2780),
    [anon_sym_LT] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2780),
    [anon_sym_SLASH] = ACTIONS(2778),
    [anon_sym_class] = ACTIONS(2778),
    [anon_sym_async] = ACTIONS(2778),
    [anon_sym_function] = ACTIONS(2778),
    [anon_sym_EQ_GT] = ACTIONS(2780),
    [anon_sym_new] = ACTIONS(2778),
    [anon_sym_AMP] = ACTIONS(2780),
    [anon_sym_PIPE] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2778),
    [anon_sym_DASH] = ACTIONS(2778),
    [anon_sym_TILDE] = ACTIONS(2780),
    [anon_sym_void] = ACTIONS(2778),
    [anon_sym_delete] = ACTIONS(2778),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_DQUOTE] = ACTIONS(2780),
    [anon_sym_SQUOTE] = ACTIONS(2780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2780),
    [sym_number] = ACTIONS(2780),
    [sym_this] = ACTIONS(2778),
    [sym_super] = ACTIONS(2778),
    [sym_true] = ACTIONS(2778),
    [sym_false] = ACTIONS(2778),
    [sym_null] = ACTIONS(2778),
    [sym_undefined] = ACTIONS(2778),
    [anon_sym_AT] = ACTIONS(2780),
    [anon_sym_static] = ACTIONS(2778),
    [anon_sym_readonly] = ACTIONS(2778),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_declare] = ACTIONS(2778),
    [anon_sym_public] = ACTIONS(2778),
    [anon_sym_private] = ACTIONS(2778),
    [anon_sym_protected] = ACTIONS(2778),
    [anon_sym_override] = ACTIONS(2778),
    [anon_sym_module] = ACTIONS(2778),
    [anon_sym_any] = ACTIONS(2778),
    [anon_sym_number] = ACTIONS(2778),
    [anon_sym_boolean] = ACTIONS(2778),
    [anon_sym_string] = ACTIONS(2778),
    [anon_sym_symbol] = ACTIONS(2778),
    [anon_sym_extends] = ACTIONS(2778),
    [anon_sym_implements] = ACTIONS(2778),
  },
  [835] = {
    [sym_nested_identifier] = STATE(1285),
    [sym_string] = STATE(1284),
    [sym__module] = STATE(1334),
    [sym_identifier] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_RBRACE] = ACTIONS(206),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(555),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [836] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [837] = {
    [sym_export_statement] = STATE(2823),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3568),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2823),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2823),
    [sym_property_signature] = STATE(2823),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2823),
    [sym_index_signature] = STATE(2823),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_export] = ACTIONS(2650),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2648),
    [anon_sym_namespace] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_readonly] = ACTIONS(2658),
    [anon_sym_get] = ACTIONS(2660),
    [anon_sym_set] = ACTIONS(2660),
    [anon_sym_declare] = ACTIONS(2648),
    [anon_sym_public] = ACTIONS(2662),
    [anon_sym_private] = ACTIONS(2662),
    [anon_sym_protected] = ACTIONS(2662),
    [anon_sym_override] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_any] = ACTIONS(2648),
    [anon_sym_number] = ACTIONS(2648),
    [anon_sym_boolean] = ACTIONS(2648),
    [anon_sym_string] = ACTIONS(2648),
    [anon_sym_symbol] = ACTIONS(2648),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2792),
  },
  [838] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [839] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4129),
    [sym_nested_type_identifier] = STATE(2706),
    [sym__type] = STATE(2920),
    [sym_constructor_type] = STATE(2920),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2920),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_predicate] = STATE(2323),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3781),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2920),
    [sym_union_type] = STATE(2920),
    [sym_intersection_type] = STATE(2920),
    [sym_function_type] = STATE(2920),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_typeof] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(2704),
    [anon_sym_SQUOTE] = ACTIONS(2706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(2708),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(2710),
    [anon_sym_QMARK] = ACTIONS(2712),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(2714),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2716),
  },
  [840] = {
    [sym_export_statement] = STATE(2859),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3568),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2859),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2859),
    [sym_property_signature] = STATE(2859),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2859),
    [sym_index_signature] = STATE(2859),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2590),
    [anon_sym_export] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2590),
    [anon_sym_namespace] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2616),
    [anon_sym_readonly] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2620),
    [anon_sym_set] = ACTIONS(2620),
    [anon_sym_declare] = ACTIONS(2590),
    [anon_sym_public] = ACTIONS(2622),
    [anon_sym_private] = ACTIONS(2622),
    [anon_sym_protected] = ACTIONS(2622),
    [anon_sym_override] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_any] = ACTIONS(2590),
    [anon_sym_number] = ACTIONS(2590),
    [anon_sym_boolean] = ACTIONS(2590),
    [anon_sym_string] = ACTIONS(2590),
    [anon_sym_symbol] = ACTIONS(2590),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2626),
  },
  [841] = {
    [sym_identifier] = ACTIONS(2798),
    [anon_sym_export] = ACTIONS(2798),
    [anon_sym_type] = ACTIONS(2798),
    [anon_sym_EQ] = ACTIONS(2798),
    [anon_sym_namespace] = ACTIONS(2798),
    [anon_sym_LBRACE] = ACTIONS(2800),
    [anon_sym_COMMA] = ACTIONS(2800),
    [anon_sym_RBRACE] = ACTIONS(2800),
    [anon_sym_typeof] = ACTIONS(2798),
    [anon_sym_import] = ACTIONS(2798),
    [anon_sym_BANG] = ACTIONS(2800),
    [anon_sym_LPAREN] = ACTIONS(2800),
    [anon_sym_RPAREN] = ACTIONS(2800),
    [anon_sym_await] = ACTIONS(2798),
    [anon_sym_COLON] = ACTIONS(2800),
    [anon_sym_yield] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_RBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2800),
    [anon_sym_GT] = ACTIONS(2800),
    [anon_sym_SLASH] = ACTIONS(2798),
    [anon_sym_class] = ACTIONS(2798),
    [anon_sym_async] = ACTIONS(2798),
    [anon_sym_function] = ACTIONS(2798),
    [anon_sym_EQ_GT] = ACTIONS(2800),
    [anon_sym_new] = ACTIONS(2798),
    [anon_sym_AMP] = ACTIONS(2800),
    [anon_sym_PIPE] = ACTIONS(2800),
    [anon_sym_PLUS] = ACTIONS(2798),
    [anon_sym_DASH] = ACTIONS(2798),
    [anon_sym_TILDE] = ACTIONS(2800),
    [anon_sym_void] = ACTIONS(2798),
    [anon_sym_delete] = ACTIONS(2798),
    [anon_sym_PLUS_PLUS] = ACTIONS(2800),
    [anon_sym_DASH_DASH] = ACTIONS(2800),
    [anon_sym_DQUOTE] = ACTIONS(2800),
    [anon_sym_SQUOTE] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2800),
    [sym_number] = ACTIONS(2800),
    [sym_this] = ACTIONS(2798),
    [sym_super] = ACTIONS(2798),
    [sym_true] = ACTIONS(2798),
    [sym_false] = ACTIONS(2798),
    [sym_null] = ACTIONS(2798),
    [sym_undefined] = ACTIONS(2798),
    [anon_sym_AT] = ACTIONS(2800),
    [anon_sym_static] = ACTIONS(2798),
    [anon_sym_readonly] = ACTIONS(2798),
    [anon_sym_get] = ACTIONS(2798),
    [anon_sym_set] = ACTIONS(2798),
    [anon_sym_QMARK] = ACTIONS(2800),
    [anon_sym_declare] = ACTIONS(2798),
    [anon_sym_public] = ACTIONS(2798),
    [anon_sym_private] = ACTIONS(2798),
    [anon_sym_protected] = ACTIONS(2798),
    [anon_sym_override] = ACTIONS(2798),
    [anon_sym_module] = ACTIONS(2798),
    [anon_sym_any] = ACTIONS(2798),
    [anon_sym_number] = ACTIONS(2798),
    [anon_sym_boolean] = ACTIONS(2798),
    [anon_sym_string] = ACTIONS(2798),
    [anon_sym_symbol] = ACTIONS(2798),
    [anon_sym_extends] = ACTIONS(2798),
    [anon_sym_implements] = ACTIONS(2798),
  },
  [842] = {
    [sym_nested_identifier] = STATE(3862),
    [sym_string] = STATE(1270),
    [sym_formal_parameters] = STATE(3915),
    [sym_nested_type_identifier] = STATE(1206),
    [sym__type] = STATE(1302),
    [sym_constructor_type] = STATE(1302),
    [sym__primary_type] = STATE(1253),
    [sym_template_literal_type] = STATE(1241),
    [sym_infer_type] = STATE(1302),
    [sym_conditional_type] = STATE(1241),
    [sym_generic_type] = STATE(1241),
    [sym_type_predicate] = STATE(1301),
    [sym_type_query] = STATE(1241),
    [sym_index_type_query] = STATE(1241),
    [sym_lookup_type] = STATE(1241),
    [sym_literal_type] = STATE(1241),
    [sym__number] = STATE(1239),
    [sym_existential_type] = STATE(1241),
    [sym_flow_maybe_type] = STATE(1241),
    [sym_parenthesized_type] = STATE(1241),
    [sym_predefined_type] = STATE(1241),
    [sym_object_type] = STATE(1241),
    [sym_type_parameters] = STATE(3843),
    [sym_array_type] = STATE(1241),
    [sym_tuple_type] = STATE(1241),
    [sym_readonly_type] = STATE(1302),
    [sym_union_type] = STATE(1302),
    [sym_intersection_type] = STATE(1302),
    [sym_function_type] = STATE(1302),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_STAR] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2806),
    [anon_sym_typeof] = ACTIONS(2808),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2816),
    [anon_sym_PIPE] = ACTIONS(2818),
    [anon_sym_PLUS] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2820),
    [anon_sym_void] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [sym_number] = ACTIONS(2826),
    [sym_this] = ACTIONS(2828),
    [sym_true] = ACTIONS(2830),
    [sym_false] = ACTIONS(2830),
    [sym_null] = ACTIONS(2830),
    [sym_undefined] = ACTIONS(2830),
    [anon_sym_readonly] = ACTIONS(2832),
    [anon_sym_QMARK] = ACTIONS(2834),
    [anon_sym_any] = ACTIONS(2822),
    [anon_sym_number] = ACTIONS(2822),
    [anon_sym_boolean] = ACTIONS(2822),
    [anon_sym_string] = ACTIONS(2822),
    [anon_sym_symbol] = ACTIONS(2822),
    [anon_sym_infer] = ACTIONS(2836),
    [anon_sym_keyof] = ACTIONS(2838),
    [anon_sym_unknown] = ACTIONS(2822),
    [anon_sym_never] = ACTIONS(2822),
    [anon_sym_object] = ACTIONS(2822),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2840),
  },
  [843] = {
    [sym_nested_identifier] = STATE(1285),
    [sym_string] = STATE(1284),
    [sym__module] = STATE(1334),
    [sym_identifier] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_RBRACE] = ACTIONS(120),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(120),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(555),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [844] = {
    [sym_nested_identifier] = STATE(3862),
    [sym_string] = STATE(1270),
    [sym_formal_parameters] = STATE(3915),
    [sym_nested_type_identifier] = STATE(1206),
    [sym__type] = STATE(1219),
    [sym_constructor_type] = STATE(1219),
    [sym__primary_type] = STATE(1253),
    [sym_template_literal_type] = STATE(1241),
    [sym_infer_type] = STATE(1219),
    [sym_conditional_type] = STATE(1241),
    [sym_generic_type] = STATE(1241),
    [sym_type_predicate] = STATE(1220),
    [sym_type_query] = STATE(1241),
    [sym_index_type_query] = STATE(1241),
    [sym_lookup_type] = STATE(1241),
    [sym_literal_type] = STATE(1241),
    [sym__number] = STATE(1239),
    [sym_existential_type] = STATE(1241),
    [sym_flow_maybe_type] = STATE(1241),
    [sym_parenthesized_type] = STATE(1241),
    [sym_predefined_type] = STATE(1241),
    [sym_object_type] = STATE(1241),
    [sym_type_parameters] = STATE(3843),
    [sym_array_type] = STATE(1241),
    [sym_tuple_type] = STATE(1241),
    [sym_readonly_type] = STATE(1219),
    [sym_union_type] = STATE(1219),
    [sym_intersection_type] = STATE(1219),
    [sym_function_type] = STATE(1219),
    [sym_identifier] = ACTIONS(2802),
    [anon_sym_STAR] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2806),
    [anon_sym_typeof] = ACTIONS(2808),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2816),
    [anon_sym_PIPE] = ACTIONS(2818),
    [anon_sym_PLUS] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2820),
    [anon_sym_void] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2824),
    [sym_number] = ACTIONS(2826),
    [sym_this] = ACTIONS(2828),
    [sym_true] = ACTIONS(2830),
    [sym_false] = ACTIONS(2830),
    [sym_null] = ACTIONS(2830),
    [sym_undefined] = ACTIONS(2830),
    [anon_sym_readonly] = ACTIONS(2832),
    [anon_sym_QMARK] = ACTIONS(2834),
    [anon_sym_any] = ACTIONS(2822),
    [anon_sym_number] = ACTIONS(2822),
    [anon_sym_boolean] = ACTIONS(2822),
    [anon_sym_string] = ACTIONS(2822),
    [anon_sym_symbol] = ACTIONS(2822),
    [anon_sym_infer] = ACTIONS(2836),
    [anon_sym_keyof] = ACTIONS(2838),
    [anon_sym_unknown] = ACTIONS(2822),
    [anon_sym_never] = ACTIONS(2822),
    [anon_sym_object] = ACTIONS(2822),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2840),
  },
  [845] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [846] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(2941),
    [sym_constructor_type] = STATE(2941),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(2941),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(2941),
    [sym_union_type] = STATE(2941),
    [sym_intersection_type] = STATE(2941),
    [sym_function_type] = STATE(2941),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2844),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [847] = {
    [sym_nested_identifier] = STATE(1285),
    [sym_string] = STATE(1284),
    [sym__module] = STATE(1334),
    [sym_identifier] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(1228),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_RPAREN] = ACTIONS(1228),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1966),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [848] = {
    [sym_export_statement] = STATE(2859),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3568),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2859),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2859),
    [sym_property_signature] = STATE(2859),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2859),
    [sym_index_signature] = STATE(2859),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_export] = ACTIONS(2650),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2648),
    [anon_sym_namespace] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_readonly] = ACTIONS(2658),
    [anon_sym_get] = ACTIONS(2660),
    [anon_sym_set] = ACTIONS(2660),
    [anon_sym_declare] = ACTIONS(2648),
    [anon_sym_public] = ACTIONS(2662),
    [anon_sym_private] = ACTIONS(2662),
    [anon_sym_protected] = ACTIONS(2662),
    [anon_sym_override] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_any] = ACTIONS(2648),
    [anon_sym_number] = ACTIONS(2648),
    [anon_sym_boolean] = ACTIONS(2648),
    [anon_sym_string] = ACTIONS(2648),
    [anon_sym_symbol] = ACTIONS(2648),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2626),
  },
  [849] = {
    [sym_nested_identifier] = STATE(3999),
    [sym_string] = STATE(2320),
    [sym_formal_parameters] = STATE(4000),
    [sym_nested_type_identifier] = STATE(2310),
    [sym__type] = STATE(3263),
    [sym_constructor_type] = STATE(3263),
    [sym__primary_type] = STATE(2324),
    [sym_template_literal_type] = STATE(2326),
    [sym_infer_type] = STATE(3263),
    [sym_conditional_type] = STATE(2326),
    [sym_generic_type] = STATE(2326),
    [sym_type_query] = STATE(2326),
    [sym_index_type_query] = STATE(2326),
    [sym_lookup_type] = STATE(2326),
    [sym_literal_type] = STATE(2326),
    [sym__number] = STATE(2327),
    [sym_existential_type] = STATE(2326),
    [sym_flow_maybe_type] = STATE(2326),
    [sym_parenthesized_type] = STATE(2326),
    [sym_predefined_type] = STATE(2326),
    [sym_object_type] = STATE(2326),
    [sym_type_parameters] = STATE(3737),
    [sym_array_type] = STATE(2326),
    [sym_tuple_type] = STATE(2326),
    [sym_readonly_type] = STATE(3263),
    [sym_union_type] = STATE(3263),
    [sym_intersection_type] = STATE(3263),
    [sym_function_type] = STATE(3263),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [anon_sym_RBRACK] = ACTIONS(2846),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_readonly] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [850] = {
    [sym_export_statement] = STATE(2859),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3449),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3449),
    [sym_pair] = STATE(3449),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2859),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2859),
    [sym_property_signature] = STATE(2859),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2859),
    [sym_index_signature] = STATE(2859),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3496),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2676),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2674),
    [anon_sym_namespace] = ACTIONS(2674),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2848),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2682),
    [anon_sym_readonly] = ACTIONS(2684),
    [anon_sym_get] = ACTIONS(2686),
    [anon_sym_set] = ACTIONS(2686),
    [anon_sym_declare] = ACTIONS(2674),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_override] = ACTIONS(2690),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_any] = ACTIONS(2674),
    [anon_sym_number] = ACTIONS(2674),
    [anon_sym_boolean] = ACTIONS(2674),
    [anon_sym_string] = ACTIONS(2674),
    [anon_sym_symbol] = ACTIONS(2674),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2626),
  },
  [851] = {
    [sym_export_statement] = STATE(2859),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3568),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2859),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2859),
    [sym_property_signature] = STATE(2859),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2859),
    [sym_index_signature] = STATE(2859),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2850),
    [anon_sym_export] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2854),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_readonly] = ACTIONS(2858),
    [anon_sym_get] = ACTIONS(2860),
    [anon_sym_set] = ACTIONS(2860),
    [anon_sym_declare] = ACTIONS(2850),
    [anon_sym_public] = ACTIONS(2862),
    [anon_sym_private] = ACTIONS(2862),
    [anon_sym_protected] = ACTIONS(2862),
    [anon_sym_override] = ACTIONS(2864),
    [anon_sym_module] = ACTIONS(2850),
    [anon_sym_any] = ACTIONS(2850),
    [anon_sym_number] = ACTIONS(2850),
    [anon_sym_boolean] = ACTIONS(2850),
    [anon_sym_string] = ACTIONS(2850),
    [anon_sym_symbol] = ACTIONS(2850),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2626),
  },
  [852] = {
    [sym_export_statement] = STATE(2859),
    [sym_object_pattern] = STATE(4009),
    [sym_object_assignment_pattern] = STATE(3440),
    [sym_array_pattern] = STATE(4009),
    [sym__call_signature] = STATE(3101),
    [sym__destructuring_pattern] = STATE(4009),
    [sym_spread_element] = STATE(3568),
    [sym_string] = STATE(2462),
    [sym_decorator] = STATE(1140),
    [sym_formal_parameters] = STATE(2593),
    [sym_rest_pattern] = STATE(3440),
    [sym_method_definition] = STATE(3568),
    [sym_pair] = STATE(3568),
    [sym_pair_pattern] = STATE(3440),
    [sym__property_name] = STATE(2462),
    [sym_computed_property_name] = STATE(2462),
    [sym_method_signature] = STATE(2859),
    [sym_accessibility_modifier] = STATE(2200),
    [sym_override_modifier] = STATE(2223),
    [sym_call_signature] = STATE(2859),
    [sym_property_signature] = STATE(2859),
    [sym_type_parameters] = STATE(3652),
    [sym_construct_signature] = STATE(2859),
    [sym_index_signature] = STATE(2859),
    [aux_sym_export_statement_repeat1] = STATE(3308),
    [aux_sym_object_repeat1] = STATE(3566),
    [aux_sym_object_pattern_repeat1] = STATE(3512),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_export] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2628),
    [anon_sym_namespace] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2866),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2634),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2614),
    [sym_private_property_identifier] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_readonly] = ACTIONS(2638),
    [anon_sym_get] = ACTIONS(2640),
    [anon_sym_set] = ACTIONS(2640),
    [anon_sym_declare] = ACTIONS(2628),
    [anon_sym_public] = ACTIONS(2642),
    [anon_sym_private] = ACTIONS(2642),
    [anon_sym_protected] = ACTIONS(2642),
    [anon_sym_override] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_any] = ACTIONS(2628),
    [anon_sym_number] = ACTIONS(2628),
    [anon_sym_boolean] = ACTIONS(2628),
    [anon_sym_string] = ACTIONS(2628),
    [anon_sym_symbol] = ACTIONS(2628),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2626),
  },
  [853] = {
    [sym_nested_identifier] = STATE(4008),
    [sym_string] = STATE(2528),
    [sym_formal_parameters] = STATE(3901),
    [sym_nested_type_identifier] = STATE(2442),
    [sym__type] = STATE(2567),
    [sym_constructor_type] = STATE(2567),
    [sym__primary_type] = STATE(2530),
    [sym_template_literal_type] = STATE(2536),
    [sym_infer_type] = STATE(2567),
    [sym_conditional_type] = STATE(2536),
    [sym_generic_type] = STATE(2536),
    [sym_type_predicate] = STATE(2569),
    [sym_type_query] = STATE(2536),
    [sym_index_type_query] = STATE(2536),
    [sym_lookup_type] = STATE(2536),
    [sym_literal_type] = STATE(2536),
    [sym__number] = STATE(2540),
    [sym_existential_type] = STATE(2536),
    [sym_flow_maybe_type] = STATE(2536),
    [sym_parenthesized_type] = STATE(2536),
    [sym_predefined_type] = STATE(2536),
    [sym_object_type] = STATE(2536),
    [sym_type_parameters] = STATE(3745),
    [sym_array_type] = STATE(2536),
    [sym_tuple_type] = STATE(2536),
    [sym_readonly_type] = STATE(2567),
    [sym_union_type] = STATE(2567),
    [sym_intersection_type] = STATE(2567),
    [sym_function_type] = STATE(2567),
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_typeof] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_PIPE] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(2528),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_void] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1262),
    [sym_number] = ACTIONS(1264),
    [sym_this] = ACTIONS(2530),
    [sym_true] = ACTIONS(1268),
    [sym_false] = ACTIONS(1268),
    [sym_null] = ACTIONS(1268),
    [sym_undefined] = ACTIONS(1268),
    [anon_sym_readonly] = ACTIONS(1270),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_any] = ACTIONS(725),
    [anon_sym_number] = ACTIONS(725),
    [anon_sym_boolean] = ACTIONS(725),
    [anon_sym_string] = ACTIONS(725),
    [anon_sym_symbol] = ACTIONS(725),
    [anon_sym_infer] = ACTIONS(721),
    [anon_sym_keyof] = ACTIONS(723),
    [anon_sym_unknown] = ACTIONS(725),
    [anon_sym_never] = ACTIONS(725),
    [anon_sym_object] = ACTIONS(725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(727),
  },
  [854] = {
    [sym_nested_identifier] = STATE(4128),
    [sym_string] = STATE(1617),
    [sym_formal_parameters] = STATE(4095),
    [sym_nested_type_identifier] = STATE(1424),
    [sym__type] = STATE(1594),
    [sym_constructor_type] = STATE(1594),
    [sym__primary_type] = STATE(1666),
    [sym_template_literal_type] = STATE(1665),
    [sym_infer_type] = STATE(1594),
    [sym_conditional_type] = STATE(1665),
    [sym_generic_type] = STATE(1665),
    [sym_type_predicate] = STATE(1595),
    [sym_type_query] = STATE(1665),
    [sym_index_type_query] = STATE(1665),
    [sym_lookup_type] = STATE(1665),
    [sym_literal_type] = STATE(1665),
    [sym__number] = STATE(1664),
    [sym_existential_type] = STATE(1665),
    [sym_flow_maybe_type] = STATE(1665),
    [sym_parenthesized_type] = STATE(1665),
    [sym_predefined_type] = STATE(1665),
    [sym_object_type] = STATE(1665),
    [sym_type_parameters] = STATE(3624),
    [sym_array_type] = STATE(1665),
    [sym_tuple_type] = STATE(1665),
    [sym_readonly_type] = STATE(1594),
    [sym_union_type] = STATE(1594),
    [sym_intersection_type] = STATE(1594),
    [sym_function_type] = STATE(1594),
    [sym_identifier] = ACTIONS(2730),
    [anon_sym_STAR] = ACTIONS(2732),
    [anon_sym_LBRACE] = ACTIONS(2734),
    [anon_sym_typeof] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_AMP] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(2750),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2752),
    [sym_number] = ACTIONS(2754),
    [sym_this] = ACTIONS(2756),
    [sym_true] = ACTIONS(2758),
    [sym_false] = ACTIONS(2758),
    [sym_null] = ACTIONS(2758),
    [sym_undefined] = ACTIONS(2758),
    [anon_sym_readonly] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2762),
    [anon_sym_any] = ACTIONS(2750),
    [anon_sym_number] = ACTIONS(2750),
    [anon_sym_boolean] = ACTIONS(2750),
    [anon_sym_string] = ACTIONS(2750),
    [anon_sym_symbol] = ACTIONS(2750),
    [anon_sym_infer] = ACTIONS(2764),
    [anon_sym_keyof] = ACTIONS(2766),
    [anon_sym_unknown] = ACTIONS(2750),
    [anon_sym_never] = ACTIONS(2750),
    [anon_sym_object] = ACTIONS(2750),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2327), 1,
      sym__number,
    STATE(2334), 1,
      sym__primary_type,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3432), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [131] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2873), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [262] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_new,
    ACTIONS(2700), 1,
      anon_sym_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2710), 1,
      anon_sym_readonly,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3781), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4129), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2911), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [393] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3323), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [524] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3318), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [655] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_STAR,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_typeof,
    ACTIONS(2548), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_LBRACK,
    ACTIONS(2562), 1,
      anon_sym_DQUOTE,
    ACTIONS(2564), 1,
      anon_sym_SQUOTE,
    ACTIONS(2566), 1,
      anon_sym_BQUOTE,
    ACTIONS(2568), 1,
      sym_number,
    ACTIONS(2576), 1,
      anon_sym_QMARK,
    ACTIONS(2582), 1,
      anon_sym_keyof,
    ACTIONS(2584), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2870), 1,
      sym_identifier,
    ACTIONS(2872), 1,
      sym_this,
    STATE(2534), 1,
      sym_nested_type_identifier,
    STATE(2633), 1,
      sym__primary_type,
    STATE(2649), 1,
      sym__number,
    STATE(2654), 1,
      sym_string,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3916), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2572), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3540), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2560), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2650), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [786] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3299), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [917] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_STAR,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_typeof,
    ACTIONS(2548), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_LBRACK,
    ACTIONS(2562), 1,
      anon_sym_DQUOTE,
    ACTIONS(2564), 1,
      anon_sym_SQUOTE,
    ACTIONS(2566), 1,
      anon_sym_BQUOTE,
    ACTIONS(2568), 1,
      sym_number,
    ACTIONS(2576), 1,
      anon_sym_QMARK,
    ACTIONS(2582), 1,
      anon_sym_keyof,
    ACTIONS(2584), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2870), 1,
      sym_identifier,
    ACTIONS(2872), 1,
      sym_this,
    STATE(2534), 1,
      sym_nested_type_identifier,
    STATE(2635), 1,
      sym__primary_type,
    STATE(2649), 1,
      sym__number,
    STATE(2654), 1,
      sym_string,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3916), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2572), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3540), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2560), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2650), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [1048] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2957), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [1179] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_STAR,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_typeof,
    ACTIONS(2548), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_LBRACK,
    ACTIONS(2552), 1,
      anon_sym_new,
    ACTIONS(2554), 1,
      anon_sym_AMP,
    ACTIONS(2556), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_DQUOTE,
    ACTIONS(2564), 1,
      anon_sym_SQUOTE,
    ACTIONS(2566), 1,
      anon_sym_BQUOTE,
    ACTIONS(2568), 1,
      sym_number,
    ACTIONS(2574), 1,
      anon_sym_readonly,
    ACTIONS(2576), 1,
      anon_sym_QMARK,
    ACTIONS(2580), 1,
      anon_sym_infer,
    ACTIONS(2582), 1,
      anon_sym_keyof,
    ACTIONS(2584), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2870), 1,
      sym_identifier,
    ACTIONS(2872), 1,
      sym_this,
    STATE(2534), 1,
      sym_nested_type_identifier,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2649), 1,
      sym__number,
    STATE(2654), 1,
      sym_string,
    STATE(3813), 1,
      sym_type_parameters,
    STATE(3916), 1,
      sym_nested_identifier,
    STATE(3997), 1,
      sym_formal_parameters,
    ACTIONS(2558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2572), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2636), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2560), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2650), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [1310] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_STAR,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_typeof,
    ACTIONS(2548), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_LBRACK,
    ACTIONS(2552), 1,
      anon_sym_new,
    ACTIONS(2554), 1,
      anon_sym_AMP,
    ACTIONS(2556), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_DQUOTE,
    ACTIONS(2564), 1,
      anon_sym_SQUOTE,
    ACTIONS(2566), 1,
      anon_sym_BQUOTE,
    ACTIONS(2568), 1,
      sym_number,
    ACTIONS(2574), 1,
      anon_sym_readonly,
    ACTIONS(2576), 1,
      anon_sym_QMARK,
    ACTIONS(2580), 1,
      anon_sym_infer,
    ACTIONS(2582), 1,
      anon_sym_keyof,
    ACTIONS(2584), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2870), 1,
      sym_identifier,
    ACTIONS(2872), 1,
      sym_this,
    STATE(2534), 1,
      sym_nested_type_identifier,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2649), 1,
      sym__number,
    STATE(2654), 1,
      sym_string,
    STATE(3813), 1,
      sym_type_parameters,
    STATE(3916), 1,
      sym_nested_identifier,
    STATE(3997), 1,
      sym_formal_parameters,
    ACTIONS(2558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2572), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2640), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2560), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2650), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [1441] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_STAR,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_typeof,
    ACTIONS(2548), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_LBRACK,
    ACTIONS(2552), 1,
      anon_sym_new,
    ACTIONS(2554), 1,
      anon_sym_AMP,
    ACTIONS(2556), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_DQUOTE,
    ACTIONS(2564), 1,
      anon_sym_SQUOTE,
    ACTIONS(2566), 1,
      anon_sym_BQUOTE,
    ACTIONS(2568), 1,
      sym_number,
    ACTIONS(2574), 1,
      anon_sym_readonly,
    ACTIONS(2576), 1,
      anon_sym_QMARK,
    ACTIONS(2580), 1,
      anon_sym_infer,
    ACTIONS(2582), 1,
      anon_sym_keyof,
    ACTIONS(2584), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2870), 1,
      sym_identifier,
    ACTIONS(2872), 1,
      sym_this,
    STATE(2534), 1,
      sym_nested_type_identifier,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2649), 1,
      sym__number,
    STATE(2654), 1,
      sym_string,
    STATE(3813), 1,
      sym_type_parameters,
    STATE(3916), 1,
      sym_nested_identifier,
    STATE(3997), 1,
      sym_formal_parameters,
    ACTIONS(2558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2572), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2644), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2560), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2650), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [1572] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3121), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [1703] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2742), 1,
      anon_sym_new,
    ACTIONS(2744), 1,
      anon_sym_AMP,
    ACTIONS(2746), 1,
      anon_sym_PIPE,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2760), 1,
      anon_sym_readonly,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2764), 1,
      anon_sym_infer,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(1666), 1,
      sym__primary_type,
    STATE(3624), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1582), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [1834] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2742), 1,
      anon_sym_new,
    ACTIONS(2744), 1,
      anon_sym_AMP,
    ACTIONS(2746), 1,
      anon_sym_PIPE,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2760), 1,
      anon_sym_readonly,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2764), 1,
      anon_sym_infer,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(1666), 1,
      sym__primary_type,
    STATE(3624), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1616), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [1965] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2742), 1,
      anon_sym_new,
    ACTIONS(2744), 1,
      anon_sym_AMP,
    ACTIONS(2746), 1,
      anon_sym_PIPE,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2760), 1,
      anon_sym_readonly,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2764), 1,
      anon_sym_infer,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(1666), 1,
      sym__primary_type,
    STATE(3624), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1613), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [2096] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2742), 1,
      anon_sym_new,
    ACTIONS(2744), 1,
      anon_sym_AMP,
    ACTIONS(2746), 1,
      anon_sym_PIPE,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2760), 1,
      anon_sym_readonly,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2764), 1,
      anon_sym_infer,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(1666), 1,
      sym__primary_type,
    STATE(3624), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1609), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [2227] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1608), 1,
      sym__primary_type,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(4000), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3513), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [2358] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1606), 1,
      sym__primary_type,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(4000), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3513), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [2489] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3330), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [2620] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_new,
    ACTIONS(2700), 1,
      anon_sym_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2710), 1,
      anon_sym_readonly,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3781), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4129), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3179), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [2751] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3328), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [2882] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2814), 1,
      anon_sym_new,
    ACTIONS(2816), 1,
      anon_sym_AMP,
    ACTIONS(2818), 1,
      anon_sym_PIPE,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2832), 1,
      anon_sym_readonly,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2836), 1,
      anon_sym_infer,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1253), 1,
      sym__primary_type,
    STATE(1270), 1,
      sym_string,
    STATE(3843), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(3915), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1218), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [3013] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2876), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [3144] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3270), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [3275] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_new,
    ACTIONS(2700), 1,
      anon_sym_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2710), 1,
      anon_sym_readonly,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3781), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4129), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2349), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [3406] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2349), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [3537] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_new,
    ACTIONS(2700), 1,
      anon_sym_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2710), 1,
      anon_sym_readonly,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3781), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4129), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2892), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [3668] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3341), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [3799] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3017), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [3930] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3047), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4061] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_STAR,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_typeof,
    ACTIONS(2548), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_LBRACK,
    ACTIONS(2552), 1,
      anon_sym_new,
    ACTIONS(2554), 1,
      anon_sym_AMP,
    ACTIONS(2556), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_DQUOTE,
    ACTIONS(2564), 1,
      anon_sym_SQUOTE,
    ACTIONS(2566), 1,
      anon_sym_BQUOTE,
    ACTIONS(2568), 1,
      sym_number,
    ACTIONS(2574), 1,
      anon_sym_readonly,
    ACTIONS(2576), 1,
      anon_sym_QMARK,
    ACTIONS(2580), 1,
      anon_sym_infer,
    ACTIONS(2582), 1,
      anon_sym_keyof,
    ACTIONS(2584), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2870), 1,
      sym_identifier,
    ACTIONS(2872), 1,
      sym_this,
    STATE(2534), 1,
      sym_nested_type_identifier,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2649), 1,
      sym__number,
    STATE(2654), 1,
      sym_string,
    STATE(3813), 1,
      sym_type_parameters,
    STATE(3916), 1,
      sym_nested_identifier,
    STATE(3997), 1,
      sym_formal_parameters,
    ACTIONS(2558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2572), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2656), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2560), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2650), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4192] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2327), 1,
      sym__number,
    STATE(3228), 1,
      sym__primary_type,
    STATE(3265), 1,
      sym_infer_type,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3432), 6,
      sym__type,
      sym_constructor_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4325] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2814), 1,
      anon_sym_new,
    ACTIONS(2816), 1,
      anon_sym_AMP,
    ACTIONS(2818), 1,
      anon_sym_PIPE,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2832), 1,
      anon_sym_readonly,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2836), 1,
      anon_sym_infer,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1253), 1,
      sym__primary_type,
    STATE(1270), 1,
      sym_string,
    STATE(3843), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(3915), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1306), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4456] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_STAR,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_typeof,
    ACTIONS(2548), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_LBRACK,
    ACTIONS(2552), 1,
      anon_sym_new,
    ACTIONS(2554), 1,
      anon_sym_AMP,
    ACTIONS(2556), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_DQUOTE,
    ACTIONS(2564), 1,
      anon_sym_SQUOTE,
    ACTIONS(2566), 1,
      anon_sym_BQUOTE,
    ACTIONS(2568), 1,
      sym_number,
    ACTIONS(2574), 1,
      anon_sym_readonly,
    ACTIONS(2576), 1,
      anon_sym_QMARK,
    ACTIONS(2580), 1,
      anon_sym_infer,
    ACTIONS(2582), 1,
      anon_sym_keyof,
    ACTIONS(2584), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2870), 1,
      sym_identifier,
    ACTIONS(2872), 1,
      sym_this,
    STATE(2534), 1,
      sym_nested_type_identifier,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2649), 1,
      sym__number,
    STATE(2654), 1,
      sym_string,
    STATE(3813), 1,
      sym_type_parameters,
    STATE(3916), 1,
      sym_nested_identifier,
    STATE(3997), 1,
      sym_formal_parameters,
    ACTIONS(2558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2572), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2603), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2560), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2650), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4587] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_STAR,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_typeof,
    ACTIONS(2548), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_LBRACK,
    ACTIONS(2552), 1,
      anon_sym_new,
    ACTIONS(2554), 1,
      anon_sym_AMP,
    ACTIONS(2556), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_DQUOTE,
    ACTIONS(2564), 1,
      anon_sym_SQUOTE,
    ACTIONS(2566), 1,
      anon_sym_BQUOTE,
    ACTIONS(2568), 1,
      sym_number,
    ACTIONS(2574), 1,
      anon_sym_readonly,
    ACTIONS(2576), 1,
      anon_sym_QMARK,
    ACTIONS(2580), 1,
      anon_sym_infer,
    ACTIONS(2582), 1,
      anon_sym_keyof,
    ACTIONS(2584), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2870), 1,
      sym_identifier,
    ACTIONS(2872), 1,
      sym_this,
    STATE(2534), 1,
      sym_nested_type_identifier,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2649), 1,
      sym__number,
    STATE(2654), 1,
      sym_string,
    STATE(3813), 1,
      sym_type_parameters,
    STATE(3916), 1,
      sym_nested_identifier,
    STATE(3997), 1,
      sym_formal_parameters,
    ACTIONS(2558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2572), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2681), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2560), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2650), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4718] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2742), 1,
      anon_sym_new,
    ACTIONS(2744), 1,
      anon_sym_AMP,
    ACTIONS(2746), 1,
      anon_sym_PIPE,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2760), 1,
      anon_sym_readonly,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2764), 1,
      anon_sym_infer,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(1666), 1,
      sym__primary_type,
    STATE(3624), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1656), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4849] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1270), 1,
      sym_string,
    STATE(1281), 1,
      sym__primary_type,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3525), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4980] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3233), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5111] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_STAR,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_typeof,
    ACTIONS(2548), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_LBRACK,
    ACTIONS(2552), 1,
      anon_sym_new,
    ACTIONS(2554), 1,
      anon_sym_AMP,
    ACTIONS(2556), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_DQUOTE,
    ACTIONS(2564), 1,
      anon_sym_SQUOTE,
    ACTIONS(2566), 1,
      anon_sym_BQUOTE,
    ACTIONS(2568), 1,
      sym_number,
    ACTIONS(2574), 1,
      anon_sym_readonly,
    ACTIONS(2576), 1,
      anon_sym_QMARK,
    ACTIONS(2580), 1,
      anon_sym_infer,
    ACTIONS(2582), 1,
      anon_sym_keyof,
    ACTIONS(2584), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2870), 1,
      sym_identifier,
    ACTIONS(2872), 1,
      sym_this,
    STATE(2534), 1,
      sym_nested_type_identifier,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2649), 1,
      sym__number,
    STATE(2654), 1,
      sym_string,
    STATE(3813), 1,
      sym_type_parameters,
    STATE(3916), 1,
      sym_nested_identifier,
    STATE(3997), 1,
      sym_formal_parameters,
    ACTIONS(2558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2572), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2622), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2560), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2650), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5242] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2936), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5373] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1270), 1,
      sym_string,
    STATE(1271), 1,
      sym__primary_type,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3525), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5504] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2814), 1,
      anon_sym_new,
    ACTIONS(2816), 1,
      anon_sym_AMP,
    ACTIONS(2818), 1,
      anon_sym_PIPE,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2832), 1,
      anon_sym_readonly,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2836), 1,
      anon_sym_infer,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1253), 1,
      sym__primary_type,
    STATE(1270), 1,
      sym_string,
    STATE(3843), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(3915), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1264), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5635] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3329), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5766] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_STAR,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_typeof,
    ACTIONS(2548), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_LBRACK,
    ACTIONS(2552), 1,
      anon_sym_new,
    ACTIONS(2554), 1,
      anon_sym_AMP,
    ACTIONS(2556), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_DQUOTE,
    ACTIONS(2564), 1,
      anon_sym_SQUOTE,
    ACTIONS(2566), 1,
      anon_sym_BQUOTE,
    ACTIONS(2568), 1,
      sym_number,
    ACTIONS(2574), 1,
      anon_sym_readonly,
    ACTIONS(2576), 1,
      anon_sym_QMARK,
    ACTIONS(2580), 1,
      anon_sym_infer,
    ACTIONS(2582), 1,
      anon_sym_keyof,
    ACTIONS(2584), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2870), 1,
      sym_identifier,
    ACTIONS(2872), 1,
      sym_this,
    STATE(2534), 1,
      sym_nested_type_identifier,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2649), 1,
      sym__number,
    STATE(2654), 1,
      sym_string,
    STATE(3813), 1,
      sym_type_parameters,
    STATE(3916), 1,
      sym_nested_identifier,
    STATE(3997), 1,
      sym_formal_parameters,
    ACTIONS(2558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2572), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2642), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2560), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2650), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5897] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2542), 1,
      anon_sym_STAR,
    ACTIONS(2544), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_typeof,
    ACTIONS(2548), 1,
      anon_sym_LPAREN,
    ACTIONS(2550), 1,
      anon_sym_LBRACK,
    ACTIONS(2552), 1,
      anon_sym_new,
    ACTIONS(2554), 1,
      anon_sym_AMP,
    ACTIONS(2556), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_DQUOTE,
    ACTIONS(2564), 1,
      anon_sym_SQUOTE,
    ACTIONS(2566), 1,
      anon_sym_BQUOTE,
    ACTIONS(2568), 1,
      sym_number,
    ACTIONS(2574), 1,
      anon_sym_readonly,
    ACTIONS(2576), 1,
      anon_sym_QMARK,
    ACTIONS(2580), 1,
      anon_sym_infer,
    ACTIONS(2582), 1,
      anon_sym_keyof,
    ACTIONS(2584), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2870), 1,
      sym_identifier,
    ACTIONS(2872), 1,
      sym_this,
    STATE(2534), 1,
      sym_nested_type_identifier,
    STATE(2618), 1,
      sym__primary_type,
    STATE(2649), 1,
      sym__number,
    STATE(2654), 1,
      sym_string,
    STATE(3813), 1,
      sym_type_parameters,
    STATE(3916), 1,
      sym_nested_identifier,
    STATE(3997), 1,
      sym_formal_parameters,
    ACTIONS(2558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2572), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2655), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2560), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2650), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6028] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2558), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6159] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2904), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6290] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2814), 1,
      anon_sym_new,
    ACTIONS(2816), 1,
      anon_sym_AMP,
    ACTIONS(2818), 1,
      anon_sym_PIPE,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2832), 1,
      anon_sym_readonly,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2836), 1,
      anon_sym_infer,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1253), 1,
      sym__primary_type,
    STATE(1270), 1,
      sym_string,
    STATE(3843), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(3915), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1248), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6421] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3012), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6552] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2814), 1,
      anon_sym_new,
    ACTIONS(2816), 1,
      anon_sym_AMP,
    ACTIONS(2818), 1,
      anon_sym_PIPE,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2832), 1,
      anon_sym_readonly,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2836), 1,
      anon_sym_infer,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1253), 1,
      sym__primary_type,
    STATE(1270), 1,
      sym_string,
    STATE(3843), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(3915), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1247), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6683] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1157), 1,
      anon_sym_EQ,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6772] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3292), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6903] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3309), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7034] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2545), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7165] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3311), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7296] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2574), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7427] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3001), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7558] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2678), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7689] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3351), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7820] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3068), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7951] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2742), 1,
      anon_sym_new,
    ACTIONS(2744), 1,
      anon_sym_AMP,
    ACTIONS(2746), 1,
      anon_sym_PIPE,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2760), 1,
      anon_sym_readonly,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2764), 1,
      anon_sym_infer,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(1666), 1,
      sym__primary_type,
    STATE(3624), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1643), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8082] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2814), 1,
      anon_sym_new,
    ACTIONS(2816), 1,
      anon_sym_AMP,
    ACTIONS(2818), 1,
      anon_sym_PIPE,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2832), 1,
      anon_sym_readonly,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2836), 1,
      anon_sym_infer,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1253), 1,
      sym__primary_type,
    STATE(1270), 1,
      sym_string,
    STATE(3843), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(3915), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1221), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8213] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2814), 1,
      anon_sym_new,
    ACTIONS(2816), 1,
      anon_sym_AMP,
    ACTIONS(2818), 1,
      anon_sym_PIPE,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2832), 1,
      anon_sym_readonly,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2836), 1,
      anon_sym_infer,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1253), 1,
      sym__primary_type,
    STATE(1270), 1,
      sym_string,
    STATE(3843), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(3915), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1225), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8344] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3262), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8475] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2742), 1,
      anon_sym_new,
    ACTIONS(2744), 1,
      anon_sym_AMP,
    ACTIONS(2746), 1,
      anon_sym_PIPE,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2760), 1,
      anon_sym_readonly,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2764), 1,
      anon_sym_infer,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(1666), 1,
      sym__primary_type,
    STATE(1669), 1,
      sym_template_literal_type,
    STATE(3624), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1673), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8608] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2434), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8739] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2814), 1,
      anon_sym_new,
    ACTIONS(2816), 1,
      anon_sym_AMP,
    ACTIONS(2818), 1,
      anon_sym_PIPE,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2832), 1,
      anon_sym_readonly,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2836), 1,
      anon_sym_infer,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1253), 1,
      sym__primary_type,
    STATE(1270), 1,
      sym_string,
    STATE(3843), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(3915), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1260), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8870] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2315), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9001] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2814), 1,
      anon_sym_new,
    ACTIONS(2816), 1,
      anon_sym_AMP,
    ACTIONS(2818), 1,
      anon_sym_PIPE,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2832), 1,
      anon_sym_readonly,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2836), 1,
      anon_sym_infer,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1253), 1,
      sym__primary_type,
    STATE(1270), 1,
      sym_string,
    STATE(3843), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(3915), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1267), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9132] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2538), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9263] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2742), 1,
      anon_sym_new,
    ACTIONS(2744), 1,
      anon_sym_AMP,
    ACTIONS(2746), 1,
      anon_sym_PIPE,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2760), 1,
      anon_sym_readonly,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2764), 1,
      anon_sym_infer,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(1666), 1,
      sym__primary_type,
    STATE(3624), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1544), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9394] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_new,
    ACTIONS(2700), 1,
      anon_sym_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2710), 1,
      anon_sym_readonly,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3781), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4129), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2330), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9525] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2742), 1,
      anon_sym_new,
    ACTIONS(2744), 1,
      anon_sym_AMP,
    ACTIONS(2746), 1,
      anon_sym_PIPE,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2760), 1,
      anon_sym_readonly,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2764), 1,
      anon_sym_infer,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(1666), 1,
      sym__primary_type,
    STATE(3624), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1543), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9656] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2833), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9787] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2409), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9918] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2708), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10049] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2732), 1,
      anon_sym_STAR,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(2736), 1,
      anon_sym_typeof,
    ACTIONS(2738), 1,
      anon_sym_LPAREN,
    ACTIONS(2740), 1,
      anon_sym_LBRACK,
    ACTIONS(2742), 1,
      anon_sym_new,
    ACTIONS(2744), 1,
      anon_sym_AMP,
    ACTIONS(2746), 1,
      anon_sym_PIPE,
    ACTIONS(2752), 1,
      anon_sym_BQUOTE,
    ACTIONS(2754), 1,
      sym_number,
    ACTIONS(2760), 1,
      anon_sym_readonly,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
    ACTIONS(2764), 1,
      anon_sym_infer,
    ACTIONS(2766), 1,
      anon_sym_keyof,
    ACTIONS(2768), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2876), 1,
      sym_this,
    STATE(1424), 1,
      sym_nested_type_identifier,
    STATE(1617), 1,
      sym_string,
    STATE(1664), 1,
      sym__number,
    STATE(1666), 1,
      sym__primary_type,
    STATE(3624), 1,
      sym_type_parameters,
    STATE(4095), 1,
      sym_formal_parameters,
    STATE(4128), 1,
      sym_nested_identifier,
    ACTIONS(2748), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2758), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1628), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2750), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1665), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10180] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [10269] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2709), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10400] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2535), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10531] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2572), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10662] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3344), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10793] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2570), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10924] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2540), 1,
      sym__number,
    STATE(2556), 1,
      sym__primary_type,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(4000), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3521), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11055] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2327), 1,
      sym__number,
    STATE(2344), 1,
      sym__primary_type,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3432), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11186] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2405), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11317] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2591), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11448] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2395), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11579] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3362), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11710] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2330), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11841] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2941), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11972] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2348), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12103] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2554), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12234] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_new,
    ACTIONS(2700), 1,
      anon_sym_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2710), 1,
      anon_sym_readonly,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3781), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4129), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2348), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12365] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2880), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12496] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_new,
    ACTIONS(2700), 1,
      anon_sym_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2710), 1,
      anon_sym_readonly,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3781), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4129), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2871), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12627] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2540), 1,
      sym__number,
    STATE(2541), 1,
      sym__primary_type,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(4000), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3521), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12758] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_new,
    ACTIONS(2700), 1,
      anon_sym_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2710), 1,
      anon_sym_readonly,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3781), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4129), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2878), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12889] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2327), 1,
      sym__number,
    STATE(2334), 1,
      sym__primary_type,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3547), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13020] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2327), 1,
      sym__number,
    STATE(2344), 1,
      sym__primary_type,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3547), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13151] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3257), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13282] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_STAR,
    ACTIONS(2806), 1,
      anon_sym_LBRACE,
    ACTIONS(2808), 1,
      anon_sym_typeof,
    ACTIONS(2810), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_LBRACK,
    ACTIONS(2814), 1,
      anon_sym_new,
    ACTIONS(2816), 1,
      anon_sym_AMP,
    ACTIONS(2818), 1,
      anon_sym_PIPE,
    ACTIONS(2824), 1,
      anon_sym_BQUOTE,
    ACTIONS(2826), 1,
      sym_number,
    ACTIONS(2832), 1,
      anon_sym_readonly,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    ACTIONS(2836), 1,
      anon_sym_infer,
    ACTIONS(2838), 1,
      anon_sym_keyof,
    ACTIONS(2840), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_identifier,
    ACTIONS(2880), 1,
      sym_this,
    STATE(1206), 1,
      sym_nested_type_identifier,
    STATE(1239), 1,
      sym__number,
    STATE(1253), 1,
      sym__primary_type,
    STATE(1270), 1,
      sym_string,
    STATE(1280), 1,
      sym_template_literal_type,
    STATE(3843), 1,
      sym_type_parameters,
    STATE(3862), 1,
      sym_nested_identifier,
    STATE(3915), 1,
      sym_formal_parameters,
    ACTIONS(2820), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2830), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1283), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(2822), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1241), 13,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13415] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2397), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13546] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2827), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13677] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_AMP,
    ACTIONS(699), 1,
      anon_sym_PIPE,
    ACTIONS(717), 1,
      anon_sym_QMARK,
    ACTIONS(721), 1,
      anon_sym_infer,
    ACTIONS(723), 1,
      anon_sym_keyof,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1238), 1,
      sym_identifier,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(1244), 1,
      anon_sym_typeof,
    ACTIONS(1246), 1,
      anon_sym_LPAREN,
    ACTIONS(1248), 1,
      anon_sym_LBRACK,
    ACTIONS(1250), 1,
      anon_sym_new,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1262), 1,
      anon_sym_BQUOTE,
    ACTIONS(1264), 1,
      sym_number,
    ACTIONS(1266), 1,
      sym_this,
    ACTIONS(1270), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2442), 1,
      sym_nested_type_identifier,
    STATE(2528), 1,
      sym_string,
    STATE(2530), 1,
      sym__primary_type,
    STATE(2540), 1,
      sym__number,
    STATE(3745), 1,
      sym_type_parameters,
    STATE(3901), 1,
      sym_formal_parameters,
    STATE(4008), 1,
      sym_nested_identifier,
    ACTIONS(2528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1268), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2546), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(725), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2536), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13808] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_new,
    ACTIONS(2700), 1,
      anon_sym_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2710), 1,
      anon_sym_readonly,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3781), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4129), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2315), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13939] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    ACTIONS(2696), 1,
      anon_sym_typeof,
    ACTIONS(2698), 1,
      anon_sym_new,
    ACTIONS(2700), 1,
      anon_sym_AMP,
    ACTIONS(2702), 1,
      anon_sym_PIPE,
    ACTIONS(2704), 1,
      anon_sym_DQUOTE,
    ACTIONS(2706), 1,
      anon_sym_SQUOTE,
    ACTIONS(2710), 1,
      anon_sym_readonly,
    ACTIONS(2712), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2868), 1,
      sym_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(2706), 1,
      sym_nested_type_identifier,
    STATE(3781), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4129), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2978), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14070] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3256), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14201] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3259), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14332] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      sym_identifier,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(1161), 1,
      anon_sym_typeof,
    ACTIONS(1163), 1,
      anon_sym_LPAREN,
    ACTIONS(1165), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_new,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1177), 1,
      anon_sym_BQUOTE,
    ACTIONS(1179), 1,
      sym_number,
    ACTIONS(1181), 1,
      sym_this,
    ACTIONS(1185), 1,
      anon_sym_readonly,
    ACTIONS(2440), 1,
      anon_sym_LT,
    STATE(2310), 1,
      sym_nested_type_identifier,
    STATE(2320), 1,
      sym_string,
    STATE(2324), 1,
      sym__primary_type,
    STATE(2327), 1,
      sym__number,
    STATE(3737), 1,
      sym_type_parameters,
    STATE(3999), 1,
      sym_nested_identifier,
    STATE(4000), 1,
      sym_formal_parameters,
    ACTIONS(2444), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1183), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3261), 7,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2326), 14,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14463] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14551] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(2882), 1,
      sym_identifier,
    STATE(1204), 1,
      sym_string,
    STATE(1207), 1,
      sym_nested_identifier,
    STATE(1322), 1,
      sym__module,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14639] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(2882), 1,
      sym_identifier,
    STATE(1204), 1,
      sym_string,
    STATE(1207), 1,
      sym_nested_identifier,
    STATE(1322), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14727] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1157), 1,
      anon_sym_EQ,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(1225), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14819] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1784), 1,
      anon_sym_COLON,
    ACTIONS(2518), 1,
      sym_identifier,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(603), 1,
      sym_string,
    STATE(740), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14909] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1784), 1,
      anon_sym_COLON,
    ACTIONS(2520), 1,
      sym_identifier,
    ACTIONS(2522), 1,
      anon_sym_DQUOTE,
    ACTIONS(2524), 1,
      anon_sym_SQUOTE,
    STATE(113), 1,
      sym_nested_identifier,
    STATE(114), 1,
      sym_string,
    STATE(124), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14999] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1836), 1,
      anon_sym_COLON,
    ACTIONS(2882), 1,
      sym_identifier,
    STATE(1204), 1,
      sym_string,
    STATE(1207), 1,
      sym_nested_identifier,
    STATE(1322), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15089] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1836), 1,
      anon_sym_COLON,
    ACTIONS(2518), 1,
      sym_identifier,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(603), 1,
      sym_string,
    STATE(740), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15179] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1980), 1,
      anon_sym_in,
    ACTIONS(1983), 1,
      anon_sym_of,
    ACTIONS(2882), 1,
      sym_identifier,
    STATE(1204), 1,
      sym_string,
    STATE(1207), 1,
      sym_nested_identifier,
    STATE(1322), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15271] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15359] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1613), 1,
      anon_sym_LPAREN,
    ACTIONS(1616), 1,
      anon_sym_COLON,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1628), 1,
      anon_sym_QMARK,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(1734), 1,
      anon_sym_EQ,
    ACTIONS(2884), 1,
      sym_identifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15450] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    ACTIONS(1613), 1,
      anon_sym_LPAREN,
    ACTIONS(1616), 1,
      anon_sym_COLON,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1628), 1,
      anon_sym_QMARK,
    ACTIONS(1734), 1,
      anon_sym_EQ,
    ACTIONS(2884), 1,
      sym_identifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15541] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_COMMA,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(206), 1,
      anon_sym_RBRACK,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1998), 1,
      anon_sym_COLON,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15634] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1230), 1,
      anon_sym_EQ,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [15721] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1613), 1,
      anon_sym_LPAREN,
    ACTIONS(1616), 1,
      anon_sym_COLON,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1628), 1,
      anon_sym_QMARK,
    ACTIONS(1660), 1,
      anon_sym_RBRACE,
    ACTIONS(1734), 1,
      anon_sym_EQ,
    ACTIONS(2884), 1,
      sym_identifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15812] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [15899] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15985] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2594), 1,
      anon_sym_STAR,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2606), 1,
      anon_sym_LBRACK,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(2888), 1,
      anon_sym_export,
    ACTIONS(2893), 1,
      anon_sym_async,
    ACTIONS(2895), 1,
      anon_sym_static,
    ACTIONS(2897), 1,
      anon_sym_readonly,
    ACTIONS(2903), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2200), 1,
      sym_accessibility_modifier,
    STATE(2223), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(2614), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2890), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2899), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2901), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2462), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3679), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3742), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(2864), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2886), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16115] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2594), 1,
      anon_sym_STAR,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2606), 1,
      anon_sym_LBRACK,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(2888), 1,
      anon_sym_export,
    ACTIONS(2893), 1,
      anon_sym_async,
    ACTIONS(2895), 1,
      anon_sym_static,
    ACTIONS(2897), 1,
      anon_sym_readonly,
    ACTIONS(2903), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2200), 1,
      sym_accessibility_modifier,
    STATE(2223), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(2614), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2890), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2899), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2901), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2462), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3679), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3742), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(2927), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2886), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16245] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1234), 1,
      anon_sym_EQ,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2905), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2907), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [16399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2911), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [16467] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16553] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(2913), 1,
      sym_identifier,
    STATE(2704), 1,
      sym_nested_identifier,
    STATE(2786), 1,
      sym_string,
    STATE(2982), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2917), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [16707] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1234), 1,
      anon_sym_EQ,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(2016), 1,
      anon_sym_COLON,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16795] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    ACTIONS(1613), 1,
      anon_sym_LPAREN,
    ACTIONS(1616), 1,
      anon_sym_COLON,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1628), 1,
      anon_sym_QMARK,
    ACTIONS(1734), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16883] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(2882), 1,
      sym_identifier,
    STATE(1204), 1,
      sym_string,
    STATE(1207), 1,
      sym_nested_identifier,
    STATE(1322), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16969] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_COMMA,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(206), 1,
      anon_sym_RBRACK,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17059] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1616), 1,
      anon_sym_COLON,
    ACTIONS(1628), 1,
      anon_sym_QMARK,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(2921), 1,
      anon_sym_EQ,
    ACTIONS(2925), 1,
      anon_sym_LPAREN,
    ACTIONS(2928), 1,
      anon_sym_LT,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17147] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(2518), 1,
      sym_identifier,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(603), 1,
      sym_string,
    STATE(740), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17233] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(2520), 1,
      sym_identifier,
    ACTIONS(2522), 1,
      anon_sym_DQUOTE,
    ACTIONS(2524), 1,
      anon_sym_SQUOTE,
    STATE(113), 1,
      sym_nested_identifier,
    STATE(114), 1,
      sym_string,
    STATE(124), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17319] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1613), 1,
      anon_sym_LPAREN,
    ACTIONS(1616), 1,
      anon_sym_COLON,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1628), 1,
      anon_sym_QMARK,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(1734), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17407] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    ACTIONS(1616), 1,
      anon_sym_COLON,
    ACTIONS(1628), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_EQ,
    ACTIONS(2925), 1,
      anon_sym_LPAREN,
    ACTIONS(2928), 1,
      anon_sym_LT,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17495] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1234), 1,
      anon_sym_EQ,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(1998), 1,
      anon_sym_COLON,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2937), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [17651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2941), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [17719] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1616), 1,
      anon_sym_COLON,
    ACTIONS(1628), 1,
      anon_sym_QMARK,
    ACTIONS(1660), 1,
      anon_sym_RBRACE,
    ACTIONS(2921), 1,
      anon_sym_EQ,
    ACTIONS(2925), 1,
      anon_sym_LPAREN,
    ACTIONS(2928), 1,
      anon_sym_LT,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17807] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1613), 1,
      anon_sym_LPAREN,
    ACTIONS(1616), 1,
      anon_sym_COLON,
    ACTIONS(1619), 1,
      anon_sym_LT,
    ACTIONS(1628), 1,
      anon_sym_QMARK,
    ACTIONS(1660), 1,
      anon_sym_RBRACE,
    ACTIONS(1734), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17895] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1280), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17980] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    ACTIONS(2952), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2966), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_extends,
    STATE(2341), 1,
      sym_type_arguments,
    STATE(3838), 1,
      sym_type_annotation,
    ACTIONS(2946), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2963), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18073] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(1280), 1,
      anon_sym_EQ_GT,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18158] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2969), 1,
      anon_sym_extends,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2952), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2963), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18243] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2973), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2979), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18330] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(2952), 1,
      anon_sym_LBRACK,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2985), 1,
      anon_sym_LT,
    ACTIONS(2988), 1,
      anon_sym_DOT,
    STATE(2573), 1,
      sym_type_arguments,
    ACTIONS(2946), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2963), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2969), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2923), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2502), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2504), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [18484] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(1980), 1,
      anon_sym_in,
    ACTIONS(1983), 1,
      anon_sym_of,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [18644] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(2993), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_LBRACK,
    ACTIONS(2997), 1,
      anon_sym_DOT,
    ACTIONS(2999), 1,
      anon_sym_QMARK_DOT,
    STATE(2452), 1,
      sym_arguments,
    ACTIONS(2979), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2973), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2923), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18731] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2498), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2500), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [18885] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(2969), 1,
      anon_sym_extends,
    ACTIONS(3001), 1,
      anon_sym_EQ,
    ACTIONS(3003), 1,
      anon_sym_EQ_GT,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2952), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2963), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18969] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(3012), 1,
      anon_sym_QMARK,
    ACTIONS(3008), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19045] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(1966), 1,
      anon_sym_QMARK,
    ACTIONS(1228), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19121] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(3016), 1,
      anon_sym_QMARK,
    ACTIONS(3014), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19197] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(2946), 1,
      anon_sym_RPAREN,
    ACTIONS(2952), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2969), 1,
      anon_sym_extends,
    ACTIONS(3012), 1,
      anon_sym_QMARK,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2963), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3018), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2923), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19287] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 1,
      anon_sym_EQ,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(206), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19363] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3001), 1,
      anon_sym_EQ,
    ACTIONS(3003), 1,
      anon_sym_EQ_GT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2973), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2979), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19449] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2979), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2973), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(2923), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19535] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2973), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2979), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19621] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(3012), 1,
      anon_sym_QMARK,
    ACTIONS(3018), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19697] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(2969), 1,
      anon_sym_extends,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(3012), 1,
      anon_sym_QMARK,
    ACTIONS(3023), 1,
      anon_sym_RPAREN,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2963), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3008), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2923), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19787] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 1,
      anon_sym_EQ,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(3026), 1,
      anon_sym_LBRACK,
    ACTIONS(3029), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1508), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19865] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(2782), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_string,
    STATE(1285), 1,
      sym_nested_identifier,
    STATE(1334), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [19949] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_EQ,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(120), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20025] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(2969), 1,
      anon_sym_extends,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2952), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2963), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20109] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1157), 1,
      anon_sym_EQ,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(3026), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3029), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20187] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20258] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1157), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20329] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(3026), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3029), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20406] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3034), 1,
      anon_sym_EQ_GT,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2969), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2963), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20489] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2973), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2979), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(2923), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20574] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(3036), 1,
      anon_sym_EQ,
    ACTIONS(3038), 1,
      anon_sym_EQ_GT,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2969), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2963), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20657] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20728] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3036), 1,
      anon_sym_EQ,
    ACTIONS(3038), 1,
      anon_sym_EQ_GT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2973), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2979), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20813] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1784), 1,
      anon_sym_COLON,
    ACTIONS(2884), 1,
      sym_identifier,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [20888] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_EQ,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(3026), 1,
      anon_sym_LBRACK,
    ACTIONS(120), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1508), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3029), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20969] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(3012), 1,
      anon_sym_QMARK,
    ACTIONS(3018), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21042] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(3014), 1,
      anon_sym_COLON,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2963), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2969), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2923), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3016), 1,
      anon_sym_QMARK,
    ACTIONS(3014), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21200] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21271] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2969), 1,
      anon_sym_extends,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(3014), 1,
      anon_sym_COLON,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2963), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3040), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2923), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21358] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3034), 1,
      anon_sym_EQ_GT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2973), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2979), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21443] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1836), 1,
      anon_sym_COLON,
    ACTIONS(2884), 1,
      sym_identifier,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [21518] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(3026), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3029), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21595] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3044), 1,
      anon_sym_EQ,
    ACTIONS(3046), 1,
      anon_sym_EQ_GT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2973), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2979), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21680] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3012), 1,
      anon_sym_QMARK,
    ACTIONS(3008), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21753] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(2969), 1,
      anon_sym_extends,
    ACTIONS(3044), 1,
      anon_sym_EQ,
    ACTIONS(3046), 1,
      anon_sym_EQ_GT,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2952), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2963), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21836] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 1,
      anon_sym_EQ,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(555), 1,
      anon_sym_QMARK,
    ACTIONS(3026), 1,
      anon_sym_LBRACK,
    ACTIONS(206), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1508), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3029), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21917] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21985] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22055] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_EQ,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(3026), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3029), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22131] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2498), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2500), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22263] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(3026), 1,
      anon_sym_LBRACK,
    ACTIONS(1508), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3029), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22339] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22409] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(3048), 1,
      anon_sym_EQ,
    ACTIONS(3050), 1,
      anon_sym_EQ_GT,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2969), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2963), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2905), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2907), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22555] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1980), 1,
      anon_sym_in,
    ACTIONS(3052), 1,
      anon_sym_of,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2911), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22693] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2969), 1,
      anon_sym_extends,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2952), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(2963), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22775] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2941), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22909] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1836), 1,
      anon_sym_COLON,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22981] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 1,
      anon_sym_EQ,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1510), 1,
      anon_sym_QMARK,
    ACTIONS(3026), 1,
      anon_sym_LBRACK,
    ACTIONS(3029), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1508), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23059] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(3054), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23131] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2979), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2973), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2923), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23215] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1157), 1,
      anon_sym_EQ,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(1225), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23289] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_EQ,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1784), 1,
      anon_sym_COLON,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23361] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(3026), 1,
      anon_sym_LBRACK,
    ACTIONS(3029), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1508), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23439] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1784), 1,
      anon_sym_COLON,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23511] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 1,
      anon_sym_EQ,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(3026), 1,
      anon_sym_LBRACK,
    ACTIONS(1508), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3029), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23587] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1836), 1,
      anon_sym_COLON,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23659] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3001), 1,
      anon_sym_EQ,
    ACTIONS(3003), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23729] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1157), 1,
      anon_sym_EQ,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(3026), 1,
      anon_sym_LBRACK,
    ACTIONS(3029), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3056), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23809] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    ACTIONS(3060), 1,
      anon_sym_in,
    ACTIONS(3063), 1,
      anon_sym_of,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23883] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3048), 1,
      anon_sym_EQ,
    ACTIONS(3050), 1,
      anon_sym_EQ_GT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2973), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2979), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23967] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 1,
      anon_sym_EQ,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24037] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3003), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2502), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2504), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24241] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ_GT,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    ACTIONS(3065), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2937), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24377] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2917), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24511] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(1280), 1,
      anon_sym_EQ_GT,
    ACTIONS(3026), 1,
      anon_sym_LBRACK,
    ACTIONS(1508), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3029), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24586] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      anon_sym_LT,
    ACTIONS(2958), 1,
      anon_sym_DOT,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2969), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2963), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24667] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24736] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24803] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(3014), 1,
      anon_sym_COLON,
    ACTIONS(3067), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24874] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_EQ_GT,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(3067), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24945] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(3070), 1,
      sym_identifier,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [25016] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_COMMA,
    ACTIONS(206), 1,
      anon_sym_RBRACK,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1998), 1,
      anon_sym_COLON,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3001), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25158] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(3076), 1,
      anon_sym_DOT,
    STATE(1133), 1,
      sym_arguments,
    ACTIONS(3074), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3072), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [25227] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    ACTIONS(3060), 1,
      anon_sym_in,
    ACTIONS(3063), 1,
      anon_sym_of,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25298] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_EQ,
    ACTIONS(1232), 1,
      anon_sym_EQ_GT,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25367] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2973), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2979), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25450] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2973), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(2979), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2923), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25533] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3046), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25602] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_COMMA,
    ACTIONS(3018), 1,
      anon_sym_RBRACK,
    ACTIONS(3034), 1,
      anon_sym_EQ_GT,
    ACTIONS(3078), 1,
      anon_sym_EQ,
    ACTIONS(3081), 1,
      anon_sym_in,
    ACTIONS(3083), 1,
      anon_sym_COLON,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25679] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_AT,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
    ACTIONS(3087), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3085), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [25748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_EQ,
    ACTIONS(3046), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25817] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1157), 1,
      anon_sym_EQ,
    ACTIONS(1508), 1,
      anon_sym_extends,
    ACTIONS(3026), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3029), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25892] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(2884), 1,
      sym_identifier,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [25963] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_AT,
    ACTIONS(3092), 1,
      anon_sym_class,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
    ACTIONS(3087), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3085), 37,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26033] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(3026), 1,
      anon_sym_LBRACK,
    ACTIONS(1508), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3029), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3095), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [26237] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 1,
      anon_sym_EQ,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26305] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3034), 1,
      anon_sym_EQ_GT,
    ACTIONS(3081), 1,
      anon_sym_in,
    ACTIONS(3099), 1,
      anon_sym_COLON,
    ACTIONS(2923), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26377] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3038), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26445] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 1,
      anon_sym_EQ,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(2016), 1,
      anon_sym_COLON,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26515] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 1,
      anon_sym_EQ,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(1998), 1,
      anon_sym_COLON,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26585] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_COMMA,
    ACTIONS(3018), 1,
      anon_sym_RBRACK,
    ACTIONS(3034), 1,
      anon_sym_EQ_GT,
    ACTIONS(3078), 1,
      anon_sym_EQ,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26657] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3034), 1,
      anon_sym_EQ_GT,
    ACTIONS(3081), 1,
      anon_sym_in,
    ACTIONS(3083), 1,
      anon_sym_COLON,
    ACTIONS(2923), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26729] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_COMMA,
    ACTIONS(206), 1,
      anon_sym_RBRACK,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26867] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_EQ,
    ACTIONS(3038), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26935] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3034), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27003] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3034), 1,
      anon_sym_EQ_GT,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27071] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 1,
      anon_sym_EQ,
    ACTIONS(1236), 1,
      anon_sym_EQ_GT,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27139] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27207] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(3060), 1,
      anon_sym_in,
    ACTIONS(3063), 1,
      anon_sym_of,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27278] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_COMMA,
    ACTIONS(3018), 1,
      anon_sym_RBRACK,
    ACTIONS(3078), 1,
      anon_sym_EQ,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27347] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1278), 1,
      anon_sym_EQ,
    ACTIONS(1280), 1,
      anon_sym_EQ_GT,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1280), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3103), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3101), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [27542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3072), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [27603] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(1980), 1,
      anon_sym_in,
    ACTIONS(3052), 1,
      anon_sym_of,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27674] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3050), 1,
      anon_sym_EQ_GT,
    ACTIONS(2923), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27806] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 1,
      anon_sym_EQ,
    ACTIONS(3050), 1,
      anon_sym_EQ_GT,
    ACTIONS(2923), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27873] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1228), 1,
      anon_sym_COLON,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3107), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3105), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [28003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2923), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28068] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1282), 1,
      anon_sym_EQ,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28134] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 1,
      anon_sym_EQ,
    ACTIONS(2923), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28198] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3060), 1,
      anon_sym_in,
    ACTIONS(3063), 1,
      anon_sym_of,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28266] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3010), 1,
      anon_sym_EQ_GT,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28332] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3014), 1,
      anon_sym_COLON,
    ACTIONS(2923), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2933), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2919), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28398] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3115), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2886), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28511] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(2604), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2626), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2859), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28624] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(2790), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2792), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2823), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28737] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3135), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3137), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2872), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28850] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3139), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3141), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2882), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28963] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3143), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3145), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2952), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29076] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(1902), 1,
      anon_sym_namespace,
    ACTIONS(1904), 1,
      anon_sym_import,
    ACTIONS(1906), 1,
      anon_sym_var,
    ACTIONS(1908), 1,
      anon_sym_let,
    ACTIONS(1910), 1,
      anon_sym_const,
    ACTIONS(1912), 1,
      anon_sym_class,
    ACTIONS(1914), 1,
      anon_sym_async,
    ACTIONS(1916), 1,
      anon_sym_function,
    ACTIONS(1918), 1,
      anon_sym_declare,
    ACTIONS(1922), 1,
      anon_sym_abstract,
    ACTIONS(1926), 1,
      anon_sym_interface,
    ACTIONS(1928), 1,
      anon_sym_enum,
    ACTIONS(3147), 1,
      anon_sym_STAR,
    ACTIONS(3149), 1,
      anon_sym_default,
    ACTIONS(3151), 1,
      anon_sym_type,
    ACTIONS(3153), 1,
      anon_sym_EQ,
    ACTIONS(3155), 1,
      anon_sym_as,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3160), 1,
      anon_sym_RBRACE,
    ACTIONS(3165), 1,
      anon_sym_module,
    STATE(1140), 1,
      sym_decorator,
    STATE(3056), 1,
      aux_sym_export_statement_repeat1,
    STATE(3084), 1,
      sym_internal_module,
    STATE(3104), 1,
      sym_declaration,
    STATE(3277), 1,
      sym_export_clause,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    STATE(3640), 1,
      sym_namespace_import_export,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3102), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29194] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(1902), 1,
      anon_sym_namespace,
    ACTIONS(1904), 1,
      anon_sym_import,
    ACTIONS(1906), 1,
      anon_sym_var,
    ACTIONS(1908), 1,
      anon_sym_let,
    ACTIONS(1910), 1,
      anon_sym_const,
    ACTIONS(1912), 1,
      anon_sym_class,
    ACTIONS(1914), 1,
      anon_sym_async,
    ACTIONS(1916), 1,
      anon_sym_function,
    ACTIONS(1918), 1,
      anon_sym_declare,
    ACTIONS(1922), 1,
      anon_sym_abstract,
    ACTIONS(1926), 1,
      anon_sym_interface,
    ACTIONS(1928), 1,
      anon_sym_enum,
    ACTIONS(3147), 1,
      anon_sym_STAR,
    ACTIONS(3149), 1,
      anon_sym_default,
    ACTIONS(3151), 1,
      anon_sym_type,
    ACTIONS(3153), 1,
      anon_sym_EQ,
    ACTIONS(3155), 1,
      anon_sym_as,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3165), 1,
      anon_sym_module,
    ACTIONS(3167), 1,
      anon_sym_RBRACE,
    STATE(1140), 1,
      sym_decorator,
    STATE(3056), 1,
      aux_sym_export_statement_repeat1,
    STATE(3084), 1,
      sym_internal_module,
    STATE(3104), 1,
      sym_declaration,
    STATE(3277), 1,
      sym_export_clause,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    STATE(3640), 1,
      sym_namespace_import_export,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3102), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29312] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(1902), 1,
      anon_sym_namespace,
    ACTIONS(1904), 1,
      anon_sym_import,
    ACTIONS(1906), 1,
      anon_sym_var,
    ACTIONS(1908), 1,
      anon_sym_let,
    ACTIONS(1910), 1,
      anon_sym_const,
    ACTIONS(1912), 1,
      anon_sym_class,
    ACTIONS(1914), 1,
      anon_sym_async,
    ACTIONS(1916), 1,
      anon_sym_function,
    ACTIONS(1918), 1,
      anon_sym_declare,
    ACTIONS(1922), 1,
      anon_sym_abstract,
    ACTIONS(1926), 1,
      anon_sym_interface,
    ACTIONS(1928), 1,
      anon_sym_enum,
    ACTIONS(3147), 1,
      anon_sym_STAR,
    ACTIONS(3149), 1,
      anon_sym_default,
    ACTIONS(3151), 1,
      anon_sym_type,
    ACTIONS(3153), 1,
      anon_sym_EQ,
    ACTIONS(3155), 1,
      anon_sym_as,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3165), 1,
      anon_sym_module,
    ACTIONS(3170), 1,
      anon_sym_RBRACE,
    STATE(1140), 1,
      sym_decorator,
    STATE(3056), 1,
      aux_sym_export_statement_repeat1,
    STATE(3084), 1,
      sym_internal_module,
    STATE(3104), 1,
      sym_declaration,
    STATE(3277), 1,
      sym_export_clause,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    STATE(3640), 1,
      sym_namespace_import_export,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3102), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29430] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(1902), 1,
      anon_sym_namespace,
    ACTIONS(1904), 1,
      anon_sym_import,
    ACTIONS(1906), 1,
      anon_sym_var,
    ACTIONS(1908), 1,
      anon_sym_let,
    ACTIONS(1910), 1,
      anon_sym_const,
    ACTIONS(1912), 1,
      anon_sym_class,
    ACTIONS(1914), 1,
      anon_sym_async,
    ACTIONS(1916), 1,
      anon_sym_function,
    ACTIONS(1918), 1,
      anon_sym_declare,
    ACTIONS(1922), 1,
      anon_sym_abstract,
    ACTIONS(1926), 1,
      anon_sym_interface,
    ACTIONS(1928), 1,
      anon_sym_enum,
    ACTIONS(3147), 1,
      anon_sym_STAR,
    ACTIONS(3149), 1,
      anon_sym_default,
    ACTIONS(3151), 1,
      anon_sym_type,
    ACTIONS(3153), 1,
      anon_sym_EQ,
    ACTIONS(3155), 1,
      anon_sym_as,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3165), 1,
      anon_sym_module,
    ACTIONS(3173), 1,
      anon_sym_RBRACE,
    STATE(1140), 1,
      sym_decorator,
    STATE(3056), 1,
      aux_sym_export_statement_repeat1,
    STATE(3084), 1,
      sym_internal_module,
    STATE(3104), 1,
      sym_declaration,
    STATE(3277), 1,
      sym_export_clause,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    STATE(3640), 1,
      sym_namespace_import_export,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3102), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29548] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(1902), 1,
      anon_sym_namespace,
    ACTIONS(1904), 1,
      anon_sym_import,
    ACTIONS(1906), 1,
      anon_sym_var,
    ACTIONS(1908), 1,
      anon_sym_let,
    ACTIONS(1910), 1,
      anon_sym_const,
    ACTIONS(1912), 1,
      anon_sym_class,
    ACTIONS(1914), 1,
      anon_sym_async,
    ACTIONS(1916), 1,
      anon_sym_function,
    ACTIONS(1918), 1,
      anon_sym_declare,
    ACTIONS(1922), 1,
      anon_sym_abstract,
    ACTIONS(1926), 1,
      anon_sym_interface,
    ACTIONS(1928), 1,
      anon_sym_enum,
    ACTIONS(3147), 1,
      anon_sym_STAR,
    ACTIONS(3149), 1,
      anon_sym_default,
    ACTIONS(3151), 1,
      anon_sym_type,
    ACTIONS(3153), 1,
      anon_sym_EQ,
    ACTIONS(3155), 1,
      anon_sym_as,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3165), 1,
      anon_sym_module,
    ACTIONS(3176), 1,
      anon_sym_RBRACE,
    STATE(1140), 1,
      sym_decorator,
    STATE(3056), 1,
      aux_sym_export_statement_repeat1,
    STATE(3084), 1,
      sym_internal_module,
    STATE(3104), 1,
      sym_declaration,
    STATE(3277), 1,
      sym_export_clause,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    STATE(3640), 1,
      sym_namespace_import_export,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3102), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29666] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3179), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29775] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3181), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29884] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3183), 1,
      sym_identifier,
    ACTIONS(3185), 1,
      anon_sym_STAR,
    ACTIONS(3191), 1,
      anon_sym_LBRACE,
    STATE(3842), 1,
      sym_import_clause,
    STATE(3844), 1,
      sym_string,
    STATE(3847), 1,
      sym_import_require_clause,
    ACTIONS(3187), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(3861), 2,
      sym_namespace_import_export,
      sym_named_imports,
    ACTIONS(3189), 14,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3193), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [29961] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3195), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30070] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3197), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30179] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3199), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30288] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3201), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30397] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3203), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30506] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3205), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30615] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3207), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30724] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3209), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30833] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3211), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30942] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3213), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31051] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3215), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31160] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3217), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31269] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3219), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31378] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3221), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31487] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3223), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31596] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3225), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31705] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(1902), 1,
      anon_sym_namespace,
    ACTIONS(1904), 1,
      anon_sym_import,
    ACTIONS(1906), 1,
      anon_sym_var,
    ACTIONS(1908), 1,
      anon_sym_let,
    ACTIONS(1910), 1,
      anon_sym_const,
    ACTIONS(1912), 1,
      anon_sym_class,
    ACTIONS(1914), 1,
      anon_sym_async,
    ACTIONS(1916), 1,
      anon_sym_function,
    ACTIONS(1918), 1,
      anon_sym_declare,
    ACTIONS(1922), 1,
      anon_sym_abstract,
    ACTIONS(1926), 1,
      anon_sym_interface,
    ACTIONS(1928), 1,
      anon_sym_enum,
    ACTIONS(3147), 1,
      anon_sym_STAR,
    ACTIONS(3149), 1,
      anon_sym_default,
    ACTIONS(3151), 1,
      anon_sym_type,
    ACTIONS(3155), 1,
      anon_sym_as,
    ACTIONS(3165), 1,
      anon_sym_module,
    ACTIONS(3227), 1,
      anon_sym_EQ,
    STATE(1140), 1,
      sym_decorator,
    STATE(3056), 1,
      aux_sym_export_statement_repeat1,
    STATE(3084), 1,
      sym_internal_module,
    STATE(3104), 1,
      sym_declaration,
    STATE(3277), 1,
      sym_export_clause,
    STATE(3640), 1,
      sym_namespace_import_export,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3102), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [31813] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(1902), 1,
      anon_sym_namespace,
    ACTIONS(1904), 1,
      anon_sym_import,
    ACTIONS(1906), 1,
      anon_sym_var,
    ACTIONS(1908), 1,
      anon_sym_let,
    ACTIONS(1910), 1,
      anon_sym_const,
    ACTIONS(1912), 1,
      anon_sym_class,
    ACTIONS(1914), 1,
      anon_sym_async,
    ACTIONS(1916), 1,
      anon_sym_function,
    ACTIONS(1918), 1,
      anon_sym_declare,
    ACTIONS(1922), 1,
      anon_sym_abstract,
    ACTIONS(1926), 1,
      anon_sym_interface,
    ACTIONS(1928), 1,
      anon_sym_enum,
    ACTIONS(3147), 1,
      anon_sym_STAR,
    ACTIONS(3149), 1,
      anon_sym_default,
    ACTIONS(3151), 1,
      anon_sym_type,
    ACTIONS(3153), 1,
      anon_sym_EQ,
    ACTIONS(3155), 1,
      anon_sym_as,
    ACTIONS(3165), 1,
      anon_sym_module,
    STATE(1140), 1,
      sym_decorator,
    STATE(3056), 1,
      aux_sym_export_statement_repeat1,
    STATE(3084), 1,
      sym_internal_module,
    STATE(3104), 1,
      sym_declaration,
    STATE(3277), 1,
      sym_export_clause,
    STATE(3640), 1,
      sym_namespace_import_export,
    ACTIONS(3229), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3102), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [31923] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2927), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32028] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2817), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32133] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2864), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1306), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1304), 33,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [32293] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2934), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32398] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2921), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1364), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1362), 33,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [32558] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2953), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32663] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(2610), 1,
      anon_sym_new,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3111), 1,
      anon_sym_export,
    ACTIONS(3113), 1,
      anon_sym_STAR,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3121), 1,
      anon_sym_async,
    ACTIONS(3125), 1,
      anon_sym_static,
    ACTIONS(3127), 1,
      anon_sym_readonly,
    ACTIONS(3133), 1,
      anon_sym_override,
    STATE(1140), 1,
      sym_decorator,
    STATE(2212), 1,
      sym_accessibility_modifier,
    STATE(2226), 1,
      sym_override_modifier,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3101), 1,
      sym__call_signature,
    STATE(3308), 1,
      aux_sym_export_statement_repeat1,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(3123), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3129), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3132), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32768] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(3235), 1,
      anon_sym_RBRACE,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_async,
    ACTIONS(3241), 1,
      anon_sym_static,
    ACTIONS(3243), 1,
      anon_sym_readonly,
    ACTIONS(3249), 1,
      anon_sym_override,
    STATE(2198), 1,
      sym_accessibility_modifier,
    STATE(2224), 1,
      sym_override_modifier,
    STATE(3512), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3566), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3245), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3247), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2785), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3568), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3233), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32866] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    ACTIONS(3253), 1,
      anon_sym_RBRACE,
    ACTIONS(3255), 1,
      anon_sym_async,
    ACTIONS(3257), 1,
      anon_sym_static,
    ACTIONS(3259), 1,
      anon_sym_readonly,
    ACTIONS(3265), 1,
      anon_sym_override,
    STATE(2198), 1,
      sym_accessibility_modifier,
    STATE(2224), 1,
      sym_override_modifier,
    STATE(3496), 1,
      aux_sym_object_repeat1,
    STATE(3512), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3261), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3263), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2785), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3449), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3251), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32964] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    ACTIONS(3269), 1,
      anon_sym_RBRACE,
    ACTIONS(3271), 1,
      anon_sym_async,
    ACTIONS(3273), 1,
      anon_sym_static,
    ACTIONS(3275), 1,
      anon_sym_readonly,
    ACTIONS(3281), 1,
      anon_sym_override,
    STATE(2198), 1,
      sym_accessibility_modifier,
    STATE(2224), 1,
      sym_override_modifier,
    STATE(3512), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3566), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3277), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3279), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2785), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3568), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3267), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33062] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    ACTIONS(3285), 1,
      anon_sym_RBRACE,
    ACTIONS(3287), 1,
      anon_sym_async,
    ACTIONS(3289), 1,
      anon_sym_static,
    ACTIONS(3291), 1,
      anon_sym_readonly,
    ACTIONS(3297), 1,
      anon_sym_override,
    STATE(2198), 1,
      sym_accessibility_modifier,
    STATE(2224), 1,
      sym_override_modifier,
    STATE(3512), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3566), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3293), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3295), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2785), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3568), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3283), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33160] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    ACTIONS(3301), 1,
      anon_sym_RBRACE,
    ACTIONS(3303), 1,
      anon_sym_async,
    ACTIONS(3305), 1,
      anon_sym_static,
    ACTIONS(3307), 1,
      anon_sym_readonly,
    ACTIONS(3313), 1,
      anon_sym_override,
    STATE(2198), 1,
      sym_accessibility_modifier,
    STATE(2224), 1,
      sym_override_modifier,
    STATE(3496), 1,
      aux_sym_object_repeat1,
    STATE(3512), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3309), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3311), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2785), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3449), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3299), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33258] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    ACTIONS(3317), 1,
      anon_sym_RBRACE,
    ACTIONS(3319), 1,
      anon_sym_async,
    ACTIONS(3321), 1,
      anon_sym_static,
    ACTIONS(3323), 1,
      anon_sym_readonly,
    ACTIONS(3329), 1,
      anon_sym_override,
    STATE(2198), 1,
      sym_accessibility_modifier,
    STATE(2224), 1,
      sym_override_modifier,
    STATE(3512), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3566), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3325), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3327), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2785), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3568), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3315), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33356] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    ACTIONS(3333), 1,
      anon_sym_RBRACE,
    ACTIONS(3335), 1,
      anon_sym_async,
    ACTIONS(3337), 1,
      anon_sym_static,
    ACTIONS(3339), 1,
      anon_sym_readonly,
    ACTIONS(3345), 1,
      anon_sym_override,
    STATE(2198), 1,
      sym_accessibility_modifier,
    STATE(2224), 1,
      sym_override_modifier,
    STATE(3512), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3566), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3341), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3343), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2785), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3440), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3568), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3331), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33454] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_LT,
    ACTIONS(3351), 1,
      anon_sym_DOT,
    ACTIONS(3353), 1,
      anon_sym_is,
    STATE(1228), 1,
      sym_type_arguments,
    ACTIONS(3347), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2969), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33516] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3357), 1,
      anon_sym_LBRACK,
    ACTIONS(3359), 1,
      anon_sym_DOT,
    ACTIONS(3361), 1,
      anon_sym_QMARK_DOT,
    STATE(1240), 1,
      sym_arguments,
    ACTIONS(2979), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2973), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33579] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3367), 1,
      anon_sym_LBRACK,
    ACTIONS(3369), 1,
      anon_sym_DOT,
    ACTIONS(3371), 1,
      anon_sym_QMARK_DOT,
    STATE(1231), 1,
      sym_arguments,
    ACTIONS(3363), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3365), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33642] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(3373), 1,
      sym__automatic_semicolon,
    ACTIONS(1294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33699] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3379), 1,
      anon_sym_LBRACK,
    ACTIONS(3381), 1,
      anon_sym_DOT,
    ACTIONS(3383), 1,
      anon_sym_QMARK_DOT,
    STATE(1233), 1,
      sym_arguments,
    ACTIONS(3375), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3377), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 1,
      anon_sym_is,
    ACTIONS(3385), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3387), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33817] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_LT,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3397), 1,
      anon_sym_QMARK_DOT,
    STATE(1299), 1,
      sym_type_arguments,
    STATE(1318), 1,
      sym_arguments,
    ACTIONS(3389), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3391), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1306), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1304), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1364), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1362), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33990] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1350), 1,
      sym_statement_block,
    ACTIONS(1286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1284), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [34047] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_LT,
    ACTIONS(3351), 1,
      anon_sym_DOT,
    STATE(1228), 1,
      sym_type_arguments,
    ACTIONS(3347), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2969), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34106] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_LT,
    STATE(1296), 1,
      sym_type_arguments,
    ACTIONS(3401), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3403), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34163] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_DOT,
    STATE(1350), 1,
      sym_statement_block,
    ACTIONS(1286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1284), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [34222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3409), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2516), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3413), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3415), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3419), 1,
      sym__automatic_semicolon,
    ACTIONS(1346), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1344), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34484] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    ACTIONS(3423), 1,
      anon_sym_async,
    ACTIONS(3425), 1,
      anon_sym_static,
    ACTIONS(3427), 1,
      anon_sym_readonly,
    ACTIONS(3433), 1,
      anon_sym_override,
    STATE(2198), 1,
      sym_accessibility_modifier,
    STATE(2224), 1,
      sym_override_modifier,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2890), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3429), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3431), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2785), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3679), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3742), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3421), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3437), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34626] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3443), 1,
      anon_sym_LBRACK,
    ACTIONS(3445), 1,
      anon_sym_DOT,
    ACTIONS(3447), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3439), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3441), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1938), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3453), 1,
      anon_sym_DOT,
    ACTIONS(3449), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3451), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_AMP,
    ACTIONS(3462), 1,
      anon_sym_PIPE,
    ACTIONS(3456), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3458), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34846] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_AMP,
    ACTIONS(3462), 1,
      anon_sym_PIPE,
    ACTIONS(3468), 1,
      anon_sym_extends,
    ACTIONS(3464), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3466), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3466), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3470), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3472), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2800), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1358), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [35168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_AMP,
    ACTIONS(3474), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3476), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3373), 1,
      sym__automatic_semicolon,
    ACTIONS(1294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3482), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3484), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1932), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1930), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3486), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3488), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3492), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3496), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35640] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(1938), 1,
      anon_sym_extends,
    ACTIONS(3502), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3505), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1296), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3510), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3514), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3514), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3514), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3516), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3518), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3403), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3526), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3530), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3526), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3526), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3534), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3538), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_AMP,
    ACTIONS(3540), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3542), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1948), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1946), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3546), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3534), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3550), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3556), 1,
      anon_sym_LBRACK,
    ACTIONS(3552), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3554), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3530), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3534), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3558), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3560), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3562), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3564), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1934), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3550), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3568), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3570), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3572), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3576), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2506), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2508), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37212] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_AMP,
    ACTIONS(3462), 1,
      anon_sym_PIPE,
    ACTIONS(3468), 1,
      anon_sym_extends,
    ACTIONS(3578), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3580), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3584), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37322] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3510), 1,
      anon_sym_extends,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(3592), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3595), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3586), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37382] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_AMP,
    ACTIONS(3462), 1,
      anon_sym_PIPE,
    ACTIONS(3468), 1,
      anon_sym_extends,
    ACTIONS(3598), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3600), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37440] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3546), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3387), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3604), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3554), 1,
      anon_sym_extends,
    ACTIONS(3556), 1,
      anon_sym_LBRACK,
    ACTIONS(3552), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3606), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3608), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2780), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2512), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3576), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1508), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3576), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3614), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3616), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 1,
      anon_sym_extends,
    ACTIONS(3618), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3620), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3556), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3624), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3628), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_AMP,
    ACTIONS(3462), 1,
      anon_sym_PIPE,
    ACTIONS(3468), 1,
      anon_sym_extends,
    ACTIONS(3618), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3620), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    STATE(1374), 1,
      sym_statement_block,
    ACTIONS(1286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1284), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38350] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    ACTIONS(3632), 1,
      anon_sym_DOT,
    STATE(1374), 1,
      sym_statement_block,
    ACTIONS(1286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1284), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3584), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3409), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3628), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3636), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2588), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3628), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3640), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3640), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3640), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3644), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3648), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1944), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1942), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3652), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39084] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    STATE(1370), 1,
      sym_arguments,
    ACTIONS(3654), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3656), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3636), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3660), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39244] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_AMP,
    ACTIONS(3462), 1,
      anon_sym_PIPE,
    ACTIONS(3468), 1,
      anon_sym_extends,
    ACTIONS(3658), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3660), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3664), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3652), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3668), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3670), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3672), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1392), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39561] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3678), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [39666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3720), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3586), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1332), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1330), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3723), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3725), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3727), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3729), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1406), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1408), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1416), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1418), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39976] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3731), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [40081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3733), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3735), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3737), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3739), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3741), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3743), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3745), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3747), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40285] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 1,
      anon_sym_LT,
    ACTIONS(3751), 1,
      anon_sym_DOT,
    ACTIONS(3753), 1,
      anon_sym_is,
    STATE(1610), 1,
      sym_type_arguments,
    ACTIONS(3347), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2969), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [40344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3755), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3757), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1352), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1350), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [40446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3759), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3761), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40497] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3763), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [40602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3765), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3767), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40653] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3767), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [40758] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3769), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [40863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3771), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1296), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3774), 1,
      sym__automatic_semicolon,
    ACTIONS(1346), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1344), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [40971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3776), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3778), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41022] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3784), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1356), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1354), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [41144] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_extends,
    ACTIONS(3787), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3790), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1352), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1350), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41252] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3795), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [41359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(3586), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1346), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1344), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [41463] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3799), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3807), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3805), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41650] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [41745] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [41842] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3784), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41919] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3780), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3782), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [42008] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [42099] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [42192] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      anon_sym_extends,
    ACTIONS(3814), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3817), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3810), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3820), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3822), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42300] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3784), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1308), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [42426] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3784), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42495] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3780), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [42580] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [42679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3824), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3826), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3830), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3678), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42832] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3834), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [42937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 1,
      sym__automatic_semicolon,
    ACTIONS(1294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [43041] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3838), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3840), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3834), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43197] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3842), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1358), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1400), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1398), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3846), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43455] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3684), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3848), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3850), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [43516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3854), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3858), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1370), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3860), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3862), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1448), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3810), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1308), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3866), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43975] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 1,
      anon_sym_extends,
    ACTIONS(3868), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 1,
      anon_sym_EQ,
    ACTIONS(3801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3805), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1346), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1344), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44136] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3397), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1456), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1458), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1332), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1330), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [44244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3876), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44295] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3878), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [44400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3878), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1458), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(1296), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3882), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1316), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1318), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44708] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3890), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3886), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3888), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [44777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1428), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3893), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3895), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44930] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3901), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3897), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3899), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [44997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1382), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3904), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3908), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3910), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1400), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1398), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [45201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3189), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3193), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1340), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3916), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3918), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3920), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3922), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45456] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3924), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45561] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3930), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3926), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3928), 19,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45634] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3799), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3933), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3935), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45790] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3918), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3939), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1356), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1354), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3943), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46048] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3945), 1,
      anon_sym_STAR,
    ACTIONS(3947), 1,
      anon_sym_RBRACE,
    ACTIONS(3949), 1,
      anon_sym_async,
    ACTIONS(3953), 1,
      anon_sym_AT,
    ACTIONS(3955), 1,
      anon_sym_static,
    ACTIONS(3957), 1,
      anon_sym_readonly,
    ACTIONS(3961), 1,
      anon_sym_declare,
    ACTIONS(3963), 1,
      anon_sym_abstract,
    STATE(2151), 1,
      sym_method_definition,
    STATE(2182), 1,
      sym_accessibility_modifier,
    STATE(2218), 1,
      sym_override_modifier,
    STATE(3300), 1,
      sym_method_signature,
    ACTIONS(3951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1429), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2354), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3514), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46142] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3945), 1,
      anon_sym_STAR,
    ACTIONS(3949), 1,
      anon_sym_async,
    ACTIONS(3953), 1,
      anon_sym_AT,
    ACTIONS(3955), 1,
      anon_sym_static,
    ACTIONS(3957), 1,
      anon_sym_readonly,
    ACTIONS(3961), 1,
      anon_sym_declare,
    ACTIONS(3963), 1,
      anon_sym_abstract,
    ACTIONS(3965), 1,
      anon_sym_RBRACE,
    STATE(2151), 1,
      sym_method_definition,
    STATE(2182), 1,
      sym_accessibility_modifier,
    STATE(2218), 1,
      sym_override_modifier,
    STATE(3300), 1,
      sym_method_signature,
    ACTIONS(3951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2354), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3514), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46236] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3834), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [46340] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3012), 1,
      anon_sym_QMARK,
    ACTIONS(3008), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46396] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3945), 1,
      anon_sym_STAR,
    ACTIONS(3949), 1,
      anon_sym_async,
    ACTIONS(3953), 1,
      anon_sym_AT,
    ACTIONS(3955), 1,
      anon_sym_static,
    ACTIONS(3957), 1,
      anon_sym_readonly,
    ACTIONS(3961), 1,
      anon_sym_declare,
    ACTIONS(3963), 1,
      anon_sym_abstract,
    ACTIONS(4017), 1,
      anon_sym_RBRACE,
    STATE(2151), 1,
      sym_method_definition,
    STATE(2182), 1,
      sym_accessibility_modifier,
    STATE(2218), 1,
      sym_override_modifier,
    STATE(3300), 1,
      sym_method_signature,
    ACTIONS(3951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2354), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3514), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46490] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3945), 1,
      anon_sym_STAR,
    ACTIONS(3949), 1,
      anon_sym_async,
    ACTIONS(3953), 1,
      anon_sym_AT,
    ACTIONS(3955), 1,
      anon_sym_static,
    ACTIONS(3957), 1,
      anon_sym_readonly,
    ACTIONS(3961), 1,
      anon_sym_declare,
    ACTIONS(3963), 1,
      anon_sym_abstract,
    ACTIONS(4019), 1,
      anon_sym_RBRACE,
    STATE(2151), 1,
      sym_method_definition,
    STATE(2182), 1,
      sym_accessibility_modifier,
    STATE(2218), 1,
      sym_override_modifier,
    STATE(3300), 1,
      sym_method_signature,
    ACTIONS(3951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1415), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2354), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3514), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46584] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3170), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4031), 1,
      anon_sym_readonly,
    STATE(2220), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46666] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3763), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [46770] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4039), 1,
      anon_sym_in,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4044), 1,
      anon_sym_GT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4037), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [46876] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3767), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [46980] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4076), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47050] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3945), 1,
      anon_sym_STAR,
    ACTIONS(3949), 1,
      anon_sym_async,
    ACTIONS(3953), 1,
      anon_sym_AT,
    ACTIONS(3955), 1,
      anon_sym_static,
    ACTIONS(3957), 1,
      anon_sym_readonly,
    ACTIONS(3961), 1,
      anon_sym_declare,
    ACTIONS(3963), 1,
      anon_sym_abstract,
    ACTIONS(4079), 1,
      anon_sym_RBRACE,
    STATE(2151), 1,
      sym_method_definition,
    STATE(2182), 1,
      sym_accessibility_modifier,
    STATE(2218), 1,
      sym_override_modifier,
    STATE(3300), 1,
      sym_method_signature,
    ACTIONS(3951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2354), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3514), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4081), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1296), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 1,
      anon_sym_LT,
    STATE(1605), 1,
      sym_type_arguments,
    ACTIONS(3401), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3403), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [47252] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3763), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [47356] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3842), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [47460] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(4042), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3848), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3850), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [47520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4083), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3805), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47574] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3945), 1,
      anon_sym_STAR,
    ACTIONS(3949), 1,
      anon_sym_async,
    ACTIONS(3953), 1,
      anon_sym_AT,
    ACTIONS(3955), 1,
      anon_sym_static,
    ACTIONS(3957), 1,
      anon_sym_readonly,
    ACTIONS(3961), 1,
      anon_sym_declare,
    ACTIONS(3963), 1,
      anon_sym_abstract,
    ACTIONS(4085), 1,
      anon_sym_RBRACE,
    STATE(2151), 1,
      sym_method_definition,
    STATE(2182), 1,
      sym_accessibility_modifier,
    STATE(2218), 1,
      sym_override_modifier,
    STATE(3300), 1,
      sym_method_signature,
    ACTIONS(3951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2354), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3514), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47668] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3842), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [47772] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47852] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3834), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [47956] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3769), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [48060] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [48154] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [48250] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4076), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48326] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [48414] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [48504] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [48596] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4076), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4087), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3586), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48724] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4089), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3890), 1,
      sym_type_annotation,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48834] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4076), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48902] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3780), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [48986] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [49084] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3678), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [49188] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3838), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [49292] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3769), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [49396] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3979), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3848), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3850), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [49456] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 1,
      anon_sym_LT,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(4091), 1,
      anon_sym_QMARK_DOT,
    STATE(1677), 1,
      sym_type_arguments,
    STATE(1698), 1,
      sym_arguments,
    ACTIONS(3389), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3391), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49520] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3767), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [49624] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4093), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49694] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49774] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [49868] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [49964] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4093), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50040] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [50128] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [50218] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [50310] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4093), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50384] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    ACTIONS(4096), 1,
      anon_sym_COMMA,
    ACTIONS(4099), 1,
      anon_sym_RBRACE,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3842), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50492] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4093), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50560] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3780), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [50644] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [50742] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3678), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [50846] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3838), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [50950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3016), 1,
      anon_sym_QMARK,
    ACTIONS(3014), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51006] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3799), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51110] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3918), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51214] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3878), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51318] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3731), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51422] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(4101), 1,
      anon_sym_LBRACK,
    ACTIONS(4103), 1,
      anon_sym_DOT,
    ACTIONS(4105), 1,
      anon_sym_QMARK_DOT,
    STATE(1567), 1,
      sym_arguments,
    ACTIONS(2979), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2973), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [51482] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(4107), 1,
      anon_sym_LBRACK,
    ACTIONS(4109), 1,
      anon_sym_DOT,
    ACTIONS(4111), 1,
      anon_sym_QMARK_DOT,
    STATE(1566), 1,
      sym_arguments,
    ACTIONS(3375), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3377), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [51542] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(4113), 1,
      anon_sym_LBRACK,
    ACTIONS(4115), 1,
      anon_sym_DOT,
    ACTIONS(4117), 1,
      anon_sym_QMARK_DOT,
    STATE(1565), 1,
      sym_arguments,
    ACTIONS(3363), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3365), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [51602] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3173), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4031), 1,
      anon_sym_readonly,
    STATE(2220), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [51684] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3945), 1,
      anon_sym_STAR,
    ACTIONS(3949), 1,
      anon_sym_async,
    ACTIONS(3953), 1,
      anon_sym_AT,
    ACTIONS(3955), 1,
      anon_sym_static,
    ACTIONS(3957), 1,
      anon_sym_readonly,
    ACTIONS(3961), 1,
      anon_sym_declare,
    ACTIONS(3963), 1,
      anon_sym_abstract,
    ACTIONS(4119), 1,
      anon_sym_RBRACE,
    STATE(2151), 1,
      sym_method_definition,
    STATE(2182), 1,
      sym_accessibility_modifier,
    STATE(2218), 1,
      sym_override_modifier,
    STATE(3300), 1,
      sym_method_signature,
    ACTIONS(3951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1483), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2354), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3514), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [51778] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    ACTIONS(4099), 1,
      anon_sym_RBRACE,
    ACTIONS(4121), 1,
      anon_sym_COMMA,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3763), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51886] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    ACTIONS(4124), 1,
      anon_sym_COMMA,
    ACTIONS(4127), 1,
      anon_sym_RBRACE,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3763), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51994] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3871), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3604), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52052] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 1,
      anon_sym_LT,
    ACTIONS(3751), 1,
      anon_sym_DOT,
    STATE(1610), 1,
      sym_type_arguments,
    ACTIONS(3347), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2969), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [52108] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4129), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1938), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1296), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52168] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(3592), 1,
      anon_sym_LBRACK,
    ACTIONS(3595), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4133), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3510), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3586), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52228] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3945), 1,
      anon_sym_STAR,
    ACTIONS(3949), 1,
      anon_sym_async,
    ACTIONS(3953), 1,
      anon_sym_AT,
    ACTIONS(3955), 1,
      anon_sym_static,
    ACTIONS(3957), 1,
      anon_sym_readonly,
    ACTIONS(3961), 1,
      anon_sym_declare,
    ACTIONS(3963), 1,
      anon_sym_abstract,
    ACTIONS(4137), 1,
      anon_sym_RBRACE,
    STATE(2151), 1,
      sym_method_definition,
    STATE(2182), 1,
      sym_accessibility_modifier,
    STATE(2218), 1,
      sym_override_modifier,
    STATE(3300), 1,
      sym_method_signature,
    ACTIONS(3951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2354), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3514), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [52322] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4139), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [52426] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3945), 1,
      anon_sym_STAR,
    ACTIONS(3949), 1,
      anon_sym_async,
    ACTIONS(3953), 1,
      anon_sym_AT,
    ACTIONS(3955), 1,
      anon_sym_static,
    ACTIONS(3957), 1,
      anon_sym_readonly,
    ACTIONS(3961), 1,
      anon_sym_declare,
    ACTIONS(3963), 1,
      anon_sym_abstract,
    ACTIONS(4141), 1,
      anon_sym_RBRACE,
    STATE(2151), 1,
      sym_method_definition,
    STATE(2182), 1,
      sym_accessibility_modifier,
    STATE(2218), 1,
      sym_override_modifier,
    STATE(3300), 1,
      sym_method_signature,
    ACTIONS(3951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1422), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2354), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3514), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [52520] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4143), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3928), 1,
      sym_type_annotation,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52630] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4145), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3897), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3899), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [52696] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3878), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [52800] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3918), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [52904] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3799), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [53008] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_STAR,
    ACTIONS(4154), 1,
      anon_sym_RBRACE,
    ACTIONS(4156), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_async,
    ACTIONS(4162), 1,
      anon_sym_DASH,
    ACTIONS(4165), 1,
      anon_sym_DQUOTE,
    ACTIONS(4168), 1,
      anon_sym_SQUOTE,
    ACTIONS(4174), 1,
      anon_sym_AT,
    ACTIONS(4177), 1,
      anon_sym_static,
    ACTIONS(4180), 1,
      anon_sym_readonly,
    ACTIONS(4186), 1,
      anon_sym_declare,
    ACTIONS(4192), 1,
      anon_sym_override,
    ACTIONS(4195), 1,
      anon_sym_abstract,
    STATE(2151), 1,
      sym_method_definition,
    STATE(2182), 1,
      sym_accessibility_modifier,
    STATE(2218), 1,
      sym_override_modifier,
    STATE(3300), 1,
      sym_method_signature,
    ACTIONS(4171), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4183), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4189), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2354), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3514), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4148), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53102] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3167), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4031), 1,
      anon_sym_readonly,
    STATE(2220), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53184] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3731), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [53288] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3924), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [53392] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(3604), 1,
      anon_sym_extends,
    ACTIONS(3868), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53450] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4198), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3926), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3928), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53522] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4201), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(4142), 1,
      sym_type_annotation,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53632] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(3012), 1,
      anon_sym_QMARK,
    ACTIONS(3018), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53688] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4203), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3886), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3888), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53756] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3160), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4031), 1,
      anon_sym_readonly,
    STATE(2220), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53838] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4206), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(4062), 1,
      sym_type_annotation,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53948] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(1938), 1,
      anon_sym_extends,
    ACTIONS(3502), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3505), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1296), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54006] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4212), 1,
      anon_sym_COMMA,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(2698), 1,
      sym_type_arguments,
    STATE(3353), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4210), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54114] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4031), 1,
      anon_sym_readonly,
    STATE(2220), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54196] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4248), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3886), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3888), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [54264] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(2612), 1,
      anon_sym_DASH,
    ACTIONS(3119), 1,
      anon_sym_LBRACK,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(3945), 1,
      anon_sym_STAR,
    ACTIONS(3949), 1,
      anon_sym_async,
    ACTIONS(3953), 1,
      anon_sym_AT,
    ACTIONS(3955), 1,
      anon_sym_static,
    ACTIONS(3957), 1,
      anon_sym_readonly,
    ACTIONS(3961), 1,
      anon_sym_declare,
    ACTIONS(3963), 1,
      anon_sym_abstract,
    ACTIONS(4251), 1,
      anon_sym_RBRACE,
    STATE(2151), 1,
      sym_method_definition,
    STATE(2182), 1,
      sym_accessibility_modifier,
    STATE(2218), 1,
      sym_override_modifier,
    STATE(3300), 1,
      sym_method_signature,
    ACTIONS(3951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1412), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2354), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3514), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3109), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54358] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3510), 1,
      anon_sym_extends,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(3592), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3595), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3586), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54416] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4253), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3926), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3928), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [54488] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4042), 1,
      anon_sym_LT,
    ACTIONS(4046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4048), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4050), 1,
      anon_sym_GT_GT,
    ACTIONS(4054), 1,
      anon_sym_AMP,
    ACTIONS(4056), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE,
    ACTIONS(4062), 1,
      anon_sym_PERCENT,
    ACTIONS(4064), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4072), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4074), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4035), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4044), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4052), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4060), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4068), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4070), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4066), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3924), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [54592] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4256), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3897), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3899), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [54658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3753), 1,
      anon_sym_is,
    ACTIONS(3385), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3387), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [54710] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3878), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2800), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [54862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3550), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [54911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3530), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [54960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3496), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3486), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3488), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1932), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1930), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [55107] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4259), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [55174] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [55247] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_extends,
    ACTIONS(3787), 1,
      anon_sym_LBRACK,
    ACTIONS(4266), 1,
      anon_sym_RPAREN,
    ACTIONS(3790), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4262), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4264), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55308] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [55399] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [55488] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [55575] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [55650] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3012), 1,
      anon_sym_QMARK,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3008), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3604), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3871), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55711] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4037), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [55814] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [55909] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [56002] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(4269), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3424), 1,
      aux_sym_array_repeat1,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56109] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [56188] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4259), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [56257] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3767), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56360] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3763), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56463] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3769), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56566] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3834), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56669] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3842), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56772] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(4216), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3848), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3850), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [56831] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1938), 1,
      anon_sym_extends,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(4129), 1,
      anon_sym_RPAREN,
    ACTIONS(1298), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3771), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1296), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56892] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4271), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [56995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3409), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3480), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_AMP,
    ACTIONS(3474), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3476), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3470), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3472), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2780), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3466), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57291] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_AMP,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_extends,
    ACTIONS(3464), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3466), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3453), 1,
      anon_sym_DOT,
    ACTIONS(3449), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3451), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3437), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3550), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3584), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3415), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3413), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57642] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      anon_sym_extends,
    ACTIONS(3814), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3817), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3810), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57697] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3546), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57750] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    ACTIONS(4279), 1,
      anon_sym_COMMA,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4281), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3409), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3584), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57953] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58006] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4283), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3897), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3899), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [58071] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3636), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58195] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4292), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58268] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3173), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3492), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1948), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1946), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58539] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3510), 1,
      anon_sym_extends,
    ACTIONS(3592), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 1,
      anon_sym_RPAREN,
    ACTIONS(3588), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3595), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3720), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3586), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58600] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(4294), 1,
      anon_sym_RBRACK,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3508), 1,
      aux_sym_array_repeat1,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3652), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3546), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58809] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4037), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [58912] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1938), 1,
      anon_sym_extends,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(4296), 1,
      anon_sym_RPAREN,
    ACTIONS(1298), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4081), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1296), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58973] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3160), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4292), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3636), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59095] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3160), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59170] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3510), 1,
      anon_sym_extends,
    ACTIONS(3592), 1,
      anon_sym_LBRACK,
    ACTIONS(4299), 1,
      anon_sym_RPAREN,
    ACTIONS(3588), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3595), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4087), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3586), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59231] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_extends,
    ACTIONS(3787), 1,
      anon_sym_LBRACK,
    ACTIONS(4306), 1,
      anon_sym_RPAREN,
    ACTIONS(3790), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4302), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4304), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3652), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3668), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3670), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3672), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59439] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3780), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [59522] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    ACTIONS(4279), 1,
      anon_sym_COMMA,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4309), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59627] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    ACTIONS(4279), 1,
      anon_sym_COMMA,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4311), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2588), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3664), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(3586), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59881] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(4313), 1,
      anon_sym_RBRACK,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3375), 1,
      aux_sym_array_repeat1,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2516), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60037] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3173), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4292), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60110] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3167), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4292), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60183] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3167), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60258] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_AMP,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_extends,
    ACTIONS(3658), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3660), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3660), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2506), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2508), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60462] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [60559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4319), 1,
      sym_regex_flags,
    ACTIONS(4315), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4317), 25,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60610] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3678), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3530), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60762] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3838), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60865] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3799), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60968] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(2744), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4321), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [61071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3648), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4323), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3624), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61220] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3554), 1,
      anon_sym_extends,
    ACTIONS(4323), 1,
      anon_sym_LBRACK,
    ACTIONS(3552), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3606), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3608), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61275] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_AMP,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_extends,
    ACTIONS(3578), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3580), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3482), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3484), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3562), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3564), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3546), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_AMP,
    ACTIONS(3540), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3542), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61528] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(4325), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3562), 1,
      aux_sym_array_repeat1,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61635] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3918), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3538), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3604), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3510), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61885] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(3012), 1,
      anon_sym_QMARK,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3604), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3871), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61946] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_extends,
    ACTIONS(3787), 1,
      anon_sym_LBRACK,
    ACTIONS(4330), 1,
      anon_sym_RPAREN,
    ACTIONS(3790), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4262), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4327), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62007] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 1,
      anon_sym_extends,
    ACTIONS(3868), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62062] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4334), 1,
      anon_sym_LBRACK,
    ACTIONS(4336), 1,
      anon_sym_DOT,
    ACTIONS(4338), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3439), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3441), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62117] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3731), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1944), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1942), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3644), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1938), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62367] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3787), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3387), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62422] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_AMP,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_extends,
    ACTIONS(3598), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3600), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3640), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3640), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3640), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62624] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3817), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3814), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3564), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3810), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3628), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62728] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(3592), 1,
      anon_sym_LBRACK,
    ACTIONS(3510), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3595), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3586), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62785] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(1938), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3505), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1296), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3628), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62891] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3871), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3868), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3604), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3628), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3576), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3576), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3576), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3570), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3572), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3568), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1934), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3558), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3560), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3534), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3534), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3534), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3526), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63534] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3001), 1,
      anon_sym_EQ,
    ACTIONS(3604), 1,
      anon_sym_extends,
    ACTIONS(3868), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3526), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3526), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3514), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3514), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3514), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_AMP,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(3456), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3458), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63889] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4340), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [63992] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(3836), 1,
      sym__automatic_semicolon,
    ACTIONS(1294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1292), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64045] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    ACTIONS(3604), 1,
      anon_sym_extends,
    ACTIONS(3868), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64102] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_extends,
    ACTIONS(3787), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3790), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64157] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(4342), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3433), 1,
      aux_sym_array_repeat1,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(1296), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2512), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3516), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3518), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3403), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4323), 1,
      anon_sym_LBRACK,
    ACTIONS(3552), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3554), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64513] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3979), 1,
      anon_sym_LT,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3989), 1,
      anon_sym_GT_GT,
    ACTIONS(3993), 1,
      anon_sym_AMP,
    ACTIONS(3995), 1,
      anon_sym_CARET,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_PERCENT,
    ACTIONS(4003), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4011), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4015), 1,
      sym__ternary_qmark,
    ACTIONS(4279), 1,
      anon_sym_COMMA,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3967), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3975), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3991), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3999), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4007), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4005), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3387), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64667] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 1,
      anon_sym_extends,
    ACTIONS(3618), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3620), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64718] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(4344), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3431), 1,
      aux_sym_array_repeat1,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64825] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3170), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4292), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64898] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_QMARK,
    ACTIONS(3510), 1,
      anon_sym_extends,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(3592), 1,
      anon_sym_LBRACK,
    ACTIONS(4087), 1,
      anon_sym_COLON,
    ACTIONS(3595), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4133), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3586), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64961] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_AMP,
    ACTIONS(4275), 1,
      anon_sym_PIPE,
    ACTIONS(4277), 1,
      anon_sym_extends,
    ACTIONS(3618), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3620), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65016] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(1938), 1,
      anon_sym_extends,
    ACTIONS(1940), 1,
      anon_sym_QMARK,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(4081), 1,
      anon_sym_COLON,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4129), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1296), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65079] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3170), 1,
      anon_sym_RBRACE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65205] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    STATE(1885), 1,
      sym_arguments,
    ACTIONS(3654), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3656), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65258] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(4346), 1,
      anon_sym_RBRACK,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3375), 1,
      aux_sym_array_repeat1,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65365] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4348), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3886), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3888), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [65432] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(4351), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3422), 1,
      aux_sym_array_repeat1,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65539] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(1302), 1,
      sym__automatic_semicolon,
    ACTIONS(1292), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1296), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65594] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(4353), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3475), 1,
      aux_sym_array_repeat1,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65701] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4355), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3926), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3928), 17,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [65772] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(4358), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(3492), 1,
      aux_sym_array_repeat1,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 1,
      anon_sym_EQ,
    ACTIONS(3801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3805), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65930] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4220), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4222), 1,
      anon_sym_GT_GT,
    ACTIONS(4226), 1,
      anon_sym_AMP,
    ACTIONS(4228), 1,
      anon_sym_CARET,
    ACTIONS(4230), 1,
      anon_sym_PIPE,
    ACTIONS(4234), 1,
      anon_sym_PERCENT,
    ACTIONS(4236), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4244), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4246), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4208), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4224), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4232), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3924), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4238), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3614), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3616), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1508), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66131] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(1938), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3505), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1296), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4360), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4362), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3727), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3729), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66287] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3763), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1334), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1338), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1340), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66439] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66507] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3733), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3735), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3737), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3739), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3741), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3743), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66705] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4400), 1,
      anon_sym_RBRACE,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66809] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_EQ,
    ACTIONS(3602), 1,
      anon_sym_QMARK,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3871), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3604), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66867] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3767), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66969] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4402), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [67037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3759), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3761), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3765), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3767), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67133] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [67211] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(4081), 1,
      anon_sym_of,
    ACTIONS(4405), 1,
      anon_sym_in,
    ACTIONS(1296), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3814), 1,
      anon_sym_LBRACK,
    ACTIONS(3564), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3817), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3810), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67319] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [67411] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [67505] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4408), 1,
      anon_sym_RBRACK,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1456), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1458), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67659] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 1,
      anon_sym_EQ,
    ACTIONS(4083), 1,
      anon_sym_of,
    ACTIONS(4410), 1,
      anon_sym_in,
    ACTIONS(3801), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3805), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67713] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      anon_sym_extends,
    ACTIONS(3817), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3814), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3810), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67767] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4402), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [67841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1392), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67891] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4413), 1,
      sym__automatic_semicolon,
    ACTIONS(1402), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1406), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1408), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1412), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1416), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1418), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3824), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3826), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3830), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3678), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68187] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4415), 1,
      anon_sym_LPAREN,
    ACTIONS(4418), 1,
      anon_sym_COLON,
    ACTIONS(4420), 1,
      anon_sym_LT,
    ACTIONS(4423), 1,
      anon_sym_QMARK,
    ACTIONS(2919), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68243] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4031), 1,
      anon_sym_readonly,
    STATE(2220), 1,
      sym_override_modifier,
    ACTIONS(3229), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68317] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [68403] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [68491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3001), 1,
      anon_sym_EQ,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1456), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1458), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3866), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1422), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1426), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1428), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4425), 1,
      sym__automatic_semicolon,
    ACTIONS(1312), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1316), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1318), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      sym__automatic_semicolon,
    ACTIONS(1376), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1380), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1382), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68793] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4262), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4264), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68845] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3834), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4429), 1,
      sym__automatic_semicolon,
    ACTIONS(1442), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1446), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1448), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3858), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1366), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1370), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69197] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [69287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3840), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3834), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69335] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3160), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69403] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3790), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69457] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4431), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3886), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3888), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [69523] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4434), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3926), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3928), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [69593] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3842), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69695] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(4368), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3848), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3850), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [69753] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(4437), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3848), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3850), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [69811] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3924), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69913] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(3014), 1,
      anon_sym_COLON,
    ACTIONS(3604), 1,
      anon_sym_extends,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3871), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4473), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69973] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4477), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3546), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3562), 1,
      anon_sym_QMARK,
    ACTIONS(3564), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3817), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3814), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3810), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70183] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4402), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3189), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3193), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70303] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3014), 1,
      anon_sym_COLON,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3871), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3604), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(4087), 1,
      anon_sym_of,
    ACTIONS(4479), 1,
      anon_sym_in,
    ACTIONS(3586), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70415] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4402), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70481] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4482), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3897), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3899), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [70545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4262), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4327), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70597] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4485), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70699] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3780), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [70781] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [70877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3914), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70925] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3678), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71027] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3838), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4487), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4489), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71181] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4491), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3897), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3899), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [71245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3755), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3757), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71293] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4487), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4489), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71345] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4487), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4489), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71397] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3731), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3893), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3895), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3939), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71595] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3924), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3723), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3725), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71745] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      sym__automatic_semicolon,
    ACTIONS(1366), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1370), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71797] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3842), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71899] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3834), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72001] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3769), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4494), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4496), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1428), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72203] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(3502), 1,
      anon_sym_LBRACK,
    ACTIONS(4081), 1,
      anon_sym_COLON,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1938), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1296), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72261] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(3592), 1,
      anon_sym_LBRACK,
    ACTIONS(4087), 1,
      anon_sym_COLON,
    ACTIONS(3595), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3510), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3586), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72319] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4498), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72423] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4500), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3926), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3928), 16,
      sym__ternary_qmark,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [72493] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4503), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1316), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1318), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3854), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72693] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4505), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72845] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1450), 1,
      sym__automatic_semicolon,
    ACTIONS(1442), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1446), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1448), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72897] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4507), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73001] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4509), 1,
      anon_sym_LPAREN,
    ACTIONS(4512), 1,
      anon_sym_COLON,
    ACTIONS(4514), 1,
      anon_sym_LT,
    ACTIONS(4517), 1,
      anon_sym_QMARK,
    ACTIONS(3755), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3757), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73057] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3170), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73125] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    ACTIONS(4519), 1,
      anon_sym_SEMI,
    ACTIONS(4521), 1,
      sym__automatic_semicolon,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73229] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4523), 1,
      anon_sym_RBRACK,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73333] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3878), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3933), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3935), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73483] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3918), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1416), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1418), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73633] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3799), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3846), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      sym__automatic_semicolon,
    ACTIONS(1388), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1392), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1406), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1408), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 1,
      sym__automatic_semicolon,
    ACTIONS(1470), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73935] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4525), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3886), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3888), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [74001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4530), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4532), 1,
      sym_regex_flags,
    ACTIONS(4315), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4317), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74151] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 1,
      sym__automatic_semicolon,
    ACTIONS(1432), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1392), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      sym__automatic_semicolon,
    ACTIONS(1460), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74303] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 1,
      anon_sym_extends,
    ACTIONS(3871), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3868), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4530), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3908), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3910), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74457] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4534), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4302), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4304), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74611] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1384), 1,
      sym__automatic_semicolon,
    ACTIONS(1376), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1380), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1382), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 1,
      sym__automatic_semicolon,
    ACTIONS(1312), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1316), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1318), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1340), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74867] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 1,
      sym__automatic_semicolon,
    ACTIONS(1422), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1426), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1428), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74919] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3769), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75021] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3167), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75089] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3799), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75191] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4127), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75293] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4099), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75395] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4536), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4530), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1448), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1370), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75647] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3838), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75749] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4538), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75853] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3678), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75955] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4540), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4542), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4544), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76111] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 5,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [76207] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4546), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76311] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3780), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [76393] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4548), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76497] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4550), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [76563] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(3592), 1,
      anon_sym_LBRACK,
    ACTIONS(3510), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3595), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3586), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76619] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      anon_sym_QMARK,
    ACTIONS(3604), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3871), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3868), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76675] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4550), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [76747] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [76837] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [76925] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [77011] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4550), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [77085] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 6,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [77179] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [77271] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3173), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4532), 1,
      sym_regex_flags,
    ACTIONS(4315), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4317), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77389] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4553), 1,
      anon_sym_RBRACK,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3904), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77541] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [77619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1458), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77667] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3918), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77769] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4550), 1,
      anon_sym_LT,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [77837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77887] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_EQ,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77943] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_EQ,
    ACTIONS(3604), 1,
      anon_sym_extends,
    ACTIONS(3868), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [77999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1420), 1,
      sym__automatic_semicolon,
    ACTIONS(1412), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1416), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1418), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78051] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4557), 1,
      anon_sym_static,
    ACTIONS(4559), 1,
      anon_sym_readonly,
    ACTIONS(4561), 1,
      anon_sym_abstract,
    STATE(2196), 1,
      sym_accessibility_modifier,
    STATE(2237), 1,
      sym_override_modifier,
    ACTIONS(4555), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3131), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2680), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3109), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78123] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3878), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78225] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_EQ,
    ACTIONS(3060), 1,
      anon_sym_in,
    ACTIONS(3063), 1,
      anon_sym_of,
    ACTIONS(2919), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78279] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3767), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3745), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3747), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78429] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(4091), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1456), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1458), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4565), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3799), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78583] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    ACTIONS(4567), 1,
      anon_sym_SEMI,
    ACTIONS(4569), 1,
      sym__automatic_semicolon,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3810), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3820), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3822), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3776), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3778), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78831] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1342), 1,
      sym__automatic_semicolon,
    ACTIONS(1334), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1338), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1340), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78883] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4571), 1,
      anon_sym_RBRACK,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1382), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      sym__automatic_semicolon,
    ACTIONS(1402), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1406), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1408), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3943), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79135] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3969), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4437), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4447), 1,
      anon_sym_GT_GT,
    ACTIONS(4451), 1,
      anon_sym_AMP,
    ACTIONS(4453), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_PIPE,
    ACTIONS(4459), 1,
      anon_sym_PERCENT,
    ACTIONS(4461), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4469), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4471), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3763), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4013), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4439), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4441), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4449), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4465), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4467), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4463), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3882), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3920), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3922), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3860), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3862), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3876), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79477] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3684), 1,
      anon_sym_LT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3688), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3692), 1,
      anon_sym_GT_GT,
    ACTIONS(3696), 1,
      anon_sym_AMP,
    ACTIONS(3698), 1,
      anon_sym_CARET,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3704), 1,
      anon_sym_PERCENT,
    ACTIONS(3706), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3714), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3718), 1,
      sym__ternary_qmark,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(4573), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3674), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3682), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3694), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3702), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3710), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3708), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3878), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79629] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3731), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3916), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3918), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79779] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4575), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79880] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4037), 1,
      anon_sym_of,
    ACTIONS(4579), 1,
      anon_sym_in,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_GT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79983] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4616), 1,
      anon_sym_STAR,
    ACTIONS(4618), 1,
      anon_sym_async,
    ACTIONS(4622), 1,
      anon_sym_readonly,
    STATE(2228), 1,
      sym_override_modifier,
    ACTIONS(4620), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4624), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3109), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80052] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4286), 1,
      anon_sym_LBRACK,
    ACTIONS(4616), 1,
      anon_sym_STAR,
    ACTIONS(4618), 1,
      anon_sym_async,
    ACTIONS(4626), 1,
      anon_sym_abstract,
    ACTIONS(4620), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4624), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80117] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1660), 1,
      anon_sym_RBRACE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(1894), 1,
      anon_sym_readonly,
    ACTIONS(1898), 1,
      anon_sym_override,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    STATE(2225), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(3067), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80247] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4630), 1,
      anon_sym_STAR,
    ACTIONS(4632), 1,
      anon_sym_async,
    ACTIONS(4636), 1,
      anon_sym_readonly,
    STATE(2219), 1,
      sym_override_modifier,
    ACTIONS(4634), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4638), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2448), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80316] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4640), 1,
      anon_sym_STAR,
    ACTIONS(4642), 1,
      anon_sym_async,
    ACTIONS(4648), 1,
      anon_sym_abstract,
    ACTIONS(4644), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4646), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80381] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4640), 1,
      anon_sym_STAR,
    ACTIONS(4642), 1,
      anon_sym_async,
    ACTIONS(4650), 1,
      anon_sym_readonly,
    STATE(2215), 1,
      sym_override_modifier,
    ACTIONS(4644), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4646), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3109), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80450] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4652), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80551] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3510), 1,
      anon_sym_extends,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(3592), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3595), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3586), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80606] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(1938), 1,
      anon_sym_extends,
    ACTIONS(3502), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3505), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1296), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80661] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4654), 1,
      anon_sym_RBRACK,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80762] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 1,
      anon_sym_EQ,
    ACTIONS(4083), 1,
      anon_sym_COLON,
    ACTIONS(3807), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3805), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80815] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(1894), 1,
      anon_sym_readonly,
    ACTIONS(1898), 1,
      anon_sym_override,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    STATE(2225), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80894] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4656), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80995] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(4582), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3848), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3850), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [81052] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3842), 1,
      anon_sym_of,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81153] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4658), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81254] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3834), 1,
      anon_sym_of,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81355] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4660), 1,
      anon_sym_RBRACK,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81456] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3769), 1,
      anon_sym_of,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81557] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(1894), 1,
      anon_sym_readonly,
    ACTIONS(1898), 1,
      anon_sym_override,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4662), 1,
      anon_sym_RBRACE,
    STATE(2225), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81636] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(1894), 1,
      anon_sym_readonly,
    ACTIONS(1898), 1,
      anon_sym_override,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    STATE(2225), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81715] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3763), 1,
      anon_sym_of,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81816] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3814), 1,
      anon_sym_LBRACK,
    ACTIONS(3564), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3817), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3810), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81869] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3767), 1,
      anon_sym_of,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81970] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4664), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82037] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3790), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82090] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82167] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [82258] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82311] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [82404] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4664), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82477] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [82562] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [82649] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [82738] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4664), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82809] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4664), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82874] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4667), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82975] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(4673), 1,
      anon_sym_RBRACE,
    STATE(3565), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4675), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3570), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4100), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4669), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83044] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3780), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [83125] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(1894), 1,
      anon_sym_readonly,
    ACTIONS(1898), 1,
      anon_sym_override,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4677), 1,
      anon_sym_RBRACE,
    STATE(2225), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83204] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_QMARK_QMARK,
  [83299] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3678), 1,
      anon_sym_of,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83400] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3838), 1,
      anon_sym_of,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83501] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3799), 1,
      anon_sym_of,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83602] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3918), 1,
      anon_sym_of,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83703] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3878), 1,
      anon_sym_of,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83804] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3731), 1,
      anon_sym_of,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83905] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4679), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3886), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3888), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [83970] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4682), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3926), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3928), 15,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [84039] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3924), 1,
      anon_sym_of,
    ACTIONS(4582), 1,
      anon_sym_LT,
    ACTIONS(4586), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4590), 1,
      anon_sym_GT_GT,
    ACTIONS(4594), 1,
      anon_sym_AMP,
    ACTIONS(4596), 1,
      anon_sym_CARET,
    ACTIONS(4598), 1,
      anon_sym_PIPE,
    ACTIONS(4602), 1,
      anon_sym_PERCENT,
    ACTIONS(4604), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4612), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4614), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4577), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4592), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4600), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4608), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4610), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4606), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84140] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_EQ,
    ACTIONS(3604), 1,
      anon_sym_extends,
    ACTIONS(3868), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3871), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84195] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4685), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3897), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3899), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [84258] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84359] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(3229), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4292), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84424] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4690), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84525] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4286), 1,
      anon_sym_LBRACK,
    ACTIONS(3229), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84592] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4694), 1,
      anon_sym_async,
    ACTIONS(4698), 1,
      anon_sym_readonly,
    STATE(2221), 1,
      sym_override_modifier,
    ACTIONS(4696), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4700), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2455), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84661] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4702), 1,
      anon_sym_STAR,
    ACTIONS(4704), 1,
      anon_sym_async,
    ACTIONS(4708), 1,
      anon_sym_readonly,
    STATE(2230), 1,
      sym_override_modifier,
    ACTIONS(4706), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4710), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84730] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 1,
      anon_sym_EQ,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84785] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(4714), 1,
      anon_sym_RBRACE,
    STATE(3512), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4675), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3440), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4100), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4712), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84854] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(1894), 1,
      anon_sym_readonly,
    ACTIONS(1898), 1,
      anon_sym_override,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4716), 1,
      anon_sym_RBRACE,
    STATE(2225), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(3546), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84984] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4368), 1,
      anon_sym_LT,
    ACTIONS(4370), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4374), 1,
      anon_sym_GT_GT,
    ACTIONS(4378), 1,
      anon_sym_AMP,
    ACTIONS(4380), 1,
      anon_sym_CARET,
    ACTIONS(4382), 1,
      anon_sym_PIPE,
    ACTIONS(4386), 1,
      anon_sym_PERCENT,
    ACTIONS(4388), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4718), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4364), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4366), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4376), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4384), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4392), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4394), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4390), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85085] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(1894), 1,
      anon_sym_readonly,
    ACTIONS(1898), 1,
      anon_sym_override,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4720), 1,
      anon_sym_RBRACE,
    STATE(2225), 1,
      sym_override_modifier,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_EQ,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [85213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4319), 1,
      sym_regex_flags,
    ACTIONS(4315), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
    ACTIONS(4317), 22,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85262] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_QMARK,
    ACTIONS(3387), 1,
      anon_sym_extends,
    ACTIONS(3790), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3787), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85317] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1660), 1,
      anon_sym_RBRACE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85389] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4702), 1,
      anon_sym_STAR,
    ACTIONS(4704), 1,
      anon_sym_async,
    ACTIONS(4706), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4710), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85451] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4722), 1,
      anon_sym_STAR,
    ACTIONS(4724), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4726), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2865), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85511] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4728), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4731), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85559] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4736), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2853), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_EQ,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85667] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85765] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85863] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4694), 1,
      anon_sym_async,
    ACTIONS(4696), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4700), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2455), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3747), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4774), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85973] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86071] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4780), 1,
      anon_sym_STAR,
    ACTIONS(4782), 1,
      anon_sym_async,
    ACTIONS(4784), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4786), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2392), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86133] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86231] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86329] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86399] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86471] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4788), 1,
      anon_sym_STAR,
    ACTIONS(4790), 1,
      anon_sym_async,
    ACTIONS(4792), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4794), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86533] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4720), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86605] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4720), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86675] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4796), 1,
      anon_sym_STAR,
    ACTIONS(4798), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86735] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1660), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3906), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4802), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4805), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86853] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4662), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86923] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87021] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4808), 1,
      sym_identifier,
    ACTIONS(3189), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3193), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87167] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(3720), 1,
      anon_sym_RBRACK,
    ACTIONS(4087), 1,
      anon_sym_COMMA,
    ACTIONS(3586), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87219] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_QMARK_QMARK,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87313] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4640), 1,
      anon_sym_STAR,
    ACTIONS(4810), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4812), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2850), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87373] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3780), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [87453] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4640), 1,
      anon_sym_STAR,
    ACTIONS(4642), 1,
      anon_sym_async,
    ACTIONS(4644), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4646), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87515] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4662), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87587] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87645] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3160), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87703] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4814), 1,
      anon_sym_STAR,
    ACTIONS(4816), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4818), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2937), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87763] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3160), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4820), 1,
      sym_identifier,
    ACTIONS(3189), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3193), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87869] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4677), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87941] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87999] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4716), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88071] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4716), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88141] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4822), 1,
      anon_sym_STAR,
    ACTIONS(4824), 1,
      anon_sym_async,
    ACTIONS(4826), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4828), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2454), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88203] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4677), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(3771), 1,
      anon_sym_RBRACK,
    ACTIONS(4081), 1,
      anon_sym_COMMA,
    ACTIONS(1296), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3866), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4830), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4833), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88373] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4836), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [88437] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4836), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [88507] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [88595] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4839), 1,
      anon_sym_STAR,
    ACTIONS(4841), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4843), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88655] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4702), 1,
      anon_sym_STAR,
    ACTIONS(4845), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4847), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2917), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88715] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3780), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [88801] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [88885] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 1,
      anon_sym_EQ,
    ACTIONS(3807), 1,
      anon_sym_RBRACK,
    ACTIONS(4083), 1,
      anon_sym_COMMA,
    ACTIONS(3801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3805), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88937] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4836), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [89009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1560), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [89057] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3604), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3871), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89111] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_BANG,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(3977), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      anon_sym_DOT,
    ACTIONS(3983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3279), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1788), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [89209] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [89301] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4849), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3897), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3899), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [89363] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4722), 1,
      anon_sym_STAR,
    ACTIONS(4852), 1,
      anon_sym_async,
    ACTIONS(4854), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2357), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89425] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3780), 1,
      anon_sym_BANG,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [89515] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [89591] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89661] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89733] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4286), 1,
      anon_sym_LBRACK,
    ACTIONS(4630), 1,
      anon_sym_STAR,
    ACTIONS(4632), 1,
      anon_sym_async,
    ACTIONS(4634), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4638), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2448), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89795] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3170), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89853] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3170), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89911] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4630), 1,
      anon_sym_STAR,
    ACTIONS(4858), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4860), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2931), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89971] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3173), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90029] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3173), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90087] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3167), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90145] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 1,
      anon_sym_LBRACK,
    ACTIONS(3790), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3387), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [90197] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3167), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90255] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90353] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4836), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3780), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3782), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [90419] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4839), 1,
      anon_sym_STAR,
    ACTIONS(4862), 1,
      anon_sym_async,
    ACTIONS(4864), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4866), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2464), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90481] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90579] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90677] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90775] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4868), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3926), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3928), 14,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [90843] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90941] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4871), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3886), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3888), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [91005] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_LBRACK,
    ACTIONS(3395), 1,
      anon_sym_DOT,
    ACTIONS(3676), 1,
      anon_sym_as,
    ACTIONS(3680), 1,
      anon_sym_BANG,
    ACTIONS(3686), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4742), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4746), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4748), 1,
      anon_sym_GT_GT,
    ACTIONS(4752), 1,
      anon_sym_AMP,
    ACTIONS(4754), 1,
      anon_sym_CARET,
    ACTIONS(4756), 1,
      anon_sym_PIPE,
    ACTIONS(4760), 1,
      anon_sym_PERCENT,
    ACTIONS(4762), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4770), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4772), 1,
      sym__ternary_qmark,
    STATE(3298), 1,
      sym_type_arguments,
    ACTIONS(3716), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4738), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4740), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4750), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4766), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4764), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 1,
      anon_sym_COMMA,
    ACTIONS(3018), 1,
      anon_sym_RBRACK,
    ACTIONS(3078), 1,
      anon_sym_EQ,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91155] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(4742), 1,
      anon_sym_LT,
    STATE(3298), 1,
      sym_type_arguments,
    STATE(1367), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3848), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3850), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [91211] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    ACTIONS(4675), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4876), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3679), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4009), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(4100), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4874), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91275] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4878), 1,
      anon_sym_STAR,
    ACTIONS(4880), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4882), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2891), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_extends,
    ACTIONS(3787), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3790), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1372), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4884), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4887), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91435] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4616), 1,
      anon_sym_STAR,
    ACTIONS(4890), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4892), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2935), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91495] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3814), 1,
      anon_sym_LBRACK,
    ACTIONS(3817), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3564), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3810), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3914), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4894), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4897), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91595] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3868), 1,
      anon_sym_LBRACK,
    ACTIONS(3871), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3604), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2919), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91647] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(3229), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91707] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4788), 1,
      anon_sym_STAR,
    ACTIONS(4900), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4902), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2893), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      anon_sym_LPAREN,
    STATE(2452), 1,
      sym_arguments,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4904), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4907), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91865] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4780), 1,
      anon_sym_STAR,
    ACTIONS(4910), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4912), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2830), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4914), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4917), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91973] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4822), 1,
      anon_sym_STAR,
    ACTIONS(4920), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4922), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2894), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92033] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4924), 1,
      anon_sym_STAR,
    ACTIONS(4926), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4928), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2913), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92093] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4924), 1,
      anon_sym_STAR,
    ACTIONS(4930), 1,
      anon_sym_async,
    ACTIONS(4932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4934), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2443), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_EQ,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92203] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4936), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2683), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3109), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92258] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4920), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2894), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92313] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2853), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92368] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4816), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2937), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92423] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 1,
      anon_sym_EQ,
    ACTIONS(4087), 1,
      anon_sym_of,
    ACTIONS(4479), 1,
      anon_sym_in,
    ACTIONS(3586), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3590), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92474] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 1,
      anon_sym_EQ,
    ACTIONS(4083), 1,
      anon_sym_of,
    ACTIONS(4410), 1,
      anon_sym_in,
    ACTIONS(3801), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3805), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92525] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4724), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2865), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92580] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4900), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2893), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92635] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4720), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4319), 1,
      sym_regex_flags,
    ACTIONS(4315), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4317), 20,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92747] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92812] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(1894), 1,
      anon_sym_readonly,
    ACTIONS(1898), 1,
      anon_sym_override,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    STATE(2225), 1,
      sym_override_modifier,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92883] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4841), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92938] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4910), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2830), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92993] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2647), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3109), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93048] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 1,
      anon_sym_EQ,
    ACTIONS(4081), 1,
      anon_sym_of,
    ACTIONS(4405), 1,
      anon_sym_in,
    ACTIONS(1296), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1300), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [93099] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4845), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2917), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93154] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1660), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93219] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4880), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2891), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93274] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4890), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2935), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93329] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4943), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93384] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4926), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2913), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93439] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4858), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2931), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 1,
      anon_sym_EQ,
    ACTIONS(2919), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [93541] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4662), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93606] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4810), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2850), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93661] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4949), 1,
      anon_sym_async,
    ACTIONS(4953), 1,
      anon_sym_static,
    ACTIONS(4955), 1,
      anon_sym_readonly,
    ACTIONS(4961), 1,
      anon_sym_override,
    STATE(2198), 1,
      sym_accessibility_modifier,
    STATE(2224), 1,
      sym_override_modifier,
    ACTIONS(4947), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4957), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2772), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3742), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4945), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93738] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4677), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93803] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93868] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4963), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2848), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93923] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4798), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93978] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_EQ,
    ACTIONS(3060), 1,
      anon_sym_in,
    ACTIONS(3063), 1,
      anon_sym_of,
    ACTIONS(2919), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2923), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [94029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94076] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4716), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94141] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4648), 1,
      anon_sym_abstract,
    ACTIONS(4936), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2683), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3109), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(3229), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94247] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94311] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4965), 1,
      anon_sym_readonly,
    STATE(2234), 1,
      sym_override_modifier,
    ACTIONS(4936), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2683), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3109), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94371] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94433] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(1894), 1,
      anon_sym_readonly,
    ACTIONS(1898), 1,
      anon_sym_override,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    STATE(2225), 1,
      sym_override_modifier,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4967), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94501] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4969), 1,
      anon_sym_abstract,
    ACTIONS(4941), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2647), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3109), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94557] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(3229), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94607] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4971), 1,
      anon_sym_readonly,
    STATE(2240), 1,
      sym_override_modifier,
    ACTIONS(4941), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2647), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3109), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94667] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4967), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94728] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94783] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4677), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94838] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4716), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94893] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4720), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94948] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95005] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4716), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95060] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4677), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95115] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1660), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95170] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1660), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95225] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4720), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95280] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4662), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95335] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4973), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2671), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3109), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95388] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4975), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2686), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3109), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95441] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4662), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95496] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4967), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95555] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95610] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95665] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95720] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4967), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95774] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4977), 1,
      anon_sym_LPAREN,
    ACTIONS(4979), 1,
      anon_sym_DOT,
    STATE(2207), 1,
      sym_arguments,
    ACTIONS(3074), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3072), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [95821] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1599), 1,
      anon_sym_namespace,
    ACTIONS(1605), 1,
      anon_sym_import,
    ACTIONS(1607), 1,
      anon_sym_var,
    ACTIONS(1609), 1,
      anon_sym_let,
    ACTIONS(1611), 1,
      anon_sym_const,
    ACTIONS(1622), 1,
      anon_sym_class,
    ACTIONS(1624), 1,
      anon_sym_async,
    ACTIONS(1626), 1,
      anon_sym_function,
    ACTIONS(1630), 1,
      anon_sym_declare,
    ACTIONS(1634), 1,
      anon_sym_abstract,
    ACTIONS(1636), 1,
      anon_sym_interface,
    ACTIONS(1638), 1,
      anon_sym_enum,
    ACTIONS(1732), 1,
      anon_sym_type,
    ACTIONS(1736), 1,
      anon_sym_module,
    ACTIONS(1738), 1,
      anon_sym_global,
    STATE(624), 1,
      sym_internal_module,
    STATE(738), 1,
      sym_declaration,
    STATE(1140), 1,
      sym_decorator,
    STATE(3062), 1,
      aux_sym_export_statement_repeat1,
    STATE(629), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [95900] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1599), 1,
      anon_sym_namespace,
    ACTIONS(1605), 1,
      anon_sym_import,
    ACTIONS(1607), 1,
      anon_sym_var,
    ACTIONS(1609), 1,
      anon_sym_let,
    ACTIONS(1611), 1,
      anon_sym_const,
    ACTIONS(1622), 1,
      anon_sym_class,
    ACTIONS(1624), 1,
      anon_sym_async,
    ACTIONS(1626), 1,
      anon_sym_function,
    ACTIONS(1630), 1,
      anon_sym_declare,
    ACTIONS(1632), 1,
      anon_sym_module,
    ACTIONS(1634), 1,
      anon_sym_abstract,
    ACTIONS(1636), 1,
      anon_sym_interface,
    ACTIONS(1638), 1,
      anon_sym_enum,
    ACTIONS(1732), 1,
      anon_sym_type,
    ACTIONS(4981), 1,
      anon_sym_default,
    STATE(624), 1,
      sym_internal_module,
    STATE(699), 1,
      sym_declaration,
    STATE(1140), 1,
      sym_decorator,
    STATE(3062), 1,
      aux_sym_export_statement_repeat1,
    STATE(629), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [95979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96026] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1898), 1,
      anon_sym_override,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4983), 1,
      anon_sym_STAR,
    ACTIONS(4985), 1,
      anon_sym_async,
    ACTIONS(4989), 1,
      anon_sym_readonly,
    STATE(2216), 1,
      sym_override_modifier,
    ACTIONS(4987), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4991), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2866), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96089] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1599), 1,
      anon_sym_namespace,
    ACTIONS(1605), 1,
      anon_sym_import,
    ACTIONS(1607), 1,
      anon_sym_var,
    ACTIONS(1609), 1,
      anon_sym_let,
    ACTIONS(1611), 1,
      anon_sym_const,
    ACTIONS(1622), 1,
      anon_sym_class,
    ACTIONS(1624), 1,
      anon_sym_async,
    ACTIONS(1626), 1,
      anon_sym_function,
    ACTIONS(1630), 1,
      anon_sym_declare,
    ACTIONS(1632), 1,
      anon_sym_module,
    ACTIONS(1634), 1,
      anon_sym_abstract,
    ACTIONS(1636), 1,
      anon_sym_interface,
    ACTIONS(1638), 1,
      anon_sym_enum,
    ACTIONS(1732), 1,
      anon_sym_type,
    ACTIONS(4993), 1,
      anon_sym_default,
    STATE(624), 1,
      sym_internal_module,
    STATE(699), 1,
      sym_declaration,
    STATE(1140), 1,
      sym_decorator,
    STATE(3062), 1,
      aux_sym_export_statement_repeat1,
    STATE(629), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [96168] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96215] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1900), 1,
      anon_sym_type,
    ACTIONS(1902), 1,
      anon_sym_namespace,
    ACTIONS(1904), 1,
      anon_sym_import,
    ACTIONS(1906), 1,
      anon_sym_var,
    ACTIONS(1908), 1,
      anon_sym_let,
    ACTIONS(1910), 1,
      anon_sym_const,
    ACTIONS(1912), 1,
      anon_sym_class,
    ACTIONS(1914), 1,
      anon_sym_async,
    ACTIONS(1916), 1,
      anon_sym_function,
    ACTIONS(1918), 1,
      anon_sym_declare,
    ACTIONS(1922), 1,
      anon_sym_abstract,
    ACTIONS(1926), 1,
      anon_sym_interface,
    ACTIONS(1928), 1,
      anon_sym_enum,
    ACTIONS(3165), 1,
      anon_sym_module,
    ACTIONS(4995), 1,
      anon_sym_default,
    STATE(1140), 1,
      sym_decorator,
    STATE(3056), 1,
      aux_sym_export_statement_repeat1,
    STATE(3084), 1,
      sym_internal_module,
    STATE(3221), 1,
      sym_declaration,
    STATE(3102), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [96294] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1900), 1,
      anon_sym_type,
    ACTIONS(1902), 1,
      anon_sym_namespace,
    ACTIONS(1904), 1,
      anon_sym_import,
    ACTIONS(1906), 1,
      anon_sym_var,
    ACTIONS(1908), 1,
      anon_sym_let,
    ACTIONS(1910), 1,
      anon_sym_const,
    ACTIONS(1912), 1,
      anon_sym_class,
    ACTIONS(1914), 1,
      anon_sym_async,
    ACTIONS(1916), 1,
      anon_sym_function,
    ACTIONS(1918), 1,
      anon_sym_declare,
    ACTIONS(1920), 1,
      anon_sym_module,
    ACTIONS(1922), 1,
      anon_sym_abstract,
    ACTIONS(1924), 1,
      anon_sym_global,
    ACTIONS(1926), 1,
      anon_sym_interface,
    ACTIONS(1928), 1,
      anon_sym_enum,
    STATE(1140), 1,
      sym_decorator,
    STATE(3056), 1,
      aux_sym_export_statement_repeat1,
    STATE(3084), 1,
      sym_internal_module,
    STATE(3117), 1,
      sym_declaration,
    STATE(3102), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [96373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4999), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4997), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5001), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5005), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5009), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5015), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5013), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5019), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5017), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1398), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1400), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96653] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5021), 1,
      anon_sym_EQ_GT,
    ACTIONS(4987), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2866), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5023), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96745] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5027), 1,
      anon_sym_STAR,
    ACTIONS(5029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5031), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2954), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96799] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5033), 1,
      anon_sym_STAR,
    ACTIONS(5035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5037), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2862), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 1,
      sym__automatic_semicolon,
    ACTIONS(1344), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1346), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3095), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_DOT,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [96935] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4983), 1,
      anon_sym_STAR,
    ACTIONS(4985), 1,
      anon_sym_async,
    ACTIONS(4987), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4991), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2866), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 1,
      sym__automatic_semicolon,
    ACTIONS(1292), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1294), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5047), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5045), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5043), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5051), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5049), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4999), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4997), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5055), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5053), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97195] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5057), 1,
      anon_sym_STAR,
    ACTIONS(5059), 1,
      anon_sym_async,
    ACTIONS(5061), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5063), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5065), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97291] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1562), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1560), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5023), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5071), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5069), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97459] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5057), 1,
      anon_sym_STAR,
    ACTIONS(5061), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5063), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5019), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5017), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5009), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5073), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5065), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5077), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97713] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5033), 1,
      anon_sym_STAR,
    ACTIONS(5081), 1,
      anon_sym_async,
    ACTIONS(5035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5037), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2862), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5015), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5013), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5077), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5055), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5053), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5083), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1344), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1346), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [97969] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4983), 1,
      anon_sym_STAR,
    ACTIONS(4987), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4991), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2866), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98023] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2966), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98072] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4880), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2891), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98121] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4910), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2830), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98170] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4816), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2937), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98219] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2874), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98268] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2890), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98317] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4724), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2865), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98366] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2862), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98415] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4616), 1,
      anon_sym_STAR,
    ACTIONS(4618), 1,
      anon_sym_async,
    ACTIONS(5093), 1,
      anon_sym_static,
    ACTIONS(5095), 1,
      anon_sym_readonly,
    ACTIONS(5097), 1,
      anon_sym_abstract,
    STATE(2228), 1,
      sym_override_modifier,
    ACTIONS(4620), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4624), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98478] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4926), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2913), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98527] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2853), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98576] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4900), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2893), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98625] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4841), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98674] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4798), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98723] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4845), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2917), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98772] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2954), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98821] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4920), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2894), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98870] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4987), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2866), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98919] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5061), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98968] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5099), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2922), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99017] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4810), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2850), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99066] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5101), 1,
      anon_sym_RBRACE,
    STATE(3753), 1,
      sym_enum_assignment,
    ACTIONS(5103), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99116] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(5105), 1,
      anon_sym_static,
    ACTIONS(5107), 1,
      anon_sym_readonly,
    ACTIONS(5109), 1,
      anon_sym_abstract,
    STATE(2234), 1,
      sym_override_modifier,
    ACTIONS(4936), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2683), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99172] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5111), 1,
      anon_sym_RBRACE,
    STATE(3427), 1,
      sym_enum_assignment,
    ACTIONS(5113), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2994), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99222] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(1894), 1,
      anon_sym_readonly,
    ACTIONS(1898), 1,
      anon_sym_override,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(5115), 1,
      anon_sym_static,
    STATE(2225), 1,
      sym_override_modifier,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4154), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5117), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99320] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4031), 1,
      anon_sym_readonly,
    ACTIONS(5119), 1,
      anon_sym_static,
    STATE(2220), 1,
      sym_override_modifier,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99380] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5121), 1,
      anon_sym_RBRACE,
    STATE(3753), 1,
      sym_enum_assignment,
    ACTIONS(5103), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99430] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5123), 1,
      anon_sym_RBRACE,
    STATE(3753), 1,
      sym_enum_assignment,
    ACTIONS(5103), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2506), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99518] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5125), 1,
      anon_sym_RBRACE,
    STATE(3753), 1,
      sym_enum_assignment,
    ACTIONS(5103), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99568] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5127), 1,
      anon_sym_RBRACE,
    STATE(3366), 1,
      sym_enum_assignment,
    ACTIONS(5129), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2995), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99618] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5131), 1,
      anon_sym_RBRACE,
    STATE(3753), 1,
      sym_enum_assignment,
    ACTIONS(5103), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3103), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3101), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99706] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5133), 1,
      anon_sym_RBRACE,
    STATE(3753), 1,
      sym_enum_assignment,
    ACTIONS(5103), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3072), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99794] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5135), 1,
      anon_sym_RBRACE,
    STATE(3753), 1,
      sym_enum_assignment,
    ACTIONS(5103), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2516), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2514), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99882] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3133), 1,
      anon_sym_override,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4630), 1,
      anon_sym_STAR,
    ACTIONS(4632), 1,
      anon_sym_async,
    ACTIONS(4636), 1,
      anon_sym_readonly,
    ACTIONS(5137), 1,
      anon_sym_static,
    STATE(2219), 1,
      sym_override_modifier,
    ACTIONS(4634), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4638), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2448), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2510), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99980] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5139), 1,
      anon_sym_RBRACE,
    STATE(3753), 1,
      sym_enum_assignment,
    ACTIONS(5103), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100030] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4722), 1,
      anon_sym_STAR,
    ACTIONS(4852), 1,
      anon_sym_async,
    ACTIONS(5141), 1,
      anon_sym_readonly,
    ACTIONS(4854), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2357), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100083] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5033), 1,
      anon_sym_STAR,
    ACTIONS(5081), 1,
      anon_sym_async,
    ACTIONS(5143), 1,
      anon_sym_readonly,
    ACTIONS(5035), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5037), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2862), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100136] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(5145), 1,
      anon_sym_STAR,
    ACTIONS(5149), 1,
      anon_sym_readonly,
    ACTIONS(5147), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5151), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100187] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4616), 1,
      anon_sym_STAR,
    ACTIONS(4618), 1,
      anon_sym_async,
    ACTIONS(4622), 1,
      anon_sym_readonly,
    ACTIONS(4620), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4624), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100240] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4694), 1,
      anon_sym_async,
    ACTIONS(4698), 1,
      anon_sym_readonly,
    ACTIONS(4696), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4700), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2455), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100293] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4702), 1,
      anon_sym_STAR,
    ACTIONS(4704), 1,
      anon_sym_async,
    ACTIONS(4708), 1,
      anon_sym_readonly,
    ACTIONS(4706), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4710), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100346] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4839), 1,
      anon_sym_STAR,
    ACTIONS(4862), 1,
      anon_sym_async,
    ACTIONS(5153), 1,
      anon_sym_readonly,
    ACTIONS(4864), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4866), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2464), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100399] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4965), 1,
      anon_sym_readonly,
    ACTIONS(5155), 1,
      anon_sym_STAR,
    ACTIONS(5157), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5159), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2433), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100450] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_STAR,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      anon_sym_async,
    ACTIONS(4031), 1,
      anon_sym_readonly,
    ACTIONS(4029), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100503] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      anon_sym_async,
    ACTIONS(1894), 1,
      anon_sym_readonly,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1896), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100556] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4983), 1,
      anon_sym_STAR,
    ACTIONS(4985), 1,
      anon_sym_async,
    ACTIONS(4989), 1,
      anon_sym_readonly,
    ACTIONS(4987), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4991), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2866), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100609] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4630), 1,
      anon_sym_STAR,
    ACTIONS(4632), 1,
      anon_sym_async,
    ACTIONS(4636), 1,
      anon_sym_readonly,
    ACTIONS(4634), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4638), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2448), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1581), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100701] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4640), 1,
      anon_sym_STAR,
    ACTIONS(4642), 1,
      anon_sym_async,
    ACTIONS(4650), 1,
      anon_sym_readonly,
    ACTIONS(4644), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4646), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100754] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    STATE(3753), 1,
      sym_enum_assignment,
    ACTIONS(5103), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100801] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4822), 1,
      anon_sym_STAR,
    ACTIONS(4824), 1,
      anon_sym_async,
    ACTIONS(5161), 1,
      anon_sym_readonly,
    ACTIONS(4826), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4828), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2454), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100854] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4841), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2828), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100898] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4926), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2913), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100942] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4890), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2935), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100986] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4971), 1,
      anon_sym_readonly,
    ACTIONS(4941), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2647), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101032] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4963), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2848), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101076] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5087), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2966), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101120] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4965), 1,
      anon_sym_readonly,
    ACTIONS(4936), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2683), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101166] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4900), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2893), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101210] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4880), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2891), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101254] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(5163), 1,
      anon_sym_readonly,
    ACTIONS(4973), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2671), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101300] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4920), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2894), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101344] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5091), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2890), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101388] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5061), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101432] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4810), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2850), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101476] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5089), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2874), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101520] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2647), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101564] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4936), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2683), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101608] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4290), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101652] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4816), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2937), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101696] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2853), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101740] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4973), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2671), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3109), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101784] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4798), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101828] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5099), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2922), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101872] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4858), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2931), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101916] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4910), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2830), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101960] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4845), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2917), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102004] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5029), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2954), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4724), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2865), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102092] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(1872), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2901), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102136] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4987), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2866), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102180] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(5035), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2862), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102224] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(4288), 1,
      anon_sym_LBRACK,
    ACTIONS(4943), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1890), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5165), 1,
      sym_identifier,
    STATE(3908), 1,
      sym_mapped_type_clause,
    ACTIONS(5167), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102299] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2979), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2973), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3526), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3409), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102387] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(5169), 1,
      anon_sym_LBRACK,
    ACTIONS(5171), 1,
      anon_sym_DOT,
    ACTIONS(5173), 1,
      anon_sym_QMARK_DOT,
    STATE(2305), 1,
      sym_arguments,
    ACTIONS(3375), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3377), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102423] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    ACTIONS(5175), 1,
      anon_sym_LBRACK,
    ACTIONS(5177), 1,
      anon_sym_DOT,
    ACTIONS(5179), 1,
      anon_sym_QMARK_DOT,
    STATE(2304), 1,
      sym_arguments,
    ACTIONS(3363), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3365), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3496), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3558), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3560), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3530), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3584), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3550), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3514), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3576), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3530), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3534), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3576), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3550), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3584), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3576), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3514), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3628), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3628), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3409), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3628), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3640), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3640), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3640), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3644), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3636), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3652), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3534), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3636), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3534), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3526), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3652), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3486), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3488), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3526), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3514), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103291] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3347), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_is,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2969), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3347), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_DOT,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2969), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103356] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5187), 1,
      anon_sym_LBRACK,
    ACTIONS(5189), 1,
      anon_sym_DOT,
    ACTIONS(5191), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3439), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3441), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3492), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3500), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(3449), 1,
      anon_sym_EQ,
    ACTIONS(3451), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3522), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1364), 1,
      anon_sym_PIPE,
    ACTIONS(1362), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1306), 1,
      anon_sym_PIPE,
    ACTIONS(1304), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [103537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LT,
    STATE(2322), 1,
      sym_type_arguments,
    ACTIONS(3403), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(3437), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_EQ,
    ACTIONS(3510), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_EQ,
    ACTIONS(3480), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3464), 1,
      anon_sym_EQ,
    ACTIONS(3466), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_EQ,
    ACTIONS(3472), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 1,
      anon_sym_EQ,
    ACTIONS(3546), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_EQ,
    ACTIONS(3664), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3614), 1,
      anon_sym_EQ,
    ACTIONS(3616), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 1,
      anon_sym_EQ,
    ACTIONS(1508), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      anon_sym_EQ,
    ACTIONS(3604), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3387), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 1,
      anon_sym_EQ,
    ACTIONS(3648), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 1,
      anon_sym_EQ,
    ACTIONS(3660), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3552), 1,
      anon_sym_EQ,
    ACTIONS(5193), 1,
      anon_sym_LBRACK,
    ACTIONS(3554), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_EQ,
    ACTIONS(3403), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3516), 1,
      anon_sym_EQ,
    ACTIONS(3518), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [103956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5197), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_EQ,
    ACTIONS(3612), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3670), 1,
      anon_sym_EQ,
    ACTIONS(3672), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104023] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3347), 1,
      anon_sym_PIPE,
    ACTIONS(5199), 1,
      anon_sym_LT,
    ACTIONS(5201), 1,
      anon_sym_DOT,
    ACTIONS(5203), 1,
      anon_sym_is,
    STATE(2573), 1,
      sym_type_arguments,
    ACTIONS(2969), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 1,
      anon_sym_EQ,
    ACTIONS(3668), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5205), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3606), 1,
      anon_sym_EQ,
    ACTIONS(5193), 1,
      anon_sym_LBRACK,
    ACTIONS(3554), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3608), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [104125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3415), 1,
      anon_sym_EQ,
    ACTIONS(3417), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5207), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 1,
      anon_sym_EQ,
    ACTIONS(3413), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3562), 1,
      anon_sym_EQ,
    ACTIONS(3564), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104236] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2979), 1,
      anon_sym_PIPE,
    ACTIONS(2993), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_LBRACK,
    ACTIONS(2997), 1,
      anon_sym_DOT,
    ACTIONS(2999), 1,
      anon_sym_QMARK_DOT,
    STATE(2452), 1,
      sym_arguments,
    ACTIONS(2973), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3482), 1,
      anon_sym_EQ,
    ACTIONS(3484), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104292] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      anon_sym_LPAREN,
    ACTIONS(3375), 1,
      anon_sym_PIPE,
    ACTIONS(5211), 1,
      anon_sym_LBRACK,
    ACTIONS(5213), 1,
      anon_sym_DOT,
    ACTIONS(5215), 1,
      anon_sym_QMARK_DOT,
    STATE(2456), 1,
      sym_arguments,
    ACTIONS(3377), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104325] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      anon_sym_LPAREN,
    ACTIONS(3363), 1,
      anon_sym_PIPE,
    ACTIONS(5217), 1,
      anon_sym_LBRACK,
    ACTIONS(5219), 1,
      anon_sym_DOT,
    ACTIONS(5221), 1,
      anon_sym_QMARK_DOT,
    STATE(2457), 1,
      sym_arguments,
    ACTIONS(3365), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3622), 1,
      anon_sym_EQ,
    ACTIONS(5193), 1,
      anon_sym_LBRACK,
    ACTIONS(3624), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5223), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(5185), 1,
      anon_sym_is,
    ACTIONS(3387), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3570), 1,
      anon_sym_EQ,
    ACTIONS(3572), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_EQ,
    ACTIONS(3538), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_EQ,
    ACTIONS(3568), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_PIPE,
    ACTIONS(3640), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104562] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_BANG,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5239), 1,
      anon_sym_QMARK,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2898), 1,
      sym__call_signature,
    STATE(3170), 1,
      sym_type_annotation,
    STATE(3435), 1,
      sym__initializer,
    STATE(3798), 1,
      sym_type_parameters,
    ACTIONS(5231), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104604] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5243), 1,
      anon_sym_BANG,
    ACTIONS(5245), 1,
      anon_sym_QMARK,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2883), 1,
      sym__call_signature,
    STATE(3197), 1,
      sym_type_annotation,
    STATE(3544), 1,
      sym__initializer,
    STATE(3798), 1,
      sym_type_parameters,
    ACTIONS(5241), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104646] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5249), 1,
      sym_number,
    STATE(3970), 1,
      sym_predefined_type,
    STATE(3971), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [104676] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5251), 1,
      sym_number,
    STATE(3964), 1,
      sym_predefined_type,
    STATE(3965), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [104706] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5255), 1,
      anon_sym_BANG,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2841), 1,
      sym__call_signature,
    STATE(3186), 1,
      sym_type_annotation,
    STATE(3560), 1,
      sym__initializer,
    STATE(3798), 1,
      sym_type_parameters,
    ACTIONS(5253), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 1,
      anon_sym_PIPE,
    ACTIONS(3644), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104770] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5259), 1,
      sym_number,
    STATE(3975), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [104798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_PIPE,
    ACTIONS(3640), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3638), 1,
      anon_sym_PIPE,
    ACTIONS(3640), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 1,
      anon_sym_PIPE,
    ACTIONS(3628), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 1,
      anon_sym_PIPE,
    ACTIONS(3628), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3626), 1,
      anon_sym_PIPE,
    ACTIONS(3628), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 1,
      anon_sym_PIPE,
    ACTIONS(3576), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 1,
      anon_sym_PIPE,
    ACTIONS(3576), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 1,
      anon_sym_PIPE,
    ACTIONS(3576), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [104974] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5261), 1,
      sym_number,
    STATE(4117), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105002] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5263), 1,
      sym_number,
    STATE(4110), 1,
      sym_string,
    STATE(4118), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105032] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5265), 1,
      sym_number,
    STATE(3957), 1,
      sym_predefined_type,
    STATE(3961), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105062] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5267), 1,
      sym_number,
    STATE(4098), 1,
      sym_predefined_type,
    STATE(4102), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3558), 1,
      anon_sym_PIPE,
    ACTIONS(3560), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_PIPE,
    ACTIONS(3534), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_PIPE,
    ACTIONS(3534), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_PIPE,
    ACTIONS(3534), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 1,
      anon_sym_PIPE,
    ACTIONS(3526), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 1,
      anon_sym_PIPE,
    ACTIONS(3526), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 1,
      anon_sym_PIPE,
    ACTIONS(3526), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_PIPE,
    ACTIONS(3514), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_PIPE,
    ACTIONS(3514), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_PIPE,
    ACTIONS(3514), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105312] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5269), 1,
      sym_number,
    STATE(4085), 1,
      sym_string,
    STATE(4086), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105342] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5271), 1,
      sym_number,
    STATE(3909), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105370] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5273), 1,
      sym_number,
    STATE(4075), 1,
      sym_string,
    STATE(4076), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5275), 1,
      sym_number,
    STATE(3942), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105428] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5277), 1,
      sym_number,
    STATE(3934), 1,
      sym_predefined_type,
    STATE(3938), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105458] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5279), 1,
      sym_number,
    STATE(4070), 1,
      sym_string,
    STATE(4071), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105488] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5281), 1,
      sym_number,
    STATE(3927), 1,
      sym_predefined_type,
    STATE(3929), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105518] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5283), 1,
      sym_number,
    STATE(3924), 1,
      sym_predefined_type,
    STATE(3925), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105548] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5285), 1,
      sym_number,
    STATE(4065), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105576] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5287), 1,
      sym_number,
    STATE(3911), 1,
      sym_string,
    STATE(3913), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105606] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5291), 1,
      anon_sym_BANG,
    ACTIONS(5293), 1,
      anon_sym_QMARK,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2967), 1,
      sym__call_signature,
    STATE(3127), 1,
      sym_type_annotation,
    STATE(3595), 1,
      sym__initializer,
    STATE(3798), 1,
      sym_type_parameters,
    ACTIONS(5289), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105648] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5295), 1,
      sym_number,
    STATE(3917), 1,
      sym_string,
    STATE(3918), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105678] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5297), 1,
      sym_number,
    STATE(4061), 1,
      sym_string,
    STATE(4063), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3540), 1,
      anon_sym_EQ,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(3542), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [105732] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5301), 1,
      sym_number,
    STATE(4043), 1,
      sym_string,
    STATE(4046), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3456), 1,
      anon_sym_EQ,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(3458), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
  [105788] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5305), 1,
      sym_number,
    STATE(4034), 1,
      sym_string,
    STATE(4037), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105818] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5307), 1,
      sym_number,
    STATE(4031), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105846] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5309), 1,
      sym_number,
    STATE(4090), 1,
      sym_predefined_type,
    STATE(4091), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105876] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5311), 1,
      sym_number,
    STATE(3904), 1,
      sym_predefined_type,
    STATE(3921), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105906] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3347), 1,
      anon_sym_PIPE,
    ACTIONS(5199), 1,
      anon_sym_LT,
    ACTIONS(5201), 1,
      anon_sym_DOT,
    STATE(2573), 1,
      sym_type_arguments,
    ACTIONS(2969), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105934] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5313), 1,
      sym_number,
    STATE(3991), 1,
      sym_string,
    STATE(4109), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105964] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5315), 1,
      sym_number,
    STATE(3986), 1,
      sym_string,
    STATE(3988), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [105994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3578), 1,
      anon_sym_EQ,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(3580), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [106022] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5319), 1,
      sym_number,
    STATE(3982), 1,
      sym_string,
    STATE(3983), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106052] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5321), 1,
      sym_number,
    STATE(3980), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106080] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5323), 1,
      sym_number,
    STATE(3977), 1,
      sym_string,
    STATE(3978), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106110] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_EQ,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(3600), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [106138] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5325), 1,
      sym_number,
    STATE(3949), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 1,
      anon_sym_PIPE,
    ACTIONS(3652), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 1,
      anon_sym_PIPE,
    ACTIONS(3636), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106210] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5327), 1,
      sym_number,
    STATE(3864), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 1,
      anon_sym_PIPE,
    ACTIONS(3652), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 1,
      anon_sym_PIPE,
    ACTIONS(3636), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 1,
      anon_sym_PIPE,
    ACTIONS(3409), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_PIPE,
    ACTIONS(3584), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106326] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5329), 1,
      sym_number,
    STATE(3868), 1,
      sym_string,
    STATE(3874), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 1,
      anon_sym_PIPE,
    ACTIONS(3409), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_PIPE,
    ACTIONS(3584), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 1,
      anon_sym_EQ,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(3660), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [106428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    ACTIONS(3550), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    ACTIONS(3550), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 1,
      anon_sym_PIPE,
    ACTIONS(3530), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106516] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5331), 1,
      sym_number,
    STATE(3878), 1,
      sym_string,
    STATE(3879), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106546] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5335), 1,
      anon_sym_BANG,
    ACTIONS(5337), 1,
      anon_sym_QMARK,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2875), 1,
      sym__call_signature,
    STATE(3091), 1,
      sym_type_annotation,
    STATE(3381), 1,
      sym__initializer,
    STATE(3798), 1,
      sym_type_parameters,
    ACTIONS(5333), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3486), 1,
      anon_sym_PIPE,
    ACTIONS(3488), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106632] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5339), 1,
      sym_number,
    STATE(3887), 1,
      sym_string,
    STATE(3894), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106662] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3464), 1,
      anon_sym_EQ,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(3466), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [106690] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5341), 1,
      sym_number,
    STATE(3953), 1,
      sym_string,
    STATE(3956), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106720] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5335), 1,
      anon_sym_BANG,
    ACTIONS(5343), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3091), 1,
      sym_type_annotation,
    STATE(3408), 1,
      sym__call_signature,
    STATE(3411), 1,
      sym__initializer,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5333), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 1,
      anon_sym_EQ,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(3476), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106786] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5233), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5345), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3170), 1,
      sym_type_annotation,
    STATE(3367), 1,
      sym__initializer,
    STATE(3450), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5231), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106828] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5347), 1,
      sym_number,
    STATE(3858), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106856] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5349), 1,
      sym_number,
    STATE(3969), 1,
      sym_predefined_type,
    STATE(3992), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106886] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5351), 1,
      sym_number,
    STATE(3854), 1,
      sym_predefined_type,
    STATE(3855), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106916] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5353), 1,
      sym_number,
    STATE(3851), 1,
      sym_predefined_type,
    STATE(3852), 1,
      sym_string,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106946] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5355), 1,
      sym_number,
    STATE(3849), 1,
      sym_string,
    STATE(3859), 1,
      sym_predefined_type,
    ACTIONS(5247), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106976] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5359), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2779), 1,
      sym__call_signature,
    STATE(3138), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5357), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107011] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PIPE,
    ACTIONS(5199), 1,
      anon_sym_LT,
    STATE(2533), 1,
      sym_type_arguments,
    ACTIONS(3403), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107036] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5363), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3240), 1,
      sym__call_signature,
    STATE(3243), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5361), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107071] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5367), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_DOT,
    ACTIONS(5371), 1,
      anon_sym_QMARK_DOT,
    STATE(2559), 1,
      sym_arguments,
    ACTIONS(3365), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107100] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5373), 1,
      anon_sym_LBRACK,
    ACTIONS(5375), 1,
      anon_sym_DOT,
    ACTIONS(5377), 1,
      anon_sym_QMARK_DOT,
    STATE(2563), 1,
      sym_arguments,
    ACTIONS(3377), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107129] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5181), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_DOT,
    ACTIONS(5379), 1,
      anon_sym_EQ,
    ACTIONS(5384), 1,
      anon_sym_COLON,
    ACTIONS(5386), 1,
      anon_sym_extends,
    STATE(2341), 1,
      sym_type_arguments,
    STATE(3322), 1,
      sym_constraint,
    STATE(3674), 1,
      sym_default_type,
    ACTIONS(5381), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(2969), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [107166] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5389), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_DOT,
    ACTIONS(5393), 1,
      anon_sym_QMARK_DOT,
    STATE(2565), 1,
      sym_arguments,
    ACTIONS(2973), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107195] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5397), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3155), 1,
      sym_type_annotation,
    STATE(3156), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5395), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107230] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5401), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3064), 1,
      sym__call_signature,
    STATE(3071), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5399), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5403), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_DOT,
    ACTIONS(5407), 1,
      anon_sym_is,
    STATE(2637), 1,
      sym_type_arguments,
    ACTIONS(2969), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_LBRACK,
    ACTIONS(5411), 1,
      anon_sym_DOT,
    ACTIONS(5413), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3441), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_PIPE,
    ACTIONS(3522), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(2512), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107361] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5417), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2763), 1,
      sym__call_signature,
    STATE(3058), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5415), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107396] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3138), 1,
      sym_type_annotation,
    STATE(3142), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5357), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_PIPE,
    ACTIONS(3500), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 1,
      anon_sym_PIPE,
    ACTIONS(3492), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107494] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5421), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2791), 1,
      sym__call_signature,
    STATE(3155), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5395), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107529] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5423), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2778), 1,
      sym__call_signature,
    STATE(3243), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5361), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(3449), 1,
      anon_sym_PIPE,
    ACTIONS(3451), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107587] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5425), 1,
      anon_sym_COLON,
    ACTIONS(5427), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2758), 1,
      sym__call_signature,
    STATE(3071), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5399), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2506), 1,
      anon_sym_PIPE,
    ACTIONS(2508), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107643] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5429), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3052), 1,
      sym__call_signature,
    STATE(3058), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5415), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3576), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3514), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107714] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2870), 1,
      sym__call_signature,
    STATE(3187), 1,
      sym_type_annotation,
    STATE(3505), 1,
      sym__initializer,
    STATE(3798), 1,
      sym_type_parameters,
    ACTIONS(5431), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3584), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107786] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    ACTIONS(5181), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_DOT,
    ACTIONS(5433), 1,
      anon_sym_QMARK,
    STATE(2341), 1,
      sym_type_arguments,
    STATE(3838), 1,
      sym_type_annotation,
    ACTIONS(2969), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3584), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3550), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3530), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3550), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3530), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3496), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107942] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2928), 1,
      sym__call_signature,
    STATE(3082), 1,
      sym_type_annotation,
    STATE(3474), 1,
      sym__initializer,
    STATE(3798), 1,
      sym_type_parameters,
    ACTIONS(5436), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3488), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107996] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3135), 1,
      sym_type_annotation,
    STATE(3137), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5438), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108028] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3173), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [108056] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3238), 1,
      sym__call_signature,
    STATE(3239), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5440), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_PIPE,
    ACTIONS(5203), 1,
      anon_sym_is,
    ACTIONS(3387), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3636), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3644), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108182] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3157), 1,
      sym_type_annotation,
    STATE(3576), 1,
      sym__call_signature,
    STATE(3577), 1,
      sym__initializer,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5442), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3640), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3640), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3640), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3628), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3628), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3628), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3576), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3576), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108362] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2789), 1,
      sym__call_signature,
    STATE(3115), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5444), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108394] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5403), 1,
      anon_sym_LT,
    ACTIONS(5405), 1,
      anon_sym_DOT,
    STATE(2637), 1,
      sym_type_arguments,
    ACTIONS(2969), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108418] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3044), 1,
      sym__call_signature,
    STATE(3045), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5446), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108450] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2759), 1,
      sym__call_signature,
    STATE(3045), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5446), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108482] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3094), 1,
      sym__call_signature,
    STATE(3122), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5448), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108514] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3170), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [108542] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3167), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [108570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3560), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3534), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108606] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2885), 1,
      sym__call_signature,
    STATE(3089), 1,
      sym_type_annotation,
    STATE(3383), 1,
      sym__initializer,
    STATE(3798), 1,
      sym_type_parameters,
    ACTIONS(5450), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108642] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3000), 1,
      sym__call_signature,
    STATE(3115), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5444), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3534), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3636), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108710] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2783), 1,
      sym__call_signature,
    STATE(3122), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5448), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108742] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2958), 1,
      sym__call_signature,
    STATE(3252), 1,
      sym_type_annotation,
    STATE(3593), 1,
      sym__initializer,
    STATE(3798), 1,
      sym_type_parameters,
    ACTIONS(5452), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108778] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3089), 1,
      sym_type_annotation,
    STATE(3390), 1,
      sym__call_signature,
    STATE(3398), 1,
      sym__initializer,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5450), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108814] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [108842] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2777), 1,
      sym__call_signature,
    STATE(3239), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5440), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108874] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2825), 1,
      sym__call_signature,
    STATE(3157), 1,
      sym_type_annotation,
    STATE(3543), 1,
      sym__initializer,
    STATE(3798), 1,
      sym_type_parameters,
    ACTIONS(5442), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3534), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108928] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2713), 1,
      sym__call_signature,
    STATE(3135), 1,
      sym_type_annotation,
    STATE(3652), 1,
      sym_type_parameters,
    ACTIONS(5438), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108978] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3160), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [109006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3514), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3514), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 1,
      anon_sym_PIPE,
    ACTIONS(3660), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_PIPE,
    ACTIONS(2588), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_PIPE,
    ACTIONS(1934), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 1,
      anon_sym_PIPE,
    ACTIONS(1508), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      anon_sym_PIPE,
    ACTIONS(3604), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_PIPE,
    ACTIONS(3387), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109192] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3552), 1,
      anon_sym_PIPE,
    ACTIONS(5454), 1,
      anon_sym_LBRACK,
    ACTIONS(3554), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 1,
      anon_sym_PIPE,
    ACTIONS(2780), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1932), 1,
      anon_sym_PIPE,
    ACTIONS(1930), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 1,
      anon_sym_PIPE,
    ACTIONS(3648), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5403), 1,
      anon_sym_LT,
    STATE(2632), 1,
      sym_type_arguments,
    ACTIONS(3403), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_PIPE,
    ACTIONS(3538), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_PIPE,
    ACTIONS(3403), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [109346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_PIPE,
    ACTIONS(3568), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3570), 1,
      anon_sym_PIPE,
    ACTIONS(3572), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3516), 1,
      anon_sym_PIPE,
    ACTIONS(3518), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3622), 1,
      anon_sym_PIPE,
    ACTIONS(5454), 1,
      anon_sym_LBRACK,
    ACTIONS(3624), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1948), 1,
      anon_sym_PIPE,
    ACTIONS(1946), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_PIPE,
    ACTIONS(3480), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3610), 1,
      anon_sym_PIPE,
    ACTIONS(3612), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5458), 1,
      anon_sym_PIPE,
    ACTIONS(3458), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3670), 1,
      anon_sym_PIPE,
    ACTIONS(3672), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3614), 1,
      anon_sym_PIPE,
    ACTIONS(3616), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 1,
      anon_sym_PIPE,
    ACTIONS(3668), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_PIPE,
    ACTIONS(1938), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [109612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 1,
      anon_sym_PIPE,
    ACTIONS(2800), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1944), 1,
      anon_sym_PIPE,
    ACTIONS(1942), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5458), 1,
      anon_sym_PIPE,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(3600), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [109673] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 1,
      anon_sym_LBRACK,
    ACTIONS(5464), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3441), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3552), 1,
      anon_sym_PIPE,
    ACTIONS(5454), 1,
      anon_sym_LBRACK,
    ACTIONS(3554), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(3608), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(3451), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 1,
      anon_sym_PIPE,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(3476), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3492), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3413), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5458), 1,
      anon_sym_PIPE,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(3660), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [109818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3415), 1,
      anon_sym_PIPE,
    ACTIONS(3417), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_PIPE,
    ACTIONS(3510), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3522), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_PIPE,
    ACTIONS(3437), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5458), 1,
      anon_sym_PIPE,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(3466), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [109932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_PIPE,
    ACTIONS(3664), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3464), 1,
      anon_sym_PIPE,
    ACTIONS(3466), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5458), 1,
      anon_sym_PIPE,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(3580), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [109993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2516), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3540), 1,
      anon_sym_PIPE,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(3542), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3482), 1,
      anon_sym_PIPE,
    ACTIONS(3484), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_PIPE,
    ACTIONS(3472), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3562), 1,
      anon_sym_PIPE,
    ACTIONS(3564), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3544), 1,
      anon_sym_PIPE,
    ACTIONS(3546), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(3229), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3163), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [110144] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5468), 1,
      sym_identifier,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_extends,
    ACTIONS(5474), 1,
      anon_sym_implements,
    STATE(1882), 1,
      sym_class_body,
    STATE(2718), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3721), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110178] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5478), 1,
      anon_sym_BANG,
    STATE(3185), 1,
      sym_type_annotation,
    STATE(3561), 1,
      sym__initializer,
    ACTIONS(5480), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5476), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110206] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(3191), 1,
      anon_sym_LBRACE,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5484), 1,
      anon_sym_STAR,
    STATE(3597), 1,
      sym_string,
    STATE(3704), 1,
      sym_import_require_clause,
    STATE(3732), 1,
      sym_import_clause,
    STATE(3861), 2,
      sym_namespace_import_export,
      sym_named_imports,
  [110238] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5478), 1,
      anon_sym_BANG,
    ACTIONS(5486), 1,
      anon_sym_EQ,
    STATE(3177), 1,
      sym__initializer,
    STATE(3185), 1,
      sym_type_annotation,
    ACTIONS(5480), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5476), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110266] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_extends,
    ACTIONS(5474), 1,
      anon_sym_implements,
    ACTIONS(5488), 1,
      sym_identifier,
    STATE(1728), 1,
      sym_class_body,
    STATE(2811), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3676), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110300] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_extends,
    ACTIONS(5474), 1,
      anon_sym_implements,
    ACTIONS(5490), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(1375), 1,
      sym_class_body,
    STATE(2740), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3719), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110334] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_extends,
    ACTIONS(5474), 1,
      anon_sym_implements,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    ACTIONS(5494), 1,
      sym_identifier,
    STATE(1387), 1,
      sym_class_body,
    STATE(2794), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3684), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110368] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_DOT,
    ACTIONS(5496), 1,
      anon_sym_LT,
    ACTIONS(5498), 1,
      anon_sym_is,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2969), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110392] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_extends,
    ACTIONS(5474), 1,
      anon_sym_implements,
    ACTIONS(5500), 1,
      sym_identifier,
    STATE(1728), 1,
      sym_class_body,
    STATE(2811), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3676), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110426] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5169), 1,
      anon_sym_LBRACK,
    ACTIONS(5171), 1,
      anon_sym_DOT,
    ACTIONS(5173), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5502), 1,
      anon_sym_LPAREN,
    STATE(2305), 1,
      sym_arguments,
    ACTIONS(3377), 5,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_COLON,
    STATE(2930), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5504), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110472] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_extends,
    ACTIONS(5474), 1,
      anon_sym_implements,
    ACTIONS(5508), 1,
      sym_identifier,
    STATE(1882), 1,
      sym_class_body,
    STATE(2718), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3721), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110506] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5458), 1,
      anon_sym_PIPE,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(5510), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110528] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_extends,
    ACTIONS(5474), 1,
      anon_sym_implements,
    ACTIONS(5512), 1,
      sym_identifier,
    STATE(1882), 1,
      sym_class_body,
    STATE(2718), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3721), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_COLON,
    STATE(2839), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5514), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110582] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_DOT,
    ACTIONS(2983), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5502), 1,
      anon_sym_LPAREN,
    STATE(2307), 1,
      sym_arguments,
    ACTIONS(2973), 5,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110608] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_extends,
    ACTIONS(5474), 1,
      anon_sym_implements,
    ACTIONS(5516), 1,
      sym_identifier,
    STATE(1728), 1,
      sym_class_body,
    STATE(2811), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3676), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5407), 1,
      anon_sym_is,
    ACTIONS(3387), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110660] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5472), 1,
      anon_sym_extends,
    ACTIONS(5474), 1,
      anon_sym_implements,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    ACTIONS(5518), 1,
      sym_identifier,
    STATE(2005), 1,
      sym_class_body,
    STATE(2715), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3755), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110694] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_extends,
    ACTIONS(5474), 1,
      anon_sym_implements,
    ACTIONS(5520), 1,
      sym_identifier,
    STATE(1728), 1,
      sym_class_body,
    STATE(2811), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3676), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110728] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5175), 1,
      anon_sym_LBRACK,
    ACTIONS(5177), 1,
      anon_sym_DOT,
    ACTIONS(5179), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5502), 1,
      anon_sym_LPAREN,
    STATE(2304), 1,
      sym_arguments,
    ACTIONS(3365), 5,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110754] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5472), 1,
      anon_sym_extends,
    ACTIONS(5474), 1,
      anon_sym_implements,
    ACTIONS(5522), 1,
      sym_identifier,
    STATE(1882), 1,
      sym_class_body,
    STATE(2718), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3721), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110788] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1718), 1,
      sym_class_body,
    STATE(2753), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3840), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_AMP,
    ACTIONS(3476), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [110851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3480), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110866] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(2721), 1,
      sym_type_parameters,
    STATE(3193), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3762), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110897] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1863), 1,
      sym_class_body,
    STATE(2726), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3763), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110928] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1314), 1,
      sym_class_body,
    STATE(2736), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3771), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [110959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1930), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110974] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1800), 1,
      sym_class_body,
    STATE(2802), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3628), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [111005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3413), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111035] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(2733), 1,
      sym_type_parameters,
    STATE(3159), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3766), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [111066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1946), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_AMP,
    ACTIONS(5532), 1,
      anon_sym_PIPE,
    ACTIONS(5534), 1,
      anon_sym_extends,
    ACTIONS(3466), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [111117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 1,
      anon_sym_LBRACE,
    ACTIONS(2780), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [111149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5536), 1,
      anon_sym_LBRACK,
    ACTIONS(3554), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111166] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5486), 1,
      anon_sym_EQ,
    STATE(3178), 1,
      sym__initializer,
    STATE(3185), 1,
      sym_type_annotation,
    ACTIONS(5480), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5476), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111191] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3185), 1,
      sym_type_annotation,
    STATE(3572), 1,
      sym__initializer,
    ACTIONS(5480), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5476), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3668), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3672), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111246] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1964), 1,
      sym_class_body,
    STATE(2723), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3607), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [111277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_LBRACE,
    ACTIONS(2588), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [111294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3664), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_AMP,
    ACTIONS(5532), 1,
      anon_sym_PIPE,
    ACTIONS(5534), 1,
      anon_sym_extends,
    ACTIONS(3660), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [111330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3660), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111345] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(2749), 1,
      sym_type_parameters,
    STATE(3042), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3780), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [111376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [111391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1942), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 1,
      anon_sym_LBRACE,
    ACTIONS(2800), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [111423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5536), 1,
      anon_sym_LBRACK,
    ACTIONS(3624), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3612), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5536), 1,
      anon_sym_LBRACK,
    ACTIONS(3554), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3608), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_AMP,
    ACTIONS(5532), 1,
      anon_sym_PIPE,
    ACTIONS(5534), 1,
      anon_sym_extends,
    ACTIONS(3580), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [111510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3484), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3546), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_AMP,
    ACTIONS(3542), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [111572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3572), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3568), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1934), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3538), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3510), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1938), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111662] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3186), 1,
      sym_type_annotation,
    STATE(3564), 1,
      sym__initializer,
    ACTIONS(5255), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5253), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111687] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4720), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [111712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3518), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111742] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5540), 1,
      anon_sym_LBRACE,
    STATE(121), 1,
      sym_class_body,
    STATE(2810), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3645), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [111773] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1822), 1,
      sym_class_body,
    STATE(2754), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3713), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [111804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3604), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_AMP,
    ACTIONS(5532), 1,
      anon_sym_PIPE,
    ACTIONS(3458), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [111853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3472), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1362), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5542), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [111913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5544), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [111928] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5546), 1,
      anon_sym_LBRACE,
    STATE(617), 1,
      sym_class_body,
    STATE(2745), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3731), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [111959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4716), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [111984] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1660), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3499), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [112009] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1603), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [112034] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1693), 1,
      sym_class_body,
    STATE(2784), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3826), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [112065] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1399), 1,
      sym_class_body,
    STATE(2731), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3728), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [112096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5548), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [112111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5550), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [112126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5552), 1,
      anon_sym_COLON,
    STATE(3253), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5504), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_DOT,
    ACTIONS(5496), 1,
      anon_sym_LT,
    STATE(2341), 1,
      sym_type_arguments,
    ACTIONS(2969), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112166] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3127), 1,
      sym_type_annotation,
    STATE(3487), 1,
      sym__initializer,
    ACTIONS(5291), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5289), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5552), 1,
      anon_sym_COLON,
    STATE(3214), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5514), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112210] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(2737), 1,
      sym_type_parameters,
    STATE(3226), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3725), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [112241] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(605), 1,
      sym_class_body,
    STATE(2746), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3669), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [112272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112302] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(608), 1,
      sym_class_body,
    STATE(2814), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3693), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [112333] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(5554), 1,
      anon_sym_EQ,
    ACTIONS(5510), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [112356] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4662), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [112381] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3170), 1,
      sym_type_annotation,
    STATE(3590), 1,
      sym__initializer,
    ACTIONS(5233), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5231), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112406] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_AMP,
    ACTIONS(5532), 1,
      anon_sym_PIPE,
    ACTIONS(5534), 1,
      anon_sym_extends,
    ACTIONS(3600), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [112427] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1876), 1,
      sym_class_body,
    STATE(2760), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3707), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [112458] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3091), 1,
      sym_type_annotation,
    STATE(3385), 1,
      sym__initializer,
    ACTIONS(5335), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5333), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112483] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5540), 1,
      anon_sym_LBRACE,
    STATE(135), 1,
      sym_class_body,
    STATE(2714), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3695), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [112514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112529] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3034), 1,
      sym_type_annotation,
    STATE(3485), 1,
      sym__initializer,
    ACTIONS(5558), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5556), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112554] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4677), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [112579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112594] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3523), 1,
      aux_sym_object_repeat1,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [112619] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5546), 1,
      anon_sym_LBRACE,
    STATE(675), 1,
      sym_class_body,
    STATE(2711), 1,
      sym_type_parameters,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3810), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [112650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_AMP,
    ACTIONS(5532), 1,
      anon_sym_PIPE,
    ACTIONS(5534), 1,
      anon_sym_extends,
    ACTIONS(5510), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112670] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      sym_identifier,
    ACTIONS(5562), 1,
      anon_sym_LBRACE,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5566), 1,
      anon_sym_enum,
    STATE(3337), 1,
      sym_variable_declarator,
    STATE(2742), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [112694] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 1,
      sym_escape_sequence,
    ACTIONS(5570), 1,
      anon_sym_BQUOTE,
    ACTIONS(5572), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5574), 1,
      sym__template_chars,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3218), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112718] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 1,
      sym_escape_sequence,
    ACTIONS(5572), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5574), 1,
      sym__template_chars,
    ACTIONS(5576), 1,
      anon_sym_BQUOTE,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3218), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112742] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5574), 1,
      sym__template_chars,
    ACTIONS(5578), 1,
      sym_escape_sequence,
    ACTIONS(5580), 1,
      anon_sym_BQUOTE,
    STATE(2980), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3218), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112766] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 1,
      sym_escape_sequence,
    ACTIONS(5572), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5574), 1,
      sym__template_chars,
    ACTIONS(5582), 1,
      anon_sym_BQUOTE,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3172), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112790] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 1,
      sym_identifier,
    ACTIONS(5562), 1,
      anon_sym_LBRACE,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5584), 1,
      anon_sym_enum,
    STATE(3284), 1,
      sym_variable_declarator,
    STATE(2742), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [112814] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(4212), 1,
      anon_sym_COMMA,
    STATE(3297), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5586), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    STATE(1354), 2,
      sym_template_string,
      sym_arguments,
  [112838] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 1,
      sym_escape_sequence,
    ACTIONS(5572), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5574), 1,
      sym__template_chars,
    ACTIONS(5588), 1,
      anon_sym_BQUOTE,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3218), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112862] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5478), 1,
      anon_sym_BANG,
    STATE(3185), 1,
      sym_type_annotation,
    STATE(3561), 1,
      sym__initializer,
    ACTIONS(5476), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112886] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 1,
      sym_escape_sequence,
    ACTIONS(5572), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5574), 1,
      sym__template_chars,
    ACTIONS(5590), 1,
      anon_sym_BQUOTE,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3218), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2516), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112924] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 1,
      sym_escape_sequence,
    ACTIONS(5572), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5574), 1,
      sym__template_chars,
    ACTIONS(5592), 1,
      anon_sym_BQUOTE,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3218), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [112948] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    ACTIONS(5596), 1,
      anon_sym_DOT,
    STATE(3105), 1,
      sym_statement_block,
    ACTIONS(1284), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5496), 1,
      anon_sym_LT,
    STATE(2322), 1,
      sym_type_arguments,
    ACTIONS(3403), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113000] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5574), 1,
      sym__template_chars,
    ACTIONS(5578), 1,
      sym_escape_sequence,
    ACTIONS(5598), 1,
      anon_sym_BQUOTE,
    STATE(2980), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3218), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [113024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5458), 1,
      anon_sym_PIPE,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(5600), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5458), 1,
      anon_sym_PIPE,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(5602), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113078] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5546), 1,
      anon_sym_LBRACE,
    STATE(647), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3748), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_LBRACE,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5604), 1,
      sym_identifier,
    STATE(3280), 1,
      sym_variable_declarator,
    STATE(2742), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [113124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3611), 1,
      sym_statement_block,
    ACTIONS(5606), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113141] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5540), 1,
      anon_sym_LBRACE,
    STATE(137), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3806), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113166] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1982), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3604), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113191] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    ACTIONS(5181), 1,
      anon_sym_LT,
    ACTIONS(5608), 1,
      sym_identifier,
    ACTIONS(5610), 1,
      anon_sym_LBRACK,
    ACTIONS(5612), 1,
      sym_private_property_identifier,
    STATE(1720), 1,
      sym_arguments,
    STATE(3648), 1,
      sym_type_arguments,
  [113216] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5614), 1,
      sym_identifier,
    ACTIONS(5616), 1,
      anon_sym_STAR,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3616), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [113241] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1691), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3609), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113266] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(5620), 1,
      anon_sym_LT,
    ACTIONS(5622), 1,
      anon_sym_extends,
    STATE(650), 1,
      sym_object_type,
    STATE(3061), 1,
      sym_type_parameters,
    STATE(3379), 1,
      sym_extends_type_clause,
  [113291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5624), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [113304] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3065), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3778), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113329] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3082), 1,
      sym_type_annotation,
    STATE(3501), 1,
      sym__initializer,
    ACTIONS(5436), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113350] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(2057), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3835), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3819), 1,
      sym_statement_block,
    ACTIONS(5626), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3817), 1,
      sym_statement_block,
    ACTIONS(5606), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113409] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1810), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3779), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113434] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    ACTIONS(5628), 1,
      anon_sym_EQ,
    ACTIONS(5632), 1,
      anon_sym_QMARK,
    STATE(3342), 1,
      sym_type_annotation,
    STATE(3638), 1,
      sym__initializer,
    ACTIONS(5630), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [113457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [113470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [113483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3639), 1,
      sym_statement_block,
    ACTIONS(5634), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113500] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1358), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3767), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5636), 1,
      anon_sym_EQ,
    ACTIONS(3008), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [113540] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3037), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3786), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5542), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [113578] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5496), 1,
      anon_sym_LT,
    ACTIONS(5639), 1,
      anon_sym_LBRACE,
    ACTIONS(5641), 1,
      anon_sym_COMMA,
    ACTIONS(5643), 1,
      anon_sym_DOT,
    ACTIONS(5645), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3276), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3526), 1,
      sym_type_arguments,
  [113603] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1386), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3788), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113628] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3160), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3765), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5647), 1,
      anon_sym_EQ,
    ACTIONS(3014), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [113668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5550), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [113681] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1395), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3764), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [113719] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3185), 1,
      sym_type_annotation,
    STATE(3572), 1,
      sym__initializer,
    ACTIONS(5476), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3740), 1,
      sym_statement_block,
    ACTIONS(5649), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113757] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    STATE(1354), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5651), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [113776] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5546), 1,
      anon_sym_LBRACE,
    STATE(695), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3800), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113801] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(600), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3816), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113826] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_LBRACE,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5653), 1,
      sym_identifier,
    STATE(3280), 1,
      sym_variable_declarator,
    STATE(2619), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [113847] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5655), 1,
      sym_identifier,
    ACTIONS(5657), 1,
      anon_sym_STAR,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3616), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [113872] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3027), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3793), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_LBRACE,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5659), 1,
      sym_identifier,
    STATE(3337), 1,
      sym_variable_declarator,
    STATE(2620), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [113918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [113935] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3026), 1,
      sym_type_annotation,
    STATE(3420), 1,
      sym__initializer,
    ACTIONS(5661), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113956] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1735), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3845), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [113981] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1807), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3646), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [114006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_EQ,
    ACTIONS(3008), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [114034] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5666), 1,
      sym_identifier,
    ACTIONS(5668), 1,
      anon_sym_STAR,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3709), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [114059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3712), 1,
      sym_statement_block,
    ACTIONS(5670), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3606), 1,
      sym_statement_block,
    ACTIONS(5672), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114093] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1805), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3756), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [114118] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5674), 1,
      sym_identifier,
    ACTIONS(5676), 1,
      anon_sym_STAR,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3705), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [114143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3187), 1,
      sym_type_annotation,
    STATE(3493), 1,
      sym__initializer,
    ACTIONS(5431), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3603), 1,
      sym_statement_block,
    ACTIONS(5649), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114181] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5379), 1,
      anon_sym_EQ,
    STATE(3322), 1,
      sym_constraint,
    STATE(3674), 1,
      sym_default_type,
    ACTIONS(5384), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5678), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [114202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [114215] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5680), 1,
      sym_identifier,
    ACTIONS(5682), 1,
      anon_sym_STAR,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3705), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [114240] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5684), 1,
      sym_identifier,
    ACTIONS(5686), 1,
      anon_sym_STAR,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3705), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [114265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_LBRACE,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5604), 1,
      sym_identifier,
    STATE(3283), 1,
      sym_variable_declarator,
    STATE(2742), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [114286] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5690), 1,
      anon_sym_STAR,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3616), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [114311] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5692), 1,
      sym_identifier,
    ACTIONS(5694), 1,
      anon_sym_STAR,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3616), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [114336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_LBRACE,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5604), 1,
      sym_identifier,
    STATE(3284), 1,
      sym_variable_declarator,
    STATE(2742), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [114357] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5696), 1,
      anon_sym_COLON,
    ACTIONS(5698), 1,
      anon_sym_QMARK,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3799), 1,
      sym__call_signature,
  [114382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3663), 1,
      sym_statement_block,
    ACTIONS(5700), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3658), 1,
      sym_statement_block,
    ACTIONS(5702), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114416] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_LBRACE,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5604), 1,
      sym_identifier,
    STATE(3464), 1,
      sym_variable_declarator,
    STATE(2742), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [114437] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3157), 1,
      sym_type_annotation,
    STATE(3541), 1,
      sym__initializer,
    ACTIONS(5442), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3602), 1,
      sym_statement_block,
    ACTIONS(5700), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3600), 1,
      sym_statement_block,
    ACTIONS(5702), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3615), 1,
      sym_statement_block,
    ACTIONS(5626), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [114522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3644), 1,
      sym_statement_block,
    ACTIONS(5706), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3746), 1,
      sym_statement_block,
    ACTIONS(5672), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3598), 1,
      sym_statement_block,
    ACTIONS(5706), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114573] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1716), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3596), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [114598] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5698), 1,
      anon_sym_QMARK,
    ACTIONS(5708), 1,
      anon_sym_COLON,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3799), 1,
      sym__call_signature,
  [114623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(3105), 1,
      sym_statement_block,
    ACTIONS(1284), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5203), 1,
      anon_sym_is,
    ACTIONS(5710), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3163), 1,
      sym_type_annotation,
    ACTIONS(5712), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3647), 1,
      sym_statement_block,
    ACTIONS(5714), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3637), 1,
      sym_statement_block,
    ACTIONS(5716), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3617), 1,
      sym_statement_block,
    ACTIONS(5718), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4087), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3661), 1,
      sym_statement_block,
    ACTIONS(5718), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114753] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1312), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3708), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [114778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3627), 1,
      sym_statement_block,
    ACTIONS(5720), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5722), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [114808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4081), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3089), 1,
      sym_type_annotation,
    STATE(3382), 1,
      sym__initializer,
    ACTIONS(5450), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114842] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5724), 1,
      sym_identifier,
    ACTIONS(5726), 1,
      anon_sym_STAR,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3687), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [114867] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3252), 1,
      sym_type_annotation,
    STATE(3592), 1,
      sym__initializer,
    ACTIONS(5452), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5548), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114901] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1884), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3822), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [114926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 1,
      anon_sym_is,
    ACTIONS(3387), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3626), 1,
      sym_statement_block,
    ACTIONS(5728), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114958] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5730), 1,
      sym_identifier,
    ACTIONS(5732), 1,
      anon_sym_STAR,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3705), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [114983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5544), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3180), 1,
      sym_type_annotation,
    ACTIONS(5734), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [115026] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5738), 1,
      sym_identifier,
    ACTIONS(5740), 1,
      anon_sym_DOT,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(603), 1,
      sym_string,
    STATE(740), 1,
      sym__module,
  [115051] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5540), 1,
      anon_sym_LBRACE,
    STATE(141), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3772), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [115076] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    STATE(1855), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3689), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [115101] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    ACTIONS(5181), 1,
      anon_sym_LT,
    ACTIONS(5742), 1,
      sym_identifier,
    ACTIONS(5744), 1,
      anon_sym_LBRACK,
    ACTIONS(5746), 1,
      sym_private_property_identifier,
    STATE(1355), 1,
      sym_arguments,
    STATE(3750), 1,
      sym_type_arguments,
  [115126] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(5748), 1,
      sym_identifier,
    ACTIONS(5750), 1,
      anon_sym_DOT,
    STATE(2704), 1,
      sym_nested_identifier,
    STATE(2786), 1,
      sym_string,
    STATE(2982), 1,
      sym__module,
  [115151] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_extends,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(613), 1,
      sym_class_body,
    STATE(3426), 1,
      sym_extends_clause,
    STATE(3675), 1,
      sym_class_heritage,
    STATE(4039), 1,
      sym_implements_clause,
  [115176] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(5620), 1,
      anon_sym_LT,
    ACTIONS(5622), 1,
      anon_sym_extends,
    STATE(3050), 1,
      sym_type_parameters,
    STATE(3106), 1,
      sym_object_type,
    STATE(3486), 1,
      sym_extends_type_clause,
  [115201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 1,
      anon_sym_LBRACE,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(5604), 1,
      sym_identifier,
    STATE(3337), 1,
      sym_variable_declarator,
    STATE(2742), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [115222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2822), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3209), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5752), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3223), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5754), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2378), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5756), 1,
      anon_sym_default,
    ACTIONS(5759), 1,
      anon_sym_RBRACE,
    ACTIONS(5761), 1,
      anon_sym_case,
    STATE(2820), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [115284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [115296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3221), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5764), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2867), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5768), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5766), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115328] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5770), 1,
      sym_identifier,
    ACTIONS(5772), 1,
      anon_sym_import,
    STATE(1473), 1,
      sym__type_query_member_expression,
    STATE(1474), 1,
      sym__type_query_subscript_expression,
    STATE(1622), 1,
      sym__type_query_call_expression,
    STATE(3703), 1,
      sym_import,
  [115350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2168), 1,
      sym_statement_block,
    ACTIONS(5672), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115378] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(5776), 1,
      anon_sym_COMMA,
    ACTIONS(5778), 1,
      anon_sym_GT,
    STATE(3500), 1,
      aux_sym_implements_clause_repeat1,
  [115400] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5780), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3039), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [115422] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5782), 1,
      sym_identifier,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3759), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [115444] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5784), 1,
      anon_sym_QMARK,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2951), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [115466] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_import,
    ACTIONS(5786), 1,
      sym_identifier,
    STATE(2267), 1,
      sym__type_query_member_expression,
    STATE(2268), 1,
      sym__type_query_subscript_expression,
    STATE(2303), 1,
      sym__type_query_call_expression,
    STATE(3747), 1,
      sym_import,
  [115488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2094), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115500] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(5788), 1,
      anon_sym_COMMA,
    ACTIONS(5790), 1,
      anon_sym_GT,
    STATE(3447), 1,
      aux_sym_implements_clause_repeat1,
  [115522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2090), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2141), 1,
      sym_statement_block,
    ACTIONS(5649), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5794), 1,
      anon_sym_BQUOTE,
    ACTIONS(5796), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5792), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2914), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [115568] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_import,
    ACTIONS(5798), 1,
      sym_identifier,
    STATE(2342), 1,
      sym__type_query_member_expression,
    STATE(2343), 1,
      sym__type_query_subscript_expression,
    STATE(2451), 1,
      sym__type_query_call_expression,
    STATE(3825), 1,
      sym_import,
  [115590] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
    ACTIONS(5804), 1,
      anon_sym_COMMA,
    ACTIONS(5806), 1,
      anon_sym_RBRACE,
    STATE(3587), 1,
      sym__import_export_specifier,
    ACTIONS(5802), 2,
      anon_sym_type,
      anon_sym_typeof,
  [115610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5808), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2140), 1,
      sym_statement_block,
    ACTIONS(5672), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2162), 1,
      sym_statement_block,
    ACTIONS(5649), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5813), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5810), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1946), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115682] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5815), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5817), 1,
      anon_sym_QMARK_COLON,
    STATE(3093), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [115700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5815), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5817), 1,
      anon_sym_QMARK_COLON,
    STATE(3003), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [115718] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    ACTIONS(5628), 1,
      anon_sym_EQ,
    STATE(3358), 1,
      sym_type_annotation,
    STATE(3749), 1,
      sym__initializer,
    ACTIONS(5819), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [115738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5710), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115750] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5821), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3386), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [115772] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5823), 1,
      anon_sym_export,
    ACTIONS(5825), 1,
      anon_sym_class,
    ACTIONS(5827), 1,
      anon_sym_abstract,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
  [115794] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5829), 1,
      anon_sym_QMARK,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2861), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [115816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2136), 1,
      sym_statement_block,
    ACTIONS(5718), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1930), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115844] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5831), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3166), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [115866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3209), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5752), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115882] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_import,
    ACTIONS(5833), 1,
      sym_identifier,
    STATE(2444), 1,
      sym__type_query_subscript_expression,
    STATE(2445), 1,
      sym__type_query_member_expression,
    STATE(2555), 1,
      sym__type_query_call_expression,
    STATE(3743), 1,
      sym_import,
  [115904] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5815), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5817), 1,
      anon_sym_QMARK_COLON,
    STATE(3175), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [115922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1938), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3201), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5835), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2818), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5839), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5837), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2165), 1,
      sym_statement_block,
    ACTIONS(5606), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2163), 1,
      sym_statement_block,
    ACTIONS(5626), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115998] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5841), 1,
      anon_sym_QMARK,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3820), 1,
      sym__call_signature,
  [116020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5722), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [116032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2909), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3225), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5843), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5845), 1,
      anon_sym_QMARK,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2835), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [116070] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5847), 1,
      anon_sym_QMARK,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3651), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [116092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3225), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5843), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116108] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5849), 1,
      sym_identifier,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3754), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [116130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2164), 1,
      sym_statement_block,
    ACTIONS(5728), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2152), 1,
      sym_statement_block,
    ACTIONS(5714), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 1,
      anon_sym_AMP,
    ACTIONS(3542), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [116176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2955), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5855), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5853), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116192] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(5857), 1,
      anon_sym_LBRACE,
    ACTIONS(5859), 1,
      anon_sym_COMMA,
    STATE(3370), 1,
      aux_sym_implements_clause_repeat1,
  [116214] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3118), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [116236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2139), 1,
      sym_statement_block,
    ACTIONS(5626), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116252] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(5863), 1,
      anon_sym_COMMA,
    ACTIONS(5865), 1,
      anon_sym_GT,
    STATE(3399), 1,
      aux_sym_implements_clause_repeat1,
  [116274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3163), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [116288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(5869), 1,
      anon_sym_extends,
    ACTIONS(3580), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [116306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2158), 1,
      sym_statement_block,
    ACTIONS(5706), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116322] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(5871), 1,
      anon_sym_COMMA,
    ACTIONS(5873), 1,
      anon_sym_GT,
    STATE(3413), 1,
      aux_sym_implements_clause_repeat1,
  [116344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5407), 1,
      anon_sym_is,
    ACTIONS(5710), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2854), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5877), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5875), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2138), 1,
      sym_statement_block,
    ACTIONS(5670), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 1,
      anon_sym_default,
    ACTIONS(5881), 1,
      anon_sym_RBRACE,
    ACTIONS(5883), 1,
      anon_sym_case,
    STATE(2948), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [116408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2156), 1,
      sym_statement_block,
    ACTIONS(5606), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2929), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5887), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5885), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2159), 1,
      sym_statement_block,
    ACTIONS(5634), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116456] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5889), 1,
      sym_identifier,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3618), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [116478] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5891), 1,
      sym_identifier,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3618), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [116500] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5893), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2795), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [116522] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5895), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2730), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [116544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(3458), 4,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
  [116560] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5897), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2774), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [116582] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5899), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2743), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [116604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [116616] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5901), 1,
      sym_identifier,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3754), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [116638] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(5748), 1,
      sym_identifier,
    STATE(2704), 1,
      sym_nested_identifier,
    STATE(2786), 1,
      sym_string,
    STATE(2982), 1,
      sym__module,
  [116660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2153), 1,
      sym_statement_block,
    ACTIONS(5718), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116676] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
    ACTIONS(5903), 1,
      anon_sym_COMMA,
    ACTIONS(5905), 1,
      anon_sym_RBRACE,
    STATE(3468), 1,
      sym__import_export_specifier,
    ACTIONS(5802), 2,
      anon_sym_type,
      anon_sym_typeof,
  [116696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5796), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5907), 1,
      anon_sym_BQUOTE,
    ACTIONS(5578), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2980), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [116714] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5909), 1,
      anon_sym_QMARK,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3701), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [116736] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    ACTIONS(5748), 1,
      sym_identifier,
    STATE(2704), 1,
      sym_nested_identifier,
    STATE(2786), 1,
      sym_string,
    STATE(3114), 1,
      sym__module,
  [116758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2137), 1,
      sym_statement_block,
    ACTIONS(5720), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116774] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(5911), 1,
      anon_sym_COMMA,
    ACTIONS(5913), 1,
      anon_sym_GT,
    STATE(3503), 1,
      aux_sym_implements_clause_repeat1,
  [116796] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_import,
    ACTIONS(5915), 1,
      sym_identifier,
    STATE(2303), 1,
      sym__type_query_call_expression,
    STATE(2588), 1,
      sym__type_query_member_expression,
    STATE(2599), 1,
      sym__type_query_subscript_expression,
    STATE(3605), 1,
      sym_import,
  [116818] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5917), 1,
      sym_identifier,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3710), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [116840] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5796), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5919), 1,
      anon_sym_BQUOTE,
    ACTIONS(5568), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2836), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [116858] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_import,
    ACTIONS(5921), 1,
      sym_identifier,
    STATE(1197), 1,
      sym__type_query_subscript_expression,
    STATE(1199), 1,
      sym__type_query_member_expression,
    STATE(1215), 1,
      sym__type_query_call_expression,
    STATE(3791), 1,
      sym_import,
  [116880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3205), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5923), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [116908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(5869), 1,
      anon_sym_extends,
    ACTIONS(3600), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [116926] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5925), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3573), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [116948] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5927), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3237), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [116970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5932), 1,
      anon_sym_BQUOTE,
    ACTIONS(5934), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5929), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2914), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [116988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3211), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5937), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117004] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5939), 1,
      sym_identifier,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3618), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [117026] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5941), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2724), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [117048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5943), 1,
      sym_identifier,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3754), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [117070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5815), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5817), 1,
      anon_sym_QMARK_COLON,
    STATE(3227), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [117088] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(5869), 1,
      anon_sym_extends,
    ACTIONS(3660), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [117106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2962), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3203), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5945), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117122] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5947), 1,
      anon_sym_QMARK,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2903), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [117144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5815), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5817), 1,
      anon_sym_QMARK_COLON,
    STATE(3219), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [117162] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5815), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5817), 1,
      anon_sym_QMARK_COLON,
    STATE(3215), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [117180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5624), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [117204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2858), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3223), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5754), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2144), 1,
      sym_statement_block,
    ACTIONS(5706), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3203), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5945), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5951), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117264] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5953), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3189), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [117286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3199), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5955), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117302] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5738), 1,
      sym_identifier,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(603), 1,
      sym_string,
    STATE(740), 1,
      sym__module,
  [117324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2915), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3199), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5955), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117340] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5957), 1,
      anon_sym_QMARK,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2851), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [117362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(5959), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [117380] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(5961), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3112), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [117402] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5963), 1,
      sym_identifier,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3754), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [117424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(5965), 1,
      sym_identifier,
    ACTIONS(5967), 1,
      anon_sym_LBRACK,
    STATE(3574), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [117442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3179), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117458] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(5971), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
  [117476] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5815), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5817), 1,
      anon_sym_QMARK_COLON,
    STATE(3080), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [117494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5815), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5817), 1,
      anon_sym_QMARK_COLON,
    STATE(3109), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [117512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    ACTIONS(5815), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5817), 1,
      anon_sym_QMARK_COLON,
    STATE(3095), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [117530] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
    ACTIONS(5973), 1,
      anon_sym_COMMA,
    ACTIONS(5975), 1,
      anon_sym_RBRACE,
    STATE(3552), 1,
      sym__import_export_specifier,
    ACTIONS(5802), 2,
      anon_sym_type,
      anon_sym_typeof,
  [117550] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5977), 1,
      anon_sym_QMARK,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3739), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [117572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2169), 1,
      sym_statement_block,
    ACTIONS(5700), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 1,
      anon_sym_default,
    ACTIONS(5883), 1,
      anon_sym_case,
    ACTIONS(5979), 1,
      anon_sym_RBRACE,
    STATE(2820), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [117606] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5496), 1,
      anon_sym_LT,
    ACTIONS(5641), 1,
      anon_sym_COMMA,
    ACTIONS(5981), 1,
      anon_sym_LBRACE,
    ACTIONS(5983), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3275), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3527), 1,
      sym_type_arguments,
  [117628] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    ACTIONS(5738), 1,
      sym_identifier,
    STATE(591), 1,
      sym_nested_identifier,
    STATE(603), 1,
      sym_string,
    STATE(743), 1,
      sym__module,
  [117650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2170), 1,
      sym_statement_block,
    ACTIONS(5702), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2932), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5987), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5985), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2940), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3195), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5989), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117698] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(5991), 1,
      anon_sym_QMARK,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3654), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [117720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3195), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5989), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117736] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    ACTIONS(5993), 1,
      anon_sym_QMARK,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2887), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [117758] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(5995), 1,
      anon_sym_COMMA,
    ACTIONS(5997), 1,
      anon_sym_GT,
    STATE(3467), 1,
      aux_sym_implements_clause_repeat1,
  [117780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2166), 1,
      sym_statement_block,
    ACTIONS(5700), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117796] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5496), 1,
      anon_sym_LT,
    ACTIONS(5643), 1,
      anon_sym_DOT,
    ACTIONS(5999), 1,
      anon_sym_LBRACE,
    STATE(3526), 1,
      sym_type_arguments,
    ACTIONS(6001), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [117816] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(5967), 1,
      anon_sym_LBRACK,
    ACTIONS(6003), 1,
      sym_identifier,
    STATE(3303), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [117834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [117846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2842), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3207), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6005), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_LBRACE,
    ACTIONS(5967), 1,
      anon_sym_LBRACK,
    ACTIONS(6007), 1,
      sym_identifier,
    STATE(3614), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [117892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6011), 1,
      anon_sym_QMARK,
    ACTIONS(6009), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117912] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(6013), 1,
      anon_sym_QMARK,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3650), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [117934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2154), 1,
      sym_statement_block,
    ACTIONS(5702), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117950] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5827), 1,
      anon_sym_abstract,
    ACTIONS(6015), 1,
      anon_sym_export,
    ACTIONS(6017), 1,
      anon_sym_class,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
  [117972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_COLON,
    ACTIONS(5504), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3670), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [117988] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    ACTIONS(6021), 1,
      sym_identifier,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3618), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [118010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_COLON,
    ACTIONS(5514), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3613), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [118038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1362), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118050] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    ACTIONS(6023), 1,
      anon_sym_QMARK,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2793), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [118072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1934), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_LBRACE,
    STATE(2171), 1,
      sym_statement_block,
    ACTIONS(5716), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(5869), 1,
      anon_sym_extends,
    ACTIONS(3466), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [118118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 1,
      anon_sym_AMP,
    ACTIONS(3476), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [118132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1942), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5796), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6025), 1,
      anon_sym_BQUOTE,
    ACTIONS(5792), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2914), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [118162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5706), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2346), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2114), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118206] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1288), 1,
      anon_sym_LBRACE,
    ACTIONS(6027), 1,
      anon_sym_SEMI,
    ACTIONS(6029), 1,
      sym__automatic_semicolon,
    ACTIONS(6031), 1,
      sym__function_signature_automatic_semicolon,
    STATE(134), 1,
      sym_statement_block,
  [118225] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2985), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [118244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_COLON,
    ACTIONS(6033), 1,
      anon_sym_EQ_GT,
    STATE(3670), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [118259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    ACTIONS(6036), 1,
      anon_sym_SEMI,
    ACTIONS(6038), 1,
      sym__automatic_semicolon,
    ACTIONS(6040), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1821), 1,
      sym_statement_block,
  [118278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_COLON,
    ACTIONS(6042), 1,
      anon_sym_EQ_GT,
    STATE(3613), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [118293] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3073), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [118312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4565), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [118323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
    ACTIONS(6045), 1,
      anon_sym_RBRACE,
    STATE(3683), 1,
      sym__import_export_specifier,
    ACTIONS(5802), 2,
      anon_sym_type,
      anon_sym_typeof,
  [118340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118351] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 1,
      anon_sym_EQ,
    ACTIONS(6047), 1,
      anon_sym_COMMA,
    ACTIONS(6049), 1,
      anon_sym_RBRACE,
    STATE(3586), 1,
      aux_sym_enum_body_repeat1,
    STATE(3804), 1,
      sym__initializer,
  [118370] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 1,
      anon_sym_EQ,
    ACTIONS(6051), 1,
      anon_sym_COMMA,
    ACTIONS(6053), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      aux_sym_enum_body_repeat1,
    STATE(3804), 1,
      sym__initializer,
  [118389] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3660), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [118408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_COLON,
    ACTIONS(6055), 1,
      anon_sym_EQ_GT,
    STATE(3613), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [118423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5496), 1,
      anon_sym_LT,
    ACTIONS(6058), 1,
      anon_sym_LBRACE,
    STATE(3527), 1,
      sym_type_arguments,
    ACTIONS(6060), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [118440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [118451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(6062), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [118479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2066), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6066), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_COLON,
    ACTIONS(6068), 1,
      anon_sym_EQ_GT,
    STATE(3670), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [118527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
    ACTIONS(6071), 1,
      anon_sym_RBRACE,
    STATE(3683), 1,
      sym__import_export_specifier,
    ACTIONS(5802), 2,
      anon_sym_type,
      anon_sym_typeof,
  [118544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [118555] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    ACTIONS(6073), 1,
      anon_sym_SEMI,
    ACTIONS(6075), 1,
      sym__automatic_semicolon,
    ACTIONS(6077), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3048), 1,
      sym_statement_block,
  [118574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4413), 1,
      sym__automatic_semicolon,
    ACTIONS(1402), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2098), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2102), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(6079), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [118626] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3812), 1,
      sym__call_signature,
  [118645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [118656] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3667), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [118675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2110), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118686] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(6081), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [118703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    ACTIONS(6036), 1,
      anon_sym_SEMI,
    ACTIONS(6038), 1,
      sym__automatic_semicolon,
    ACTIONS(6040), 1,
      sym__function_signature_automatic_semicolon,
    STATE(598), 1,
      sym_statement_block,
  [118722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2162), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118733] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    ACTIONS(6083), 1,
      anon_sym_SEMI,
    ACTIONS(6085), 1,
      sym__automatic_semicolon,
    ACTIONS(6087), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3009), 1,
      sym_statement_block,
  [118752] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3653), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [118771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2126), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6089), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [118804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
    ACTIONS(6091), 1,
      anon_sym_RBRACE,
    STATE(3683), 1,
      sym__import_export_specifier,
    ACTIONS(5802), 2,
      anon_sym_type,
      anon_sym_typeof,
  [118821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3458), 1,
      sym__initializer,
    ACTIONS(6093), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2134), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1366), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
    ACTIONS(6095), 1,
      anon_sym_RBRACE,
    STATE(3625), 1,
      sym__import_export_specifier,
    ACTIONS(5802), 2,
      anon_sym_type,
      anon_sym_typeof,
  [118886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_COLON,
    ACTIONS(6097), 1,
      anon_sym_EQ_GT,
    STATE(3670), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [118901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3629), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [118920] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3634), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [118939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3407), 1,
      sym__initializer,
    ACTIONS(6100), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118954] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2725), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [118973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3229), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [119014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5649), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1422), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2174), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119058] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6102), 1,
      anon_sym_BQUOTE,
    ACTIONS(6104), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6106), 1,
      sym__template_chars,
    STATE(3232), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [119075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6108), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [119125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4425), 1,
      sym__automatic_semicolon,
    ACTIONS(1312), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      sym__automatic_semicolon,
    ACTIONS(1376), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119151] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    ACTIONS(5622), 1,
      anon_sym_extends,
    STATE(3184), 1,
      sym_object_type,
    STATE(3428), 1,
      sym_extends_type_clause,
  [119170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5649), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119192] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3715), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [119211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119233] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6112), 1,
      anon_sym_class,
    ACTIONS(6114), 1,
      anon_sym_abstract,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
  [119252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2869), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [119271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119282] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    ACTIONS(6027), 1,
      anon_sym_SEMI,
    ACTIONS(6029), 1,
      sym__automatic_semicolon,
    ACTIONS(6031), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1879), 1,
      sym_statement_block,
  [119301] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3751), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [119320] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    ACTIONS(5622), 1,
      anon_sym_extends,
    STATE(733), 1,
      sym_object_type,
    STATE(3419), 1,
      sym_extends_type_clause,
  [119339] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5827), 1,
      anon_sym_abstract,
    ACTIONS(6118), 1,
      anon_sym_class,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
  [119358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2782), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [119410] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(3107), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [119429] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(6120), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [119446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119457] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3567), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [119476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6122), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4429), 1,
      sym__automatic_semicolon,
    ACTIONS(1442), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119511] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2773), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [119530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2178), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119552] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2781), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [119571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119582] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2790), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [119601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6124), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119612] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2804), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [119631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3439), 1,
      sym__initializer,
    ACTIONS(6126), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(3182), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [119687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2242), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2206), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6106), 1,
      sym__template_chars,
    ACTIONS(6128), 1,
      anon_sym_BQUOTE,
    STATE(3232), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [119726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3546), 1,
      sym__initializer,
    ACTIONS(6130), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119741] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2976), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [119760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3545), 1,
      sym__initializer,
    ACTIONS(6132), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_COLON,
    ACTIONS(6134), 1,
      anon_sym_EQ_GT,
    STATE(3613), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [119790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6137), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5706), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6139), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119823] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3818), 1,
      sym__call_signature,
  [119842] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3787), 1,
      sym__call_signature,
  [119861] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2840), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [119880] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3777), 1,
      sym__call_signature,
  [119899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119932] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(6143), 1,
      anon_sym_RBRACE,
    STATE(3497), 1,
      aux_sym_object_pattern_repeat1,
  [119951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2086), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2142), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119984] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1288), 1,
      anon_sym_LBRACE,
    ACTIONS(6036), 1,
      anon_sym_SEMI,
    ACTIONS(6038), 1,
      sym__automatic_semicolon,
    ACTIONS(6040), 1,
      sym__function_signature_automatic_semicolon,
    STATE(118), 1,
      sym_statement_block,
  [120003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6145), 1,
      anon_sym_BQUOTE,
    ACTIONS(6147), 1,
      sym__template_chars,
    STATE(3043), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [120020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6149), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6151), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [120053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6153), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2860), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [120116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120138] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3662), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [120157] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2993), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [120176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_AMP,
    ACTIONS(5460), 1,
      anon_sym_extends,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(6155), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6157), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6159), 1,
      anon_sym_BQUOTE,
    ACTIONS(6161), 1,
      sym__template_chars,
    STATE(3218), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [120221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_EQ,
    ACTIONS(3014), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [120234] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    ACTIONS(6027), 1,
      anon_sym_SEMI,
    ACTIONS(6029), 1,
      sym__automatic_semicolon,
    ACTIONS(6031), 1,
      sym__function_signature_automatic_semicolon,
    STATE(615), 1,
      sym_statement_block,
  [120253] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3794), 1,
      sym__call_signature,
  [120272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3374), 1,
      sym__initializer,
    ACTIONS(6165), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2390), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120309] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6114), 1,
      anon_sym_abstract,
    ACTIONS(6167), 1,
      anon_sym_class,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
  [120328] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(3125), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [120347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4081), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [120369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4087), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [120380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6169), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3711), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [120410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6171), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120432] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3671), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [120451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2166), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120462] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(6173), 1,
      anon_sym_RBRACE,
    STATE(3522), 1,
      aux_sym_object_pattern_repeat1,
  [120481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120492] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2947), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [120511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2170), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4544), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [120533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6175), 1,
      anon_sym_BQUOTE,
    ACTIONS(6177), 1,
      sym__template_chars,
    STATE(3172), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [120550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120561] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(3018), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [120580] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3770), 1,
      sym__call_signature,
  [120599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
    ACTIONS(6179), 1,
      anon_sym_RBRACE,
    STATE(3683), 1,
      sym__import_export_specifier,
    ACTIONS(5802), 2,
      anon_sym_type,
      anon_sym_typeof,
  [120616] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3768), 1,
      sym__call_signature,
  [120635] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(3211), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [120654] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(3008), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [120673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5718), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3591), 1,
      sym__initializer,
    ACTIONS(6183), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120721] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3839), 1,
      sym__call_signature,
  [120740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1412), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6185), 1,
      anon_sym_BQUOTE,
    ACTIONS(6187), 1,
      sym__template_chars,
    STATE(3088), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [120779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6189), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
    ACTIONS(6191), 1,
      anon_sym_RBRACE,
    STATE(3625), 1,
      sym__import_export_specifier,
    ACTIONS(5802), 2,
      anon_sym_type,
      anon_sym_typeof,
  [120818] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(3059), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [120837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(3449), 1,
      anon_sym_LBRACE,
    ACTIONS(3451), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [120863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3846), 1,
      sym__call_signature,
  [120882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    STATE(3838), 1,
      sym_type_annotation,
    ACTIONS(3008), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [120897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3384), 1,
      sym__initializer,
    ACTIONS(6193), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2338), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120923] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6106), 1,
      sym__template_chars,
    ACTIONS(6195), 1,
      anon_sym_BQUOTE,
    STATE(3232), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [120940] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3036), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [120959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_COLON,
    ACTIONS(6197), 1,
      anon_sym_EQ_GT,
    STATE(3613), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [120974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6200), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120985] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3631), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [121004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 1,
      anon_sym_in,
    ACTIONS(6206), 1,
      anon_sym_of,
    ACTIONS(6202), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6208), 1,
      anon_sym_in,
    ACTIONS(6210), 1,
      anon_sym_of,
    ACTIONS(6202), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121034] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 1,
      anon_sym_AMP,
    ACTIONS(5867), 1,
      anon_sym_PIPE,
    ACTIONS(5869), 1,
      anon_sym_extends,
    ACTIONS(6212), 1,
      anon_sym_as,
    ACTIONS(6214), 1,
      anon_sym_RBRACK,
  [121053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6216), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121064] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5827), 1,
      anon_sym_abstract,
    ACTIONS(6017), 1,
      anon_sym_class,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
  [121083] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    ACTIONS(6083), 1,
      anon_sym_SEMI,
    ACTIONS(6085), 1,
      sym__automatic_semicolon,
    ACTIONS(6087), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1717), 1,
      sym_statement_block,
  [121102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2058), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3466), 1,
      sym__initializer,
    ACTIONS(6218), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3594), 1,
      sym__initializer,
    ACTIONS(6220), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3402), 1,
      sym__initializer,
    ACTIONS(6222), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5718), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2326), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121202] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3188), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [121221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5710), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2062), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6106), 1,
      sym__template_chars,
    ACTIONS(6224), 1,
      anon_sym_BQUOTE,
    STATE(3232), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [121260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3515), 1,
      sym__initializer,
    ACTIONS(6226), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_COLON,
    ACTIONS(6228), 1,
      anon_sym_EQ_GT,
    STATE(3670), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [121312] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(3528), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [121331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5825), 1,
      anon_sym_class,
    ACTIONS(5827), 1,
      anon_sym_abstract,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
  [121350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4362), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [121361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6231), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [121378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4304), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [121400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym_type_parameters,
    STATE(3821), 1,
      sym__call_signature,
  [121419] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(3020), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [121438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4489), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [121449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121460] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3641), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [121479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4489), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [121490] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    ACTIONS(6073), 1,
      anon_sym_SEMI,
    ACTIONS(6075), 1,
      sym__automatic_semicolon,
    ACTIONS(6077), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1730), 1,
      sym_statement_block,
  [121509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2150), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6233), 1,
      anon_sym_BQUOTE,
    ACTIONS(6235), 1,
      sym__template_chars,
    STATE(3194), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [121537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5808), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6237), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121559] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3729), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [121578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4489), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [121589] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6106), 1,
      sym__template_chars,
    ACTIONS(6239), 1,
      anon_sym_BQUOTE,
    STATE(3232), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [121606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6241), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2988), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [121636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1334), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6243), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5193), 1,
      anon_sym_LBRACK,
    ACTIONS(6245), 1,
      anon_sym_RBRACE,
    ACTIONS(3554), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6247), 1,
      anon_sym_BQUOTE,
    ACTIONS(6249), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6252), 1,
      sym__template_chars,
    STATE(3232), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [121778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6255), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [121795] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_formal_parameters,
    STATE(2981), 1,
      sym__call_signature,
    STATE(3652), 1,
      sym_type_parameters,
  [121814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5702), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6257), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5702), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121880] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3741), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [121899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [121910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6259), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [121932] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2672), 1,
      sym_formal_parameters,
    STATE(2879), 1,
      sym__call_signature,
    STATE(3798), 1,
      sym_type_parameters,
  [121951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4496), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [121973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121984] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2972), 1,
      sym_formal_parameters,
    STATE(3760), 1,
      sym__call_signature,
    STATE(3761), 1,
      sym_type_parameters,
  [122003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6261), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [122025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      anon_sym_EQ,
    STATE(3502), 1,
      sym__initializer,
    ACTIONS(6263), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5951), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122051] = 4,
    ACTIONS(6265), 1,
      anon_sym_DQUOTE,
    ACTIONS(6269), 1,
      sym_comment,
    STATE(3340), 1,
      aux_sym_string_repeat1,
    ACTIONS(6267), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122065] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6271), 1,
      anon_sym_SQUOTE,
    STATE(3361), 1,
      aux_sym_string_repeat2,
    ACTIONS(6273), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122079] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6275), 1,
      anon_sym_RBRACK,
  [122095] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6277), 1,
      anon_sym_COLON,
  [122111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
    STATE(3683), 1,
      sym__import_export_specifier,
    ACTIONS(5802), 2,
      anon_sym_type,
      anon_sym_typeof,
  [122125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6279), 1,
      anon_sym_RBRACK,
  [122141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 1,
      anon_sym_COMMA,
    STATE(3260), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(5971), 2,
      anon_sym_LBRACE,
      anon_sym_GT,
  [122155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6284), 1,
      anon_sym_RBRACK,
  [122171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6286), 1,
      anon_sym_QMARK,
  [122187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6288), 1,
      anon_sym_RBRACK,
  [122203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6290), 1,
      anon_sym_RPAREN,
  [122219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_RBRACE,
    ACTIONS(3554), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
    STATE(3625), 1,
      sym__import_export_specifier,
    ACTIONS(5802), 2,
      anon_sym_type,
      anon_sym_typeof,
  [122245] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6292), 1,
      anon_sym_DQUOTE,
    STATE(3294), 1,
      aux_sym_string_repeat1,
    ACTIONS(6294), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122259] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6292), 1,
      anon_sym_SQUOTE,
    STATE(3295), 1,
      aux_sym_string_repeat2,
    ACTIONS(6296), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5021), 1,
      anon_sym_EQ_GT,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [122285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6298), 1,
      anon_sym_QMARK,
  [122301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 1,
      anon_sym_COMMA,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    ACTIONS(6302), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3335), 1,
      aux_sym_extends_type_clause_repeat1,
  [122317] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6304), 1,
      anon_sym_DQUOTE,
    STATE(3289), 1,
      aux_sym_string_repeat1,
    ACTIONS(6306), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122331] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6304), 1,
      anon_sym_SQUOTE,
    STATE(3290), 1,
      aux_sym_string_repeat2,
    ACTIONS(6308), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122345] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3848), 1,
      sym_type_parameters,
    STATE(3943), 1,
      sym_formal_parameters,
  [122361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 1,
      anon_sym_COMMA,
    ACTIONS(6300), 1,
      anon_sym_LBRACE,
    ACTIONS(6302), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3335), 1,
      aux_sym_extends_type_clause_repeat1,
  [122377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 1,
      anon_sym_COMMA,
    ACTIONS(6310), 1,
      anon_sym_LBRACE,
    ACTIONS(6312), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3335), 1,
      aux_sym_extends_type_clause_repeat1,
  [122393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 1,
      anon_sym_from,
    STATE(3716), 1,
      sym__from_clause,
    ACTIONS(6316), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 1,
      sym_identifier,
    STATE(2998), 1,
      sym_nested_type_identifier,
    STATE(3430), 1,
      sym_generic_type,
    STATE(3898), 1,
      sym_nested_identifier,
  [122423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    STATE(1719), 2,
      sym_template_string,
      sym_arguments,
  [122437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_COMMA,
    STATE(3282), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6322), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_COMMA,
    STATE(3321), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6324), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_COMMA,
    STATE(3321), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6326), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122479] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_COMMA,
    STATE(3302), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6328), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_COMMA,
    STATE(3305), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6330), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6332), 1,
      anon_sym_EQ,
    ACTIONS(6334), 1,
      anon_sym_RBRACK,
    STATE(3506), 1,
      aux_sym_array_pattern_repeat1,
  [122523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [122533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6336), 1,
      anon_sym_RBRACK,
  [122549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6338), 1,
      anon_sym_class,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
  [122565] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6340), 1,
      anon_sym_DQUOTE,
    STATE(3340), 1,
      aux_sym_string_repeat1,
    ACTIONS(6267), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122579] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6340), 1,
      anon_sym_SQUOTE,
    STATE(3319), 1,
      aux_sym_string_repeat2,
    ACTIONS(6342), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122593] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3610), 1,
      sym_type_parameters,
    STATE(4054), 1,
      sym_formal_parameters,
  [122609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6344), 1,
      anon_sym_QMARK,
  [122625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6346), 1,
      anon_sym_class,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
  [122641] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6348), 1,
      anon_sym_DQUOTE,
    STATE(3340), 1,
      aux_sym_string_repeat1,
    ACTIONS(6267), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122655] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6348), 1,
      anon_sym_SQUOTE,
    STATE(3319), 1,
      aux_sym_string_repeat2,
    ACTIONS(6342), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6352), 1,
      anon_sym_COMMA,
    STATE(3296), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6350), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [122683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4212), 1,
      anon_sym_COMMA,
    STATE(3296), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6355), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [122697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    STATE(1354), 2,
      sym_template_string,
      sym_arguments,
  [122711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6357), 1,
      anon_sym_QMARK,
  [122727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5047), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6359), 1,
      anon_sym_RPAREN,
  [122753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_COMMA,
    STATE(3321), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6361), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6363), 1,
      anon_sym_EQ,
    STATE(3836), 1,
      sym__initializer,
    ACTIONS(5480), 2,
      anon_sym_in,
      anon_sym_of,
  [122781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6332), 1,
      anon_sym_EQ,
    ACTIONS(6365), 1,
      anon_sym_RBRACK,
    STATE(3376), 1,
      aux_sym_array_pattern_repeat1,
  [122797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_COMMA,
    STATE(3321), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6367), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3191), 1,
      anon_sym_LBRACE,
    ACTIONS(5484), 1,
      anon_sym_STAR,
    STATE(4024), 2,
      sym_namespace_import_export,
      sym_named_imports,
  [122825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6369), 1,
      anon_sym_RPAREN,
  [122841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6371), 1,
      anon_sym_export,
    STATE(1107), 1,
      aux_sym_export_statement_repeat1,
    STATE(1140), 1,
      sym_decorator,
  [122857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6373), 1,
      anon_sym_RBRACK,
  [122873] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6375), 1,
      anon_sym_DQUOTE,
    STATE(3333), 1,
      aux_sym_string_repeat1,
    ACTIONS(6377), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122887] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6379), 1,
      anon_sym_RBRACK,
  [122903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6381), 1,
      sym_escape_sequence,
    ACTIONS(6383), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [122915] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6375), 1,
      anon_sym_SQUOTE,
    STATE(3332), 1,
      aux_sym_string_repeat2,
    ACTIONS(6386), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122929] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6388), 1,
      anon_sym_SQUOTE,
    STATE(3319), 1,
      aux_sym_string_repeat2,
    ACTIONS(6342), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122943] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6388), 1,
      anon_sym_DQUOTE,
    STATE(3340), 1,
      aux_sym_string_repeat1,
    ACTIONS(6267), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122957] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6390), 1,
      anon_sym_SQUOTE,
    STATE(3314), 1,
      aux_sym_string_repeat2,
    ACTIONS(6392), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [122971] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6390), 1,
      anon_sym_DQUOTE,
    STATE(3315), 1,
      aux_sym_string_repeat1,
    ACTIONS(6394), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [122985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6396), 1,
      anon_sym_COLON,
  [123001] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6398), 1,
      anon_sym_SQUOTE,
    STATE(3319), 1,
      aux_sym_string_repeat2,
    ACTIONS(6400), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_COLON,
    ACTIONS(4023), 1,
      anon_sym_EQ,
    ACTIONS(6403), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [123029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6405), 1,
      anon_sym_COMMA,
    STATE(3321), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6408), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5379), 1,
      anon_sym_EQ,
    STATE(3824), 1,
      sym_default_type,
    ACTIONS(6410), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [123057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6412), 1,
      anon_sym_QMARK,
  [123073] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6414), 1,
      anon_sym_SQUOTE,
    STATE(3319), 1,
      aux_sym_string_repeat2,
    ACTIONS(6342), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123087] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6414), 1,
      anon_sym_DQUOTE,
    STATE(3340), 1,
      aux_sym_string_repeat1,
    ACTIONS(6267), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123101] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6416), 1,
      anon_sym_SQUOTE,
    STATE(3324), 1,
      aux_sym_string_repeat2,
    ACTIONS(6418), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123115] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6416), 1,
      anon_sym_DQUOTE,
    STATE(3325), 1,
      aux_sym_string_repeat1,
    ACTIONS(6420), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6422), 1,
      anon_sym_RBRACK,
  [123145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6424), 1,
      anon_sym_COLON,
  [123161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_RBRACK,
  [123177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6428), 1,
      anon_sym_RBRACK,
  [123193] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6430), 1,
      anon_sym_SQUOTE,
    STATE(3319), 1,
      aux_sym_string_repeat2,
    ACTIONS(6342), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123207] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6430), 1,
      anon_sym_DQUOTE,
    STATE(3340), 1,
      aux_sym_string_repeat1,
    ACTIONS(6267), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 1,
      anon_sym_EQ,
    STATE(3804), 1,
      sym__initializer,
    ACTIONS(6432), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [123235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6434), 1,
      anon_sym_LBRACE,
    ACTIONS(6436), 1,
      anon_sym_COMMA,
    ACTIONS(6439), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3335), 1,
      aux_sym_extends_type_clause_repeat1,
  [123251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6441), 1,
      anon_sym_RBRACK,
  [123267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_COMMA,
    STATE(3281), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6443), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123281] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6445), 1,
      anon_sym_RPAREN,
  [123297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6447), 1,
      anon_sym_RBRACK,
  [123313] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6449), 1,
      anon_sym_DQUOTE,
    STATE(3340), 1,
      aux_sym_string_repeat1,
    ACTIONS(6451), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123327] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6454), 1,
      anon_sym_COLON,
  [123343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 1,
      anon_sym_EQ,
    STATE(3752), 1,
      sym__initializer,
    ACTIONS(6456), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [123357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 1,
      anon_sym_COMMA,
    ACTIONS(5981), 1,
      anon_sym_LBRACE,
    ACTIONS(5983), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3271), 1,
      aux_sym_extends_type_clause_repeat1,
  [123373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6458), 1,
      anon_sym_QMARK,
  [123389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 1,
      anon_sym_from,
    STATE(3642), 1,
      sym__from_clause,
    ACTIONS(6460), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3774), 1,
      sym_type_parameters,
    STATE(4152), 1,
      sym_formal_parameters,
  [123419] = 4,
    ACTIONS(6265), 1,
      anon_sym_SQUOTE,
    ACTIONS(6269), 1,
      sym_comment,
    STATE(3319), 1,
      aux_sym_string_repeat2,
    ACTIONS(6342), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6462), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [123443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3802), 1,
      sym_type_parameters,
    STATE(4011), 1,
      sym_formal_parameters,
  [123459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6464), 1,
      anon_sym_RPAREN,
  [123475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6466), 1,
      anon_sym_COLON,
  [123491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6468), 1,
      anon_sym_EQ_GT,
    ACTIONS(3163), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [123503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4212), 1,
      anon_sym_COMMA,
    STATE(3296), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6470), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [123517] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6472), 1,
      anon_sym_SQUOTE,
    STATE(3347), 1,
      aux_sym_string_repeat2,
    ACTIONS(6474), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123531] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6472), 1,
      anon_sym_DQUOTE,
    STATE(3254), 1,
      aux_sym_string_repeat1,
    ACTIONS(6476), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3718), 1,
      sym_type_parameters,
    STATE(3937), 1,
      sym_formal_parameters,
  [123561] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6478), 1,
      anon_sym_DQUOTE,
    STATE(3340), 1,
      aux_sym_string_repeat1,
    ACTIONS(6267), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 1,
      anon_sym_EQ,
    STATE(3612), 1,
      sym__initializer,
    ACTIONS(6480), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [123589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6482), 1,
      anon_sym_COMMA,
    STATE(3359), 1,
      aux_sym_array_repeat1,
    ACTIONS(4340), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [123603] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6485), 1,
      sym_identifier,
    STATE(2949), 1,
      sym_nested_type_identifier,
    STATE(3343), 1,
      sym_generic_type,
    STATE(3898), 1,
      sym_nested_identifier,
  [123619] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6478), 1,
      anon_sym_SQUOTE,
    STATE(3319), 1,
      aux_sym_string_repeat2,
    ACTIONS(6342), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [123633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
    ACTIONS(6487), 1,
      anon_sym_COLON,
  [123649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2807), 1,
      sym_formal_parameters,
    STATE(3789), 1,
      sym_type_parameters,
  [123665] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3769), 1,
      sym_type_parameters,
    STATE(3885), 1,
      sym_formal_parameters,
  [123681] = 4,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(6271), 1,
      anon_sym_DQUOTE,
    STATE(3357), 1,
      aux_sym_string_repeat1,
    ACTIONS(6489), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [123695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6491), 1,
      anon_sym_COMMA,
    ACTIONS(6493), 1,
      anon_sym_RBRACE,
    STATE(3401), 1,
      aux_sym_enum_body_repeat1,
  [123708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 1,
      anon_sym_COMMA,
    ACTIONS(6500), 1,
      anon_sym_RBRACE,
    STATE(3368), 1,
      aux_sym_object_repeat1,
  [123730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6502), 1,
      anon_sym_LBRACE,
    ACTIONS(6151), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [123741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 1,
      anon_sym_COMMA,
    ACTIONS(6504), 1,
      anon_sym_LBRACE,
    STATE(3260), 1,
      aux_sym_implements_clause_repeat1,
  [123754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6506), 1,
      anon_sym_COMMA,
    ACTIONS(6509), 1,
      anon_sym_RBRACE,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
  [123767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    ACTIONS(6511), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_statement_block,
  [123780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4340), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [123789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(6515), 1,
      anon_sym_RBRACK,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [123811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6517), 1,
      anon_sym_RBRACK,
    STATE(3378), 1,
      aux_sym_array_pattern_repeat1,
  [123824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6519), 1,
      sym_identifier,
    ACTIONS(6521), 1,
      anon_sym_LBRACK,
    ACTIONS(6523), 1,
      sym_private_property_identifier,
  [123837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 1,
      anon_sym_COMMA,
    ACTIONS(6528), 1,
      anon_sym_RBRACK,
    STATE(3378), 1,
      aux_sym_array_pattern_repeat1,
  [123850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    STATE(731), 1,
      sym_object_type,
  [123863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6530), 1,
      sym_identifier,
    ACTIONS(6532), 1,
      anon_sym_LBRACK,
    ACTIONS(6534), 1,
      sym_private_property_identifier,
  [123876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6544), 1,
      sym_identifier,
    ACTIONS(6546), 1,
      anon_sym_LBRACK,
    ACTIONS(6548), 1,
      sym_private_property_identifier,
  [123943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(6550), 1,
      anon_sym_EQ,
    STATE(4006), 1,
      sym_type_parameters,
  [123956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LT,
    ACTIONS(6552), 1,
      anon_sym_EQ,
    STATE(3960), 1,
      sym_type_parameters,
  [123969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6556), 1,
      anon_sym_COMMA,
    ACTIONS(6558), 1,
      anon_sym_RBRACE,
    STATE(3368), 1,
      aux_sym_object_repeat1,
  [123991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6560), 1,
      anon_sym_COMMA,
    ACTIONS(6562), 1,
      anon_sym_RBRACE,
    STATE(3548), 1,
      aux_sym_named_imports_repeat1,
  [124004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6564), 1,
      anon_sym_COMMA,
    ACTIONS(6566), 1,
      anon_sym_RBRACK,
    STATE(3418), 1,
      aux_sym_tuple_type_repeat1,
  [124017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      sym_identifier,
    ACTIONS(6570), 1,
      anon_sym_LBRACK,
    ACTIONS(6572), 1,
      sym_private_property_identifier,
  [124030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5647), 1,
      anon_sym_EQ,
    ACTIONS(3063), 2,
      anon_sym_in,
      anon_sym_of,
  [124041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6574), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [124050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6576), 1,
      anon_sym_COMMA,
    ACTIONS(6578), 1,
      anon_sym_GT,
    STATE(3417), 1,
      aux_sym_type_parameters_repeat1,
  [124063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 1,
      anon_sym_GT,
    ACTIONS(6580), 1,
      anon_sym_COMMA,
    STATE(3260), 1,
      aux_sym_implements_clause_repeat1,
  [124085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6582), 1,
      anon_sym_COMMA,
    ACTIONS(6585), 1,
      anon_sym_RBRACK,
    STATE(3400), 1,
      aux_sym_tuple_type_repeat1,
  [124098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 1,
      anon_sym_COMMA,
    ACTIONS(6589), 1,
      anon_sym_RBRACE,
    STATE(3441), 1,
      aux_sym_enum_body_repeat1,
  [124111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6593), 1,
      anon_sym_COMMA,
    ACTIONS(6595), 1,
      anon_sym_RBRACE,
    STATE(3441), 1,
      aux_sym_enum_body_repeat1,
  [124133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4351), 1,
      anon_sym_RPAREN,
    STATE(3422), 1,
      aux_sym_array_repeat1,
  [124146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4351), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [124159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      sym_identifier,
    ACTIONS(6599), 1,
      anon_sym_GT,
    STATE(3803), 1,
      sym_type_parameter,
  [124172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 1,
      sym_identifier,
    ACTIONS(6605), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_private_property_identifier,
  [124203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 1,
      sym_identifier,
    ACTIONS(6611), 1,
      anon_sym_LBRACK,
    ACTIONS(6613), 1,
      sym_private_property_identifier,
  [124216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_LBRACK,
    ACTIONS(6619), 1,
      sym_private_property_identifier,
  [124238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_GT,
    ACTIONS(6621), 1,
      anon_sym_COMMA,
    STATE(3260), 1,
      aux_sym_implements_clause_repeat1,
  [124251] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      sym_identifier,
    ACTIONS(6625), 1,
      anon_sym_LBRACK,
    ACTIONS(6627), 1,
      sym_private_property_identifier,
  [124264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6365), 1,
      anon_sym_RBRACK,
    STATE(3378), 1,
      aux_sym_array_pattern_repeat1,
  [124277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6629), 1,
      sym_identifier,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6633), 1,
      sym_private_property_identifier,
  [124290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 1,
      anon_sym_GT,
    ACTIONS(6635), 1,
      anon_sym_COMMA,
    STATE(3581), 1,
      aux_sym_type_parameters_repeat1,
  [124303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 1,
      anon_sym_RBRACK,
    ACTIONS(6637), 1,
      anon_sym_COMMA,
    STATE(3400), 1,
      aux_sym_tuple_type_repeat1,
  [124316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1159), 1,
      anon_sym_LBRACE,
    STATE(692), 1,
      sym_object_type,
  [124329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6639), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124338] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_RPAREN,
    ACTIONS(6641), 1,
      anon_sym_COMMA,
    STATE(3445), 1,
      aux_sym_formal_parameters_repeat1,
  [124351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(6643), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [124364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6645), 1,
      sym_identifier,
    ACTIONS(6647), 1,
      anon_sym_LBRACE,
    STATE(755), 1,
      sym_export_clause,
  [124377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(6649), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [124390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_EQ,
    ACTIONS(6528), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [124401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5526), 1,
      anon_sym_implements,
    ACTIONS(6651), 1,
      anon_sym_LBRACE,
    STATE(4154), 1,
      sym_implements_clause,
  [124414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6653), 1,
      anon_sym_COMMA,
    ACTIONS(6655), 1,
      anon_sym_RBRACE,
    STATE(3588), 1,
      aux_sym_enum_body_repeat1,
  [124427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(3063), 1,
      sym_object_type,
  [124440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 1,
      anon_sym_from,
    ACTIONS(6657), 1,
      anon_sym_as,
    STATE(3599), 1,
      sym__from_clause,
  [124453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 1,
      anon_sym_LBRACE,
    ACTIONS(6060), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [124464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(6659), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [124477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_extends,
  [124490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(6661), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [124503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5185), 1,
      anon_sym_is,
    ACTIONS(5710), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [124514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      sym_identifier,
    ACTIONS(6663), 1,
      anon_sym_GT,
    STATE(3803), 1,
      sym_type_parameter,
  [124536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6665), 1,
      anon_sym_COMMA,
    ACTIONS(6667), 1,
      anon_sym_RBRACK,
    STATE(3553), 1,
      aux_sym_tuple_type_repeat1,
  [124549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 1,
      anon_sym_RBRACK,
    ACTIONS(6669), 1,
      anon_sym_COMMA,
    STATE(3400), 1,
      aux_sym_tuple_type_repeat1,
  [124562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6671), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(6673), 1,
      anon_sym_RBRACE,
    STATE(3579), 1,
      aux_sym_object_pattern_repeat1,
  [124584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6675), 1,
      anon_sym_COMMA,
    ACTIONS(6678), 1,
      anon_sym_RBRACE,
    STATE(3441), 1,
      aux_sym_enum_body_repeat1,
  [124597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2462), 1,
      anon_sym_RBRACK,
    ACTIONS(6680), 1,
      anon_sym_COMMA,
    STATE(3400), 1,
      aux_sym_tuple_type_repeat1,
  [124610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6682), 1,
      anon_sym_COMMA,
    ACTIONS(6684), 1,
      anon_sym_RBRACE,
    STATE(3448), 1,
      aux_sym_export_clause_repeat1,
  [124623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6686), 1,
      anon_sym_EQ,
    ACTIONS(6688), 1,
      anon_sym_COMMA,
    ACTIONS(6690), 1,
      anon_sym_from,
  [124636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6692), 1,
      anon_sym_COMMA,
    ACTIONS(6695), 1,
      anon_sym_RPAREN,
    STATE(3445), 1,
      aux_sym_formal_parameters_repeat1,
  [124649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5624), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [124658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_GT,
    ACTIONS(6697), 1,
      anon_sym_COMMA,
    STATE(3260), 1,
      aux_sym_implements_clause_repeat1,
  [124671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 1,
      anon_sym_COMMA,
    ACTIONS(6702), 1,
      anon_sym_RBRACE,
    STATE(3448), 1,
      aux_sym_export_clause_repeat1,
  [124684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6556), 1,
      anon_sym_COMMA,
    ACTIONS(6704), 1,
      anon_sym_RBRACE,
    STATE(3391), 1,
      aux_sym_object_repeat1,
  [124697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6706), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6708), 1,
      sym_identifier,
    ACTIONS(6710), 1,
      anon_sym_LBRACK,
    ACTIONS(6712), 1,
      sym_private_property_identifier,
  [124719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 1,
      sym_identifier,
    STATE(1100), 1,
      sym_decorator_member_expression,
    STATE(1134), 1,
      sym_decorator_call_expression,
  [124732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6716), 1,
      sym_identifier,
    ACTIONS(6718), 1,
      anon_sym_LBRACK,
    ACTIONS(6720), 1,
      sym_private_property_identifier,
  [124745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6722), 1,
      sym_identifier,
    ACTIONS(6724), 1,
      anon_sym_LBRACK,
    ACTIONS(6726), 1,
      sym_private_property_identifier,
  [124758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6728), 1,
      sym_identifier,
    ACTIONS(6730), 1,
      anon_sym_LBRACK,
    ACTIONS(6732), 1,
      sym_private_property_identifier,
  [124771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4313), 1,
      anon_sym_RBRACK,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [124784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6734), 1,
      sym_identifier,
    ACTIONS(6736), 1,
      anon_sym_LBRACK,
    ACTIONS(6738), 1,
      sym_private_property_identifier,
  [124797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6742), 1,
      sym_identifier,
    ACTIONS(6744), 1,
      anon_sym_LBRACK,
    ACTIONS(6746), 1,
      sym_private_property_identifier,
  [124819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 1,
      anon_sym_DOT,
    ACTIONS(6748), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [124830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4325), 1,
      anon_sym_RPAREN,
    STATE(3562), 1,
      aux_sym_array_repeat1,
  [124843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6750), 1,
      anon_sym_EQ,
    ACTIONS(3063), 2,
      anon_sym_in,
      anon_sym_of,
  [124854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [124863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4342), 1,
      anon_sym_RPAREN,
    STATE(3433), 1,
      aux_sym_array_repeat1,
  [124885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6752), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_GT,
    ACTIONS(6754), 1,
      anon_sym_COMMA,
    STATE(3260), 1,
      aux_sym_implements_clause_repeat1,
  [124907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6756), 1,
      anon_sym_COMMA,
    ACTIONS(6758), 1,
      anon_sym_RBRACE,
    STATE(3443), 1,
      aux_sym_export_clause_repeat1,
  [124920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4353), 1,
      anon_sym_RPAREN,
    STATE(3475), 1,
      aux_sym_array_repeat1,
  [124933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4353), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [124946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4342), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [124968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2847), 1,
      sym_type_predicate,
    ACTIONS(6762), 2,
      sym_identifier,
      sym_this,
  [124979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(6766), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [125001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 1,
      anon_sym_DOT,
    ACTIONS(6768), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [125012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4325), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [125025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6770), 1,
      sym_identifier,
    ACTIONS(6772), 1,
      anon_sym_LBRACK,
    ACTIONS(6774), 1,
      sym_private_property_identifier,
  [125038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4269), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [125051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3192), 1,
      sym_type_predicate,
    ACTIONS(6776), 2,
      sym_identifier,
      sym_this,
  [125062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6778), 1,
      anon_sym_COMMA,
    ACTIONS(6780), 1,
      anon_sym_RPAREN,
    STATE(3421), 1,
      aux_sym_formal_parameters_repeat1,
  [125075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4269), 1,
      anon_sym_RPAREN,
    STATE(3424), 1,
      aux_sym_array_repeat1,
  [125088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_RPAREN,
    ACTIONS(6782), 1,
      anon_sym_COMMA,
    STATE(3445), 1,
      aux_sym_formal_parameters_repeat1,
  [125101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4344), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [125114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6784), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1242), 1,
      anon_sym_LBRACE,
    STATE(3190), 1,
      sym_object_type,
  [125136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_EQ,
    ACTIONS(6788), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [125156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4344), 1,
      anon_sym_RPAREN,
    STATE(3431), 1,
      aux_sym_array_repeat1,
  [125169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4358), 1,
      anon_sym_RPAREN,
    STATE(3492), 1,
      aux_sym_array_repeat1,
  [125182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4358), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [125195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(6790), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [125208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6792), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6794), 1,
      anon_sym_COMMA,
    ACTIONS(6796), 1,
      anon_sym_GT,
    STATE(3581), 1,
      aux_sym_type_parameters_repeat1,
  [125230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      sym_identifier,
    ACTIONS(6796), 1,
      anon_sym_GT,
    STATE(3803), 1,
      sym_type_parameter,
  [125243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6556), 1,
      anon_sym_COMMA,
    ACTIONS(6704), 1,
      anon_sym_RBRACE,
    STATE(3368), 1,
      aux_sym_object_repeat1,
  [125256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(6798), 1,
      anon_sym_RBRACE,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
  [125269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6800), 1,
      sym_identifier,
    ACTIONS(6802), 1,
      anon_sym_LBRACK,
    ACTIONS(6804), 1,
      sym_private_property_identifier,
  [125282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6556), 1,
      anon_sym_COMMA,
    ACTIONS(6806), 1,
      anon_sym_RBRACE,
    STATE(3368), 1,
      aux_sym_object_repeat1,
  [125295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2718), 1,
      anon_sym_GT,
    ACTIONS(6808), 1,
      anon_sym_COMMA,
    STATE(3260), 1,
      aux_sym_implements_clause_repeat1,
  [125308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6810), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_GT,
    ACTIONS(6812), 1,
      anon_sym_COMMA,
    STATE(3260), 1,
      aux_sym_implements_clause_repeat1,
  [125339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6814), 1,
      anon_sym_COMMA,
    ACTIONS(6816), 1,
      anon_sym_RBRACK,
    STATE(3442), 1,
      aux_sym_tuple_type_repeat1,
  [125352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6792), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6818), 1,
      anon_sym_RBRACK,
    STATE(3378), 1,
      aux_sym_array_pattern_repeat1,
  [125374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6820), 1,
      anon_sym_LPAREN,
    ACTIONS(6822), 1,
      anon_sym_await,
    STATE(31), 1,
      sym__for_header,
  [125387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(6824), 1,
      anon_sym_RBRACK,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [125400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 1,
      anon_sym_RPAREN,
    ACTIONS(6826), 1,
      anon_sym_COMMA,
    STATE(3445), 1,
      aux_sym_formal_parameters_repeat1,
  [125413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6828), 1,
      sym_identifier,
    ACTIONS(6830), 1,
      anon_sym_require,
    STATE(3476), 1,
      sym_nested_identifier,
  [125426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 1,
      sym_identifier,
    ACTIONS(5610), 1,
      anon_sym_LBRACK,
    ACTIONS(5612), 1,
      sym_private_property_identifier,
  [125439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(6673), 1,
      anon_sym_RBRACE,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
  [125452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_extends,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
  [125465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5047), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6832), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6834), 1,
      sym_identifier,
    ACTIONS(6836), 1,
      anon_sym_LBRACK,
    ACTIONS(6838), 1,
      sym_private_property_identifier,
  [125496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_COMMA,
    ACTIONS(6842), 1,
      anon_sym_RBRACK,
    STATE(3438), 1,
      aux_sym_tuple_type_repeat1,
  [125509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4313), 1,
      anon_sym_RBRACK,
    STATE(3375), 1,
      aux_sym_array_repeat1,
  [125522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6556), 1,
      anon_sym_COMMA,
    ACTIONS(6844), 1,
      anon_sym_RBRACE,
    STATE(3368), 1,
      aux_sym_object_repeat1,
  [125535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(6846), 1,
      anon_sym_RBRACE,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
  [125548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5460), 1,
      anon_sym_extends,
  [125561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(6848), 1,
      anon_sym_RBRACE,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
  [125574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6556), 1,
      anon_sym_COMMA,
    ACTIONS(6850), 1,
      anon_sym_RBRACE,
    STATE(3368), 1,
      aux_sym_object_repeat1,
  [125587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 1,
      anon_sym_from,
    ACTIONS(6657), 1,
      anon_sym_as,
    STATE(3698), 1,
      sym__from_clause,
  [125600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_extends,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
  [125613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3482), 1,
      anon_sym_LBRACE,
    ACTIONS(3484), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [125624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 1,
      anon_sym_LBRACE,
    ACTIONS(3648), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [125635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6852), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_LBRACE,
    ACTIONS(6089), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [125655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6856), 1,
      sym_identifier,
    ACTIONS(6858), 1,
      anon_sym_LBRACK,
    ACTIONS(6860), 1,
      sym_private_property_identifier,
  [125668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 1,
      sym_identifier,
    ACTIONS(5744), 1,
      anon_sym_LBRACK,
    ACTIONS(5746), 1,
      sym_private_property_identifier,
  [125681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6365), 1,
      anon_sym_RBRACK,
    STATE(3376), 1,
      aux_sym_array_pattern_repeat1,
  [125694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6862), 1,
      sym_identifier,
    ACTIONS(6864), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      sym_private_property_identifier,
  [125707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_COMMA,
    ACTIONS(6870), 1,
      anon_sym_RBRACE,
    STATE(3448), 1,
      aux_sym_export_clause_repeat1,
  [125720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [125729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6872), 1,
      anon_sym_as,
    ACTIONS(6874), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [125740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6876), 1,
      sym_identifier,
    ACTIONS(6878), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [125751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6880), 1,
      sym_identifier,
    ACTIONS(6882), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [125762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6884), 1,
      anon_sym_COMMA,
    ACTIONS(6886), 1,
      anon_sym_GT,
    STATE(3494), 1,
      aux_sym_type_parameters_repeat1,
  [125775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5534), 1,
      anon_sym_extends,
  [125788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6888), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6890), 1,
      anon_sym_LPAREN,
    ACTIONS(6892), 1,
      anon_sym_await,
    STATE(45), 1,
      sym__for_header,
  [125810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6888), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6896), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6898), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5299), 1,
      anon_sym_AMP,
    ACTIONS(5303), 1,
      anon_sym_PIPE,
    ACTIONS(5869), 1,
      anon_sym_extends,
  [125859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6900), 1,
      anon_sym_COMMA,
    ACTIONS(6903), 1,
      anon_sym_RBRACE,
    STATE(3548), 1,
      aux_sym_named_imports_repeat1,
  [125872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6334), 1,
      anon_sym_RBRACK,
    STATE(3378), 1,
      aux_sym_array_pattern_repeat1,
  [125885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4294), 1,
      anon_sym_RBRACK,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [125898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      anon_sym_SQUOTE,
    STATE(3863), 1,
      sym_string,
  [125911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6905), 1,
      anon_sym_COMMA,
    ACTIONS(6907), 1,
      anon_sym_RBRACE,
    STATE(3534), 1,
      aux_sym_export_clause_repeat1,
  [125924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 1,
      anon_sym_RBRACK,
    ACTIONS(6909), 1,
      anon_sym_COMMA,
    STATE(3400), 1,
      aux_sym_tuple_type_repeat1,
  [125937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_as,
    ACTIONS(6913), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [125948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(4294), 1,
      anon_sym_RBRACK,
    STATE(3508), 1,
      aux_sym_array_repeat1,
  [125961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    ACTIONS(6334), 1,
      anon_sym_RBRACK,
    STATE(3506), 1,
      aux_sym_array_pattern_repeat1,
  [125974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5722), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [125983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6915), 1,
      anon_sym_EQ,
    ACTIONS(3008), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [125994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6918), 1,
      anon_sym_COMMA,
    ACTIONS(6920), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      aux_sym_formal_parameters_repeat1,
  [126007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6922), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(6924), 1,
      anon_sym_RPAREN,
    STATE(3359), 1,
      aux_sym_array_repeat1,
  [126038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6926), 1,
      anon_sym_LBRACE,
    ACTIONS(6261), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [126049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6922), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(6928), 1,
      anon_sym_RBRACE,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
  [126071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6556), 1,
      anon_sym_COMMA,
    ACTIONS(6930), 1,
      anon_sym_RBRACE,
    STATE(3368), 1,
      aux_sym_object_repeat1,
  [126084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6556), 1,
      anon_sym_COMMA,
    ACTIONS(6930), 1,
      anon_sym_RBRACE,
    STATE(3519), 1,
      aux_sym_object_repeat1,
  [126106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 1,
      anon_sym_DQUOTE,
    ACTIONS(1260), 1,
      anon_sym_SQUOTE,
    STATE(3681), 1,
      sym_string,
  [126119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(6928), 1,
      anon_sym_RBRACE,
    STATE(3520), 1,
      aux_sym_object_pattern_repeat1,
  [126132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym_COMMA,
    ACTIONS(6690), 1,
      anon_sym_from,
    ACTIONS(6934), 1,
      anon_sym_EQ,
  [126145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6936), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    ACTIONS(6938), 1,
      anon_sym_RPAREN,
    STATE(3880), 1,
      sym_type_annotation,
  [126176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 1,
      anon_sym_RBRACK,
    ACTIONS(6940), 1,
      anon_sym_COMMA,
    STATE(3400), 1,
      aux_sym_tuple_type_repeat1,
  [126189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6888), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6942), 1,
      anon_sym_COMMA,
    ACTIONS(6944), 1,
      anon_sym_RBRACK,
    STATE(3575), 1,
      aux_sym_tuple_type_repeat1,
  [126220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_COMMA,
    ACTIONS(6946), 1,
      anon_sym_RBRACE,
    STATE(3371), 1,
      aux_sym_object_pattern_repeat1,
  [126233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 1,
      anon_sym_LBRACE,
    ACTIONS(6948), 1,
      sym_identifier,
    STATE(3129), 1,
      sym_export_clause,
  [126246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6950), 1,
      anon_sym_COMMA,
    ACTIONS(6953), 1,
      anon_sym_GT,
    STATE(3581), 1,
      aux_sym_type_parameters_repeat1,
  [126259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3697), 1,
      sym_type_predicate,
    ACTIONS(6955), 2,
      sym_identifier,
      sym_this,
  [126270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6957), 1,
      sym_identifier,
    STATE(2127), 1,
      sym_decorator_member_expression,
    STATE(2209), 1,
      sym_decorator_call_expression,
  [126283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_while,
    ACTIONS(6959), 1,
      anon_sym_else,
    STATE(713), 1,
      sym_else_clause,
  [126296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      sym_identifier,
    ACTIONS(6961), 1,
      anon_sym_GT,
    STATE(3803), 1,
      sym_type_parameter,
  [126309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_COMMA,
    ACTIONS(6965), 1,
      anon_sym_RBRACE,
    STATE(3441), 1,
      aux_sym_enum_body_repeat1,
  [126322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(6969), 1,
      anon_sym_RBRACE,
    STATE(3392), 1,
      aux_sym_named_imports_repeat1,
  [126335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_COMMA,
    ACTIONS(6973), 1,
      anon_sym_RBRACE,
    STATE(3441), 1,
      aux_sym_enum_body_repeat1,
  [126348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 1,
      anon_sym_COMMA,
    ACTIONS(6977), 1,
      anon_sym_RPAREN,
    STATE(3483), 1,
      aux_sym_formal_parameters_repeat1,
  [126361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6983), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1729), 1,
      sym_class_body,
  [126425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6985), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6987), 1,
      anon_sym_SEMI,
    ACTIONS(6989), 1,
      sym__automatic_semicolon,
  [126451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5055), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5019), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(2052), 1,
      sym_class_body,
  [126493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 1,
      anon_sym_LPAREN,
    STATE(2307), 1,
      sym_arguments,
  [126503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5015), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(2059), 1,
      sym_class_body,
  [126521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2987), 1,
      sym_formal_parameters,
  [126531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1880), 1,
      sym_class_body,
  [126541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3922), 1,
      sym_formal_parameters,
  [126551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6991), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [126567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5808), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [126575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5480), 2,
      anon_sym_in,
      anon_sym_of,
  [126583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1883), 1,
      sym_statement_block,
  [126601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4999), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1886), 1,
      sym_statement_block,
  [126619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6993), 1,
      anon_sym_LPAREN,
    STATE(3773), 1,
      sym_parenthesized_expression,
  [126645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(723), 1,
      sym_statement_block,
  [126655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [126663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(4048), 1,
      sym_formal_parameters,
  [126673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6995), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1790), 1,
      sym_class_body,
  [126707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1878), 1,
      sym_statement_block,
  [126717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [126725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3626), 1,
      sym_statement_block,
  [126735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6997), 1,
      sym_identifier,
    STATE(3460), 1,
      sym_nested_identifier,
  [126745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      sym_identifier,
    STATE(3539), 1,
      sym_type_parameter,
  [126755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1787), 1,
      sym_statement_block,
  [126765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6999), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym__for_header,
  [126775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7001), 1,
      sym_identifier,
    ACTIONS(7003), 1,
      anon_sym_STAR,
  [126785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7005), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [126801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5071), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 1,
      anon_sym_from,
    STATE(3699), 1,
      sym__from_clause,
  [126819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3637), 1,
      sym_statement_block,
  [126829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7007), 1,
      anon_sym_SEMI,
    ACTIONS(7009), 1,
      sym__automatic_semicolon,
  [126839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3031), 1,
      sym_formal_parameters,
  [126849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5540), 1,
      anon_sym_LBRACE,
    STATE(132), 1,
      sym_class_body,
  [126867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1781), 1,
      sym_class_body,
  [126877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5051), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    STATE(1875), 1,
      sym_arguments,
  [126895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7011), 1,
      anon_sym_SEMI,
    ACTIONS(7013), 1,
      sym__automatic_semicolon,
  [126905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3627), 1,
      sym_statement_block,
  [126915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3819), 1,
      sym_statement_block,
  [126925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2589), 1,
      sym_formal_parameters,
  [126935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(3049), 1,
      sym_statement_block,
  [126945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3639), 1,
      sym_statement_block,
  [126955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7015), 1,
      anon_sym_LPAREN,
    STATE(29), 1,
      sym_parenthesized_expression,
  [126965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7015), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_parenthesized_expression,
  [126975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7015), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym_parenthesized_expression,
  [126985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5055), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [126993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7015), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
  [127003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3644), 1,
      sym_statement_block,
  [127013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4999), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3817), 1,
      sym_statement_block,
  [127031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7015), 1,
      anon_sym_LPAREN,
    STATE(3830), 1,
      sym_parenthesized_expression,
  [127049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7017), 1,
      anon_sym_LBRACE,
    STATE(717), 1,
      sym_enum_body,
  [127059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      anon_sym_COLON,
    STATE(3471), 1,
      sym_type_annotation,
  [127069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(3072), 1,
      sym_statement_block,
  [127079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [127087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(599), 1,
      sym_class_body,
  [127097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5951), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [127105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym_statement_block,
  [127115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7015), 1,
      anon_sym_LPAREN,
    STATE(42), 1,
      sym_parenthesized_expression,
  [127125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(569), 1,
      sym_statement_block,
  [127135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7019), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [127143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(597), 1,
      sym_class_body,
  [127153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1868), 1,
      sym_class_body,
  [127163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 1,
      sym_identifier,
    ACTIONS(5612), 1,
      sym_private_property_identifier,
  [127173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7015), 1,
      anon_sym_LPAREN,
    STATE(34), 1,
      sym_parenthesized_expression,
  [127183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7017), 1,
      anon_sym_LBRACE,
    STATE(653), 1,
      sym_enum_body,
  [127201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7021), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7023), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(1311), 1,
      sym_class_body,
  [127235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7029), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    STATE(1316), 1,
      sym_statement_block,
  [127261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(3208), 1,
      sym_statement_block,
  [127271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1763), 1,
      sym_class_body,
  [127281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 1,
      sym_identifier,
    STATE(3476), 1,
      sym_nested_identifier,
  [127291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(646), 1,
      sym_statement_block,
  [127301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      sym_identifier,
    STATE(3397), 1,
      sym_type_parameter,
  [127311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(611), 1,
      sym_class_body,
  [127321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(3212), 1,
      sym_enum_body,
  [127331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5540), 1,
      anon_sym_LBRACE,
    STATE(140), 1,
      sym_class_body,
  [127341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 1,
      sym_identifier,
    ACTIONS(5746), 1,
      sym_private_property_identifier,
  [127351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5710), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [127359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7035), 1,
      anon_sym_SEMI,
    ACTIONS(7037), 1,
      sym__automatic_semicolon,
  [127369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7039), 1,
      anon_sym_SEMI,
    ACTIONS(7041), 1,
      sym__automatic_semicolon,
  [127379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_SEMI,
    ACTIONS(7045), 1,
      sym__automatic_semicolon,
  [127389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3661), 1,
      sym_statement_block,
  [127399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(3250), 1,
      sym_enum_body,
  [127409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_LPAREN,
    STATE(1567), 1,
      sym_arguments,
  [127419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7047), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1696), 1,
      sym_statement_block,
  [127437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6788), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1803), 1,
      sym_class_body,
  [127455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(1410), 1,
      sym_class_body,
  [127465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    STATE(1402), 1,
      sym_statement_block,
  [127475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    STATE(1381), 1,
      sym_statement_block,
  [127485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3647), 1,
      sym_statement_block,
  [127495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1811), 1,
      sym_class_body,
  [127513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(609), 1,
      sym_statement_block,
  [127523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1804), 1,
      sym_statement_block,
  [127533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 1,
      anon_sym_SEMI,
    ACTIONS(7051), 1,
      sym__automatic_semicolon,
  [127543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7053), 1,
      anon_sym_SEMI,
    ACTIONS(7055), 1,
      sym__automatic_semicolon,
  [127553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3857), 1,
      sym_formal_parameters,
  [127563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(1319), 1,
      sym_class_body,
  [127573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7057), 1,
      sym_identifier,
    ACTIONS(7059), 1,
      sym_private_property_identifier,
  [127583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1775), 1,
      sym_class_body,
  [127593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7061), 1,
      sym_identifier,
    ACTIONS(7063), 1,
      sym_private_property_identifier,
  [127603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      sym_identifier,
    ACTIONS(7069), 1,
      sym_private_property_identifier,
  [127621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3162), 1,
      sym_class_body,
  [127631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 1,
      sym_identifier,
    ACTIONS(6613), 1,
      sym_private_property_identifier,
  [127641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7071), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(1307), 1,
      sym_class_body,
  [127659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    STATE(1313), 1,
      sym_statement_block,
  [127669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7073), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [127677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5546), 1,
      anon_sym_LBRACE,
    STATE(696), 1,
      sym_class_body,
  [127687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 1,
      anon_sym_from,
    STATE(3717), 1,
      sym__from_clause,
  [127697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6734), 1,
      sym_identifier,
    ACTIONS(6738), 1,
      sym_private_property_identifier,
  [127707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6585), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [127715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7075), 1,
      sym_identifier,
    ACTIONS(7077), 1,
      sym_private_property_identifier,
  [127725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      sym_identifier,
    ACTIONS(7081), 1,
      sym_private_property_identifier,
  [127735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3930), 1,
      sym_formal_parameters,
  [127745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      sym_identifier,
    ACTIONS(7085), 1,
      sym_private_property_identifier,
  [127755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3658), 1,
      sym_statement_block,
  [127765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5019), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3663), 1,
      sym_statement_block,
  [127783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    STATE(2565), 1,
      sym_arguments,
  [127801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [127809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3883), 1,
      sym_formal_parameters,
  [127819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5015), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_LPAREN,
    STATE(2307), 1,
      sym_arguments,
  [127837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5546), 1,
      anon_sym_LBRACE,
    STATE(688), 1,
      sym_class_body,
  [127847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7087), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [127855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    STATE(1330), 1,
      sym_arguments,
  [127865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1288), 1,
      anon_sym_LBRACE,
    STATE(130), 1,
      sym_statement_block,
  [127875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7089), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [127883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7091), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1874), 1,
      sym_statement_block,
  [127901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(1970), 1,
      sym_class_body,
  [127911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1823), 1,
      sym_class_body,
  [127921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      sym_identifier,
    STATE(3803), 1,
      sym_type_parameter,
  [127931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4281), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    STATE(1348), 1,
      sym_statement_block,
  [127949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1820), 1,
      sym_statement_block,
  [127959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(2969), 1,
      sym_formal_parameters,
  [127969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3069), 1,
      sym_class_body,
  [127979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1812), 1,
      sym_class_body,
  [127989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(1400), 1,
      sym_class_body,
  [127999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3041), 1,
      sym_class_body,
  [128009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3040), 1,
      sym_class_body,
  [128019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(1390), 1,
      sym_class_body,
  [128029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    STATE(1388), 1,
      sym_statement_block,
  [128039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3870), 1,
      sym_formal_parameters,
  [128049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    STATE(1394), 1,
      sym_statement_block,
  [128059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(1391), 1,
      sym_class_body,
  [128069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5540), 1,
      anon_sym_LBRACE,
    STATE(136), 1,
      sym_class_body,
  [128079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7093), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(4120), 1,
      sym_formal_parameters,
  [128097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7095), 1,
      sym_identifier,
    ACTIONS(7097), 1,
      anon_sym_STAR,
  [128107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7099), 1,
      sym_identifier,
    ACTIONS(7101), 1,
      anon_sym_STAR,
  [128117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1791), 1,
      sym_statement_block,
  [128127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3004), 1,
      sym_class_body,
  [128137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1776), 1,
      sym_class_body,
  [128147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3023), 1,
      sym_class_body,
  [128157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(4151), 1,
      sym_formal_parameters,
  [128167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7103), 1,
      sym_identifier,
    ACTIONS(7105), 1,
      sym_private_property_identifier,
  [128177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 1,
      sym_identifier,
    ACTIONS(7109), 1,
      sym_private_property_identifier,
  [128187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7113), 1,
      sym_private_property_identifier,
  [128197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6770), 1,
      sym_identifier,
    ACTIONS(6774), 1,
      sym_private_property_identifier,
  [128207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3028), 1,
      sym_class_body,
  [128217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    STATE(1371), 1,
      sym_statement_block,
  [128227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_class_body,
  [128237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(2788), 1,
      sym_formal_parameters,
  [128247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7115), 1,
      sym_identifier,
    ACTIONS(7117), 1,
      anon_sym_STAR,
  [128257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_LPAREN,
    STATE(1240), 1,
      sym_arguments,
  [128267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 1,
      anon_sym_from,
    STATE(3649), 1,
      sym__from_clause,
  [128277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(3087), 1,
      sym_class_body,
  [128287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1288), 1,
      anon_sym_LBRACE,
    STATE(138), 1,
      sym_statement_block,
  [128297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6530), 1,
      sym_identifier,
    ACTIONS(6534), 1,
      sym_private_property_identifier,
  [128307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7119), 1,
      sym_identifier,
    ACTIONS(7121), 1,
      sym_private_property_identifier,
  [128317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4311), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      anon_sym_LPAREN,
    STATE(2669), 1,
      sym_formal_parameters,
  [128335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3712), 1,
      sym_statement_block,
  [128345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5546), 1,
      anon_sym_LBRACE,
    STATE(706), 1,
      sym_class_body,
  [128355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4309), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(4026), 1,
      sym_formal_parameters,
  [128373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [128381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7123), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7125), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5540), 1,
      anon_sym_LBRACE,
    STATE(129), 1,
      sym_class_body,
  [128407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7127), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    STATE(3838), 1,
      sym_type_annotation,
  [128425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7129), 1,
      sym_identifier,
    ACTIONS(7131), 1,
      sym_private_property_identifier,
  [128435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5546), 1,
      anon_sym_LBRACE,
    STATE(645), 1,
      sym_class_body,
  [128445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7133), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_LBRACE,
    STATE(606), 1,
      sym_statement_block,
  [128463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(4013), 1,
      sym_formal_parameters,
  [128473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7135), 1,
      anon_sym_in,
    ACTIONS(7137), 1,
      anon_sym_COLON,
  [128483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3198), 1,
      sym_formal_parameters,
  [128493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_LBRACE,
    STATE(610), 1,
      sym_class_body,
  [128503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3746), 1,
      sym_statement_block,
  [128521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [128529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(3740), 1,
      sym_statement_block,
  [128539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1831), 1,
      sym_statement_block,
  [128549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1832), 1,
      sym_class_body,
  [128559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7139), 1,
      sym_identifier,
    ACTIONS(7141), 1,
      sym_private_property_identifier,
  [128569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7143), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [128577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      anon_sym_LPAREN,
    STATE(2452), 1,
      sym_arguments,
  [128587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1715), 1,
      sym_class_body,
  [128597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6999), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym__for_header,
  [128607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3005), 1,
      sym_formal_parameters,
  [128617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6800), 1,
      sym_identifier,
    ACTIONS(6804), 1,
      sym_private_property_identifier,
  [128627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7145), 1,
      anon_sym_LBRACE,
    STATE(690), 1,
      sym_switch_body,
  [128637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7147), 1,
      sym_identifier,
    ACTIONS(7149), 1,
      sym_private_property_identifier,
  [128647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7151), 1,
      sym_identifier,
    ACTIONS(7153), 1,
      sym_private_property_identifier,
  [128657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7155), 1,
      sym_identifier,
    ACTIONS(7157), 1,
      sym_private_property_identifier,
  [128667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(614), 1,
      sym_statement_block,
  [128677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LBRACE,
    STATE(2049), 1,
      sym_class_body,
  [128687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 1,
      anon_sym_in,
    ACTIONS(6206), 1,
      anon_sym_of,
  [128697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    STATE(3730), 1,
      sym_type_annotation,
  [128707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [128715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1731), 1,
      sym_statement_block,
  [128725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1734), 1,
      sym_class_body,
  [128735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7161), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [128743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 1,
      anon_sym_from,
    STATE(3700), 1,
      sym__from_clause,
  [128753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3946), 1,
      sym_formal_parameters,
  [128763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7163), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_LBRACE,
    STATE(1738), 1,
      sym_class_body,
  [128781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_LBRACE,
    STATE(1736), 1,
      sym_statement_block,
  [128791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7165), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_LPAREN,
    STATE(3947), 1,
      sym_formal_parameters,
  [128809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7167), 1,
      anon_sym_RBRACK,
  [128816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7169), 1,
      anon_sym_RBRACK,
  [128823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7171), 1,
      anon_sym_RBRACK,
  [128830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7173), 1,
      anon_sym_RBRACK,
  [128837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7175), 1,
      anon_sym_RBRACK,
  [128844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7177), 1,
      anon_sym_RBRACK,
  [128851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_RBRACK,
  [128858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7181), 1,
      anon_sym_RBRACK,
  [128865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7183), 1,
      anon_sym_EQ_GT,
  [128872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7185), 1,
      anon_sym_RBRACK,
  [128879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7187), 1,
      anon_sym_RBRACK,
  [128886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7189), 1,
      anon_sym_from,
  [128893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6690), 1,
      anon_sym_from,
  [128900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3351), 1,
      anon_sym_DOT,
  [128907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_RPAREN,
  [128914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7193), 1,
      anon_sym_RBRACK,
  [128921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      sym_identifier,
  [128928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6657), 1,
      anon_sym_as,
  [128935] = 2,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(7197), 1,
      sym_regex_pattern,
  [128942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7199), 1,
      anon_sym_RBRACK,
  [128949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7201), 1,
      anon_sym_EQ_GT,
  [128956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7203), 1,
      anon_sym_EQ_GT,
  [128963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4573), 1,
      anon_sym_RPAREN,
  [128970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7205), 1,
      anon_sym_EQ_GT,
  [128977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7207), 1,
      anon_sym_EQ_GT,
  [128984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7209), 1,
      anon_sym_RBRACK,
  [128991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7211), 1,
      anon_sym_RBRACK,
  [128998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7213), 1,
      anon_sym_EQ_GT,
  [129005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7215), 1,
      sym_identifier,
  [129012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7217), 1,
      anon_sym_RBRACK,
  [129019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7219), 1,
      anon_sym_RBRACK,
  [129026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7221), 1,
      anon_sym_RPAREN,
  [129033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7223), 1,
      anon_sym_RBRACK,
  [129040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7225), 1,
      anon_sym_EQ,
  [129047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7227), 1,
      anon_sym_EQ_GT,
  [129054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7229), 1,
      sym_identifier,
  [129061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_EQ_GT,
  [129068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6667), 1,
      anon_sym_RBRACK,
  [129075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7233), 1,
      anon_sym_RBRACK,
  [129082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7235), 1,
      anon_sym_COLON,
  [129089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7237), 1,
      anon_sym_EQ_GT,
  [129096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_RPAREN,
  [129103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7241), 1,
      anon_sym_EQ_GT,
  [129110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7243), 1,
      anon_sym_EQ_GT,
  [129117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7245), 1,
      anon_sym_EQ_GT,
  [129124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7247), 1,
      anon_sym_RBRACK,
  [129131] = 2,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(7249), 1,
      sym_regex_pattern,
  [129138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7251), 1,
      sym_identifier,
  [129145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4201), 1,
      anon_sym_RPAREN,
  [129152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5643), 1,
      anon_sym_DOT,
  [129159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_RBRACK,
  [129166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7253), 1,
      anon_sym_SLASH2,
  [129173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_EQ_GT,
  [129180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7257), 1,
      anon_sym_while,
  [129187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4143), 1,
      anon_sym_RPAREN,
  [129194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7259), 1,
      anon_sym_RBRACK,
  [129201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7261), 1,
      sym_number,
  [129208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4089), 1,
      anon_sym_RPAREN,
  [129215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7263), 1,
      sym_number,
  [129222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7265), 1,
      anon_sym_RBRACK,
  [129229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7267), 1,
      anon_sym_RBRACK,
  [129236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7269), 1,
      anon_sym_RBRACK,
  [129243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7271), 1,
      anon_sym_RBRACK,
  [129250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      sym_identifier,
  [129257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7275), 1,
      anon_sym_RBRACK,
  [129264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7277), 1,
      anon_sym_RBRACK,
  [129271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7279), 1,
      anon_sym_EQ_GT,
  [129278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 1,
      anon_sym_DOT,
  [129285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7281), 1,
      anon_sym_RBRACK,
  [129292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7283), 1,
      anon_sym_RBRACK,
  [129299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym_RBRACK,
  [129306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7287), 1,
      anon_sym_SLASH2,
  [129313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7289), 1,
      anon_sym_RBRACK,
  [129320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7291), 1,
      anon_sym_EQ_GT,
  [129327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7293), 1,
      sym_identifier,
  [129334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_RBRACK,
  [129341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7297), 1,
      anon_sym_RBRACK,
  [129348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7299), 1,
      anon_sym_RBRACK,
  [129355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_RBRACK,
  [129362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7303), 1,
      anon_sym_RPAREN,
  [129369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7305), 1,
      anon_sym_RBRACK,
  [129376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_EQ_GT,
  [129383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7309), 1,
      anon_sym_class,
  [129390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 1,
      anon_sym_RBRACK,
  [129397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7313), 1,
      anon_sym_EQ_GT,
  [129404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 1,
      anon_sym_RBRACK,
  [129411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7317), 1,
      anon_sym_EQ,
  [129418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7319), 1,
      anon_sym_namespace,
  [129425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7321), 1,
      anon_sym_EQ_GT,
  [129432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7323), 1,
      anon_sym_RBRACK,
  [129439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7325), 1,
      anon_sym_RBRACK,
  [129446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7327), 1,
      anon_sym_LBRACK,
  [129453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6842), 1,
      anon_sym_RBRACK,
  [129460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7329), 1,
      anon_sym_RBRACK,
  [129467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_EQ_GT,
  [129474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_RBRACK,
  [129481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7335), 1,
      sym_identifier,
  [129488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      anon_sym_EQ_GT,
  [129495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7339), 1,
      anon_sym_EQ_GT,
  [129502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_EQ_GT,
  [129509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_RBRACK,
  [129516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7345), 1,
      anon_sym_EQ_GT,
  [129523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym_EQ_GT,
  [129530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_RBRACK,
  [129537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_RBRACK,
  [129544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6948), 1,
      sym_identifier,
  [129551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7353), 1,
      anon_sym_class,
  [129558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7355), 1,
      anon_sym_RBRACK,
  [129565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7357), 1,
      anon_sym_RBRACK,
  [129572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7359), 1,
      anon_sym_EQ,
  [129579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7361), 1,
      anon_sym_RBRACK,
  [129586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7363), 1,
      anon_sym_EQ,
  [129593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7365), 1,
      anon_sym_RBRACK,
  [129600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      sym_identifier,
  [129607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_RBRACK,
  [129614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7371), 1,
      anon_sym_RBRACK,
  [129621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7373), 1,
      anon_sym_RBRACK,
  [129628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 1,
      anon_sym_RBRACK,
  [129635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 1,
      anon_sym_RBRACK,
  [129642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7379), 1,
      anon_sym_function,
  [129649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7381), 1,
      anon_sym_RBRACK,
  [129656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7383), 1,
      anon_sym_RBRACK,
  [129663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7385), 1,
      anon_sym_RBRACK,
  [129670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7387), 1,
      anon_sym_RBRACK,
  [129677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7389), 1,
      anon_sym_RBRACK,
  [129684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7391), 1,
      sym_identifier,
  [129691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7393), 1,
      anon_sym_RBRACK,
  [129698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7395), 1,
      anon_sym_COLON,
  [129705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7397), 1,
      anon_sym_RBRACK,
  [129712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_RBRACK,
  [129719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7401), 1,
      sym_identifier,
  [129726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7403), 1,
      anon_sym_RBRACK,
  [129733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7405), 1,
      anon_sym_RBRACK,
  [129740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7407), 1,
      anon_sym_RBRACK,
  [129747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7409), 1,
      anon_sym_RBRACK,
  [129754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7411), 1,
      anon_sym_namespace,
  [129761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7413), 1,
      anon_sym_RBRACK,
  [129768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7415), 1,
      anon_sym_RBRACK,
  [129775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_RBRACK,
  [129782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7417), 1,
      anon_sym_RBRACK,
  [129789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7419), 1,
      anon_sym_RBRACK,
  [129796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7421), 1,
      sym_number,
  [129803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_RBRACK,
  [129810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7425), 1,
      anon_sym_RBRACK,
  [129817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6750), 1,
      anon_sym_EQ,
  [129824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7427), 1,
      sym_number,
  [129831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7429), 1,
      anon_sym_EQ_GT,
  [129838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7431), 1,
      sym_identifier,
  [129845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_EQ_GT,
  [129852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7435), 1,
      sym_identifier,
  [129859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_DOT,
  [129866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_EQ_GT,
  [129873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7439), 1,
      ts_builtin_sym_end,
  [129880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7441), 1,
      sym_identifier,
  [129887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7443), 1,
      sym_identifier,
  [129894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7445), 1,
      anon_sym_class,
  [129901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7447), 1,
      anon_sym_SLASH2,
  [129908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7449), 1,
      anon_sym_EQ,
  [129915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7451), 1,
      sym_identifier,
  [129922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      anon_sym_DOT,
  [129929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_EQ,
  [129936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 1,
      anon_sym_RBRACK,
  [129943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7455), 1,
      anon_sym_EQ_GT,
  [129950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      sym_identifier,
  [129957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7459), 1,
      anon_sym_EQ_GT,
  [129964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7461), 1,
      anon_sym_SLASH2,
  [129971] = 2,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(7463), 1,
      sym_regex_pattern,
  [129978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7465), 1,
      anon_sym_COLON,
  [129985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7467), 1,
      sym_identifier,
  [129992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 1,
      anon_sym_COLON,
  [129999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_EQ_GT,
  [130006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7473), 1,
      anon_sym_EQ_GT,
  [130013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7475), 1,
      anon_sym_EQ_GT,
  [130020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_EQ,
  [130027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 1,
      anon_sym_EQ_GT,
  [130034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7479), 1,
      anon_sym_from,
  [130041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym_LPAREN,
  [130048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7483), 1,
      anon_sym_EQ_GT,
  [130055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 1,
      anon_sym_RPAREN,
  [130062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7487), 1,
      anon_sym_from,
  [130069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7489), 1,
      anon_sym_RPAREN,
  [130076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7491), 1,
      anon_sym_from,
  [130083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7493), 1,
      anon_sym_RBRACK,
  [130090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7495), 1,
      anon_sym_require,
  [130097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7497), 1,
      anon_sym_RBRACK,
  [130104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7499), 1,
      anon_sym_RBRACK,
  [130111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7501), 1,
      anon_sym_RPAREN,
  [130118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7503), 1,
      anon_sym_RPAREN,
  [130125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7505), 1,
      anon_sym_RBRACK,
  [130132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4553), 1,
      anon_sym_RBRACK,
  [130139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 1,
      anon_sym_LBRACE,
  [130146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7507), 1,
      sym_identifier,
  [130153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7509), 1,
      anon_sym_RBRACK,
  [130160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5021), 1,
      anon_sym_EQ_GT,
  [130167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7511), 1,
      anon_sym_RBRACK,
  [130174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6468), 1,
      anon_sym_EQ_GT,
  [130181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7513), 1,
      anon_sym_EQ_GT,
  [130188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7515), 1,
      anon_sym_RBRACK,
  [130195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7517), 1,
      anon_sym_EQ_GT,
  [130202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7519), 1,
      anon_sym_EQ_GT,
  [130209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_EQ,
  [130216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_EQ_GT,
  [130223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7525), 1,
      anon_sym_EQ_GT,
  [130230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_EQ_GT,
  [130237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      sym_identifier,
  [130244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7531), 1,
      anon_sym_EQ_GT,
  [130251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7533), 1,
      anon_sym_RBRACK,
  [130258] = 2,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(7535), 1,
      sym_regex_pattern,
  [130265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6816), 1,
      anon_sym_RBRACK,
  [130272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7537), 1,
      anon_sym_target,
  [130279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7539), 1,
      anon_sym_RBRACE,
  [130286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7541), 1,
      anon_sym_from,
  [130293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7543), 1,
      anon_sym_RBRACK,
  [130300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_RPAREN,
  [130307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7547), 1,
      anon_sym_RBRACK,
  [130314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4571), 1,
      anon_sym_RBRACK,
  [130321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      anon_sym_RBRACK,
  [130328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      sym_identifier,
  [130335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7553), 1,
      anon_sym_RBRACK,
  [130342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7555), 1,
      anon_sym_EQ_GT,
  [130349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      anon_sym_RBRACE,
  [130356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7559), 1,
      anon_sym_RBRACK,
  [130363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7561), 1,
      anon_sym_RBRACK,
  [130370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7563), 1,
      sym_identifier,
  [130377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7565), 1,
      anon_sym_RBRACK,
  [130384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6645), 1,
      sym_identifier,
  [130391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7567), 1,
      anon_sym_RBRACK,
  [130398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7569), 1,
      anon_sym_RBRACK,
  [130405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7571), 1,
      anon_sym_target,
  [130412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7573), 1,
      sym_identifier,
  [130419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7575), 1,
      sym_identifier,
  [130426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7577), 1,
      anon_sym_EQ_GT,
  [130433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7579), 1,
      anon_sym_EQ_GT,
  [130440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7581), 1,
      anon_sym_RBRACK,
  [130447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7583), 1,
      anon_sym_EQ_GT,
  [130454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7585), 1,
      sym_identifier,
  [130461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7587), 1,
      anon_sym_RBRACK,
  [130468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7589), 1,
      anon_sym_RBRACK,
  [130475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7591), 1,
      anon_sym_from,
  [130482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7593), 1,
      sym_identifier,
  [130489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7595), 1,
      anon_sym_SLASH2,
  [130496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7597), 1,
      anon_sym_RBRACK,
  [130503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7599), 1,
      anon_sym_RBRACK,
  [130510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7601), 1,
      anon_sym_EQ,
  [130517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7603), 1,
      anon_sym_RBRACK,
  [130524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7605), 1,
      sym_identifier,
  [130531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7607), 1,
      anon_sym_EQ_GT,
  [130538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7609), 1,
      sym_identifier,
  [130545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7611), 1,
      sym_number,
  [130552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7613), 1,
      anon_sym_RBRACK,
  [130559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7615), 1,
      anon_sym_EQ_GT,
  [130566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7617), 1,
      anon_sym_COLON,
  [130573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7619), 1,
      anon_sym_EQ,
  [130580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7621), 1,
      anon_sym_RBRACK,
  [130587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7623), 1,
      sym_identifier,
  [130594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7625), 1,
      anon_sym_EQ_GT,
  [130601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4206), 1,
      anon_sym_RPAREN,
  [130608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7627), 1,
      anon_sym_EQ_GT,
  [130615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7629), 1,
      anon_sym_EQ_GT,
  [130622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7631), 1,
      anon_sym_RBRACK,
  [130629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7633), 1,
      anon_sym_RBRACK,
  [130636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7635), 1,
      anon_sym_RBRACK,
  [130643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7637), 1,
      anon_sym_RBRACK,
  [130650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7639), 1,
      sym_identifier,
  [130657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4536), 1,
      anon_sym_RPAREN,
  [130664] = 2,
    ACTIONS(6269), 1,
      sym_comment,
    ACTIONS(7641), 1,
      sym_regex_pattern,
  [130671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7643), 1,
      sym_identifier,
  [130678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5647), 1,
      anon_sym_EQ,
  [130685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7645), 1,
      anon_sym_RBRACK,
  [130692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7647), 1,
      anon_sym_RBRACK,
  [130699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      sym_identifier,
  [130706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7651), 1,
      anon_sym_EQ_GT,
  [130713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7653), 1,
      sym_identifier,
  [130720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7655), 1,
      anon_sym_EQ,
  [130727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7657), 1,
      anon_sym_RBRACK,
  [130734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4408), 1,
      anon_sym_RBRACK,
  [130741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7659), 1,
      sym_identifier,
  [130748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7661), 1,
      sym_identifier,
  [130755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      sym_identifier,
  [130762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3751), 1,
      anon_sym_DOT,
  [130769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7665), 1,
      anon_sym_EQ_GT,
  [130776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      anon_sym_from,
  [130783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym_readonly,
  [130790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7671), 1,
      sym_identifier,
  [130797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7673), 1,
      anon_sym_function,
  [130804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      anon_sym_from,
  [130811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_EQ,
  [130818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7677), 1,
      sym_identifier,
  [130825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7679), 1,
      sym_identifier,
  [130832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7681), 1,
      sym_identifier,
  [130839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7683), 1,
      sym_identifier,
  [130846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7685), 1,
      sym_identifier,
  [130853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      sym_identifier,
  [130860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7689), 1,
      anon_sym_RPAREN,
  [130867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4400), 1,
      anon_sym_RBRACE,
  [130874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3193), 1,
      anon_sym_LPAREN,
  [130881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4507), 1,
      anon_sym_COLON,
  [130888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7691), 1,
      anon_sym_RBRACE,
  [130895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4505), 1,
      anon_sym_RPAREN,
  [130902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7693), 1,
      sym_identifier,
  [130909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4503), 1,
      anon_sym_RPAREN,
  [130916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4498), 1,
      anon_sym_RPAREN,
  [130923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7695), 1,
      anon_sym_EQ_GT,
  [130930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_EQ_GT,
  [130937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7699), 1,
      anon_sym_class,
  [130944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7701), 1,
      anon_sym_LBRACE,
  [130951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7703), 1,
      sym_identifier,
  [130958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7705), 1,
      sym_identifier,
  [130965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7707), 1,
      sym_identifier,
  [130972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7709), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(855)] = 0,
  [SMALL_STATE(856)] = 131,
  [SMALL_STATE(857)] = 262,
  [SMALL_STATE(858)] = 393,
  [SMALL_STATE(859)] = 524,
  [SMALL_STATE(860)] = 655,
  [SMALL_STATE(861)] = 786,
  [SMALL_STATE(862)] = 917,
  [SMALL_STATE(863)] = 1048,
  [SMALL_STATE(864)] = 1179,
  [SMALL_STATE(865)] = 1310,
  [SMALL_STATE(866)] = 1441,
  [SMALL_STATE(867)] = 1572,
  [SMALL_STATE(868)] = 1703,
  [SMALL_STATE(869)] = 1834,
  [SMALL_STATE(870)] = 1965,
  [SMALL_STATE(871)] = 2096,
  [SMALL_STATE(872)] = 2227,
  [SMALL_STATE(873)] = 2358,
  [SMALL_STATE(874)] = 2489,
  [SMALL_STATE(875)] = 2620,
  [SMALL_STATE(876)] = 2751,
  [SMALL_STATE(877)] = 2882,
  [SMALL_STATE(878)] = 3013,
  [SMALL_STATE(879)] = 3144,
  [SMALL_STATE(880)] = 3275,
  [SMALL_STATE(881)] = 3406,
  [SMALL_STATE(882)] = 3537,
  [SMALL_STATE(883)] = 3668,
  [SMALL_STATE(884)] = 3799,
  [SMALL_STATE(885)] = 3930,
  [SMALL_STATE(886)] = 4061,
  [SMALL_STATE(887)] = 4192,
  [SMALL_STATE(888)] = 4325,
  [SMALL_STATE(889)] = 4456,
  [SMALL_STATE(890)] = 4587,
  [SMALL_STATE(891)] = 4718,
  [SMALL_STATE(892)] = 4849,
  [SMALL_STATE(893)] = 4980,
  [SMALL_STATE(894)] = 5111,
  [SMALL_STATE(895)] = 5242,
  [SMALL_STATE(896)] = 5373,
  [SMALL_STATE(897)] = 5504,
  [SMALL_STATE(898)] = 5635,
  [SMALL_STATE(899)] = 5766,
  [SMALL_STATE(900)] = 5897,
  [SMALL_STATE(901)] = 6028,
  [SMALL_STATE(902)] = 6159,
  [SMALL_STATE(903)] = 6290,
  [SMALL_STATE(904)] = 6421,
  [SMALL_STATE(905)] = 6552,
  [SMALL_STATE(906)] = 6683,
  [SMALL_STATE(907)] = 6772,
  [SMALL_STATE(908)] = 6903,
  [SMALL_STATE(909)] = 7034,
  [SMALL_STATE(910)] = 7165,
  [SMALL_STATE(911)] = 7296,
  [SMALL_STATE(912)] = 7427,
  [SMALL_STATE(913)] = 7558,
  [SMALL_STATE(914)] = 7689,
  [SMALL_STATE(915)] = 7820,
  [SMALL_STATE(916)] = 7951,
  [SMALL_STATE(917)] = 8082,
  [SMALL_STATE(918)] = 8213,
  [SMALL_STATE(919)] = 8344,
  [SMALL_STATE(920)] = 8475,
  [SMALL_STATE(921)] = 8608,
  [SMALL_STATE(922)] = 8739,
  [SMALL_STATE(923)] = 8870,
  [SMALL_STATE(924)] = 9001,
  [SMALL_STATE(925)] = 9132,
  [SMALL_STATE(926)] = 9263,
  [SMALL_STATE(927)] = 9394,
  [SMALL_STATE(928)] = 9525,
  [SMALL_STATE(929)] = 9656,
  [SMALL_STATE(930)] = 9787,
  [SMALL_STATE(931)] = 9918,
  [SMALL_STATE(932)] = 10049,
  [SMALL_STATE(933)] = 10180,
  [SMALL_STATE(934)] = 10269,
  [SMALL_STATE(935)] = 10400,
  [SMALL_STATE(936)] = 10531,
  [SMALL_STATE(937)] = 10662,
  [SMALL_STATE(938)] = 10793,
  [SMALL_STATE(939)] = 10924,
  [SMALL_STATE(940)] = 11055,
  [SMALL_STATE(941)] = 11186,
  [SMALL_STATE(942)] = 11317,
  [SMALL_STATE(943)] = 11448,
  [SMALL_STATE(944)] = 11579,
  [SMALL_STATE(945)] = 11710,
  [SMALL_STATE(946)] = 11841,
  [SMALL_STATE(947)] = 11972,
  [SMALL_STATE(948)] = 12103,
  [SMALL_STATE(949)] = 12234,
  [SMALL_STATE(950)] = 12365,
  [SMALL_STATE(951)] = 12496,
  [SMALL_STATE(952)] = 12627,
  [SMALL_STATE(953)] = 12758,
  [SMALL_STATE(954)] = 12889,
  [SMALL_STATE(955)] = 13020,
  [SMALL_STATE(956)] = 13151,
  [SMALL_STATE(957)] = 13282,
  [SMALL_STATE(958)] = 13415,
  [SMALL_STATE(959)] = 13546,
  [SMALL_STATE(960)] = 13677,
  [SMALL_STATE(961)] = 13808,
  [SMALL_STATE(962)] = 13939,
  [SMALL_STATE(963)] = 14070,
  [SMALL_STATE(964)] = 14201,
  [SMALL_STATE(965)] = 14332,
  [SMALL_STATE(966)] = 14463,
  [SMALL_STATE(967)] = 14551,
  [SMALL_STATE(968)] = 14639,
  [SMALL_STATE(969)] = 14727,
  [SMALL_STATE(970)] = 14819,
  [SMALL_STATE(971)] = 14909,
  [SMALL_STATE(972)] = 14999,
  [SMALL_STATE(973)] = 15089,
  [SMALL_STATE(974)] = 15179,
  [SMALL_STATE(975)] = 15271,
  [SMALL_STATE(976)] = 15359,
  [SMALL_STATE(977)] = 15450,
  [SMALL_STATE(978)] = 15541,
  [SMALL_STATE(979)] = 15634,
  [SMALL_STATE(980)] = 15721,
  [SMALL_STATE(981)] = 15812,
  [SMALL_STATE(982)] = 15899,
  [SMALL_STATE(983)] = 15985,
  [SMALL_STATE(984)] = 16115,
  [SMALL_STATE(985)] = 16245,
  [SMALL_STATE(986)] = 16331,
  [SMALL_STATE(987)] = 16399,
  [SMALL_STATE(988)] = 16467,
  [SMALL_STATE(989)] = 16553,
  [SMALL_STATE(990)] = 16639,
  [SMALL_STATE(991)] = 16707,
  [SMALL_STATE(992)] = 16795,
  [SMALL_STATE(993)] = 16883,
  [SMALL_STATE(994)] = 16969,
  [SMALL_STATE(995)] = 17059,
  [SMALL_STATE(996)] = 17147,
  [SMALL_STATE(997)] = 17233,
  [SMALL_STATE(998)] = 17319,
  [SMALL_STATE(999)] = 17407,
  [SMALL_STATE(1000)] = 17495,
  [SMALL_STATE(1001)] = 17583,
  [SMALL_STATE(1002)] = 17651,
  [SMALL_STATE(1003)] = 17719,
  [SMALL_STATE(1004)] = 17807,
  [SMALL_STATE(1005)] = 17895,
  [SMALL_STATE(1006)] = 17980,
  [SMALL_STATE(1007)] = 18073,
  [SMALL_STATE(1008)] = 18158,
  [SMALL_STATE(1009)] = 18243,
  [SMALL_STATE(1010)] = 18330,
  [SMALL_STATE(1011)] = 18417,
  [SMALL_STATE(1012)] = 18484,
  [SMALL_STATE(1013)] = 18573,
  [SMALL_STATE(1014)] = 18644,
  [SMALL_STATE(1015)] = 18731,
  [SMALL_STATE(1016)] = 18818,
  [SMALL_STATE(1017)] = 18885,
  [SMALL_STATE(1018)] = 18969,
  [SMALL_STATE(1019)] = 19045,
  [SMALL_STATE(1020)] = 19121,
  [SMALL_STATE(1021)] = 19197,
  [SMALL_STATE(1022)] = 19287,
  [SMALL_STATE(1023)] = 19363,
  [SMALL_STATE(1024)] = 19449,
  [SMALL_STATE(1025)] = 19535,
  [SMALL_STATE(1026)] = 19621,
  [SMALL_STATE(1027)] = 19697,
  [SMALL_STATE(1028)] = 19787,
  [SMALL_STATE(1029)] = 19865,
  [SMALL_STATE(1030)] = 19949,
  [SMALL_STATE(1031)] = 20025,
  [SMALL_STATE(1032)] = 20109,
  [SMALL_STATE(1033)] = 20187,
  [SMALL_STATE(1034)] = 20258,
  [SMALL_STATE(1035)] = 20329,
  [SMALL_STATE(1036)] = 20406,
  [SMALL_STATE(1037)] = 20489,
  [SMALL_STATE(1038)] = 20574,
  [SMALL_STATE(1039)] = 20657,
  [SMALL_STATE(1040)] = 20728,
  [SMALL_STATE(1041)] = 20813,
  [SMALL_STATE(1042)] = 20888,
  [SMALL_STATE(1043)] = 20969,
  [SMALL_STATE(1044)] = 21042,
  [SMALL_STATE(1045)] = 21127,
  [SMALL_STATE(1046)] = 21200,
  [SMALL_STATE(1047)] = 21271,
  [SMALL_STATE(1048)] = 21358,
  [SMALL_STATE(1049)] = 21443,
  [SMALL_STATE(1050)] = 21518,
  [SMALL_STATE(1051)] = 21595,
  [SMALL_STATE(1052)] = 21680,
  [SMALL_STATE(1053)] = 21753,
  [SMALL_STATE(1054)] = 21836,
  [SMALL_STATE(1055)] = 21917,
  [SMALL_STATE(1056)] = 21985,
  [SMALL_STATE(1057)] = 22055,
  [SMALL_STATE(1058)] = 22131,
  [SMALL_STATE(1059)] = 22199,
  [SMALL_STATE(1060)] = 22263,
  [SMALL_STATE(1061)] = 22339,
  [SMALL_STATE(1062)] = 22409,
  [SMALL_STATE(1063)] = 22491,
  [SMALL_STATE(1064)] = 22555,
  [SMALL_STATE(1065)] = 22629,
  [SMALL_STATE(1066)] = 22693,
  [SMALL_STATE(1067)] = 22775,
  [SMALL_STATE(1068)] = 22845,
  [SMALL_STATE(1069)] = 22909,
  [SMALL_STATE(1070)] = 22981,
  [SMALL_STATE(1071)] = 23059,
  [SMALL_STATE(1072)] = 23131,
  [SMALL_STATE(1073)] = 23215,
  [SMALL_STATE(1074)] = 23289,
  [SMALL_STATE(1075)] = 23361,
  [SMALL_STATE(1076)] = 23439,
  [SMALL_STATE(1077)] = 23511,
  [SMALL_STATE(1078)] = 23587,
  [SMALL_STATE(1079)] = 23659,
  [SMALL_STATE(1080)] = 23729,
  [SMALL_STATE(1081)] = 23809,
  [SMALL_STATE(1082)] = 23883,
  [SMALL_STATE(1083)] = 23967,
  [SMALL_STATE(1084)] = 24037,
  [SMALL_STATE(1085)] = 24107,
  [SMALL_STATE(1086)] = 24177,
  [SMALL_STATE(1087)] = 24241,
  [SMALL_STATE(1088)] = 24313,
  [SMALL_STATE(1089)] = 24377,
  [SMALL_STATE(1090)] = 24447,
  [SMALL_STATE(1091)] = 24511,
  [SMALL_STATE(1092)] = 24586,
  [SMALL_STATE(1093)] = 24667,
  [SMALL_STATE(1094)] = 24736,
  [SMALL_STATE(1095)] = 24803,
  [SMALL_STATE(1096)] = 24874,
  [SMALL_STATE(1097)] = 24945,
  [SMALL_STATE(1098)] = 25016,
  [SMALL_STATE(1099)] = 25091,
  [SMALL_STATE(1100)] = 25158,
  [SMALL_STATE(1101)] = 25227,
  [SMALL_STATE(1102)] = 25298,
  [SMALL_STATE(1103)] = 25367,
  [SMALL_STATE(1104)] = 25450,
  [SMALL_STATE(1105)] = 25533,
  [SMALL_STATE(1106)] = 25602,
  [SMALL_STATE(1107)] = 25679,
  [SMALL_STATE(1108)] = 25748,
  [SMALL_STATE(1109)] = 25817,
  [SMALL_STATE(1110)] = 25892,
  [SMALL_STATE(1111)] = 25963,
  [SMALL_STATE(1112)] = 26033,
  [SMALL_STATE(1113)] = 26107,
  [SMALL_STATE(1114)] = 26175,
  [SMALL_STATE(1115)] = 26237,
  [SMALL_STATE(1116)] = 26305,
  [SMALL_STATE(1117)] = 26377,
  [SMALL_STATE(1118)] = 26445,
  [SMALL_STATE(1119)] = 26515,
  [SMALL_STATE(1120)] = 26585,
  [SMALL_STATE(1121)] = 26657,
  [SMALL_STATE(1122)] = 26729,
  [SMALL_STATE(1123)] = 26801,
  [SMALL_STATE(1124)] = 26867,
  [SMALL_STATE(1125)] = 26935,
  [SMALL_STATE(1126)] = 27003,
  [SMALL_STATE(1127)] = 27071,
  [SMALL_STATE(1128)] = 27139,
  [SMALL_STATE(1129)] = 27207,
  [SMALL_STATE(1130)] = 27278,
  [SMALL_STATE(1131)] = 27347,
  [SMALL_STATE(1132)] = 27414,
  [SMALL_STATE(1133)] = 27481,
  [SMALL_STATE(1134)] = 27542,
  [SMALL_STATE(1135)] = 27603,
  [SMALL_STATE(1136)] = 27674,
  [SMALL_STATE(1137)] = 27739,
  [SMALL_STATE(1138)] = 27806,
  [SMALL_STATE(1139)] = 27873,
  [SMALL_STATE(1140)] = 27942,
  [SMALL_STATE(1141)] = 28003,
  [SMALL_STATE(1142)] = 28068,
  [SMALL_STATE(1143)] = 28134,
  [SMALL_STATE(1144)] = 28198,
  [SMALL_STATE(1145)] = 28266,
  [SMALL_STATE(1146)] = 28332,
  [SMALL_STATE(1147)] = 28398,
  [SMALL_STATE(1148)] = 28511,
  [SMALL_STATE(1149)] = 28624,
  [SMALL_STATE(1150)] = 28737,
  [SMALL_STATE(1151)] = 28850,
  [SMALL_STATE(1152)] = 28963,
  [SMALL_STATE(1153)] = 29076,
  [SMALL_STATE(1154)] = 29194,
  [SMALL_STATE(1155)] = 29312,
  [SMALL_STATE(1156)] = 29430,
  [SMALL_STATE(1157)] = 29548,
  [SMALL_STATE(1158)] = 29666,
  [SMALL_STATE(1159)] = 29775,
  [SMALL_STATE(1160)] = 29884,
  [SMALL_STATE(1161)] = 29961,
  [SMALL_STATE(1162)] = 30070,
  [SMALL_STATE(1163)] = 30179,
  [SMALL_STATE(1164)] = 30288,
  [SMALL_STATE(1165)] = 30397,
  [SMALL_STATE(1166)] = 30506,
  [SMALL_STATE(1167)] = 30615,
  [SMALL_STATE(1168)] = 30724,
  [SMALL_STATE(1169)] = 30833,
  [SMALL_STATE(1170)] = 30942,
  [SMALL_STATE(1171)] = 31051,
  [SMALL_STATE(1172)] = 31160,
  [SMALL_STATE(1173)] = 31269,
  [SMALL_STATE(1174)] = 31378,
  [SMALL_STATE(1175)] = 31487,
  [SMALL_STATE(1176)] = 31596,
  [SMALL_STATE(1177)] = 31705,
  [SMALL_STATE(1178)] = 31813,
  [SMALL_STATE(1179)] = 31923,
  [SMALL_STATE(1180)] = 32028,
  [SMALL_STATE(1181)] = 32133,
  [SMALL_STATE(1182)] = 32238,
  [SMALL_STATE(1183)] = 32293,
  [SMALL_STATE(1184)] = 32398,
  [SMALL_STATE(1185)] = 32503,
  [SMALL_STATE(1186)] = 32558,
  [SMALL_STATE(1187)] = 32663,
  [SMALL_STATE(1188)] = 32768,
  [SMALL_STATE(1189)] = 32866,
  [SMALL_STATE(1190)] = 32964,
  [SMALL_STATE(1191)] = 33062,
  [SMALL_STATE(1192)] = 33160,
  [SMALL_STATE(1193)] = 33258,
  [SMALL_STATE(1194)] = 33356,
  [SMALL_STATE(1195)] = 33454,
  [SMALL_STATE(1196)] = 33516,
  [SMALL_STATE(1197)] = 33579,
  [SMALL_STATE(1198)] = 33642,
  [SMALL_STATE(1199)] = 33699,
  [SMALL_STATE(1200)] = 33762,
  [SMALL_STATE(1201)] = 33817,
  [SMALL_STATE(1202)] = 33884,
  [SMALL_STATE(1203)] = 33937,
  [SMALL_STATE(1204)] = 33990,
  [SMALL_STATE(1205)] = 34047,
  [SMALL_STATE(1206)] = 34106,
  [SMALL_STATE(1207)] = 34163,
  [SMALL_STATE(1208)] = 34222,
  [SMALL_STATE(1209)] = 34274,
  [SMALL_STATE(1210)] = 34326,
  [SMALL_STATE(1211)] = 34378,
  [SMALL_STATE(1212)] = 34430,
  [SMALL_STATE(1213)] = 34484,
  [SMALL_STATE(1214)] = 34574,
  [SMALL_STATE(1215)] = 34626,
  [SMALL_STATE(1216)] = 34684,
  [SMALL_STATE(1217)] = 34736,
  [SMALL_STATE(1218)] = 34790,
  [SMALL_STATE(1219)] = 34846,
  [SMALL_STATE(1220)] = 34904,
  [SMALL_STATE(1221)] = 34956,
  [SMALL_STATE(1222)] = 35008,
  [SMALL_STATE(1223)] = 35064,
  [SMALL_STATE(1224)] = 35116,
  [SMALL_STATE(1225)] = 35168,
  [SMALL_STATE(1226)] = 35222,
  [SMALL_STATE(1227)] = 35276,
  [SMALL_STATE(1228)] = 35328,
  [SMALL_STATE(1229)] = 35380,
  [SMALL_STATE(1230)] = 35432,
  [SMALL_STATE(1231)] = 35484,
  [SMALL_STATE(1232)] = 35536,
  [SMALL_STATE(1233)] = 35588,
  [SMALL_STATE(1234)] = 35640,
  [SMALL_STATE(1235)] = 35700,
  [SMALL_STATE(1236)] = 35752,
  [SMALL_STATE(1237)] = 35804,
  [SMALL_STATE(1238)] = 35856,
  [SMALL_STATE(1239)] = 35908,
  [SMALL_STATE(1240)] = 35960,
  [SMALL_STATE(1241)] = 36012,
  [SMALL_STATE(1242)] = 36064,
  [SMALL_STATE(1243)] = 36116,
  [SMALL_STATE(1244)] = 36168,
  [SMALL_STATE(1245)] = 36220,
  [SMALL_STATE(1246)] = 36272,
  [SMALL_STATE(1247)] = 36324,
  [SMALL_STATE(1248)] = 36376,
  [SMALL_STATE(1249)] = 36430,
  [SMALL_STATE(1250)] = 36482,
  [SMALL_STATE(1251)] = 36534,
  [SMALL_STATE(1252)] = 36586,
  [SMALL_STATE(1253)] = 36638,
  [SMALL_STATE(1254)] = 36692,
  [SMALL_STATE(1255)] = 36744,
  [SMALL_STATE(1256)] = 36796,
  [SMALL_STATE(1257)] = 36848,
  [SMALL_STATE(1258)] = 36900,
  [SMALL_STATE(1259)] = 36952,
  [SMALL_STATE(1260)] = 37004,
  [SMALL_STATE(1261)] = 37056,
  [SMALL_STATE(1262)] = 37108,
  [SMALL_STATE(1263)] = 37160,
  [SMALL_STATE(1264)] = 37212,
  [SMALL_STATE(1265)] = 37270,
  [SMALL_STATE(1266)] = 37322,
  [SMALL_STATE(1267)] = 37382,
  [SMALL_STATE(1268)] = 37440,
  [SMALL_STATE(1269)] = 37496,
  [SMALL_STATE(1270)] = 37548,
  [SMALL_STATE(1271)] = 37600,
  [SMALL_STATE(1272)] = 37658,
  [SMALL_STATE(1273)] = 37710,
  [SMALL_STATE(1274)] = 37762,
  [SMALL_STATE(1275)] = 37814,
  [SMALL_STATE(1276)] = 37866,
  [SMALL_STATE(1277)] = 37918,
  [SMALL_STATE(1278)] = 37972,
  [SMALL_STATE(1279)] = 38024,
  [SMALL_STATE(1280)] = 38076,
  [SMALL_STATE(1281)] = 38130,
  [SMALL_STATE(1282)] = 38184,
  [SMALL_STATE(1283)] = 38236,
  [SMALL_STATE(1284)] = 38294,
  [SMALL_STATE(1285)] = 38350,
  [SMALL_STATE(1286)] = 38408,
  [SMALL_STATE(1287)] = 38460,
  [SMALL_STATE(1288)] = 38512,
  [SMALL_STATE(1289)] = 38564,
  [SMALL_STATE(1290)] = 38616,
  [SMALL_STATE(1291)] = 38668,
  [SMALL_STATE(1292)] = 38720,
  [SMALL_STATE(1293)] = 38772,
  [SMALL_STATE(1294)] = 38824,
  [SMALL_STATE(1295)] = 38876,
  [SMALL_STATE(1296)] = 38928,
  [SMALL_STATE(1297)] = 38980,
  [SMALL_STATE(1298)] = 39032,
  [SMALL_STATE(1299)] = 39084,
  [SMALL_STATE(1300)] = 39140,
  [SMALL_STATE(1301)] = 39192,
  [SMALL_STATE(1302)] = 39244,
  [SMALL_STATE(1303)] = 39302,
  [SMALL_STATE(1304)] = 39354,
  [SMALL_STATE(1305)] = 39406,
  [SMALL_STATE(1306)] = 39458,
  [SMALL_STATE(1307)] = 39510,
  [SMALL_STATE(1308)] = 39561,
  [SMALL_STATE(1309)] = 39666,
  [SMALL_STATE(1310)] = 39721,
  [SMALL_STATE(1311)] = 39772,
  [SMALL_STATE(1312)] = 39823,
  [SMALL_STATE(1313)] = 39874,
  [SMALL_STATE(1314)] = 39925,
  [SMALL_STATE(1315)] = 39976,
  [SMALL_STATE(1316)] = 40081,
  [SMALL_STATE(1317)] = 40132,
  [SMALL_STATE(1318)] = 40183,
  [SMALL_STATE(1319)] = 40234,
  [SMALL_STATE(1320)] = 40285,
  [SMALL_STATE(1321)] = 40344,
  [SMALL_STATE(1322)] = 40395,
  [SMALL_STATE(1323)] = 40446,
  [SMALL_STATE(1324)] = 40497,
  [SMALL_STATE(1325)] = 40602,
  [SMALL_STATE(1326)] = 40653,
  [SMALL_STATE(1327)] = 40758,
  [SMALL_STATE(1328)] = 40863,
  [SMALL_STATE(1329)] = 40918,
  [SMALL_STATE(1330)] = 40971,
  [SMALL_STATE(1331)] = 41022,
  [SMALL_STATE(1332)] = 41093,
  [SMALL_STATE(1333)] = 41144,
  [SMALL_STATE(1334)] = 41201,
  [SMALL_STATE(1335)] = 41252,
  [SMALL_STATE(1336)] = 41359,
  [SMALL_STATE(1337)] = 41412,
  [SMALL_STATE(1338)] = 41463,
  [SMALL_STATE(1339)] = 41544,
  [SMALL_STATE(1340)] = 41595,
  [SMALL_STATE(1341)] = 41650,
  [SMALL_STATE(1342)] = 41745,
  [SMALL_STATE(1343)] = 41842,
  [SMALL_STATE(1344)] = 41919,
  [SMALL_STATE(1345)] = 42008,
  [SMALL_STATE(1346)] = 42099,
  [SMALL_STATE(1347)] = 42192,
  [SMALL_STATE(1348)] = 42249,
  [SMALL_STATE(1349)] = 42300,
  [SMALL_STATE(1350)] = 42375,
  [SMALL_STATE(1351)] = 42426,
  [SMALL_STATE(1352)] = 42495,
  [SMALL_STATE(1353)] = 42580,
  [SMALL_STATE(1354)] = 42679,
  [SMALL_STATE(1355)] = 42730,
  [SMALL_STATE(1356)] = 42781,
  [SMALL_STATE(1357)] = 42832,
  [SMALL_STATE(1358)] = 42937,
  [SMALL_STATE(1359)] = 42988,
  [SMALL_STATE(1360)] = 43041,
  [SMALL_STATE(1361)] = 43146,
  [SMALL_STATE(1362)] = 43197,
  [SMALL_STATE(1363)] = 43302,
  [SMALL_STATE(1364)] = 43353,
  [SMALL_STATE(1365)] = 43404,
  [SMALL_STATE(1366)] = 43455,
  [SMALL_STATE(1367)] = 43516,
  [SMALL_STATE(1368)] = 43567,
  [SMALL_STATE(1369)] = 43618,
  [SMALL_STATE(1370)] = 43669,
  [SMALL_STATE(1371)] = 43720,
  [SMALL_STATE(1372)] = 43771,
  [SMALL_STATE(1373)] = 43822,
  [SMALL_STATE(1374)] = 43873,
  [SMALL_STATE(1375)] = 43924,
  [SMALL_STATE(1376)] = 43975,
  [SMALL_STATE(1377)] = 44032,
  [SMALL_STATE(1378)] = 44085,
  [SMALL_STATE(1379)] = 44136,
  [SMALL_STATE(1380)] = 44193,
  [SMALL_STATE(1381)] = 44244,
  [SMALL_STATE(1382)] = 44295,
  [SMALL_STATE(1383)] = 44400,
  [SMALL_STATE(1384)] = 44451,
  [SMALL_STATE(1385)] = 44502,
  [SMALL_STATE(1386)] = 44555,
  [SMALL_STATE(1387)] = 44606,
  [SMALL_STATE(1388)] = 44657,
  [SMALL_STATE(1389)] = 44708,
  [SMALL_STATE(1390)] = 44777,
  [SMALL_STATE(1391)] = 44828,
  [SMALL_STATE(1392)] = 44879,
  [SMALL_STATE(1393)] = 44930,
  [SMALL_STATE(1394)] = 44997,
  [SMALL_STATE(1395)] = 45048,
  [SMALL_STATE(1396)] = 45099,
  [SMALL_STATE(1397)] = 45150,
  [SMALL_STATE(1398)] = 45201,
  [SMALL_STATE(1399)] = 45252,
  [SMALL_STATE(1400)] = 45303,
  [SMALL_STATE(1401)] = 45354,
  [SMALL_STATE(1402)] = 45405,
  [SMALL_STATE(1403)] = 45456,
  [SMALL_STATE(1404)] = 45561,
  [SMALL_STATE(1405)] = 45634,
  [SMALL_STATE(1406)] = 45739,
  [SMALL_STATE(1407)] = 45790,
  [SMALL_STATE(1408)] = 45895,
  [SMALL_STATE(1409)] = 45946,
  [SMALL_STATE(1410)] = 45997,
  [SMALL_STATE(1411)] = 46048,
  [SMALL_STATE(1412)] = 46142,
  [SMALL_STATE(1413)] = 46236,
  [SMALL_STATE(1414)] = 46340,
  [SMALL_STATE(1415)] = 46396,
  [SMALL_STATE(1416)] = 46490,
  [SMALL_STATE(1417)] = 46584,
  [SMALL_STATE(1418)] = 46666,
  [SMALL_STATE(1419)] = 46770,
  [SMALL_STATE(1420)] = 46876,
  [SMALL_STATE(1421)] = 46980,
  [SMALL_STATE(1422)] = 47050,
  [SMALL_STATE(1423)] = 47144,
  [SMALL_STATE(1424)] = 47198,
  [SMALL_STATE(1425)] = 47252,
  [SMALL_STATE(1426)] = 47356,
  [SMALL_STATE(1427)] = 47460,
  [SMALL_STATE(1428)] = 47520,
  [SMALL_STATE(1429)] = 47574,
  [SMALL_STATE(1430)] = 47668,
  [SMALL_STATE(1431)] = 47772,
  [SMALL_STATE(1432)] = 47852,
  [SMALL_STATE(1433)] = 47956,
  [SMALL_STATE(1434)] = 48060,
  [SMALL_STATE(1435)] = 48154,
  [SMALL_STATE(1436)] = 48250,
  [SMALL_STATE(1437)] = 48326,
  [SMALL_STATE(1438)] = 48414,
  [SMALL_STATE(1439)] = 48504,
  [SMALL_STATE(1440)] = 48596,
  [SMALL_STATE(1441)] = 48670,
  [SMALL_STATE(1442)] = 48724,
  [SMALL_STATE(1443)] = 48834,
  [SMALL_STATE(1444)] = 48902,
  [SMALL_STATE(1445)] = 48986,
  [SMALL_STATE(1446)] = 49084,
  [SMALL_STATE(1447)] = 49188,
  [SMALL_STATE(1448)] = 49292,
  [SMALL_STATE(1449)] = 49396,
  [SMALL_STATE(1450)] = 49456,
  [SMALL_STATE(1451)] = 49520,
  [SMALL_STATE(1452)] = 49624,
  [SMALL_STATE(1453)] = 49694,
  [SMALL_STATE(1454)] = 49774,
  [SMALL_STATE(1455)] = 49868,
  [SMALL_STATE(1456)] = 49964,
  [SMALL_STATE(1457)] = 50040,
  [SMALL_STATE(1458)] = 50128,
  [SMALL_STATE(1459)] = 50218,
  [SMALL_STATE(1460)] = 50310,
  [SMALL_STATE(1461)] = 50384,
  [SMALL_STATE(1462)] = 50492,
  [SMALL_STATE(1463)] = 50560,
  [SMALL_STATE(1464)] = 50644,
  [SMALL_STATE(1465)] = 50742,
  [SMALL_STATE(1466)] = 50846,
  [SMALL_STATE(1467)] = 50950,
  [SMALL_STATE(1468)] = 51006,
  [SMALL_STATE(1469)] = 51110,
  [SMALL_STATE(1470)] = 51214,
  [SMALL_STATE(1471)] = 51318,
  [SMALL_STATE(1472)] = 51422,
  [SMALL_STATE(1473)] = 51482,
  [SMALL_STATE(1474)] = 51542,
  [SMALL_STATE(1475)] = 51602,
  [SMALL_STATE(1476)] = 51684,
  [SMALL_STATE(1477)] = 51778,
  [SMALL_STATE(1478)] = 51886,
  [SMALL_STATE(1479)] = 51994,
  [SMALL_STATE(1480)] = 52052,
  [SMALL_STATE(1481)] = 52108,
  [SMALL_STATE(1482)] = 52168,
  [SMALL_STATE(1483)] = 52228,
  [SMALL_STATE(1484)] = 52322,
  [SMALL_STATE(1485)] = 52426,
  [SMALL_STATE(1486)] = 52520,
  [SMALL_STATE(1487)] = 52630,
  [SMALL_STATE(1488)] = 52696,
  [SMALL_STATE(1489)] = 52800,
  [SMALL_STATE(1490)] = 52904,
  [SMALL_STATE(1491)] = 53008,
  [SMALL_STATE(1492)] = 53102,
  [SMALL_STATE(1493)] = 53184,
  [SMALL_STATE(1494)] = 53288,
  [SMALL_STATE(1495)] = 53392,
  [SMALL_STATE(1496)] = 53450,
  [SMALL_STATE(1497)] = 53522,
  [SMALL_STATE(1498)] = 53632,
  [SMALL_STATE(1499)] = 53688,
  [SMALL_STATE(1500)] = 53756,
  [SMALL_STATE(1501)] = 53838,
  [SMALL_STATE(1502)] = 53948,
  [SMALL_STATE(1503)] = 54006,
  [SMALL_STATE(1504)] = 54114,
  [SMALL_STATE(1505)] = 54196,
  [SMALL_STATE(1506)] = 54264,
  [SMALL_STATE(1507)] = 54358,
  [SMALL_STATE(1508)] = 54416,
  [SMALL_STATE(1509)] = 54488,
  [SMALL_STATE(1510)] = 54592,
  [SMALL_STATE(1511)] = 54658,
  [SMALL_STATE(1512)] = 54710,
  [SMALL_STATE(1513)] = 54813,
  [SMALL_STATE(1514)] = 54862,
  [SMALL_STATE(1515)] = 54911,
  [SMALL_STATE(1516)] = 54960,
  [SMALL_STATE(1517)] = 55009,
  [SMALL_STATE(1518)] = 55058,
  [SMALL_STATE(1519)] = 55107,
  [SMALL_STATE(1520)] = 55174,
  [SMALL_STATE(1521)] = 55247,
  [SMALL_STATE(1522)] = 55308,
  [SMALL_STATE(1523)] = 55399,
  [SMALL_STATE(1524)] = 55488,
  [SMALL_STATE(1525)] = 55575,
  [SMALL_STATE(1526)] = 55650,
  [SMALL_STATE(1527)] = 55711,
  [SMALL_STATE(1528)] = 55814,
  [SMALL_STATE(1529)] = 55909,
  [SMALL_STATE(1530)] = 56002,
  [SMALL_STATE(1531)] = 56109,
  [SMALL_STATE(1532)] = 56188,
  [SMALL_STATE(1533)] = 56257,
  [SMALL_STATE(1534)] = 56360,
  [SMALL_STATE(1535)] = 56463,
  [SMALL_STATE(1536)] = 56566,
  [SMALL_STATE(1537)] = 56669,
  [SMALL_STATE(1538)] = 56772,
  [SMALL_STATE(1539)] = 56831,
  [SMALL_STATE(1540)] = 56892,
  [SMALL_STATE(1541)] = 56995,
  [SMALL_STATE(1542)] = 57044,
  [SMALL_STATE(1543)] = 57093,
  [SMALL_STATE(1544)] = 57144,
  [SMALL_STATE(1545)] = 57193,
  [SMALL_STATE(1546)] = 57242,
  [SMALL_STATE(1547)] = 57291,
  [SMALL_STATE(1548)] = 57346,
  [SMALL_STATE(1549)] = 57397,
  [SMALL_STATE(1550)] = 57446,
  [SMALL_STATE(1551)] = 57495,
  [SMALL_STATE(1552)] = 57544,
  [SMALL_STATE(1553)] = 57593,
  [SMALL_STATE(1554)] = 57642,
  [SMALL_STATE(1555)] = 57697,
  [SMALL_STATE(1556)] = 57750,
  [SMALL_STATE(1557)] = 57855,
  [SMALL_STATE(1558)] = 57904,
  [SMALL_STATE(1559)] = 57953,
  [SMALL_STATE(1560)] = 58006,
  [SMALL_STATE(1561)] = 58071,
  [SMALL_STATE(1562)] = 58146,
  [SMALL_STATE(1563)] = 58195,
  [SMALL_STATE(1564)] = 58268,
  [SMALL_STATE(1565)] = 58343,
  [SMALL_STATE(1566)] = 58392,
  [SMALL_STATE(1567)] = 58441,
  [SMALL_STATE(1568)] = 58490,
  [SMALL_STATE(1569)] = 58539,
  [SMALL_STATE(1570)] = 58600,
  [SMALL_STATE(1571)] = 58707,
  [SMALL_STATE(1572)] = 58756,
  [SMALL_STATE(1573)] = 58809,
  [SMALL_STATE(1574)] = 58912,
  [SMALL_STATE(1575)] = 58973,
  [SMALL_STATE(1576)] = 59046,
  [SMALL_STATE(1577)] = 59095,
  [SMALL_STATE(1578)] = 59170,
  [SMALL_STATE(1579)] = 59231,
  [SMALL_STATE(1580)] = 59292,
  [SMALL_STATE(1581)] = 59341,
  [SMALL_STATE(1582)] = 59390,
  [SMALL_STATE(1583)] = 59439,
  [SMALL_STATE(1584)] = 59522,
  [SMALL_STATE(1585)] = 59627,
  [SMALL_STATE(1586)] = 59732,
  [SMALL_STATE(1587)] = 59781,
  [SMALL_STATE(1588)] = 59830,
  [SMALL_STATE(1589)] = 59881,
  [SMALL_STATE(1590)] = 59988,
  [SMALL_STATE(1591)] = 60037,
  [SMALL_STATE(1592)] = 60110,
  [SMALL_STATE(1593)] = 60183,
  [SMALL_STATE(1594)] = 60258,
  [SMALL_STATE(1595)] = 60313,
  [SMALL_STATE(1596)] = 60362,
  [SMALL_STATE(1597)] = 60411,
  [SMALL_STATE(1598)] = 60462,
  [SMALL_STATE(1599)] = 60559,
  [SMALL_STATE(1600)] = 60610,
  [SMALL_STATE(1601)] = 60713,
  [SMALL_STATE(1602)] = 60762,
  [SMALL_STATE(1603)] = 60865,
  [SMALL_STATE(1604)] = 60968,
  [SMALL_STATE(1605)] = 61071,
  [SMALL_STATE(1606)] = 61120,
  [SMALL_STATE(1607)] = 61171,
  [SMALL_STATE(1608)] = 61220,
  [SMALL_STATE(1609)] = 61275,
  [SMALL_STATE(1610)] = 61330,
  [SMALL_STATE(1611)] = 61379,
  [SMALL_STATE(1612)] = 61428,
  [SMALL_STATE(1613)] = 61477,
  [SMALL_STATE(1614)] = 61528,
  [SMALL_STATE(1615)] = 61635,
  [SMALL_STATE(1616)] = 61738,
  [SMALL_STATE(1617)] = 61787,
  [SMALL_STATE(1618)] = 61836,
  [SMALL_STATE(1619)] = 61885,
  [SMALL_STATE(1620)] = 61946,
  [SMALL_STATE(1621)] = 62007,
  [SMALL_STATE(1622)] = 62062,
  [SMALL_STATE(1623)] = 62117,
  [SMALL_STATE(1624)] = 62220,
  [SMALL_STATE(1625)] = 62269,
  [SMALL_STATE(1626)] = 62318,
  [SMALL_STATE(1627)] = 62367,
  [SMALL_STATE(1628)] = 62422,
  [SMALL_STATE(1629)] = 62477,
  [SMALL_STATE(1630)] = 62526,
  [SMALL_STATE(1631)] = 62575,
  [SMALL_STATE(1632)] = 62624,
  [SMALL_STATE(1633)] = 62679,
  [SMALL_STATE(1634)] = 62728,
  [SMALL_STATE(1635)] = 62785,
  [SMALL_STATE(1636)] = 62842,
  [SMALL_STATE(1637)] = 62891,
  [SMALL_STATE(1638)] = 62946,
  [SMALL_STATE(1639)] = 62995,
  [SMALL_STATE(1640)] = 63044,
  [SMALL_STATE(1641)] = 63093,
  [SMALL_STATE(1642)] = 63142,
  [SMALL_STATE(1643)] = 63191,
  [SMALL_STATE(1644)] = 63240,
  [SMALL_STATE(1645)] = 63289,
  [SMALL_STATE(1646)] = 63338,
  [SMALL_STATE(1647)] = 63387,
  [SMALL_STATE(1648)] = 63436,
  [SMALL_STATE(1649)] = 63485,
  [SMALL_STATE(1650)] = 63534,
  [SMALL_STATE(1651)] = 63591,
  [SMALL_STATE(1652)] = 63640,
  [SMALL_STATE(1653)] = 63689,
  [SMALL_STATE(1654)] = 63738,
  [SMALL_STATE(1655)] = 63787,
  [SMALL_STATE(1656)] = 63836,
  [SMALL_STATE(1657)] = 63889,
  [SMALL_STATE(1658)] = 63992,
  [SMALL_STATE(1659)] = 64045,
  [SMALL_STATE(1660)] = 64102,
  [SMALL_STATE(1661)] = 64157,
  [SMALL_STATE(1662)] = 64264,
  [SMALL_STATE(1663)] = 64315,
  [SMALL_STATE(1664)] = 64364,
  [SMALL_STATE(1665)] = 64413,
  [SMALL_STATE(1666)] = 64462,
  [SMALL_STATE(1667)] = 64513,
  [SMALL_STATE(1668)] = 64618,
  [SMALL_STATE(1669)] = 64667,
  [SMALL_STATE(1670)] = 64718,
  [SMALL_STATE(1671)] = 64825,
  [SMALL_STATE(1672)] = 64898,
  [SMALL_STATE(1673)] = 64961,
  [SMALL_STATE(1674)] = 65016,
  [SMALL_STATE(1675)] = 65079,
  [SMALL_STATE(1676)] = 65154,
  [SMALL_STATE(1677)] = 65205,
  [SMALL_STATE(1678)] = 65258,
  [SMALL_STATE(1679)] = 65365,
  [SMALL_STATE(1680)] = 65432,
  [SMALL_STATE(1681)] = 65539,
  [SMALL_STATE(1682)] = 65594,
  [SMALL_STATE(1683)] = 65701,
  [SMALL_STATE(1684)] = 65772,
  [SMALL_STATE(1685)] = 65879,
  [SMALL_STATE(1686)] = 65930,
  [SMALL_STATE(1687)] = 66033,
  [SMALL_STATE(1688)] = 66082,
  [SMALL_STATE(1689)] = 66131,
  [SMALL_STATE(1690)] = 66187,
  [SMALL_STATE(1691)] = 66239,
  [SMALL_STATE(1692)] = 66287,
  [SMALL_STATE(1693)] = 66389,
  [SMALL_STATE(1694)] = 66439,
  [SMALL_STATE(1695)] = 66507,
  [SMALL_STATE(1696)] = 66561,
  [SMALL_STATE(1697)] = 66609,
  [SMALL_STATE(1698)] = 66657,
  [SMALL_STATE(1699)] = 66705,
  [SMALL_STATE(1700)] = 66809,
  [SMALL_STATE(1701)] = 66867,
  [SMALL_STATE(1702)] = 66969,
  [SMALL_STATE(1703)] = 67037,
  [SMALL_STATE(1704)] = 67085,
  [SMALL_STATE(1705)] = 67133,
  [SMALL_STATE(1706)] = 67211,
  [SMALL_STATE(1707)] = 67265,
  [SMALL_STATE(1708)] = 67319,
  [SMALL_STATE(1709)] = 67411,
  [SMALL_STATE(1710)] = 67505,
  [SMALL_STATE(1711)] = 67609,
  [SMALL_STATE(1712)] = 67659,
  [SMALL_STATE(1713)] = 67713,
  [SMALL_STATE(1714)] = 67767,
  [SMALL_STATE(1715)] = 67841,
  [SMALL_STATE(1716)] = 67891,
  [SMALL_STATE(1717)] = 67941,
  [SMALL_STATE(1718)] = 67993,
  [SMALL_STATE(1719)] = 68043,
  [SMALL_STATE(1720)] = 68091,
  [SMALL_STATE(1721)] = 68139,
  [SMALL_STATE(1722)] = 68187,
  [SMALL_STATE(1723)] = 68243,
  [SMALL_STATE(1724)] = 68317,
  [SMALL_STATE(1725)] = 68403,
  [SMALL_STATE(1726)] = 68491,
  [SMALL_STATE(1727)] = 68541,
  [SMALL_STATE(1728)] = 68591,
  [SMALL_STATE(1729)] = 68639,
  [SMALL_STATE(1730)] = 68689,
  [SMALL_STATE(1731)] = 68741,
  [SMALL_STATE(1732)] = 68793,
  [SMALL_STATE(1733)] = 68845,
  [SMALL_STATE(1734)] = 68947,
  [SMALL_STATE(1735)] = 68997,
  [SMALL_STATE(1736)] = 69047,
  [SMALL_STATE(1737)] = 69099,
  [SMALL_STATE(1738)] = 69147,
  [SMALL_STATE(1739)] = 69197,
  [SMALL_STATE(1740)] = 69287,
  [SMALL_STATE(1741)] = 69335,
  [SMALL_STATE(1742)] = 69403,
  [SMALL_STATE(1743)] = 69457,
  [SMALL_STATE(1744)] = 69523,
  [SMALL_STATE(1745)] = 69593,
  [SMALL_STATE(1746)] = 69695,
  [SMALL_STATE(1747)] = 69753,
  [SMALL_STATE(1748)] = 69811,
  [SMALL_STATE(1749)] = 69913,
  [SMALL_STATE(1750)] = 69973,
  [SMALL_STATE(1751)] = 70075,
  [SMALL_STATE(1752)] = 70127,
  [SMALL_STATE(1753)] = 70183,
  [SMALL_STATE(1754)] = 70255,
  [SMALL_STATE(1755)] = 70303,
  [SMALL_STATE(1756)] = 70361,
  [SMALL_STATE(1757)] = 70415,
  [SMALL_STATE(1758)] = 70481,
  [SMALL_STATE(1759)] = 70545,
  [SMALL_STATE(1760)] = 70597,
  [SMALL_STATE(1761)] = 70699,
  [SMALL_STATE(1762)] = 70781,
  [SMALL_STATE(1763)] = 70877,
  [SMALL_STATE(1764)] = 70925,
  [SMALL_STATE(1765)] = 71027,
  [SMALL_STATE(1766)] = 71129,
  [SMALL_STATE(1767)] = 71181,
  [SMALL_STATE(1768)] = 71245,
  [SMALL_STATE(1769)] = 71293,
  [SMALL_STATE(1770)] = 71345,
  [SMALL_STATE(1771)] = 71397,
  [SMALL_STATE(1772)] = 71499,
  [SMALL_STATE(1773)] = 71547,
  [SMALL_STATE(1774)] = 71595,
  [SMALL_STATE(1775)] = 71697,
  [SMALL_STATE(1776)] = 71745,
  [SMALL_STATE(1777)] = 71797,
  [SMALL_STATE(1778)] = 71899,
  [SMALL_STATE(1779)] = 72001,
  [SMALL_STATE(1780)] = 72103,
  [SMALL_STATE(1781)] = 72155,
  [SMALL_STATE(1782)] = 72203,
  [SMALL_STATE(1783)] = 72261,
  [SMALL_STATE(1784)] = 72319,
  [SMALL_STATE(1785)] = 72423,
  [SMALL_STATE(1786)] = 72493,
  [SMALL_STATE(1787)] = 72597,
  [SMALL_STATE(1788)] = 72645,
  [SMALL_STATE(1789)] = 72693,
  [SMALL_STATE(1790)] = 72797,
  [SMALL_STATE(1791)] = 72845,
  [SMALL_STATE(1792)] = 72897,
  [SMALL_STATE(1793)] = 73001,
  [SMALL_STATE(1794)] = 73057,
  [SMALL_STATE(1795)] = 73125,
  [SMALL_STATE(1796)] = 73229,
  [SMALL_STATE(1797)] = 73333,
  [SMALL_STATE(1798)] = 73435,
  [SMALL_STATE(1799)] = 73483,
  [SMALL_STATE(1800)] = 73585,
  [SMALL_STATE(1801)] = 73633,
  [SMALL_STATE(1802)] = 73735,
  [SMALL_STATE(1803)] = 73783,
  [SMALL_STATE(1804)] = 73835,
  [SMALL_STATE(1805)] = 73883,
  [SMALL_STATE(1806)] = 73935,
  [SMALL_STATE(1807)] = 74001,
  [SMALL_STATE(1808)] = 74049,
  [SMALL_STATE(1809)] = 74101,
  [SMALL_STATE(1810)] = 74151,
  [SMALL_STATE(1811)] = 74203,
  [SMALL_STATE(1812)] = 74251,
  [SMALL_STATE(1813)] = 74303,
  [SMALL_STATE(1814)] = 74357,
  [SMALL_STATE(1815)] = 74409,
  [SMALL_STATE(1816)] = 74457,
  [SMALL_STATE(1817)] = 74559,
  [SMALL_STATE(1818)] = 74611,
  [SMALL_STATE(1819)] = 74667,
  [SMALL_STATE(1820)] = 74715,
  [SMALL_STATE(1821)] = 74767,
  [SMALL_STATE(1822)] = 74819,
  [SMALL_STATE(1823)] = 74867,
  [SMALL_STATE(1824)] = 74919,
  [SMALL_STATE(1825)] = 75021,
  [SMALL_STATE(1826)] = 75089,
  [SMALL_STATE(1827)] = 75191,
  [SMALL_STATE(1828)] = 75293,
  [SMALL_STATE(1829)] = 75395,
  [SMALL_STATE(1830)] = 75499,
  [SMALL_STATE(1831)] = 75551,
  [SMALL_STATE(1832)] = 75599,
  [SMALL_STATE(1833)] = 75647,
  [SMALL_STATE(1834)] = 75749,
  [SMALL_STATE(1835)] = 75853,
  [SMALL_STATE(1836)] = 75955,
  [SMALL_STATE(1837)] = 76059,
  [SMALL_STATE(1838)] = 76111,
  [SMALL_STATE(1839)] = 76207,
  [SMALL_STATE(1840)] = 76311,
  [SMALL_STATE(1841)] = 76393,
  [SMALL_STATE(1842)] = 76497,
  [SMALL_STATE(1843)] = 76563,
  [SMALL_STATE(1844)] = 76619,
  [SMALL_STATE(1845)] = 76675,
  [SMALL_STATE(1846)] = 76747,
  [SMALL_STATE(1847)] = 76837,
  [SMALL_STATE(1848)] = 76925,
  [SMALL_STATE(1849)] = 77011,
  [SMALL_STATE(1850)] = 77085,
  [SMALL_STATE(1851)] = 77179,
  [SMALL_STATE(1852)] = 77271,
  [SMALL_STATE(1853)] = 77339,
  [SMALL_STATE(1854)] = 77389,
  [SMALL_STATE(1855)] = 77493,
  [SMALL_STATE(1856)] = 77541,
  [SMALL_STATE(1857)] = 77619,
  [SMALL_STATE(1858)] = 77667,
  [SMALL_STATE(1859)] = 77769,
  [SMALL_STATE(1860)] = 77837,
  [SMALL_STATE(1861)] = 77887,
  [SMALL_STATE(1862)] = 77943,
  [SMALL_STATE(1863)] = 77999,
  [SMALL_STATE(1864)] = 78051,
  [SMALL_STATE(1865)] = 78123,
  [SMALL_STATE(1866)] = 78225,
  [SMALL_STATE(1867)] = 78279,
  [SMALL_STATE(1868)] = 78381,
  [SMALL_STATE(1869)] = 78429,
  [SMALL_STATE(1870)] = 78483,
  [SMALL_STATE(1871)] = 78535,
  [SMALL_STATE(1872)] = 78583,
  [SMALL_STATE(1873)] = 78687,
  [SMALL_STATE(1874)] = 78735,
  [SMALL_STATE(1875)] = 78783,
  [SMALL_STATE(1876)] = 78831,
  [SMALL_STATE(1877)] = 78883,
  [SMALL_STATE(1878)] = 78987,
  [SMALL_STATE(1879)] = 79035,
  [SMALL_STATE(1880)] = 79087,
  [SMALL_STATE(1881)] = 79135,
  [SMALL_STATE(1882)] = 79237,
  [SMALL_STATE(1883)] = 79285,
  [SMALL_STATE(1884)] = 79333,
  [SMALL_STATE(1885)] = 79381,
  [SMALL_STATE(1886)] = 79429,
  [SMALL_STATE(1887)] = 79477,
  [SMALL_STATE(1888)] = 79581,
  [SMALL_STATE(1889)] = 79629,
  [SMALL_STATE(1890)] = 79731,
  [SMALL_STATE(1891)] = 79779,
  [SMALL_STATE(1892)] = 79880,
  [SMALL_STATE(1893)] = 79983,
  [SMALL_STATE(1894)] = 80052,
  [SMALL_STATE(1895)] = 80117,
  [SMALL_STATE(1896)] = 80196,
  [SMALL_STATE(1897)] = 80247,
  [SMALL_STATE(1898)] = 80316,
  [SMALL_STATE(1899)] = 80381,
  [SMALL_STATE(1900)] = 80450,
  [SMALL_STATE(1901)] = 80551,
  [SMALL_STATE(1902)] = 80606,
  [SMALL_STATE(1903)] = 80661,
  [SMALL_STATE(1904)] = 80762,
  [SMALL_STATE(1905)] = 80815,
  [SMALL_STATE(1906)] = 80894,
  [SMALL_STATE(1907)] = 80995,
  [SMALL_STATE(1908)] = 81052,
  [SMALL_STATE(1909)] = 81153,
  [SMALL_STATE(1910)] = 81254,
  [SMALL_STATE(1911)] = 81355,
  [SMALL_STATE(1912)] = 81456,
  [SMALL_STATE(1913)] = 81557,
  [SMALL_STATE(1914)] = 81636,
  [SMALL_STATE(1915)] = 81715,
  [SMALL_STATE(1916)] = 81816,
  [SMALL_STATE(1917)] = 81869,
  [SMALL_STATE(1918)] = 81970,
  [SMALL_STATE(1919)] = 82037,
  [SMALL_STATE(1920)] = 82090,
  [SMALL_STATE(1921)] = 82167,
  [SMALL_STATE(1922)] = 82258,
  [SMALL_STATE(1923)] = 82311,
  [SMALL_STATE(1924)] = 82404,
  [SMALL_STATE(1925)] = 82477,
  [SMALL_STATE(1926)] = 82562,
  [SMALL_STATE(1927)] = 82649,
  [SMALL_STATE(1928)] = 82738,
  [SMALL_STATE(1929)] = 82809,
  [SMALL_STATE(1930)] = 82874,
  [SMALL_STATE(1931)] = 82975,
  [SMALL_STATE(1932)] = 83044,
  [SMALL_STATE(1933)] = 83125,
  [SMALL_STATE(1934)] = 83204,
  [SMALL_STATE(1935)] = 83299,
  [SMALL_STATE(1936)] = 83400,
  [SMALL_STATE(1937)] = 83501,
  [SMALL_STATE(1938)] = 83602,
  [SMALL_STATE(1939)] = 83703,
  [SMALL_STATE(1940)] = 83804,
  [SMALL_STATE(1941)] = 83905,
  [SMALL_STATE(1942)] = 83970,
  [SMALL_STATE(1943)] = 84039,
  [SMALL_STATE(1944)] = 84140,
  [SMALL_STATE(1945)] = 84195,
  [SMALL_STATE(1946)] = 84258,
  [SMALL_STATE(1947)] = 84359,
  [SMALL_STATE(1948)] = 84424,
  [SMALL_STATE(1949)] = 84525,
  [SMALL_STATE(1950)] = 84592,
  [SMALL_STATE(1951)] = 84661,
  [SMALL_STATE(1952)] = 84730,
  [SMALL_STATE(1953)] = 84785,
  [SMALL_STATE(1954)] = 84854,
  [SMALL_STATE(1955)] = 84933,
  [SMALL_STATE(1956)] = 84984,
  [SMALL_STATE(1957)] = 85085,
  [SMALL_STATE(1958)] = 85164,
  [SMALL_STATE(1959)] = 85213,
  [SMALL_STATE(1960)] = 85262,
  [SMALL_STATE(1961)] = 85317,
  [SMALL_STATE(1962)] = 85389,
  [SMALL_STATE(1963)] = 85451,
  [SMALL_STATE(1964)] = 85511,
  [SMALL_STATE(1965)] = 85559,
  [SMALL_STATE(1966)] = 85619,
  [SMALL_STATE(1967)] = 85667,
  [SMALL_STATE(1968)] = 85765,
  [SMALL_STATE(1969)] = 85863,
  [SMALL_STATE(1970)] = 85925,
  [SMALL_STATE(1971)] = 85973,
  [SMALL_STATE(1972)] = 86071,
  [SMALL_STATE(1973)] = 86133,
  [SMALL_STATE(1974)] = 86231,
  [SMALL_STATE(1975)] = 86329,
  [SMALL_STATE(1976)] = 86399,
  [SMALL_STATE(1977)] = 86471,
  [SMALL_STATE(1978)] = 86533,
  [SMALL_STATE(1979)] = 86605,
  [SMALL_STATE(1980)] = 86675,
  [SMALL_STATE(1981)] = 86735,
  [SMALL_STATE(1982)] = 86805,
  [SMALL_STATE(1983)] = 86853,
  [SMALL_STATE(1984)] = 86923,
  [SMALL_STATE(1985)] = 87021,
  [SMALL_STATE(1986)] = 87119,
  [SMALL_STATE(1987)] = 87167,
  [SMALL_STATE(1988)] = 87219,
  [SMALL_STATE(1989)] = 87313,
  [SMALL_STATE(1990)] = 87373,
  [SMALL_STATE(1991)] = 87453,
  [SMALL_STATE(1992)] = 87515,
  [SMALL_STATE(1993)] = 87587,
  [SMALL_STATE(1994)] = 87645,
  [SMALL_STATE(1995)] = 87703,
  [SMALL_STATE(1996)] = 87763,
  [SMALL_STATE(1997)] = 87821,
  [SMALL_STATE(1998)] = 87869,
  [SMALL_STATE(1999)] = 87941,
  [SMALL_STATE(2000)] = 87999,
  [SMALL_STATE(2001)] = 88071,
  [SMALL_STATE(2002)] = 88141,
  [SMALL_STATE(2003)] = 88203,
  [SMALL_STATE(2004)] = 88273,
  [SMALL_STATE(2005)] = 88325,
  [SMALL_STATE(2006)] = 88373,
  [SMALL_STATE(2007)] = 88437,
  [SMALL_STATE(2008)] = 88507,
  [SMALL_STATE(2009)] = 88595,
  [SMALL_STATE(2010)] = 88655,
  [SMALL_STATE(2011)] = 88715,
  [SMALL_STATE(2012)] = 88801,
  [SMALL_STATE(2013)] = 88885,
  [SMALL_STATE(2014)] = 88937,
  [SMALL_STATE(2015)] = 89009,
  [SMALL_STATE(2016)] = 89057,
  [SMALL_STATE(2017)] = 89111,
  [SMALL_STATE(2018)] = 89209,
  [SMALL_STATE(2019)] = 89301,
  [SMALL_STATE(2020)] = 89363,
  [SMALL_STATE(2021)] = 89425,
  [SMALL_STATE(2022)] = 89515,
  [SMALL_STATE(2023)] = 89591,
  [SMALL_STATE(2024)] = 89661,
  [SMALL_STATE(2025)] = 89733,
  [SMALL_STATE(2026)] = 89795,
  [SMALL_STATE(2027)] = 89853,
  [SMALL_STATE(2028)] = 89911,
  [SMALL_STATE(2029)] = 89971,
  [SMALL_STATE(2030)] = 90029,
  [SMALL_STATE(2031)] = 90087,
  [SMALL_STATE(2032)] = 90145,
  [SMALL_STATE(2033)] = 90197,
  [SMALL_STATE(2034)] = 90255,
  [SMALL_STATE(2035)] = 90353,
  [SMALL_STATE(2036)] = 90419,
  [SMALL_STATE(2037)] = 90481,
  [SMALL_STATE(2038)] = 90579,
  [SMALL_STATE(2039)] = 90677,
  [SMALL_STATE(2040)] = 90775,
  [SMALL_STATE(2041)] = 90843,
  [SMALL_STATE(2042)] = 90941,
  [SMALL_STATE(2043)] = 91005,
  [SMALL_STATE(2044)] = 91103,
  [SMALL_STATE(2045)] = 91155,
  [SMALL_STATE(2046)] = 91211,
  [SMALL_STATE(2047)] = 91275,
  [SMALL_STATE(2048)] = 91335,
  [SMALL_STATE(2049)] = 91387,
  [SMALL_STATE(2050)] = 91435,
  [SMALL_STATE(2051)] = 91495,
  [SMALL_STATE(2052)] = 91547,
  [SMALL_STATE(2053)] = 91595,
  [SMALL_STATE(2054)] = 91647,
  [SMALL_STATE(2055)] = 91707,
  [SMALL_STATE(2056)] = 91767,
  [SMALL_STATE(2057)] = 91817,
  [SMALL_STATE(2058)] = 91865,
  [SMALL_STATE(2059)] = 91925,
  [SMALL_STATE(2060)] = 91973,
  [SMALL_STATE(2061)] = 92033,
  [SMALL_STATE(2062)] = 92093,
  [SMALL_STATE(2063)] = 92155,
  [SMALL_STATE(2064)] = 92203,
  [SMALL_STATE(2065)] = 92258,
  [SMALL_STATE(2066)] = 92313,
  [SMALL_STATE(2067)] = 92368,
  [SMALL_STATE(2068)] = 92423,
  [SMALL_STATE(2069)] = 92474,
  [SMALL_STATE(2070)] = 92525,
  [SMALL_STATE(2071)] = 92580,
  [SMALL_STATE(2072)] = 92635,
  [SMALL_STATE(2073)] = 92700,
  [SMALL_STATE(2074)] = 92747,
  [SMALL_STATE(2075)] = 92812,
  [SMALL_STATE(2076)] = 92883,
  [SMALL_STATE(2077)] = 92938,
  [SMALL_STATE(2078)] = 92993,
  [SMALL_STATE(2079)] = 93048,
  [SMALL_STATE(2080)] = 93099,
  [SMALL_STATE(2081)] = 93154,
  [SMALL_STATE(2082)] = 93219,
  [SMALL_STATE(2083)] = 93274,
  [SMALL_STATE(2084)] = 93329,
  [SMALL_STATE(2085)] = 93384,
  [SMALL_STATE(2086)] = 93439,
  [SMALL_STATE(2087)] = 93494,
  [SMALL_STATE(2088)] = 93541,
  [SMALL_STATE(2089)] = 93606,
  [SMALL_STATE(2090)] = 93661,
  [SMALL_STATE(2091)] = 93738,
  [SMALL_STATE(2092)] = 93803,
  [SMALL_STATE(2093)] = 93868,
  [SMALL_STATE(2094)] = 93923,
  [SMALL_STATE(2095)] = 93978,
  [SMALL_STATE(2096)] = 94029,
  [SMALL_STATE(2097)] = 94076,
  [SMALL_STATE(2098)] = 94141,
  [SMALL_STATE(2099)] = 94197,
  [SMALL_STATE(2100)] = 94247,
  [SMALL_STATE(2101)] = 94311,
  [SMALL_STATE(2102)] = 94371,
  [SMALL_STATE(2103)] = 94433,
  [SMALL_STATE(2104)] = 94501,
  [SMALL_STATE(2105)] = 94557,
  [SMALL_STATE(2106)] = 94607,
  [SMALL_STATE(2107)] = 94667,
  [SMALL_STATE(2108)] = 94728,
  [SMALL_STATE(2109)] = 94783,
  [SMALL_STATE(2110)] = 94838,
  [SMALL_STATE(2111)] = 94893,
  [SMALL_STATE(2112)] = 94948,
  [SMALL_STATE(2113)] = 95005,
  [SMALL_STATE(2114)] = 95060,
  [SMALL_STATE(2115)] = 95115,
  [SMALL_STATE(2116)] = 95170,
  [SMALL_STATE(2117)] = 95225,
  [SMALL_STATE(2118)] = 95280,
  [SMALL_STATE(2119)] = 95335,
  [SMALL_STATE(2120)] = 95388,
  [SMALL_STATE(2121)] = 95441,
  [SMALL_STATE(2122)] = 95496,
  [SMALL_STATE(2123)] = 95555,
  [SMALL_STATE(2124)] = 95610,
  [SMALL_STATE(2125)] = 95665,
  [SMALL_STATE(2126)] = 95720,
  [SMALL_STATE(2127)] = 95774,
  [SMALL_STATE(2128)] = 95821,
  [SMALL_STATE(2129)] = 95900,
  [SMALL_STATE(2130)] = 95979,
  [SMALL_STATE(2131)] = 96026,
  [SMALL_STATE(2132)] = 96089,
  [SMALL_STATE(2133)] = 96168,
  [SMALL_STATE(2134)] = 96215,
  [SMALL_STATE(2135)] = 96294,
  [SMALL_STATE(2136)] = 96373,
  [SMALL_STATE(2137)] = 96413,
  [SMALL_STATE(2138)] = 96453,
  [SMALL_STATE(2139)] = 96493,
  [SMALL_STATE(2140)] = 96533,
  [SMALL_STATE(2141)] = 96573,
  [SMALL_STATE(2142)] = 96613,
  [SMALL_STATE(2143)] = 96653,
  [SMALL_STATE(2144)] = 96705,
  [SMALL_STATE(2145)] = 96745,
  [SMALL_STATE(2146)] = 96799,
  [SMALL_STATE(2147)] = 96853,
  [SMALL_STATE(2148)] = 96895,
  [SMALL_STATE(2149)] = 96935,
  [SMALL_STATE(2150)] = 96991,
  [SMALL_STATE(2151)] = 97033,
  [SMALL_STATE(2152)] = 97075,
  [SMALL_STATE(2153)] = 97115,
  [SMALL_STATE(2154)] = 97155,
  [SMALL_STATE(2155)] = 97195,
  [SMALL_STATE(2156)] = 97251,
  [SMALL_STATE(2157)] = 97291,
  [SMALL_STATE(2158)] = 97335,
  [SMALL_STATE(2159)] = 97375,
  [SMALL_STATE(2160)] = 97415,
  [SMALL_STATE(2161)] = 97459,
  [SMALL_STATE(2162)] = 97513,
  [SMALL_STATE(2163)] = 97553,
  [SMALL_STATE(2164)] = 97593,
  [SMALL_STATE(2165)] = 97633,
  [SMALL_STATE(2166)] = 97673,
  [SMALL_STATE(2167)] = 97713,
  [SMALL_STATE(2168)] = 97769,
  [SMALL_STATE(2169)] = 97809,
  [SMALL_STATE(2170)] = 97849,
  [SMALL_STATE(2171)] = 97889,
  [SMALL_STATE(2172)] = 97929,
  [SMALL_STATE(2173)] = 97969,
  [SMALL_STATE(2174)] = 98023,
  [SMALL_STATE(2175)] = 98072,
  [SMALL_STATE(2176)] = 98121,
  [SMALL_STATE(2177)] = 98170,
  [SMALL_STATE(2178)] = 98219,
  [SMALL_STATE(2179)] = 98268,
  [SMALL_STATE(2180)] = 98317,
  [SMALL_STATE(2181)] = 98366,
  [SMALL_STATE(2182)] = 98415,
  [SMALL_STATE(2183)] = 98478,
  [SMALL_STATE(2184)] = 98527,
  [SMALL_STATE(2185)] = 98576,
  [SMALL_STATE(2186)] = 98625,
  [SMALL_STATE(2187)] = 98674,
  [SMALL_STATE(2188)] = 98723,
  [SMALL_STATE(2189)] = 98772,
  [SMALL_STATE(2190)] = 98821,
  [SMALL_STATE(2191)] = 98870,
  [SMALL_STATE(2192)] = 98919,
  [SMALL_STATE(2193)] = 98968,
  [SMALL_STATE(2194)] = 99017,
  [SMALL_STATE(2195)] = 99066,
  [SMALL_STATE(2196)] = 99116,
  [SMALL_STATE(2197)] = 99172,
  [SMALL_STATE(2198)] = 99222,
  [SMALL_STATE(2199)] = 99282,
  [SMALL_STATE(2200)] = 99320,
  [SMALL_STATE(2201)] = 99380,
  [SMALL_STATE(2202)] = 99430,
  [SMALL_STATE(2203)] = 99480,
  [SMALL_STATE(2204)] = 99518,
  [SMALL_STATE(2205)] = 99568,
  [SMALL_STATE(2206)] = 99618,
  [SMALL_STATE(2207)] = 99668,
  [SMALL_STATE(2208)] = 99706,
  [SMALL_STATE(2209)] = 99756,
  [SMALL_STATE(2210)] = 99794,
  [SMALL_STATE(2211)] = 99844,
  [SMALL_STATE(2212)] = 99882,
  [SMALL_STATE(2213)] = 99942,
  [SMALL_STATE(2214)] = 99980,
  [SMALL_STATE(2215)] = 100030,
  [SMALL_STATE(2216)] = 100083,
  [SMALL_STATE(2217)] = 100136,
  [SMALL_STATE(2218)] = 100187,
  [SMALL_STATE(2219)] = 100240,
  [SMALL_STATE(2220)] = 100293,
  [SMALL_STATE(2221)] = 100346,
  [SMALL_STATE(2222)] = 100399,
  [SMALL_STATE(2223)] = 100450,
  [SMALL_STATE(2224)] = 100503,
  [SMALL_STATE(2225)] = 100556,
  [SMALL_STATE(2226)] = 100609,
  [SMALL_STATE(2227)] = 100662,
  [SMALL_STATE(2228)] = 100701,
  [SMALL_STATE(2229)] = 100754,
  [SMALL_STATE(2230)] = 100801,
  [SMALL_STATE(2231)] = 100854,
  [SMALL_STATE(2232)] = 100898,
  [SMALL_STATE(2233)] = 100942,
  [SMALL_STATE(2234)] = 100986,
  [SMALL_STATE(2235)] = 101032,
  [SMALL_STATE(2236)] = 101076,
  [SMALL_STATE(2237)] = 101120,
  [SMALL_STATE(2238)] = 101166,
  [SMALL_STATE(2239)] = 101210,
  [SMALL_STATE(2240)] = 101254,
  [SMALL_STATE(2241)] = 101300,
  [SMALL_STATE(2242)] = 101344,
  [SMALL_STATE(2243)] = 101388,
  [SMALL_STATE(2244)] = 101432,
  [SMALL_STATE(2245)] = 101476,
  [SMALL_STATE(2246)] = 101520,
  [SMALL_STATE(2247)] = 101564,
  [SMALL_STATE(2248)] = 101608,
  [SMALL_STATE(2249)] = 101652,
  [SMALL_STATE(2250)] = 101696,
  [SMALL_STATE(2251)] = 101740,
  [SMALL_STATE(2252)] = 101784,
  [SMALL_STATE(2253)] = 101828,
  [SMALL_STATE(2254)] = 101872,
  [SMALL_STATE(2255)] = 101916,
  [SMALL_STATE(2256)] = 101960,
  [SMALL_STATE(2257)] = 102004,
  [SMALL_STATE(2258)] = 102048,
  [SMALL_STATE(2259)] = 102092,
  [SMALL_STATE(2260)] = 102136,
  [SMALL_STATE(2261)] = 102180,
  [SMALL_STATE(2262)] = 102224,
  [SMALL_STATE(2263)] = 102268,
  [SMALL_STATE(2264)] = 102299,
  [SMALL_STATE(2265)] = 102335,
  [SMALL_STATE(2266)] = 102361,
  [SMALL_STATE(2267)] = 102387,
  [SMALL_STATE(2268)] = 102423,
  [SMALL_STATE(2269)] = 102459,
  [SMALL_STATE(2270)] = 102485,
  [SMALL_STATE(2271)] = 102511,
  [SMALL_STATE(2272)] = 102537,
  [SMALL_STATE(2273)] = 102563,
  [SMALL_STATE(2274)] = 102589,
  [SMALL_STATE(2275)] = 102615,
  [SMALL_STATE(2276)] = 102641,
  [SMALL_STATE(2277)] = 102667,
  [SMALL_STATE(2278)] = 102693,
  [SMALL_STATE(2279)] = 102719,
  [SMALL_STATE(2280)] = 102745,
  [SMALL_STATE(2281)] = 102771,
  [SMALL_STATE(2282)] = 102797,
  [SMALL_STATE(2283)] = 102823,
  [SMALL_STATE(2284)] = 102849,
  [SMALL_STATE(2285)] = 102875,
  [SMALL_STATE(2286)] = 102901,
  [SMALL_STATE(2287)] = 102927,
  [SMALL_STATE(2288)] = 102953,
  [SMALL_STATE(2289)] = 102979,
  [SMALL_STATE(2290)] = 103005,
  [SMALL_STATE(2291)] = 103031,
  [SMALL_STATE(2292)] = 103057,
  [SMALL_STATE(2293)] = 103083,
  [SMALL_STATE(2294)] = 103109,
  [SMALL_STATE(2295)] = 103135,
  [SMALL_STATE(2296)] = 103161,
  [SMALL_STATE(2297)] = 103187,
  [SMALL_STATE(2298)] = 103213,
  [SMALL_STATE(2299)] = 103239,
  [SMALL_STATE(2300)] = 103265,
  [SMALL_STATE(2301)] = 103291,
  [SMALL_STATE(2302)] = 103325,
  [SMALL_STATE(2303)] = 103356,
  [SMALL_STATE(2304)] = 103387,
  [SMALL_STATE(2305)] = 103412,
  [SMALL_STATE(2306)] = 103437,
  [SMALL_STATE(2307)] = 103464,
  [SMALL_STATE(2308)] = 103489,
  [SMALL_STATE(2309)] = 103513,
  [SMALL_STATE(2310)] = 103537,
  [SMALL_STATE(2311)] = 103565,
  [SMALL_STATE(2312)] = 103588,
  [SMALL_STATE(2313)] = 103611,
  [SMALL_STATE(2314)] = 103634,
  [SMALL_STATE(2315)] = 103657,
  [SMALL_STATE(2316)] = 103680,
  [SMALL_STATE(2317)] = 103703,
  [SMALL_STATE(2318)] = 103726,
  [SMALL_STATE(2319)] = 103749,
  [SMALL_STATE(2320)] = 103772,
  [SMALL_STATE(2321)] = 103795,
  [SMALL_STATE(2322)] = 103818,
  [SMALL_STATE(2323)] = 103841,
  [SMALL_STATE(2324)] = 103864,
  [SMALL_STATE(2325)] = 103889,
  [SMALL_STATE(2326)] = 103910,
  [SMALL_STATE(2327)] = 103933,
  [SMALL_STATE(2328)] = 103956,
  [SMALL_STATE(2329)] = 103977,
  [SMALL_STATE(2330)] = 104000,
  [SMALL_STATE(2331)] = 104023,
  [SMALL_STATE(2332)] = 104054,
  [SMALL_STATE(2333)] = 104077,
  [SMALL_STATE(2334)] = 104098,
  [SMALL_STATE(2335)] = 104125,
  [SMALL_STATE(2336)] = 104148,
  [SMALL_STATE(2337)] = 104169,
  [SMALL_STATE(2338)] = 104192,
  [SMALL_STATE(2339)] = 104213,
  [SMALL_STATE(2340)] = 104236,
  [SMALL_STATE(2341)] = 104269,
  [SMALL_STATE(2342)] = 104292,
  [SMALL_STATE(2343)] = 104325,
  [SMALL_STATE(2344)] = 104358,
  [SMALL_STATE(2345)] = 104383,
  [SMALL_STATE(2346)] = 104404,
  [SMALL_STATE(2347)] = 104429,
  [SMALL_STATE(2348)] = 104452,
  [SMALL_STATE(2349)] = 104475,
  [SMALL_STATE(2350)] = 104498,
  [SMALL_STATE(2351)] = 104519,
  [SMALL_STATE(2352)] = 104540,
  [SMALL_STATE(2353)] = 104562,
  [SMALL_STATE(2354)] = 104604,
  [SMALL_STATE(2355)] = 104646,
  [SMALL_STATE(2356)] = 104676,
  [SMALL_STATE(2357)] = 104706,
  [SMALL_STATE(2358)] = 104748,
  [SMALL_STATE(2359)] = 104770,
  [SMALL_STATE(2360)] = 104798,
  [SMALL_STATE(2361)] = 104820,
  [SMALL_STATE(2362)] = 104842,
  [SMALL_STATE(2363)] = 104864,
  [SMALL_STATE(2364)] = 104886,
  [SMALL_STATE(2365)] = 104908,
  [SMALL_STATE(2366)] = 104930,
  [SMALL_STATE(2367)] = 104952,
  [SMALL_STATE(2368)] = 104974,
  [SMALL_STATE(2369)] = 105002,
  [SMALL_STATE(2370)] = 105032,
  [SMALL_STATE(2371)] = 105062,
  [SMALL_STATE(2372)] = 105092,
  [SMALL_STATE(2373)] = 105114,
  [SMALL_STATE(2374)] = 105136,
  [SMALL_STATE(2375)] = 105158,
  [SMALL_STATE(2376)] = 105180,
  [SMALL_STATE(2377)] = 105202,
  [SMALL_STATE(2378)] = 105224,
  [SMALL_STATE(2379)] = 105246,
  [SMALL_STATE(2380)] = 105268,
  [SMALL_STATE(2381)] = 105290,
  [SMALL_STATE(2382)] = 105312,
  [SMALL_STATE(2383)] = 105342,
  [SMALL_STATE(2384)] = 105370,
  [SMALL_STATE(2385)] = 105400,
  [SMALL_STATE(2386)] = 105428,
  [SMALL_STATE(2387)] = 105458,
  [SMALL_STATE(2388)] = 105488,
  [SMALL_STATE(2389)] = 105518,
  [SMALL_STATE(2390)] = 105548,
  [SMALL_STATE(2391)] = 105576,
  [SMALL_STATE(2392)] = 105606,
  [SMALL_STATE(2393)] = 105648,
  [SMALL_STATE(2394)] = 105678,
  [SMALL_STATE(2395)] = 105708,
  [SMALL_STATE(2396)] = 105732,
  [SMALL_STATE(2397)] = 105762,
  [SMALL_STATE(2398)] = 105788,
  [SMALL_STATE(2399)] = 105818,
  [SMALL_STATE(2400)] = 105846,
  [SMALL_STATE(2401)] = 105876,
  [SMALL_STATE(2402)] = 105906,
  [SMALL_STATE(2403)] = 105934,
  [SMALL_STATE(2404)] = 105964,
  [SMALL_STATE(2405)] = 105994,
  [SMALL_STATE(2406)] = 106022,
  [SMALL_STATE(2407)] = 106052,
  [SMALL_STATE(2408)] = 106080,
  [SMALL_STATE(2409)] = 106110,
  [SMALL_STATE(2410)] = 106138,
  [SMALL_STATE(2411)] = 106166,
  [SMALL_STATE(2412)] = 106188,
  [SMALL_STATE(2413)] = 106210,
  [SMALL_STATE(2414)] = 106238,
  [SMALL_STATE(2415)] = 106260,
  [SMALL_STATE(2416)] = 106282,
  [SMALL_STATE(2417)] = 106304,
  [SMALL_STATE(2418)] = 106326,
  [SMALL_STATE(2419)] = 106356,
  [SMALL_STATE(2420)] = 106378,
  [SMALL_STATE(2421)] = 106400,
  [SMALL_STATE(2422)] = 106428,
  [SMALL_STATE(2423)] = 106450,
  [SMALL_STATE(2424)] = 106472,
  [SMALL_STATE(2425)] = 106494,
  [SMALL_STATE(2426)] = 106516,
  [SMALL_STATE(2427)] = 106546,
  [SMALL_STATE(2428)] = 106588,
  [SMALL_STATE(2429)] = 106610,
  [SMALL_STATE(2430)] = 106632,
  [SMALL_STATE(2431)] = 106662,
  [SMALL_STATE(2432)] = 106690,
  [SMALL_STATE(2433)] = 106720,
  [SMALL_STATE(2434)] = 106762,
  [SMALL_STATE(2435)] = 106786,
  [SMALL_STATE(2436)] = 106828,
  [SMALL_STATE(2437)] = 106856,
  [SMALL_STATE(2438)] = 106886,
  [SMALL_STATE(2439)] = 106916,
  [SMALL_STATE(2440)] = 106946,
  [SMALL_STATE(2441)] = 106976,
  [SMALL_STATE(2442)] = 107011,
  [SMALL_STATE(2443)] = 107036,
  [SMALL_STATE(2444)] = 107071,
  [SMALL_STATE(2445)] = 107100,
  [SMALL_STATE(2446)] = 107129,
  [SMALL_STATE(2447)] = 107166,
  [SMALL_STATE(2448)] = 107195,
  [SMALL_STATE(2449)] = 107230,
  [SMALL_STATE(2450)] = 107265,
  [SMALL_STATE(2451)] = 107292,
  [SMALL_STATE(2452)] = 107319,
  [SMALL_STATE(2453)] = 107340,
  [SMALL_STATE(2454)] = 107361,
  [SMALL_STATE(2455)] = 107396,
  [SMALL_STATE(2456)] = 107431,
  [SMALL_STATE(2457)] = 107452,
  [SMALL_STATE(2458)] = 107473,
  [SMALL_STATE(2459)] = 107494,
  [SMALL_STATE(2460)] = 107529,
  [SMALL_STATE(2461)] = 107564,
  [SMALL_STATE(2462)] = 107587,
  [SMALL_STATE(2463)] = 107622,
  [SMALL_STATE(2464)] = 107643,
  [SMALL_STATE(2465)] = 107678,
  [SMALL_STATE(2466)] = 107696,
  [SMALL_STATE(2467)] = 107714,
  [SMALL_STATE(2468)] = 107750,
  [SMALL_STATE(2469)] = 107768,
  [SMALL_STATE(2470)] = 107786,
  [SMALL_STATE(2471)] = 107816,
  [SMALL_STATE(2472)] = 107834,
  [SMALL_STATE(2473)] = 107852,
  [SMALL_STATE(2474)] = 107870,
  [SMALL_STATE(2475)] = 107888,
  [SMALL_STATE(2476)] = 107906,
  [SMALL_STATE(2477)] = 107924,
  [SMALL_STATE(2478)] = 107942,
  [SMALL_STATE(2479)] = 107978,
  [SMALL_STATE(2480)] = 107996,
  [SMALL_STATE(2481)] = 108028,
  [SMALL_STATE(2482)] = 108056,
  [SMALL_STATE(2483)] = 108088,
  [SMALL_STATE(2484)] = 108110,
  [SMALL_STATE(2485)] = 108128,
  [SMALL_STATE(2486)] = 108146,
  [SMALL_STATE(2487)] = 108164,
  [SMALL_STATE(2488)] = 108182,
  [SMALL_STATE(2489)] = 108218,
  [SMALL_STATE(2490)] = 108236,
  [SMALL_STATE(2491)] = 108254,
  [SMALL_STATE(2492)] = 108272,
  [SMALL_STATE(2493)] = 108290,
  [SMALL_STATE(2494)] = 108308,
  [SMALL_STATE(2495)] = 108326,
  [SMALL_STATE(2496)] = 108344,
  [SMALL_STATE(2497)] = 108362,
  [SMALL_STATE(2498)] = 108394,
  [SMALL_STATE(2499)] = 108418,
  [SMALL_STATE(2500)] = 108450,
  [SMALL_STATE(2501)] = 108482,
  [SMALL_STATE(2502)] = 108514,
  [SMALL_STATE(2503)] = 108542,
  [SMALL_STATE(2504)] = 108570,
  [SMALL_STATE(2505)] = 108588,
  [SMALL_STATE(2506)] = 108606,
  [SMALL_STATE(2507)] = 108642,
  [SMALL_STATE(2508)] = 108674,
  [SMALL_STATE(2509)] = 108692,
  [SMALL_STATE(2510)] = 108710,
  [SMALL_STATE(2511)] = 108742,
  [SMALL_STATE(2512)] = 108778,
  [SMALL_STATE(2513)] = 108814,
  [SMALL_STATE(2514)] = 108842,
  [SMALL_STATE(2515)] = 108874,
  [SMALL_STATE(2516)] = 108910,
  [SMALL_STATE(2517)] = 108928,
  [SMALL_STATE(2518)] = 108960,
  [SMALL_STATE(2519)] = 108978,
  [SMALL_STATE(2520)] = 109006,
  [SMALL_STATE(2521)] = 109024,
  [SMALL_STATE(2522)] = 109042,
  [SMALL_STATE(2523)] = 109060,
  [SMALL_STATE(2524)] = 109078,
  [SMALL_STATE(2525)] = 109097,
  [SMALL_STATE(2526)] = 109116,
  [SMALL_STATE(2527)] = 109135,
  [SMALL_STATE(2528)] = 109154,
  [SMALL_STATE(2529)] = 109173,
  [SMALL_STATE(2530)] = 109192,
  [SMALL_STATE(2531)] = 109213,
  [SMALL_STATE(2532)] = 109232,
  [SMALL_STATE(2533)] = 109251,
  [SMALL_STATE(2534)] = 109270,
  [SMALL_STATE(2535)] = 109291,
  [SMALL_STATE(2536)] = 109310,
  [SMALL_STATE(2537)] = 109329,
  [SMALL_STATE(2538)] = 109346,
  [SMALL_STATE(2539)] = 109365,
  [SMALL_STATE(2540)] = 109384,
  [SMALL_STATE(2541)] = 109403,
  [SMALL_STATE(2542)] = 109424,
  [SMALL_STATE(2543)] = 109443,
  [SMALL_STATE(2544)] = 109462,
  [SMALL_STATE(2545)] = 109481,
  [SMALL_STATE(2546)] = 109502,
  [SMALL_STATE(2547)] = 109521,
  [SMALL_STATE(2548)] = 109540,
  [SMALL_STATE(2549)] = 109559,
  [SMALL_STATE(2550)] = 109576,
  [SMALL_STATE(2551)] = 109595,
  [SMALL_STATE(2552)] = 109612,
  [SMALL_STATE(2553)] = 109631,
  [SMALL_STATE(2554)] = 109650,
  [SMALL_STATE(2555)] = 109673,
  [SMALL_STATE(2556)] = 109696,
  [SMALL_STATE(2557)] = 109719,
  [SMALL_STATE(2558)] = 109738,
  [SMALL_STATE(2559)] = 109759,
  [SMALL_STATE(2560)] = 109776,
  [SMALL_STATE(2561)] = 109795,
  [SMALL_STATE(2562)] = 109818,
  [SMALL_STATE(2563)] = 109837,
  [SMALL_STATE(2564)] = 109854,
  [SMALL_STATE(2565)] = 109873,
  [SMALL_STATE(2566)] = 109890,
  [SMALL_STATE(2567)] = 109909,
  [SMALL_STATE(2568)] = 109932,
  [SMALL_STATE(2569)] = 109951,
  [SMALL_STATE(2570)] = 109970,
  [SMALL_STATE(2571)] = 109993,
  [SMALL_STATE(2572)] = 110010,
  [SMALL_STATE(2573)] = 110031,
  [SMALL_STATE(2574)] = 110050,
  [SMALL_STATE(2575)] = 110069,
  [SMALL_STATE(2576)] = 110088,
  [SMALL_STATE(2577)] = 110105,
  [SMALL_STATE(2578)] = 110124,
  [SMALL_STATE(2579)] = 110144,
  [SMALL_STATE(2580)] = 110178,
  [SMALL_STATE(2581)] = 110206,
  [SMALL_STATE(2582)] = 110238,
  [SMALL_STATE(2583)] = 110266,
  [SMALL_STATE(2584)] = 110300,
  [SMALL_STATE(2585)] = 110334,
  [SMALL_STATE(2586)] = 110368,
  [SMALL_STATE(2587)] = 110392,
  [SMALL_STATE(2588)] = 110426,
  [SMALL_STATE(2589)] = 110452,
  [SMALL_STATE(2590)] = 110472,
  [SMALL_STATE(2591)] = 110506,
  [SMALL_STATE(2592)] = 110528,
  [SMALL_STATE(2593)] = 110562,
  [SMALL_STATE(2594)] = 110582,
  [SMALL_STATE(2595)] = 110608,
  [SMALL_STATE(2596)] = 110642,
  [SMALL_STATE(2597)] = 110660,
  [SMALL_STATE(2598)] = 110694,
  [SMALL_STATE(2599)] = 110728,
  [SMALL_STATE(2600)] = 110754,
  [SMALL_STATE(2601)] = 110788,
  [SMALL_STATE(2602)] = 110819,
  [SMALL_STATE(2603)] = 110834,
  [SMALL_STATE(2604)] = 110851,
  [SMALL_STATE(2605)] = 110866,
  [SMALL_STATE(2606)] = 110897,
  [SMALL_STATE(2607)] = 110928,
  [SMALL_STATE(2608)] = 110959,
  [SMALL_STATE(2609)] = 110974,
  [SMALL_STATE(2610)] = 111005,
  [SMALL_STATE(2611)] = 111020,
  [SMALL_STATE(2612)] = 111035,
  [SMALL_STATE(2613)] = 111066,
  [SMALL_STATE(2614)] = 111081,
  [SMALL_STATE(2615)] = 111096,
  [SMALL_STATE(2616)] = 111117,
  [SMALL_STATE(2617)] = 111132,
  [SMALL_STATE(2618)] = 111149,
  [SMALL_STATE(2619)] = 111166,
  [SMALL_STATE(2620)] = 111191,
  [SMALL_STATE(2621)] = 111216,
  [SMALL_STATE(2622)] = 111231,
  [SMALL_STATE(2623)] = 111246,
  [SMALL_STATE(2624)] = 111277,
  [SMALL_STATE(2625)] = 111294,
  [SMALL_STATE(2626)] = 111309,
  [SMALL_STATE(2627)] = 111330,
  [SMALL_STATE(2628)] = 111345,
  [SMALL_STATE(2629)] = 111376,
  [SMALL_STATE(2630)] = 111391,
  [SMALL_STATE(2631)] = 111406,
  [SMALL_STATE(2632)] = 111423,
  [SMALL_STATE(2633)] = 111438,
  [SMALL_STATE(2634)] = 111455,
  [SMALL_STATE(2635)] = 111470,
  [SMALL_STATE(2636)] = 111489,
  [SMALL_STATE(2637)] = 111510,
  [SMALL_STATE(2638)] = 111525,
  [SMALL_STATE(2639)] = 111540,
  [SMALL_STATE(2640)] = 111555,
  [SMALL_STATE(2641)] = 111572,
  [SMALL_STATE(2642)] = 111587,
  [SMALL_STATE(2643)] = 111602,
  [SMALL_STATE(2644)] = 111617,
  [SMALL_STATE(2645)] = 111632,
  [SMALL_STATE(2646)] = 111647,
  [SMALL_STATE(2647)] = 111662,
  [SMALL_STATE(2648)] = 111687,
  [SMALL_STATE(2649)] = 111712,
  [SMALL_STATE(2650)] = 111727,
  [SMALL_STATE(2651)] = 111742,
  [SMALL_STATE(2652)] = 111773,
  [SMALL_STATE(2653)] = 111804,
  [SMALL_STATE(2654)] = 111819,
  [SMALL_STATE(2655)] = 111834,
  [SMALL_STATE(2656)] = 111853,
  [SMALL_STATE(2657)] = 111868,
  [SMALL_STATE(2658)] = 111883,
  [SMALL_STATE(2659)] = 111898,
  [SMALL_STATE(2660)] = 111913,
  [SMALL_STATE(2661)] = 111928,
  [SMALL_STATE(2662)] = 111959,
  [SMALL_STATE(2663)] = 111984,
  [SMALL_STATE(2664)] = 112009,
  [SMALL_STATE(2665)] = 112034,
  [SMALL_STATE(2666)] = 112065,
  [SMALL_STATE(2667)] = 112096,
  [SMALL_STATE(2668)] = 112111,
  [SMALL_STATE(2669)] = 112126,
  [SMALL_STATE(2670)] = 112145,
  [SMALL_STATE(2671)] = 112166,
  [SMALL_STATE(2672)] = 112191,
  [SMALL_STATE(2673)] = 112210,
  [SMALL_STATE(2674)] = 112241,
  [SMALL_STATE(2675)] = 112272,
  [SMALL_STATE(2676)] = 112287,
  [SMALL_STATE(2677)] = 112302,
  [SMALL_STATE(2678)] = 112333,
  [SMALL_STATE(2679)] = 112356,
  [SMALL_STATE(2680)] = 112381,
  [SMALL_STATE(2681)] = 112406,
  [SMALL_STATE(2682)] = 112427,
  [SMALL_STATE(2683)] = 112458,
  [SMALL_STATE(2684)] = 112483,
  [SMALL_STATE(2685)] = 112514,
  [SMALL_STATE(2686)] = 112529,
  [SMALL_STATE(2687)] = 112554,
  [SMALL_STATE(2688)] = 112579,
  [SMALL_STATE(2689)] = 112594,
  [SMALL_STATE(2690)] = 112619,
  [SMALL_STATE(2691)] = 112650,
  [SMALL_STATE(2692)] = 112670,
  [SMALL_STATE(2693)] = 112694,
  [SMALL_STATE(2694)] = 112718,
  [SMALL_STATE(2695)] = 112742,
  [SMALL_STATE(2696)] = 112766,
  [SMALL_STATE(2697)] = 112790,
  [SMALL_STATE(2698)] = 112814,
  [SMALL_STATE(2699)] = 112838,
  [SMALL_STATE(2700)] = 112862,
  [SMALL_STATE(2701)] = 112886,
  [SMALL_STATE(2702)] = 112910,
  [SMALL_STATE(2703)] = 112924,
  [SMALL_STATE(2704)] = 112948,
  [SMALL_STATE(2705)] = 112968,
  [SMALL_STATE(2706)] = 112982,
  [SMALL_STATE(2707)] = 113000,
  [SMALL_STATE(2708)] = 113024,
  [SMALL_STATE(2709)] = 113044,
  [SMALL_STATE(2710)] = 113064,
  [SMALL_STATE(2711)] = 113078,
  [SMALL_STATE(2712)] = 113103,
  [SMALL_STATE(2713)] = 113124,
  [SMALL_STATE(2714)] = 113141,
  [SMALL_STATE(2715)] = 113166,
  [SMALL_STATE(2716)] = 113191,
  [SMALL_STATE(2717)] = 113216,
  [SMALL_STATE(2718)] = 113241,
  [SMALL_STATE(2719)] = 113266,
  [SMALL_STATE(2720)] = 113291,
  [SMALL_STATE(2721)] = 113304,
  [SMALL_STATE(2722)] = 113329,
  [SMALL_STATE(2723)] = 113350,
  [SMALL_STATE(2724)] = 113375,
  [SMALL_STATE(2725)] = 113392,
  [SMALL_STATE(2726)] = 113409,
  [SMALL_STATE(2727)] = 113434,
  [SMALL_STATE(2728)] = 113457,
  [SMALL_STATE(2729)] = 113470,
  [SMALL_STATE(2730)] = 113483,
  [SMALL_STATE(2731)] = 113500,
  [SMALL_STATE(2732)] = 113525,
  [SMALL_STATE(2733)] = 113540,
  [SMALL_STATE(2734)] = 113565,
  [SMALL_STATE(2735)] = 113578,
  [SMALL_STATE(2736)] = 113603,
  [SMALL_STATE(2737)] = 113628,
  [SMALL_STATE(2738)] = 113653,
  [SMALL_STATE(2739)] = 113668,
  [SMALL_STATE(2740)] = 113681,
  [SMALL_STATE(2741)] = 113706,
  [SMALL_STATE(2742)] = 113719,
  [SMALL_STATE(2743)] = 113740,
  [SMALL_STATE(2744)] = 113757,
  [SMALL_STATE(2745)] = 113776,
  [SMALL_STATE(2746)] = 113801,
  [SMALL_STATE(2747)] = 113826,
  [SMALL_STATE(2748)] = 113847,
  [SMALL_STATE(2749)] = 113872,
  [SMALL_STATE(2750)] = 113897,
  [SMALL_STATE(2751)] = 113918,
  [SMALL_STATE(2752)] = 113935,
  [SMALL_STATE(2753)] = 113956,
  [SMALL_STATE(2754)] = 113981,
  [SMALL_STATE(2755)] = 114006,
  [SMALL_STATE(2756)] = 114019,
  [SMALL_STATE(2757)] = 114034,
  [SMALL_STATE(2758)] = 114059,
  [SMALL_STATE(2759)] = 114076,
  [SMALL_STATE(2760)] = 114093,
  [SMALL_STATE(2761)] = 114118,
  [SMALL_STATE(2762)] = 114143,
  [SMALL_STATE(2763)] = 114164,
  [SMALL_STATE(2764)] = 114181,
  [SMALL_STATE(2765)] = 114202,
  [SMALL_STATE(2766)] = 114215,
  [SMALL_STATE(2767)] = 114240,
  [SMALL_STATE(2768)] = 114265,
  [SMALL_STATE(2769)] = 114286,
  [SMALL_STATE(2770)] = 114311,
  [SMALL_STATE(2771)] = 114336,
  [SMALL_STATE(2772)] = 114357,
  [SMALL_STATE(2773)] = 114382,
  [SMALL_STATE(2774)] = 114399,
  [SMALL_STATE(2775)] = 114416,
  [SMALL_STATE(2776)] = 114437,
  [SMALL_STATE(2777)] = 114458,
  [SMALL_STATE(2778)] = 114475,
  [SMALL_STATE(2779)] = 114492,
  [SMALL_STATE(2780)] = 114509,
  [SMALL_STATE(2781)] = 114522,
  [SMALL_STATE(2782)] = 114539,
  [SMALL_STATE(2783)] = 114556,
  [SMALL_STATE(2784)] = 114573,
  [SMALL_STATE(2785)] = 114598,
  [SMALL_STATE(2786)] = 114623,
  [SMALL_STATE(2787)] = 114640,
  [SMALL_STATE(2788)] = 114655,
  [SMALL_STATE(2789)] = 114672,
  [SMALL_STATE(2790)] = 114689,
  [SMALL_STATE(2791)] = 114706,
  [SMALL_STATE(2792)] = 114723,
  [SMALL_STATE(2793)] = 114736,
  [SMALL_STATE(2794)] = 114753,
  [SMALL_STATE(2795)] = 114778,
  [SMALL_STATE(2796)] = 114795,
  [SMALL_STATE(2797)] = 114808,
  [SMALL_STATE(2798)] = 114821,
  [SMALL_STATE(2799)] = 114842,
  [SMALL_STATE(2800)] = 114867,
  [SMALL_STATE(2801)] = 114888,
  [SMALL_STATE(2802)] = 114901,
  [SMALL_STATE(2803)] = 114926,
  [SMALL_STATE(2804)] = 114941,
  [SMALL_STATE(2805)] = 114958,
  [SMALL_STATE(2806)] = 114983,
  [SMALL_STATE(2807)] = 114996,
  [SMALL_STATE(2808)] = 115013,
  [SMALL_STATE(2809)] = 115026,
  [SMALL_STATE(2810)] = 115051,
  [SMALL_STATE(2811)] = 115076,
  [SMALL_STATE(2812)] = 115101,
  [SMALL_STATE(2813)] = 115126,
  [SMALL_STATE(2814)] = 115151,
  [SMALL_STATE(2815)] = 115176,
  [SMALL_STATE(2816)] = 115201,
  [SMALL_STATE(2817)] = 115222,
  [SMALL_STATE(2818)] = 115238,
  [SMALL_STATE(2819)] = 115254,
  [SMALL_STATE(2820)] = 115266,
  [SMALL_STATE(2821)] = 115284,
  [SMALL_STATE(2822)] = 115296,
  [SMALL_STATE(2823)] = 115312,
  [SMALL_STATE(2824)] = 115328,
  [SMALL_STATE(2825)] = 115350,
  [SMALL_STATE(2826)] = 115366,
  [SMALL_STATE(2827)] = 115378,
  [SMALL_STATE(2828)] = 115400,
  [SMALL_STATE(2829)] = 115422,
  [SMALL_STATE(2830)] = 115444,
  [SMALL_STATE(2831)] = 115466,
  [SMALL_STATE(2832)] = 115488,
  [SMALL_STATE(2833)] = 115500,
  [SMALL_STATE(2834)] = 115522,
  [SMALL_STATE(2835)] = 115534,
  [SMALL_STATE(2836)] = 115550,
  [SMALL_STATE(2837)] = 115568,
  [SMALL_STATE(2838)] = 115590,
  [SMALL_STATE(2839)] = 115610,
  [SMALL_STATE(2840)] = 115622,
  [SMALL_STATE(2841)] = 115638,
  [SMALL_STATE(2842)] = 115654,
  [SMALL_STATE(2843)] = 115670,
  [SMALL_STATE(2844)] = 115682,
  [SMALL_STATE(2845)] = 115700,
  [SMALL_STATE(2846)] = 115718,
  [SMALL_STATE(2847)] = 115738,
  [SMALL_STATE(2848)] = 115750,
  [SMALL_STATE(2849)] = 115772,
  [SMALL_STATE(2850)] = 115794,
  [SMALL_STATE(2851)] = 115816,
  [SMALL_STATE(2852)] = 115832,
  [SMALL_STATE(2853)] = 115844,
  [SMALL_STATE(2854)] = 115866,
  [SMALL_STATE(2855)] = 115882,
  [SMALL_STATE(2856)] = 115904,
  [SMALL_STATE(2857)] = 115922,
  [SMALL_STATE(2858)] = 115934,
  [SMALL_STATE(2859)] = 115950,
  [SMALL_STATE(2860)] = 115966,
  [SMALL_STATE(2861)] = 115982,
  [SMALL_STATE(2862)] = 115998,
  [SMALL_STATE(2863)] = 116020,
  [SMALL_STATE(2864)] = 116032,
  [SMALL_STATE(2865)] = 116048,
  [SMALL_STATE(2866)] = 116070,
  [SMALL_STATE(2867)] = 116092,
  [SMALL_STATE(2868)] = 116108,
  [SMALL_STATE(2869)] = 116130,
  [SMALL_STATE(2870)] = 116146,
  [SMALL_STATE(2871)] = 116162,
  [SMALL_STATE(2872)] = 116176,
  [SMALL_STATE(2873)] = 116192,
  [SMALL_STATE(2874)] = 116214,
  [SMALL_STATE(2875)] = 116236,
  [SMALL_STATE(2876)] = 116252,
  [SMALL_STATE(2877)] = 116274,
  [SMALL_STATE(2878)] = 116288,
  [SMALL_STATE(2879)] = 116306,
  [SMALL_STATE(2880)] = 116322,
  [SMALL_STATE(2881)] = 116344,
  [SMALL_STATE(2882)] = 116358,
  [SMALL_STATE(2883)] = 116374,
  [SMALL_STATE(2884)] = 116390,
  [SMALL_STATE(2885)] = 116408,
  [SMALL_STATE(2886)] = 116424,
  [SMALL_STATE(2887)] = 116440,
  [SMALL_STATE(2888)] = 116456,
  [SMALL_STATE(2889)] = 116478,
  [SMALL_STATE(2890)] = 116500,
  [SMALL_STATE(2891)] = 116522,
  [SMALL_STATE(2892)] = 116544,
  [SMALL_STATE(2893)] = 116560,
  [SMALL_STATE(2894)] = 116582,
  [SMALL_STATE(2895)] = 116604,
  [SMALL_STATE(2896)] = 116616,
  [SMALL_STATE(2897)] = 116638,
  [SMALL_STATE(2898)] = 116660,
  [SMALL_STATE(2899)] = 116676,
  [SMALL_STATE(2900)] = 116696,
  [SMALL_STATE(2901)] = 116714,
  [SMALL_STATE(2902)] = 116736,
  [SMALL_STATE(2903)] = 116758,
  [SMALL_STATE(2904)] = 116774,
  [SMALL_STATE(2905)] = 116796,
  [SMALL_STATE(2906)] = 116818,
  [SMALL_STATE(2907)] = 116840,
  [SMALL_STATE(2908)] = 116858,
  [SMALL_STATE(2909)] = 116880,
  [SMALL_STATE(2910)] = 116896,
  [SMALL_STATE(2911)] = 116908,
  [SMALL_STATE(2912)] = 116926,
  [SMALL_STATE(2913)] = 116948,
  [SMALL_STATE(2914)] = 116970,
  [SMALL_STATE(2915)] = 116988,
  [SMALL_STATE(2916)] = 117004,
  [SMALL_STATE(2917)] = 117026,
  [SMALL_STATE(2918)] = 117048,
  [SMALL_STATE(2919)] = 117070,
  [SMALL_STATE(2920)] = 117088,
  [SMALL_STATE(2921)] = 117106,
  [SMALL_STATE(2922)] = 117122,
  [SMALL_STATE(2923)] = 117144,
  [SMALL_STATE(2924)] = 117162,
  [SMALL_STATE(2925)] = 117180,
  [SMALL_STATE(2926)] = 117192,
  [SMALL_STATE(2927)] = 117204,
  [SMALL_STATE(2928)] = 117220,
  [SMALL_STATE(2929)] = 117236,
  [SMALL_STATE(2930)] = 117252,
  [SMALL_STATE(2931)] = 117264,
  [SMALL_STATE(2932)] = 117286,
  [SMALL_STATE(2933)] = 117302,
  [SMALL_STATE(2934)] = 117324,
  [SMALL_STATE(2935)] = 117340,
  [SMALL_STATE(2936)] = 117362,
  [SMALL_STATE(2937)] = 117380,
  [SMALL_STATE(2938)] = 117402,
  [SMALL_STATE(2939)] = 117424,
  [SMALL_STATE(2940)] = 117442,
  [SMALL_STATE(2941)] = 117458,
  [SMALL_STATE(2942)] = 117476,
  [SMALL_STATE(2943)] = 117494,
  [SMALL_STATE(2944)] = 117512,
  [SMALL_STATE(2945)] = 117530,
  [SMALL_STATE(2946)] = 117550,
  [SMALL_STATE(2947)] = 117572,
  [SMALL_STATE(2948)] = 117588,
  [SMALL_STATE(2949)] = 117606,
  [SMALL_STATE(2950)] = 117628,
  [SMALL_STATE(2951)] = 117650,
  [SMALL_STATE(2952)] = 117666,
  [SMALL_STATE(2953)] = 117682,
  [SMALL_STATE(2954)] = 117698,
  [SMALL_STATE(2955)] = 117720,
  [SMALL_STATE(2956)] = 117736,
  [SMALL_STATE(2957)] = 117758,
  [SMALL_STATE(2958)] = 117780,
  [SMALL_STATE(2959)] = 117796,
  [SMALL_STATE(2960)] = 117816,
  [SMALL_STATE(2961)] = 117834,
  [SMALL_STATE(2962)] = 117846,
  [SMALL_STATE(2963)] = 117862,
  [SMALL_STATE(2964)] = 117874,
  [SMALL_STATE(2965)] = 117892,
  [SMALL_STATE(2966)] = 117912,
  [SMALL_STATE(2967)] = 117934,
  [SMALL_STATE(2968)] = 117950,
  [SMALL_STATE(2969)] = 117972,
  [SMALL_STATE(2970)] = 117988,
  [SMALL_STATE(2971)] = 118010,
  [SMALL_STATE(2972)] = 118022,
  [SMALL_STATE(2973)] = 118038,
  [SMALL_STATE(2974)] = 118050,
  [SMALL_STATE(2975)] = 118072,
  [SMALL_STATE(2976)] = 118084,
  [SMALL_STATE(2977)] = 118100,
  [SMALL_STATE(2978)] = 118118,
  [SMALL_STATE(2979)] = 118132,
  [SMALL_STATE(2980)] = 118144,
  [SMALL_STATE(2981)] = 118162,
  [SMALL_STATE(2982)] = 118173,
  [SMALL_STATE(2983)] = 118184,
  [SMALL_STATE(2984)] = 118195,
  [SMALL_STATE(2985)] = 118206,
  [SMALL_STATE(2986)] = 118225,
  [SMALL_STATE(2987)] = 118244,
  [SMALL_STATE(2988)] = 118259,
  [SMALL_STATE(2989)] = 118278,
  [SMALL_STATE(2990)] = 118293,
  [SMALL_STATE(2991)] = 118312,
  [SMALL_STATE(2992)] = 118323,
  [SMALL_STATE(2993)] = 118340,
  [SMALL_STATE(2994)] = 118351,
  [SMALL_STATE(2995)] = 118370,
  [SMALL_STATE(2996)] = 118389,
  [SMALL_STATE(2997)] = 118408,
  [SMALL_STATE(2998)] = 118423,
  [SMALL_STATE(2999)] = 118440,
  [SMALL_STATE(3000)] = 118451,
  [SMALL_STATE(3001)] = 118462,
  [SMALL_STATE(3002)] = 118479,
  [SMALL_STATE(3003)] = 118490,
  [SMALL_STATE(3004)] = 118501,
  [SMALL_STATE(3005)] = 118512,
  [SMALL_STATE(3006)] = 118527,
  [SMALL_STATE(3007)] = 118544,
  [SMALL_STATE(3008)] = 118555,
  [SMALL_STATE(3009)] = 118574,
  [SMALL_STATE(3010)] = 118587,
  [SMALL_STATE(3011)] = 118598,
  [SMALL_STATE(3012)] = 118609,
  [SMALL_STATE(3013)] = 118626,
  [SMALL_STATE(3014)] = 118645,
  [SMALL_STATE(3015)] = 118656,
  [SMALL_STATE(3016)] = 118675,
  [SMALL_STATE(3017)] = 118686,
  [SMALL_STATE(3018)] = 118703,
  [SMALL_STATE(3019)] = 118722,
  [SMALL_STATE(3020)] = 118733,
  [SMALL_STATE(3021)] = 118752,
  [SMALL_STATE(3022)] = 118771,
  [SMALL_STATE(3023)] = 118782,
  [SMALL_STATE(3024)] = 118793,
  [SMALL_STATE(3025)] = 118804,
  [SMALL_STATE(3026)] = 118821,
  [SMALL_STATE(3027)] = 118836,
  [SMALL_STATE(3028)] = 118847,
  [SMALL_STATE(3029)] = 118858,
  [SMALL_STATE(3030)] = 118869,
  [SMALL_STATE(3031)] = 118886,
  [SMALL_STATE(3032)] = 118901,
  [SMALL_STATE(3033)] = 118920,
  [SMALL_STATE(3034)] = 118939,
  [SMALL_STATE(3035)] = 118954,
  [SMALL_STATE(3036)] = 118973,
  [SMALL_STATE(3037)] = 118984,
  [SMALL_STATE(3038)] = 118995,
  [SMALL_STATE(3039)] = 119014,
  [SMALL_STATE(3040)] = 119025,
  [SMALL_STATE(3041)] = 119036,
  [SMALL_STATE(3042)] = 119047,
  [SMALL_STATE(3043)] = 119058,
  [SMALL_STATE(3044)] = 119075,
  [SMALL_STATE(3045)] = 119086,
  [SMALL_STATE(3046)] = 119097,
  [SMALL_STATE(3047)] = 119108,
  [SMALL_STATE(3048)] = 119125,
  [SMALL_STATE(3049)] = 119138,
  [SMALL_STATE(3050)] = 119151,
  [SMALL_STATE(3051)] = 119170,
  [SMALL_STATE(3052)] = 119181,
  [SMALL_STATE(3053)] = 119192,
  [SMALL_STATE(3054)] = 119211,
  [SMALL_STATE(3055)] = 119222,
  [SMALL_STATE(3056)] = 119233,
  [SMALL_STATE(3057)] = 119252,
  [SMALL_STATE(3058)] = 119271,
  [SMALL_STATE(3059)] = 119282,
  [SMALL_STATE(3060)] = 119301,
  [SMALL_STATE(3061)] = 119320,
  [SMALL_STATE(3062)] = 119339,
  [SMALL_STATE(3063)] = 119358,
  [SMALL_STATE(3064)] = 119369,
  [SMALL_STATE(3065)] = 119380,
  [SMALL_STATE(3066)] = 119391,
  [SMALL_STATE(3067)] = 119410,
  [SMALL_STATE(3068)] = 119429,
  [SMALL_STATE(3069)] = 119446,
  [SMALL_STATE(3070)] = 119457,
  [SMALL_STATE(3071)] = 119476,
  [SMALL_STATE(3072)] = 119487,
  [SMALL_STATE(3073)] = 119500,
  [SMALL_STATE(3074)] = 119511,
  [SMALL_STATE(3075)] = 119530,
  [SMALL_STATE(3076)] = 119541,
  [SMALL_STATE(3077)] = 119552,
  [SMALL_STATE(3078)] = 119571,
  [SMALL_STATE(3079)] = 119582,
  [SMALL_STATE(3080)] = 119601,
  [SMALL_STATE(3081)] = 119612,
  [SMALL_STATE(3082)] = 119631,
  [SMALL_STATE(3083)] = 119646,
  [SMALL_STATE(3084)] = 119657,
  [SMALL_STATE(3085)] = 119668,
  [SMALL_STATE(3086)] = 119687,
  [SMALL_STATE(3087)] = 119698,
  [SMALL_STATE(3088)] = 119709,
  [SMALL_STATE(3089)] = 119726,
  [SMALL_STATE(3090)] = 119741,
  [SMALL_STATE(3091)] = 119760,
  [SMALL_STATE(3092)] = 119775,
  [SMALL_STATE(3093)] = 119790,
  [SMALL_STATE(3094)] = 119801,
  [SMALL_STATE(3095)] = 119812,
  [SMALL_STATE(3096)] = 119823,
  [SMALL_STATE(3097)] = 119842,
  [SMALL_STATE(3098)] = 119861,
  [SMALL_STATE(3099)] = 119880,
  [SMALL_STATE(3100)] = 119899,
  [SMALL_STATE(3101)] = 119910,
  [SMALL_STATE(3102)] = 119921,
  [SMALL_STATE(3103)] = 119932,
  [SMALL_STATE(3104)] = 119951,
  [SMALL_STATE(3105)] = 119962,
  [SMALL_STATE(3106)] = 119973,
  [SMALL_STATE(3107)] = 119984,
  [SMALL_STATE(3108)] = 120003,
  [SMALL_STATE(3109)] = 120020,
  [SMALL_STATE(3110)] = 120031,
  [SMALL_STATE(3111)] = 120042,
  [SMALL_STATE(3112)] = 120053,
  [SMALL_STATE(3113)] = 120064,
  [SMALL_STATE(3114)] = 120075,
  [SMALL_STATE(3115)] = 120086,
  [SMALL_STATE(3116)] = 120097,
  [SMALL_STATE(3117)] = 120116,
  [SMALL_STATE(3118)] = 120127,
  [SMALL_STATE(3119)] = 120138,
  [SMALL_STATE(3120)] = 120157,
  [SMALL_STATE(3121)] = 120176,
  [SMALL_STATE(3122)] = 120193,
  [SMALL_STATE(3123)] = 120204,
  [SMALL_STATE(3124)] = 120221,
  [SMALL_STATE(3125)] = 120234,
  [SMALL_STATE(3126)] = 120253,
  [SMALL_STATE(3127)] = 120272,
  [SMALL_STATE(3128)] = 120287,
  [SMALL_STATE(3129)] = 120298,
  [SMALL_STATE(3130)] = 120309,
  [SMALL_STATE(3131)] = 120328,
  [SMALL_STATE(3132)] = 120347,
  [SMALL_STATE(3133)] = 120358,
  [SMALL_STATE(3134)] = 120369,
  [SMALL_STATE(3135)] = 120380,
  [SMALL_STATE(3136)] = 120391,
  [SMALL_STATE(3137)] = 120410,
  [SMALL_STATE(3138)] = 120421,
  [SMALL_STATE(3139)] = 120432,
  [SMALL_STATE(3140)] = 120451,
  [SMALL_STATE(3141)] = 120462,
  [SMALL_STATE(3142)] = 120481,
  [SMALL_STATE(3143)] = 120492,
  [SMALL_STATE(3144)] = 120511,
  [SMALL_STATE(3145)] = 120522,
  [SMALL_STATE(3146)] = 120533,
  [SMALL_STATE(3147)] = 120550,
  [SMALL_STATE(3148)] = 120561,
  [SMALL_STATE(3149)] = 120580,
  [SMALL_STATE(3150)] = 120599,
  [SMALL_STATE(3151)] = 120616,
  [SMALL_STATE(3152)] = 120635,
  [SMALL_STATE(3153)] = 120654,
  [SMALL_STATE(3154)] = 120673,
  [SMALL_STATE(3155)] = 120684,
  [SMALL_STATE(3156)] = 120695,
  [SMALL_STATE(3157)] = 120706,
  [SMALL_STATE(3158)] = 120721,
  [SMALL_STATE(3159)] = 120740,
  [SMALL_STATE(3160)] = 120751,
  [SMALL_STATE(3161)] = 120762,
  [SMALL_STATE(3162)] = 120779,
  [SMALL_STATE(3163)] = 120790,
  [SMALL_STATE(3164)] = 120801,
  [SMALL_STATE(3165)] = 120818,
  [SMALL_STATE(3166)] = 120837,
  [SMALL_STATE(3167)] = 120848,
  [SMALL_STATE(3168)] = 120863,
  [SMALL_STATE(3169)] = 120882,
  [SMALL_STATE(3170)] = 120897,
  [SMALL_STATE(3171)] = 120912,
  [SMALL_STATE(3172)] = 120923,
  [SMALL_STATE(3173)] = 120940,
  [SMALL_STATE(3174)] = 120959,
  [SMALL_STATE(3175)] = 120974,
  [SMALL_STATE(3176)] = 120985,
  [SMALL_STATE(3177)] = 121004,
  [SMALL_STATE(3178)] = 121019,
  [SMALL_STATE(3179)] = 121034,
  [SMALL_STATE(3180)] = 121053,
  [SMALL_STATE(3181)] = 121064,
  [SMALL_STATE(3182)] = 121083,
  [SMALL_STATE(3183)] = 121102,
  [SMALL_STATE(3184)] = 121113,
  [SMALL_STATE(3185)] = 121124,
  [SMALL_STATE(3186)] = 121139,
  [SMALL_STATE(3187)] = 121154,
  [SMALL_STATE(3188)] = 121169,
  [SMALL_STATE(3189)] = 121180,
  [SMALL_STATE(3190)] = 121191,
  [SMALL_STATE(3191)] = 121202,
  [SMALL_STATE(3192)] = 121221,
  [SMALL_STATE(3193)] = 121232,
  [SMALL_STATE(3194)] = 121243,
  [SMALL_STATE(3195)] = 121260,
  [SMALL_STATE(3196)] = 121271,
  [SMALL_STATE(3197)] = 121282,
  [SMALL_STATE(3198)] = 121297,
  [SMALL_STATE(3199)] = 121312,
  [SMALL_STATE(3200)] = 121331,
  [SMALL_STATE(3201)] = 121350,
  [SMALL_STATE(3202)] = 121361,
  [SMALL_STATE(3203)] = 121378,
  [SMALL_STATE(3204)] = 121389,
  [SMALL_STATE(3205)] = 121400,
  [SMALL_STATE(3206)] = 121419,
  [SMALL_STATE(3207)] = 121438,
  [SMALL_STATE(3208)] = 121449,
  [SMALL_STATE(3209)] = 121460,
  [SMALL_STATE(3210)] = 121479,
  [SMALL_STATE(3211)] = 121490,
  [SMALL_STATE(3212)] = 121509,
  [SMALL_STATE(3213)] = 121520,
  [SMALL_STATE(3214)] = 121537,
  [SMALL_STATE(3215)] = 121548,
  [SMALL_STATE(3216)] = 121559,
  [SMALL_STATE(3217)] = 121578,
  [SMALL_STATE(3218)] = 121589,
  [SMALL_STATE(3219)] = 121606,
  [SMALL_STATE(3220)] = 121617,
  [SMALL_STATE(3221)] = 121636,
  [SMALL_STATE(3222)] = 121647,
  [SMALL_STATE(3223)] = 121658,
  [SMALL_STATE(3224)] = 121669,
  [SMALL_STATE(3225)] = 121680,
  [SMALL_STATE(3226)] = 121691,
  [SMALL_STATE(3227)] = 121702,
  [SMALL_STATE(3228)] = 121713,
  [SMALL_STATE(3229)] = 121728,
  [SMALL_STATE(3230)] = 121739,
  [SMALL_STATE(3231)] = 121750,
  [SMALL_STATE(3232)] = 121761,
  [SMALL_STATE(3233)] = 121778,
  [SMALL_STATE(3234)] = 121795,
  [SMALL_STATE(3235)] = 121814,
  [SMALL_STATE(3236)] = 121825,
  [SMALL_STATE(3237)] = 121836,
  [SMALL_STATE(3238)] = 121847,
  [SMALL_STATE(3239)] = 121858,
  [SMALL_STATE(3240)] = 121869,
  [SMALL_STATE(3241)] = 121880,
  [SMALL_STATE(3242)] = 121899,
  [SMALL_STATE(3243)] = 121910,
  [SMALL_STATE(3244)] = 121921,
  [SMALL_STATE(3245)] = 121932,
  [SMALL_STATE(3246)] = 121951,
  [SMALL_STATE(3247)] = 121962,
  [SMALL_STATE(3248)] = 121973,
  [SMALL_STATE(3249)] = 121984,
  [SMALL_STATE(3250)] = 122003,
  [SMALL_STATE(3251)] = 122014,
  [SMALL_STATE(3252)] = 122025,
  [SMALL_STATE(3253)] = 122040,
  [SMALL_STATE(3254)] = 122051,
  [SMALL_STATE(3255)] = 122065,
  [SMALL_STATE(3256)] = 122079,
  [SMALL_STATE(3257)] = 122095,
  [SMALL_STATE(3258)] = 122111,
  [SMALL_STATE(3259)] = 122125,
  [SMALL_STATE(3260)] = 122141,
  [SMALL_STATE(3261)] = 122155,
  [SMALL_STATE(3262)] = 122171,
  [SMALL_STATE(3263)] = 122187,
  [SMALL_STATE(3264)] = 122203,
  [SMALL_STATE(3265)] = 122219,
  [SMALL_STATE(3266)] = 122231,
  [SMALL_STATE(3267)] = 122245,
  [SMALL_STATE(3268)] = 122259,
  [SMALL_STATE(3269)] = 122273,
  [SMALL_STATE(3270)] = 122285,
  [SMALL_STATE(3271)] = 122301,
  [SMALL_STATE(3272)] = 122317,
  [SMALL_STATE(3273)] = 122331,
  [SMALL_STATE(3274)] = 122345,
  [SMALL_STATE(3275)] = 122361,
  [SMALL_STATE(3276)] = 122377,
  [SMALL_STATE(3277)] = 122393,
  [SMALL_STATE(3278)] = 122407,
  [SMALL_STATE(3279)] = 122423,
  [SMALL_STATE(3280)] = 122437,
  [SMALL_STATE(3281)] = 122451,
  [SMALL_STATE(3282)] = 122465,
  [SMALL_STATE(3283)] = 122479,
  [SMALL_STATE(3284)] = 122493,
  [SMALL_STATE(3285)] = 122507,
  [SMALL_STATE(3286)] = 122523,
  [SMALL_STATE(3287)] = 122533,
  [SMALL_STATE(3288)] = 122549,
  [SMALL_STATE(3289)] = 122565,
  [SMALL_STATE(3290)] = 122579,
  [SMALL_STATE(3291)] = 122593,
  [SMALL_STATE(3292)] = 122609,
  [SMALL_STATE(3293)] = 122625,
  [SMALL_STATE(3294)] = 122641,
  [SMALL_STATE(3295)] = 122655,
  [SMALL_STATE(3296)] = 122669,
  [SMALL_STATE(3297)] = 122683,
  [SMALL_STATE(3298)] = 122697,
  [SMALL_STATE(3299)] = 122711,
  [SMALL_STATE(3300)] = 122727,
  [SMALL_STATE(3301)] = 122737,
  [SMALL_STATE(3302)] = 122753,
  [SMALL_STATE(3303)] = 122767,
  [SMALL_STATE(3304)] = 122781,
  [SMALL_STATE(3305)] = 122797,
  [SMALL_STATE(3306)] = 122811,
  [SMALL_STATE(3307)] = 122825,
  [SMALL_STATE(3308)] = 122841,
  [SMALL_STATE(3309)] = 122857,
  [SMALL_STATE(3310)] = 122873,
  [SMALL_STATE(3311)] = 122887,
  [SMALL_STATE(3312)] = 122903,
  [SMALL_STATE(3313)] = 122915,
  [SMALL_STATE(3314)] = 122929,
  [SMALL_STATE(3315)] = 122943,
  [SMALL_STATE(3316)] = 122957,
  [SMALL_STATE(3317)] = 122971,
  [SMALL_STATE(3318)] = 122985,
  [SMALL_STATE(3319)] = 123001,
  [SMALL_STATE(3320)] = 123015,
  [SMALL_STATE(3321)] = 123029,
  [SMALL_STATE(3322)] = 123043,
  [SMALL_STATE(3323)] = 123057,
  [SMALL_STATE(3324)] = 123073,
  [SMALL_STATE(3325)] = 123087,
  [SMALL_STATE(3326)] = 123101,
  [SMALL_STATE(3327)] = 123115,
  [SMALL_STATE(3328)] = 123129,
  [SMALL_STATE(3329)] = 123145,
  [SMALL_STATE(3330)] = 123161,
  [SMALL_STATE(3331)] = 123177,
  [SMALL_STATE(3332)] = 123193,
  [SMALL_STATE(3333)] = 123207,
  [SMALL_STATE(3334)] = 123221,
  [SMALL_STATE(3335)] = 123235,
  [SMALL_STATE(3336)] = 123251,
  [SMALL_STATE(3337)] = 123267,
  [SMALL_STATE(3338)] = 123281,
  [SMALL_STATE(3339)] = 123297,
  [SMALL_STATE(3340)] = 123313,
  [SMALL_STATE(3341)] = 123327,
  [SMALL_STATE(3342)] = 123343,
  [SMALL_STATE(3343)] = 123357,
  [SMALL_STATE(3344)] = 123373,
  [SMALL_STATE(3345)] = 123389,
  [SMALL_STATE(3346)] = 123403,
  [SMALL_STATE(3347)] = 123419,
  [SMALL_STATE(3348)] = 123433,
  [SMALL_STATE(3349)] = 123443,
  [SMALL_STATE(3350)] = 123459,
  [SMALL_STATE(3351)] = 123475,
  [SMALL_STATE(3352)] = 123491,
  [SMALL_STATE(3353)] = 123503,
  [SMALL_STATE(3354)] = 123517,
  [SMALL_STATE(3355)] = 123531,
  [SMALL_STATE(3356)] = 123545,
  [SMALL_STATE(3357)] = 123561,
  [SMALL_STATE(3358)] = 123575,
  [SMALL_STATE(3359)] = 123589,
  [SMALL_STATE(3360)] = 123603,
  [SMALL_STATE(3361)] = 123619,
  [SMALL_STATE(3362)] = 123633,
  [SMALL_STATE(3363)] = 123649,
  [SMALL_STATE(3364)] = 123665,
  [SMALL_STATE(3365)] = 123681,
  [SMALL_STATE(3366)] = 123695,
  [SMALL_STATE(3367)] = 123708,
  [SMALL_STATE(3368)] = 123717,
  [SMALL_STATE(3369)] = 123730,
  [SMALL_STATE(3370)] = 123741,
  [SMALL_STATE(3371)] = 123754,
  [SMALL_STATE(3372)] = 123767,
  [SMALL_STATE(3373)] = 123780,
  [SMALL_STATE(3374)] = 123789,
  [SMALL_STATE(3375)] = 123798,
  [SMALL_STATE(3376)] = 123811,
  [SMALL_STATE(3377)] = 123824,
  [SMALL_STATE(3378)] = 123837,
  [SMALL_STATE(3379)] = 123850,
  [SMALL_STATE(3380)] = 123863,
  [SMALL_STATE(3381)] = 123876,
  [SMALL_STATE(3382)] = 123885,
  [SMALL_STATE(3383)] = 123894,
  [SMALL_STATE(3384)] = 123903,
  [SMALL_STATE(3385)] = 123912,
  [SMALL_STATE(3386)] = 123921,
  [SMALL_STATE(3387)] = 123930,
  [SMALL_STATE(3388)] = 123943,
  [SMALL_STATE(3389)] = 123956,
  [SMALL_STATE(3390)] = 123969,
  [SMALL_STATE(3391)] = 123978,
  [SMALL_STATE(3392)] = 123991,
  [SMALL_STATE(3393)] = 124004,
  [SMALL_STATE(3394)] = 124017,
  [SMALL_STATE(3395)] = 124030,
  [SMALL_STATE(3396)] = 124041,
  [SMALL_STATE(3397)] = 124050,
  [SMALL_STATE(3398)] = 124063,
  [SMALL_STATE(3399)] = 124072,
  [SMALL_STATE(3400)] = 124085,
  [SMALL_STATE(3401)] = 124098,
  [SMALL_STATE(3402)] = 124111,
  [SMALL_STATE(3403)] = 124120,
  [SMALL_STATE(3404)] = 124133,
  [SMALL_STATE(3405)] = 124146,
  [SMALL_STATE(3406)] = 124159,
  [SMALL_STATE(3407)] = 124172,
  [SMALL_STATE(3408)] = 124181,
  [SMALL_STATE(3409)] = 124190,
  [SMALL_STATE(3410)] = 124203,
  [SMALL_STATE(3411)] = 124216,
  [SMALL_STATE(3412)] = 124225,
  [SMALL_STATE(3413)] = 124238,
  [SMALL_STATE(3414)] = 124251,
  [SMALL_STATE(3415)] = 124264,
  [SMALL_STATE(3416)] = 124277,
  [SMALL_STATE(3417)] = 124290,
  [SMALL_STATE(3418)] = 124303,
  [SMALL_STATE(3419)] = 124316,
  [SMALL_STATE(3420)] = 124329,
  [SMALL_STATE(3421)] = 124338,
  [SMALL_STATE(3422)] = 124351,
  [SMALL_STATE(3423)] = 124364,
  [SMALL_STATE(3424)] = 124377,
  [SMALL_STATE(3425)] = 124390,
  [SMALL_STATE(3426)] = 124401,
  [SMALL_STATE(3427)] = 124414,
  [SMALL_STATE(3428)] = 124427,
  [SMALL_STATE(3429)] = 124440,
  [SMALL_STATE(3430)] = 124453,
  [SMALL_STATE(3431)] = 124464,
  [SMALL_STATE(3432)] = 124477,
  [SMALL_STATE(3433)] = 124490,
  [SMALL_STATE(3434)] = 124503,
  [SMALL_STATE(3435)] = 124514,
  [SMALL_STATE(3436)] = 124523,
  [SMALL_STATE(3437)] = 124536,
  [SMALL_STATE(3438)] = 124549,
  [SMALL_STATE(3439)] = 124562,
  [SMALL_STATE(3440)] = 124571,
  [SMALL_STATE(3441)] = 124584,
  [SMALL_STATE(3442)] = 124597,
  [SMALL_STATE(3443)] = 124610,
  [SMALL_STATE(3444)] = 124623,
  [SMALL_STATE(3445)] = 124636,
  [SMALL_STATE(3446)] = 124649,
  [SMALL_STATE(3447)] = 124658,
  [SMALL_STATE(3448)] = 124671,
  [SMALL_STATE(3449)] = 124684,
  [SMALL_STATE(3450)] = 124697,
  [SMALL_STATE(3451)] = 124706,
  [SMALL_STATE(3452)] = 124719,
  [SMALL_STATE(3453)] = 124732,
  [SMALL_STATE(3454)] = 124745,
  [SMALL_STATE(3455)] = 124758,
  [SMALL_STATE(3456)] = 124771,
  [SMALL_STATE(3457)] = 124784,
  [SMALL_STATE(3458)] = 124797,
  [SMALL_STATE(3459)] = 124806,
  [SMALL_STATE(3460)] = 124819,
  [SMALL_STATE(3461)] = 124830,
  [SMALL_STATE(3462)] = 124843,
  [SMALL_STATE(3463)] = 124854,
  [SMALL_STATE(3464)] = 124863,
  [SMALL_STATE(3465)] = 124872,
  [SMALL_STATE(3466)] = 124885,
  [SMALL_STATE(3467)] = 124894,
  [SMALL_STATE(3468)] = 124907,
  [SMALL_STATE(3469)] = 124920,
  [SMALL_STATE(3470)] = 124933,
  [SMALL_STATE(3471)] = 124946,
  [SMALL_STATE(3472)] = 124955,
  [SMALL_STATE(3473)] = 124968,
  [SMALL_STATE(3474)] = 124979,
  [SMALL_STATE(3475)] = 124988,
  [SMALL_STATE(3476)] = 125001,
  [SMALL_STATE(3477)] = 125012,
  [SMALL_STATE(3478)] = 125025,
  [SMALL_STATE(3479)] = 125038,
  [SMALL_STATE(3480)] = 125051,
  [SMALL_STATE(3481)] = 125062,
  [SMALL_STATE(3482)] = 125075,
  [SMALL_STATE(3483)] = 125088,
  [SMALL_STATE(3484)] = 125101,
  [SMALL_STATE(3485)] = 125114,
  [SMALL_STATE(3486)] = 125123,
  [SMALL_STATE(3487)] = 125136,
  [SMALL_STATE(3488)] = 125145,
  [SMALL_STATE(3489)] = 125156,
  [SMALL_STATE(3490)] = 125169,
  [SMALL_STATE(3491)] = 125182,
  [SMALL_STATE(3492)] = 125195,
  [SMALL_STATE(3493)] = 125208,
  [SMALL_STATE(3494)] = 125217,
  [SMALL_STATE(3495)] = 125230,
  [SMALL_STATE(3496)] = 125243,
  [SMALL_STATE(3497)] = 125256,
  [SMALL_STATE(3498)] = 125269,
  [SMALL_STATE(3499)] = 125282,
  [SMALL_STATE(3500)] = 125295,
  [SMALL_STATE(3501)] = 125308,
  [SMALL_STATE(3502)] = 125317,
  [SMALL_STATE(3503)] = 125326,
  [SMALL_STATE(3504)] = 125339,
  [SMALL_STATE(3505)] = 125352,
  [SMALL_STATE(3506)] = 125361,
  [SMALL_STATE(3507)] = 125374,
  [SMALL_STATE(3508)] = 125387,
  [SMALL_STATE(3509)] = 125400,
  [SMALL_STATE(3510)] = 125413,
  [SMALL_STATE(3511)] = 125426,
  [SMALL_STATE(3512)] = 125439,
  [SMALL_STATE(3513)] = 125452,
  [SMALL_STATE(3514)] = 125465,
  [SMALL_STATE(3515)] = 125474,
  [SMALL_STATE(3516)] = 125483,
  [SMALL_STATE(3517)] = 125496,
  [SMALL_STATE(3518)] = 125509,
  [SMALL_STATE(3519)] = 125522,
  [SMALL_STATE(3520)] = 125535,
  [SMALL_STATE(3521)] = 125548,
  [SMALL_STATE(3522)] = 125561,
  [SMALL_STATE(3523)] = 125574,
  [SMALL_STATE(3524)] = 125587,
  [SMALL_STATE(3525)] = 125600,
  [SMALL_STATE(3526)] = 125613,
  [SMALL_STATE(3527)] = 125624,
  [SMALL_STATE(3528)] = 125635,
  [SMALL_STATE(3529)] = 125644,
  [SMALL_STATE(3530)] = 125655,
  [SMALL_STATE(3531)] = 125668,
  [SMALL_STATE(3532)] = 125681,
  [SMALL_STATE(3533)] = 125694,
  [SMALL_STATE(3534)] = 125707,
  [SMALL_STATE(3535)] = 125720,
  [SMALL_STATE(3536)] = 125729,
  [SMALL_STATE(3537)] = 125740,
  [SMALL_STATE(3538)] = 125751,
  [SMALL_STATE(3539)] = 125762,
  [SMALL_STATE(3540)] = 125775,
  [SMALL_STATE(3541)] = 125788,
  [SMALL_STATE(3542)] = 125797,
  [SMALL_STATE(3543)] = 125810,
  [SMALL_STATE(3544)] = 125819,
  [SMALL_STATE(3545)] = 125828,
  [SMALL_STATE(3546)] = 125837,
  [SMALL_STATE(3547)] = 125846,
  [SMALL_STATE(3548)] = 125859,
  [SMALL_STATE(3549)] = 125872,
  [SMALL_STATE(3550)] = 125885,
  [SMALL_STATE(3551)] = 125898,
  [SMALL_STATE(3552)] = 125911,
  [SMALL_STATE(3553)] = 125924,
  [SMALL_STATE(3554)] = 125937,
  [SMALL_STATE(3555)] = 125948,
  [SMALL_STATE(3556)] = 125961,
  [SMALL_STATE(3557)] = 125974,
  [SMALL_STATE(3558)] = 125983,
  [SMALL_STATE(3559)] = 125994,
  [SMALL_STATE(3560)] = 126007,
  [SMALL_STATE(3561)] = 126016,
  [SMALL_STATE(3562)] = 126025,
  [SMALL_STATE(3563)] = 126038,
  [SMALL_STATE(3564)] = 126049,
  [SMALL_STATE(3565)] = 126058,
  [SMALL_STATE(3566)] = 126071,
  [SMALL_STATE(3567)] = 126084,
  [SMALL_STATE(3568)] = 126093,
  [SMALL_STATE(3569)] = 126106,
  [SMALL_STATE(3570)] = 126119,
  [SMALL_STATE(3571)] = 126132,
  [SMALL_STATE(3572)] = 126145,
  [SMALL_STATE(3573)] = 126154,
  [SMALL_STATE(3574)] = 126163,
  [SMALL_STATE(3575)] = 126176,
  [SMALL_STATE(3576)] = 126189,
  [SMALL_STATE(3577)] = 126198,
  [SMALL_STATE(3578)] = 126207,
  [SMALL_STATE(3579)] = 126220,
  [SMALL_STATE(3580)] = 126233,
  [SMALL_STATE(3581)] = 126246,
  [SMALL_STATE(3582)] = 126259,
  [SMALL_STATE(3583)] = 126270,
  [SMALL_STATE(3584)] = 126283,
  [SMALL_STATE(3585)] = 126296,
  [SMALL_STATE(3586)] = 126309,
  [SMALL_STATE(3587)] = 126322,
  [SMALL_STATE(3588)] = 126335,
  [SMALL_STATE(3589)] = 126348,
  [SMALL_STATE(3590)] = 126361,
  [SMALL_STATE(3591)] = 126370,
  [SMALL_STATE(3592)] = 126379,
  [SMALL_STATE(3593)] = 126388,
  [SMALL_STATE(3594)] = 126397,
  [SMALL_STATE(3595)] = 126406,
  [SMALL_STATE(3596)] = 126415,
  [SMALL_STATE(3597)] = 126425,
  [SMALL_STATE(3598)] = 126433,
  [SMALL_STATE(3599)] = 126441,
  [SMALL_STATE(3600)] = 126451,
  [SMALL_STATE(3601)] = 126459,
  [SMALL_STATE(3602)] = 126467,
  [SMALL_STATE(3603)] = 126475,
  [SMALL_STATE(3604)] = 126483,
  [SMALL_STATE(3605)] = 126493,
  [SMALL_STATE(3606)] = 126503,
  [SMALL_STATE(3607)] = 126511,
  [SMALL_STATE(3608)] = 126521,
  [SMALL_STATE(3609)] = 126531,
  [SMALL_STATE(3610)] = 126541,
  [SMALL_STATE(3611)] = 126551,
  [SMALL_STATE(3612)] = 126559,
  [SMALL_STATE(3613)] = 126567,
  [SMALL_STATE(3614)] = 126575,
  [SMALL_STATE(3615)] = 126583,
  [SMALL_STATE(3616)] = 126591,
  [SMALL_STATE(3617)] = 126601,
  [SMALL_STATE(3618)] = 126609,
  [SMALL_STATE(3619)] = 126619,
  [SMALL_STATE(3620)] = 126627,
  [SMALL_STATE(3621)] = 126635,
  [SMALL_STATE(3622)] = 126645,
  [SMALL_STATE(3623)] = 126655,
  [SMALL_STATE(3624)] = 126663,
  [SMALL_STATE(3625)] = 126673,
  [SMALL_STATE(3626)] = 126681,
  [SMALL_STATE(3627)] = 126689,
  [SMALL_STATE(3628)] = 126697,
  [SMALL_STATE(3629)] = 126707,
  [SMALL_STATE(3630)] = 126717,
  [SMALL_STATE(3631)] = 126725,
  [SMALL_STATE(3632)] = 126735,
  [SMALL_STATE(3633)] = 126745,
  [SMALL_STATE(3634)] = 126755,
  [SMALL_STATE(3635)] = 126765,
  [SMALL_STATE(3636)] = 126775,
  [SMALL_STATE(3637)] = 126785,
  [SMALL_STATE(3638)] = 126793,
  [SMALL_STATE(3639)] = 126801,
  [SMALL_STATE(3640)] = 126809,
  [SMALL_STATE(3641)] = 126819,
  [SMALL_STATE(3642)] = 126829,
  [SMALL_STATE(3643)] = 126839,
  [SMALL_STATE(3644)] = 126849,
  [SMALL_STATE(3645)] = 126857,
  [SMALL_STATE(3646)] = 126867,
  [SMALL_STATE(3647)] = 126877,
  [SMALL_STATE(3648)] = 126885,
  [SMALL_STATE(3649)] = 126895,
  [SMALL_STATE(3650)] = 126905,
  [SMALL_STATE(3651)] = 126915,
  [SMALL_STATE(3652)] = 126925,
  [SMALL_STATE(3653)] = 126935,
  [SMALL_STATE(3654)] = 126945,
  [SMALL_STATE(3655)] = 126955,
  [SMALL_STATE(3656)] = 126965,
  [SMALL_STATE(3657)] = 126975,
  [SMALL_STATE(3658)] = 126985,
  [SMALL_STATE(3659)] = 126993,
  [SMALL_STATE(3660)] = 127003,
  [SMALL_STATE(3661)] = 127013,
  [SMALL_STATE(3662)] = 127021,
  [SMALL_STATE(3663)] = 127031,
  [SMALL_STATE(3664)] = 127039,
  [SMALL_STATE(3665)] = 127049,
  [SMALL_STATE(3666)] = 127059,
  [SMALL_STATE(3667)] = 127069,
  [SMALL_STATE(3668)] = 127079,
  [SMALL_STATE(3669)] = 127087,
  [SMALL_STATE(3670)] = 127097,
  [SMALL_STATE(3671)] = 127105,
  [SMALL_STATE(3672)] = 127115,
  [SMALL_STATE(3673)] = 127125,
  [SMALL_STATE(3674)] = 127135,
  [SMALL_STATE(3675)] = 127143,
  [SMALL_STATE(3676)] = 127153,
  [SMALL_STATE(3677)] = 127163,
  [SMALL_STATE(3678)] = 127173,
  [SMALL_STATE(3679)] = 127183,
  [SMALL_STATE(3680)] = 127191,
  [SMALL_STATE(3681)] = 127201,
  [SMALL_STATE(3682)] = 127209,
  [SMALL_STATE(3683)] = 127217,
  [SMALL_STATE(3684)] = 127225,
  [SMALL_STATE(3685)] = 127235,
  [SMALL_STATE(3686)] = 127243,
  [SMALL_STATE(3687)] = 127251,
  [SMALL_STATE(3688)] = 127261,
  [SMALL_STATE(3689)] = 127271,
  [SMALL_STATE(3690)] = 127281,
  [SMALL_STATE(3691)] = 127291,
  [SMALL_STATE(3692)] = 127301,
  [SMALL_STATE(3693)] = 127311,
  [SMALL_STATE(3694)] = 127321,
  [SMALL_STATE(3695)] = 127331,
  [SMALL_STATE(3696)] = 127341,
  [SMALL_STATE(3697)] = 127351,
  [SMALL_STATE(3698)] = 127359,
  [SMALL_STATE(3699)] = 127369,
  [SMALL_STATE(3700)] = 127379,
  [SMALL_STATE(3701)] = 127389,
  [SMALL_STATE(3702)] = 127399,
  [SMALL_STATE(3703)] = 127409,
  [SMALL_STATE(3704)] = 127419,
  [SMALL_STATE(3705)] = 127427,
  [SMALL_STATE(3706)] = 127437,
  [SMALL_STATE(3707)] = 127445,
  [SMALL_STATE(3708)] = 127455,
  [SMALL_STATE(3709)] = 127465,
  [SMALL_STATE(3710)] = 127475,
  [SMALL_STATE(3711)] = 127485,
  [SMALL_STATE(3712)] = 127495,
  [SMALL_STATE(3713)] = 127503,
  [SMALL_STATE(3714)] = 127513,
  [SMALL_STATE(3715)] = 127523,
  [SMALL_STATE(3716)] = 127533,
  [SMALL_STATE(3717)] = 127543,
  [SMALL_STATE(3718)] = 127553,
  [SMALL_STATE(3719)] = 127563,
  [SMALL_STATE(3720)] = 127573,
  [SMALL_STATE(3721)] = 127583,
  [SMALL_STATE(3722)] = 127593,
  [SMALL_STATE(3723)] = 127603,
  [SMALL_STATE(3724)] = 127611,
  [SMALL_STATE(3725)] = 127621,
  [SMALL_STATE(3726)] = 127631,
  [SMALL_STATE(3727)] = 127641,
  [SMALL_STATE(3728)] = 127649,
  [SMALL_STATE(3729)] = 127659,
  [SMALL_STATE(3730)] = 127669,
  [SMALL_STATE(3731)] = 127677,
  [SMALL_STATE(3732)] = 127687,
  [SMALL_STATE(3733)] = 127697,
  [SMALL_STATE(3734)] = 127707,
  [SMALL_STATE(3735)] = 127715,
  [SMALL_STATE(3736)] = 127725,
  [SMALL_STATE(3737)] = 127735,
  [SMALL_STATE(3738)] = 127745,
  [SMALL_STATE(3739)] = 127755,
  [SMALL_STATE(3740)] = 127765,
  [SMALL_STATE(3741)] = 127773,
  [SMALL_STATE(3742)] = 127783,
  [SMALL_STATE(3743)] = 127791,
  [SMALL_STATE(3744)] = 127801,
  [SMALL_STATE(3745)] = 127809,
  [SMALL_STATE(3746)] = 127819,
  [SMALL_STATE(3747)] = 127827,
  [SMALL_STATE(3748)] = 127837,
  [SMALL_STATE(3749)] = 127847,
  [SMALL_STATE(3750)] = 127855,
  [SMALL_STATE(3751)] = 127865,
  [SMALL_STATE(3752)] = 127875,
  [SMALL_STATE(3753)] = 127883,
  [SMALL_STATE(3754)] = 127891,
  [SMALL_STATE(3755)] = 127901,
  [SMALL_STATE(3756)] = 127911,
  [SMALL_STATE(3757)] = 127921,
  [SMALL_STATE(3758)] = 127931,
  [SMALL_STATE(3759)] = 127939,
  [SMALL_STATE(3760)] = 127949,
  [SMALL_STATE(3761)] = 127959,
  [SMALL_STATE(3762)] = 127969,
  [SMALL_STATE(3763)] = 127979,
  [SMALL_STATE(3764)] = 127989,
  [SMALL_STATE(3765)] = 127999,
  [SMALL_STATE(3766)] = 128009,
  [SMALL_STATE(3767)] = 128019,
  [SMALL_STATE(3768)] = 128029,
  [SMALL_STATE(3769)] = 128039,
  [SMALL_STATE(3770)] = 128049,
  [SMALL_STATE(3771)] = 128059,
  [SMALL_STATE(3772)] = 128069,
  [SMALL_STATE(3773)] = 128079,
  [SMALL_STATE(3774)] = 128087,
  [SMALL_STATE(3775)] = 128097,
  [SMALL_STATE(3776)] = 128107,
  [SMALL_STATE(3777)] = 128117,
  [SMALL_STATE(3778)] = 128127,
  [SMALL_STATE(3779)] = 128137,
  [SMALL_STATE(3780)] = 128147,
  [SMALL_STATE(3781)] = 128157,
  [SMALL_STATE(3782)] = 128167,
  [SMALL_STATE(3783)] = 128177,
  [SMALL_STATE(3784)] = 128187,
  [SMALL_STATE(3785)] = 128197,
  [SMALL_STATE(3786)] = 128207,
  [SMALL_STATE(3787)] = 128217,
  [SMALL_STATE(3788)] = 128227,
  [SMALL_STATE(3789)] = 128237,
  [SMALL_STATE(3790)] = 128247,
  [SMALL_STATE(3791)] = 128257,
  [SMALL_STATE(3792)] = 128267,
  [SMALL_STATE(3793)] = 128277,
  [SMALL_STATE(3794)] = 128287,
  [SMALL_STATE(3795)] = 128297,
  [SMALL_STATE(3796)] = 128307,
  [SMALL_STATE(3797)] = 128317,
  [SMALL_STATE(3798)] = 128325,
  [SMALL_STATE(3799)] = 128335,
  [SMALL_STATE(3800)] = 128345,
  [SMALL_STATE(3801)] = 128355,
  [SMALL_STATE(3802)] = 128363,
  [SMALL_STATE(3803)] = 128373,
  [SMALL_STATE(3804)] = 128381,
  [SMALL_STATE(3805)] = 128389,
  [SMALL_STATE(3806)] = 128397,
  [SMALL_STATE(3807)] = 128407,
  [SMALL_STATE(3808)] = 128415,
  [SMALL_STATE(3809)] = 128425,
  [SMALL_STATE(3810)] = 128435,
  [SMALL_STATE(3811)] = 128445,
  [SMALL_STATE(3812)] = 128453,
  [SMALL_STATE(3813)] = 128463,
  [SMALL_STATE(3814)] = 128473,
  [SMALL_STATE(3815)] = 128483,
  [SMALL_STATE(3816)] = 128493,
  [SMALL_STATE(3817)] = 128503,
  [SMALL_STATE(3818)] = 128511,
  [SMALL_STATE(3819)] = 128521,
  [SMALL_STATE(3820)] = 128529,
  [SMALL_STATE(3821)] = 128539,
  [SMALL_STATE(3822)] = 128549,
  [SMALL_STATE(3823)] = 128559,
  [SMALL_STATE(3824)] = 128569,
  [SMALL_STATE(3825)] = 128577,
  [SMALL_STATE(3826)] = 128587,
  [SMALL_STATE(3827)] = 128597,
  [SMALL_STATE(3828)] = 128607,
  [SMALL_STATE(3829)] = 128617,
  [SMALL_STATE(3830)] = 128627,
  [SMALL_STATE(3831)] = 128637,
  [SMALL_STATE(3832)] = 128647,
  [SMALL_STATE(3833)] = 128657,
  [SMALL_STATE(3834)] = 128667,
  [SMALL_STATE(3835)] = 128677,
  [SMALL_STATE(3836)] = 128687,
  [SMALL_STATE(3837)] = 128697,
  [SMALL_STATE(3838)] = 128707,
  [SMALL_STATE(3839)] = 128715,
  [SMALL_STATE(3840)] = 128725,
  [SMALL_STATE(3841)] = 128735,
  [SMALL_STATE(3842)] = 128743,
  [SMALL_STATE(3843)] = 128753,
  [SMALL_STATE(3844)] = 128763,
  [SMALL_STATE(3845)] = 128771,
  [SMALL_STATE(3846)] = 128781,
  [SMALL_STATE(3847)] = 128791,
  [SMALL_STATE(3848)] = 128799,
  [SMALL_STATE(3849)] = 128809,
  [SMALL_STATE(3850)] = 128816,
  [SMALL_STATE(3851)] = 128823,
  [SMALL_STATE(3852)] = 128830,
  [SMALL_STATE(3853)] = 128837,
  [SMALL_STATE(3854)] = 128844,
  [SMALL_STATE(3855)] = 128851,
  [SMALL_STATE(3856)] = 128858,
  [SMALL_STATE(3857)] = 128865,
  [SMALL_STATE(3858)] = 128872,
  [SMALL_STATE(3859)] = 128879,
  [SMALL_STATE(3860)] = 128886,
  [SMALL_STATE(3861)] = 128893,
  [SMALL_STATE(3862)] = 128900,
  [SMALL_STATE(3863)] = 128907,
  [SMALL_STATE(3864)] = 128914,
  [SMALL_STATE(3865)] = 128921,
  [SMALL_STATE(3866)] = 128928,
  [SMALL_STATE(3867)] = 128935,
  [SMALL_STATE(3868)] = 128942,
  [SMALL_STATE(3869)] = 128949,
  [SMALL_STATE(3870)] = 128956,
  [SMALL_STATE(3871)] = 128963,
  [SMALL_STATE(3872)] = 128970,
  [SMALL_STATE(3873)] = 128977,
  [SMALL_STATE(3874)] = 128984,
  [SMALL_STATE(3875)] = 128991,
  [SMALL_STATE(3876)] = 128998,
  [SMALL_STATE(3877)] = 129005,
  [SMALL_STATE(3878)] = 129012,
  [SMALL_STATE(3879)] = 129019,
  [SMALL_STATE(3880)] = 129026,
  [SMALL_STATE(3881)] = 129033,
  [SMALL_STATE(3882)] = 129040,
  [SMALL_STATE(3883)] = 129047,
  [SMALL_STATE(3884)] = 129054,
  [SMALL_STATE(3885)] = 129061,
  [SMALL_STATE(3886)] = 129068,
  [SMALL_STATE(3887)] = 129075,
  [SMALL_STATE(3888)] = 129082,
  [SMALL_STATE(3889)] = 129089,
  [SMALL_STATE(3890)] = 129096,
  [SMALL_STATE(3891)] = 129103,
  [SMALL_STATE(3892)] = 129110,
  [SMALL_STATE(3893)] = 129117,
  [SMALL_STATE(3894)] = 129124,
  [SMALL_STATE(3895)] = 129131,
  [SMALL_STATE(3896)] = 129138,
  [SMALL_STATE(3897)] = 129145,
  [SMALL_STATE(3898)] = 129152,
  [SMALL_STATE(3899)] = 129159,
  [SMALL_STATE(3900)] = 129166,
  [SMALL_STATE(3901)] = 129173,
  [SMALL_STATE(3902)] = 129180,
  [SMALL_STATE(3903)] = 129187,
  [SMALL_STATE(3904)] = 129194,
  [SMALL_STATE(3905)] = 129201,
  [SMALL_STATE(3906)] = 129208,
  [SMALL_STATE(3907)] = 129215,
  [SMALL_STATE(3908)] = 129222,
  [SMALL_STATE(3909)] = 129229,
  [SMALL_STATE(3910)] = 129236,
  [SMALL_STATE(3911)] = 129243,
  [SMALL_STATE(3912)] = 129250,
  [SMALL_STATE(3913)] = 129257,
  [SMALL_STATE(3914)] = 129264,
  [SMALL_STATE(3915)] = 129271,
  [SMALL_STATE(3916)] = 129278,
  [SMALL_STATE(3917)] = 129285,
  [SMALL_STATE(3918)] = 129292,
  [SMALL_STATE(3919)] = 129299,
  [SMALL_STATE(3920)] = 129306,
  [SMALL_STATE(3921)] = 129313,
  [SMALL_STATE(3922)] = 129320,
  [SMALL_STATE(3923)] = 129327,
  [SMALL_STATE(3924)] = 129334,
  [SMALL_STATE(3925)] = 129341,
  [SMALL_STATE(3926)] = 129348,
  [SMALL_STATE(3927)] = 129355,
  [SMALL_STATE(3928)] = 129362,
  [SMALL_STATE(3929)] = 129369,
  [SMALL_STATE(3930)] = 129376,
  [SMALL_STATE(3931)] = 129383,
  [SMALL_STATE(3932)] = 129390,
  [SMALL_STATE(3933)] = 129397,
  [SMALL_STATE(3934)] = 129404,
  [SMALL_STATE(3935)] = 129411,
  [SMALL_STATE(3936)] = 129418,
  [SMALL_STATE(3937)] = 129425,
  [SMALL_STATE(3938)] = 129432,
  [SMALL_STATE(3939)] = 129439,
  [SMALL_STATE(3940)] = 129446,
  [SMALL_STATE(3941)] = 129453,
  [SMALL_STATE(3942)] = 129460,
  [SMALL_STATE(3943)] = 129467,
  [SMALL_STATE(3944)] = 129474,
  [SMALL_STATE(3945)] = 129481,
  [SMALL_STATE(3946)] = 129488,
  [SMALL_STATE(3947)] = 129495,
  [SMALL_STATE(3948)] = 129502,
  [SMALL_STATE(3949)] = 129509,
  [SMALL_STATE(3950)] = 129516,
  [SMALL_STATE(3951)] = 129523,
  [SMALL_STATE(3952)] = 129530,
  [SMALL_STATE(3953)] = 129537,
  [SMALL_STATE(3954)] = 129544,
  [SMALL_STATE(3955)] = 129551,
  [SMALL_STATE(3956)] = 129558,
  [SMALL_STATE(3957)] = 129565,
  [SMALL_STATE(3958)] = 129572,
  [SMALL_STATE(3959)] = 129579,
  [SMALL_STATE(3960)] = 129586,
  [SMALL_STATE(3961)] = 129593,
  [SMALL_STATE(3962)] = 129600,
  [SMALL_STATE(3963)] = 129607,
  [SMALL_STATE(3964)] = 129614,
  [SMALL_STATE(3965)] = 129621,
  [SMALL_STATE(3966)] = 129628,
  [SMALL_STATE(3967)] = 129635,
  [SMALL_STATE(3968)] = 129642,
  [SMALL_STATE(3969)] = 129649,
  [SMALL_STATE(3970)] = 129656,
  [SMALL_STATE(3971)] = 129663,
  [SMALL_STATE(3972)] = 129670,
  [SMALL_STATE(3973)] = 129677,
  [SMALL_STATE(3974)] = 129684,
  [SMALL_STATE(3975)] = 129691,
  [SMALL_STATE(3976)] = 129698,
  [SMALL_STATE(3977)] = 129705,
  [SMALL_STATE(3978)] = 129712,
  [SMALL_STATE(3979)] = 129719,
  [SMALL_STATE(3980)] = 129726,
  [SMALL_STATE(3981)] = 129733,
  [SMALL_STATE(3982)] = 129740,
  [SMALL_STATE(3983)] = 129747,
  [SMALL_STATE(3984)] = 129754,
  [SMALL_STATE(3985)] = 129761,
  [SMALL_STATE(3986)] = 129768,
  [SMALL_STATE(3987)] = 129775,
  [SMALL_STATE(3988)] = 129782,
  [SMALL_STATE(3989)] = 129789,
  [SMALL_STATE(3990)] = 129796,
  [SMALL_STATE(3991)] = 129803,
  [SMALL_STATE(3992)] = 129810,
  [SMALL_STATE(3993)] = 129817,
  [SMALL_STATE(3994)] = 129824,
  [SMALL_STATE(3995)] = 129831,
  [SMALL_STATE(3996)] = 129838,
  [SMALL_STATE(3997)] = 129845,
  [SMALL_STATE(3998)] = 129852,
  [SMALL_STATE(3999)] = 129859,
  [SMALL_STATE(4000)] = 129866,
  [SMALL_STATE(4001)] = 129873,
  [SMALL_STATE(4002)] = 129880,
  [SMALL_STATE(4003)] = 129887,
  [SMALL_STATE(4004)] = 129894,
  [SMALL_STATE(4005)] = 129901,
  [SMALL_STATE(4006)] = 129908,
  [SMALL_STATE(4007)] = 129915,
  [SMALL_STATE(4008)] = 129922,
  [SMALL_STATE(4009)] = 129929,
  [SMALL_STATE(4010)] = 129936,
  [SMALL_STATE(4011)] = 129943,
  [SMALL_STATE(4012)] = 129950,
  [SMALL_STATE(4013)] = 129957,
  [SMALL_STATE(4014)] = 129964,
  [SMALL_STATE(4015)] = 129971,
  [SMALL_STATE(4016)] = 129978,
  [SMALL_STATE(4017)] = 129985,
  [SMALL_STATE(4018)] = 129992,
  [SMALL_STATE(4019)] = 129999,
  [SMALL_STATE(4020)] = 130006,
  [SMALL_STATE(4021)] = 130013,
  [SMALL_STATE(4022)] = 130020,
  [SMALL_STATE(4023)] = 130027,
  [SMALL_STATE(4024)] = 130034,
  [SMALL_STATE(4025)] = 130041,
  [SMALL_STATE(4026)] = 130048,
  [SMALL_STATE(4027)] = 130055,
  [SMALL_STATE(4028)] = 130062,
  [SMALL_STATE(4029)] = 130069,
  [SMALL_STATE(4030)] = 130076,
  [SMALL_STATE(4031)] = 130083,
  [SMALL_STATE(4032)] = 130090,
  [SMALL_STATE(4033)] = 130097,
  [SMALL_STATE(4034)] = 130104,
  [SMALL_STATE(4035)] = 130111,
  [SMALL_STATE(4036)] = 130118,
  [SMALL_STATE(4037)] = 130125,
  [SMALL_STATE(4038)] = 130132,
  [SMALL_STATE(4039)] = 130139,
  [SMALL_STATE(4040)] = 130146,
  [SMALL_STATE(4041)] = 130153,
  [SMALL_STATE(4042)] = 130160,
  [SMALL_STATE(4043)] = 130167,
  [SMALL_STATE(4044)] = 130174,
  [SMALL_STATE(4045)] = 130181,
  [SMALL_STATE(4046)] = 130188,
  [SMALL_STATE(4047)] = 130195,
  [SMALL_STATE(4048)] = 130202,
  [SMALL_STATE(4049)] = 130209,
  [SMALL_STATE(4050)] = 130216,
  [SMALL_STATE(4051)] = 130223,
  [SMALL_STATE(4052)] = 130230,
  [SMALL_STATE(4053)] = 130237,
  [SMALL_STATE(4054)] = 130244,
  [SMALL_STATE(4055)] = 130251,
  [SMALL_STATE(4056)] = 130258,
  [SMALL_STATE(4057)] = 130265,
  [SMALL_STATE(4058)] = 130272,
  [SMALL_STATE(4059)] = 130279,
  [SMALL_STATE(4060)] = 130286,
  [SMALL_STATE(4061)] = 130293,
  [SMALL_STATE(4062)] = 130300,
  [SMALL_STATE(4063)] = 130307,
  [SMALL_STATE(4064)] = 130314,
  [SMALL_STATE(4065)] = 130321,
  [SMALL_STATE(4066)] = 130328,
  [SMALL_STATE(4067)] = 130335,
  [SMALL_STATE(4068)] = 130342,
  [SMALL_STATE(4069)] = 130349,
  [SMALL_STATE(4070)] = 130356,
  [SMALL_STATE(4071)] = 130363,
  [SMALL_STATE(4072)] = 130370,
  [SMALL_STATE(4073)] = 130377,
  [SMALL_STATE(4074)] = 130384,
  [SMALL_STATE(4075)] = 130391,
  [SMALL_STATE(4076)] = 130398,
  [SMALL_STATE(4077)] = 130405,
  [SMALL_STATE(4078)] = 130412,
  [SMALL_STATE(4079)] = 130419,
  [SMALL_STATE(4080)] = 130426,
  [SMALL_STATE(4081)] = 130433,
  [SMALL_STATE(4082)] = 130440,
  [SMALL_STATE(4083)] = 130447,
  [SMALL_STATE(4084)] = 130454,
  [SMALL_STATE(4085)] = 130461,
  [SMALL_STATE(4086)] = 130468,
  [SMALL_STATE(4087)] = 130475,
  [SMALL_STATE(4088)] = 130482,
  [SMALL_STATE(4089)] = 130489,
  [SMALL_STATE(4090)] = 130496,
  [SMALL_STATE(4091)] = 130503,
  [SMALL_STATE(4092)] = 130510,
  [SMALL_STATE(4093)] = 130517,
  [SMALL_STATE(4094)] = 130524,
  [SMALL_STATE(4095)] = 130531,
  [SMALL_STATE(4096)] = 130538,
  [SMALL_STATE(4097)] = 130545,
  [SMALL_STATE(4098)] = 130552,
  [SMALL_STATE(4099)] = 130559,
  [SMALL_STATE(4100)] = 130566,
  [SMALL_STATE(4101)] = 130573,
  [SMALL_STATE(4102)] = 130580,
  [SMALL_STATE(4103)] = 130587,
  [SMALL_STATE(4104)] = 130594,
  [SMALL_STATE(4105)] = 130601,
  [SMALL_STATE(4106)] = 130608,
  [SMALL_STATE(4107)] = 130615,
  [SMALL_STATE(4108)] = 130622,
  [SMALL_STATE(4109)] = 130629,
  [SMALL_STATE(4110)] = 130636,
  [SMALL_STATE(4111)] = 130643,
  [SMALL_STATE(4112)] = 130650,
  [SMALL_STATE(4113)] = 130657,
  [SMALL_STATE(4114)] = 130664,
  [SMALL_STATE(4115)] = 130671,
  [SMALL_STATE(4116)] = 130678,
  [SMALL_STATE(4117)] = 130685,
  [SMALL_STATE(4118)] = 130692,
  [SMALL_STATE(4119)] = 130699,
  [SMALL_STATE(4120)] = 130706,
  [SMALL_STATE(4121)] = 130713,
  [SMALL_STATE(4122)] = 130720,
  [SMALL_STATE(4123)] = 130727,
  [SMALL_STATE(4124)] = 130734,
  [SMALL_STATE(4125)] = 130741,
  [SMALL_STATE(4126)] = 130748,
  [SMALL_STATE(4127)] = 130755,
  [SMALL_STATE(4128)] = 130762,
  [SMALL_STATE(4129)] = 130769,
  [SMALL_STATE(4130)] = 130776,
  [SMALL_STATE(4131)] = 130783,
  [SMALL_STATE(4132)] = 130790,
  [SMALL_STATE(4133)] = 130797,
  [SMALL_STATE(4134)] = 130804,
  [SMALL_STATE(4135)] = 130811,
  [SMALL_STATE(4136)] = 130818,
  [SMALL_STATE(4137)] = 130825,
  [SMALL_STATE(4138)] = 130832,
  [SMALL_STATE(4139)] = 130839,
  [SMALL_STATE(4140)] = 130846,
  [SMALL_STATE(4141)] = 130853,
  [SMALL_STATE(4142)] = 130860,
  [SMALL_STATE(4143)] = 130867,
  [SMALL_STATE(4144)] = 130874,
  [SMALL_STATE(4145)] = 130881,
  [SMALL_STATE(4146)] = 130888,
  [SMALL_STATE(4147)] = 130895,
  [SMALL_STATE(4148)] = 130902,
  [SMALL_STATE(4149)] = 130909,
  [SMALL_STATE(4150)] = 130916,
  [SMALL_STATE(4151)] = 130923,
  [SMALL_STATE(4152)] = 130930,
  [SMALL_STATE(4153)] = 130937,
  [SMALL_STATE(4154)] = 130944,
  [SMALL_STATE(4155)] = 130951,
  [SMALL_STATE(4156)] = 130958,
  [SMALL_STATE(4157)] = 130965,
  [SMALL_STATE(4158)] = 130972,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2816),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3656),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3664),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3542),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3672),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3673),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3678),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3538),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3685),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4056),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2579),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2766),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4004),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4002),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(365),
  [114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(397),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(4114),
  [142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 1),
  [156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(315),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3998),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(522),
  [206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1076),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(247),
  [317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1041),
  [322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(971),
  [325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(336),
  [331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1160),
  [334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2712),
  [337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2816),
  [340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2692),
  [343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(336),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3656),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3664),
  [352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3542),
  [355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(123),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(359),
  [361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3672),
  [364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(47),
  [367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3673),
  [370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3678),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3538),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3537),
  [379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3685),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(212),
  [385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(286),
  [388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(601),
  [391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(87),
  [394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(158),
  [397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(811),
  [400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4056),
  [403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2579),
  [406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(559),
  [409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2766),
  [412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(276),
  [415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(390),
  [418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3310),
  [421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3313),
  [424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2900),
  [427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1819),
  [430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1819),
  [433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1860),
  [436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3452),
  [439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1074),
  [442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(527),
  [445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(970),
  [448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4004),
  [451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4003),
  [454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4002),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, .production_id = 57),
  [459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3, .production_id = 57),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 56),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 56),
  [465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 198),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 198),
  [469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3659),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3657),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3655),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2592),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2761),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(119),
  [538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(155),
  [541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(811),
  [544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(2907),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4114),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3865),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2527),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4015),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3867),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3895),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [1073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1676),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2831),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3692),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3990),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2771),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4148),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4119),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_rest_pattern, 2, .production_id = 29),
  [1228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, .production_id = 29),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3364),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [1256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3905),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [1266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2529),
  [1268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2528),
  [1270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 5),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 5),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4112),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [1294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [1298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 26),
  [1310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 26),
  [1312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 153),
  [1314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 153),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 153),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 153),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [1324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [1330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 55),
  [1336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 55),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 55),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 55),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 193),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 193),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 193),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 193),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 153),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 153),
  [1380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 153),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 153),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 104),
  [1390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 104),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 104),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 104),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 114),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 114),
  [1406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 114),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 114),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 122),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 122),
  [1416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 122),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 122),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 148),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 148),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 148),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 148),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 162),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 162),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 162),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 162),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 187),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 187),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 187),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 187),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [1456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 161),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 161),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 161),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 161),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 105),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 105),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 105),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 105),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [1524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2747),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2750),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [1554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [1556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [1560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [1568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [1572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1575] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2562),
  [1579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_modifier, 1),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_modifier, 1),
  [1583] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2335),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3984),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [1613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(40),
  [1619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [1628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [1636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [1654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [1656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [1682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [1720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2960),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2964),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [1734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4058),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4077),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3352),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3269),
  [1856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(2260),
  [1859] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(145),
  [1863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(355),
  [1866] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3692),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [1880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [1882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [1892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [1894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [1898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [1930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [1932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [1936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [1938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [1940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [1942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [1944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [1946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [1948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4081),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4083),
  [1954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(145),
  [1957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3692),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2757),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4020),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4021),
  [1966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, .production_id = 29),
  [1968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4044),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4042),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2748),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4106),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4104),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [1980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(296),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4051),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4050),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3872),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3873),
  [1995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(436),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [2002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [2004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3372),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3622),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3950),
  [2010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3948),
  [2012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4066),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3892),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3891),
  [2028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [2030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [2032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [2034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [2036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 34),
  [2042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 34),
  [2044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 220),
  [2052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 220),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 201),
  [2056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 201),
  [2058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [2060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 116),
  [2064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 116),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 153),
  [2068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 153),
  [2070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 95),
  [2072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 95),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 153),
  [2076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 153),
  [2078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 148),
  [2080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 148),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 36),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 36),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, .production_id = 77),
  [2092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_clause, 3, .production_id = 77),
  [2094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [2096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_clause, 3),
  [2098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 76),
  [2100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 76),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 190),
  [2104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 190),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 88),
  [2108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 88),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [2114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 192),
  [2116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 192),
  [2118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 161),
  [2120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 161),
  [2122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 162),
  [2124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 162),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 194),
  [2128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 194),
  [2130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [2132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [2134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 195),
  [2136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 195),
  [2138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 170),
  [2140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 170),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 55),
  [2144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 55),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 200),
  [2148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 200),
  [2150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 64),
  [2152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 64),
  [2154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, .production_id = 30),
  [2156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, .production_id = 30),
  [2158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [2160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [2162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 166),
  [2164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 166),
  [2166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [2168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3, .production_id = 33),
  [2172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3, .production_id = 33),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 164),
  [2176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 164),
  [2178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 187),
  [2180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 187),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 122),
  [2184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 122),
  [2186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, .production_id = 215),
  [2188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, .production_id = 215),
  [2190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 160),
  [2192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 160),
  [2194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 190),
  [2196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 190),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 192),
  [2200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 192),
  [2202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 193),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 193),
  [2206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 216),
  [2208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 216),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 35),
  [2216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 35),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, .production_id = 76),
  [2220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, .production_id = 76),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 148),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 148),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [2232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [2234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 155),
  [2236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 155),
  [2238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 154),
  [2240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 154),
  [2242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 114),
  [2244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 114),
  [2246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [2248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 72),
  [2252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 72),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 152),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 152),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [2264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 188),
  [2268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 188),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 74),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 74),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 75),
  [2276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 75),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4),
  [2280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 113),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 113),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 87),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 87),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 105),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 105),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 104),
  [2300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 104),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 86),
  [2304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 86),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4, .production_id = 33),
  [2308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4, .production_id = 33),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [2312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [2316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 77),
  [2320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_clause, 4, .production_id = 77),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 78),
  [2324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 78),
  [2326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 104),
  [2328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 104),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 105),
  [2332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 105),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 74),
  [2336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 74),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 121),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 121),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [2344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [2346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 6),
  [2348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 6),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [2352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [2356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 82),
  [2360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 82),
  [2362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 126),
  [2364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 126),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [2368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 128),
  [2372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 128),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 77),
  [2376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_clause, 5, .production_id = 77),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [2380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_clause, 2),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [2384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [2392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 22),
  [2396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 22),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 132),
  [2400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 132),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [2404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [2408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [2410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [2412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [2414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [2416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [2418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [2420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [2422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [2424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [2426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [2432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 7, .production_id = 219),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 7, .production_id = 219),
  [2486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 169),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 169),
  [2490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 199),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 199),
  [2494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 168),
  [2496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 168),
  [2498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 89),
  [2504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 89),
  [2506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [2508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [2510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [2514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [2518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [2520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [2526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [2530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2483),
  [2532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3473),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [2538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [2540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2450),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [2546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3349),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [2570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [2572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2654),
  [2574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3480),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3996),
  [2582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [2586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [2588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [2590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2519),
  [2592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [2610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3363),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [2616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [2618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [2622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [2624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [2630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [2638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [2640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [2642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [2644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [2646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [2648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [2654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [2656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [2658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [2662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [2664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [2674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2905),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3346),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2803),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [2734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2824),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [2760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4096),
  [2766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [2778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [2780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [2798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [2800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3274),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [2828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3912),
  [2838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [2850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [2852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [2862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2670),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [2880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3388),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [2890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1), REDUCE(aux_sym_object_pattern_repeat1, 1),
  [2893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [2897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [2899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [2901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [2905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 67),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 67),
  [2909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 66),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 66),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [2915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 159),
  [2917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 159),
  [2919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [2925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [2933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [2935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 119),
  [2937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 119),
  [2939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [2941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [2943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(508),
  [2946] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [2955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(950),
  [2958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4103),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [2966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 12), SHIFT(3837),
  [2969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12),
  [2971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [2979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [2985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(902),
  [2988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(3884),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [3001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(360),
  [3008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [3012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2),
  [3016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2),
  [3018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [3023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 12),
  [3026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [3036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3040] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 12), REDUCE(sym_rest_pattern, 2),
  [3044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [3048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [3056] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1), REDUCE(sym_rest_pattern, 2, .production_id = 29),
  [3060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(285),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [3067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_rest_pattern, 2),
  [3070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [3072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [3076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4138),
  [3078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(443),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21),
  [3087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21),
  [3089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21), SHIFT_REPEAT(3452),
  [3092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21), SHIFT(2584),
  [3095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 66),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 66),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [3101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [3103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [3105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [3111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [3125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [3127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [3129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [3157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1213),
  [3160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1428),
  [3163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [3167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1377),
  [3170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1904),
  [3173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1340),
  [3176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1685),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3571),
  [3185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3866),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [3189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [3193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [3229] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 27), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 28),
  [3233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2679),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [3239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [3241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [3243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [3245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [3249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [3251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [3255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [3257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [3259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [3261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [3263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [3265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [3267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2664),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [3271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [3273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [3275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [3277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [3279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [3283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [3287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [3289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [3291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [3293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [3295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [3299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [3303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [3305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [3307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [3309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [3313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [3315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2689),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [3319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [3321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [3327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [3329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [3331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [3335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [3341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [3343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [3345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [3347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 12),
  [3349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [3355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [3357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [3363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 48),
  [3365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 48),
  [3367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [3375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 47),
  [3377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 47),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [3385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [3387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [3389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [3401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [3403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [3407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 141),
  [3409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 141),
  [3411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [3413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [3415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [3417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [3421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2751),
  [3423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [3425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [3427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [3429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [3431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [3433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 3),
  [3437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 3),
  [3439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 49),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 49),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [3449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 100),
  [3451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 100),
  [3453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 100),
  [3456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 229),
  [3458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 229),
  [3460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [3462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [3464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 102),
  [3466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 102),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [3470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [3472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [3474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [3476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [3478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [3480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [3482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 50),
  [3484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 50),
  [3486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 66),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 66),
  [3490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 99),
  [3492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 99),
  [3494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 67),
  [3496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 67),
  [3498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 98),
  [3500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 98),
  [3502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [3505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [3508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [3510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [3512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 210),
  [3514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 210),
  [3516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, .production_id = 15),
  [3518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, .production_id = 15),
  [3520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 18),
  [3522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 18),
  [3524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 209),
  [3526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 209),
  [3528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 138),
  [3530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 138),
  [3532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 208),
  [3534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 208),
  [3536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [3538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [3540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [3542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [3544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 8),
  [3546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 8),
  [3548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 139),
  [3550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 139),
  [3552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [3554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [3558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 159),
  [3560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 159),
  [3562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 2),
  [3564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 2),
  [3566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 182),
  [3568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 182),
  [3570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [3572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [3574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 181),
  [3576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 181),
  [3578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2),
  [3580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2),
  [3582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 140),
  [3584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 140),
  [3586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [3588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2),
  [3590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [3592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [3595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [3598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 84),
  [3600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 84),
  [3602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [3604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [3606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [3608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [3610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, .production_id = 53),
  [3612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, .production_id = 53),
  [3614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [3616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [3618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [3620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [3622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [3624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [3626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 180),
  [3628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 180),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [3634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 142),
  [3636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 142),
  [3638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 179),
  [3640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 179),
  [3642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 119),
  [3644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 119),
  [3646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 54),
  [3648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 54),
  [3650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 143),
  [3652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 143),
  [3654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 61),
  [3656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 61),
  [3658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 145),
  [3660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 145),
  [3662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [3664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [3666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [3668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [3670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4, .production_id = 144),
  [3672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4, .production_id = 144),
  [3674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [3678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 70),
  [3680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [3684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [3720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [3723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 57),
  [3725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 57),
  [3727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 58),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 58),
  [3731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 158),
  [3733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 59),
  [3735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 59),
  [3737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [3739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [3741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 60),
  [3743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 60),
  [3745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 123),
  [3747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 123),
  [3749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [3755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [3759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [3761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [3763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [3765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 63),
  [3767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 63),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [3771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [3776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 120),
  [3778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 120),
  [3780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65),
  [3782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 65),
  [3784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(80),
  [3787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [3795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 62),
  [3797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 109),
  [3799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 109),
  [3801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 27),
  [3803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, .production_id = 28),
  [3805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 27),
  [3807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 27), REDUCE(sym_object_pattern, 3, .production_id = 28),
  [3810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [3812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [3814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [3817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [3820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 151),
  [3822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 151),
  [3824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 68),
  [3826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 68),
  [3828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 69),
  [3830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 69),
  [3832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 70),
  [3834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 25),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [3838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 65),
  [3840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 25),
  [3842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [3844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [3846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [3848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2),
  [3850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2),
  [3852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [3854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [3856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [3858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [3860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 115),
  [3862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 115),
  [3864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 73),
  [3866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 73),
  [3868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [3871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [3874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 110),
  [3876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 110),
  [3878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 112),
  [3880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 112),
  [3882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 11),
  [3884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 11),
  [3886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(80),
  [3893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 27),
  [3895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 27),
  [3897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(80),
  [3904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 124),
  [3906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 124),
  [3908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [3910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [3912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 163),
  [3914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 163),
  [3916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 111),
  [3918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 111),
  [3920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 110),
  [3922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 110),
  [3924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [3926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [3928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [3930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(80),
  [3933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [3935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [3937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 103),
  [3939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 103),
  [3941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 108),
  [3943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 108),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [3949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [3955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [3957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [3959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [3961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [3963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [3967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [3971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [3975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [3989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [3999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [4007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [4031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [4035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [4037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 56),
  [4039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 56), SHIFT(410),
  [4042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [4058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [4060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(84),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [4081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2),
  [4083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, .production_id = 28),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [4087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [4093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(77),
  [4096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 79), REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [4099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 79),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [4121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 79), REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [4124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 62), REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [4127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 62),
  [4129] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4133] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [4139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [4145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(84),
  [4148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2551),
  [4151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2233),
  [4154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(234),
  [4159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2050),
  [4162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4131),
  [4165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3355),
  [4168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3354),
  [4171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2354),
  [4174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3583),
  [4177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1893),
  [4180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1894),
  [4183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2083),
  [4186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1864),
  [4189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2015),
  [4192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2096),
  [4195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2217),
  [4198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(84),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [4203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(84),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [4208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [4210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 56),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [4214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [4222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [4232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [4240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [4248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(77),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [4253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(77),
  [4256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(77),
  [4259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(76),
  [4262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 9), REDUCE(sym__primary_type, 1, .production_id = 14),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [4271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 62),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [4275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [4283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(76),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [4290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [4292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [4296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 37),
  [4304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 37),
  [4306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym__parameter_name, 2, .production_id = 37),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [4315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 37),
  [4317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 37),
  [4319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [4321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 56),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [4327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4330] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 9), REDUCE(sym__primary_type, 1, .production_id = 14),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [4340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [4348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(76),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [4355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(76),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [4360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 5, .production_id = 171),
  [4362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 5, .production_id = 171),
  [4364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [4368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [4378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [4384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [4402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(79),
  [4405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [4410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 27), REDUCE(sym_object_pattern, 3, .production_id = 28),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [4415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [4418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [4420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [4423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [4431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(85),
  [4434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(85),
  [4437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [4439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [4441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [4447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [4455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [4457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [4459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [4465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [4473] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1), REDUCE(sym_rest_pattern, 2),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [4479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [4482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(85),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [4487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 131),
  [4489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 131),
  [4491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(79),
  [4494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 129),
  [4496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 129),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [4500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(79),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [4509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [4514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_computed_property_name, 3),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [4525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(79),
  [4528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 94),
  [4530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 94),
  [4532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [4534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 80),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [4542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 40),
  [4544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 40),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [4550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(85),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [4557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [4559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [4561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [4563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 90),
  [4565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 90),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [4579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 56), SHIFT(485),
  [4582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [4590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [4618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [4622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [4626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [4636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [4638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [4642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [4648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [4664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(82),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [4669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3141),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [4679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(82),
  [4682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(82),
  [4685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(82),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [4704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [4726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [4728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 55), REDUCE(sym_class, 4, .production_id = 122),
  [4731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 55), REDUCE(sym_class, 4, .production_id = 122),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [4738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [4740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [4742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [4752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [4758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [4766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [4774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 57), REDUCE(sym_class, 4, .production_id = 123),
  [4777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 57), REDUCE(sym_class, 4, .production_id = 123),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [4782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [4786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [4790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [4794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [4800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [4802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 58), REDUCE(sym_class, 4, .production_id = 124),
  [4805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 58), REDUCE(sym_class, 4, .production_id = 124),
  [4808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3958),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [4812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [4818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [4820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4135),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [4824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [4828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [4830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 11), REDUCE(sym_class, 3, .production_id = 73),
  [4833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 11), REDUCE(sym_class, 3, .production_id = 73),
  [4836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(78),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [4847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [4849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(78),
  [4852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [4856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [4860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [4862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [4866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [4868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(78),
  [4871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(78),
  [4874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [4876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 1),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [4880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [4882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [4884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 148), REDUCE(sym_class, 6, .production_id = 193),
  [4887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 148), REDUCE(sym_class, 6, .production_id = 193),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [4892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [4894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 108), REDUCE(sym_class, 5, .production_id = 163),
  [4897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 108), REDUCE(sym_class, 5, .production_id = 163),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [4902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [4904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 105), REDUCE(sym_class, 5, .production_id = 162),
  [4907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 105), REDUCE(sym_class, 5, .production_id = 162),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [4912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [4914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 104), REDUCE(sym_class, 5, .production_id = 161),
  [4917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 104), REDUCE(sym_class, 5, .production_id = 161),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [4922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [4928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [4930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [4934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [4938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 27), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 28),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [4945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2877),
  [4947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [4949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [4953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [4955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [4957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [4959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [4961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [4965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [4967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 27),
  [4969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [4971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [4979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4040),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [4985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [4989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [4991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [4997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 114),
  [4999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 114),
  [5001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 248),
  [5003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 248),
  [5005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 81),
  [5007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 81),
  [5009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 153),
  [5011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 153),
  [5013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 196),
  [5015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 196),
  [5017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 187),
  [5019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 187),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [5023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 235),
  [5025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 235),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [5031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [5037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [5043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [5049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 127),
  [5051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 127),
  [5053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 218),
  [5055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 218),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [5059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [5063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [5065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 167),
  [5067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 167),
  [5069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 236),
  [5071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 236),
  [5073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 10, .production_id = 257),
  [5075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 10, .production_id = 257),
  [5077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 217),
  [5079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 217),
  [5081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [5083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 247),
  [5085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 247),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [5093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [5095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [5097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [5105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [5107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [5109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [5115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [5117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [5137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [5141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [5143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [5149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [5151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [5153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [5159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [5161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [5163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [5165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3814),
  [5167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3888),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [5231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 76),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [5241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [5253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 178),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [5257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [5289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 207),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [5333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 135),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [5357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 135),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [5361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 207),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [5381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12), REDUCE(sym_type_parameter, 1, .production_id = 13),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [5386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12), SHIFT(895),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [5395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 76),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [5399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [5415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 178),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [5431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [5433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 12), SHIFT(3837),
  [5436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 207),
  [5438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 76),
  [5440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 178),
  [5442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 135),
  [5444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [5446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 135),
  [5448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 207),
  [5450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 76),
  [5452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 178),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [5458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [5468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [5472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [5474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [5476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [5480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [5488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2606),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [5500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [5504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [5508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2652),
  [5510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [5512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [5514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2601),
  [5518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [5520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2684),
  [5522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [5538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [5542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4),
  [5544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [5548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3),
  [5550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, .production_id = 28),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [5554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2),
  [5556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 234),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [5560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3877),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [5584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4126),
  [5586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 106),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [5600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [5602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [5606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 172),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [5624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [5626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 152),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [5630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, .production_id = 10),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [5634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 238),
  [5636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(508),
  [5639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 117),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [5643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [5645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 117),
  [5647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [5649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 203),
  [5651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 3, .production_id = 106),
  [5653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [5657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [5659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [5661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 234),
  [5663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(360),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [5670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 97),
  [5672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 202),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [5678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 13),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [5700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 225),
  [5702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 226),
  [5704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [5706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 237),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [5710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [5712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 134),
  [5714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 137),
  [5716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 251),
  [5718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 113),
  [5720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 252),
  [5722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [5728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 9, .production_id = 258),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [5734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2, .production_id = 96),
  [5736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [5756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(4018),
  [5759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [5761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(299),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [5770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [5772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4144),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [5786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [5798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [5800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [5802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4017),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [5808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 19),
  [5810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1187),
  [5813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [5819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, .production_id = 10),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [5833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [5835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [5855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [5857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [5859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [5863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [5867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [5869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [5873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [5875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [5877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [5879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [5883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [5885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [5893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [5897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [5899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [5901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [5905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [5911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [5913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [5915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [5921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [5923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [5925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [5929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2914),
  [5932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [5934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(253),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [5949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [5951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 71),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [5959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [5961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [5971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [5981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 118),
  [5983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 118),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [5999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 117),
  [6001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 117),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [6009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [6033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(818),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [6042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(960),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [6055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(830),
  [6058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 118),
  [6060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 118),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [6066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 250),
  [6068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(881),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [6089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [6093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 255),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [6097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(925),
  [6100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 246),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [6108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 204),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [6116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 205),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [6122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 32),
  [6124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5, .production_id = 206),
  [6126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 241),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [6130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 177),
  [6132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 176),
  [6134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(853),
  [6137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 249),
  [6139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 240),
  [6141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 46),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [6149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 239),
  [6151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [6153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 84),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [6157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 7, .production_id = 241),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [6165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 228),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [6169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 177),
  [6171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 176),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [6181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 136),
  [6183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 204),
  [6185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [6189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 175),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [6193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 136),
  [6195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [6197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(945),
  [6200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4, .production_id = 174),
  [6202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [6214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 173),
  [6216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 133),
  [6218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [6220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 205),
  [6222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 84),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [6226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 32),
  [6228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(809),
  [6231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [6237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 221),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [6241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 223),
  [6243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 224),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [6247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2),
  [6249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(887),
  [6252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(3232),
  [6255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [6257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 227),
  [6259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 228),
  [6261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [6263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 227),
  [6265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [6269] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [6271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [6281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(946),
  [6284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 5, .production_id = 222),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [6292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [6300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 157),
  [6302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 157),
  [6304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [6310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 156),
  [6312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 156),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [6340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [6348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [6350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 150),
  [6352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 150), SHIFT_REPEAT(434),
  [6355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 4, .production_id = 149),
  [6357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [6363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [6367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [6369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [6373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [6375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [6381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1),
  [6383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1), REDUCE(aux_sym_template_literal_type_repeat1, 1),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [6388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2961),
  [6390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [6398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [6400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(3319),
  [6403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 28),
  [6405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2775),
  [6408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [6410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 52),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [6414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2676),
  [6416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [6430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [6432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 76),
  [6434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 189),
  [6436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 189), SHIFT_REPEAT(3278),
  [6439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 189),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [6443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [6445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [6449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [6451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(3340),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [6456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 39),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [6462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [6470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 107),
  [6472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2308),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [6478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [6480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 92),
  [6482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(180),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [6491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [6495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 146),
  [6497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(2090),
  [6500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [6502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [6504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [6506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2), SHIFT_REPEAT(2046),
  [6509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [6513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 244),
  [6515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [6519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [6521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [6523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [6525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2), SHIFT_REPEAT(176),
  [6528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [6536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 183),
  [6538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 184),
  [6540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 185),
  [6542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 152),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [6546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [6550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [6554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 172),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [6574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 3),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [6582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(783),
  [6585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [6591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 186),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [6595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [6597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [6601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 256),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [6639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 254),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [6651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [6667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [6669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [6671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 253),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [6675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 191), SHIFT_REPEAT(2229),
  [6678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 191),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [6690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [6692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(151),
  [6695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [6699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(3258),
  [6702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [6706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 113),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [6720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [6740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, .production_id = 259),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [6752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 85),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [6760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 84),
  [6762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2787),
  [6764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 243),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [6776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [6784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 245),
  [6786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 233),
  [6788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, .production_id = 80),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [6792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 147),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [6800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [6802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [6810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 242),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [6828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3476),
  [6830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4025),
  [6832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 85),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [6852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 225),
  [6854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [6874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 2, .production_id = 76),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [6888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 211),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [6894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 31),
  [6896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 212),
  [6898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 213),
  [6900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(3266),
  [6903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [6913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [6915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(443),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [6922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 214),
  [6924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [6926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [6932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 202),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [6936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 203),
  [6938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [6950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(3757),
  [6953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [6955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3434),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [6979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 230),
  [6981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 231),
  [6983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 232),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [6991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 130),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [6995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 83),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [7005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 38),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [7017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [7019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 51),
  [7021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 30),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [7025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 77),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [7029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 125),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [7071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6, .production_id = 197),
  [7073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3, .production_id = 84),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [7087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 91),
  [7089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 93),
  [7091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [7123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 31),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [7133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 4, .production_id = 165),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [7143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 101),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [7159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2, .production_id = 32),
  [7161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [7163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [7165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [7173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [7189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 83),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [7197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3920),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [7201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [7205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [7211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [7215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [7217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [7219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [7225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [7229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [7231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [7233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [7241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [7245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [7249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4005),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [7253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [7279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [7287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [7291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [7295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [7297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [7299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [7301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [7303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [7305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [7307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [7309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [7311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [7317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [7319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [7321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [7323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [7325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [7327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [7341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [7347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [7351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [7359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [7373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [7387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [7397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [7399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [7403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [7405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [7407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [7409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [7411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [7413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [7415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [7419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [7421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [7435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [7439] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [7443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [7447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [7449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [7451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [7453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [7459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [7461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [7463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3900),
  [7465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [7475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [7477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [7479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [7481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [7483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [7487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 83),
  [7489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [7491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [7493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [7495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [7499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [7501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [7505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [7511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [7513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [7515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [7535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4014),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [7541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [7555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [7559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [7561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [7563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [7567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [7569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [7571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [7575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [7577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [7579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [7583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [7585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [7589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [7591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import_export, 3),
  [7593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [7595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [7603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [7607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [7611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [7623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [7625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [7627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [7629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [7631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [7633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [7637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [7641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4089),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [7647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [7667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 83),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [7699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [7701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [7705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [7709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
